<?php

    class CacheManager{
  
      
      private function emptyCache($srv){
        dibi::query('DELETE FROM [cache] WHERE [server] = %i', $srv);
      }
  
      private function cacheEnabled($srv){
        global $_TYP_SERVERU;
        $key = "cache".$_TYP_SERVERU[$srv]."Enabled";
        $result = dibi::query('SELECT [value] FROM [config] WHERE [key] LIKE %s', '%'.$key.'%');
        $enabled = $result->fetchSingle();
        if(!$enabled){
           $arr = array(
                'key' => $key,
                'value'  => 'enabled',
                'comment' => 'urcuje, zda je povoleno nacitat hesla z cache'
           );  
           dibi::query('INSERT INTO [config]', $arr);
           return true;   
        }
        if($enabled == "enabled"){
          return true;
        }
        return false;
      }
  
      private function checkCache($srv){
          global $_TYP_SERVERU;
          $fmts = filemtime(PROJ_PATH_ABS."/VERSION"); //file modification timestamp
          $key = "cache".$_TYP_SERVERU[$srv]."UTS";
          $result = dibi::query('SELECT [value] FROM [config] WHERE [key] LIKE %s', '%'.$key.'%');
          $uts = $result->fetchSingle(); //cache update timestamp
          if(!$uts || ($uts < $fmts)){
              $arr = array(
                'key' => $key,
                'value'  => $fmts,
                'comment' => 'obsahuje timestamp posledni zmeny souboru VERSION',
              );
              if(!$uts){  
                dibi::query('INSERT INTO [config]', $arr);
              } else{
                dibi::query('UPDATE [config] SET ', $arr, 'WHERE [key] LIKE %s', '%'.$key.'%');
              }
              //$this->emptyCache($srv);
              return false;
          }
          return true;
      }
  
      public function entryValid($id, $output, $vid=0, $role = -1){
        global $_TYP_SERVERU;
        if($role == -1){
          $role = get_role();
        }
        //vystupy jsou pro tisteny vystup nezavisle na roli
        if($output == TISTENY || $output == WORD){
          $role = UZIVATEL;
        }
        //role HLAVNI_REDAKTOR se chova ve vystupech stejne jako uzivatel
        if($role == HLAVNI_REDAKTOR){
            $role = UZIVATEL;
        }
        $srv = get_deployment();
        if(!$this->cacheEnabled($srv)){
          return CACHEDISABLED; //nacitani z cache je v DB zakazano
        }
        $fmts = filemtime(PROJ_PATH_ABS."/VERSION");
        if($vid!=0)
        {   
          $result = dibi::query('SELECT [stamp],[valid] FROM [cache] WHERE [hid] = %i AND [vystup] = %i AND [server] = %i AND [vyz] = %i AND [role] = %i', $id, $output, $srv, $vid, $role);                                                   
        }
        else
        {            
          $result = dibi::query('SELECT [stamp],[valid] FROM [cache] WHERE [hid] = %i AND [server] = %i AND [vystup] = %i AND [role] = %i
          ', $id, $srv, $output, $role);
        }
        $val = $result->fetchAll();
        if(!$val){
            return NOTCACHED;
        }
        
        $valid = (array)$val[0]['valid'];
        if(isset($valid[0]) && $valid[0]==0){
          return INVALID;
        }
        $date = (array)$val[0]['stamp'];
        $uts = strtotime($date['date']); 
        if($fmts - $uts > 0){
          return OLDVERSION; /// VERSION novejsi nez UTS hesla v cache
        } else{
          return VALID;
        }
      }
  
  /*
      public function entryCached($id, $output, $vid=0, $role = -1){
        $srv = get_deployment();
        if($role == -1){
          $role = get_role();
        }
        if(!$this->cacheEnabled($srv)){
          return false; //nacitani z cache je v DB zakazano
        } 
        if($vid!=0)
        {   
          $result = dibi::query('SELECT COUNT(*) FROM [cache] WHERE [hid] = %i AND [vystup] = %i AND [server] = %i AND [role] = %i AND [vyz] = %i AND [valid] = %i', $id, $output, $srv, $role, $vid, 1);
        }
        else
        {            
          $result = dibi::query('SELECT COUNT(*) FROM [cache] WHERE [hid] = %i AND [server] = %i AND [role] = %i AND [vystup] = %i AND [valid] = %i', $id, $srv,  $role, $output, 1);
        }
        $val = $result->fetchSingle();
        return (is_numeric($val) && $val > 0);
      }
    */  
      
      public function saveToCache($id, $output, $data, $vid=0, $role = -1){
        $srv = get_deployment();
        if(!$this->cacheEnabled($srv)){
          return false; //prace s cache je v DB zakazana
        }
        if($role == -1){
          $role = get_role();
        }
        //vystupy jsou pro tisteny vystup nezavisle na roli
        if($output == TISTENY || $output == WORD){
          $role = UZIVATEL;
        }
        //role HLAVNI_REDAKTOR se chova ve vystupech stejne jako uzivatel
        if($role == HLAVNI_REDAKTOR){
            $role = UZIVATEL;
        }
        $arr = array(
          'hid' => $id,
          'vystup'  => $output,
          'server' => $srv,
          'role' => $role,
          'data' => $data,
          'vyz' => $vid,
          'valid' => 1,
        );
        if($output == WEB){
          if(!empty($data)){
            $data_bz = strip_tags($data);
            $data_bz = my_trim($data_bz);
            $arr['data_bz'] = strip_tags($data_bz);
            global $prevodni_tabulka;
            $arr['data_bd'] = strtr($data_bz, $prevodni_tabulka);
          }
        }
        $result = dibi::query('SELECT [id] FROM [cache] WHERE [hid] = %i AND [server] = %i AND [role] = %i AND [vyz] = %i AND [vystup] = %i', $id, $srv,  $role, $vid, $output);
        $val = $result->fetchSingle();
        if(is_numeric($val) && $val > 0){
          dibi::query('UPDATE [cache] SET', $arr, "WHERE [id] = %i", $val);
        } else{
          dibi::query('INSERT INTO [cache]', $arr);
        }
      }
      
      public function loadFromCache($id, $output, $vid=0){
        $srv = get_deployment();
        $role = get_role();
        //vystupy jsou pro tisteny vystup nezavisle na roli
        if($output == TISTENY || $output == WORD){
          $role = UZIVATEL;
        }
        //role HLAVNI_REDAKTOR se chova ve vystupech stejne jako uzivatel
        if($role == HLAVNI_REDAKTOR){
            $role = UZIVATEL;
        }
        if($vid!=0)
        {   
          $result = dibi::query('SELECT [data] FROM [cache] WHERE [hid] = %i AND [vystup] = %i AND [server] = %i AND [role] = %i AND [vyz] = %i', $id, $output, $srv, $role, $vid);
        }
        else
        {            
          $result = dibi::query('SELECT [data] FROM [cache] WHERE [hid] = %i AND [server] = %i AND [role] = %i AND [vystup] = %i', $id, $srv, $role, $output);
        } 
        $val = $result->fetchSingle();
        return $val;
      }
  
      public function removeFromWeb($hid){
        dibi::query('DELETE FROM [cache] WHERE [hid] = %i AND [vystup] = %i', $hid, WEB);
      }
      
      public function dropCache($id, $output = null, $master_only = false){
        if(!is_numeric($id)){
          return;
        }
        
        $hids = array();
        $hids[] = (int)$id;
        if(!$master_only){
          $depth = 0;
          //1. TODO pripojovani/prihnizdovani
          do{
              $depth++;
              $old_cnt = count($hids);
              $ids = "(".implode($hids, ',').")";
              $pripoj = dibi::query('SELECT DISTINCT [main_hid] FROM [hesla_rel]
              WHERE [slave_hid] IN '. $ids .' AND 
              ([rel_type] = %i OR [rel_type] = %i)', HREL_TYPE_pripojovani, HREL_TYPE_prihnizdovani);
              $res = $pripoj->fetchAll();
              foreach($res as $hid){
                if(is_numeric($hid['main_hid']) && $hid['main_hid'] > 0)
                  $hids[] = $hid['main_hid'];
              }
              $hids = array_unique($hids);
              $new_cnt = count($hids);
          } while($old_cnt != $new_cnt && $depth < 5);
                           
          //2. vymazat z cache antonyma a synonyma
          $synant = dibi::query('SELECT [slave_hid] FROM [hesla_rel] WHERE [main_hid] = %i AND 
          ([rel_type] = %i OR [rel_type] = %i OR [rel_type] = %i OR [rel_type] = %i)',
           $id, HREL_TYPE_ant, HREL_TYPE_syn, HREL_TYPE_ant_przn, HREL_TYPE_syn_przn); 
           $res = $synant->fetchAll();
           foreach($res as $hid){
              if(is_numeric($hid['slave_hid']) && $hid['slave_hid'] > 0){
                $hids[] = $hid['slave_hid'];
              }
           }
           //3. vymazat skupinky vyznamu
           $vyznamy = dibi::query('SELECT [hid] FROM [vyznamy] WHERE [vyklad_vyznamu_link]
           IN
           (SELECT vyklad_vyznamu_link FROM [vyznamy] WHERE [hid]=%i 
           AND vyklad_vyznamu_link > 0)', $id);
           $res = $vyznamy->fetchAll();
           foreach($res as $hid){
              if(is_numeric($hid['hid']) && $hid['hid'] > 0){
                $hids[] = $hid['hid'];
              }
           }
           
           //4. vymazat z cache odkazy
           $odkazy = dibi::query('SELECT [main_hid] FROM [hesla_rel] 
           WHERE [slave_hid] = %i AND [rel_type] = %i;', $id, HREL_TYPE_odkazy);
           $res = $odkazy->fetchAll();
           foreach($res as $hid){
              if(is_numeric($hid['main_hid'] && $hid['main_hid'] > 0)){
                $hids[] = $hid['main_hid'];
              }
           }
          
           //5. vymazat z cache odkazy na zakladove slovo
           $vyznamy = get('vyznamy_hesla', $hid, array('sortorder')); 
           $vyznamy_tmp = vygeneruj_podvyznamy($hid, $vyznamy);
           foreach($vyznamy_tmp as $vyz_id){
              $ids = check_vyznam_link_from($vyz_id);
              if(!empty($ids)){
                foreach($ids as $i){
                  if(is_numeric($i) && $i > 0){
                    $hids[] = $i;
                  }
                }
              }
           } 
                                                                                
          $hids = array_unique($hids);
        } 
        //$srv = get_deployment();
        $ids = "(".implode($hids, ',').")";    
        $arr = array();
        $arr['valid'] = 0;
        if(is_null($output)){
          //dibi::query('DELETE FROM [cache] WHERE [hid] IN '.$ids.' AND [server] = %i', $srv );
          //dibi::query('DELETE FROM [cache] WHERE [hid] IN '.$ids);
          dibi::query('UPDATE [cache] SET ', $arr, 'WHERE [hid] IN ', $ids);
        } else{
          //dibi::query('DELETE FROM [cache] WHERE [hid] = '.$ids.' AND [vystup] = %i AND [server] = %i', $output, $srv);
          //dibi::query('DELETE FROM [cache] WHERE [hid] IN '.$ids.' AND [vystup] = %i', $output);
          dibi::query('UPDATE [cache] SET ', $arr, 'WHERE [hid] IN '. $ids.' AND [vystup] = %i', $output);
        }
      }
    }    
?>
