<?php
/**
 * Soubor odkzakl.php obsahujici definici tridy CDO_Odkzakl.
 */

/**
 * Trida pro skupinu odkazu na zakladove slovo (!! ZATIM NEPOUZIVAME).
 */
class CDO_Odkzakl extends CDO_Base
{
    /**
     * @var string $parentDomId id DOM elementu nadrazeneho zaznamu
     */
    private $parentLinked;

    /**
     * CDO_Odkzakl constructor.
     * @param int $input
     * @param $parentVal
     * @param $parentDomId
     * @param $parentLinked
     */
    function __construct($input = CDOin_DB, $parentVal, $parentDomId, $parentLinked = False)
    {
        $this->input = $input;
        $this->parentVal = $parentVal;
        $this->parentDomId = $parentDomId;
        $this->parentLinked = $parentLinked;
        if ($this->input === CDOin_DB) {
            $this->loadFromDB();
            $this->loadCorrections();
        }
    }

    private function loadCorrections()
    {
    }

    protected function loadFromDB($archive = False)
    {
        if ($archive) {
            $this->data = array();
        } else {
            if ($this->parentLinked) {
                $this->data = dibi::query('
                SELECT pv.id, pv.vyz_from, pv.vyz_m_from, pv.heslo_to, pv.heslo_id, pv.vyz_to, v.hid
                FROM [propojeni_vyznamu] pv LEFT JOIN [vyznamy] v ON pv.vyz_to = v.id
                WHERE [vyz_m_from] = %i
            ', $this->parentLinked)->fetchAssoc('id');
            } else {
                $this->data = dibi::query('
                SELECT pv.id, pv.vyz_from, pv.vyz_m_from, pv.heslo_to, pv.heslo_id, pv.vyz_to, v.hid
                FROM [propojeni_vyznamu] pv LEFT JOIN [vyznamy] v ON pv.vyz_to = v.id
                WHERE [vyz_from] = %i
            ', $this->parentVal)->fetchAssoc('id');
            }
        }

    }

    protected function saveToDB($archive = False, $originalData = array())
    {
        // TODO: Implement saveToDB() method.
    }

    /**
     * XML export
     * @return string
     */
    public function printXML()
    {
        // TODO: Implement printXML() method.
    }

    /**
     * Ulozeni dat do archivu.
     * @param $archiveParentVal
     * @return mixed
     */
    public function saveToArchive($archiveParentVal, $archiveHid = 0)
    {
        // TODO: Implement saveToArchive() method.
    }

    /**
     * Export do pole pro html tabulku / csv
     * @param array $fields pole pro export
     * @return array
     */
    public function tabExport($fields = array())
    {
        // TODO: Implement tabExport() method.
    }
}