<?php

  require_once(ROOT_PATH.'/cls/snappy/autoload.php');
  require_once(ROOT_PATH.'/super_common.php');

  use Knp\Snappy\Pdf;

  class Export{
      private $snappy;
      
      function __construct(){
        $this->snappy = new PDF();
        $this->snappy->setBinary(WKHTMLTOPDF_BINARY);
      }
    
    
      private function pageHeader(){
        $html = '
          <!DOCTYPE html>
          <html xml:lang="cs" xmlns="http://www.w3.org/1999/xhtml" lang="cs" dir="ltr">
          <head>
          <title>Alexis - tisk</title>   
          <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
            <style type="text/css">';
  
          $styl = file_get_contents(ROOT_PATH.'/css/tisk_hesel_pdf.css');
          $html.=$styl;
  
          $html.='
            </style>
        </head>
        <body id="tisk_page"> 
          <div id="page_wrapper">
            <div id="content_wrapper">';
      return $html;
    }

    private function pageFooter(){
      $html = "      </div>
                  </div>
                </body>
              </html>";
      return $html;
    }

    public function generuj($contents){
      $filename = "alexis.pdf";
      $cache = PROJ_PATH_ABS."/".CACHE_DIR."/";
      if(file_exists($cache.$filename)){
        unlink($cache.$filename);
      }
      $html = $this->pageHeader().$contents.$this->pageFooter();
      $this->snappy->generateFromHtml($html, $cache.$filename);
      header('Content-Transfer-Encoding: binary');  // For Gecko browsers mainly
      header('Last-Modified: ' . gmdate('D, d M Y H:i:s', filemtime($cache.$filename)) . ' GMT');
      header('Accept-Ranges: bytes');  // For download resume
      header('Content-Encoding: none');
      header('Content-Type: application/pdf');  // PDF
      header('Content-Disposition: attachment; filename=' . $filename);
      readfile($cache.$filename);
    }
  }
?>