<?php
require_once('fx.php');
class QuickSearch{

    public $id      = ''; //interny identifikator pola pre vyhladavie
    public $name    = ''; //nazov pre vystupy na obrazovku
    public $group   = ''; //group id (helps to group options in SELECTs)
    public $type    = ''; //txt: textove pole | txt_ac: textove pole s autocomplete | txt_MCE: text z MCE editoru | cis: ciselnik
    public $var_vyz = ''; //parent - var: varianta | vyz: vyznam | hes: heslo | podh: podhesli
    public $cis     = ''; //identifikator ciselniku (pomocou konstant)
    public $tbl     = ''; //tabulka kde najdem hodnoty textoveho pola (pre autokomplete)
    public $searchField = ''; //in last join table!
    public $replaceField_full = '';
    public $replaceField = '';
    public $domIdPattern = '';
    public $custom_vals = array();

    public $JOIN_tbls = array();

    public function __construct($id){
        $this->id = $id;
        $this->search_setup();
    }

    public static function get_search_fields($role){
        if(is_role_uzivatel($role))
        {
            return array(
                "heslo",
                "heslo-do_vystupu", //new
                "heslo-stav", //new
                "heslo-konec_zahlavi",
                "lexikograficka_poznamka",//new
                "odbornik_poznamka",//new
                "zpracovatele",//new
                "heslo-pripojeni", //new
                "heslo-prihnizdovani", //new
                //"heslo-pripojeni-prihnizdovani", //new
                "heslo-typ-linkovani", //new
                "heslo-extPozn-textDisp",
                "heslo-extPozn-typeDisp",
                "varianta-komentar_varianty",
                "varianta-komentar_varianty_za",
                "varianta-podhesli",
                //"varianta-komentar_podhesli", //pole odstraneno z formulare
                "varianta-typ_hesla",
                "varianta-vyslovnost-text",
                "varianta-vyslovnost-komentar",
                "varianta-komentar-tvaru", //2015-05-10
                "varianta-slovny_druh-komentar",
                "varianta-slovnyDruh",
                "varianta-tvarChar",
                "varianta-tvarChar-komentar", //2014-11-14
                "varianta-tvarChar-koncovka-tvar",
                "varianta-tvarChar-koncovka-komentar",
                "varianta-tvarCharSl",
                "varianta-tvarCharSl-komentar", //2014-11-14
                "varianta-tvarCharSl-koncovka-tvar",
                "varianta-tvarCharSl-koncovka-komentar",
                "varianta-vazebnost-text",
                "varianta-vazebnost-komentar",
                "varianta-styl_kval",
                "varianta-gram_info",
                "varianta-tematicke_okruhy",
                "varianta-puvod",
                "varianta-obor_uziti",
                "varianta-prvni_registr_vyskyt",
                "vyznam-vazebnost-text",
                "vyznam-vazebnost-komentar",
                "vyznam-styl_kval",
                "vyznam-tematicke_okruhy",
                "vyznam-obor_uziti",
                "vyznam-slovnyDruh", //new
                "vyznam-slovny_druh-komentar", //new
                "vyznam-gram_info",
                //"vyznam-konc_gram_info",
                "vyznam-tvarChar", //new
                "vyznam-tvarChar-koncovka-tvar", //new
                "vyznam-tvarChar-koncovka-komentar", //new
                "vyznam-tvarCharSl", //new
                "vyznam-tvarCharSl-koncovka-tvar", //new
                "vyznam-tvarCharSl-koncovka-komentar", //new
                "vyznam-zacatek-predvykladu",
                "vyznam-vyraz-predvykladu",
                "vyznam-komentar-predvykladu",
                "vyznam-konec-predvykladu",
                "vyznam-metavyklad1",
                "vyznam-vyklad_vyznamu",
                "vyznam-metavyklad2",
                "vyznam-synonymum-synonymum",
                "vyznam-synonymum-komentar",
                "vyznam-antonymum-antonymum",
                "vyznam-antonymum-komentar",
                "vyznam-exemplifikacia-text",
                "vyznam-exemplifikacia-nez-text",
                "vyznam-exemplifikacia-ele-text",
                "vyznam-extPozn-textDisp",
                "vyznam-extPozn-typeDisp",
                "podvyznam-existence",
                "podhesli-podhesli", //zmenene
                "podhesli-komentar-pred", //nove
                "podhesli-komentar-za", //nove
                "podhesli-gram_info"
            );
        }
        else
        {
            return array(
                "heslo"
            );
        }
    }

    private function search_setup(){
        global $_CIS_VYBER, $_VYSTUP_PRO_FILTR, $_STAV_HESLA, $_STAV_HESLA_SEMAFOR;
        switch($this->id){
            case 'heslo-do_vystupu':
                $this->name = 'výstup';
                $this->group = 'hes';
                $this->type = 'select';
                $this->custom_vals = $_VYSTUP_PRO_FILTR;
                $this->searchField = "vystup";
                $this->replaceField = "vystup";
                $this->tbl = 'heslo';
                $this->domIdPattern = "heslo-*hid*--do_vystupu";
                break;
            case 'heslo-stav':
                $this->name = 'semafor';
                $this->group = 'hes';
                $this->type = 'select';
                $this->var_vyz = 'hes';
                $this->custom_vals = $_STAV_HESLA_SEMAFOR;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"aktual_heslo_stav", "fk"=>"hid")
                );
                $this->searchField = "a1.stav";
                $this->replaceField = "stav";
                $this->tbl = 'aktual_heslo_stav';
                $this->domIdPattern = "heslo-*hid*--stav_semafor";
                break;
            case 'heslo-prihnizdovani':
                $this->name = 'přihnízdovaná hesla';
                $this->group = 'hes';
                $this->type = 'txt';
                $this->var_vyz = 'hes';
                $this->size = 'single';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"hesla_rel", "fk"=>"slave_hid")
                );
                $this->tbl = 'hesla_rel';
                $this->searchField = 'slave_str';
                $this->replaceField = "slave_str";
                $this->domIdPattern = "nest-*detail_id*";
                break;
            case 'heslo-pripojeni-prihnizdovani':
                $this->name = 'připojená nebo přihnízdovaná hesla';
                $this->group = 'hes';
                $this->type = 'txt';
                $this->var_vyz = 'hes';
                $this->size = 'single';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"hesla_rel", "fk"=>"slave_hid")
                );
                $this->tbl = 'hesla_rel';
                $this->searchField = 'slave_str';
                $this->replaceField = "slave_str";
                $this->domIdPattern = "nest-*detail_id*";
                break;
            case 'heslo-pripojeni':
                $this->name = 'připojená hesla';
                $this->group = 'hes';
                $this->type = 'txt';
                $this->var_vyz = 'hes';
                $this->size = 'single';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"hesla_rel", "fk"=>"slave_hid")
                );
                $this->tbl = 'hesla_rel';
                $this->searchField = 'slave_str';
                $this->replaceField = "slave_str";
                $this->domIdPattern = "nest-*detail_id*";
                break;
            case 'odbornik_poznamka':
                $this->name = 'poznámka pro odborníka';
                $this->group = 'hes';
                $this->type = 'txt';
                $this->size = 'mult';
                $this->searchField = "pozn_odbornik";
                $this->replaceField = "pozn_odbornik";
                $this->tbl = 'heslo';
                $this->domIdPattern = "heslo-*hid*--poznamka_odbornik";
                break;
            case 'lexikograficka_poznamka':
                $this->name = 'lexikografická poznámka';
                $this->group = 'hes';
                $this->type = 'txt';
                $this->size = 'mult';
                $this->searchField = "lexgraf_pozn";
                $this->replaceField = "lexgraf_pozn";
                $this->tbl = 'heslo';
                $this->domIdPattern = "heslo-*hid*--lexikograficka_poznamka";
                break;
            case 'zpracovatele':
                $this->name = 'zpracovatel';
                $this->group = 'hes';
                $this->type = 'cis';
                $this->var_vyz = 'hes';
                $this->cis = ZPRACOVATELE;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>$_CIS_VYBER[ZPRACOVATELE][0], "fk"=>"hid")
                );
                $this->tbl = $_CIS_VYBER[ZPRACOVATELE][0];
                $this->searchField = "a1.uid";
                $this->replaceField = "uid";
                $this->domIdPattern = ""; //nelze menit redakcnim modulem
                break;
            case 'heslo-typ-linkovani':
                $this->name = 'typ odkazu';
                $this->group = 'hes';
                $this->type = 'cis';
                $this->var_vyz = 'hes';
                $this->cis = TYP_LINKOVANI;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"hesla_rel", "fk"=>"main_hid"),
                    2 => array("tbl"=>$_CIS_VYBER[TYP_LINKOVANI][0], "fk"=>"hesla_rel_id")
                );
                $this->tbl = $_CIS_VYBER[TYP_LINKOVANI][0];
                $this->jine = "a2.jine";
                $this->searchField = "a2.cis_id";//array("a1.main_hid", "a2.cis_id");
                $this->replaceField = "cis_id";
                $this->domIdPattern = "link-*detail_id*";
                break;
            case 'heslo-extPozn-textDisp':
                $this->name = 'externí poznámka hesla';
                $this->group = 'hes';
                $this->type = 'txt';
                $this->size = 'mult';
                $this->var_vyz = 'hes';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"ext_poznamky_hes", "fk"=>"hid")
                );
                $this->searchField = "poznamka";
                $this->replaceField = "poznamka";
                $this->tbl = 'ext_poznamky_hes';
                $this->domIdPattern = "heslo-*hid*--extPozn-*detail_id*--text";
                break;
            case 'heslo-extPozn-typeDisp':
                $this->name = 'typ externí poznámky';
                $this->group = 'hes';
                $this->type = 'cis';
                $this->var_vyz = 'hes';
                $this->cis = TYP_EXT_POZN;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>$_CIS_VYBER[TYP_EXT_POZN][0], "fk"=>"hid")
                );
                $this->tbl = $_CIS_VYBER[TYP_EXT_POZN][0];
                $this->searchField = "cis_id";
                $this->replaceField = "cis_id";
                $this->domIdPattern = ""; //neni v redakci
                break;
            case 'heslo-konec_zahlavi':
                $this->name = 'poslední místo záhlaví';
                $this->group = 'hes';
                $this->type = 'cis';
                $this->var_vyz = 'hes';
                $this->cis  = KONEC_ZAHLAVI;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>$_CIS_VYBER[KONEC_ZAHLAVI][0], "fk"=>"hid")
                );
                $this->tbl = $_CIS_VYBER[KONEC_ZAHLAVI][0];
                $this->searchField = "cis_id";
                $this->replaceField = "cis_id";
                $this->jine = "jine";
                $this->domIdPattern = "heslo-*hid*--konec_zahlavi";
                break;
            case 'varianta-komentar_varianty':
                $this->name = 'komentář k variantě (před)';
                $this->group = 'var';
                $this->type = 'txt';
                $this->size = 'single';
                $this->var_vyz = 'var';
                $this->searchField = "komentar";
                $this->replaceField = "komentar";
                $this->tbl = 'varianty';
                $this->domIdPattern = "varianta-*varid*--komentar";
                break;
            case 'varianta-komentar_varianty_za':
                $this->name = 'komentář k variantě (za)';
                $this->group = 'var';
                $this->type = 'txt';
                $this->size = 'single';
                $this->var_vyz = 'var';
                $this->searchField = "komentar_za";
                $this->replaceField = "komentar_za";
                $this->tbl = 'varianty';
                $this->domIdPattern = "varianta-*varid*--komentarza";
                break;
            case 'varianta-podhesli':
                $this->name = 'podheslí';
                $this->group = 'var';
                $this->type = 'txt_ac';
                $this->size = 'single';
                $this->var_vyz = 'var';
                $this->searchField = "varianta";
                $this->replaceField = "varianta";
                $this->tbl = 'varianty';
                $this->domIdPattern = "varianta-*varid*--tvar";
                break;
            case 'varianta-komentar_podhesli':
                $this->name = 'komentář k podhesli varianty';
                $this->group = 'var';
                $this->type = 'txt';
                $this->size = 'single';
                $this->var_vyz = 'var';
                $this->searchField = "komentar_podhesli";
                $this->replaceField = "komentar_podhesli";
                $this->tbl = 'varianty';
                $this->domIdPattern = "varianta-*varid*--komentar";
                break;
            case 'varianta-typ_hesla':
                $this->name = 'typ hesla';
                $this->group = 'var';
                $this->type = 'cis';
                $this->var_vyz = 'var';
                $this->cis  = TYP_HESLA;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>$_CIS_VYBER[TYP_HESLA][0], "fk"=>"vid")
                );
                $this->tbl = $_CIS_VYBER[TYP_HESLA][0];
                $this->searchField = "cis_id";
                $this->replaceField = "cis_id";
                $this->jine = "jine";
                $this->domIdPattern = "varianta-*varid*--typ_hesla";
                break;
            case 'varianta-vyslovnost-text':
                $this->name = 'výslovnost varianty';
                $this->group = 'var';
                $this->type = 'txt_ac';
                $this->size = 'single';
                $this->var_vyz = 'var';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"vyslovnost_var", "fk"=>"vid")
                );
                $this->searchField = "vyslovnost";
                $this->replaceField = "vyslovnost";
                $this->tbl = 'vyslovnost_var';
                $this->domIdPattern = "varianta-*varid*--vyslovnost-*detail_id*--tvar";
                break;
            case 'varianta-vyslovnost-komentar':
                $this->name = 'komentář k výslovnosti varianty';
                $this->group = 'var';
                $this->type = 'txt';
                $this->size = 'single';
                $this->var_vyz = 'var';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"vyslovnost_var", "fk"=>"vid")
                );
                $this->searchField = "a1.komentar"; //a1 is because of alias of table in the Join
                $this->replaceField = "komentar";
                $this->tbl = 'vyslovnost_var';
                $this->domIdPattern = "varianta-*varid*--*detail_id*--komentar";
                break;
            case 'varianta-komentar-tvaru':
                $this->name = 'okomentované tvary';
                $this->group = 'var';
                $this->type = 'txt_MCE';
                $this->size = 'mult';
                $this->var_vyz = 'var';
                $this->searchField = "komentar_tvaru_bz";
                $this->replaceField_full = "komentar_tvaru";
                $this->replaceField = "komentar_tvaru";
                $this->tbl = 'varianty';
                $this->domIdPattern = "varianta-*varid*--komentar_tvaru";
                break;
            case 'varianta-slovny_druh-komentar':
                $this->name = 'komentář slovního druhu';
                $this->group = 'var';
                $this->type = 'txt';
                $this->size = 'single';
                $this->var_vyz = 'var';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"var_slov_druhy_vyber_rel", "fk"=>"vid")
                );
                $this->searchField = "a1.komentar";
                $this->replaceField = "komentar";
                $this->tbl = "var_slov_druhy_vyber_rel";
                $this->domIdPattern = "varianta-*varid*--slovnyDruh-*detail_id*--komentar";
                break;
            case 'varianta-tvarChar':
                $this->name = 'tvaroslovná charakteristika';
                $this->group = 'var';
                $this->type = 'cis';
                $this->var_vyz = 'var';
                $this->cis  = TVAR_CHAR;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"var_tvar_char_vyber_rel", "fk"=>"vid"),
                    2 => array("tbl"=>"tvar_char_vyber", "fk"=>"var_tvar_char_vyber_rel_id"));
                $this->searchField = "cis_id";
                $this->replaceField = "cis_id";
                $this->tbl = "tvar_char_vyber";
                $this->jine = "jine";
                $this->domIdPattern = "varianta-*varid*--tvarChar-*detail_id*";
                break;
            case 'varianta-tvarChar-komentar':
                $this->name = 'komentář tvaroslovné charakteristiky';
                $this->group = 'var';
                $this->type = 'txt';
                $this->size = 'single';
                $this->var_vyz = 'var';
                $this->searchField = "komentar_tvarchar";
                $this->replaceField = "komentar_tvarchar";
                $this->tbl = 'varianty';
                $this->domIdPattern = "varianta-*varid*--komentar_tvarchar";
                break;
            case 'varianta-tvarChar-koncovka-tvar':
                $this->name = 'tvar tvaroslovné charakteristiky';
                $this->group = 'var';
                $this->type = 'txt_ac';
                $this->size = 'single';
                $this->var_vyz = 'var';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"var_tvar_char_vyber_rel", "fk"=>"vid"),
                    2 => array("tbl"=>"koncovky_tvar_char", "fk"=>"var_tvar_char_rel_id"));
                $this->searchField = "koncovka";
                $this->replaceField = "koncovka";
                $this->tbl = "koncovky_tvar_char";
                $this->domIdPattern = "varianta-*varid*--tvarChar-*detail1_id*--koncovka-*detail2_id*--tvar";
                break;
            case 'varianta-tvarChar-koncovka-komentar':
                $this->name = 'komentář k tvaru tvaroslovné char.';
                $this->group = 'var';
                $this->type = 'txt';
                $this->size = 'single';
                $this->var_vyz = 'var';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"var_tvar_char_vyber_rel", "fk"=>"vid"),
                    2 => array("tbl"=>"koncovky_tvar_char", "fk"=>"var_tvar_char_rel_id")
                );
                $this->searchField = "a2.komentar";
                $this->replaceField = "komentar";
                $this->tbl = "koncovky_tvar_char";
                $this->domIdPattern = "varianta-*varid*--tvarChar-*detail1_id*--koncovka-*detail2_id*--komentar";
                break;
            case 'varianta-tvarCharSl':
                $this->name = 'tvaroslovná charakteristika slovesa';
                $this->group = 'var';
                $this->type = 'cis';
                $this->var_vyz = 'var';
                $this->cis  = TVAR_CHAR_SL;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"var_tvar_char_sl_vyber_rel", "fk"=>"vid"),
                    2 => array("tbl"=>"tvar_char_sl_vyber", "fk"=>"var_tvar_char_sl_vyber_rel_id"));
                $this->searchField = "cis_id";
                $this->replaceField = "cis_id";
                $this->jine="jine";
                $this->tbl = "tvar_char_sl_vyber";
                $this->domIdPattern = "varianta-*varid*--tvarCharSl-*detail_id*";
                break;
            case 'varianta-tvarCharSl-komentar':
                $this->name = 'komentář tvaroslovné char. slovesa';
                $this->group = 'var';
                $this->type = 'txt';
                $this->size = 'single';
                $this->var_vyz = 'var';
                $this->searchField = "komentar_tvarchar_slovesa";
                $this->replaceField = "komentar_tvarchar_slovesa";
                $this->tbl = 'varianty';
                $this->domIdPattern = "varianta-*varid*--komentar_tvarchar_slovesa";
                break;
            case 'varianta-tvarCharSl-koncovka-tvar':
                $this->name = 'tvar tvarosl. char. slovesa';
                $this->group = 'var';
                $this->type = 'txt_ac';
                $this->size = 'single';
                $this->var_vyz = 'var';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"var_tvar_char_sl_vyber_rel", "fk"=>"vid"),
                    2 => array("tbl"=>"koncovky_tvar_char_sl", "fk"=>"var_tvar_char_sl_rel_id"));
                $this->searchField = "koncovka";
                $this->replaceField = "koncovka";
                $this->tbl = "koncovky_tvar_char_sl";
                $this->domIdPattern = "varianta-*varid*--tvarCharSl-*detail1_id*--koncovka-*detail2_id*--tvar";
                break;
            case 'varianta-tvarCharSl-koncovka-komentar':
                $this->name = 'komentář k tvaru tvaroslovné char. slovesa';
                $this->group = 'var';
                $this->type = 'txt';
                $this->size = 'single';
                $this->var_vyz = 'var';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"var_tvar_char_sl_vyber_rel", "fk"=>"vid"),
                    2 => array("tbl"=>"koncovky_tvar_char_sl", "fk"=>"var_tvar_char_sl_rel_id")
                );
                $this->searchField = "a2.komentar";
                $this->replaceField = "komentar";
                $this->tbl = "koncovky_tvar_char_sl";
                $this->domIdPattern = "varianta-*varid*--tvarCharSl-*detail1_id*--koncovka-*detail2_id*--komentar";
                break;
            case 'varianta-vazebnost-text':
                $this->name = 'valence/vazebnost';
                $this->group = 'var';
                $this->type = 'txt_ac';
                $this->size = 'mult';
                $this->var_vyz = 'var';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"vazebnost_var", "fk"=>"vid")
                );
                $this->searchField = "vazebnost";
                $this->replaceField = "vazebnost";
                $this->tbl = 'vazebnost_var';
                $this->domIdPattern = "varianta-*varid*--vazebnost-*detail_id*--tvar";
                break;
            case 'varianta-vazebnost-komentar':
                $this->name = 'kom. k valenci/vazebnosti varianty';
                $this->group = 'var';
                $this->type = 'txt';
                $this->size = 'single';
                $this->var_vyz = 'var';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"vazebnost_var", "fk"=>"vid")
                );
                $this->searchField = "a1.komentar";
                $this->replaceField = "komentar";
                $this->tbl = 'vazebnost_var';
                $this->domIdPattern = "varianta-*varid*--vazebnost-*detail_id*--komentar";
                break;
            case 'varianta-styl_kval':
                $this->name = 'stylistický kvalifikátor';
                $this->group = 'var';
                $this->type = 'cis';
                $this->var_vyz = 'var';
                $this->cis  = STYL_KVAL;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>$_CIS_VYBER[STYL_KVAL][0], "fk"=>"vid")
                );
                $this->tbl = $_CIS_VYBER[STYL_KVAL][0];
                $this->searchField = "cis_id";
                $this->replaceField = "cis_id";
                $this->jine = "jine";
                $this->domIdPattern = "varianta-*varid*--styl_kval";
                break;
            case 'varianta-gram_info':
                $this->name = 'upřesňující gramatické inf.';
                $this->group = 'var';
                $this->type = 'cis';
                $this->var_vyz = 'var';
                $this->cis  = GRAM_INFO;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>$_CIS_VYBER[GRAM_INFO][0], "fk"=>"vid")
                );
                $this->tbl = $_CIS_VYBER[GRAM_INFO][0];
                $this->searchField = "cis_id";
                $this->replaceField = "cis_id";
                $this->jine = "jine";
                $this->domIdPattern = "varianta-*varid*--gram_info";
                break;
            case "varianta-slovnyDruh":
                $this->name = 'slovní druh';
                $this->group = 'var';
                $this->type = 'cis';
                $this->var_vyz = 'var';
                $this->cis  = SLOV_DRUHY;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"var_slov_druhy_vyber_rel", "fk"=>"vid"),
                    2 => array("tbl"=>"slov_druhy_vyber", "fk"=>"var_slov_druhy_vyber_rel_id"));
                $this->searchField = "cis_id";
                $this->replaceField = "cis_id";
                $this->jine = "jine";
                $this->tbl = "slov_druhy_vyber";
                $this->domIdPattern = "varianta-*varid*--slovnyDruh-*detail_id*";
                break;
            case 'varianta-tematicke_okruhy':
                $this->name = 'tematické okruhy';
                $this->group = 'var';
                $this->type = 'cis';
                $this->var_vyz = 'var';
                $this->cis  = TEMATICKE_OKRUHY;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>$_CIS_VYBER[TEMATICKE_OKRUHY][0], "fk"=>"vid")
                );
                $this->tbl = $_CIS_VYBER[TEMATICKE_OKRUHY][0];
                $this->searchField = "cis_id";
                $this->replaceField = "cis_id";
                $this->jine = "jine";
                $this->domIdPattern = "varianta-*varid*--tematicke_okruhy";
                break;
            case 'varianta-puvod':
                $this->name = 'původ';
                $this->group = 'var';
                $this->type = 'cis';
                $this->var_vyz = 'var';
                $this->cis  = PUVOD;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>$_CIS_VYBER[PUVOD][0], "fk"=>"vid")
                );
                $this->tbl = $_CIS_VYBER[PUVOD][0];
                $this->searchField = "cis_id";
                $this->replaceField = "cis_id";
                $this->jine = "jine";
                $this->domIdPattern = "varianta-*varid*--puvod";
                break;
            case 'varianta-obor_uziti':
                $this->name = 'obor/oblast užití';
                $this->group = 'var';
                $this->type = 'cis';
                $this->var_vyz = 'var';
                $this->cis  = OBOR_UZITI;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>$_CIS_VYBER[OBOR_UZITI][0], "fk"=>"vid")
                );
                $this->tbl = $_CIS_VYBER[OBOR_UZITI][0];
                $this->searchField = "cis_id";
                $this->replaceField = "cis_id";
                $this->jine = "jine";
                $this->domIdPattern = "varianta-*varid*--obor_uziti";
                break;
            case 'varianta-prvni_registr_vyskyt':
                $this->name = 'první registrovaný výskyt';
                $this->group = 'var';
                $this->type = 'txt_ac';
                $this->size = 'single';
                $this->var_vyz = 'var';
                $this->searchField = "prvni_reg_vyskyt";
                $this->replaceField = "prvni_reg_vyskyt";
                $this->tbl = 'varianty';
                $this->domIdPattern = "varianta-*varid*--prvni_registr_vyskyt";
                break;
            case 'vyznam-vazebnost-text':
                $this->name = 'valence/vazebnost';
                $this->group = 'vyz';
                $this->type = 'txt_ac';
                $this->size = 'mult';
                $this->var_vyz = 'vyz';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"vazebnost_vyz", "fk"=>"vyz_id")
                );
                $this->searchField = "vazebnost";
                $this->replaceField = "vazebnost";
                $this->tbl = 'vazebnost_vyz';
                $this->domIdPattern = "vyznam-*vyz_id*--vazebnost-*detail_id*--tvar";
                break;
            case 'vyznam-vazebnost-komentar':
                $this->name = 'kom. k valenci/vazebnosti významu';
                $this->group = 'vyz';
                $this->type = 'txt';
                $this->size = 'single';
                $this->var_vyz = 'vyz';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"vazebnost_vyz", "fk"=>"vyz_id")
                );
                $this->searchField = "a1.komentar";
                $this->replaceField = "komentar";
                $this->tbl = 'vazebnost_vyz';
                $this->domIdPattern = "vyznam-*vyz_id*--vazebnost-*detail_id*--komentar";
                break;
            case 'vyznam-styl_kval':
                $this->name = 'stylistický kvalifikátor významu';
                $this->group = 'vyz';
                $this->type = 'cis';
                $this->var_vyz = 'vyz';
                $this->cis  = STYL_KVAL;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>$_CIS_VYBER[STYL_KVAL][1], "fk"=>"vyz_id")
                );
                $this->jine = "jine";
                $this->searchField = "cis_id";
                $this->replaceField = "cis_id";
                $this->tbl = $_CIS_VYBER[STYL_KVAL][1];
                $this->domIdPattern = "vyznam-*vyz_id*--styl_kval";
                break;
            case 'vyznam-tematicke_okruhy':
                $this->name = 'tematické okruhy významu';
                $this->group = 'vyz';
                $this->type = 'cis';
                $this->var_vyz = 'vyz';
                $this->cis  = TEMATICKE_OKRUHY;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>$_CIS_VYBER[TEMATICKE_OKRUHY][1], "fk"=>"vyz_id")
                );
                $this->tbl = $_CIS_VYBER[TEMATICKE_OKRUHY][1];
                $this->jine = "jine";
                $this->searchField = "cis_id";
                $this->replaceField = "cis_id";
                $this->domIdPattern = "vyznam-*vyz_id*--tematicke_okruhy";
                break;
            case 'vyznam-obor_uziti':
                $this->name = 'obor/oblast užití významu';
                $this->group = 'vyz';
                $this->type = 'cis';
                $this->var_vyz = 'vyz';
                $this->cis  = OBOR_UZITI;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>$_CIS_VYBER[OBOR_UZITI][1], "fk"=>"vyz_id")
                );
                $this->tbl = $_CIS_VYBER[OBOR_UZITI][1];
                $this->jine = "jine";
                $this->searchField = "cis_id";
                $this->replaceField = "cis_id";
                $this->domIdPattern = "vyznam-*vyz_id*--obor_uziti";
                break;
            case 'vyznam-gram_info':
                $this->name = 'upřesňující gram. inf. významu';
                $this->group = 'vyz';
                $this->type = 'cis';
                $this->var_vyz = 'vyz';
                $this->cis  = GRAM_INFO;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>$_CIS_VYBER[GRAM_INFO][1], "fk"=>"vyz_id")
                );
                $this->tbl = $_CIS_VYBER[GRAM_INFO][1];
                $this->jine = "jine";
                $this->searchField = "cis_id";
                $this->replaceField = "cis_id";
                $this->domIdPattern = "vyznam-*vyz_id*--gram_info";
                break;
            case 'vyznam-konc_gram_info':
                $this->name = 'koncovka gram. inf. významu';
                $this->group = 'vyz';
                $this->type = 'txt_ac';
                $this->size = 'single';
                $this->var_vyz = 'vyz';
                $this->searchField = "koncovka_gram_info";
                $this->replaceField = "koncovka_gram_info";
                $this->tbl  = "vyznamy";
                $this->domIdPattern = " ";
                break;
            case 'vyznam-slovnyDruh':
                $this->name = 'slovní druh významu';
                $this->group = 'vyz';
                $this->type = 'cis';
                $this->var_vyz = 'vyz';
                $this->cis  = SLOV_DRUHY;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"vyz_slov_druhy_vyber_rel", "fk"=>"vyz_id"),
                    2 => array("tbl"=>"slov_druhy_vyber_vyz", "fk"=>"vyz_slov_druhy_vyber_rel_id"));
                $this->searchField = "cis_id";
                $this->replaceField = "cis_id";
                $this->jine = "jine";
                $this->tbl = "slov_druhy_vyber_vyz";
                $this->domIdPattern = "vyznam-*vyz_id*--slovnyDruh-*detail_id*";
                break;
            case 'vyznam-slovny_druh-komentar':
                $this->name = 'komentář slovního druhu významu';
                $this->group = 'vyz';
                $this->type = 'txt';
                $this->size = 'single';
                $this->var_vyz = 'vyz';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"vyz_slov_druhy_vyber_rel", "fk"=>"vyz_id")
                );
                $this->searchField = "a1.komentar";
                $this->replaceField = "komentar";
                $this->tbl = "vyz_slov_druhy_vyber_rel";
                $this->domIdPattern = "vyznam-*vyz_id*--slovnyDruh-*detail_id*--komentar";
                break;
            case 'vyznam-tvarChar':
                $this->name = 'tvaroslovná char. významu';
                $this->group = 'vyz';
                $this->type = 'cis';
                $this->var_vyz = 'vyz';
                $this->cis  = TVAR_CHAR;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"vyz_tvar_char_vyber_rel", "fk"=>"vyz_id"),
                    2 => array("tbl"=>"tvar_char_vyber_vyz", "fk"=>"vyz_tvar_char_vyber_rel_id"));
                $this->searchField = "cis_id";
                $this->replaceField = "cis_id";
                $this->jine = "jine";
                $this->tbl = "tvar_char_vyber_vyz";
                $this->domIdPattern = "vyznam-*vyz_id*--tvarChar-*detail_id*";
                break;
            case 'vyznam-tvarChar-koncovka-tvar':
                $this->name = 'tvar tvaroslovné charakteristiky';
                $this->group = 'vyz';
                $this->type = 'txt_ac';
                $this->size = 'single';
                $this->var_vyz = 'vyz';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"vyz_tvar_char_vyber_rel", "fk"=>"vyz_id"),
                    2 => array("tbl"=>"koncovky_tvar_char_vyz", "fk"=>"vyz_tvar_char_rel_id"));
                $this->searchField = "koncovka";
                $this->replaceField = "koncovka";
                $this->tbl = "koncovky_tvar_char_vyz";
                $this->domIdPattern = "vyznam-*vyz_id*--tvarChar-*detail1_id*--koncovka-*detail2_id*--tvar";
                break;
            case 'vyznam-tvarChar-koncovka-komentar':
                $this->name = 'komentář tvaroslovné char. významu';
                $this->group = 'vyz';
                $this->type = 'txt';
                $this->size = 'single';
                $this->var_vyz = 'vyz';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"vyz_tvar_char_vyber_rel", "fk"=>"vyz_id"),
                    2 => array("tbl"=>"koncovky_tvar_char_vyz", "fk"=>"vyz_tvar_char_rel_id")
                );
                $this->searchField = "a2.komentar";
                $this->replaceField = "komentar";
                $this->tbl = "koncovky_tvar_char_vyz";
                $this->domIdPattern = "vyznam-*vyz_id*--tvarChar-*detail1_id*--koncovka-*detail2_id*--komentar";
                break;
            case 'vyznam-tvarCharSl':
                $this->name = 'tvar. char. slovesa významu';
                $this->group = 'vyz';
                $this->type = 'cis';
                $this->var_vyz = 'vyz';
                $this->cis  = TVAR_CHAR_SL;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"vyz_tvar_char_sl_vyber_rel", "fk"=>"vyz_id"),
                    2 => array("tbl"=>"tvar_char_sl_vyber_vyz", "fk"=>"vyz_tvar_char_sl_vyber_rel_id"));
                $this->searchField = "cis_id";
                $this->replaceField = "cis_id";
                $this->jine = "jine";
                $this->tbl = "tvar_char_sl_vyber_vyz";
                $this->domIdPattern = "vyznam-*vyz_id*--tvarCharSl-*detail_id*";
                break;
            case 'vyznam-tvarCharSl-koncovka-tvar':
                $this->name = 'tvar tvarosl. char. slovesa';
                $this->group = 'vyz';
                $this->type = 'txt_ac';
                $this->size = 'single';
                $this->var_vyz = 'vyz';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"vyz_tvar_char_sl_vyber_rel", "fk"=>"vyz_id"),
                    2 => array("tbl"=>"koncovky_tvar_char_sl_vyz", "fk"=>"vyz_tvar_char_sl_rel_id"));
                $this->searchField = "koncovka";
                $this->replaceField = "koncovka";
                $this->tbl = "koncovky_tvar_char_sl_vyz";
                $this->domIdPattern = "vyznam-*vyz_id*--tvarCharSl-*detail1_id*--koncovka-*detail2_id*--tvar";
                break;
            case 'vyznam-tvarCharSl-koncovka-komentar':
                $this->name = 'kom. tvar. char. slovesa významu';
                $this->group = 'vyz';
                $this->type = 'txt';
                $this->size = 'single';
                $this->var_vyz = 'vyz';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"vyz_tvar_char_sl_vyber_rel", "fk"=>"vyz_id"),
                    2 => array("tbl"=>"koncovky_tvar_char_sl_vyz", "fk"=>"vyz_tvar_char_sl_rel_id")
                );
                $this->searchField = "a2.komentar";
                $this->replaceField = "komentar";
                $this->tbl = "koncovky_tvar_char_sl_vyz";
                $this->domIdPattern = "vyznam-*vyz_id*--tvarCharSl-*detail1_id*--koncovka-*detail2_id*--komentar";
                break;
            case 'vyznam-predvyklad-master':
                $this->name = 'předvýklad významu';
                $this->group = 'vyz';
                $this->type = 'txt';
                $this->size = 'mult';
                $this->var_vyz = 'master';
                $this->searchField = "vm.predvyklad";
                $this->replaceField = "predvyklad";
                $this->tbl = "vyznamy";
                $this->domIdPattern = " ";
                break;
            case 'vyznam-metavyklad1-master':
                $this->name = 'metavýklad 1 významu';
                $this->group = 'vyz';
                $this->type = 'cis';
                $this->var_vyz = 'master';
                $this->cis  = METAVYKLAD1;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>$_CIS_VYBER[METAVYKLAD1][0], "fk"=>"vyz_id")
                );
                $this->tbl = $_CIS_VYBER[METAVYKLAD1][0];
                $this->jine = "jine";
                $this->searchField = "cis_id";
                $this->replaceField = "cis_id";
                $this->domIdPattern = "vyznam-*detail_id*--metavyklad1_master";
                break;
            case 'vyznam-vyklad_vyznamu-master':
                $this->name = 'výklad významu';
                $this->group = 'vyz';
                $this->type = 'txt_MCE';
                $this->size = 'mult';
                $this->var_vyz = 'master';
                $this->searchField = "vm.vyklad_vyznamu_bz";
                $this->replaceField_full = "vm.vyklad_vyznamu";
                $this->replaceField = "vyklad_vyznamu";
                $this->tbl = "vyznamy";
                $this->domIdPattern = "vyznam_master-*detail_id*--vyklad_vyznamu";
                break;
            case 'vyznam-metavyklad2-master':
                $this->name = 'metavýklad 2 významu';
                $this->group = 'vyz';
                $this->type = 'txt';
                $this->size = 'mult';
                $this->var_vyz = 'master';
                $this->searchField = "vm.metavyklad2";
                $this->replaceField = "metavyklad2";
                $this->tbl = "vyznamy";
                $this->domIdPattern = "vyznam-*detail_id*--metavyklad2_master";
                break;
            case 'vyznam-zacatek-predvykladu':
                $this->name = 'začátek předvýkladu významu';
                $this->group = 'vyz';
                $this->type = 'txt';
                $this->size = 'mult';
                $this->var_vyz = 'vyz';
                $this->searchField = "zacatek_predvykladu";
                $this->replaceField = "zacatek_predvykladu";
                $this->tbl = "vyznamy";
                //$this->master  = "check";
                $this->domIdPattern = "vyznam-*detail_id*--zacatek_predvykladu";
                break;
            case 'vyznam-vyraz-predvykladu':
                $this->name = 'výraz předvýkladu';
                $this->group = 'vyz';
                $this->type = 'txt';
                $this->size = 'mult';
                $this->var_vyz = 'vyz';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"vyrazy_predvykladu", "fk"=>"vyz_id")
                );
                $this->searchField = "a1.vyraz";
                $this->replaceField = "vyraz";
                $this->tbl = "vyrazy_predvykladu";
                $this->domIdPattern = "vyznam-*vyz_id*--vyraz_predvykladu-*detail_id*";
                break;
            case 'vyznam-komentar-predvykladu':
                $this->name = 'komentář výrazu předvýkladu';
                $this->group = 'vyz';
                $this->type = 'txt';
                $this->size = 'mult';
                $this->var_vyz = 'vyz';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"vyrazy_predvykladu", "fk"=>"vyz_id")
                );
                $this->searchField = "a1.komentar";
                $this->replaceField = "komentar";
                $this->tbl = "vyrazy_predvykladu";
                $this->domIdPattern = "vyznam-*vyz_id*--komentar_predvykladu-*detail_id*";
                break;
            case 'vyznam-konec-predvykladu':
                $this->name = 'konec předvýkladu významu';
                $this->group = 'vyz';
                $this->type = 'txt';
                $this->size = 'mult';
                $this->var_vyz = 'vyz';
                $this->searchField = "konec_predvykladu";
                $this->replaceField = "konec_predvykladu";
                $this->tbl = "vyznamy";
                //$this->master  = "check";
                $this->domIdPattern = "vyznam-*detail_id*--konec_predvykladu";
                break;
            case 'vyznam-metavyklad1':
                $this->name = 'metavýklad 1 významu';
                $this->group = 'vyz';
                $this->type = 'cis';
                $this->var_vyz = 'vyz';
                $this->cis  = METAVYKLAD1;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>$_CIS_VYBER[METAVYKLAD1][0], "fk"=>"vyz_id")
                );
                $this->tbl = $_CIS_VYBER[METAVYKLAD1][0];
                $this->jine = "jine";
                $this->searchField = "cis_id";
                $this->replaceField = "cis_id";
                $this->master  = "check";
                $this->domIdPattern = "vyznam-*detail_id*--metavyklad1";
                break;
            case 'vyznam-vyklad_vyznamu':
                $this->name = 'výklad významu';
                $this->group = 'vyz';
                $this->type = 'txt_MCE';
                $this->size = 'mult';
                $this->var_vyz = 'vyz';
                $this->searchField = "vyz.vyklad_vyznamu_bz";
                $this->replaceField_full = "vyz.vyklad_vyznamu";
                $this->replaceField = "vyklad_vyznamu";
                $this->tbl  = "vyznamy";
                $this->master  = "check";
                $this->domIdPattern = "vyznam-*detail_id*--vyklad_vyznamu";
                break;
            case 'vyznam-metavyklad2':
                $this->name = 'metavýklad 2 významu';
                $this->group = 'vyz';
                $this->type = 'txt';
                $this->size = 'mult';
                $this->var_vyz = 'vyz';
                $this->searchField = "metavyklad2";
                $this->replaceField = "metavyklad2";
                $this->tbl  = "vyznamy";
                $this->master  = "check";
                $this->domIdPattern = "vyznam-*detail_id*--metavyklad2";
                break;
            case 'vyznam-synonymum-synonymum':
                $this->name = 'synonymum';
                $this->group = 'vyz';
                $this->type = 'txt_ac';
                $this->size = 'single';
                $this->var_vyz = 'hes';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"hesla_rel", "fk"=>"main_hid")
                );
                $this->searchField = "slave_str";
                $this->replaceField = "slave_str";
                $this->tbl = 'hesla_rel';
                $this->domIdPattern = "hidRel-synonymum-slaves-*detail_id*";
                break;
            case 'vyznam-synonymum-komentar':
                $this->name = 'komentář k synonymu';
                $this->group = 'vyz';
                $this->type = 'txt';
                $this->size = 'single';
                $this->var_vyz = 'hes';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"hesla_rel", "fk"=>"main_hid")
                );
                $this->searchField = "a1.komentar";
                $this->replaceField = "komentar";
                $this->tbl = 'hesla_rel';
                $this->domIdPattern = "hidRel-synonymum-slaves-*detail_id*";
                break;
            case 'vyznam-antonymum-antonymum':
                $this->name = 'antonymum';
                $this->group = 'vyz';
                $this->type = 'txt_ac';
                $this->size = 'single';
                $this->var_vyz = 'hes';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"hesla_rel", "fk"=>"main_hid")
                );
                $this->searchField = "slave_str";
                $this->replaceField = "slave_str";
                $this->tbl = 'hesla_rel';
                $this->domIdPattern = "hidRel-antonymum-slaves-*detail_id*";
                break;
            case 'vyznam-antonymum-komentar':
                $this->name = 'komentář k antonymu';
                $this->group = 'vyz';
                $this->type = 'txt';
                $this->size = 'single';
                $this->var_vyz = 'hes';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"hesla_rel", "fk"=>"main_hid")
                );
                $this->searchField = "a1.komentar";
                $this->replaceField = "komentar";
                $this->tbl = 'hesla_rel';
                $this->domIdPattern = "hidRel-antonymum-slaves-*detail_id*";
                break;
            case 'vyznam-exemplifikacia-text':
                $this->name = 'exemplifikace významu (tištěný a elektronický výstup)';
                $this->group = 'vyz';
                $this->type = 'txt_MCE';
                $this->size = 'mult';
                $this->var_vyz = 'vyz';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"exemplifikace", "fk"=>"vyz_id")
                );
                $this->searchField = "exemplifikace_bz";
                $this->replaceField_full = "exemplifikace";
                $this->replaceField = "exemplifikace";
                $this->tbl = 'exemplifikace';
                $this->domIdPattern = "vyznam-*vyz_id*--exemplifikacia-*detail_id*";
                break;
            case 'vyznam-exemplifikacia-ele-text':
                $this->name = 'exemplifikace významu (elektronický výstup)';
                $this->group = 'vyz';
                $this->type = 'txt_MCE';
                $this->size = 'mult';
                $this->var_vyz = 'vyz';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"exemplifikace", "fk"=>"vyz_id")
                );
                $this->searchField = "exemplifikace_bz";
                $this->replaceField_full = "exemplifikace";
                $this->replaceField = "exemplifikace";
                $this->tbl = 'exemplifikace';
                $this->domIdPattern = "vyznam-*vyz_id*--exemplifikacia-*detail_id*";
                break;
            case 'vyznam-exemplifikacia-nez-text':
                $this->name = 'exemplifikace významu (nezařazená)';
                $this->group = 'vyz';
                $this->type = 'txt_MCE';
                $this->size = 'mult';
                $this->var_vyz = 'vyz';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"exemplifikace", "fk"=>"vyz_id")
                );
                $this->searchField = "exemplifikace_bz";
                $this->replaceField_full = "exemplifikace";
                $this->replaceField =  "exemplifikace";
                $this->tbl = 'exemplifikace';
                $this->domIdPattern = "vyznam-*vyz_id*--exemplifikacia-*detail_id*";
                break;
            case 'vyznam-extPozn-textDisp':
                $this->name = 'externí poznámka k významu';
                $this->group = 'vyz';
                $this->type = 'txt';
                $this->size = 'single';
                $this->var_vyz = 'vyz';
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"ext_poznamky_vyz", "fk"=>"vyz_id")
                );
                $this->searchField = "poznamka";
                $this->replaceField = "poznamka";
                $this->tbl = 'ext_poznamky_vyz';
                $this->domIdPattern = "vyznam-*vyz_id*--extPozn-*detail_id*--text";
                break;
            case 'vyznam-extPozn-typeDisp':
                $this->name = 'typ externí poznámky k významu';
                $this->group = 'vyz';
                $this->type = 'cis';
                $this->var_vyz = 'vyz';
                $this->cis = TYP_EXT_POZN;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>$_CIS_VYBER[TYP_EXT_POZN][1], "fk"=>"vyz_id")
                );
                $this->searchField = "cis_id";
                $this->replaceField = "cis_id";
                $this->tbl = $_CIS_VYBER[TYP_EXT_POZN][1];
                $this->domIdPattern = ""; //neni v redakci
                break;
            case 'podvyznam-existence':
                $this->name = 'podvýznam';
                $this->group = 'vyz';
                $this->type = 'exi';
                $this->var_vyz = 'vyz';
                $this->searchField = "vyz.pid";
                $this->replaceField = "pid";
                $this->tbl = "vyznamy";
                $this->domIdPattern = " ";
                break;
            case 'spr-gram_info':
                $this->name = 'upřesňující gramatické inf.';
                $this->group = 'other';
                $this->type = 'cis';
                $this->var_vyz = 'oba';
                $this->cis  = GRAM_INFO;
                $this->searchField = array( "a1.cis_id",  "a4.cis_id" );
                $this->replaceField = "cis_id";
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>$_CIS_VYBER[GRAM_INFO][0], "fk"=>"vid"),
                    4 => array("tbl"=>$_CIS_VYBER[GRAM_INFO][1], "fk"=>"vyz_id")
                );
                $this->tbl = $_CIS_VYBER[GRAM_INFO][1];
                $this->domIdPattern = " ";
                break;
            case 'spr-obor_uziti':
                $this->name = 'obor/oblast užití';
                $this->group = 'other';
                $this->type = 'cis';
                $this->var_vyz = 'oba';
                $this->cis  = OBOR_UZITI;
                $this->searchField = array( "a1.cis_id",  "a4.cis_id" );
                $this->replaceField = "cis_id";
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>$_CIS_VYBER[OBOR_UZITI][0], "fk"=>"vid"),
                    4 => array("tbl"=>$_CIS_VYBER[OBOR_UZITI][1], "fk"=>"vyz_id")
                );
                $this->tbl = $_CIS_VYBER[OBOR_UZITI][1];
                $this->domIdPattern = " ";

                break;
            case "spr-slovnyDruh":
                $this->name = 'slovní druh';
                $this->group = 'other';
                $this->type = 'cis';
                $this->var_vyz = 'oba';
                $this->cis  = SLOV_DRUHY;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"var_slov_druhy_vyber_rel", "fk"=>"vid"),
                    2 => array("tbl"=>"slov_druhy_vyber", "fk"=>"var_slov_druhy_vyber_rel_id"),
                    4 => array("tbl"=>"vyz_slov_druhy_vyber_rel", "fk"=>"vyz_id"),
                    5 => array("tbl"=>"slov_druhy_vyber_vyz", "fk"=>"vyz_slov_druhy_vyber_rel_id"));
                $this->searchField = array( "a2.cis_id",  "a5.cis_id" );
                $this->replaceField = "cis_id";
                $this->domIdPattern = " ";
                break;
            case 'spr-styl_kval':
                $this->name = 'stylistický kvalifikátor';
                $this->group = 'other';
                $this->type = 'cis';
                $this->var_vyz = 'oba';
                $this->cis  = STYL_KVAL;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>$_CIS_VYBER[STYL_KVAL][0], "fk"=>"vid"),
                    4 => array("tbl"=>$_CIS_VYBER[STYL_KVAL][1], "fk"=>"vyz_id")
                );
                $this->searchField = array( "a1.cis_id",  "a4.cis_id" );
                $this->replaceField = "cis_id";
                $this->domIdPattern = " ";
                break;
            case 'spr-tematicke_okruhy':
                $this->name = 'tematické okruhy';
                $this->group = 'other';
                $this->type = 'cis';
                $this->var_vyz = 'oba';
                $this->cis  = TEMATICKE_OKRUHY;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>$_CIS_VYBER[TEMATICKE_OKRUHY][0], "fk"=>"vid"),
                    4 => array("tbl"=>$_CIS_VYBER[TEMATICKE_OKRUHY][1], "fk"=>"vyz_id")
                );
                $this->searchField = array( "a1.cis_id",  "a4.cis_id" );
                $this->replaceField = "cis_id";
                $this->domIdPattern = " ";
                break;
            case 'spr-tvarChar':
                $this->name = 'tvaroslovná char.';
                $this->group = 'other';
                $this->type = 'cis';
                $this->var_vyz = 'oba';
                $this->cis  = TVAR_CHAR;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"var_tvar_char_vyber_rel", "fk"=>"vid"),
                    2 => array("tbl"=>"tvar_char_vyber", "fk"=>"var_tvar_char_vyber_rel_id"),
                    4 => array("tbl"=>"vyz_tvar_char_vyber_rel", "fk"=>"vyz_id"),
                    5 => array("tbl"=>"tvar_char_vyber_vyz", "fk"=>"vyz_tvar_char_vyber_rel_id"));
                $this->searchField = array( "a2.cis_id",  "a5.cis_id" );
                $this->replaceField = "cis_id";
                $this->domIdPattern = " ";
                break;
            case 'spr-tvarCharSl':
                $this->name = 'tvaroslovná char. slovesa';
                $this->group = 'other';
                $this->type = 'cis';
                $this->var_vyz = 'oba';
                $this->cis  = TVAR_CHAR_SL;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"var_tvar_char_sl_vyber_rel", "fk"=>"vid"),
                    2 => array("tbl"=>"tvar_char_sl_vyber", "fk"=>"var_tvar_char_sl_vyber_rel_id"),
                    4 => array("tbl"=>"vyz_tvar_char_sl_vyber_rel", "fk"=>"vyz_id"),
                    5 => array("tbl"=>"tvar_char_sl_vyber_vyz", "fk"=>"vyz_tvar_char_sl_vyber_rel_id"));
                $this->searchField = array( "a2.cis_id",  "a5.cis_id" );
                $this->replaceField = "cis_id";
                $this->domIdPattern = " ";
                break;
            case 'spr-typ-linkovani':
                $this->name = 'typ odkazu';
                //$this->group = 'hes';
                $this->type = 'cis';
                $this->var_vyz = 'hes';
                $this->cis = TYP_LINKOVANI;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>"hesla_rel", "fk"=>"main_hid"),
                    2 => array("tbl"=>$_CIS_VYBER[TYP_LINKOVANI][0], "fk"=>"hesla_rel_id")
                );
                $this->searchField = "cis_id";
                $this->replaceField = "cis_id";
                $this->domIdPattern = " ";
                break;
            case 'spr-prevzaty-metavyklad1':
                $this->name = 'převzatý metavýklad 1 významu';
                $this->group = 'vyz';
                $this->type = 'cis';
                $this->var_vyz = 'master';
                $this->cis  = METAVYKLAD1_M;
                $this->JOIN_tbls = array(
                    1 => array("tbl"=>$_CIS_VYBER[METAVYKLAD1_M][0], "fk"=>"vyz_id")
                );
                $this->searchField = "a1.cis_id";
                $this->replaceField = "cis_id";
                //$this->master  = "master";
                $this->domIdPattern = " ";
                break;
            case 'podhesli-podhesli':
                $this->name = 'podheslí významu';
                $this->group = 'podh';
                $this->type = 'txt_ac';
                $this->size = 'single';
                $this->var_vyz = 'podh';
                $this->searchField = "podh.podhesli";
                $this->replaceField = "podhesli";
                $this->tbl = 'podhesli_vyznamu';
                $this->domIdPattern = "podhesli-*detail_id*--tvar_podhesli";
                break;
            case 'podhesli-komentar-pred':
                $this->name = 'komentář k podheslí významu (před)';
                $this->group = 'podh';
                $this->type = 'txt';
                $this->size = 'single';
                $this->var_vyz = 'podh';
                $this->searchField = "podh.komentar_pred";
                $this->replaceField = "komentar_pred";
                $this->tbl = 'podhesli_vyznamu';
                $this->domIdPattern = "podhesli-*detail_id*--komentar_podhesli";
                break;
            case 'podhesli-komentar-za':
                $this->name = 'komentář k podheslí významu (za)';
                $this->group = 'podh';
                $this->type = 'txt';
                $this->size = 'single';
                $this->var_vyz = 'podh';
                $this->searchField = "podh.komentar_za";
                $this->replaceField = "komentar_za";
                $this->tbl = 'podhesli_vyznamu';
                $this->domIdPattern = "podhesli-*detail_id*--komentar_podhesli_za";
                break;
            case 'podhesli-gram_info':
                    $this->name = 'upřesňující gram. inf. podheslí';
                    $this->group = 'podh';
                    $this->type = 'cis';
                    $this->var_vyz = 'podh';
                    $this->cis  = GRAM_INFO;
                    $this->JOIN_tbls = array(
                      1 => array("tbl"=>$_CIS_VYBER[GRAM_INFO][2], "fk"=>"podh_id")
                    );
                    $this->jine = "jine";
                    $this->searchField = "cis_id";
                    $this->replaceField = "cis_id";
                    $this->tbl = 'podh_vyz_gram_info';
                    $this->domIdPattern = "podhesli-*detail_id*--gram_info";
                    break;
            default:
                $this->name = 'heslo';
                $this->group = 'hes';
                $this->type = 'txt_ac';
                $this->size = 'single';
                $this->var_vyz = 'var';
                $this->searchField = "varianta";
                $this->replaceField = "varianta";
                $this->tbl = 'varianty';
                $this->domIdPattern = "varianta-*varid*--tvar";
                break;
        }
        //make textfield searches and autocompletes case insensitive
        //if($this->type == 'txt_ac' || $this->type == 'txt') $this->searchField.=" COLLATE cp1250_general_ci";
        /* zakomentovane, pretoze nefungovala diakritika a hlasilo chybu pri MATCH AGAINST konstrukcii */

    }

    public function get_joins($search_q = ""){
        /*********** P A T T E R N ***************

        SELECT distinct h.id as hid
        FROM heslo h
        INNER JOIN varianty v ON h.id=v.hid
        INNER JOIN zpracovatel u ON h.id=u.hid
        (1)--> INNER JOIN vyznamy vyz ON vyz.hid = h.id
        (2)--> INNER JOIN A1 a1 ON a1.FK = v.id
        (3)--> INNER JOIN A2 a2 ON a2.FK = a1.id
        WHERE a2.B LIKE "%o%"

         ******************************************/
        $joins = array();
        if($this->var_vyz == 'vyz' || $this->var_vyz == 'oba') $joins[] = "INNER JOIN vyznamy vyz ON vyz.hid = h.id"; //(1)
        if($this->var_vyz == 'podh'){
            $joins[] = "INNER JOIN vyznamy vyz ON vyz.hid = h.id";
            $joins[] = "INNER JOIN podhesli_vyznamu podh ON podh.vyz_id = vyz.id";
        }
        if($this->var_vyz == 'master') {
            $joins[] = "INNER JOIN vyznamy vyz ON vyz.hid = h.id";
            $joins[] = "INNER JOIN vyznamy_master vm ON vm.id = vyz.vyklad_vyznamu_link";
            $joins[] = "LEFT JOIN metavyklad1_vyz_vyber_m a1 ON a1.vyz_id = vm.id";
        }else if ($this->id=="heslo-stav"){
            $joins[] = "LEFT JOIN aktual_heslo_stav a1 ON a1.hid = h.id";
        }else{
            foreach($this->JOIN_tbls as $k => $tblAndFk){ //(2)
                $pTbl_alias = 'v'; //varianty - alias tabulky na ktoru sa pripaja prvy join
                if($this->var_vyz=='hes') $pTbl_alias = 'h'; //heslo
                if($this->var_vyz=='vyz') $pTbl_alias = 'vyz'; //vyznamy
                if($this->var_vyz=='podh') $pTbl_alias = 'podh'; //podhesli
                if($k<2) $constr = $pTbl_alias.".id"; else if($k==4) $constr = "vyz.id"; else if($k==5) $constr = "a4.id";else $constr = "a".($k-1).".id";
                if($this->group=='other' || ($this->type=="cis" && $this->cis == TEMATICKE_OKRUHY && $search_q=="0")){
                    $joins[] = "LEFT JOIN ".$tblAndFk['tbl']." a$k ON a".$k.".".$tblAndFk['fk']."=".$constr;
                } else{
                    $joins[] = "INNER JOIN ".$tblAndFk['tbl']." a$k ON a".$k.".".$tblAndFk['fk']."=".$constr;
                }
            }
        }
        return $joins;
    }

    private function translate_wildcards(&$s){ //returns operator
        $s = trim($s);
        if($s=="") return "";
        $useLike = false;
        if($s=="*") return "%s_field% <> '' and %s_field% IS NOT NULL";

        if($this->size == 'single')
        {
            if(substr($s,0,1)=="*" || substr($s,-1)=="*")
            {
                escape_special_char($s);
                if(substr($s,0,1)=="*") {$s=".*".substr($s,1); $useLike = true;}
                else if(substr($s,-1)=="*"){$s="^".$s; $useLike = true;}
                if(substr($s,-1)=="*") {$s=substr($s,0,-1).".*"; $useLike = true;}
                else if(substr($s,0,1)=="*" OR substr($s,0,2)==".*"){$s=$s."$"; $useLike = true;}
            }
            else
            {
                return "LOWER(%s_field%) = BINARY LOWER('%s_query%')";
            }
        }
        else
        {
            if(substr($s,0,1)=="^" )
            {
                $s=substr($s,1);
                if(substr($s,0,1)=="*" || substr($s,-1)=="*")
                {
                    escape_special_char($s);
                    if(substr($s,0,1)=="*")
                    {
                        $s="[^<>,.;:?!()\"\' ]*".substr($s,1);
                        if(substr($s,-1)=="*")
                        {
                            $s=substr($s,0,-1).".*[<>,.;:?!()\"\' ]+.*";
                        }
                        else
                        {
                            $s=$s."[<>,.;:?!()\"\' ]+.*";
                        }
                    }
                    else if(substr($s,-1)=="*")
                    {
                        $s=substr($s,0,-1).".*[<>,.;:?!()\"\' ]+.*";
                    }
                    //$s=priprav_reg($s);
                    return "LOWER(CONCAT( (%s_field%), ' ')) REGEXP LOWER(('^%s_query%'))";
                }
                else
                {
                    escape_special_char($s);
                    //$s=priprav_reg($s);
                    return "LOWER(CONCAT(%s_field%,' '))  REGEXP LOWER('^%s_query%[<>,;.:?!()\"\' ]+.*')";
                }
            }
            else
            {
                if(substr($s,0,1)=="*" || substr($s,-1)=="*")
                {
                    escape_special_char($s);
                    //$s=priprav_reg($s);
                    if(substr($s,0,1)=="*")
                    {
                        $s=".*[<>,.;:?!()\"\' ]+.*".substr($s,1);
                        if(substr($s,-1)=="*")
                        {
                            $s=substr($s,0,-1).".*[<>,.;:?!()\"\' ]+.*";
                        }
                        else
                        {
                            $s=$s."[<>,.;:?!()\"\' ]+.*";
                        }
                    }
                    else if(substr($s,-1)=="*")
                    {
                        $s=".*[<>,.;:?!()\"\' ]+".substr($s,0,-1).".*[<>,.;:?!()\"\' ]+.*";
                    }
                    return "LOWER(CONCAT(' ', (%s_field%), ' ')) REGEXP LOWER(('%s_query%'))";
                }
                else
                {
                    escape_special_char($s);
                    //$s=priprav_reg($s);
                    return "LOWER(CONCAT(' ',%s_field%,' '))  REGEXP LOWER('.*[<>,.;:?!()\"\' ]+%s_query%[<>,;.:?!()\"\' ]+.*')";
                }
            }

        }
        return ($useLike) ? "%s_field% REGEXP '%s_query%'" : "%s_field% = '%s_query%'";
    }

    public function get_where_clause($sq){

        //if($this->type=="txt_MCE") $sq = htmlspecialchars($sq);
        $_SESSION['search']['morphodita_ok'] = true;
        $morphodita_active = false;
        if($this->type == "cis" or $this->type == "select" )
        {
            if($sq == "jine"){
                if($this->id=="heslo-typ-linkovani"){
                    $where_q = "%s_field% IS NULL AND ".$this->jine." IS NOT NULL";
                } else{
                    $where_q = "%s_field% IS NULL AND ".$this->jine." IS NOT NULL AND ".$this->jine."<>''";
                }
            }else{
                if ($this->id=="heslo-stav" && $sq=="1"){
                    $where_q = "%s_field% = %s_query% OR %s_field% IS NULL";
                }else{
                    //nevyplnene tematicke okruhy
                    if($this->cis == TEMATICKE_OKRUHY && $sq == "0"){
                        if($this->var_vyz == "vyz"){
                            $where_q = "a1.vyz_id IS NULL";
                        } else{
                            $where_q = "a1.vid IS NULL";
                        }
                        
                    } else{
                        $where_q = "%s_field% = %s_query%";
                    }
                }
            }
        }
        else if($this->type == "exi")
        {
            $where_q = "%s_field% > 0";
        }
        else
        {  //txt | txt_ac | txt_MCE
            $tvary = false;
            if($sq[0]=="[" && $sq[strlen($sq)-1]=="]"){
                $morphodita_active = true;
                $sq = trim($sq, "]");
                $sq = trim($sq, "[");
                $tvary = generuj_tvary($sq);
            }
            if($tvary){
                $where_q = "";
                $first = true;
                foreach($tvary as $tvar){
                    escape_special_char($tvar);
                    //$tvar=priprav_reg($tvar);
                    if($first)
                    {
                        $first = false;
                    }
                    else
                    {
                        $where_q.=" OR ";
                    }
                    $where_q .= "(LOWER(CONCAT(' ',%s_field%,' ')) REGEXP LOWER('.*[<>,.;:?!()\"\' ]+".$tvar."[<>,;.:?!()\"\' ]+.*'))";
                }
            }
            else
            {
                if($morphodita_active){
                    $_SESSION['search']['morphodita_ok'] = false;
                }
                $where_q = $this->translate_wildcards($sq);
            }
        }
        if($this->id == "varianta-podhesli"){
            $where_q.=" AND f_varianta=0";
        }
        else if($this->id == "heslo"){
            $where_q.=" AND f_varianta=1";
        }
        if($this->id == "heslo-pripojeni"){
            $where_q.=" AND rel_type=".HREL_TYPE_pripojovani;
        }
        else if($this->id == "heslo-prihnizdovani"){
            $where_q.=" AND rel_type=".HREL_TYPE_prihnizdovani;
        }
        else if($this->id == "heslo-pripojeni-prihnizdovani"){
            $where_q.=" AND rel_type=".HREL_TYPE_prihnizdovani." OR rel_type=".HREL_TYPE_pripojovani;
        }
        else if($this->id == "vyznam-antonymum-antonymum" || $this->id == "vyznam-antonymum-komentar")
        {
            $where_q.=" AND rel_type=4";
        }
        else if($this->id == "vyznam-synonymum-synonymum" || $this->id == "vyznam-synonymum-komentar")
        {
            $where_q.=" AND rel_type=5";
        }
        else if($this->id == "vyznam-exemplifikacia-nez-text"){
            $where_q.=") AND (a1.vystup = ".NEZARAZENO;
        }
        else if($this->id == "vyznam-exemplifikacia-ele-text"){
            $where_q.=") AND (a1.vystup = ".ELEKTRONICKY;
        }
        else if($this->id == "vyznam-exemplifikacia-text"){
            $where_q.=") AND (a1.vystup = ".TISTENY;
        }
        else if($this->id == "varianta-komentar-tvaru"){
            $where_q.=" AND v.hid in (SELECT `hid` FROM `field_control` WHERE `field` = 'varianta-komentar_tvaru')";
        }
        else if($this->master == "check")
        {
            $where_q.=" AND (vyz.vyklad_vyznamu_link IS NULL OR vyz.vyklad_vyznamu_link=0)";
        }
        if($this->group=='other')
        {
            if ($this->type == "txt"){
                $where_q = "%s_field1% = BINARY %s_query% OR %s_field2% = BINARY %s_query% ";
            }else{
                $where_q = "%s_field1% = %s_query% OR %s_field2% = %s_query% ";
            }
            return str_replace(array('%s_field1%','%s_field2%','%s_query%'), array($this->searchField[0], $this->searchField[1], $sq), $where_q);
        }
        else
        {
            return str_replace(array('%s_field%','%s_query%'), array($this->searchField, $sq), $where_q);
        }
    }
}
?>
