<?php

require_once('formular_hesla_fx.php');
require_once('odkazy_fx.php');
require_once('tisk_hesel_fx.php');

class Redakce{

  public $hid     = ''; //identifikator hesla
  public $field   = ''; //identifikator typu hodnoty
  public $val_id  = ''; //identifikator hodnoty
  public $var_vyz = ''; //parent - var: varianta | vyz: vyznam | hes: heslo
  public $name    = ''; //nazov pre vystupy na obrazovku
  public $type    = ''; //Typ pola = cis: ciselnik | txt: textove pole | tarea: textarea | rtext: richtext editor
  public $cis     = ''; //ciselnik
  public $cis_vyb_id = ''; //identifikacia akce pro funkci uloz_vyber_cis() -
  public $tbl     = ''; //tabulka v ktere se provede korekce
  public $db_field= ''; //pole tabulke ktere se bude korigovat

  function __construct() {
    $argv = func_get_args();
    switch(func_num_args()){
      case 1:
        self::__construct1($argv[0]);
        break;
      case 2:
        self::__construct2($argv[0], $argv[1]);
        break;
    }
    $this->_setup();
  }

  function __construct1($kor_id){
    $d = get_db_values('korektura', array('field','field_val_id'), $kor_id);
    $this->field = $d['field'];
    $this->val_id = $d['field_val_id'];
    $this->var_vyz = substr($this->field, 0, 3);
    if($this->var_vyz == "pod"){
        $this->var_vyz = "podh";
    }
  }

  function __construct2($field, $val_id){
    $this->field = $field;
    $this->val_id = $val_id;
    $this->var_vyz = substr($field, 0, 3);
    if($this->var_vyz == "pod"){
        $this->var_vyz = "podh";
    }
  }

  public static function get_type($field){
    switch($field){
      case 'heslo-do_vystupu':
        return 'radio';
        break;
      case 'heslo-stav':
        return 'semafor';
        break;
      case 'heslo-lexikograficka_poznamka':
        return 'tarea';
        break;
      case 'heslo-poznamka_odbornik':
        return 'tarea';
        break;
      case 'heslo-extPozn-text':
        return 'rtext';
        break;
      case 'heslo-konec_zahlavi':
        return 'cis';
        break;
      case 'varianta-tvar':
        return 'txt';
        break;
      case 'varianta-komentar':
        return 'txt';
        break;
      case 'varianta-komentarza':
        return 'txt';
        break;
      case 'varianta-homonymie':
        return 'txt';
        break;
      case 'varianta-podhesli-tvar':
        return 'txt';
        break;
      case 'varianta-podhesli-komentar':
        return 'txt';
        break;
      case 'varianta-typ_hesla':
        return 'cis';
        break;
      case 'varianta-vyslovnost-tvar':
        return 'txt';
        break;
      case 'varianta-vyslovnost-komentar':
        return 'txt';
        break;
      case "varianta-komentar_tvaru":
        return 'rtext';
      break;
      case "varianta-slovnyDruh":
        return 'cis';
        break;
      case 'varianta-slovny_druh-komentar':
        return 'txt';
        break;
      case 'varianta-tvarChar':
        return 'cis';
        break;
      case 'varianta-tvarChar-koncovka-tvar':
        return 'txt';
        break;
      case 'varianta-tvarChar-koncovka-komentar':
        return 'txt';
        break;
      case 'varianta-tvarCharSl':
        return 'cis';
        break;
      case 'varianta-tvarCharSl-koncovka-tvar':
        return 'txt';
        break;
      case 'varianta-tvarCharSl-koncovka-komentar':
        return 'txt';
        break;
      case 'varianta-vazebnost-tvar':
        return 'tarea_wb';
        break;
      case 'varianta-vazebnost-komentar':
        return 'txt';
        break;
      case 'varianta-styl_kval':
        return 'cis';
        break;
      case 'varianta-tematicke_okruhy':
        return 'cis';
        break;
      case 'varianta-puvod':
        return 'cis';
        break;
      case 'varianta-obor_uziti':
        return 'cis';
        break;
      case 'varianta-gram_info':
        return 'cis';
        break;
      case 'varianta-komentar_tvarchar':
        return 'txt';
        break;
      case 'varianta-komentar_tvarchar_slovesa':
        return 'txt';
        break;
      case 'varianta-prvni_registr_vyskyt':
        return 'txt';
        break;
      case 'vyznam-podhesli':
        return 'txt';
        break;
      case 'vyznam-komentar_podhesli':
        return 'txt';
        break;
      case 'vyznam-vazebnost-tvar':
        return 'tarea_wb';
        break;
      case 'vyznam-vazebnost-komentar':
        return 'txt';
        break;
      case 'vyznam-styl_kval':
        return 'cis';
        break;
      case 'vyznam-tematicke_okruhy':
        return 'cis';
        break;
      case 'vyznam-obor_uziti':
        return 'cis';
        break;
      case 'vyznam-gram_info':
        return 'cis';
        break;
      case 'vyznam-slovnyDruh':
        return 'cis';
        break;
      case 'vyznam-slovnyDruh-komentar':
        return 'txt';
        break;
      case 'vyznam-tvarChar':
        return 'cis';
        break;
      case 'vyznam-tvarChar-koncovka-tvar':
        return 'txt';
        break;
      case 'vyznam-tvarChar-koncovka-komentar':
        return 'txt';
        break;
      case 'vyznam-tvarCharSl':
        return 'cis';
        break;
      case 'vyznam-tvarCharSl-koncovka-tvar':
        return 'txt';
        break;
      case 'vyznam-tvarCharSl-koncovka-komentar':
        return 'txt';
        break;
      case 'vyznam-komentar_tvarchar':
        return 'txt';
        break;
      case 'vyznam-komentar_tvarchar_slovesa':
        return 'txt';
        break;
      /*case 'vyznam-predvyklad':
        return 'tarea';
        break;
      case 'vyznam-predvyklad_master':
        return 'tarea';  */
      case 'vyznam-zacatek_predvykladu':
        return 'txt';
        break;
      case 'vyznam-zacatek_predvykladu_master':
        return 'txt';
        break;
      case 'vyznam-vyraz_predvykladu':
        return 'txt';
        break;
      case 'vyznam-vyraz_predvykladu_master':
        return 'txt';
        break;
      case 'vyznam-komentar_predvykladu':
        return 'txt';
        break;
      case 'vyznam-komentar_predvykladu_master':
        return 'txt';
        break;
      case 'vyznam-konec_predvykladu':
        return 'txt';
        break;
      case 'vyznam-konec_predvykladu_master':
        return 'txt';
        break;
      case 'vyznam-metavyklad1':
        return 'cis';
        break;
      case 'vyznam-metavyklad1_master':
        return 'cis';
        break;
      case 'vyznam-vyklad_vyznamu':
        return 'rtext';
        break;
      case 'vyznam-vyklad_vyznamu_master':
        return 'rtext';
        break;
      case 'vyznam-metavyklad2':
        return 'tarea';
        break;
      case 'vyznam-metavyklad2_master':
        return 'tarea';
        break;
      case 'vyznam-synonymum-synonymum':
        return 'txt';
        break;
      case 'vyznam-synonymum-komentar':
        return 'txt';
        break;
      case 'vyznam-antonymum-antonymum':
        return 'txt';
        break;
      case 'vyznam-antonymum-komentar':
        return 'txt';
        break;
      case 'vyznam-exemplifikacia-text':
        return 'rtext';
        break;
      case 'vyznam-extPozn-text':
        return 'rtext';
        break;
      case 'synonymum':
        return 'antsyn';
        break;
      case 'antonymum':
        return 'antsyn';
      break;
      case 'nest':
        return 'nest';
      break;
      case 'vyznam-link':
        return 'vyznam-link';
      break;
      case 'link':
        return 'link';
      break;
      case 'odkaz-typ':
        return 'cis';
        break;
      case 'podhesli-vyslovnost-tvar':
        return 'txt';
        break;
      case 'podhesli-vyslovnost-komentar':
        return 'txt';
        break;
      case 'podhesli-slovnyDruh':
        return 'cis';
        break;
      case 'podhesli-slovnyDruh-komentar':
        return 'txt';
        break;
      case 'podhesli-gram_info':
        return 'cis';
        break;
      case 'podhesli-tvarChar':
        return 'cis';
        break;
      case 'podhesli-tvarChar-koncovka-tvar':
        return 'txt';
        break;
      case 'podhesli-tvarChar-koncovka-komentar':
        return 'txt';
        break;
     case 'podhesli-tvarCharSl':
        return 'cis';
        break;
      case 'podhesli-tvarCharSl-koncovka-tvar':
        return 'txt';
        break;
      case 'podhesli-tvarCharSl-koncovka-komentar':
        return 'txt';
        break;
      case 'podhesli-komentar_tvarchar':
        return 'txt';
        break;
      case 'podhesli-komentar_tvarchar_slovesa':
        return 'txt';
        break;
      case 'podhesli-podhesli':
        return 'txt';
        break;
      case 'podhesli-komentar_podhesli':
        return 'txt';
        break;
      case 'podhesli-komentar-za_podhesli':
        return 'txt';
        break;
      case 'podhesli-vazebnost-tvar':
        return 'tarea_wb';
        break;
      case 'podhesli-vazebnost-komentar':
        return 'txt';
        break;
      case 'podhesli-obor_uziti':
        return 'cis';
        break;
     case 'podhesli-styl_kval':
        return 'cis';
        break;
     case 'podhesli-tematicke_okruhy':
        return 'cis';
        break;
    }
  }

  private function _setup(){
    switch($this->field){
      case 'heslo-do_vystupu':
        $this->name = 'výstup';
        $this->type = 'radio';
        $this->tbl = 'heslo';
        $this->db_field='vystup';
        break;
      case 'heslo-stav':
        $this->name = 'stav hesla';
        $this->type = 'radio';
        $this->tbl = 'heslo';
        $this->db_field='stav';
        break;
      case 'heslo-lexikograficka_poznamka':
        $this->name = 'lexikografická poznámka';
        $this->type = 'tarea';
        $this->tbl = 'heslo';
        $this->db_field='lexgraf_pozn';
        break;
      case 'heslo-poznamka_odbornik':
        $this->name = 'poznámka pro odborníka';
        $this->type = 'tarea';
        $this->tbl = 'heslo';
        $this->db_field='pozn_odbornik';
        break;
      case 'heslo-extPozn-text':
        $this->name = 'externí poznámka hesla';
        $this->type = 'rtext';
        $this->tbl = 'ext_poznamky_hes';
        $this->db_field='poznamka';
        break;
      case 'heslo-konec_zahlavi':
        $this->name = 'poslední místo záhlaví';
        $this->type = 'cis';
        $this->cis = KONEC_ZAHLAVI;
        $this->cis_vyb_id = 'konec_zahlavi_vyber';
        break;
      case 'varianta-tvar':
        $this->name = 'varianta';
        $this->type = 'txt';
        $this->tbl = 'varianty';
        $this->db_field='varianta';
        break;
      case 'varianta-komentar':
        $this->name = 'komentář k variantě (před)';
        $this->type = 'txt';
        $this->tbl = 'varianty';
        $this->db_field='komentar';
        break;
      case 'varianta-komentarza':
        $this->name = 'komentář k variantě (za)';
        $this->type = 'txt';
        $this->tbl = 'varianty';
        $this->db_field='komentar_za';
        break;
      case 'varianta-homonymie':
        $this->name = 'homonymie pro variantu';
        $this->type = 'txt';
        $this->tbl = 'varianty';
        $this->db_field='homonymie';
        break;
      case 'varianta-komentar_tvaru':
        $this->name = 'Okomentované tvary';
        $this->type = 'rtext';
        $this->tbl  = 'varianty';
        $this->db_field = 'komentar_tvaru';
        break;
      case 'varianta-podhesli-tvar':
        $this->name = 'podheslí varianty';
        $this->type = 'txt';
        $this->tbl = 'varianty';
        $this->db_field='podhesli';
        break;
      case 'varianta-podhesli-komentar':
        $this->name = 'komentář k podheslí varianty';
        $this->type = 'txt';
        $this->tbl = 'varianty';
        $this->db_field='komentar_podhesli';
        break;
      case 'varianta-typ_hesla':
        $this->name = 'typ hesla';
        $this->type = 'cis';
        $this->cis = TYP_HESLA;
        $this->cis_vyb_id = 'typ_hesla';
        break;
      case 'varianta-vyslovnost-tvar':
        $this->name = 'výslovnost varianty';
        $this->type = 'txt';
        $this->tbl = 'vyslovnost_var';
        $this->db_field='vyslovnost';
        break;
      case 'varianta-vyslovnost-komentar':
        $this->name = 'komentář k výslovnosti varianty';
        $this->type = 'txt';
        $this->tbl = 'vyslovnost_var';
        $this->db_field='komentar';
        break;
      case "varianta-slovnyDruh":
        $this->name = 'slovní druh varianty';
        $this->type = 'cis';
        $this->cis = SLOV_DRUHY;
        $this->cis_vyb_id = 'slov_druhy';
        break;
      case 'varianta-slovny_druh-komentar':
        $this->name = 'komentář k slovnímu druhu varianty';
        $this->type = 'txt';
        $this->tbl = 'var_slov_druhy_vyber_rel';
        $this->db_field='komentar';
        break;
      case 'varianta-tvarChar':
        $this->name = 'tvaroslovná charakteristika varianty';
        $this->type = 'cis';
        $this->cis = TVAR_CHAR;
        $this->cis_vyb_id = 'tvar_char';
        break;
      case 'varianta-tvarChar-koncovka-tvar':
        $this->name = 'tvar tvaroslovné charakteristiky varianty';
        $this->type = 'txt';
        $this->tbl = 'koncovky_tvar_char';
        $this->db_field='koncovka';
        break;
      case 'varianta-tvarChar-koncovka-komentar':
        $this->name = 'komentář tvaru tvaroslovné charakteristiky varianty';
        $this->type = 'txt';
        $this->tbl = 'koncovky_tvar_char';
        $this->db_field='komentar';
        break;
      case 'varianta-tvarCharSl':
        $this->name = 'tvaroslovná charakteristika slovesa varianty';
        $this->type = 'cis';
        $this->cis = TVAR_CHAR_SL;
        $this->cis_vyb_id = 'tvar_char_sl';
        break;
      case 'varianta-tvarCharSl-koncovka-tvar':
        $this->name = 'tvar tvaroslovné charakteristiky slovesa varianty';
        $this->type = 'txt';
        $this->tbl = 'koncovky_tvar_char_sl';
        $this->db_field='koncovka';
        break;
      case 'varianta-tvarCharSl-koncovka-komentar':
        $this->name = 'komentář tvaru tvaroslovné charakteristiky slovesa varianty';
        $this->type = 'txt';
        $this->tbl = 'koncovky_tvar_char_sl';
        $this->db_field='komentar';
        break;
      case 'varianta-vazebnost-tvar':
        $this->name = 'valence/vazebnost';
        $this->type = 'tarea_wb';
//        $this->type = 'tarea';
        $this->tbl = 'vazebnost_var';
        $this->db_field='vazebnost';
        break;
      case 'varianta-vazebnost-komentar':
        $this->name = 'komentář k valenci/vazebnosti';
        $this->type = 'txt';
        $this->tbl = 'vazebnost_var';
        $this->db_field='komentar';
        break;
      case 'varianta-styl_kval':
        $this->name = 'stylistický kvalifikátor varianty';
        $this->type = 'cis';
        $this->cis = STYL_KVAL;
        $this->cis_vyb_id = 'styl_kval';
        break;
      case 'varianta-tematicke_okruhy':
        $this->name = 'tematické okruhy varianty';
        $this->type = 'cis';
        $this->cis = TEMATICKE_OKRUHY;
        $this->cis_vyb_id = 'tematicke_okruhy';
        break;
      case 'varianta-puvod':
        $this->name = 'původ varianty';
        $this->type = 'cis';
        $this->cis = PUVOD;
        $this->cis_vyb_id = 'puvod';
        break;
      case 'varianta-obor_uziti':
        $this->name = 'obor/oblast užití na variantě';
        $this->type = 'cis';
        $this->cis = OBOR_UZITI;
        $this->cis_vyb_id = 'obor_uziti';
        break;
      case 'varianta-gram_info':
        $this->name = 'upřesňující gram. inf. varianty';
        $this->type = 'cis';
        $this->cis = GRAM_INFO;
        $this->cis_vyb_id = 'gram_info';
        break;
      case 'varianta-komentar_tvarchar':
        $this->name = 'komentář k tvaroslovné charakteristice varianty';
        $this->type = 'txt';
        $this->tbl = 'varianty';
        $this->db_field='komentar_tvarchar';
        break;
      case 'varianta-komentar_tvarchar_slovesa':
        $this->name = 'komentář k tvaroslovné charakteristice slovesa varianty';
        $this->type = 'txt';
        $this->tbl = 'varianty';
        $this->db_field='komentar_tvarchar_slovesa';
        break;
      case 'varianta-prvni_registr_vyskyt':
        $this->name = 'první registrovaný výskyt varianty';
        $this->type = 'txt';
        $this->tbl = 'varianty';
        $this->db_field='prvni_reg_vyskyt';
        break;
      case 'vyznam-podhesli':
        $this->name = 'podheslí významu';
        $this->type = 'txt';
        $this->tbl = 'vyznamy';
        $this->db_field='podhesli';
        break;
      case 'vyznam-komentar_podhesli':
        $this->name = 'komentář k podheslí významu';
        $this->type = 'txt';
        $this->tbl = 'vyznamy';
        $this->db_field='komentar';
        break;
      case 'vyznam-vazebnost-tvar':
        $this->name = 'valence/vazebnost';
        $this->type = 'tarea_wb';
//        $this->type = 'txt';
        $this->tbl = 'vazebnost_vyz';
        $this->db_field='vazebnost';
        break;
      case 'vyznam-vazebnost-komentar':
        $this->name = 'komentář k valenci/vazebnosti';
        $this->type = 'txt';
        $this->tbl = 'vazebnost_vyz';
        $this->db_field='komentar';
        break;
      case 'vyznam-styl_kval':
        $this->name = 'stylistický kvalifikátor na významu';
        $this->type = 'cis';
        $this->cis = STYL_KVAL;
        $this->cis_vyb_id = 'styl_kval_vyz';
        break;
      case 'vyznam-tematicke_okruhy':
        $this->name = 'tematické okruhy na významu';
        $this->type = 'cis';
        $this->cis = TEMATICKE_OKRUHY;
        $this->cis_vyb_id = 'tematicke_okruhy_vyz';
        break;
      case 'vyznam-obor_uziti':
        $this->name = 'obor/oblast užití na významu';
        $this->type = 'cis';
        $this->cis = OBOR_UZITI;
        $this->cis_vyb_id = 'obor_uziti_vyz';
        break;
      case 'vyznam-gram_info':
        $this->name = 'upřesňující gram. inf. na významu';
        $this->type = 'cis';
        $this->cis = GRAM_INFO;
        $this->cis_vyb_id = 'gram_info_vyz';
        break;
      case 'vyznam-slovnyDruh':
        $this->name = 'slovní druh na významu';
        $this->type = 'cis';
        $this->cis = SLOV_DRUHY;
        $this->cis_vyb_id = 'slov_druhy_vyz';
        break;
      case 'vyznam-slovnyDruh-komentar':
        $this->name = 'komentář k slovnímu druhu na významu';
        $this->type = 'txt';
        $this->tbl = 'vyz_slov_druhy_vyber_rel';
        $this->db_field='komentar';
        break;
      case 'vyznam-tvarChar':
        $this->name = 'tvaroslovná charakteristika na významu';
        $this->type = 'cis';
        $this->cis = TVAR_CHAR;
        $this->cis_vyb_id = 'tvar_char_vyz';
        break;
      case 'vyznam-tvarChar-koncovka-tvar':
        $this->name = 'tvar tvarosl. char.';
        $this->type = 'txt';
        $this->tbl = 'koncovky_tvar_char_vyz';
        $this->db_field='koncovka';
        break;
      case 'vyznam-tvarChar-koncovka-komentar':
        $this->name = 'komentář ke tvaru koncovky tvar. char. na významu';
        $this->type = 'txt';
        $this->tbl = 'koncovky_tvar_char_vyz';
        $this->db_field='komentar';
        break;
      case 'vyznam-tvarCharSl':
        $this->name = 'tvaroslovná charakteristika slovesa na významu';
        $this->type = 'cis';
        $this->cis = TVAR_CHAR_SL;
        $this->cis_vyb_id = 'tvar_char_sl_vyz';
        break;
      case 'vyznam-tvarCharSl-koncovka-tvar':
        $this->name = 'tvar tvarosl. char. slovesa';
        $this->type = 'txt';
        $this->tbl = 'koncovky_tvar_char_sl_vyz';
        $this->db_field='koncovka';
        break;
      case 'vyznam-tvarCharSl-koncovka-komentar':
        $this->name = 'komentář ke tvaru koncovky tvar. char. slovesa na významu';
        $this->type = 'txt';
        $this->tbl = 'koncovky_tvar_char_sl_vyz';
        $this->db_field='komentar';
        break;
      case 'vyznam-komentar_tvarchar':
        $this->name = 'komentář tvaroslovné charakteristiky na významu';
        $this->type = 'txt';
        $this->tbl = 'vyznamy';
        $this->db_field='komentar_tvarchar';
        break;
      case 'vyznam-komentar_tvarchar_slovesa':
        $this->name = 'komentář tvaroslovné charakteristiky slovesa na významu';
        $this->type = 'txt';
        $this->tbl = 'vyznamy';
        $this->db_field='komentar_tvarchar_slovesa';
        break;
      /*case 'vyznam-predvyklad':
        $this->name = 'předvýklad významu';
        $this->type = 'tarea';
        $this->tbl = 'vyznamy';
        $this->db_field='predvyklad';
        break;
      case 'vyznam-predvyklad_master':
        $this->name = 'převzatý předvýklad významu';
        $this->type = 'tarea';
        $this->tbl = 'vyznamy_master';
        $this->db_field='predvyklad';
        break; */
      case 'vyznam-zacatek_predvykladu':
        $this->name = 'začátek předvýkladu významu';
        $this->type = 'txt';
        $this->tbl = 'vyznamy';
        $this->db_field='zacatek_predvykladu';
        break;
      case 'vyznam-zacatek_predvykladu_master':
        $this->name = 'převzatý začátek předvýkladu významu';
        $this->type = 'txt';
        $this->tbl = 'vyznamy_master';
        $this->db_field='zacatek_predvykladu';
        break;
      case 'vyznam-vyraz_predvykladu':
        $this->name = 'výraz předvýkladu významu';
        $this->type = 'txt';
        $this->tbl = 'vyrazy_predvykladu';
        $this->db_field='vyraz';
        break;
      case 'vyznam-vyraz_predvykladu_master':
        $this->name = 'převzatý výraz předvýkladu významu';
        $this->type = 'txt';
        $this->tbl = 'vyrazy_predvykladu_m';
        $this->db_field='vyraz';
        break;
      case 'vyznam-komentar_predvykladu':
        $this->name = 'komentář výrazu předvýkladu významu';
        $this->type = 'txt';
        $this->tbl = 'vyrazy_predvykladu';
        $this->db_field='komentar';
        break;
      case 'vyznam-komentar_predvykladu_master':
        $this->name = 'převzatý komentář výrazu předvýkladu významu';
        $this->type = 'txt';
        $this->tbl = 'vyrazy_predvykladu_m';
        $this->db_field='komentar';
        break;
      case 'vyznam-konec_predvykladu':
        $this->name = 'konec předvýkladu významu';
        $this->type = 'txt';
        $this->tbl = 'vyznamy';
        $this->db_field='konec_predvykladu';
        break;
      case 'vyznam-konec_predvykladu_master':
        $this->name = 'převzatý konec předvýkladu významu';
        $this->type = 'txt';
        $this->tbl = 'vyznamy_master';
        $this->db_field='konec_predvykladu';
        break;
      case 'vyznam-metavyklad1':
        $this->name = 'metavýklad 1';
        $this->type = 'cis';
        $this->cis = METAVYKLAD1;
        $this->cis_vyb_id = 'metavyklad1_vyz';
        break;
      case 'vyznam-metavyklad1_master':
        $this->name = 'převzatý metavýklad 1';
        $this->type = 'cis';
        $this->cis = METAVYKLAD1_M;
        $this->cis_vyb_id = 'metavyklad1_vyz_master';
        break;
      case 'vyznam-vyklad_vyznamu':
        $this->name = 'výklad významu';
        $this->type = 'rtext';
        $this->tbl = 'vyznamy';
        $this->db_field='vyklad_vyznamu';
        break;
      case 'vyznam-vyklad_vyznamu_master':
        $this->name = 'převzatý výklad významu';
        $this->type = 'rtext';
        $this->tbl = 'vyznamy_master';
        $this->db_field='vyklad_vyznamu';
        break;
      case 'vyznam-metavyklad2':
        $this->name = 'metavýklad 2';
        $this->type = 'tarea';
        $this->tbl = 'vyznamy';
        $this->db_field='metavyklad2';
        break;
      case 'vyznam-metavyklad2_master':
        $this->name = 'převzatý metavýklad 2';
        $this->type = 'tarea';
        $this->tbl = 'vyznamy_master';
        $this->db_field='metavyklad2';
        break;
      case 'vyznam-exemplifikacia-text':
        $this->name = 'exemplifikace';
        $this->type = 'rtext';
        $this->tbl = 'exemplifikace';
        $this->db_field='exemplifikace';
        break;
      case 'vyznam-extPozn-text':
        $this->name = 'externí poznámka významu';
        $this->type = 'rtext';
        $this->tbl = 'ext_poznamky_vyz';
        $this->db_field='poznamka';
        break;
      case 'synonymum':
        $this->name = 'synonymum';
        $this->type = 'antsyn';
        $this->tbl = 'hesla_rel';
        $this->db_field='slave_str';
        break;
      case 'antonymum':
        $this->name = 'antonymum';
        $this->type = 'antsyn';
        $this->tbl = 'hesla_rel';
        $this->db_field='slave_str';
      break;
      case 'nest':
        $this->name = 'připojování/přihnízdování';
        $this->type = 'nest';
        $this->tbl = 'hesla_rel';
        $this->db_field='slave_str';
      break;
      case 'vyznam-link':
        $this->name = 'propojení významů';
        $this->type = 'vyznam-link';
        $this->tbl = 'propojeni_vyznamu';
        $this->db_field='vyz_to';
      break;
      case 'link':
        $this->name = 'typ odkazu';
        $this->type = 'link';
        $this->tbl = 'hesla_rel';
        $this->db_field='slave_str';
      break;
      case 'odkaz-typ':
        $this->name = 'typ linkování';
        $this->type = 'cis';
        $this->cis = TYP_LINKOVANI;
        $this->cis_vyb_id = typ_linkovani;
        //$this->tbl = 'hesla_rel_link_type_vyber';
        //$this->db_field='cis_id';
        break;
      case 'podhesli-vyslovnost-tvar':
        $this->name = 'výslovnost podheslí';
        $this->type = 'txt';
        $this->tbl = 'podh_vyz_vyslovnost';
        $this->db_field='vyslovnost';
        break;
      case 'podhesli-vyslovnost-komentar':
        $this->name = 'komentář k výslovnosti podheslí';
        $this->type = 'txt';
        $this->tbl = 'podh_vyz_vyslovnost';
        $this->db_field='komentar';
        break;
      case 'podhesli-slovnyDruh':
        $this->name = 'slovní druh podheslí';
        $this->type = 'cis';
        $this->cis = SLOV_DRUHY;
        $this->cis_vyb_id = 'slov_druhy_podh';
        break;
      case 'podhesli-slovnyDruh-komentar':
        $this->name = 'komentář k slovnímu druhu podheslí';
        $this->type = 'txt';
        $this->tbl = 'podh_vyz_slov_druhy_vyber_rel';
        $this->db_field='komentar';
        break;
      case 'podhesli-gram_info':
        $this->name = 'upřesňující gram. inf. podheslí';
        $this->type = 'cis';
        $this->cis = GRAM_INFO;
        $this->cis_vyb_id = 'gram_info_podh';
        break;
      case 'podhesli-tvarChar':
        $this->name = 'tvaroslovná charakteristika podheslí';
        $this->type = 'cis';
        $this->cis = TVAR_CHAR;
        $this->cis_vyb_id = 'tvar_char_podh';
        break;
      case 'podhesli-tvarChar-koncovka-tvar':
        $this->name = 'tvar tvaroslovné charakteristiky podheslí';
        $this->type = 'txt';
        $this->tbl = 'podh_vyz_koncovky_tvar_char';
        $this->db_field='koncovka';
        break;
      case 'podhesli-tvarChar-koncovka-komentar':
        $this->name = 'komentář ke tvaru tvar. char. podheslí';
        $this->type = 'txt';
        $this->tbl = 'podh_vyz_koncovky_tvar_char';
        $this->db_field='komentar';
        break;
     case 'podhesli-tvarCharSl':
        $this->name = 'tvaroslovná charakteristika slovesa podheslí';
        $this->type = 'cis';
        $this->cis = TVAR_CHAR_SL;
        $this->cis_vyb_id = 'tvar_char_sl_podh';
        break;
      case 'podhesli-tvarCharSl-koncovka-tvar':
        $this->name = 'tvar tvaroslovné charakteristiky slovesa podheslí';
        $this->type = 'txt';
        $this->tbl = 'podh_vyz_koncovky_tvar_char_sl';
        $this->db_field='koncovka';
        break;
      case 'podhesli-tvarCharSl-koncovka-komentar':
        $this->name = 'komentář ke tvaru tvar. char. slovesa podheslí';
        $this->type = 'txt';
        $this->tbl = 'podh_vyz_koncovky_tvar_char_sl';
        $this->db_field='komentar';
        break;
      case 'podhesli-komentar_tvarchar':
        $this->name = 'komentář tvaroslovné charakteristiky podheslí';
        $this->type = 'txt';
        $this->tbl = 'podhesli_vyznamu';
        $this->db_field='komentar_tvarchar';
        break;
      case 'podhesli-komentar_tvarchar_slovesa':
        $this->name = 'komentář tvaroslovné charakteristiky slovesa podheslí';
        $this->type = 'txt';
        $this->tbl = 'podhesli_vyznamu';
        $this->db_field='komentar_tvarchar_slovesa';
        break;
      case 'podhesli-podhesli':
        $this->name = 'podheslí významu';
        $this->type = 'txt';
        $this->tbl = 'podhesli_vyznamu';
        $this->db_field='podhesli';
        break;
      case 'podhesli-komentar_podhesli':
        $this->name = 'komentář k podheslí významu (před)';
        $this->type = 'txt';
        $this->tbl = 'podhesli_vyznamu';
        $this->db_field='komentar_pred';
        break;
      case 'podhesli-komentar-za_podhesli':
        $this->name = 'komentář k podheslí významu (za)';
        $this->type = 'txt';
        $this->tbl = 'podhesli_vyznamu';
        $this->db_field='komentar_za';
        break;
      case 'podhesli-vazebnost-tvar':
        $this->name = 'valence/vazebnost';
        $this->type = 'tarea_wb';
        $this->tbl = 'podhesli_vazebnost';
        $this->db_field='vazebnost';
        break;
      case 'podhesli-vazebnost-komentar':
        $this->name = 'komentář k valenci/vazebnosti';
        $this->type = 'txt';
        $this->tbl = 'podhesli_vazebnost';
        $this->db_field='komentar';
        break;
      case 'podhesli-obor_uziti':
        $this->name = 'obor/oblast užití podheslí';
        $this->type = 'cis';
        $this->cis = OBOR_UZITI;
        $this->cis_vyb_id = 'obor_uziti_podh';
        break;
     case 'podhesli-styl_kval':
        $this->name = 'stylistický kvalifikátor podheslí';
        $this->type = 'cis';
        $this->cis = STYL_KVAL;
        $this->cis_vyb_id = 'styl_kval_podh';
        break;
     case 'podhesli-tematicke_okruhy':
        $this->name = 'tematické okruhy podheslí';
        $this->type = 'cis';
        $this->cis = TEMATICKE_OKRUHY;
        $this->cis_vyb_id = 'tematicke_okruhy_podh';
        break;
    }
  }//f:_setup

  public function save_correcture($pid, $hid, $field_DOMid, $val_orig, $val_new, $note){
    $korektura = array();
    if(text_db_preprocess($pid)>0)
    {
      $korektura['pid'] = text_db_preprocess($pid);
    }
    $korektura['hid'] = text_db_preprocess($hid);
    $korektura['field_DOMid'] = "'".text_db_preprocess($field_DOMid)."'";
    $korektura['field'] = "'".text_db_preprocess($this->field)."'";
    $korektura['field_val_id'] = text_db_preprocess($this->val_id);
    $korektura['val_orig'] = "'".text_db_preprocess($val_orig)."'";
    $korektura['val_new'] = "'".text_db_preprocess($val_new)."'";
    $korektura['corrector'] = get_logged_user();
    $korektura['note'] = "'".text_db_preprocess($note)."'";
    /*  stary pristup k cilenym korekturam
    $uid = get_logged_user();
    $role = get_role();
    //odbornik ma prirazeny seznam redaktoru
    if($role == ODBORNIK){
      $sid = get_list_for_ext_user($uid);
      if(is_numeric($sid) && ($sid > 0)){
        $korektura['sid'] = text_db_preprocess($sid);
      }
    } */
    Redakce::clearCache(0, $hid);
    return sql_w('korektura', $korektura);
  }

  public function set_status($status, $kor_id, $note){
    $d = array();
    $d['status'] = $status;
    if($note!="") $d['note'] = "'".text_db_preprocess($note)."'";
    $d['kor_id'] = $kor_id;
    $d['uid'] = get_logged_user();
    Redakce::clearCache($kor_id);
    return sql_w('korektura_stavy', $d);
  }

  private function apply_link_change($rel_id, $rel_data,$spojeno)
  {
     $d = array();
        $d[slave_str] = "'".text_db_preprocess($rel_data[slave_str])."'";
        if($rel_data[slave_hid]>0)
          $d[slave_hid] = "'".$rel_data[slave_hid]."'";
        $d[rel_type] = "'".$rel_data[rel_type]."'";
        $d[poznamka] = "'".text_db_preprocess($rel_data[note])."'";
        if($spojeno!=NULL)
        {
          $d[spojeno] = "'".$spojeno."'";
        }
        else
        {
          $d[spojeno] = "NULL";
        }
        $link = array();
        if($rel_data[link_type]>0)
        {
          $link[cis_id] = "'".$rel_data[link_type]."'";
        }
        else
        {
          $link[cis_id] = "NULL";
        }
        $link[jine] = "'".text_db_preprocess($rel_data[slave_jine_str])."'";

        sql_w('hesla_rel', $d, $rel_id);
        sql_w_where('hesla_rel_link_type_vyber', $link, $rel_id, 'hesla_rel_id');

        //vymaz stara mista
        $q1 = "DELETE FROM hesla_rel_places WHERE hesla_rel_id='$rel_id'";
        dbq($q1);
        $q2 = "DELETE FROM hesla_rel_slave_places WHERE hesla_rel_id='$rel_id'";
        dbq($q2);
        //uloz nova main mista
        if(count($rel_data[hidRel_place])>0)
        {
          foreach($rel_data[hidRel_place] as $main_place)
          {
            unset($db_place);
            $db_place = array();
            $place = explode("-", $main_place);
            if($place[0]=="heslo")
            {
              $place[1] = $rel_data[main_hid];
            }
            $db_place[place] = "'".$place[0]."'";
            $db_place[place_id] = "'".$place[1]."'";
            $db_place[hesla_rel_id] = "'".$rel_id."'";
            sql_w('hesla_rel_places', $db_place);
          }
          if(count($rel_data[hidRel_slave_place])>0)
          {
            //uloz nova slave mista
            foreach($rel_data[hidRel_slave_place] as $slave_place)
            {
              unset($db_place);
              $db_place = array();
              $place = explode("-", $slave_place);
              if($place[0]=="heslo")
              {
                $place[1] = $rel_data[slave_hid];
              }
              $db_place[place] = "'".$place[0]."'";
              $db_place[place_id] = "'".$place[1]."'";
              $db_place[hesla_rel_id] = "'".$rel_id."'";
              sql_w('hesla_rel_slave_places', $db_place);
            }
          }
          else
          {
            smaz_hidRel($rel_id);
          }
        }
        else
        {
          smaz_hidRel($rel_id);
        }
  }

  private function parse_place($place, $place_id)
  {
    $d = array();
    if($place=='heslo'){
      $d[place] = "'".heslo."'";
      $d[place_id] = "'".$place_id."'";
    }
    else{
      $place_info = explode('-', $place);
      $d[place] = "'".$place_info[0]."'";
      $d[place_id] = "'".$place_info[1]."'";
    }
    return $d;
  }

  public function apply_correction($kor_id, $data){
    $return = array('type' => $this->type);
    if($this->type=='cis'){
     $parsout_only_ids = true;
     $new_cis_vals = $this->parse_cis_correction($kor_id, $parsout_only_ids);
     uloz_vyber_cis($this->cis_vyb_id, $new_cis_vals, $this->val_id);
     $return['cis_vyb'] = $this->cis_vyb_id;
     $return['vals'] = $new_cis_vals;
     $return['val_id'] = $this->val_id;
    }else{
     if($this->type == 'antsyn'){
      $rel_data = $data[hidRel][$this->val_id];
      if(empty($rel_data[slave_str])){
        $d1 = array();
        $d1['place'] = "'heslo'";
        $d1['place_id'] = 0;
        sql_w_where('hesla_rel_slave_places', $d1, $this->val_id, 'hesla_rel_id');
        $d2 = array();
        $d2['slave_str'] = "''";
        $d2['slave_hid'] = "NULL";
        $d2['komentar'] = "''";
        sql_w('hesla_rel', $d2, $this->val_id);
        $return['rel_id'] = $this->val_id;

        /*$rel_id = $this->val_id;
        $sql1 = "DELETE FROM `hesla_rel_slave_places` WHERE `hesla_rel_id` = $rel_id";
        dbq($sql1);
        $sql2 = "DELETE FROM `hesla_rel` WHERE `id` = $rel_id";
        dbq($sql2);                                                        */
      } else{
        $d = $this->parse_place($rel_data[hidRel_slave_place][0], $rel_data[slave_hid]);
        sql_w_where('hesla_rel_slave_places', $d, $this->val_id, 'hesla_rel_id');
        $d = array();
        $d['slave_str'] = "'".text_db_preprocess($rel_data['slave_str'])."'";
        if($rel_data['slave_hid']>0){
          $d['slave_hid'] = "'".$rel_data['slave_hid']."'";
        }
        $d['komentar'] = "'".text_db_preprocess($rel_data['slave_kom'])."'";
        $d['rel_type'] = "'".$rel_data['rel_type']."'";
        sql_w('hesla_rel', $d, $this->val_id);
        $return['rel_id'] = $this->val_id;
      }
    }
    else if($this->type == 'nest')
    {
        $rel_data = $data[hidRel][$this->val_id];
        if(empty($rel_data['slave_str'])){
            dbq("DELETE FROM `hesla_rel_places` WHERE `hesla_rel_id` = ". $this->val_id);
        } else{
            $d = $this->parse_place($rel_data[hidRel_place][0], $rel_data[main_hid]);
            sql_w_where('hesla_rel_places', $d, $this->val_id, 'hesla_rel_id');
            unset($d);
        }
        $d = array();
        $d[slave_str] = "'".text_db_preprocess($rel_data[slave_str])."'";
        if($rel_data[slave_hid]>0)$d[slave_hid] = "'".$rel_data[slave_hid]."'";
        $d[rel_type]  = "'".$rel_data[rel_type]."'";
        sql_w('hesla_rel', $d, $this->val_id);
    }
    else if($this->type == 'vyznam-link')
    {
        $slave_str = $data['vyznam-link-slave'];
        $link_text = $data['vyznam-link-text'];
        $vyz_to = $data['vyznam-link-vyz_to'];

        $d = array();
        $d['vyz_to'] = "'".$vyz_to."'";
        $vyz_from = $data['vyznam-link-vyz_from'];
        if($data['vyznam-link-master']=='1'){
          $v = get_db_values("vyznamy_master", array("vyklad_vyznamu"), $vyz_from);
        } else{
          $v = get_db_values("vyznamy", array("vyklad_vyznamu"), $vyz_from);
        }
        $vyznam_casti = split_vyznam($v["vyklad_vyznamu"], $this->val_id);
        if($vyz_to!=0){
            $vyznam_casti[1] = '<span id="link-'.$this->val_id.'" class="vyznam_link_text" title="Připojeno k: '.$slave_str.'">'.$link_text.'</span>';
        } else{
            $vyznam_casti[1] = $link_text;
        }
        $novy_vyznam = implode("", $vyznam_casti);
        $novy_vyznam_bz = strip_tags(my_trim(text_db_preprocess($novy_vyznam)));

        if($vyz_to){
            $db1 = array();
            $db1['vyz_to'] = "'".$vyz_to."'";
            sql_w("propojeni_vyznamu", $db1, $this->val_id);
        } else{
            dbq("DELETE FROM `propojeni_vyznamu` WHERE `id` = ".$this->val_id.";");
        }
        $db2 = array();
        $db2['vyklad_vyznamu'] = "'".$novy_vyznam."'";
        $db2['vyklad_vyznamu_bz'] = "'".$novy_vyznam_bz." '";
        if($data['vyznam-link-master']=='0'){
          sql_w("vyznamy", $db2, $vyz_from);
        } else{
          sql_w("vyznamy_master", $db2, $vyz_from);
        }
    }
    else if($this->type == 'link')
    {
        //$rel_data2
        $rel_data = $data[hidRel][$this->val_id];
        $spojeno = get_db_values('hesla_rel', array('spojeno'), $this->val_id);
        if(empty($rel_data['slave_str'])){
            smaz_hidRel($this->val_id, true);
            if($spojeno[0]>0){
                if($rel_data[link_type]==2 || $rel_data[link_type]==3){
                    smaz_hidRel($spojeno[0]); //smazani druhe strany dok./nedok.
                }
            }
        } else if($spojeno[0]>0)
        {
          if($rel_data[link_type]==2)
          {
            $rel_data_2=get_db_values('hesla_rel', array('slave_hid', 'slave_str', 'main_hid' , 'rel_type'), $spojeno[0]);

            $rel_data_2[hidRel_place]=$rel_data[hidRel_slave_place];
            $rel_data_2[hidRel_slave_place]=$rel_data[hidRel_place];
            $rel_data_2[link_type]=3;
            $this->apply_link_change($spojeno[0],$rel_data_2,$this->val_id);
          }
          else if($rel_data[link_type]==3)
          {
            $rel_data_2=get_db_values('hesla_rel', array('slave_hid', 'slave_str', 'main_hid', 'rel_type'), $spojeno[0]);

            $rel_data_2[hidRel_place]=$rel_data[hidRel_slave_place];
            $rel_data_2[hidRel_slave_place]=$rel_data[hidRel_place];
            $rel_data_2[link_type]=2;
            $this->apply_link_change($spojeno[0],$rel_data_2,$this->val_id);
          }
          else
          {
            smaz_hidRel($spojeno[0]);
            $spojeno=0;
          }
          $this->apply_link_change($this->val_id,$rel_data,$spojeno[0]);
        }
        else
        {
          $this->apply_link_change($this->val_id,$rel_data,NULL);
        }
     }
     else
     { //txt
        $d = array();
        $outval = get_db_values('korektura', 'val_new', $kor_id);
        $val = text_db_preprocess($outval);
        $d[$this->db_field] = "'".$val."'";
        if($this->field=="vyznam-exemplifikacia-text"){
          $d['exemplifikace_bz'] = "'".strip_tags(my_trim(text_db_preprocess($val)))." '";
        }
        if($this->field=="vyznam-vyklad_vyznamu"){
          $d['vyklad_vyznamu_bz'] = "'".strip_tags(my_trim(text_db_preprocess($val)))." '";
        }
        if($this->field=="vyznam-vyklad_vyznamu_master"){
          $d['vyklad_vyznamu_bz'] = "'".strip_tags(my_trim(text_db_preprocess($val)))." '";
        }
        if($this->field=="varianta-komentar_tvaru"){
          $d['komentar_tvaru_bz'] = "'".strip_tags(my_trim(text_db_preprocess($val)))." '";
        }
        $return['field'] = $this->field;
        $return['id'] = $this->val_id;
        $return['val'] = $outval;
        sql_w($this->tbl, $d, $this->val_id);

     }
    }
    return $return;
  }

  public static function get_last_correcture_id(){
    $sql = "SELECT MAX(id) as maxid FROM korektura";
    $res = dbq($sql);
    return mysql_result($res, 0, "maxid");
  }

  public function get_field_opts($field){
    switch($field){
      case 'heslo-do_vystupu':
        global $_VYSTUP;
        $_opts = $_VYSTUP;
        break;
      case 'heslo-stav':
        global $_STAV_HESLA;
        $_opts = $_STAV_HESLA;
        break;
    }
    return $_opts;
  }

  private function print_radio_form($DOMid, $value){
    $html="";
    $_opts = $this->get_field_opts($this->field);
    foreach($_opts as $id => $label){
      $checked=""; if($id == $value) $checked = "checked=checked";
      if($this->field=="heslo-do_vystupu" && ($id == WEB || $id == WORD)){
      	continue;
      }
      $html.="<br/><input type='radio' name='val_new' value='$id' class='' $checked/> <label class='thinLabel'>$label</label>";
    }
    return $html;
  }


  private function print_syn_form(){
    $multiContainerDOMid = "$this->field-12345";
    $hidRel_id = $this->val_id;
    $main_hid = $this->hid;
    return "\r\n<br />".print_hid_rel_ant_syn_slave($multiContainerDOMid, $main_hid, $hidRel_id, $this->field, 0, true);
  }

  private function print_nest_form(){
    $field = explode("^", $this->raw_orig_val);
    $multiContainerDOMid = "$this->field-54321";
    $hidRel_id = $this->val_id;
    $main_hid = $field[3];
    $place = $fields[4];
    $place_id = $fields[5];
    return "\r\n<br />".print_hid_rel_pripojeni_slave($multiContainerDOMid, $main_hid, $place, $place_id, $hidRel_id, false, true)."<div style='clear:both'></div>";
  }

  private function print_link_form(){
    $fields = explode("^", $this->raw_orig_val);
    $multiContainerDOMid = "link-123456";
    $hidRel_id = $this->val_id;
    return "\r\n<br />".print_hid_rel_odkazy_slave($multiContainerDOMid, $this->hid, $hidRel_id, false, true);
  }


    private function print_vyznam_link_form(){
        $post = array();
        $rel_data = get_db_values("propojeni_vyznamu", array("vyz_to", "vyz_from", "vyz_m_from"), $this->val_id);
        $post["relid"] = $this->val_id;
        if($rel_data[vyz_from]){
          $post["vyznam"] = $rel_data["vyz_from"];
          $v = get_db_values("vyznamy", array("vyklad_vyznamu"), $rel_data['vyz_from']);
          $post["master"] = 0;
        } else{
          $post["vyznam"] = $rel_data["vyz_m_from"];
          $v = get_db_values("vyznamy_master", array("vyklad_vyznamu"), $rel_data['vyz_m_from']);
          $post["master"] = 1;
        }
        $vyznam_casti = split_vyznam($v["vyklad_vyznamu"], $this->val_id);
        $post["text"] =  $vyznam_casti[1];
        $post["trg"] = $rel_data["vyz_to"];
        $post["redakce"] = true;
        return print_vyznam_link_form($post);
        //return print_vyznam_link_form($this->val_id, $this->hid);
    }

   private function get_field_name(){

    $name = $this->name;
    if($this->field == "varianta-tvar"){
      if(is_sublemma($this->val_id)){
        $name = "podheslí";
      }
    } else if(substr($this->field, 0, 3) == 'var'){
      $DOMid = isset($_POST['DOMid']) ? $_POST['DOMid'] : $_POST['form_id'];
      preg_match('/\d+/', $DOMid, $matches);
      if(is_numeric($matches[0]) && is_sublemma($matches[0])){
        $name = str_replace(array("varianty", "variantě"), array("podheslí", "podheslí"), $this->name);
      }
    }

    /*if($this->field == "varianta-tvar"){
      $D = db_fetchSingle("SELECT `f_varianta` FROM `varianty` WHERE `id` = ".$this->val_id);
      if($D=='0'){
        $res = "podheslí";
      }
    } */
    return $name;
  }


  private function print_syn_form_corrected($value){
    $multiContainerDOMid = "$this->field-12345";
    $hidRel_id = $this->val_id;
    $main_hid = $this->hid;
    return "\r\n<br />".print_hid_rel_ant_syn_slave_corrected(
    $multiContainerDOMid, $main_hid, $hidRel_id, $this->field, $this->val_new, $value);
  }

  private function print_nest_form_corrected($value){
    $multiContainerDOMid = "$this->field-54321";
    $hidRel_id = $this->val_id;
    return "\r\n<br />".print_hid_rel_pripojeni_slave_corrected($multiContainerDOMid, $hidRel_id, $value);
  }

  private function print_link_form_corrected($value){
    $multiContainerDOMid = "link-123456";
    $hidRel_id = $this->val_id;
    $main_hid = $this->hid;
    return "\r\n<br />".print_hid_rel_odkazy_slave_corrected($multiContainerDOMid, $main_hid, $hidRel_id, $value);
  }

  private function print_vyznam_link_form_corrected($value){
      return "\r\n<br />".print_vyznam_link_form_corrected($this->val_id, $value, $this->hid);
  }

  private function print_txt_form($DOMid, $value){
    $new_val_field_name = 'val_new';
    $test_cls = "";
    if($this->field == "varianta-tvar"){
        $q = dibi::query("SELECT [sortorder] FROM [varianty] WHERE [id] = %i", $this->val_id);
        $sortorder = $q->fetchSingle();
        if($sortorder == 1){
           $test_cls = "class='empty_test'";
        }
    }

    $html="";
    switch($this->type){
      case 'txt':
       $html.="<input type='text' $test_cls name='$new_val_field_name' value='$value' />";
       break;
      case 'tarea':
      case 'tarea_wb':
       if($this->type==='tarea_wb'){
         $html.="<br />
        <div class='butt blueBG symbolButt' onclick='insert_symbol(\"|\", \"$DOMid-area\")'><center>|</center></div>
                 <div class='butt blueBG symbolButt' onclick='insert_symbol(\"~\", \"$DOMid-area\")'><center>~</center></div>
                 <div class='butt blueBG symbolButt' onclick='insert_symbol(\"{}\", \"$DOMid-area\")'><center>{}</center></div>
                 <div class='butt blueBG symbolButt' onclick='insert_symbol(\"„“\", \"$DOMid-area\")'><center>„“</center></div>";
       }
       $html.="<br /><textarea name='$new_val_field_name' id='$DOMid-area'>$value</textarea>";
       break;
      case 'rtext':
       $html.="<br /><textarea name='$new_val_field_name' class='mceEditor' id='$DOMid' style='position: relative;'>$value</textarea>";
       $html.="";
       break;
    }
    return $html;
  }

  private function print_cis_form_TPL($HTMLdata){
     return "
      <div class='form_vyber_z_ciselniku'>
        <table>
          <tr>
           <td rowspan='2'>".$HTMLdata['sb_ciselnik']."</td>
           <td style='vertical-align: bottom'>".$HTMLdata['arr_toVyber']."</td>
           <td rowspan='2'>".$HTMLdata['sb_cisVyber']."</td>
           <td>".$HTMLdata['arr_up']."</td>
          </tr>
          <tr>
           <td>".$HTMLdata['arr_toCis']."</td>
           <td style='vertical-align: bottom'>".$HTMLdata['arr_down']."</td>
          </tr>
          <tr>
           <td>&nbsp;</td>
           <td>Jiné:</td>
           <td>".$HTMLdata['field_extraOpt']."</td>
           <td>&nbsp;</td>
          </tr>
        </table>
      </div>
     ";
  }

  private function print_cis_form($DOMid, $vyber){
    $cisAll = get_hodnoty_ciselniku($this->cis);
    if($vyber == "--neoborové--"){
        $vyber = array();
    }
    $tpl_data = array();
    $vyber_jine = "";
    if(array_key_exists('jine',$vyber)) {
      $vyber_jine = $vyber['jine'];
      $vyber['jine'] = 'jiné';
    }

    $form_name = 'val_new';
    $id_ciselnik = $DOMid."--cis";
    $name_ciselnik = "";
    $id_cisVyber = $DOMid."--cisVyber";
    $name_cisVyber = $form_name."[]";

    $tpl_data['sb_ciselnik'] = "";
    $tpl_data['sb_ciselnik'].="<select multiple='multiple' class='sbCiselnik' id='$id_ciselnik' name='$name_ciselnik'>";
    foreach(array_diff($cisAll,$vyber) as $id => $val)
      $tpl_data['sb_ciselnik'].="<option value='$id'>".text_html_preprocess($val)."</option>";
    $tpl_data['sb_ciselnik'].="</select>";

    $tpl_data['sb_cisVyber'] = "";
    $tpl_data['sb_cisVyber'].="<select multiple='multiple' class='sbCisVyber' id='$id_cisVyber' name='$name_cisVyber'>";
    foreach($vyber as $id => $val)
      $tpl_data['sb_cisVyber'].="<option value='$id' selected='selected'>".text_html_preprocess($val)."</option>";
    $tpl_data['sb_cisVyber'].="</select>";

    $tpl_data['arr_toVyber'] = "
     <input id='B1'
            type='button'
            name='right'
            value='&gt;&gt;'
            onClick='Selectbox.moveSelectedOptions(document.getElementById(\"$id_ciselnik\"), document.getElementById(\"$id_cisVyber\"), false)'
     >";
    $tpl_data['arr_toCis'] = "
     <input type='button'
            name='right'
            value='&lt;&lt;'
            onClick='Selectbox.moveSelectedOptions(document.getElementById(\"$id_cisVyber\"), document.getElementById(\"$id_ciselnik\"), false)'
     >";
    $tpl_data['arr_up'] = "<input type='button' class='sortUp_butt' value='&nbsp;Up&nbsp;' onClick='Selectbox.moveOptionUp(document.getElementById(\"$id_cisVyber\"))'>";
    $tpl_data['arr_down'] = "<input type='button' class='sortDown_butt' value='&nbsp;Down&nbsp;' onClick='Selectbox.moveOptionDown(document.getElementById(\"$id_cisVyber\"))'>";
    if($cis != ZPRACOVATELE)
     $tpl_data['field_extraOpt'] ="<input type='text' id='$form_id--jine' name='".$form_name."[jine]' value='".text_html_preprocess($vyber_jine)."' maxlength='45' style='width:190px'/>";

    return $this->print_cis_form_TPL($tpl_data);
  }

  private function print_val_form_field($DOMid, $kor_id=0){
    switch($this->type){
      case 'rtext':
      case 'tarea':
      case 'tarea_wb':
      case 'txt':
       if($kor_id>0){
        $value = get_db_values('korektura', 'val_new', $kor_id);
       }else{
        $value = $this->get_orig_val();
       }
       return $this->print_txt_form($DOMid, $value);
       break;
      case 'antsyn':
        if($kor_id > 0){
          $value = get_db_values('korektura', 'val_new', $kor_id);
          return $this->print_syn_form_corrected($value);
        } else {
          return $this->print_syn_form();
        }

        break;
      case 'nest':
        if($kor_id > 0){
          $value = get_db_values('korektura', 'val_new', $kor_id);
          return $this->print_nest_form_corrected($value);
        } else
        {
          return $this->print_nest_form();
        }
        break;
      case 'vyznam-link':
          if($kor_id > 0){
              $value = get_db_values('korektura', 'val_new', $kor_id);
              return $this->print_vyznam_link_form_corrected($value);
          } else{
              return $this->print_vyznam_link_form();
          }
      break;
      case 'link':
        if($kor_id > 0){
          $value = get_db_values('korektura', 'val_new', $kor_id);
          return $this->print_link_form_corrected($value);
        } else
        {
          return $this->print_link_form();
        }
      break;
      case 'radio':
       if($kor_id>0){
        $value = get_db_values('korektura', 'val_new', $kor_id);
       }else{
        $value = $this->get_orig_val();
       }
       return $this->print_radio_form($DOMid, $value);
       break;
      case 'cis':
       if($kor_id>0){
        $vyber = $this->parse_cis_correction($kor_id);
       }else{
        $vyber = $this->get_orig_val();
       }
       $r = $this->print_cis_form($DOMid, $vyber);
       return $r;
       break;
    }
  }

  public function print_new_correction_form($hid, $DOMid){
    $cislo_korektury = self::get_last_correcture_id(); // nasledujuce ID korektury
    if(empty($cislo_korektury)) $cislo_korektury = 0;
    $cislo_korektury++;
    $val_orig = implode(", ", (array)$this->get_orig_val());
    if($this->type != 'rtext' && $this->type != 'radio'){
     $val_orig = text_html_preprocess($val_orig);
     $val_orig = nl2br($val_orig);
    }

    if($this->type=='radio'){
      $_opts = $this->get_field_opts($this->field);
      $val_orig = $_opts[$val_orig];
    }

    if($this->type == 'antsyn' || $this->type == 'nest' || $this->type == 'link'){
      $val_orig = $this->raw_orig_val;
    }

    $html="";

    /*$html.="<div id='".$DOMid."_popUp' class='corrector_dialog popUp'>";
    $html.="<a onclick='javascript: Popup.hide(\"".$DOMid."_popUp\"); return false;' href='#'>
              <img class='popupCloseButt' src='css/images/popup_close.png'>
            </a>";
    */

    $html.="<form id='redakce_form-$hid' action='redakce.php' method='post' class='corrector_form'>";
    $html.="<div><strong>Nová korektura na poli </strong><em>".$this->get_field_name()."</em></div>\r\n";
    if(!is_external_user(get_logged_user())){
      $varovani="";
      $varovani.=$this->get_skupina_warning($this->field, $hid, $this->val_id);
      $varovani.=$this->get_antsyn_warning($this->field, $hid, $this->val_id);
      if($varovani!="")
      {
        $html.="<div id='varovani' class='varovani_redakce'>";
        $html.=$varovani;
        $html.="</div>\r\n";
      }
    }
    /*
    $html.="<h3>Pole: <i>".$this->name."</i></h3>\r\n";
    $html.="<p><br /></p>\r\n";
    */
    if($this->type == 'antsyn'){
      $html.="<div><strong>Aktuální hodnota:</strong> ".$this->parse_antsyn_val($val_orig)."</div>\r\n";
    }
    else if($this->type == 'nest'){
      $html.="<div><strong>Aktuální hodnota:</strong> ".$this->parse_nest_val($val_orig)."</div>\r\n";
    }
    else if($this->type == 'link'){
      $html.="<div><strong>Aktuální hodnota:</strong>".$this->parse_link_val($val_orig)."</div>\r\n";
    }
    else if($this->type == 'vyznam-link'){
      $html.="<div><strong>Aktuální hodnota:</strong>".$this->parse_vyznam_link_val($val_orig)."</div>\r\n";
    }
    else{
      $html.="<div><b>Aktuální hodnota:</b> ".$val_orig."</div>\r\n";
    }
    $html.="<div><b>Návrh:</b> ".$this->print_val_form_field($DOMid)."</div>\r\n";
    //$html.="<p><br /></p>\r\n";

    $role = get_role();
    //pro odborniky netisknout seznam redaktoru pro zacileni korektury
    if($role != ODBORNIK){
      $html.="<div class='hidden_users_container clear'>";
      $html.="<label class='clickable show_users korekture_label' style='display: block; padding-top: 20px'>
                  Ukaž seznam editorů pro zacílení korektury <img src='css/images/roll_out.png' />
                </label>";
      $zpracovatele = array_keys(get_vybrane_hodnoty_ciselniku(ZPRACOVATELE, 'hes', $hid));
      $html.="<div class='users_list' style='display: none'>
                  ".Redakce::print_users($zpracovatele)."
                  <div class='floatLeft'>
                    <label class='clickable hide_users korekture_label'>
                      Skrýt seznam editorů<img src='css/images/roll_in.png' />
                    </label>
                  </div>
                </div>";
    }
    $html.="<div><!--<br />--><p>Poznámka:</p> <textarea name='note' class='w100'></textarea></div>\r\n";
    $html.="<input type='hidden' name='hid' value='$hid' />\r\n";
    $html.="<input type='hidden' name='DOMid' value='$DOMid' />\r\n";
    $html.="<input type='hidden' name='field' value='".$this->field."' />\r\n";
    $html.="<input type='hidden' name='val_id' value='".$this->val_id."' />\r\n";
    $html.="<input type='hidden' name='act' value='' />\r\n";
    $html.="<input type='hidden' name='return_url' value='' />\r\n";
     if(!$this->is_heslo_blocked($hid)){
      $html.="<input type='button' name='save_correcture_butt' value='Odeslat editorům' onClick=\" corrector_form_submit(this, 'nova_korektura'); \" />\r\n";
      if(get_role()!=ODBORNIK){
        $html.="<input type='button' name='apply_correcture_butt' value='Aplikuj korekturu' onClick=\" corrector_form_submit(this, 'apply_by_corrector'); \" />\r\n";
      }
    }

    $html.="</form>\r\n";
    $html.="<script type='text/javascript'>$('.corrector_form input[name=return_url]').val(document.URL);</script>\r\n";



    $html.="<div class='hidden_korHist_container clear'>";
      $html.="<label class='clickable show_kor_hist korekture_label' style='display: block; padding-top: 20px'>
                Ukaž historii korektur <img src='css/images/roll_out.png' />
              </label>";
      $html.="<div class='historia_korektur' style='display: none'>
                ".self::print_korektury_hist($DOMid)."
                <div class='floatLeft'>
                  <label class='clickable hide_kor_hist korekture_label'>
                    Skrýt historii<img src='css/images/roll_in.png' />
                  </label>
                </div>
              </div>";
    $html.="</div>"; //hidden_korHist_container
    //$html.="</div>";
    return $html;
  }

  public function print_rejected_correction_form($kor_id){

    $val_orig = $this->get_orig_val();
    $val_orig = implode(", ", (array)$val_orig);
    if($this->type != 'rtext' && $this->type != 'radio' && $this->type != 'antsyn' && $this->type != 'nest')
    {
      $val_orig = text_html_preprocess($val_orig);
      $val_orig = nl2br($val_orig);
    }
    if($this->type == 'vyznam-link'){
        $val_orig = $this->parse_vyznam_link_val($val_orig);
    }
    if($this->type == 'radio'){
      $_opts = $this->get_field_opts($this->field);
      $val_orig = $_opts[$val_orig];
    }

    $DOMid = get_db_values('korektura', 'field_DOMid', $kor_id);
    $hid = get_db_values('korektura', 'hid', $kor_id);
    $rejected_status_note = self::get_status_note($kor_id, REJECTED_BY_EDITOR);

    $html="";
    /*
    $html.="<div id='".$DOMid."_popUp' class='corrector_dialog popUp'>";
    $html.="<a onclick='javascript: Popup.hide(\"".$DOMid."_popUp\"); return false;' href='#'>
              <img class='popupCloseButt' src='css/images/popup_close.png'>
            </a>";
    */
    $html.="<form  id='redakce_form-$hid' action='redakce.php' method='post' class='corrector_form'>";
    $html.="<div><strong>Vrácená korektura na poli: </strong><em>".$this->get_field_name()."</em></div>";
    //$html.="<h3>Pole: <i>".$this->name."</i></h3>";
    $html.="<div><strong>Aktuální hodnota:</strong> ".$val_orig."</div>";
    $html.="<div><strong>Návrh:</strong> ".$this->print_val_form_field($DOMid, $kor_id)."</div>";
    if($rejected_status_note!="")
     $html.="<div><strong>Poznámka od editora:</strong><br /><p>".text_html_preprocess($rejected_status_note)."</p></div>";
    $html.="<div><strong>Poznámka pro editora:</strong><br /> <textarea name='note' class='w100'></textarea></div>";
    $html.="<input type='hidden' name='DOMid' value=".$DOMid." />";
    $html.="<input type='hidden' name='kor_id' value=".$kor_id." />";
    $html.="<input type='hidden' name='act' value='' />";
    $html.="<input type='hidden' name='return_url' value='' />";
    if(!$this->is_heslo_blocked($hid)){
      $html.="<input type='button' name='save_correcture_butt' value='Odeslat editorům' onClick=\" corrector_form_submit(this, 'nova_korektura'); \" />";
      $html.="<input type='button' name='close_correcture_butt' value='Uzavřít korekturu' onClick=\" corrector_form_submit(this, 'closed_by_corrector'); \" />";
    }
    $html.="<script type='text/javascript'>$('.corrector_form input[name=return_url]').val(document.URL);</script>";
    $html.="</form>";

    $html.="<div class='hidden_korHist_container clear'>";
      $html.="<label class='clickable show_kor_hist korekture_label' style='display: block; padding-top: 20px'>
                Ukaž historii korektur <img src='css/images/roll_out.png' />
              </label>";
      $html.="<div class='historia_korektur' style='display: none'>
                ".self::print_korektury_hist($DOMid)."
                <div class='floatLeft'>
                  <label class='clickable hide_kor_hist korekture_label'>
                    Skrýt historii<img src='css/images/roll_in.png' />
                  </label>
                </div>
              </div>";
    $html.="</div>"; //hidden_korHist_container
    //$html.="</div>";
    return $html;
  }

  public function print_new_msg_dialog($kor_id){
    $s_id="";
    $res = $this->get_current_state($kor_id);
    $row = mysql_fetch_assoc($res);
    if($row){
       $s_id = $row[id];
    }
    $uid = get_logged_user();

    $html="
      <div><strong>Komentář ke korektuře</strong></div>
        <form action='redakce.php' method='post' class='message_form'>
          Předmět:<br />
          <input type='text' name='subject' /><br />
          Text komentáře:<br />
          <textarea cols='60' rows='5' name='comment'></textarea><br />
          <input type='hidden' name='kid' value='$kor_id' />
          <input type='hidden' name='sid' value='$sid' />
          <input type='hidden' name='uid' value='$uid' />
          <input type='hidden' name='pid' value='' />
          <input type='hidden' name='act' value='new_comment' />
          <input type='hidden' name='return_url' value='' />
          <input type='button' onclick='new_comment_submit(this)' value='Odeslat' />
        </form>
        <script type='text/javascript'>$('.message_form input[name=return_url]').val(document.URL);</script>\r\n
    ";
    return $html;
  }

  public function print_waiting4editor_form($kor_id){
    $d = get_db_values('korektura', array('hid', 'field_DOMid', 'val_new', 'note'), $kor_id);
    $DOMid = $d['field_DOMid'];

    $val_orig = $this->get_orig_val();
    $val_orig = implode(", ", (array)$val_orig);
    if($this->type!='rtext' && $this->type!='radio' && $this->type!='antsyn' && $this->type!='nest' && $this->type!='link' && $this->type!='vyznam-link') {
      $val_orig = text_html_preprocess($val_orig);
      $val_orig = nl2br($val_orig);
    }

    $note = nl2br(text_html_preprocess($d['note']));
    $val_new = $d['val_new'];
    if($this->type=='cis') {
      $val_new = $this->parse_cis_correction($val_new);
      $val_new = text_html_preprocess(implode(", ", $val_new));
      if(empty($val_new) && $this->cis == TEMATICKE_OKRUHY){
          $val_new = "--neoborové--";
      }
    }else{
      if($this->type!='rtext' && $this->type!='radio') {
        $val_new = text_html_preprocess($val_new);
        $val_new = nl2br($val_new);
      }
    }

    if($this->type=='radio'){
      $_opts = $this->get_field_opts($this->field);
      $val_orig = $_opts[$val_orig];
      $val_new = $_opts[$val_new];
    }
    else if($this->type=='antsyn'){
      $val_new = $this->parse_antsyn_val($val_new);
    }
    else if($this->type=='vyznam-link'){
        $val_orig = $this->parse_vyznam_link_val($val_orig);
        $val_new = $this->parse_vyznam_link_val($val_new);
    }
    else if($this->type=='nest'){
      $val_new = $this->parse_nest_val($val_new);
    }
    else if($this->type=='link'){
      $val_new = $this->parse_link_val($val_new);
    }


    $html="";
    /*
    $html.="<div id='".$DOMid."_popUp' class='waiting4editor_dialog popUp'>";
    $html.="<a onclick='javascript: Popup.hide(\"".$DOMid."_popUp\"); return false;' href='#'>
              <img class='popupCloseButt' src='css/images/popup_close.png'>
            </a>";
    */
    $html.="<div><strong>Odeslaná korektura na poli: </strong><em>".$this->get_field_name()."</em></div>";
    //$html.="<h3>Pole: <i>".$this->name."</i></h3>";
    $html.="<div class='hspaceL'></div>";
    $html.="<div><strong>Aktuální hodnota:</strong> ".$val_orig."</div>";
    $html.="<div><strong>Návrh:</strong> ".$val_new."</div>";
    if(empty($note))
      $note="<span class='inactive'>-- bez poznámky --</span>";
    $html.="<div><strong>Poznámka: </strong><p><em>$note</em></p></div>";
    $komentare = $this->print_komentare($kor_id);
    if(!empty($komentare))
      $komentare="<ul span class='korektury_hist'>$komentare</ul>";
    else
      $komentare="<span class='inactive'><em>-- bez komentářů --</em></span>";
    $html.="<div><strong>Komentáře od editorů: </strong>$komentare</div>";

    $html.="<div><b><font color='red'>Korektura pro toto pole už byla zadána a čeká na reakci editora.</font></b></div>";


    $html.=$this->print_new_msg_dialog($kor_id);

    $html.="<div class='hidden_korHist_container clear'>";
      $html.="<label class='show_kor_hist clickable korekture_label' style='display: block; padding-top: 20px'>
                Ukaž historii korektur <img src='css/images/roll_out.png' />
              </label>";
      $html.="<div class='historia_korektur' style='display: none'>
                ".self::print_korektury_hist($DOMid)."
                <div class='floatLeft'>
                  <label class='clickable hide_kor_hist korekture_label'>
                    Skrýt historii<img src='css/images/roll_in.png' />
                  </label>
                </div>
              </div>";
    $html.="</div>"; //hidden_korHist_container

    return $html;
  }

  public function print_field_value_2($val)
  {
    if($this->type=='cis')
    {
      $val = $this->parse_cis_correction($val);
      $val = text_html_preprocess(implode(", ", $val));
    }
    else
    {
      if ($this->type=='radio')
      {
        $_opts = $this->get_field_opts($this->field);
        $val = $_opts[$val];
      }
      else if($this->type == 'antsyn')
      {
        $val = $this->parse_antsyn_val($val);
      }
      else if($this->type == 'nest'){
        $val = $this->parse_nest_val($val);
      }
      else if($this->type == 'link'){
        $val = $this->parse_link_val($val);
      } else if($this->type == 'vyznam-link'){
        $val = $this->parse_vyznam_link_val($val);
      }
      else if($this->type !='rtext')
      {
        $val = text_html_preprocess($val);
        $val = nl2br($val);
      }
    }
    return $val;
  }

  public function print_field_value($kor_id, $orig=true)
  {
    $val_t = "val_new"; if($orig) $val_t = "val_orig";
    $val = get_db_values('korektura', $val_t, $kor_id);
    if(empty($this->hid)){
      $this->hid = get_db_values('korektura', 'hid', $kor_id);
    }

    if($this->type=='cis')
    {
      $val = $this->parse_cis_correction($val);
      $val = text_html_preprocess(implode(", ", $val));
    }
    else
    {
      if ($this->type=='radio')
      {
        $_opts = $this->get_field_opts($this->field);
        $val = $_opts[$val];
      } else if($this->type == 'antsyn'){
        $val = $this->parse_antsyn_val($val);
      } else if($this->type == 'nest'){
        $val = $this->parse_nest_val($val);
      } else if($this->type == 'link'){
        $val = $this->parse_link_val($val);
      } else if($this->type == 'vyznam-link'){
        $val = $this->parse_vyznam_link_val($val);
      }
      else if($this->type!='rtext')
      {
        $val = text_html_preprocess($val);
        $val = nl2br($val);
      }
    }
   return $val;
  }

  public function print_editor_dialog($kor_id, $form_id, $type){

    $d = get_db_values('korektura', array('hid', 'field_DOMid', 'val_new', 'note', 'corrector'), $kor_id);
    $DOMid = $d['field_DOMid'];

    $val_orig = $this->get_orig_val();
    $val_orig = implode(", ", (array)$val_orig);
    if($this->type!='rtext' && $this->type!='antsyn' && $this->type!='nest' && $this->type!='link' && $this->type!='vyznam-link'){
      $val_orig = text_html_preprocess($val_orig);
      $val_orig = nl2br($val_orig);
    }

    $note = nl2br(text_html_preprocess(trim($d['note'])));
    $val_new = $d['val_new'];
    if($this->type=='antsyn'){
      $this->raw_orig_val = $val_new;
      $val_new = $this->parse_antsyn_val($val_new);
    }
    else if($this->type=='nest'){
      $this->raw_orig_val = $val_new;
      $val_new = $this->parse_nest_val($val_new);
    }
    else if($this->type=='link'){
      $this->raw_orig_val = $val_new;
      $val_new = $this->parse_link_val($val_new);
    }
    else if($this->type=='vyznam-link'){
        $this->raw_orig_val = $val_new;
        $val_new = $this->parse_vyznam_link_val($val_new);
        $val_orig = $this->parse_vyznam_link_val($val_orig);
    }
    else if($this->type=='cis') {
      $val_new = $this->parse_cis_correction($val_new);
      $val_new = text_html_preprocess(implode(", ", $val_new));
      if(empty($val_new) && $this->cis == TEMATICKE_OKRUHY){
          $val_new = "--neoborové--";
      }
    }else{
      if($this->type!='rtext') {
        $val_new = text_html_preprocess($val_new);
        $val_new = nl2br($val_new);
      }
    }
    if($this->type=='radio'){
      $_opts = $this->get_field_opts($this->field);
      $radio_val = $val_new;
      $val_orig = $_opts[$val_orig];
      $val_new = $_opts[$val_new];
    }

     $ka = dbq("SELECT uid FROM `korektura_adresati` WHERE `kid` = $kor_id;");
     $adresati = array();
     while($rec = mysql_fetch_array($ka)){
       $adresati[]=get_user_name($rec['uid']);
    }

    $html="";
    $html.="<div id='".$DOMid."_popUp-redakce' class='editor_dialog popUp'>";
    $html.="<form></form><form action='redakce.php' method='post' class='editor_form'>";
    $html.="<div><strong>Korektura na poli: </strong><em>".$this->get_field_name()."</em></h5>";
    //$html.="<h3>Pole: <i>".$this->name."</i></h3>";
    $html.="<div><strong>Korektor: </strong><span style='font-weight: normal'><i>".get_user_name($d['corrector'])."</i></span></h5>";
    $html.="<div><strong>Adresáti korektury: </strong><span style='font-weight: normal'><i>".implode($adresati, ", ")."</i></span></h5>";

    if(!is_external_user(get_logged_user())){
      $varovani="";
      $varovani.=$this->get_skupina_warning($this->field, $d["hid"], $this->val_id);
      $varovani.=$this->get_antsyn_warning($this->field, $d["hid"], $this->val_id);
      if($varovani!="")
      {
        $html.="<div id='varovani' class='varovani_redakce'>";
        $html.=$varovani;
        $html.="</div>";
      }
    }

    //$html.="<div class='hspaceL'></div>";
    $html.="<div><strong>Aktuální hodnota:</strong> ".$val_orig."</div>";
    $html.="<div><strong>Návrh:</strong> ".$val_new."</div>";
    if($this->type=='antsyn'){
      $html.="<div style='display:none'>".$this->print_syn_form_corrected($this->raw_orig_val)."</div>";
    }
    else if($this->type=='nest'){
      $html.="<div style='display:none'>".$this->print_nest_form_corrected($this->raw_orig_val)."</div>";
    } else if($this->type=='link'){
      $html.="<div style='display:none'>".$this->print_link_form_corrected($this->raw_orig_val)."</div>";
    } else if($this->type=='vyznam-link'){
      $html.="<div style='display:none'>".$this->print_vyznam_link_form_corrected($this->raw_orig_val)."</div>";

    }

    //$html.="<div class='hspaceM'></div>";
    $html.="<div><strong>Poznámka od korektora: </strong><p>$note</p></div>";
    if($note=="") $html.="<div class='inactive'>-- bez poznámky --</div>";
    //else          $html.="<div><b>Poznámka od korektora:</b><p>$note</p></div>";
    $komentare = $this->print_komentare($kor_id);
    if(empty($komentare)) $komentare.="<div class='inactive'>-- bez komentářů --</div>";
    else $komentare = "<ul class='korektury_hist'>$komentare</ul>";

    $html.="<div><strong>Poznámky od editorů: </strong>$komentare</div>";

    $html.="<div class='hspaceL'></div>";
    $html.="<input type='hidden' name='hid' value='".$d['hid']."' />";
    $html.="<input type='hidden' name='kor_id' value='$kor_id' />";
    if($this->type=='cis' || $this->type=='antsyn' || $this->type=='nest' || $this->type=='link'){
      $html.="<input type='hidden' name='val_new' value='".$d['val_new']."' />";
    } else{
      $html.="<input type='hidden' name='val_new' value='$val_new' />";
    }
    if (isset($radio_val)) {
      $html .= "<input type='hidden' name='radio_val' value='" . $radio_val . "' />";
    }
    $html.="<input type='hidden' name='DOMid' value='$DOMid' />";
    $html.="<input type='hidden' name='type' value='".$this->type."' />";
    $html.="<input type='hidden' name='act' value='' />";
    $html.="<div><b>Poznámka pro korektora:</b><br /><textarea name='note' class='w100'></textarea></div>";
    $html.="<div class='hspaceL'></div>";
    $html.="<input type='button' name='save_correcture_butt' value='Vrátit korektorovi' onClick=\" editor_form_submit(this, 'reject_by_editor'); \" class='buttBox redButtBox floatLeft' />";
    $html.="<input type='button' name='apply_correcture_butt' value='Aplikuj korekturu' onClick=\" editor_form_submit(this, 'apply_by_editor', '".$type."'); \" class='buttBox blueButtBox floatRight'/>";
    $html.="</form>";

    $html.="<div class='hidden_korHist_container clear'>";
      $html.="<label class='clickable show_kor_hist korekture_label' style='display: block; padding-top: 20px'>
                Ukaž historii korektur <img src='css/images/roll_out.png' />
              </label>";
      $html.="<div class='historia_korektur' style='display: none'>
                ".self::print_korektury_hist($form_id)."
                <div class='floatLeft'>
                  <label class='clickable hide_kor_hist korekture_label'>
                    Skrýt historii<img src='css/images/roll_in.png' />
                  </label>
                </div>
              </div>";
    $html.="</div>"; //hidden_korHist_container

    $html.="</div>";
    return $html;
  }

  public static function get_last_correction_id($DOMid){
    $sql = "SELECT id
            FROM korektura
            WHERE field_DOMid = '$DOMid'
            ORDER BY cts DESC
            LIMIT 1";
    $res = dbq($sql);
    //if($DOMid=='vyznam-22--vazebnost-32') var_dump($sql);
    if(mysql_num_rows($res)==1) return mysql_result($res, 0, "id");
    else return false;
  }

  public function parse_cis_correction($correcture, $ids=false){
    //ak zadame id korektury, vrati nam sparsovanu novu hodnotu toho pola
    //ak zadame retazec.. vrati sparsovany retazec
    if(empty($correcture)) return array();
    $val_new = $correcture;
    if(is_numeric($correcture) && $correcture>0){
      $sql = "SELECT val_new FROM korektura WHERE id=$correcture";
      $res = dbq($sql);
      $val_new = mysql_result($res, 0, "val_new");
    }

    $cis_vals = array();
    $cis_val_pairs = explode("|", $val_new);
    foreach($cis_val_pairs as $cis_val_pair){
      $_cisVal = explode("::", $cis_val_pair);
      if($ids){
       $cis_vals[] = $_cisVal[0];
       if($_cisVal[0]=='jine') $cis_vals['jine'] = $_cisVal[1];
      }else{
       $cis_vals[$_cisVal[0]] = $_cisVal[1];
      }
    }
    return $cis_vals;
  }

  public static function get_cis_vals_str($cis_vals){
    $cis_vals_paired = array();
    foreach($cis_vals as $val_id => $val){
      $cis_vals_paired[] = $val_id."::".$val;
    }

    return implode("|", $cis_vals_paired);
  }

  private function get_skupina_warning($field, $hid, $vyz_id)
  {
    $html = "";
    if($vyz_id>0)
    {
      if($field == 'vyznam-vyklad_vyznamu_master' || $field == 'vyznam-zacatek_predvykladu_master' || $field == 'vyznam-konec_predvykladu_master'
              || $field == 'vyznam-komentar_predvykladu_master' || $field == 'vyznam-vyraz_predvykladu_master'
              || $field == 'vyznam-metavyklad1_master' || $field == 'vyznam-metavyklad2_master' || $field == 'vyznam-predvyklad_master')
      {

        if($field == 'vyznam-komentar_predvykladu_master' || $field == 'vyznam-vyraz_predvykladu_master')
        {
            $vyz_id = get_db_values('vyrazy_predvykladu_m', array('vyz_id'), $vyz_id);
            if(!empty($vyz_id))
            {
                $vyz_id = $vyz_id['vyz_id'];
            } else
            {
                return "";
            }
        }
        if(!($vyz_id==0 || is_null($vyz_id)))
        {
            $vyklad_vyznamu_link = $vyz_id;
            $vyklad_vyznamu_link_hid =0;
            $vyklad_vyznamu_link_var ="";
            $vyklad_vyznamu_link_text = get_linked_vyznam_text($vyklad_vyznamu_link, $vyklad_vyznamu_link_hid, $vyklad_vyznamu_link_var, $vyz_id, true);
            $html .= "<h3>Varování</h3>\r\n<p>Změny se projeví také v heslech: ".$vyklad_vyznamu_link_var."</p><br />";//.$vyklad_vyznamu_link_var;
        }
      }
    }
    return $html;
  }

  private function is_heslo_blocked($hid){
     //externiste nemohou aplikovat korekturu, takze se na ne nevztahuje blokace
     //http://www.foxcom.cz/support/ts/view.php?id=630
     if(is_external_user(get_logged_user())){
        return;
     }
     $heslo_block_stat = get_heslo_block_stat($hid);
     $heslo_is_blocked = ($heslo_block_stat!==false && !is_me_blocking_heslo($hid));
    return $heslo_is_blocked;
  }

  private function get_antsyn_warning($field, $hid, $vyz_id){
    $antsyn_array = array();
    $html_main = "";
    $html_slave = "";

    if($field == 'vyznam-vyklad_vyznamu' || $field == 'vyznam-zacatek_predvykladu' || $field == 'vyznam-konec_predvykladu'
            || $field == 'vyznam-komentar_predvykladu' || $field == 'vyznam-vyraz_predvykladu'
            || $field == 'vyznam-metavyklad1' || $field == 'vyznam-metavyklad2' || $field == 'vyznam-predvyklad')
    {
        if($field == 'vyznam-komentar_predvykladu' || $field == 'vyznam-vyraz_predvykladu'){
            $vyz_id = get_db_values('vyrazy_predvykladu', array('vyz_id'), $vyz_id);
            if(!empty($vyz_id)){
                $vyz_id = $vyz_id['vyz_id'];
            } else{
                return "";
            }
        }
        if(empty($hid)){
            $hid = get_db_values('vyznamy', array('hid'), $vyz_id);
            if(!empty($hid)){
                $hid = $hid['hid'];
            } else{
                return "";
            }
        }

        $antsyn_array = syn_ant_spojena_s_vyz($hid, $vyz_id);//kontrola_existence_syn_ant($hid, $vyz_id);
        if(empty($antsyn_array)){
            return "";
        }

        $html_main .= $antsyn_array['main'];
        $html_slave .= $antsyn_array['slave'];

    }
    if($field == 'vyznam-vyklad_vyznamu_master' || $field == 'vyznam-zacatek_predvykladu_master' || $field == 'vyznam-konec_predvykladu_master'
              || $field == 'vyznam-komentar_predvykladu_master' || $field == 'vyznam-vyraz_predvykladu_master'
              || $field == 'vyznam-metavyklad1_master' || $field == 'vyznam-metavyklad2_master' || $field == 'vyznam-predvyklad_master')
    {
      if($field == 'vyznam-komentar_predvykladu_master' || $field == 'vyznam-vyraz_predvykladu_master'){
            $vyz_id = get_db_values('vyrazy_predvykladu_m', array('vyz_id'), $vyz_id);
            if(!empty($vyz_id)){
                $vyz_id = $vyz_id['vyz_id'];
            } else{
                return "";
            }
        }
        if(empty($hid)){//z id významu není možné identifikovat
            /*$hid = get_db_values('vyznamy_master', array('hid'), $vyz_id);
            if(!empty($hid)){
                $hid = $hid['hid'];
            } else{   */
                return "";
            //}
        }
        $vyz_id = dibi::fetchSingle("SELECT id FROM vyznamy WHERE hid=$hid AND vyklad_vyznamu_link=$vyz_id");

        $antsyn_array = syn_ant_spojena_s_vyz($hid, $vyz_id);//kontrola_existence_syn_ant($hid, $vyz_id);
        if(empty($antsyn_array)){
            return "";
        }

        $html_main .= $antsyn_array['main'];
        $html_slave .= $antsyn_array['slave'];


    }
    $html = '';
    if(!empty($html_slave)){
        $html = "<p>Pozor, měníte význam, který je připojen jako synonymum/antonymum u následujících hesel:</p><br />".$html_slave;
    }
    if(!empty($html_main)){
        if(!empty($html)){
          $html .="<br />";
        }
        $html .= "<p>Pozor, měníte význam, který má následující synonyma/antonyma:</p><br />".$html_main;
    }
    if(!empty($html)){
      $html = "<h3>Varování</h3>\r\n".$html;
    }
    return $html;
  }

  private function get_place_string($place, $place_id, $slave_hid){
      $misto = '';
      if($place == 'heslo')
        $misto = 'heslo';
      else if($place=='')
        $misto = 'nepropojeno';
      else if($place=='exemplifikace'){
        $vyznamy = get('vyznamy_hesla', $slave_hid, array('sortorder'));
        $vyz = get_db_values('exemplifikace', 'vyz_id', $place_id);
        $exe = get('exempl_vyznamu', $vyz, array('sortorder'));
        $exe_index = array_search($place_id, $exe);
        if(is_numeric($exe_index))
          $exe_index++;
        $index = array_search($vyz, $vyznamy);
        $num = 0;
        $index_podvyznamu = 0;
        if($index===false){
          foreach($vyznamy as $vyznam){
            $num++;
            $subvyznamy = get_subvyznamy($vyznam);
            $index_podvyznamu = array_search($vyz, $subvyznamy);
            if($index_podvyznamu!==false){
              $index_podvyznamu++;
              $misto = " podvýznam $index_podvyznamu významu $num / exemplifikace $exe_index";
              break;
            }
          }
       }
       if($index!==false){
        $index++;
        $misto = "význam $index - exemplifikace $exe_index";

       }
      }
      else
      {
        $vyznamy = get('vyznamy_hesla', $slave_hid, array('sortorder'));
        $vyz = $place_id;
        $index = array_search($vyz, $vyznamy);
        $num = 0;
        $index_podvyznamu = 0;
        if($index===false){
          foreach($vyznamy as $vyznam){
            $num++;
            $subvyznamy = get_subvyznamy($vyznam);
            $index_podvyznamu = array_search($vyz, $subvyznamy);
            if($index_podvyznamu!==false){
              $index_podvyznamu++;
              $misto = "podvýznam $index_podvyznamu významu $num";
              break;
            }
          }
        } else{
          $index++;
          $misto = "význam $index";
        }
      }
      return $misto;
  }

  public function get_vyz_number($vyz, $vyznamy){
    //$vyznamy = get('vyznamy_hesla', $hid, array('sortorder'));
    $index = array_search($vyz, $vyznamy);
    if($index===false){
      return "";
    }
    $index++;
    return $index;
  }

  public function parse_antsyn_val($val){
    $fields = explode('^', $val);
    if(empty($fields[0])){
      return "Korektor navrhuje $this->field vymazat";
    }
    $przn = "neutrální";
    if(isset($fields[5]) && ($fields[5] == HREL_TYPE_syn_przn || $fields[5] == HREL_TYPE_ant_przn)){
      $przn = "příznakové";
    }
    $s = '';
    if($this->field == 'synonymum')
      $s = "<span class='field-label'>Synonymum ($przn):</span> ";
    else
      $s = "<span class='field-label'>Antonymum ($przn):</span> ";
    $misto = $this->get_place_string($fields[2], $fields[3], $fields[4]);
    $s .= "$fields[0],\r\n";
    $s .= "<span class='field-label'>Komentář:</span> $fields[1],\r\n";
    $s .= "<span class='field-label'>Místo:</span> $misto";
    return $s;
  }

  public function parse_nest_val($val){
    $fields = explode('^', $val);
    $s = "";
    if(empty($fields[0])){
      $s = "<span class='field-label'>Korektor se rozhodl vazbu odstranit</span>";
    } else{
      if($fields[2] == HREL_TYPE_pripojovani)
        $typ = "připojování";
      else
        $typ = "přihnízdování";
      $misto = $this->get_place_string($fields[4], $fields[5], $fields[3]);
      $s = "<span class='field-label'>Heslo:</span> $fields[0]\r\n";
      $s .= "<span class='field-label'>Místo:</span> $misto\r\n";
      $s .= "<span class='field-label'>Typ:</span> $typ\r\n";
    }
    return $s;
  }

  public function parse_vyznam_link_val($val){
      $fields = explode("^", $val);
      if($fields[1]==0){
          return "odkaz zrušen";
      }
      $cislo_vyznamu = vyznam_number($fields[1], true);
      if(empty($cislo_vyznamu)){
          $cislo_vyznamu = "1";
      }
      return $fields[0]." V".$cislo_vyznamu;
  }

  public function parse_link_val($val){
    $fields = explode('^', $val);
    if(empty($fields[0])){
        return "<span class='field-label'>Korektor se rozhodl odkaz odstranit</span>";
    }
    $vyznamy = get('vyznamy_hesla', $this->hid, array('sortorder'));
    $main_places = explode("|", $fields[5]);
    $note = "";
    if(isset($fields[7]) && ($fields[7]!=""))
      $note = $fields[7]." ";
    foreach($main_places as $main_place){
      if(!is_null($main_place) && !empty($main_place)){
        $main_place_info = explode("-", $main_place);
        if($main_place_info[0]=="vyznam"){
          $s.=" ".$this->get_vyz_number($main_place_info[1], $vyznamy);
        } else if($main_place_info[0]=="heslo"){
          //$s.=" H"; /*H se nema tisknout - viz Mantis #619*/
        }
      }
    }

    if(is_null($fields[4]) || empty($fields[4]))
      $s .= " $fields[3] &rarr; $note $fields[0]";
    else
      $s .= " $fields[4] &rarr; $note $fields[0]";
    $slave_places = explode("|", $fields[6]);
    $vyznamy = get('vyznamy_hesla', $fields[1], array('sortorder'));
    foreach($slave_places as $slave_place){
      if(!is_null($slave_place) && !empty($slave_place)){
        $slave_place_info = explode("-", $slave_place);
        if($slave_place_info[0]=="vyznam"){
          $s.=" ".$this->get_vyz_number($slave_place_info[1], $vyznamy);
        } else if($slave_place_info[0]=="heslo"){
          //$s.=" H"; /*H se nema tisknout - viz Mantis #619*/
        }
      }
    }

    return $s;
  }

  /*
    Tests if corresponding field still exists in DB
    TODO: vyresit ciselniky
  public function is_alive(){
    $x = null;

    if($this->type == 'antsyn'){
      $x = check_db_values("hesla_rel", array("slave_str", "slave_hid", "main_hid", "komentar", "rel_type"), $this->val_id);
    }
    else if($this->type == 'nest'){
      $x = check_db_values("hesla_rel", array("slave_str", "main_hid", "slave_hid", "rel_type"), $this->val_id);
    }
    else if($this->type == 'link'){
      $x = check_db_values("hesla_rel", array("main_hid", "slave_str", "slave_hid"), $this->val_id);
    }
    else if($this->type == 'cis'){
      $x = get_vybrane_hodnoty_ciselniku($this->cis, $this->var_vyz, $this->val_id);
    }else{
      $x = check_db_values($this->tbl, $this->db_field, $this->val_id);
    }
    var_dump($x);
  }
  */

  public function get_orig_val(){
      if($this->type == 'antsyn'){
      if($this->field == 'synonymum')
        $typ = "Synonymum";
      else
        $typ = "Antonymum";
      $odkazy_info = get_db_values("hesla_rel", array("slave_str", "slave_hid", "main_hid", "komentar", "rel_type"), $this->val_id);
      $this->hid = $odkazy_info[main_hid];
      $slave_place = get_db_values_where("hesla_rel_slave_places", array("place", "place_id"), "hesla_rel_id", $this->val_id);
      $misto = $this->get_place_string($slave_place[place], $slave_place[place_id], $odkazy_info[slave_hid]);

      $przn = "neutrální";
      if($odkazy_info[rel_type]==HREL_TYPE_syn_przn || $odkazy_info[rel_type]==HREL_TYPE_ant_przn){
        $przn = "příznakové";
      }
      $val = "<span class='field-label'>$typ ($przn):</span> ".text_html_preprocess($odkazy_info[slave_str]).", ";
      $val .= "<span class='field-label'>Komentář:</span> ".text_html_preprocess($odkazy_info[komentar]).", ";
      $val .= "<span class='field-label'>Místo:</span> $misto";
      $this->raw_orig_val = "$odkazy_info[slave_str]^$odkazy_info[komentar]^$slave_place[place]^$slave_place[place_id]^$odkazy_info[slave_hid]^$odkazy_info[rel_type]";
      return $val;
    }
    else if($this->type == 'nest'){
      $odkazy_info = get_db_values("hesla_rel", array("slave_str", "main_hid", "slave_hid", "rel_type"), $this->val_id);
      $this->hid = $odkazy_info[main_hid];
      $main_place = get_db_values_where("hesla_rel_places", array("place", "place_id"), "hesla_rel_id", $this->val_id);
      $this->raw_orig_val="$odkazy_info[slave_str]^$odkazy_info[slave_hid]^$odkazy_info[rel_type]^$odkazy_info[main_hid]^$main_place[place]^$main_place[place_id]";
      $val = $this->parse_nest_val($this->raw_orig_val);
      return $val;
    }
    else if($this->type == 'vyznam-link'){
        $val = "";
        $stringArray = array();
        $d = get_db_values_where("propojeni_vyznamu", array("vyz_from", "vyz_m_from", "vyz_to"), "id", $this->val_id);
        $vyz_id = 0;
        $group = false;
        if($d['vyz_from'])
          $vyz_id = $d['vyz_from'];
        else {
          $vyz_id = $d['vyz_m_from'];
          $group = true;
        }
        $vyz_to = $d['vyz_to'];
        if(is_numeric($vyz_id)){
            if(!$group){
              $vyklad_vyznamu = get_db_values("vyznamy", "vyklad_vyznamu", $vyz_id);
            } else{
              $vyklad_vyznamu = get_db_values("vyznamy_master", "vyklad_vyznamu", $vyz_id);
            }
            $stringArray = split_vyznam($vyklad_vyznamu, $this->val_id);
            $pieces = explode("<span id=\"link-$this->val_id", $vyklad_vyznamu);
            $slave_text = "";
            if(!empty($pieces[1])){
              $pieces2 = explode("Připojeno k: ", $pieces[1]);
              if(!empty($pieces2[1])){
                $pos = strpos($pieces2[1], "\"");
                $slave_text = substr($pieces2[1], 0, $pos);
              }
            }
            if(empty($slave_text)){
              $slave_text = $stringArray[1];
            }
            $slave_hid = get_db_values("vyznamy", "hid", $vyz_to);
            $master = $group ? "1" : "0";
            $val = $slave_text."^".$vyz_to."^".$slave_hid."^".$master;
        }
        return $val;
    }
    else if($this->type == 'link'){
      $odkaz_info = get_db_values("hesla_rel", array("main_hid", "slave_str", "slave_hid", "poznamka"), $this->val_id);
      $this->hid = $odkaz_info[main_hid];
      $odkaz_text = get_vybrane_hodnoty_ciselniku(TYP_LINKOVANI, "hes", $this->val_id);

      $odkaz_typ = get_db_values_where("hesla_rel_link_type_vyber", array("cis_id", "jine"), "hesla_rel_id", $this->val_id, true);
      $main_places = get_db_values_where("hesla_rel_places", array("place", "place_id"), "hesla_rel_id", $this->val_id, true);
      $slave_places = get_db_values_where("hesla_rel_slave_places", array("place", "place_id"), "hesla_rel_id", $this->val_id, true);
      $typ = $odkaz_text[$odkaz_typ[cis_id]];
      $val = "$odkaz_info[slave_str]^$odkaz_info[slave_hid]^$odkaz_typ[cis_id]^$odkaz_typ[jine]^$typ^";

      if(!empty($main_places) && !is_null($main_places)){
        foreach($main_places as $main_place){
          $val.="$main_place[place]-$main_place[place_id]|";
        }
      }
      $val.="^";
      if(!empty($slave_places) && !is_null($slave_places)){
        foreach($slave_places as $slave_place){
          $val.="$slave_place[place]-$slave_place[place_id]|";
        }
      }
      $val.="^$odkaz_info[poznamka]";
      $this->raw_orig_val = $val;
      $val = $this->parse_link_val($val);
      return $val;
    }
    else if($this->type == 'cis'){
      $r = get_vybrane_hodnoty_ciselniku($this->cis, $this->var_vyz, $this->val_id);
      if(empty($r) && $this->cis == TEMATICKE_OKRUHY){
          $r = "--neoborové--";
      }
      return $r;
    }else{
      return get_db_values($this->tbl, $this->db_field, $this->val_id);
    }
  }

  public static function is_new_correction($kor_id){
    $sql = "SELECT count(id) as c FROM korektura_stavy WHERE kor_id=$kor_id";
    $res = dbq($sql);
    return mysql_result($res, 0, "c") == 0;
  }

  public static function is_rejected_by_editor($kor_id){
    $sql = "SELECT count(id) as c FROM korektura_stavy WHERE kor_id=$kor_id AND status=".REJECTED_BY_EDITOR;
    $res = dbq($sql);
    return mysql_result($res, 0, "c") > 0 && !self::is_correction_closed($kor_id);
  }

  public static function is_correction_closed($kor_id){
    $sql = "SELECT COUNT(id) as cnt FROM korektura_stavy WHERE kor_id=$kor_id AND status IN (".APPLIED_BY_EDITOR.",".APPLIED_BY_CORRECTOR.",".CLOSED_BY_CORRECTOR.")";
    $res = dbq($sql);
    return mysql_result($res, 0, 'cnt')>0;
  }

  public static function get_status_user($kor_id){
     $sql = "SELECT status, uid FROM korektura_stavy WHERE kor_id=$kor_id ORDER BY cts DESC LIMIT 1";
    $res = dbq($sql);
    if(mysql_num_rows($res)==1){
      $r[status] = mysql_result($res, 0, 'status');
      $r[uid] = mysql_result($res, 0, 'uid');
      return $r;
    }
    if(mysql_num_rows($res)==0) return "";
  }

  private static function get_status_note($kor_id, $status){
    $sql = "SELECT note FROM korektura_stavy WHERE kor_id=$kor_id AND status=$status ORDER BY cts DESC LIMIT 1";
    $res = dbq($sql);
    if(mysql_num_rows($res)==1) return mysql_result($res, 0, 'note');
    if(mysql_num_rows($res)==0) return "";
    return "-- Fatální chyba! -- ";
  }

  //funkcia vyberie hesla, v ktorych je nova korektura pre uziavtela v argumente
  public static function get_hesla_s_korekci_pro_zpracovatele($zprac_uid, &$pids = null, $ord_by=NULL, $col=NULL){
    if(empty($ord_by) && empty($col))
    {
      $sql = "
      SELECT DISTINCT k.hid as hid, k.field as field, h.pid as pid, varianty_bez_zavor
      FROM korektura k
       JOIN heslo h ON k.hid=h.id
       JOIN varianty v ON h.id=v.hid
       LEFT JOIN korektura_stavy ks ON k.id=ks.kor_id
       LEFT JOIN zpracovatel z ON k.hid=z.hid
       LEFT JOIN korektura_adresati ka ON ka.kid=k.id
       LEFT JOIN uzivatel u3 ON ka.uid=u3.id
      WHERE (u3.id=$zprac_uid OR (u3.id IS NULL AND z.uid=$zprac_uid))
       AND ks.status IS NULL -- or ks.korid IS NULL
       ORDER BY varianty_bez_zavor ASC
    ";
    }
    else
    {
      $sql = "
      SELECT DISTINCT k.hid as hid, k.field as field, h.pid as pid, $col
      FROM korektura k
       JOIN heslo h ON k.hid=h.id
       JOIN varianty v ON h.id=v.hid
       LEFT JOIN korektura_stavy ks ON k.id=ks.kor_id
       LEFT JOIN zpracovatel z ON k.hid=z.hid
       LEFT JOIN korektura_adresati ka ON ka.kid=k.id
       LEFT JOIN uzivatel u3 ON ka.uid=u3.id
      WHERE (u3.id=$zprac_uid OR (u3.id IS NULL AND z.uid=$zprac_uid))
       AND ks.status IS NULL -- or ks.korid IS NULL
       ORDER BY $ord_by
    ";
    }
    //var_dump($sql);
    $res = dbq($sql);
    $hids = array();
    while($rec = mysql_fetch_array($res)){
    //nezarazuj korektury ze stareho systemu antonym/synonym
      if(($rec['field']=="vyznam-synonymum-synonymum") || ($rec['field']=="vyznam-antonymum-antonymum") || $rec['field']=="odkaz-synonymum")
        continue;
      if(!in_array($rec['hid'], $hids)){
        $hids[] = $rec['hid'];
        $pids[] = $rec['pid'];
      }
    }
    return $hids;
  }

  //funkcia vyberie hesla, v ktorych korektura s definovanym poslednym stavom (v argumente) pre uziavtela v argumente
  public static function get_hesla_s_korekci_ve_stavu_pro_uzivatele($stav, $zprac_uid){

    if(is_numeric($stav)) $stav = "=$stav";
    if($stav == 'nove_pro_editora') $stav = 'IS NULL';
    if($stav == 'nastavene_korektorom') $stav = 'IN ('.APPLIED_BY_CORRECTOR.', '.CLOSED_BY_CORRECTOR.')';
    //...

    $sql = "
      SELECT DISTINCT k.hid -- k.id, k.pid, k.cts, k.hid, k.corrector, ks.kor_id, ks.cts, ks.uid, ks.status, k.field_DOMid
      FROM ( SELECT kor_id, MAX(cts) AS lastStatus FROM korektura_stavy GROUP BY kor_id) ls
       INNER JOIN korektura_stavy ks ON ls.kor_id = ks.kor_id AND ls.lastStatus = ks.cts
       RIGHT JOIN korektura k ON k.id=ks.kor_id
       LEFT JOIN zpracovatel z ON k.hid=z.hid
      WHERE z.uid=$zprac_uid
       AND ks.status $stav";
    $res = dbq($sql);
    $hids = array();
    while($rec = mysql_fetch_array($res)){
     $hids[] = $rec['hid'];
    }
    return $hids;
  }

  public static function get_nove_korekce(){
    $sql = "
      SELECT k.id kor_id
      FROM korektura k LEFT JOIN korektura_stavy ks ON k.id=ks.kor_id
      WHERE ks.kor_id IS NULL";
    $res = dbq($sql);
    $kor_ids = array();
    while($rec = mysql_fetch_array($res))
    {
       $kor_ids[] = $rec['kor_id'];
    }
    return $kor_ids;
  }


  public static function over_korekce_predvykladu($field, $DOMid, $link_ids, $val_id){
    $substr = "komentar";
    if($field=="vyznam-vyraz_predvykladu_master"){
      $substr = "vyraz";
    }


    foreach($link_ids as $lid){
        $test = "vyznam-".$lid."--".$substr."_predvykladu_master-".$val_id;
        if($DOMid == $test){
            return true;
        }
    }
    return false;
  }

  public static function get_nove_korekce_skupinky($hid){
    $kids = array();
    $sql = "SELECT vyklad_vyznamu_link FROM vyznamy WHERE hid=".$hid." AND vyklad_vyznamu_link !=0 AND vyklad_vyznamu_link IS NOT NULL ";
    $res = mysql_query($sql) or die('Query: '.$sql.'  failed: ' . mysql_error());
    if(mysql_num_rows($res)>0)
    {
      $hids = array();
      $vyznamy = get('vyznamy_hesla', $hid, array('sortorder'));
      $vyznamy_tmp = vygeneruj_podvyznamy($hid, $vyznamy);
      foreach($vyznamy_tmp as $vyznamy_info){
          $vyz_id = $vyznamy_info[ID];
          $Dvyz = get_db_values('vyznamy', array('vyklad_vyznamu_link'), $vyz_id);
          $link_id = $Dvyz['vyklad_vyznamu_link'];
          if(is_numeric($link_id) && ($link_id > 0)){
              $members = get_db_values_where('vyznamy', array('hid'), 'vyklad_vyznamu_link', $link_id, true);
              foreach($members as $member){
                  if($member['hid']!=$hid){
                      $hids[] = $member['hid'];
                  }
              }
          }
      }

      foreach($hids as $id){
          $ids = Redakce::get_nove_korekce_hesla($id);
          foreach($ids as $kid){
              if(!in_array($kid, $kids)){
                  $kids[] = $kid;
              }
          }
      }
    }
    return $kids;
  }

  public static function get_nove_korekce_hesla($hid){
    $sql = "
      SELECT k.id kor_id
      FROM korektura k LEFT JOIN korektura_stavy ks ON k.id=ks.kor_id
      WHERE hid=$hid AND ks.kor_id IS NULL";
    $res = dbq($sql);
    $kor_ids = array();
    while($rec = mysql_fetch_array($res))
    {
       $kor_ids[] = $rec['kor_id'];
    }
    return $kor_ids;
  }
  
  public static function get_zamitnute_korekce_hesla($hid){
   /* $sql = "
      SELECT k.id kor_id
      FROM korektura k LEFT JOIN korektura_stavy ks ON k.id=ks.kor_id
      WHERE hid=$hid AND ks.status = ".REJECTED_BY_EDITOR; */
    $sql = "SELECT k.id 
    FROM korektura k JOIN korektura_stavy ks ON k.id=ks.kor_id
    WHERE ks.id in (SELECT max(ks.id) FROM korektura k JOIN korektura_stavy ks  ON k.id=ks.kor_id WHERE `hid`= $hid GROUP BY field_DOMid) AND `status` = ".REJECTED_BY_EDITOR;
    //$sql = "SELECT `id` FROM `aktual_stav_korektur` WHERE `hid`= $hid AND `status` = ".REJECTED_BY_EDITOR;
    $res = dbq($sql);
    $kor_ids = array();
    while($rec = mysql_fetch_array($res))
    {
       $kor_ids[] = $rec['id'];
    }
    return $kor_ids;  
  }

  public static function get_nove_korekce_hesla_pro_zpracovatele($hid, $uid){
    $sql = "
      SELECT k.id kor_id
      FROM korektura k
      LEFT JOIN korektura_stavy ks ON k.id=ks.kor_id
      LEFT JOIN korektura_adresati ka ON k.id=ka.kid
      WHERE hid=$hid AND ks.kor_id IS NULL AND ka.uid=$uid";
    $res = dbq($sql);
    $kor_ids = array();
    while($rec = mysql_fetch_array($res))
    {
       $kor_ids[] = $rec['kor_id'];
    }
    return $kor_ids;
  }


  public function get_korektori($kor_id, $hid = 0){
    if($kor_id == 0){
      $kor_id = $this->kor_id;
    }
    $sql = "SELECT uid FROM `korektura_adresati`
            WHERE kid=$kor_id";
    $res = dbq($sql);
    $uids = array();
    while($rec = mysql_fetch_array($res))
    {
       $uids[] = $rec['uid'];
    }
    //nebyl nalezen zadny prirazeny korektor, vrati se zpracovatele
    if(empty($uids) && ($hid > 0)){
       return get_zpracovatele($hid);
    }
    return $uids;
  }


  public static function field_has_opened_correction($field_DOMid){
    $sql = "
      SELECT count(k.id) as cnt
      FROM korektura k LEFT JOIN korektura_stavy ks ON k.id=ks.kor_id
      WHERE field_DOMid='$field_DOMid' AND ks.kor_id IS NULL
    ";
    $res = dbq($sql);
    return mysql_result($res, 0, 'cnt') > 0;
  }

 public static function field_has_correction($field_DOMid){
   $field_DOMid = mysql_real_escape_string($field_DOMid);
   $sql = "SELECT count(id) as cnt FROM korektura WHERE field_DOMid='$field_DOMid'";
   $res = dbq($sql);
   return mysql_result($res, 0, 'cnt') > 0;
 }

 public function get_current_state($kor_id){
  if(!is_numeric($kor_id)) return false;
  $query = "SELECT id FROM korektura_stavy WHERE kor_id=$kor_id ORDER BY cts DESC LIMIT 1";
  return dbq($query);
 }

 public function get_stavy($kor_id){
   if(!is_numeric($kor_id)) return false;
   $sql = "SELECT id FROM korektura_stavy WHERE kor_id=$kor_id";
   return db_get_val_arr($sql);
 }

 public function print_stavy_hist($kor_id){
   global $_CORRECTURE_STATE;
   $stavy = $this->get_stavy($kor_id);
   $html = "";
   if(empty($stavy)) return $html;

   $html.="\r\n<ul class='stavy'>";
   foreach($stavy as $stav_id){
     $d = get_db_values('korektura_stavy', array('status', 'uid', 'cts', 'note'), $stav_id);
     $user = get_user_name($d['uid']);
     $date = ftime($d['cts']);
     $html.="\r\n<li title='$user [$date]'>";
     $html.="<span class='korStatus'>".$_CORRECTURE_STATE[$d['status']]." $user [$date]</span> ";
     if(!empty($d['note']))
      $html.="<br /><span class='korNote'>Poznámka: &bdquo;".$d['note']."&rdquo;</span>";
     $html.="\r\n</li>";
   }
   $html.="\r\n</ul>";

   return $html;
 }

 private function print_komentare($kor_id){
   $komentare = get_db_values_where('korektura_komentare',
      array('cts', 'sid', 'uid', 'pid', 'subject', 'comment'), 'kid', $kor_id, true);
   $html = "";
   if(is_array($komentare)){
     $html.="\r\n<li>";
     foreach($komentare as $komentar){
        $html.="<span class='komentar_korektury' title='komentar'>&nbsp;</span>";
        if(!empty($komentar['subject']))
          $html.="<span class='komentar_titulek'>".text_html_preprocess($komentar['subject'])."</span>\r\n";
        else
          $html.="<span class='komentar_titulek'>-- předmět nezadán --</span>\r\n";

        $datum = ftime($komentar['cts']);
        $uzivatel = get_user_name($komentar['uid']);
        $html.="zadal(a): $uzivatel [$datum]<br />";
        if(!empty($komentar['comment']))
          $html.="<span class='korNote'>".text_html_preprocess($komentar['comment'])."</span><br />";

     }
     $html.="</li>";
   }
   return $html;
 }

 private static function print_users($uids = array()){
    $res = dbq('SELECT id, login, jmeno, prijmeni FROM uzivatel WHERE role=0 OR role=5 ORDER by prijmeni;');
    $html = "\r\n<table>";
    $cnt = 0;
    $checked = "";
    $html.="\r\n\t<tr>";
    while($row = mysql_fetch_array($res)){
      if($row['jmeno']=="web"){
        continue;
      }
      $checked = "";
      if(in_array($row[id], $uids)){
        $checked = "checked='checked'";
      }
      $html.="\r\n\t\t<td><input $checked type='checkbox' name='user$row[id]' value='$row[id]' />$row[prijmeni] $row[jmeno]</td>";

      $cnt++;
      if($cnt % 2 == 0 && $cnt>1){
        $html.="\r\n\t</tr>\r\n\t<tr>";
      }
    }
    $html.="</tr></table>";
    return $html;
 }

 public function print_new_vals_hist($kor_id){
   $val_new = $this -> print_field_value($kor_id, false);
   $d = get_db_values('korektura', array('corrector', 'cts', 'note'), $kor_id);
   $html ="";
   $user = get_user_name($d['corrector']);
   $date = ftime($d['cts']);
   $html.="\r\n<li title='$user [$date]'>";
   if(empty($val_new) && $this->cis == TEMATICKE_OKRUHY){
       $val_new = "--neoborové--";
   }
   $html.="<span class='new_val'>$val_new </span>Zadal(a): $status $user [$date]";
   if(!empty($d['note']))
      $html.="<br /><span class='korNote'>Poznámka: &bdquo;".$d['note']."&rdquo;</span>";
   $html.=$this->print_komentare($kor_id);
   $html.= $this->print_stavy_hist($kor_id);
   $html.="\r\n</li>";
   $sql = "SELECT id FROM korektura WHERE pid=$kor_id";
   $childs = db_get_val_arr($sql);
   foreach($childs as $_kor_id) {
    $html.=$this->print_new_vals_hist($_kor_id);
    $html.="<li><hr /></li>";
   }
   return $html;
 }

 public static function print_korektury_hist($DOMid=0){
   $DOMid = mysql_real_escape_string($DOMid);
   $sql = "SELECT id FROM korektura WHERE pid IS NULL AND field_DOMid='$DOMid' ORDER BY cts";
   $ids = db_get_val_arr($sql);
   $korektury_hist_html.= "\r\n<ul class = 'korektury_hist'>";
    foreach($ids as $kor_id){
      $R = new Redakce($kor_id);
      $korektury_hist_html.="\r\n<li>";
      $val_orig = $R -> print_field_value($kor_id, true);
      if(empty($val_orig) && $R->cis==TEMATICKE_OKRUHY){
          $val_orig = "--neoborové--";
      }
      $korektury_hist_html.="<span class='orig_val'>".$val_orig."</span>";
      $korektury_hist_html.= "\r\n<ul class='new_vals'>".$R -> print_new_vals_hist($kor_id)."\r\n</ul>";
      $korektury_hist_html.="\r\n</li>";
    }
    $korektury_hist_html.= "\r\n</ul>";

    $korektury_hist_html = "
        <div class='korektury_hist_container'>
         <h2>Historie korektur</h2>
          $korektury_hist_html
        </div>";

    return $korektury_hist_html;
 }

 public static function print_korektury_hist_popUp($DOMid=0){
    $html = "";
    $html.= "
      <div id='".$DOMid."_popUp-redakce' title='Historie korektur' class='popUp'>
        ".self::print_korektury_hist($DOMid)."
      </div>";

   return $html;
 }

 private static function clearCache($kor_id, $hid = 0){
    $cache = new CacheManager;
    if($hid == 0){
      $data = get_db_values('korektura', array('hid'), $kor_id);
      $hid = $data[hid];
    }
    $cache->dropCache($hid);
 }

}
?>
