<?php
class xFilter{

  const ALT_NUM = 10; //number of alternatives

  private $X = array(); //configuracne pole
  private $field   = ''; //identifikator typu hodnoty


  function __construct() {
    $this->_setup();
  }
  private function _setup(){
      global $_CIS_VYBER;
      // TYPE = txt | tarea | cis | sel1 | onoff | date
      $this->X['heslo-pripojeno']=array(
          'name' => 'Hesla, která jsou připojená/přihnízdovaná',
          'type' => 'onoffSpec',
          'search_field'=>'id',
          'JOINs' => array(
              1 => array("tbl"=>'heslo', "fk"=>"id"),
              2 => array("tbl"=>"hesla_rel", "fk"=>"slave_hid"),
          ));
      $this->X['heslo-korektura']=array(
        'name' => 'Korektura',
        'type' => 'onoffK',
        'search_field'=>'status',
        'JOINs' => array(
          1 => array("tbl"=>'korektura', "fk"=>"hid"),
          2 => array("tbl"=>"korektura_stavy", "fk"=>"kor_id", "join"=>"LEFT")
        ));
      $this->X['heslo-vytvořeno']=array(
        'name' => 'Vytvořeno',
        'type' => 'date',
        'id' => 'vy',
        'search_field'=>'cts');
      $this->X['heslo-změněno']=array(
        'name' => 'Změněno ',
        'type' => 'date',
        'id' => 'zm',
        'search_field'=>'uts');
      $this->X['heslo-zpracovatel']=array(
        'name' => 'Zpracovatel',
        'type' => 'cis',
        'cis' => ZPRACOVATELE,
        'JOINs' => array(
          1 => array("tbl"=>$_CIS_VYBER[ZPRACOVATELE][0], "fk"=>"hid", "join"=>"LEFT")
        ));
      $this->X['heslo-heslar']=array(
          'name' => 'Typ hesláře',
          'type' => 'cis',
          'cis' => PROPRII);
      $this->X['heslo-do_vystupu']=array(
        'name' => 'Výstup',
        'type' => 'sel1',
        'search_field' => 'vystup');
      $this->X['heslo-stav']=array(
        'name' => 'Semafor',
        'type' => 'sel1',
        'search_field'=>'stav',
        'JOINs' => array(
              1 => array("tbl"=>"aktual_heslo_stav", "fk"=>"hid", "join"=>"LEFT")
          ));
      $this->X['heslo-lexikograficka_poznamka']=array(
        'name' => 'Lex. pozn.',
        'type' => 'tarea',
        'search_field'=>'lexgraf_pozn');
      $this->X['heslo-odbornik_poznamka']=array(
        'name' => 'Pozn. odb.',
        'type' => 'tarea',
        'search_field'=>'pozn_odbornik');
      $this->X['heslo-extPozn-text']=array(
        'name' => 'Ext. pozn.',
        'type' => 'tarea',
        'search_field'=>'poznamka',
        'JOINs'=>array(
          1 => array("tbl"=>"ext_poznamky_hes", "fk"=>"hid")
        ));
      $this->X['heslo-extPozn-type']=array(
        'name' => 'Typ ext. pozn.',
        'type' => 'cis',
        'cis' => TYP_EXT_POZN,
        'JOINs' => array(
          1 => array("tbl"=>$_CIS_VYBER[TYP_EXT_POZN][0], "fk"=>"hid", "join"=>"LEFT")
        ));
      $this->X['heslo-konec_zahlavi']=array(
        'name' => 'Posl. místo záhlaví',
        'type' => 'cis',
        'cis' => KONEC_ZAHLAVI,
        'JOINs' => array(
          1 => array("tbl"=>$_CIS_VYBER[KONEC_ZAHLAVI][0], "fk"=>"hid")
        ));
      $this->X['varianta-neo']=array(
        'name' => 'Neosémantismus',
        'type' => 'onoff',
        'search_field'=>'neosemantismus',
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid")
        ));
      $this->X['varianta-homonymie']=array(
        'name' => 'Homonymie',
        'type' => 'txtF',
        'search_field'=>'homonymie',
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid")
        ));
      $this->X['varianta-tvar']=array(
        'name' => 'Varianta',
        'type' => 'txtF',
        'search_field'=>'varianta',
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid")
        ));
      $this->X['varianta-komentar']=array(
        'name' => 'Var. kom. (před)',
        'type' => 'txt',
        'search_field'=>'komentar',
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid")
        ));
      $this->X['varianta-komentar_za']=array(
        'name' => 'Var. kom. (za)',
        'type' => 'txt',
        'search_field'=>'komentar_za',
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid")
        ));
      $this->X['varianta-podhesli-tvar']=array(
        'name' => 'Podheslí',
        'type' => 'txtF',
        'search_field'=>'varianta',
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid")
        ));
      $this->X['varianta-typ_hesla']=array(
        'name' => 'Typ hesla',
        'type' => 'cis',
        'cis' => TYP_HESLA,
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid"),
          2 => array("tbl"=>$_CIS_VYBER[TYP_HESLA][0], "fk"=>"vid", "join"=>"LEFT")
        ));
      $this->X['varianta-vyslovnost-tvar']=array(
        'name' => 'Výslovnost',
        'type' => 'txt',
        'search_field'=>'vyslovnost',
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid"),
          2 => array("tbl"=>"vyslovnost_var", "fk"=>"vid")
        ));
      $this->X['varianta-vyslovnost-komentar']=array(
        'name' => 'Výsl. kom.',
        'type' => 'txt',
        'search_field'=>'komentar',
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid"),
          2 => array("tbl"=>"vyslovnost_var", "fk"=>"vid")
         ));
      $this->X['varianta-komentar-tvaru']=array(
        'name' => 'Okomentované tvary',
        'type' => 'tarea',
        'search_field'=>'komentar_tvaru_bz',
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid")
        ));
      $this->X['varianta-slovnyDruh']=array(
        'name' => 'Slovní druh',
        'type' => 'cis',
        'cis' => SLOV_DRUHY,
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid"),
          2 => array("tbl"=>"var_slov_druhy_vyber_rel", "fk"=>"vid"),
          3 => array("tbl"=>"slov_druhy_vyber", "fk"=>"var_slov_druhy_vyber_rel_id")
        ));
      $this->X['varianta-slovny_druh-komentar']=array(
        'name' => 'Slovní druh kom.',
        'type' => 'txt',
        'search_field'=>'komentar',
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid"),
          2 => array("tbl"=>"var_slov_druhy_vyber_rel", "fk"=>"vid")
        ));
      $this->X['varianta-tvarChar']=array(
        'name' => 'Tvaroslovná char.',
        'type' => 'cis',
        'cis' => TVAR_CHAR,
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid"),
          2 => array("tbl"=>"var_tvar_char_vyber_rel", "fk"=>"vid"),
          3 => array("tbl"=>"tvar_char_vyber", "fk"=>"var_tvar_char_vyber_rel_id")
        ));
      $this->X['varianta-tvarChar-koncovka-tvar']=array(
        'name' => 'Tv. char. tvar',
        'type' => 'txt',
        'search_field'=>'koncovka',
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid"),
          2 => array("tbl"=>"var_tvar_char_vyber_rel", "fk"=>"vid"),
          3 => array("tbl"=>"koncovky_tvar_char", "fk"=>"var_tvar_char_rel_id")
        ));
      $this->X['varianta-tvarChar-koncovka-komentar']=array(
        'name' => 'Tv. char. tvar kom.',
        'type' => 'txt',
        'search_field'=>'komentar',
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid"),
          2 => array("tbl"=>"var_tvar_char_vyber_rel", "fk"=>"vid"),
          3 => array("tbl"=>"koncovky_tvar_char", "fk"=>"var_tvar_char_rel_id")
        ));
      $this->X['varianta-tvarCharSl']=array(
        'name' => 'Tv. char. slovesa',
        'type' => 'cis',
        'cis' => TVAR_CHAR_SL,
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid"),
          2 => array("tbl"=>"var_tvar_char_sl_vyber_rel", "fk"=>"vid"),
          3 => array("tbl"=>"tvar_char_sl_vyber", "fk"=>"var_tvar_char_sl_vyber_rel_id")
        ));
      $this->X['varianta-tvarCharSl-koncovka-tvar']=array(
        'name' => 'Tv. char. sl. tvar',
        'type' => 'txt',
        'search_field'=>'koncovka',
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid"),
          2 => array("tbl"=>"var_tvar_char_sl_vyber_rel", "fk"=>"vid"),
          3 => array("tbl"=>"koncovky_tvar_char_sl", "fk"=>"var_tvar_char_sl_rel_id")
        ));
      $this->X['varianta-tvarCharSl-koncovka-komentar']=array(
        'name' => 'Tv. char. sl. tvar kom.',
        'type' => 'txt',
        'search_field'=>'komentar',
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid"),
          2 => array("tbl"=>"var_tvar_char_sl_vyber_rel", "fk"=>"vid"),
          3 => array("tbl"=>"koncovky_tvar_char_sl", "fk"=>"var_tvar_char_sl_rel_id")
        ));
      $this->X['varianta-vazebnost-tvar']=array(
        'name' => 'Valence/vazebnost',
        'type' => 'txt',
        'search_field'=>'vazebnost',
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid"),
          2 => array("tbl"=>"vazebnost_var", "fk"=>"vid")
        ));
      $this->X['varianta-vazebnost-komentar']=array(
        'name' => 'Kom. k valenci/vazebnosti',
        'type' => 'txt',
        'search_field'=>'komentar',
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid"),
          2 => array("tbl"=>"vazebnost_var", "fk"=>"vid")
        ));
      $this->X['varianta-styl_kval']=array(
        'name' => 'Stylistický kvalifikátor',
        'type' => 'cis',
        'cis' => STYL_KVAL,
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid"),
          2 => array("tbl"=>$_CIS_VYBER[STYL_KVAL][0], "fk"=>"vid")
        ));
      $this->X['varianta-tematicke_okruhy']=array(
        'name' => 'Tematické okruhy',
        'type' => 'cis',
        'cis' => TEMATICKE_OKRUHY,
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid"),
          2 => array("tbl"=>$_CIS_VYBER[TEMATICKE_OKRUHY][0], "fk"=>"vid")
        ));
      $this->X['varianta-puvod']=array(
        'name' => 'Původ',
        'type' => 'cis',
        'cis' => PUVOD,
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid"),
          2 => array("tbl"=>$_CIS_VYBER[PUVOD][0], "fk"=>"vid")
        ));
      $this->X['varianta-obor_uziti']=array(
        'name' => 'Obor/oblast užití',
        'type' => 'cis',
        'cis' => OBOR_UZITI,
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid"),
          2 => array("tbl"=>$_CIS_VYBER[OBOR_UZITI][0], "fk"=>"vid")
        ));
      $this->X['varianta-gram_info']=array(
        'name' => 'Upřesňující gram. inf.',
        'type' => 'cis',
        'cis' => GRAM_INFO,
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid"),
          2 => array("tbl"=>$_CIS_VYBER[GRAM_INFO][0], "fk"=>"vid")
        ));
      $this->X['varianta-prvni_registr_vyskyt']=array(
        'name' => 'První reg. výskyt',
        'type' => 'txt',
        'search_field'=>'prvni_reg_vyskyt',
        'JOINs' => array(
          1 => array("tbl"=>'varianty', "fk"=>"hid")
        ));
      $this->X['podhesli-podhesli']=array(
        'name' => 'Podheslí významu',
        'type' => 'txtF',
        'search_field'=>'podhesli',
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>'podhesli_vyznamu', "fk"=>"vyz_id")
        ));
      $this->X['podhesli-komentar_podhesli_pred']=array(
        'name' => 'Podheslí kom. před',
        'type' => 'txt',
        'search_field'=>'komentar_pred',
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>'podhesli_vyznamu', "fk"=>"vyz_id")
        ));
       $this->X['podhesli-komentar_podhesli_za']=array(
        'name' => 'Podheslí kom. za',
        'type' => 'txt',
        'search_field'=>'komentar_za',
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>'podhesli_vyznamu', "fk"=>"vyz_id")
        ));
      $this->X['podhesli-gram_info'] = array(
        'name' => 'Upřesňující gram. inf.',
        'type' => 'cis',
        'search_field' => 'cis_id',
        'cis' => GRAM_INFO,
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>'podhesli_vyznamu', "fk"=>"vyz_id"),
          3 => array("tbl"=>'podh_vyz_gram_info', "fk"=>"podh_id")
        ));
      $this->X['vyznam-vazebnost-tvar']=array(
        'name' => 'Valence/vazebnost',
        'type' => 'txt',
        'search_field'=>'vazebnost',
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>"vazebnost_vyz", "fk"=>"vyz_id")
        ));
      $this->X['vyznam-vazebnost-komentar']=array(
        'name' => 'Kom. k valenci/vazebnosti',
        'type' => 'txt',
        'search_field'=>'komentar',
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>"vazebnost_vyz", "fk"=>"vyz_id")
        ));
      $this->X['vyznam-styl_kval']=array(
        'name' => 'Stylistický kvalifikátor',
        'type' => 'cis',
        'cis' => STYL_KVAL,
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>$_CIS_VYBER[STYL_KVAL][1], "fk"=>"vyz_id")
        ));
      $this->X['vyznam-tematicke_okruhy']=array(
        'name' => 'Tematické okruhy',
        'type' => 'cis',
        'cis' => TEMATICKE_OKRUHY,
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>$_CIS_VYBER[TEMATICKE_OKRUHY][1], "fk"=>"vyz_id")
        ));
      $this->X['vyznam-obor_uziti']=array(
        'name' => 'Obor/oblast užití',
        'type' => 'cis',
        'cis' => OBOR_UZITI,
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>$_CIS_VYBER[OBOR_UZITI][1], "fk"=>"vyz_id")
        ));
      $this->X['vyznam-gram_info']=array(
        'name' => 'Upřesňující gram. inf.',
        'type' => 'cis',
        'cis' => GRAM_INFO,
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>$_CIS_VYBER[GRAM_INFO][1], "fk"=>"vyz_id")
        ));
      $this->X['vyznam-slovnyDruh']=array(
        'name' => 'Slovní druh',
        'type' => 'cis',
        'cis' => SLOV_DRUHY,
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>"vyz_slov_druhy_vyber_rel", "fk"=>"vyz_id"),
          3 => array("tbl"=>"slov_druhy_vyber_vyz", "fk"=>"vyz_slov_druhy_vyber_rel_id")
        ));
      $this->X['vyznam-slovnyDruh-komentar']=array(
        'name' => 'Slovní druh kom.',
        'type' => 'txt',
        'search_field'=>'komentar',
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>"vyz_slov_druhy_vyber_rel", "fk"=>"vyz_id")
        ));
      $this->X['vyznam-tvarChar']=array(
        'name' => 'Tvaroslovná char.',
        'type' => 'cis',
        'cis' => TVAR_CHAR,
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>"vyz_tvar_char_vyber_rel", "fk"=>"vyz_id"),
          3 => array("tbl"=>"tvar_char_vyber_vyz", "fk"=>"vyz_tvar_char_vyber_rel_id")
        ));
      $this->X['vyznam-tvarChar-koncovka-tvar']=array(
        'name' => 'Tv. char. tvar',
        'type' => 'txt',
        'search_field'=>'koncovka',
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>"vyz_tvar_char_vyber_rel", "fk"=>"vyz_id"),
          3 => array("tbl"=>"koncovky_tvar_char_vyz", "fk"=>"vyz_tvar_char_rel_id")
        ));
      $this->X['vyznam-tvarChar-koncovka-komentar']=array(
        'name' => 'Tv. char. tvar kom.',
        'type' => 'txt',
        'search_field'=>'komentar',
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>"vyz_tvar_char_vyber_rel", "fk"=>"vyz_id"),
          3 => array("tbl"=>"koncovky_tvar_char_vyz", "fk"=>"vyz_tvar_char_rel_id")
        ));
      $this->X['vyznam-tvarCharSl']=array(
        'name' => 'Tv. char. slovesa',
        'type' => 'cis',
        'cis' => TVAR_CHAR_SL,
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>"vyz_tvar_char_sl_vyber_rel", "fk"=>"vyz_id"),
          3 => array("tbl"=>"tvar_char_sl_vyber_vyz", "fk"=>"vyz_tvar_char_sl_vyber_rel_id")
        ));
      $this->X['vyznam-tvarCharSl-koncovka-tvar']=array(
        'name' => 'Tv. char. sl. tvar',
        'type' => 'txt',
        'search_field'=>'koncovka',
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>"vyz_tvar_char_sl_vyber_rel", "fk"=>"vyz_id"),
          3 => array("tbl"=>"koncovky_tvar_char_sl_vyz", "fk"=>"vyz_tvar_char_sl_rel_id")
        ));
      $this->X['vyznam-tvarCharSl-koncovka-komentar']=array(
        'name' => 'Tv. char. sl. tvar kom.',
        'type' => 'txt',
        'search_field'=>'komentar',
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>"vyz_tvar_char_sl_vyber_rel", "fk"=>"vyz_id"),
          3 => array("tbl"=>"koncovky_tvar_char_sl_vyz", "fk"=>"vyz_tvar_char_sl_rel_id")
        ));
      $this->X['vyznam-predvyklad']=array(
        'name' => 'Začátek předvýkladu',
        'type' => 'txt',
        'search_field'=>'zacatek_predvykladu',
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid")
        ));
      $this->X['vyznam-predvyklad-vyraz']=array(
        'name' => 'Výraz předvýkladu',
        'type' => 'txt',
        'search_field'=>'vyraz',
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>'vyrazy_predvykladu', "fk"=>"vyz_id")
        ));
      $this->X['vyznam-predvyklad-komentar']=array(
        'name' => 'Kom. výrazu předvýkladu',
        'type' => 'txt',
        'search_field'=>'komentar',
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>'vyrazy_predvykladu', "fk"=>"vyz_id")
        ));
      $this->X['vyznam-predvyklad-konec']=array(
        'name' => 'Konec předvýkladu',
        'type' => 'txt',
        'search_field'=>'konec_predvykladu',
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid")
        ));
      $this->X['vyznam-metavyklad1']=array(
        'name' => 'Metavýklad 1',
        'type' => 'cis',
        'cis' => METAVYKLAD1,
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>$_CIS_VYBER[METAVYKLAD1][0], "fk"=>"vyz_id", "join"=>"LEFT")
        ));
      $this->X['vyznam-vyklad_vyznamu']=array(
        'name' => 'Výklad významu',
        'type' => 'tarea',
        'search_field'=>'vyklad_vyznamu_bz',
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid")
        ));
      $this->X['vyznam-metavyklad2']=array(
        'name' => 'Metavýklad 2',
        'type' => 'tarea',
        'search_field'=>'metavyklad2',
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid")
        ));
      $this->X['vyznam-synonymum-synonymum']=array(
        'name' => 'Synonymum',
        'type' => 'txtF',
        'search_field'=>'slave_str',
        'JOINs' => array(
          1 => array("tbl"=>'heslo', "fk"=>"id"),
          2 => array("tbl"=>"hesla_rel", "fk"=>"main_hid")
        ));
      $this->X['vyznam-synonymum-komentar']=array(
        'name' => 'Synonymum kom.',
        'type' => 'txt',
        'search_field'=>'komentar',
        'JOINs' => array(
          1 => array("tbl"=>'heslo', "fk"=>"id"),
          2 => array("tbl"=>"hesla_rel", "fk"=>"main_hid")
        ));
      $this->X['vyznam-antonymum-antonymum']=array(
        'name' => 'Antonymum',
        'type' => 'txtF',
        'search_field'=>'slave_str',
        'JOINs' => array(
          1 => array("tbl"=>'heslo', "fk"=>"id"),
          2 => array("tbl"=>"hesla_rel", "fk"=>"main_hid")
        ));
      $this->X['vyznam-antonymum-komentar']=array(
        'name' => 'Antonymum kom.',
        'type' => 'txt',
        'search_field'=>'komentar',
        'JOINs' => array(
          1 => array("tbl"=>'heslo', "fk"=>"id"),
          2 => array("tbl"=>"hesla_rel", "fk"=>"main_hid")
        ));
      $this->X['vyznam-exemplifikacia-text']=array(
        'name' => 'Exemplifikace',
        'type' => 'tarea',
        'search_field'=>'exemplifikace_bz',
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>"exemplifikace", "fk"=>"vyz_id")
        ));
      $this->X['vyznam-exemplifikacia-vystup']=array(
        'name' => 'Exempl. výstup',
        'type' => 'sel1',
        'search_field'=>'vystup',
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>"exemplifikace", "fk"=>"vyz_id")
        ));
      $this->X['vyznam-extPozn-text']=array(
        'name' => 'Externí poznámka',
        'type' => 'tarea',
        'search_field'=>'poznamka',
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>"ext_poznamky_vyz", "fk"=>"vyz_id")
        ));
      $this->X['vyznam-extPozn-type']=array(
        'name' => 'Typ ext. pozn.',
        'type' => 'cis',
        'cis' => TYP_EXT_POZN,
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid"),
          2 => array("tbl"=>$_CIS_VYBER[TYP_EXT_POZN][1], "fk"=>"vyz_id", "join"=>"LEFT")
        ));
      $this->X['vyznam-exist-subvyznam']=array(
        'name' => 'Podvýznam',
        'type' => 'onoff',
        'search_field'=>'pid',
        'JOINs' => array(
          1 => array("tbl"=>'vyznamy', "fk"=>"hid")
        ));
  }//f:_setup

  public static function get_filters($order_by='cts', $who=0, $typ=0){
    if(is_admin(get_logged_user()) && $typ==2)
    {
      $sql = "SELECT id, filter_name FROM xfilter WHERE uzivatel!=$who AND verejne=0 ORDER BY $order_by";
    }
    else
    {
      if($typ==0)
      {
        $sql = "SELECT id, filter_name FROM xfilter WHERE uzivatel=$who ORDER BY $order_by";
      }
      else if($typ==1)
      {
        $sql = "SELECT id, filter_name FROM xfilter WHERE verejne=1 AND (uzivatel!=$who OR uzivatel is NULL)   ORDER BY $order_by";
      }
    }
    if(!empty($sql))
    {
      return db_get_val_arr($sql, array('id'=>'filter_name'));
    }
    return array();
  }

  public static function filter_exists($filter_id){
    return get_db_values('xfilter', 'id', $filter_id)!='';
  }

  public static function get_info($filter_id){
    $sql = "SELECT * FROM xfilter WHERE id=$filter_id";
    $res = dbq($sql);
    return mysql_fetch_assoc($res);
  }

  private function parse_cis_selection($str_cis_sel, $only_ids=false){
    //ids - true=get only ids
    $cis_vals = array();
    $cis_val_pairs = explode("|", $str_cis_sel);
    foreach($cis_val_pairs as $cis_val_pair){
      $_cisVal = explode("::", $cis_val_pair);
      if($only_ids){
       $cis_vals[] = $_cisVal[0];
       if($_cisVal[0]=='jine') $cis_vals['jine'] = $_cisVal[1];
      }else{
       $cis_vals[$_cisVal[0]] = $_cisVal[1];
      }
    }
    return $cis_vals;
  }

  private function cis_vals2str($cis_sel, $cis){
    global $_CIS_TBL, $_CIS_VAL_COL;
    if(empty($cis_sel)) return "";
    $cis_vals = array();
    if(in_array('jine', $cis_sel))
    {
      $hodnota_jine = trim($cis_sel['jine']);
    }
    unset($cis_sel['jine']);
    foreach($cis_sel as $i => $cis_id)
    {
      if($cis_id == 'jine')
      {
       $cis_vals['jine'] = $hodnota_jine;
      }
      else
      {
       $cis_vals[$cis_id] = get_db_values($_CIS_TBL[$cis], $_CIS_VAL_COL[$cis], $cis_id);
      }
    }
    $cis_vals_paired = array();
    foreach($cis_vals as $val_id => $val)
    {
      $cis_vals_paired[] = $val_id."::".$val;
    }
    return implode("|", $cis_vals_paired);
  }

  private function print_cis_select($field_id, $alt_num, $sel=array()){
    $cis_vals = get_hodnoty_ciselniku($this->X[$field_id]['cis']);
    if(empty($cis_vals)) return "Chyba! [ciselnik bez hodnot]";
    $html ="";
    $html.="<select name='filter_alternatives[$alt_num][".$field_id."][field_val][]' class='w100' multiple>";
    foreach($cis_vals as $cis_id => $cis_val){
      $selected = ""; if(in_array($cis_id, $sel)) $selected = "selected='selected'";
      $cis_val = text_html_preprocess($cis_val);
      $html.="<option value='$cis_id' $selected>$cis_val</option>";
    }
    $jine = ""; if(isset($sel['jine'])) $jine = $sel['jine'];
    $html.="</select>";
    $html.="<br />";
    if(!in_array($field_id, array('heslo-zpracovatel', 'heslo-heslar', 'heslo-extPozn-type', 'vyznam-extPozn-type'))){
     $html.="<input type='text' name='filter_alternatives[$alt_num][".$field_id."][field_val][jine]' value='$jine' placeholder='jiné' style='width:95%' />";
    }
    return $html;
  }

  private function get_field_opts($field){
    switch($field){
      case 'vyznam-exemplifikacia-vystup':
      case 'heslo-do_vystupu':
        global $_VYSTUP_PRO_FILTR;
        $_opts = $_VYSTUP_PRO_FILTR;
        break;
      case 'heslo-stav':
        global $_STAV_HESLA_SEMAFOR;
        $_opts = $_STAV_HESLA_SEMAFOR;
        break;
    }
    return $_opts;
  }

  private function print_select_one($field_id, $alt_num, $value=0){
    $html="";
    $_opts = $this->get_field_opts($field_id);
    $html.="<select name='filter_alternatives[$alt_num][".$field_id."][field_val]'>";
    foreach($_opts as $id => $label)
    {
      $selected=""; if($id == $value) $selected = "selected";
      $html.="<option value='$id' $selected>$label</option>";
    }
    $html.="</select>";
    return $html;
  }


  private function print_field_set($field_id, $alt_num, $filter_id=0, $tpl=''){
    global $_REL;

    $active_val = false;
    $relation_val = 1;
    $negation_val = false;
    $cs_val= false;
    $field_val = "";

    if($filter_id>0){
      $sql = "SELECT field_val, relation, negation, cs
              FROM xfilter_alternatives_vals
              WHERE filter_id=$filter_id AND alternative=$alt_num AND field_id='$field_id'";
      $res = dbq($sql);
      $rec = mysql_fetch_assoc($res);

      if(mysql_num_rows($res)>0) $active_val = true;
      $relation_val = $rec['relation'];
      if($rec['negation']>0) $negation_val = true;
      if($rec['cs'] > 0) $cs_val = true;
      $field_val = text_html_preprocess($rec['field_val']);
    }

      $html="";
    //var_dump($this->X);
    switch($this->X[$field_id]['type']){
      case 'date':
        if($tpl==''){
          $tpl="
           <tr>
            <td>%active%</td>
            <td><label><b>%label%</b></label></td>
            <td>%negation%</td>
            <td></td>
            <td>od:<br />do:</td>
            <td>%from%<br />%to%</td>

           </tr>";
        }
        $label = $this->X[$field_id]['name'];
        $id = $this->X[$field_id]['id'];
        $active = "<input type='checkbox' title='Zahrnout pole do vyhledávání' name='filter_alternatives[$alt_num][".$field_id."][active]' value='1' ".(($active_val)?"checked":"")." />";
        $negation = "<label><abbr title='Negace'>N:</abbr><br /><input type='checkbox' title='Negace' name='filter_alternatives[$alt_num][".$field_id."][negation]' value='1' ".(($negation_val)?"checked":"")." /></label>";
        $fv= explode('|', $field_val);
        $from="<input id='date_filter_from_".$id."' style='width:95%; margin: 0;' type='text' name='filter_alternatives[$alt_num][".$field_id."][field_val_from]' value='$fv[0]' size='9' />";
        $to="<input id='date_filter_to_".$id."'  style='width:95%; margin: 0; margin-top: 3px; margin-bottom: 6px;' type='text' name='filter_alternatives[$alt_num][".$field_id."][field_val_to]".$id."' value='$fv[1]' size='9' /> ";
        $search = array('%label%','%active%' ,'%negation%', '%from%', '%to%');
        $replace = array($label, $active, $negation, $from, $to);
        $html = str_replace($search, $replace, $tpl);
        break;
      case 'txt':
        if($tpl==''){
          $tpl="
           <tr>
            <td>%active%</td>
            <td><label><b>%label%</b></label></td>
            <td>%negation%</td>
            <td>%cs%</td>
            <td>%relation%</td>
            <td>%field%</td>
           </tr>";
        }
        $label = $this->X[$field_id]['name'];
        $active = "<input type='checkbox' title='Zahrnout pole do vyhledávání' name='filter_alternatives[$alt_num][".$field_id."][active]' value='1' ".(($active_val)?"checked":"")." />";
        $negation = "<label><abbr title='Negace'>N</abbr><br /><input type='checkbox' title='Negace' name='filter_alternatives[$alt_num][".$field_id."][negation]' value='1' ".(($negation_val)?"checked":"")." /></label>";
        $field = "<input type='text' style='width:95%' name='filter_alternatives[$alt_num][".$field_id."][field_val]' value='$field_val' />";
        $cs = "<label><abbr title='Rozlišovat velikost'>aA</abbr><br /><input type='checkbox' title='Rozlišovat velikost' name='filter_alternatives[$alt_num][".$field_id."][cs]' value='1'".(($cs_val)?"checked":"")." /></label>";
        $relation = "
          <select name='filter_alternatives[$alt_num][".$field_id."][relation]' style='display:none'>
           <option value=".REL_EQ." ".(($relation_val==REL_EQ)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_EQ])."</option>
           <option value=".REL_LT." ".(($relation_val==REL_LT)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_LT])."</option>
           <option value=".REL_GT." ".(($relation_val==REL_GT)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_GT])."</option>
           <option value=".REL_LTE." ".(($relation_val==REL_LTE)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_LTE])."</option>
           <option value=".REL_GTE." ".(($relation_val==REL_GTE)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_GTE])."</option>
           <option value=".REL_NE." ".(($relation_val==REL_NE)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_NE])."</option>
           </select>
        ";
        $search = array('%label%','%active%', '%relation%', '%negation%', '%field%', '%cs%');
        $replace = array($label, $active, $relation, $negation, $field, $cs);
        $html = str_replace($search, $replace, $tpl);
        break;
      case 'txtF':
        if($tpl==''){
          $tpl="
           <tr>
            <td>%active%</td>
            <td><label><b>%label%</b></label></td>
            <td>%negation%</td>
            <td>%cs%</td>
            <td>%relation%</td>
            <td>%field%%field2%</td>
           </tr> ";
        }
        $hidenclass=($relation_val==REL_USEK)?"":"display:none";
          $sirka=($relation_val==REL_USEK)?"86%":"95%";
          $field_val=explode("###",$field_val);
        $label = $this->X[$field_id]['name'];
        $active = "<input type='checkbox' title='Zahrnout pole do vyhledávání' name='filter_alternatives[$alt_num][".$field_id."][active]' value='1' ".(($active_val)?"checked":"")." />";
        $negation = "<label><abbr title='Negace'>N</abbr><br /><input type='checkbox' title='Negace' name='filter_alternatives[$alt_num][".$field_id."][negation]' value='1' ".(($negation_val)?"checked":"")." /></label>";
        $field = "<label class='druhy_usek' style='$hidenclass' >od:</label><input class='prvni_usek' type='text' style='width:$sirka' name='filter_alternatives[$alt_num][".$field_id."][field_val]' value='$field_val[0]' />";
        $field2= "<label class='druhy_usek' style='$hidenclass' >do:</label><input class='druhy_usek' type='text' style='width:85%; $hidenclass' name='filter_alternatives[$alt_num][".$field_id."][field_val_2]' value='$field_val[1]' />";
        $cs = "<label><abbr title='Rozlišovat velikost'>aA</abbr><br /><input type='checkbox' title='Rozlišovat velikost' name='filter_alternatives[$alt_num][".$field_id."][cs]' value='1' ".(($cs_val)?"checked":"")." /></label>";
        $relation = "
          <select class='select_text' name='filter_alternatives[$alt_num][".$field_id."][relation]'>
           <option value=".REL_EQ." ".(($relation_val==REL_EQ)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_EQ])."</option>
           <option value=".REL_LT." ".(($relation_val==REL_LT)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_LT])."</option>
           <option value=".REL_GT." ".(($relation_val==REL_GT)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_GT])."</option>
           <option value=".REL_LTE." ".(($relation_val==REL_LTE)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_LTE])."</option>
           <option value=".REL_GTE." ".(($relation_val==REL_GTE)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_GTE])."</option>
            <option value=".REL_USEK." ".(($relation_val==REL_USEK)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_USEK])."</option>
           </select>
        ";
        $search = array('%label%','%active%', '%relation%', '%negation%', '%field%', '%cs%', '%field2%');
        $replace = array($label, $active, $relation, $negation, $field, $cs, $field2);
        $html = str_replace($search, $replace, $tpl);
        break;
      case 'tarea':
        if($tpl==''){
          $tpl="

            <tr>
              <td>%active%</td>
              <td><label><b>%label%</b></label></td>
              <td>%negation%</td>
              <td>%cs%</td>
              <td>%relation%</td>
              <td>%field%</td>
            </tr>
          ";
        }
        $label = $this->X[$field_id]['name'];
        $active = "<input type='checkbox' title='Zahrnout pole do vyhledávání' name='filter_alternatives[$alt_num][".$field_id."][active]' value='1' ".(($active_val)?"checked":"")." />";
        $negation = "<label><abbr title='Negace'>N</abbr><br /><input type='checkbox' title='Negace' name='filter_alternatives[$alt_num][".$field_id."][negation]' value='1' ".(($negation_val)?"checked":"")." /></label>";
        $field = "<textarea name='filter_alternatives[$alt_num][".$field_id."][field_val]' class='floatLeft'>$field_val</textarea>";
        $cs = "<label><abbr title='Rozlišovat velikost'>aA</abbr><br /><input type='checkbox' title='Rozlišovat velikost' name='filter_alternatives[$alt_num][".$field_id."][cs]' value='1' ".(($cs_val)?"checked":"")."/></label>";
        $relation = "
          <select name='filter_alternatives[$alt_num][".$field_id."][relation]'  style='display:none'>
           <option value=".REL_EQ." ".(($relation_val==REL_EQ)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_EQ])."</option>
           <option value=".REL_NE." ".(($relation_val==REL_NE)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_NE])."</option>
           </select>
        ";
         /*<option value=".REL_LT." ".(($relation_val==REL_LT)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_LT])."</option>
           <option value=".REL_GT." ".(($relation_val==REL_GT)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_GT])."</option>
           <option value=".REL_LTE." ".(($relation_val==REL_LTE)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_LTE])."</option>
           <option value=".REL_GTE." ".(($relation_val==REL_GTE)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_GTE])."</option>
          */
        $search = array('%label%','%active%', '%relation%', '%negation%', '%field%', '%cs%');
        $replace = array($label, $active, $relation, $negation, $field, $cs);
        $html = str_replace($search, $replace, $tpl);
        break;
      case 'cis':
        if($tpl==''){
          $tpl="
            <tr>
              <td><div>%active%</div></td>
              <td><label><b>%label%</b></label></td>
              <td>%negation%</td>
              <td></td>
              <td>%relation%</td>
              <td>%field%</td>
            </tr>
           ";
        }

        $cis_sel_arr = $this->parse_cis_selection($field_val, true); //true: only IDs

        $label = $this->X[$field_id]['name'];
        $active = "<input type='checkbox' title='Zahrnout pole do vyhledávání' name='filter_alternatives[$alt_num][".$field_id."][active]' value='1' ".(($active_val)?"checked":"")." />";
        $negation = "<label><abbr title='Negace'>N</abbr><br /><input type='checkbox' title='Negace' name='filter_alternatives[$alt_num][".$field_id."][negation]' value='1' ".(($negation_val)?"checked":"")." /></label>";
        $field = $this->print_cis_select($field_id, $alt_num, $cis_sel_arr);
        /*$relation = "
          <select name='filter_alternatives[$alt_num][".$field_id."][relation]'>
           <option value=".REL_EQ." ".(($relation_val==REL_EQ)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_EQ])."</option>
           <option value=".REL_NE." ".(($relation_val==REL_NE)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_NE])."</option>
          </select>
        ";*/
        $relation = "
          <select name='filter_alternatives[$alt_num][".$field_id."][relation]' style='display:none'>
           <option value=".REL_EQ." ".(($relation_val==REL_EQ)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_EQ])."</option>
           <option value=".REL_NE." ".(($relation_val==REL_NE)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_NE])."</option>
          </select>
        ";
        $search = array('%label%','%active%', '%relation%', '%negation%', '%field%');
        $replace = array($label, $active, $relation, $negation, $field);
        $html = str_replace($search, $replace, $tpl);

        break;
      case 'sel1':
        if($tpl==''){
          $tpl="
           <tr>
            <td>%active%</td>
            <td><label><b>%label%</b></label></td>
            <td>%negation%</td>
            <td></td>
            <td>%relation%</td>
            <td>%field%</td>
           </tr>";
        }
        $label = $this->X[$field_id]['name'];
        $active = "<input type='checkbox' title='Zahrnout pole do vyhledávání' name='filter_alternatives[$alt_num][".$field_id."][active]' value='1' ".(($active_val)?"checked":"")." />";
        $negation = "<label><abbr title='Negace'>N</abbr><br /><input type='checkbox' name='filter_alternatives[$alt_num][".$field_id."][negation]' value='1' ".(($negation_val)?"checked":"")." /></label>";
        $field = $this->print_select_one($field_id, $alt_num, $field_val);
        $relation = "
          <select name='filter_alternatives[$alt_num][".$field_id."][relation]'  style='display:none'>
           <option value=".REL_EQ." ".(($relation_val==REL_EQ)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_EQ])."</option>
           <option value=".REL_NE." ".(($relation_val==REL_NE)?"selected='selected'":"").">".text_html_preprocess($_REL[REL_NE])."</option>
          </select>
        ";
        $search = array('%label%','%active%', '%relation%', '%negation%', '%field%');
        $replace = array($label, $active, $relation, $negation, $field);
        $html = str_replace($search, $replace, $tpl);
        break;
      case 'onoff' or 'onoffK' or 'onoffSpec':
        if($tpl==''){
          $tpl="
           <tr>
            <td>%active%</td>
            <td><label><b>%label%</b></label></td>
            <td colspan='4'>%field%</td>
           </tr>";
        }
        $checked = ""; if(is_numeric($field_val) && $field_val>0) $checked = "checked";
        $label = $this->X[$field_id]['name'];
        $active = "<input type='checkbox' title='Zahrnout pole do vyhledávání' name='filter_alternatives[$alt_num][".$field_id."][active]' value='1' ".(($active_val)?"checked":"")." />";
        $field = "<label><abbr title='Negace'>N</abbr><br /><input type='checkbox' name='filter_alternatives[$alt_num][".$field_id."][field_val]' value='1' $checked /></label>";
        $search = array('%label%','%active%', '%field%');
        $replace = array($label, $active, $field);
        $html = str_replace($search, $replace, $tpl);
        break;
    }
    return $html;
  }

  private function print_form_fields($filter_id, $alt_num){
    $active_alt_cls = ""; if($alt_num==1) $active_alt_cls = "activeAlt";
    $html="";

    $html.="<div id='filterAlt-$alt_num' data-altnum='$alt_num' class='filterAlt $active_alt_cls'>";
    $html.="<div class='panel_top'>";
    $html.="<div class='header'>speciální</div>";
      $html.="<div class='panel_top'>";
      $html.="<table class='filterTable'>";
    $html.=$this->print_field_set('heslo-pripojeno', $alt_num, $filter_id);
      $html.="</table>";
    $html.="</div><div class='header'>heslo</div>";
    $html.="<div class='panel_top_l'>";
    $html.="<table class='filterTable'>";
    $html.=$this->print_field_set('heslo-do_vystupu', $alt_num, $filter_id);
    $html.=$this->print_field_set('heslo-stav', $alt_num, $filter_id);
    $html.=$this->print_field_set('heslo-zpracovatel', $alt_num, $filter_id);
    //$html.=$this->print_field_set('heslo-heslar', $alt_num, $filter_id);

    $html.=$this->print_field_set('heslo-lexikograficka_poznamka', $alt_num, $filter_id);
    $html.="</table>";
    $html.="</div>";

    $html.="<div class='panel_top_r'>";
    $html.="<table class='filterTable'>";
    $html.=$this->print_field_set('heslo-odbornik_poznamka', $alt_num, $filter_id);
    $html.=$this->print_field_set('heslo-vytvořeno', $alt_num, $filter_id);
    $html.=$this->print_field_set('heslo-změněno', $alt_num, $filter_id);
    $html.=$this->print_field_set('heslo-korektura', $alt_num, $filter_id);
    $html.=$this->print_field_set('heslo-konec_zahlavi', $alt_num, $filter_id);
    $html.="</table>";
    $html.="</div>";
    $html.="</div>";

    $html.="<div class='panel'>";
    $html.="<div class='header'>varianta</div>";
    $html.="<div class='body'>";
    $html.="<table class='filterTable'>";
    $html.=$this->print_field_set('varianta-neo', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-homonymie', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-tvar', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-komentar', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-komentar_za', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-podhesli-tvar', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-typ_hesla', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-vyslovnost-tvar', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-vyslovnost-komentar', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-komentar-tvaru', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-vyslovnost-komentar', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-slovnyDruh', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-slovny_druh-komentar', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-tvarChar', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-tvarChar-koncovka-tvar', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-tvarChar-koncovka-komentar', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-tvarCharSl', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-tvarCharSl-koncovka-tvar', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-tvarCharSl-koncovka-komentar', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-vazebnost-tvar', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-vazebnost-komentar', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-styl_kval', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-gram_info', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-tematicke_okruhy', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-puvod', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-obor_uziti', $alt_num, $filter_id);
    $html.=$this->print_field_set('varianta-prvni_registr_vyskyt', $alt_num, $filter_id);
    $html.=$this->print_field_set('heslo-extPozn-text', $alt_num, $filter_id);
    $html.=$this->print_field_set('heslo-extPozn-type', $alt_num, $filter_id);
    $html.="</table>";
    $html.="</div>";
    $html.="</div>";

    $html.="<div class='panelr'>";
    $html.="<div class='header'>význam</div>";
    $html.="<div class='body'>";
    $html.="<table class='filterTable'>";
    $html.=$this->print_field_set('vyznam-vazebnost-tvar', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-vazebnost-komentar', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-styl_kval', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-tematicke_okruhy', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-obor_uziti', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-gram_info', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-slovnyDruh', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-slovnyDruh-komentar', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-tvarChar', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-tvarChar-koncovka-tvar', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-tvarChar-koncovka-komentar', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-tvarCharSl', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-tvarCharSl-koncovka-tvar', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-tvarCharSl-koncovka-komentar', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-predvyklad', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-predvyklad-vyraz', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-predvyklad-komentar', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-predvyklad-konec', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-metavyklad1', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-vyklad_vyznamu', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-metavyklad2', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-synonymum-synonymum', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-synonymum-komentar', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-antonymum-antonymum', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-antonymum-komentar', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-exemplifikacia-text', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-exemplifikacia-vystup', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-extPozn-text', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-extPozn-type', $alt_num, $filter_id);
    $html.=$this->print_field_set('vyznam-exist-subvyznam', $alt_num, $filter_id);
    $html.="</table>";
    $html.="</div>";
    $html.="</div>";

    $html.="<div class='panel_bottom'>";
    $html.="<div class='header'>podheslí významu</div>";
    $html.="<table class='filterTable'>";
    $html.=$this->print_field_set('podhesli-podhesli', $alt_num, $filter_id);
    $html.=$this->print_field_set('podhesli-komentar_podhesli_pred', $alt_num, $filter_id);
    $html.=$this->print_field_set('podhesli-komentar_podhesli_za', $alt_num, $filter_id);
    $html.=$this->print_field_set('podhesli-gram_info', $alt_num, $filter_id);
    $html.="</table>";

    $html.="<div class='panel_top_l'>";
    $html.="</div>";

    $html.="<div class='panel_top_r'>";
    $html.="</div>";


    $html.="</div>";



    $html.="<div class='clear'></div>";

    $html.="</div>";
    return $html;
  }

  public static function selector($field_name='xFilter_id', $filter_id=0)
  {
   $who = get_logged_user();
   $filters = self::get_filters('filter_name', $who);
    $html_fltr_sel= "";
   $html_fltr_sel.= "<select name='$field_name'>";
   $html_fltr_sel.= "<option value='0'>-- Prázdný filtr --</option>";
   $html_fltr_sel.= "<optgroup label='Vlastní'>";
   foreach($filters as $_filter_id => $filter_name){
     $sel = ""; if($_filter_id==$filter_id) $sel = "selected='selected'";
     $html_fltr_sel.= "<option value='$_filter_id' $sel>$filter_name</option>";
   }
   $filters = self::get_filters('filter_name', $who, 1);
   $html_fltr_sel.= "<optgroup label='Veřejné'>";
   foreach($filters as $_filter_id => $filter_name){
     $sel = ""; if($_filter_id==$filter_id) $sel = "selected='selected'";
     $html_fltr_sel.= "<option value='$_filter_id' $sel>$filter_name</option>";
   }
   if(is_admin($who))
   {
     $filters = self::get_filters('filter_name', $who, 2);
     $html_fltr_sel.= "<optgroup label='Ostatní'>";
     foreach($filters as $_filter_id => $filter_name){
       $sel = ""; if($_filter_id==$filter_id) $sel = "selected='selected'";
       $html_fltr_sel.= "<option value='$_filter_id' $sel>$filter_name</option>";
     }
   }
  /* $filters = self::get_filters('filter_name');
   foreach($filters as $_filter_id => $filter_name){
     $sel = ""; if($_filter_id==$filter_id) $sel = "selected='selected'";
     $html_fltr_sel.= "<option value='$_filter_id' $sel>$filter_name</option>";
   }                */
   $html_fltr_sel.= "</select>";
   return $html_fltr_sel;
  }

  public function print_main_form($filter_id=0){
   if($filter_id>0 && !xFilter::filter_exists($_GET['fltrid']))
   {
    $filter_id=0;
   }

   $html_fltr_sel = "";
   $html_fltr_sel.= "<form id='filterSelectorForm' method='post' action='#'>";
   $html_fltr_sel.= self::selector('filter_id', $filter_id);
   $html_fltr_sel.= "<input type='hidden' name='act' value='load_filter' />";
   $html_fltr_sel.= "<input type='submit' name='' value='Načíst' class='hmargin' />";
   $html_fltr_sel.= "</form>";

   $filter_name = "";
   $filter_desc = "";
   if($filter_id>0){
    $fi = self::get_info($filter_id);
    $filter_name = $fi['filter_name'];
    $filter_desc = $fi['filter_desc'];
    $uzivatel = $fi['uzivatel'];
    $verejny = $fi['verejne'];
   }
   else
   {
    $uzivatel =  get_logged_user();
    $verejny = 0;
   }
   $html="";
   $html.="<h2 class='floatLeft'>xFiltr</h2>";

   //vyber filtru
   $html.="<div class='floatLeft' style='margin-left: 30px; line-height: 30px'>";
   $html.=$html_fltr_sel;
   $html.="</div>";
   $html.="<p class='clear'>&nbsp;</p>";

   $html.="<form id='mainFilterForm' method='post'>";
   $html.="<input type='hidden' name='act' value='' />";
   $html.="<input type='hidden' name='filter_id' value='$filter_id' />";
   $html.="<input type='hidden' name='uzivatel' value='$uzivatel' />";
   $html.="<div class='mainFilterContainer box orangeBox'>"; //kontainer

    //hlavicka filtru
    $html.="<div class='header'>";
    $html.="<table class='w100'><tr>";
    $html.="<th style='width:34px;' valign='top'>Filtr:</th><td style='width:200px;'><input type='text' name='filter_name' value='$filter_name' class='w100' /></td>";
    $html.="<th style='width:10px;' valign='top'></th>";
    $html.="<th style='width:40px;' valign='top'>Popis:</th><td><input type='text' name='filter_desc' value='$filter_desc' class='w100' /></td>";
    if($verejny==0)
      $html.= "<th/><td style='width:14px;'><input type='checkbox' name='vazat'/></td>";
    else
      $html.= "<th/><td style='width:14px;'><input type='checkbox' checked   name='vazat' /></td>";
    $html.= "<th style='width:150px;'><div  class='w100'>Zpřístupnit filtr ostatním zpracovatelům</div></th>";
    $html.="</tr></table>";
    $html.="</div>";
    $abeceda=array("A","B","C","D","E","F","G","H","I","J","K","L","M");
    //subformulare filtru  (subformulare jednotlivych typov maju kazdy svoju defaultnu sablonu, ale parametrom sa da zmenit)
    $html.="<div class='body'>";
    $html_tabs = ""; $html_form_fields = "";

      $vazby=array();
      if($filter_id>0) {
          $sql = "SELECT field_val
              FROM xfilter_alternatives_vals
              WHERE filter_id=$filter_id AND field_id='vazba' ORDER BY alternative ASC";
          $res = dbq($sql);
          while($rec = mysql_fetch_assoc($res)) {
              $vazby[]=$rec['field_val'];
          }
      }
    for($i = 1; $i <= self::ALT_NUM; $i++) {
        $active_alt_tab_cls = "";
        if ($i == 1) $active_alt_tab_cls = "activeAltTab";
        $html_tabs .= "<div id='filterAltTab-$i' data-altnum='$i' class='filterAltTab floatLeft clickable $active_alt_tab_cls'>" . $abeceda[$i - 1] . "</div>";
        if ($i<self::ALT_NUM){
            $con_tab_type = "nebo";
            if (isset($vazby[$i-1])&&$vazby[$i-1]=="a") $con_tab_type = "a";
            $html_tabs.="<div id='filterAltCon-$i'  data-connum='$i'  class='filterAltCon floatLeft clickable'>$con_tab_type</div>";
            $html_tabs.="<input type='hidden' id='filterAltConHid-$i'  name='filterAltCon[]' value='$con_tab_type'/>";
        }
        $html_form_fields.=$this->print_form_fields($filter_id, $i);
    }
    $html.="<div id='filterAltTabsContainer' style='margin-bottom: 20px'>$html_tabs<div class='clear'></div></div>";
    $html.="<div id='filterAltFormsContainer'>$html_form_fields</div>";
    $html.="</div>";

   $html.="</div>"; // mainFilterContainer/orangeBox

   $typ_tlacitka=($filter_id==0)?"hidden":"button";
   //tlacitka
   $html.="
    <div style='margin-top: 20px;' class='floatRight'>
     <input id='buttSaveFilter' type='button' name='save_filter' value='Uložit' class='buttBox blueButtBox' />
     <input id='buttSaveFilterAsNew' type='button' name='save_filter_as_new' value='Uložit jako nový' class='buttBox orangeButtBox' />
     <input id='buttRemoveFilter' type=$typ_tlacitka name='remove_filter' value='Odstranit filtr' class='buttBox redButtBox' data-filter_name='$filter_name' />
     <input id='buttClearFilter' type='button' value='Vymazat formulář' class='buttBox' />
    </div>";

   $html.="</form>";

   return $html;
  }

  public function save($data, $novy=true){
    $filter_id = $data['filter_id'];
    if($data['act']=='save_filter_as_new' || $filter_id<1) $filter_id = 0;
    if(!is_numeric($filter_id)) return false;
    $edit = $filter_id > 0;

    //save filter
    $d = array();
    $d['filter_name'] = "'".text_db_preprocess(trim($data['filter_name']))."'";
    $d['filter_desc'] = "'".text_db_preprocess(trim($data['filter_desc']))."'";
    $d['uzivatel']=(empty($data['uzivatel'])) ? get_logged_user() : $data['uzivatel'];
    if(is_null($data['vazat']))
    {
      $d['verejne']=0;
      $result = dibi::query('SELECT COUNT(*) FROM xfilter WHERE filter_name=%s AND (uzivatel=%i OR uzivatel is NULL)',$data['filter_name'],$d['uzivatel']);
    }
    else
    {
      $d['verejne']=1;
      $result = dibi::query('SELECT COUNT(*) FROM xfilter WHERE filter_name=%s',$data['filter_name']);
    }
    $value = $result->fetchSingle();
    if($value!=0 && $novy)
    {
      return -1;
    }
    $filter_id = sql_w('xfilter', $d, $filter_id);
    //var_dump($filter_id); var_dump($d);die();

    //ak ide o editaciu, povodne polozky vymazem
    if($edit){
      $sql = "DELETE FROM xfilter_alternatives_vals WHERE filter_id = $filter_id";
      dbq($sql);
    }

      foreach($data['filterAltCon'] as $alt_num => $value){
          $d = array();
          $d['filter_id'] = $filter_id;
          $d['alternative'] = $alt_num;
          $d['field_id'] = "'vazba'";
          $d['relation'] = REL_EQ;
          $d['field_val'] = "'".text_db_preprocess(trim($value))."'";
          sql_w('xfilter_alternatives_vals', $d);
      }

    foreach($data['filter_alternatives'] as $alt_num => $fields){
      foreach($fields as $field_id => $field_atts){
         if(!isset($field_atts['active']) || $field_atts['active']!='1') continue;

         $relation = REL_EQ; if(isset($field_atts['relation']) && is_numeric($field_atts['relation'])) $relation = $field_atts['relation'];
         $negation = 0; if(isset($field_atts['negation'])) $negation = 1;
         $cs = 0; if(isset($field_atts['cs'])) $cs = 1;

         $d = array();
         $d['filter_id'] = $filter_id;
         $d['alternative'] = $alt_num;
         $d['field_id'] = "'".$field_id."'";

         //txt | tarea | cis | sel1 | onoff
         switch($this->X[$field_id]['type']){
          case 'date':
           $d['relation'] = $relation;
           if($field_atts['field_val_to']!="")
           {
            $d['field_val']="'".$field_atts['field_val_from']."|".$field_atts['field_val_to']."'";
           }
           else
           {
            $d['field_val']="'".$field_atts['field_val_from']."|NOW'";
           }
           break;
          case 'txt':
          case 'txtF':
          case 'tarea':
           $d['relation' ]= $relation;
           $d['negation'] = $negation;
           if($relation==9){
               $d['field_val'] = "'".text_db_preprocess(trim($field_atts['field_val']))."###".text_db_preprocess(trim($field_atts['field_val_2']))."'";
           }else{
               $d['field_val'] = "'".text_db_preprocess(trim($field_atts['field_val']))."'";
           }
           $d['cs'] = $cs;
           break;
          case 'cis':
           $cis_str = $this->cis_vals2str($field_atts['field_val'], $this->X[$field_id]['cis']);
           $d['relation'] = $relation;
           $d['negation'] = $negation;
           $d['field_val'] = "'".$cis_str."'";
           break;
          case 'sel1':
           $d['relation'] = $relation;
           $d['negation'] = $negation;
           $d['field_val'] = text_db_preprocess(trim($field_atts['field_val']));
           break;
          case 'onoff' or 'onoffK' or 'onoffSpec':
           $d['relation'] = REL_EQ;
           $d['field_val'] = 0; if(isset($field_atts['field_val'])) $d['field_val'] = 1;
           break;
         }
         if($this->X[$field_id]['type']=='cis' && $cis_str=="")
         {
            err("Nebyla zvolena hodnota z výběru pro pole ".$this->X[$field_id]['name']);
            continue;
         }
         sql_w('xfilter_alternatives_vals', $d);
      }
    }
    return $filter_id;
  }

  public function remove($filter_id){
    if(!is_numeric($filter_id)) return false;
    $sql = "DELETE FROM xfilter_alternatives_vals WHERE filter_id=$filter_id"; dbq($sql);
    $sql = "DELETE FROM xfilter WHERE id=$filter_id"; dbq($sql);
  }

  private function get_joins($field_id){
    if(!array_key_exists($field_id, $this->X)) return false;
    /*********** P A T T E R N ***************

      SELECT distinct h.id as hid
      FROM heslo h
        INNER JOIN A1 a1 ON a1.FK = h.id  -- > varianta|vyznam
        INNER JOIN A2 a2 ON a2.FK = a1.id
      WHERE a2.B LIKE "%o%"

     ******************************************/
    $JOIN_tbls = $this->X[$field_id]['JOINs'];
    //var_dump($JOIN_tbls);
    $joins = array();
    if(!empty($JOIN_tbls))
      foreach($JOIN_tbls as $k => $tblAndFk){
        $pTbl_alias = 'h'; //varianty - alias tabulky na ktoru sa pripaja prvy join
        if($k<2) $constr = $pTbl_alias.".id"; else $constr = "jt".($k-1).".id";
        //var_dump($tblAndFk);
        if($tblAndFk['join']=="LEFT") $joins[] = "LEFT JOIN ".$tblAndFk['tbl']." jt$k ON jt".$k.".".$tblAndFk['fk']."=".$constr;
        else $joins[] = "INNER JOIN ".$tblAndFk['tbl']." jt$k ON jt".$k.".".$tblAndFk['fk']."=".$constr;
      }
    return $joins;
  }

  private function translate_wildcards($s){ //returns operator
    $s = trim($s);
    if($s=="") return "";
    if(substr($s,0,1)=="*") $s="%".substr($s,1);
    if(substr($s,-1)=="*") $s=substr($s,0,-1)."%";
    return $s;
  }

  private function get_where_fragment($filter_id, $alt_id, $field_id, &$neg){
    global $_REL, $_NEG_REL;
    $binary=false;
    $where_fragment = "";

    $var_podh = "";
    if($field_id=="varianta-podhesli-tvar"){
     $var_podh = " AND f_varianta = 0";
    } else if($field_id=="varianta-tvar"){
     $var_podh = " AND f_varianta = 1";
    }


    $kom_tvaru = "";
    if($field_id == "varianta-komentar-tvaru"){
      $kom_tvaru .= " AND hid in (SELECT `hid` FROM `field_control` WHERE `field` = 'varianta-komentar_tvaru')";
    }

    if(!is_numeric($filter_id) || !is_numeric($alt_id) || !array_key_exists($field_id, $this->X)) return false;
    $sql = "SELECT field_val, relation, negation, cs
            FROM xfilter_alternatives_vals
            WHERE filter_id=$filter_id AND alternative=$alt_id AND field_id='$field_id'";
    $res = dbq($sql);
    $rec = mysql_fetch_assoc($res);
    //search field
    $search_field = $this->X[$field_id]['search_field'];
    //if($search_field=="varianta")$search_field="varianty_bez_zavor";
    if($this->X[$field_id]['type']=='cis')
    {
      $search_field = "cis_id";
      if($field_id == 'heslo-zpracovatel') $search_field = 'uid';
      if($field_id == 'heslo-heslar') $search_field = 'heslar_id';
    }
    //aby sme predisli doplikovanym nazvom poli po JOINE, vzdy definujeme pole ako pole posledneho joinu
    $joinCount = count($this->X[$field_id]['JOINs']);
    if($joinCount>0) $search_field = "jt".$joinCount.".".$search_field;

    //operator
    if($rec['negation']==1) $rec['relation'] = $_NEG_REL[$rec['relation']];
    $operator = $_REL[$rec['relation']];

    //search value
    $search_value = $rec['field_val'];
    if($this->X[$field_id]['type']=='txt' OR $this->X[$field_id]['type']=='txtF')
    {
        if($_REL[$rec['relation']]=='úsek'){
            $search_value = explode("###",$rec['field_val']);
            return "'".$search_value[0]."'<=".$search_field." AND ".$search_field."<='".$search_value[1]."Ž'";
        }
      if($search_value=="*")
      {
          //$search_value==".*";
      }
      else if(substr($search_value,0,1)=="*" || substr($search_value,-1)=="*")
      {
          escape_special_char($search_value);

          if(substr($search_value,0,1)=="*"){
              $search_value=".*".substr($search_value,1);
          }else{
              $search_value="^".$search_value;
          }
          if(substr($search_value,-1)=="*"){
              $search_value=substr($search_value,0,-1).".*";
          }else{
              $search_value=$search_value."$";
          }

          if($rec['negation']==1){$operator="  NOT REGEXP";}
          else {$operator="  REGEXP";}
      }
      else
      {
        if($rec['cs']==true) $binary=true;
      }
      $search_value = "'$search_value'";
    }

    if($this->X[$field_id]['type']=='tarea')
    {
      if($operator=="=" or $search_value=="*" or substr($search_value,0,1)=="*" or substr($search_value,-1)=="*")
      {
          if($rec['negation']==1){$operator="  NOT REGEXP";}
          else {$operator="  REGEXP";}

          escape_special_char($search_value);

          if($search_value=="*")  $search_value="'".$search_value."'";
        else if(substr($search_value,0,1)=="*" || substr($search_value,-1)=="*")
        {
          if(substr($search_value,0,1)=="*")
          {
            $search_value=".*".substr($search_value,1);
          }
          else
          {
            $search_value=".*[<>,.;:?!() ]+".$search_value;
          }
          if(substr($search_value,-1)=="*")
          {
            $search_value=substr($search_value,0,-1).".*";
          }
          else
          {
            $search_value=$search_value."[<>,;.:?!() ]+.*";
          }
          $search_value = "'$search_value'";  //přidat BINARY aby < bylo case sensitive
        }
        else
        {
          $search_value = "'.*[<>,;.:?!() ]+".$search_value."[<>,;.:?!() ]+.*'";
        }
      }
      else
      {
          $search_value = "'.*[<>,;.:?!() ]+".$search_value."[<>,;.:?!() ]+.*'";
        if($rec['cs']==true) $binary=true;
      }
    }
    //var_dump($this->X[$field_id]['type']);

    //if(in_array($this->X[$field_id]['type'], array('txt','tarea'))) $search_value = "'$search_value'";

    if($this->X[$field_id]['type']=='cis')
    {
      $cis_ids = $this->parse_cis_selection($rec['field_val'], true);
      //osetrenie hodnoty "jine"
      $jine_val=null;
      if(isset($cis_ids['jine']))
      {
        $jine_val = $cis_ids['jine'];
        unset($cis_ids['jine']);
        unset($cis_ids[array_search('jine', $cis_ids)]);
      }
      /*
       * vyber z ciselnika funguje zatial tak ze vyhladane heslo v danom poli obsahuje aspon jednu z vybranych hodnot
         malo by to ale fungovat tak, ze vybrane heslo v danom poli obsahuje presne vybrane hodnoty

       * tento kod vyberie skupinu, ktora ma presne urcenych clenov priklad na SLOVNYCH DRUHOCH

        SELECT h.id as hid
        FROM heslo h
         INNER JOIN varianty jt1 on h.id=jt1.hid
         INNER JOIN var_slov_druhy_vyber_rel jt2 on jt1.id=jt2.vid
         INNER JOIN slov_druhy_vyber jt3 on jt2.id=jt3.var_slov_druhy_vyber_rel_id
        WHERE cis_id IN (30,17) OR jine='xxx'
        GROUP BY jt3.var_slov_druhy_vyber_rel_id
        HAVING COUNT(*) =
        (
         SELECT COUNT(*)
         FROM heslo h
          INNER JOIN varianty jt1 on h.id=jt1.hid
          INNER JOIN var_slov_druhy_vyber_rel jt2 on jt1.id=jt2.vid
          INNER JOIN slov_druhy_vyber jt33 on jt2.id=jt33.var_slov_druhy_vyber_rel_id
         WHERE jt3.var_slov_druhy_vyber_rel_id = jt33.var_slov_druhy_vyber_rel_id
         GROUP BY jt33.var_slov_druhy_vyber_rel_id
        ) AND COUNT(*)=3; -- 3 = pocet hodnot vybranych v multi selecte (tu: 30,17,jine = 3x)
      */

      if(!empty($cis_ids))
      {
        $search_value = "(".implode(", ", $cis_ids).")";
        $set_operator = "IN";
        if($rec['relation']==REL_NE)
        {
          $set_operator = "NOT IN";
          $search_value = '('.$search_field.' '.$set_operator.' '.$search_value.' OR '.$search_field.' IS NULL)';
        }
        else
        {
          $search_value = '('.$search_field.' '.$set_operator.' '.$search_value.')';//.' GROUP BY hid HAVING COUNT(DISTINCT '.$search_field.')='.count($cis_ids);
        }
      }

      if(!is_null($jine_val))
      {
        //var_dump($jine_val);
        if($jine_val=="*" OR $jine_val=="")
        {
            if($operator=="=")
            {
              $operator="  REGEXP";
              $search_value="jine ".$operator." '.*' AND jine!='' ";
            }
            else
            {
              $search_value="jine IS NULL";
            }
        }
        else
        {
            $search_value=$jine_val;

            escape_special_char($search_value);

            if(substr($search_value,0,1)=="*" || substr($search_value,-1)=="*")
          {
            if(substr($search_value,0,1)=="*"){
              $search_value=".*".substr($search_value,1);
            }else{
              $search_value="^".$search_value;
            }
            if(substr($search_value,-1)=="*"){
              $search_value=substr($search_value,0,-1).".*";
            }else{
              $search_value=$search_value."$";
            }
            if($operator=="<>"){$operator=" NOT REGEXP";}
            else {$operator=" REGEXP ";}
          }
         $search_value=" LOWER(jine)  ".$operator." BINARY LOWER('".$search_value."')";
        }
      }
      $search_value = "$search_value";
      $search_field = ''; $operator =''; //uz su obsiahnute v $search_value
    }

    if ($field_id=="heslo-stav" && $search_value=="1"){
        $where_fragment = " jt1.stav = 1 OR jt1.stav IS NULL ";
    }else if(($this->X[$field_id]['type']=='onoff')) {
      if($search_value==0)
      {
        $where_fragment = ' 1=1 '.' GROUP BY hid HAVING 0!=max('.$search_field.')';
      }
      else
      {
        $where_fragment = ' 1=1 '.' GROUP BY hid HAVING 0=max('.$search_field.')';
      }
    }
    else if(($this->X[$field_id]['type']=='onoffK'))
    {
      if($search_value==0)
      {
        $where_fragment = $search_field.' IS NULL AND field   NOT REGEXP ".*synonymum-.*" AND field   NOT REGEXP ".*antonymum-.*" AND field!="odkaz-synonymum"'."  ";
      }
      else
      {
        $where_fragment =  $search_field.' IS NULL AND field   NOT REGEXP ".*synonymum-.*" AND field   NOT REGEXP ".*antonymum-.*" AND field!="odkaz-synonymum"'."  ";
      }
    }
    else if(($this->X[$field_id]['type']=='onoffSpec'))
    {
        if($search_value==0)
        {
            $where_fragment = ' rel_type='.HREL_TYPE_pripojovani.' OR rel_type='.HREL_TYPE_prihnizdovani.'  ';
        }
        else
        {
            $where_fragment = ' rel_type!='.HREL_TYPE_pripojovani.' AND rel_type!='.HREL_TYPE_prihnizdovani.'  ';
        }
    }
    else if($this->X[$field_id]['type']=='date')
    {
      $fv= explode('|', $search_value);
      $interval[0] = (!empty($fv[0])) ? date("Y-m-d", strtotime($fv[0])) : 0 ;
      $interval[1] = (!empty($fv[1])) ? date("Y-m-d", strtotime($fv[1])) : 0 ;

      $where_fragment = $search_field." >= '".$interval[0]."' and ".$search_field." <= '".$interval[1]."'  + INTERVAL 1 DAY"."  ";
    }
    else if($rec['cs']==true)
    {
      if(($this->X[$field_id]['type']=='tarea')||($this->X[$field_id]['type']=='txt')||($this->X[$field_id]['type']=='txtF'))
      {
        if($search_value=="'*'" && $this->X[$field_id]['name']=="Synonymum"  )
        {
            if ($rec['negation']==1)
            {
                $where_fragment="($search_field == '' OR $search_field IS NULL)  AND rel_type=5"."  ";
            }
            else
            {
                $where_fragment="$search_field <> '' AND $search_field IS NOT NULL  AND rel_type=5"."  ";
            }
        }
        else if($search_value=="'*'" && $this->X[$field_id]['name']=="Antonymum"  )
        {
            if ($rec['negation']==1)
            {
                $where_fragment="($search_field == '' OR $search_field IS NULL)  AND rel_type=4"."  ";
            }
            else
            {
                $where_fragment="$search_field <> '' AND $search_field IS NOT NULL  AND rel_type=4"."  ";
            }
        }
        else if($search_value=="'*'" )
        {
            if ($rec['negation']==1)
            {
                $where_fragment="$search_field == '' OR $search_field IS NULL".$var_podh.$kom_tvaru."  ";
            }
            else
            {
                $where_fragment="$search_field <> '' AND $search_field IS NOT NULL".$var_podh.$kom_tvaru."  ";
            }
        }
        else if($binary==true)  $where_fragment = "BINARY ".$search_field.' '.$operator.' '.$search_value.$var_podh.$kom_tvaru."  ";
        else $where_fragment = $search_field.' '.$operator.' '.$search_value."  ";
      }
      else $where_fragment = $search_field.' '.$operator.' '.$search_value."  ";
    }
    else
    {
      if(($this->X[$field_id]['type']=='tarea')||($this->X[$field_id]['type']=='txt')||($this->X[$field_id]['type']=='txtF'))
      {
        if($search_value=="'*'" && $this->X[$field_id]['name']=="Synonymum"  )
        {
            if ($rec['negation']==1)
            {
                $where_fragment="($search_field == '' OR $search_field IS NULL)  AND rel_type=5"."  ";
            }
            else
            {
                $where_fragment="$search_field <> '' AND $search_field IS NOT NULL  AND rel_type=5"."  ";
            }
        }
        else if($search_value=="'*'" && $this->X[$field_id]['name']=="Antonymum"  )
        {
            if ($rec['negation']==1)
            {
                $where_fragment="($search_field == '' OR $search_field IS NULL)  AND rel_type=4"."  ";
            }
            else
            {
                $where_fragment="$search_field <> '' AND $search_field IS NOT NULL  AND rel_type=4"."  ";
            }
        }
        else if($search_value=="'*'")
        {
            if ($rec['negation']==1)
            {
                $where_fragment="$search_field = '' OR $search_field IS NULL".$var_podh.$kom_tvaru."  ";
            }
            else
            {
                $where_fragment="$search_field <> '' AND $search_field IS NOT NULL".$var_podh.$kom_tvaru."  ";
            }
        }
        else $where_fragment = ' LOWER('.$search_field.') '.$operator.' BINARY LOWER('.$search_value.')'.$var_podh.$kom_tvaru."  ";  }
      else
      {
      //var_dump($search_value);
        $where_fragment = $search_field.' '.$operator.' '.$search_value." ";
      }
    }

    if($rec['relation']==REL_NE OR $rec['negation']==1)$neg=true;
    else $neg=false;

    //var_dump($where_fragment);
      //var_dump($rec['negation']);
      //var_dump($this->X[$field_id]['JOINs']);
        //$where_fragment .=  ' AND COUNT(hid)== '.$operator.' '.$search_value;
    return $where_fragment;
  }

  public function get_hesla($filter_id){
    $hids = array();
    //get alternatives where at least one field is active
    $sql_alt="SELECT DISTINCT alternative FROM xfilter_alternatives_vals WHERE filter_id=$filter_id AND field_id!='vazba'";
    $res_alt = dbq($sql_alt);
    $hids_of_alternatives = array(); //subor zjednotenych hidov z alternativ, ktore sa budu zjednocovat
      $vazby=array();
      if($filter_id>0) {
          $sql = "SELECT field_val
              FROM xfilter_alternatives_vals
              WHERE filter_id=$filter_id AND field_id='vazba' ORDER BY alternative ASC";
          $res = dbq($sql);
          while($rec = mysql_fetch_assoc($res)) {
              $vazby[]=$rec['field_val'];
          }
      }
    while($rec_alt = mysql_fetch_assoc($res_alt))
    {
      $alt = $rec_alt['alternative'];
      $sql_f = "SELECT field_id FROM xfilter_alternatives_vals WHERE filter_id=$filter_id AND alternative=$alt";
      $res_f = dbq($sql_f);
      $hids2intersect = array(); //subor poli jednej altrenativy, medzi ktorymi sa urobi prienik
      $filtr_pripoj=false;
      while($rec_f = mysql_fetch_assoc($res_f))
      {
        $field_id = $rec_f['field_id'];
        $J_arr = $this->get_joins($field_id);
          $joins="";
          if(!empty($J_arr)) {
              $joins = implode(" ", $J_arr);
          }
        $where_frag = $this->get_where_fragment($filter_id, $alt, $field_id, $neg);

          if($this->X[$field_id]['type']=='onoffSpec')$filtr_pripoj=true;
          if(empty($where_frag))
          {
              if(empty($J_arr))
              {
                  $sql = "SELECT DISTINCT h.id as hid,  1 as cnt
                FROM heslo h $joins GROUP BY hid";
              }
              else
              {
                  $sql = "SELECT DISTINCT h.id as hid, COUNT(jt1.id) as cnt
                FROM heslo h $joins GROUP BY hid";
              }
          }
          else
          {
              $grupovani="";
              if(!strpos($where_frag,"GROUP BY hid")){
                  $grupovani="GROUP BY hid";
              }
              if(empty($J_arr))
              {
                  $sql = "SELECT DISTINCT h.id as hid, 1 as cnt
                FROM heslo h $joins
                WHERE $where_frag ".$grupovani;
              }
              else
              {
                  if($field_id=="heslo-stav"){
                      $sql = "SELECT DISTINCT h.id as hid
                              FROM heslo h $joins
                              WHERE $where_frag ".$grupovani;
                  }else {
                      $sql = "SELECT DISTINCT h.id as hid, COUNT(jt1.id) as cnt
                              FROM heslo h $joins
                              WHERE $where_frag ".$grupovani;
                  }
              }
          }
          if(($this->X[$field_id]['type']=='onoffK'))
          {
              $sql2 = "SELECT field_val, relation, negation, cs
              FROM xfilter_alternatives_vals
              WHERE filter_id=$filter_id AND alternative=$alt AND field_id='$field_id'";
              $res = dbq($sql2);
              $rec = mysql_fetch_assoc($res);
              if($rec['field_val']!=0)
              {
                  $sql="SELECT DISTINCT h.id as hid, 1 as cnt FROM heslo h WHERE id NOT IN (SELECT hid from (".$sql.") sel1) ";
              }
          }
        $res = dbq($sql);
        $hids_of_field = array(); //subor hesiel vyhovujucich jednotlivym aktivnym filtrom v jednej alternative

        if($neg && !empty($this->X[$field_id]['JOINs']))
        {
          //var_dump($this->X[$field_id]['JOINs']);
          foreach($this->X[$field_id]['JOINs'] as $value)
          {
            //var_dump($value);
            if(in_array("vyznamy", $value)||in_array("zpracovatel", $value))
            {
              while($rec = mysql_fetch_array($res))
              {
                if(empty($J_arr))
                {
                  $sql2 = "SELECT 1 as cnt FROM heslo h $joins WHERE hid=".$rec['hid'] ;
                }
                else
                {
                  $sql2 = "SELECT COUNT(jt1.id) as cnt FROM heslo h $joins WHERE hid=".$rec['hid'] ;
                }
                $res2 = dbq($sql2);
                if($rec2 = mysql_fetch_array($res2))
                {
                  if($rec['cnt']==$rec2['cnt'])
                  {
                    $hids_of_field[] = $rec['hid'];
                  }
                }
              }
            }
            if(in_array("varianty", $value))
            {
              while($rec = mysql_fetch_array($res))
              {
                if(empty($J_arr))
                {
                  $sql2 = "SELECT 1 as cnt
                          FROM heslo h $joins WHERE hid=".$rec['hid'] ;
                }
                else
                {
                  $sql2 = "SELECT COUNT(jt1.id) as cnt
                            FROM heslo h $joins WHERE hid=".$rec['hid'] ;
                }
                $res2 = dbq($sql2);
                if($rec2 = mysql_fetch_array($res2))
                {
                  if($rec['cnt']==$rec2['cnt'])
                  {
                    $hids_of_field[] = $rec['hid'];
                  }
                }
              }
            }
          }
        }
        else
        {
          while($rec = mysql_fetch_array($res))
          {
              $hids_of_field[] = $rec['hid'];
          }
        }
        $hids2intersect[] = $hids_of_field;
      }

      if(count($hids2intersect)<2){
          if (count($hids2intersect[0])>0&&$filtr_pripoj){
              $hids2intersect[0]   =dibi::fetchPairs("SELECT @n := @n + 1 n, h.id FROM (SELECT @n := 0) m, heslo h JOIN hesla_rel ON h.id=hesla_rel.main_hid WHERE (rel_type=".HREL_TYPE_pripojovani." OR rel_type=".HREL_TYPE_prihnizdovani.") AND slave_hid IN (".implode(",",$hids2intersect[0]).")");
          }
          $hids_of_alternatives[$alt] = $hids2intersect[0];
      }else{
          $hids2intersect=call_user_func_array('array_intersect', $hids2intersect);
          if ($filtr_pripoj){
              if(count($hids2intersect)>0){
                  $hids2intersect=dibi::fetchPairs("SELECT @n := @n + 1 n, h.id FROM (SELECT @n := 0) m, heslo h JOIN hesla_rel ON h.id=hesla_rel.main_hid WHERE (rel_type=".HREL_TYPE_pripojovani." OR rel_type=".HREL_TYPE_prihnizdovani.") AND slave_hid IN (".implode(",",$hids2intersect).")");
              }
          }
          $hids_of_alternatives[$alt] = $hids2intersect;
      }
    } 
    if(count($hids_of_alternatives)<2)
    {
      $hids = $hids_of_alternatives;
      $hids = (array)array_values($hids)[0];
    }
    else
    {
      $out_array=array();
      $temp_array=array();
      if(!empty($vazby)){
          if (isset($hids_of_alternatives[1])){
              $temp_array[]=$hids_of_alternatives[1];
          }
          foreach ($vazby as $key=>$value){
            if($value=="nebo")
            {
                if(isset($temp_array[0])){
                    $out_array[]=$temp_array[0];
                }
                if (isset($hids_of_alternatives[$key+2])){
                    $temp_array=array();
                    $temp_array[]=$hids_of_alternatives[$key+2];
                }else{
                    $temp_array=array();
                }
            }else if($value=="a"){
                if (isset($hids_of_alternatives[$key+2])){
                    $temp_array[]=$hids_of_alternatives[$key+2];
                }
                $temp_array2=array();
                $temp_array2[]=call_user_func_array('array_intersect', $temp_array);
                $temp_array=$temp_array2;
            }
          }
      }else{
          foreach ($hids_of_alternatives as $key=>$value) {
              $out_array[] = $value;
          }
      }
        $hids = call_user_func_array('array_unique_merge', $out_array);
        $hids = (array)$hids;
      //  $hids = call_user_func_array('array_unique_merge', $hids_of_alternatives);
       // $hids = (array)$hids;
    }
    return   $hids ;
  }
}
?>
