<?php
 require_once('odkazy_fx.php');
 require_once('archive_fx.php');
  function uloz_heslo($h){
  $hid = (is_numeric($h['hid']) && $h['hid']+0 > 0) ? $h['hid'] : false;
  $pid = (is_numeric($h['parent_heslo_hid']) && $h['parent_heslo_hid']+0 > 0) ? $h['parent_heslo_hid'] : 0;
  $last_upd = dibi::fetchSingle('SELECT updated_by FROM heslo WHERE id=%i', $hid);
  archive_default($hid, $last_upd);
  $vystup = $h['do_vystupu'];
  $lex_pozn = text_db_preprocess($h['lexikograficka_poznamka']);
  $odb_pozn = text_db_preprocess($h['poznamka_odbornik']);
  $varianty = $h['varianta'];
  $ext_poznamky = $h['extPozn'];
  $vyznamy = $h['vyznam'];
  $zpracovatele = $h['zpracovatele'];
  $redukovat = ($h['redukovat']=="1") ? 1 : 0;
  $hidRels = $h['hidRel'];

  $data = array();
  if($pid == $hid) err('Podřazení nebylo provedeno. Heslo nemůže být podřazeno pod samo sebe!');
  else if($pid > 0){
    $data['pid'] = $pid;
  } else{
    $data['pid'] = "NULL";
  }
  $data['uts'] = "NOW()";
  $data['vystup'] = "$vystup";
  $data['lexgraf_pozn'] = "'$lex_pozn'";
  $data['pozn_odbornik'] = "'$odb_pozn'";
  $data['redukce'] = $redukovat;
  $data['updated_by'] = get_logged_user();
  $data['heslar_id']=$h['typ_heslare'];
  //var_dump($data); die();
  sql_w('heslo', $data, $hid);
  //uloz_hidRels($hid, $hidRels); //musi byt pred variantami, lebo vo variantach sa osetruje hid rels, co musi nastat az po ulozeni prepojeni
  uloz_varianty($hid, $varianty);
  uloz_zpracovatele($zpracovatele, $hid);
  uloz_poznamky('hes', $hid, $ext_poznamky);
  uloz_vyznamy($hid, $vyznamy);
  //vymazat starou verzi z cache
  $cache = new CacheManager;
  $cache->dropCache($hid);
 }

 function uloz_nove_heslo($heslo, $uid){ //ak heslo neexistuje ulozi ho
  $heslo = trim($heslo);
  if($heslo=='') return false;
  if($uid=='' && $uid<1) return false;
  $heslo = mysql_real_escape_string($heslo);

  $sqlData=array();
  $sqlData['uts'] = "NOW()";
  $sqlData['created_by'] = get_logged_user();
  $hid = sql_w('heslo', $sqlData);

  $sqlData=array();
  $sqlData['hid'] = $hid;
  $sqlData['varianta'] = "'".$heslo."'";
  $sqlData['sortorder'] = 1;
  $sqlData['varianty_bez_zavor'] = "REPLACE(REPLACE(REPLACE(REPLACE('".$heslo."', '(', ''), ')', ''), '[', ''), ']', '')";
  $var_id = sql_w('varianty', $sqlData);

  $sqlData=array();
  $sqlData['hid'] = $hid;
  $sqlData['uid'] = $uid;
  sql_w('zpracovatel', $sqlData);

  //default "typ hesla" = jednoslovne
  $sqlData=array();
  $sqlData['vid'] = $var_id;
  $sqlData['cis_id'] = 1;
  $sqlData['uts'] = "NOW()";
  $sqlData['sortorder'] = 1;
  sql_w('typ_hesla_var_vyber', $sqlData);

  $sqlData = array(
    'hid' => $hid,
    'sortorder' => 1
  );
  $vyz_id = sql_w('vyznamy', $sqlData);
  $sqlData = array(
    'vyz_id' => $vyz_id
  );
  $podh_id = sql_w('podhesli_vyznamu', $sqlData);

  osetri_linkovanie_pri_editacii_varianty($var_id);
  check_vyznam_neexistujici_link($heslo, $hid, $vyz_id);

  return $hid;
 }

 function get_vyber_cis($tbl, $fk_name, $pid){
  return dibi::fetchPairs('SELECT cis_id, jine FROM %n WHERE %n = %i', $tbl, $fk_name, $pid);
 }

 function uloz_vyber_cis($vyb, $vyber_arr, $pid){
   if(!is_numeric($pid) || $pid<1) $pid = NULL;
   switch($vyb){
    case 'slov_druhy':             $tbl = 'slov_druhy_vyber';           $fk_name = 'var_slov_druhy_vyber_rel_id';  $cisVyberIDENT = SLOV_DRUHY; break;
    case 'slov_druhy_vyz':         $tbl = 'slov_druhy_vyber_vyz';       $fk_name = 'vyz_slov_druhy_vyber_rel_id';  $cisVyberIDENT = SLOV_DRUHY; break;
    case 'slov_druhy_podh':        $tbl = 'podh_vyz_slov_druhy';        $fk_name = 'podh_rel_id';                  $cisVyberIDENT = SLOV_DRUHY; break;
    case 'tvar_char':              $tbl = 'tvar_char_vyber';            $fk_name = 'var_tvar_char_vyber_rel_id';   $cisVyberIDENT = TVAR_CHAR; break;
    case 'tvar_char_vyz':          $tbl = 'tvar_char_vyber_vyz';        $fk_name = 'vyz_tvar_char_vyber_rel_id';   $cisVyberIDENT = TVAR_CHAR; break;
    case 'tvar_char_podh':         $tbl = 'podh_tvar_char_vyber';       $fk_name = 'podh_tvch_rel_id';             $cisVyberIDENT = TVAR_CHAR; break;
    case 'tvar_char_sl':           $tbl = 'tvar_char_sl_vyber';         $fk_name = 'var_tvar_char_sl_vyber_rel_id';$cisVyberIDENT = TVAR_CHAR_SL; break;
    case 'tvar_char_sl_vyz':       $tbl = 'tvar_char_sl_vyber_vyz';     $fk_name = 'vyz_tvar_char_sl_vyber_rel_id';$cisVyberIDENT = TVAR_CHAR_SL; break;
    case 'tvar_char_sl_podh':      $tbl = 'podh_tvar_char_sl_vyber';    $fk_name = 'podh_tvch_sl_rel_id';          $cisVyberIDENT = TVAR_CHAR_SL; break;
    case 'typ_hesla':              $tbl = 'typ_hesla_var_vyber';        $fk_name = 'vid';                          $cisVyberIDENT = TYP_HESLA; break;
    case 'styl_kval':              $tbl = 'styl_kval_var_vyber';        $fk_name = 'vid';                          $cisVyberIDENT = STYL_KVAL; break;
    case 'styl_kval_vyz':          $tbl = 'styl_kval_vyz_vyber';        $fk_name = 'vyz_id';                       $cisVyberIDENT = STYL_KVAL; break;
    case 'styl_kval_podh':         $tbl = 'styl_kval_podh_vyber';       $fk_name = 'podh_id';                      $cisVyberIDENT = STYL_KVAL; break;
    case 'gram_info':              $tbl = 'gram_info_var_vyber';        $fk_name = 'vid';                          $cisVyberIDENT = GRAM_INFO; break;
    case 'gram_info_vyz':          $tbl = 'gram_info_vyz_vyber';        $fk_name = 'vyz_id';                       $cisVyberIDENT = GRAM_INFO; break;
    case 'gram_info_podh':         $tbl = 'podh_vyz_gram_info';         $fk_name = 'podh_id';                      $cisVyberIDENT = GRAM_INFO; break;
    case 'tematicke_okruhy':       $tbl = 'tematicke_okruhy_var_vyber'; $fk_name = 'vid';                          $cisVyberIDENT = TEMATICKE_OKRUHY; break;
    case 'tematicke_okruhy_vyz':   $tbl = 'tematicke_okruhy_vyz_vyber'; $fk_name = 'vyz_id';                       $cisVyberIDENT = TEMATICKE_OKRUHY; break;
    case 'tematicke_okruhy_podh':  $tbl = 'tematicke_okruhy_podh_vyber';$fk_name = 'podh_id';                     $cisVyberIDENT = TEMATICKE_OKRUHY; break;
    case 'puvod':                  $tbl = 'puvod_var_vyber';            $fk_name = 'vid';                          $cisVyberIDENT = PUVOD; break;
    case 'obor_uziti':             $tbl = 'obor_uziti_var_vyber';       $fk_name = 'vid';                          $cisVyberIDENT = OBOR_UZITI; break;
    case 'obor_uziti_vyz':         $tbl = 'obor_uziti_vyz_vyber';       $fk_name = 'vyz_id';                       $cisVyberIDENT = OBOR_UZITI; break;
    case 'obor_uziti_podh':        $tbl = 'obor_uziti_podh_vyber';      $fk_name = 'podh_id';                      $cisVyberIDENT = OBOR_UZITI; break;
    case 'metavyklad1_vyz':        $tbl = 'metavyklad1_vyz_vyber';      $fk_name = 'vyz_id';                       $cisVyberIDENT = METAVYKLAD1; break;
    case 'typ_linkovani':          $tbl = 'hesla_rel_link_type_vyber';  $fk_name = 'hesla_rel_id';                 $cisVyberIDENT = TYP_LINKOVANI; break;
    case 'metavyklad1_vyz_master': $tbl = 'metavyklad1_vyz_vyber_m';    $fk_name = 'vyz_id';                       $cisVyberIDENT = METAVYKLAD1; break;
    case 'konec_zahlavi_vyber':    $tbl = 'konec_zahlavi_vyber';        $fk_name = 'hid';                          $cisVyberIDENT = KONEC_ZAHLAVI; break;
   }

   $ord = 0;
   $jine_val = "";
   //if($vyb == 'typ_hesla') {var_dump($vyber_arr); die();}
   $ar_db = get_vyber_cis($tbl, $fk_name, $pid);

   if(isset($vyber_arr['jine'])){
     $jine_val = trim($vyber_arr['jine']);
     if ($jine_val){
      unset($ar_db['']);
     }
     $old_jine = dibi::fetchSingle('SELECT `jine` FROM %n WHERE %n = %i AND `cis_id` IS NULL', $tbl, $fk_name, $pid);
     if ($jine_val && ($jine_val != $old_jine)){
      if ($old_jine){
        dibi::query('UPDATE %n SET `jine` = %s WHERE %n = %i AND `cis_id` IS NULL', $tbl, $jine_val, $fk_name, $pid);
      }else{
        dibi::query('INSERT INTO %n %v', $tbl, array($fk_name => $pid, 'jine' => $jine_val));
      }
     }
     unset($vyber_arr['jine']);
   }
   $ar_form = array_flip($vyber_arr);
   $sort_arr = $ar_form;
   foreach ($ar_db as $cis_id => $jine){
    if (isset($ar_form[$cis_id])){
      unset($ar_form[$cis_id], $ar_db[$cis_id]);
    }
   }
   //ar_form = zaznamy, ktere se vlozi
   //ar_db   = zaznamy, ktere se vymazou
   foreach ($ar_db as $cis_id => $i){
    dibi::query('DELETE FROM %n WHERE %and', $tbl, array($fk_name => $pid, 'cis_id%iN' => $cis_id));
   }
   foreach ($ar_form as $cis_id => $jine){
    if (is_numeric($cis_id)){
      dibi::query('INSERT INTO %n', $tbl, array($fk_name => $pid, 'cis_id' => $cis_id));
    }
   }
   foreach ($sort_arr as $cis_id => $sort){
    $where = array($fk_name => $pid);
    if (is_numeric($cis_id)){
      $where['cis_id'] = $cis_id;
    }else{
      $where[] = 'cis_id IS NULL';
    }
    dibi::query('UPDATE %n SET `sortorder` = %i WHERE %and', $tbl, ($sort + 1), $where);
   }

   if($jine_val!=""){
     $sqlData=array();
     $sqlData['uid'] = get_logged_user();
     $sqlData['hid'] = $_POST['hid'];
     $sqlData['typ_cis'] = $cisVyberIDENT;
     $sqlData['hodnota'] = "'".text_db_preprocess($jine_val)."'";

     $sql = "SELECT id FROM stat_jinych_cis_hodnot WHERE hid=".$sqlData['hid']." AND typ_cis=".$sqlData['typ_cis']." AND hodnota=".$sqlData['hodnota'];
     $res = mysql_query($sql) or die("<p>Chyba DB! pri zistovani, ci ukladame duplikovany kluc do statistiky JINYCH hodnot.</p><p>".mysql_error()."</p><p>".$sql."</p>");
     $n = mysql_num_rows($res);
     if($n<1) sql_w('stat_jinych_cis_hodnot', $sqlData);
    }
 }

 function smaz_vyber($vyb, $fk){
   switch($vyb){
    case 'slov_druhy':           $tbl = 'slov_druhy_vyber';           $fk_name = 'var_slov_druhy_vyber_rel_id'; break;
    case 'slov_druhy_vyz':       $tbl = 'slov_druhy_vyber_vyz';       $fk_name = 'vyz_slov_druhy_vyber_rel_id'; break;
    case 'slov_druhy_podh':      $tbl = 'podh_vyz_slov_druhy';        $fk_name = 'podh_rel_id'; break;
    case 'tvar_char':            $tbl = 'tvar_char_vyber';            $fk_name = 'var_tvar_char_vyber_rel_id'; break;
    case 'tvar_char_vyz':        $tbl = 'tvar_char_vyber_vyz';        $fk_name = 'vyz_tvar_char_vyber_rel_id'; break;
    case 'tvar_char_podh':       $tbl = 'podh_tvar_char_vyber';       $fk_name = 'podh_tvch_rel_id'; break;
    case 'tvar_char_sl':         $tbl = 'tvar_char_sl_vyber';         $fk_name = 'var_tvar_char_sl_vyber_rel_id'; break;
    case 'tvar_char_sl_vyz':     $tbl = 'tvar_char_sl_vyber_vyz';     $fk_name = 'vyz_tvar_char_sl_vyber_rel_id'; break;
    case 'tvar_char_sl_podh':    $tbl = 'podh_tvar_char_sl_vyber';    $fk_name = 'podh_tvch_sl_rel_id'; break;
    case 'typ_hesla':            $tbl = 'typ_hesla_var_vyber';        $fk_name = 'vid'; break;
    case 'styl_kval':            $tbl = 'styl_kval_var_vyber';        $fk_name = 'vid'; break;
    case 'styl_kval_vyz':        $tbl = 'styl_kval_vyz_vyber';        $fk_name = 'vyz_id'; break;
    case 'styl_kval_podh':       $tbl = 'styl_kval_podh_vyber';       $fk_name = 'podh_id'; break;
    case 'gram_info':            $tbl = 'gram_info_var_vyber';        $fk_name = 'vid'; break;
    case 'gram_info_vyz':        $tbl = 'gram_info_vyz_vyber';        $fk_name = 'vyz_id'; break;
    case 'gram_info_podh':       $tbl = 'podh_vyz_gram_info';         $fk_name = 'podh_id'; break;
    case 'tematicke_okruhy':     $tbl = 'tematicke_okruhy_var_vyber'; $fk_name = 'vid'; break;
    case 'tematicke_okruhy_vyz': $tbl = 'tematicke_okruhy_vyz_vyber'; $fk_name = 'vyz_id'; break;
    case 'tematicke_okruhy_podh':$tbl = 'tematicke_okruhy_podh_vyber';$fk_name = 'podh_id'; break;
    case 'puvod':                $tbl = 'puvod_var_vyber';            $fk_name = 'vid'; break;
    case 'obor_uziti':           $tbl = 'obor_uziti_var_vyber';       $fk_name = 'vid'; break;
    case 'obor_uziti_vyz':       $tbl = 'obor_uziti_vyz_vyber';       $fk_name = 'vyz_id'; break;
    case 'obor_uziti_podh':      $tbl = 'obor_uziti_podh_vyber';      $fk_name = 'podh_id'; break;
    case 'metavyklad1_vyz':      $tbl = 'metavyklad1_vyz_vyber';      $fk_name = 'vyz_id'; break;
    case 'metavyklad1_vyz_master':$tbl = 'metavyklad1_vyz_vyber_m';   $fk_name = 'vyz_id'; break;
    case 'typ_linkovani':        $tbl = 'hesla_rel_link_type_vyber';  $fk_name = 'hesla_rel_id'; break;
   }
   $slq_del = "DELETE FROM $tbl WHERE $fk_name = $fk";
   $res_del = mysql_query($slq_del) or die("Chyba DB (pri mazani)! [f: smaz_vyber()[$vyb]] <p>".mysql_error()."</p><p>$sql_del</p>");
 }

 function uloz_varianty($hid, $varianty){
  $varianty_db = get('varianty_hesla', $hid);
  $ord = 0;
  if(!empty($varianty))
  {
    foreach($varianty as $var_id => $varianta){
      $ord++;
      if(is_numeric($var_id) && $var_id > 0) unset($varianty_db[array_search($var_id, $varianty_db)]);
      $var_id = uloz_variantu($hid, $varianta, $var_id, $ord);
      if($ord==1)
      {
        $sql ="SELECT  id,main_str  FROM hesla_rel
                WHERE main_hid=$hid and main_str!='".$varianta["heslo_var"]."'";
        $res = dbq($sql);
        //var_dump($res);
        while($rec = mysql_fetch_assoc($res))
        {
          $sql ="UPDATE hesla_rel SET main_str='".$varianta["heslo_var"].
                "' WHERE id=".$rec["id"];
          $res = dbq($sql);
        }
        $sql ="SELECT  id,slave_str  FROM hesla_rel
                WHERE slave_hid=$hid and slave_str!='".$varianta["heslo_var"]."'";
        $res = dbq($sql);
        while($rec = mysql_fetch_assoc($res))
        {
          $sql ="UPDATE hesla_rel SET slave_str='".$varianta["heslo_var"].
                "' WHERE id=".$rec["id"];
          $res = dbq($sql);
        }
      }
    }
  };
  if(!empty($varianty_db))
    foreach($varianty_db as $var_id){
      smaz_variantu($var_id);
    }
 }

 function uloz_variantu($hid, $var_data, $var_id, $ord){
     global $prevodni_tabulka;
  $sqlData['hid'] = $hid;
  $sqlData['sortorder'] = $ord;
  $sqlData['neosemantismus'] = (isset($var_data['neosemantismus']) && $var_data['neosemantismus']=='1') ? 1 : 0;
  $sqlData['homonymie'] = "'".my_trim(text_db_preprocess($var_data['homonymie']))."'";
  $sqlData['varianta'] = "'".my_trim(text_db_preprocess(trim($var_data['heslo_var'])))."'";
  $sqlData['komentar'] = "'".my_trim(text_db_preprocess($var_data['komentar_varianty']))."'";
  $sqlData['komentar_za'] = "'".my_trim(text_db_preprocess($var_data['komentarza_varianty']))."'";
  //$sqlData['podhesli'] = "'".my_trim(text_db_preprocess($var_data['podhesli']))."'";
  //$sqlData['komentar_podhesli'] = "'".my_trim(text_db_preprocess($var_data['komentar_podhesli']))."'";
  //$sqlData['vystup_podhesli'] = "'".my_trim(text_db_preprocess($var_data['vystup_podhesli']))."'";
  $sqlData['prvni_reg_vyskyt'] = "'".my_trim(text_db_preprocess($var_data['prvni_registr_vyskyt']))."'";
  $sqlData['komentar_tvarchar'] = "'".my_trim(text_db_preprocess($var_data['komentar_tvarchar']))."'";
  $sqlData['komentar_tvarchar_slovesa'] = "'".my_trim(text_db_preprocess($var_data['komentar_tvarchar_slovesa']))."'";
  $sqlData['varianty_bez_zavor'] = "REPLACE(REPLACE(REPLACE(REPLACE('".my_trim(text_db_preprocess($var_data['heslo_var']))."', '(', ''), ')', ''), '[', ''), ']', '')";
  $sqlData['varianta_bd'] = strtr($sqlData['varianty_bez_zavor'],$prevodni_tabulka);
  $sqlData['f_varianta'] = "'".my_trim(text_db_preprocess($var_data['f_varianta']))."'";
  $sqlData['komentar_tvaru'] = "'".my_trim(text_db_preprocess(($var_data['komentar_tvaru'])))."'";
  $sqlData['komentar_tvaru_bz'] = "'".my_trim(strip_tags(text_db_preprocess(($var_data['komentar_tvaru']))))."'";


  //if(!is_numeric($var_id) || $var_id < 1) $var_id = 0; //bolo zakomentovane
  $var_id = sql_w('varianty', $sqlData, $var_id);
  osetri_linkovanie_pri_editacii_varianty($var_id);

  uloz_tvarChary('var',$var_id, $var_data['tvarChar']);
  uloz_tvarCharySl('var',$var_id, $var_data['tvarCharSl']);
  uloz_vyslovnosti($var_id, $var_data['vyslovnost']);
  uloz_slDruhy('var', $var_id, $var_data['slovny_druh']);
  uloz_vazebnosti('var', $var_id, $var_data['vazebnost']);

  uloz_vyber_cis('typ_hesla', $var_data['typ_hesla'], $var_id);
  uloz_vyber_cis('styl_kval', $var_data['styl_kval'], $var_id);
  uloz_vyber_cis('gram_info', $var_data['gram_info'], $var_id);
  uloz_vyber_cis('tematicke_okruhy', $var_data['tematicke_okruhy'], $var_id);
  uloz_vyber_cis('puvod',     $var_data['puvod'], $var_id);
  uloz_vyber_cis('obor_uziti',$var_data['obor_uziti'], $var_id);
 };

 function smaz_variantu($var_id){
  $DOMid = "varianta-$var_id--typ_hesla";
  smaz_nevyrizenou_korekturu($DOMid);
  smaz_vyber('typ_hesla',$var_id);

  $DOMid = "varianta-$var_id--tvar";
  smaz_nevyrizenou_korekturu($DOMid);

  $DOMid = "varianta-$var_id--homonymie";
  smaz_nevyrizenou_korekturu($DOMid);

  $DOMid = "varianta-$var_id--komentar";
  smaz_nevyrizenou_korekturu($DOMid);

  $DOMid = "varianta-$var_id--komentarza";
  smaz_nevyrizenou_korekturu($DOMid);

  /*
  $DOMid = "varianta-$var_id--tvar_podhesli";
  smaz_nevyrizenou_korekturu($DOMid);

  $DOMid = "varianta-$var_id--komentar_podhesli";
  smaz_nevyrizenou_korekturu($DOMid);
  */

  $DOMid = "varianta-$var_id--prvni_registr_vyskyt";
  smaz_nevyrizenou_korekturu($DOMid);

  $DOMid = "varianta-$var_id--komentar_tvarchar";
  smaz_nevyrizenou_korekturu($DOMid);

  $DOMid = "varianta-$var_id--komentar_tvarchar_slovesa";
  smaz_nevyrizenou_korekturu($DOMid);

  $DOMid = "varianta-$var_id--styl_kval";
  smaz_nevyrizenou_korekturu($DOMid);
  smaz_vyber('styl_kval',$var_id);

  $DOMid = "varianta-$var_id--gram_info";
  smaz_nevyrizenou_korekturu($DOMid);
  smaz_vyber('gram_info',$var_id);

  $DOMid = "varianta-$var_id--tematicke_okruhy";
  smaz_nevyrizenou_korekturu($DOMid);
  smaz_vyber('tematicke_okruhy',$var_id);

  $DOMid = "varianta-$var_id--puvod";
  smaz_nevyrizenou_korekturu($DOMid);
  smaz_vyber('puvod',$var_id);

  $DOMid = "varianta-$var_id--obor_uziti";
  smaz_nevyrizenou_korekturu($DOMid);
  smaz_vyber('obor_uziti',$var_id);

  $x = get('vyslovnosti_varianty', $var_id); foreach($x as $xid) smaz_vyslovnost($xid, $var_id);
  $x = get('vazebnosti_varianty', $var_id); foreach($x as $xid) smaz_vazebnost('var', $xid, $var_id);
  $x = get('slovneDruhy_varianty', $var_id); foreach($x as $xid) smaz_slDruh('var', $xid, $var_id);
  $x = get('tvarChary_varianty', $var_id); foreach($x as $xid) smaz_tvarChar('var', $xid, $var_id);
  $x = get('tvarCharySl_varianty', $var_id); foreach($x as $xid) smaz_tvarCharSl('var', $xid, $var_id);
  $sql = "DELETE FROM varianty WHERE id=$var_id";
  $res = mysql_query($sql) or die("Chyba DB! [f: smaz_varianty()] <p>".mysql_error()."</p><p>$sql</p>");
};

 function uloz_zpracovatele($zpracovatele, $hid){
  $slq_del = "DELETE FROM zpracovatel WHERE hid = $hid";
  $res_del = mysql_query($slq_del) or die("Chyba DB (pri mazani)! [f: uloz_zpracovatele()] <p>".mysql_error()."</p><p>$sql_del</p>");
  $ord=0;
  foreach($zpracovatele as $uid){
    $ord++;
    $d['hid'] = $hid;
    $d['uid'] = $uid;
    $d['sortorder'] = $ord;
    sql_w('zpracovatel', $d);
  }
 }

 function uloz_vyslovnosti($var_id, $vyslovnosti){
  $vysl_db = get('vyslovnosti_varianty', $var_id);
  if(!empty($vyslovnosti))
    foreach($vyslovnosti as $vysl_id => $vyslData){
      if(is_numeric($vysl_id) && $vysl_id > 0) unset($vysl_db[array_search($vysl_id, $vysl_db)]);
      $vysl_id = uloz_vyslovnost($var_id, $vyslData, $vysl_id);
    }

  if(!empty($vysl_db))
    foreach($vysl_db as $vysl_id){
      smaz_vyslovnost($vysl_id, $var_id);
    }
 }

 function uloz_vyslovnost($var_id, $vyslData, $vysl_id){
  $sqlData['vid'] = $var_id;
  $sqlData['vyslovnost'] = "'".my_trim(text_db_preprocess($vyslData['text']))."'";
  $sqlData['komentar'] = "'".my_trim(text_db_preprocess($vyslData['komentar']))."'";

  if(!is_numeric($vysl_id) || $vysl_id < 1) $vysl_id = 0;
  return sql_w('vyslovnost_var', $sqlData, $vysl_id);
 }

 function smaz_vyslovnost($vysl_id, $var_id=0){
  $sql = "DELETE FROM vyslovnost_var WHERE id=$vysl_id;";
  $DOMid = "varianta-$var_id--vyslovnost-$vysl_id--tvar";
  smaz_nevyrizenou_korekturu($DOMid);
  $DOMid = "varianta-$var_id--vyslovnost-$vysl_id--komentar";
  smaz_nevyrizenou_korekturu($DOMid);
  $res = mysql_query($sql) or die("Chyba DB! [f: smaz_vyslovnost()] <p>".mysql_error()."</p><p>$sql</p>");
 }

 function uloz_vazebnosti($parent, $pid, $vazebnosti){
  if ($parent == 'podh'){
    $vaz_db = get('vazebnosti_podhesli', $pid);
  }else{
    $vaz_db = ($parent=='vyz') ? get('vazebnosti_vyznamu', $pid) : get('vazebnosti_varianty', $pid);
  }
  if(!empty($vazebnosti))
    foreach($vazebnosti as $vaz_id => $vaz_data){
      if(is_numeric($vaz_id) && $vaz_id > 0) unset($vaz_db[array_search($vaz_id, $vaz_db)]);
      $vaz_id = uloz_vazebnost($parent, $pid, $vaz_data, $vaz_id);
    }

  if(!empty($vaz_db))
    foreach($vaz_db as $vaz_id){
      smaz_vazebnost($parent, $vaz_id, $pid);
    }
 }

 function uloz_vazebnost($parent, $pid, $vaz_data, $vaz_id){
  if($parent=='vyz'){
   $sqlData['vyz_id'] = $pid;
  }elseif($parent == 'podh'){
    $sqlData['podh_id'] = $pid;
  }else{
    $sqlData['vid'] = $pid;
  }
  $sqlData['vazebnost'] = "'".my_trim(text_db_preprocess($vaz_data['text']))."'";
  $sqlData['komentar'] = "'".my_trim(text_db_preprocess($vaz_data['komentar']))."'";

  if(!is_numeric($vaz_id) || $vaz_id < 1) $vaz_id = 0;
  if ($parent == 'podh'){
    return sql_w('podhesli_vazebnost', $sqlData, $vaz_id);
  }else{
    return ($parent=='vyz') ? sql_w('vazebnost_vyz', $sqlData, $vaz_id) : sql_w('vazebnost_var', $sqlData, $vaz_id);
  }
 }

 function smaz_vazebnost($parent, $vaz_id, $pid = 0){
  if($parent=='vyz'){
    $DOMid = "vyznam-$pid--vazebnost-$vaz_id--tvar";
    smaz_nevyrizenou_korekturu($DOMid);
    $DOMid = "vyznam-$pid--vazebnost-$vaz_id--komentar";
    smaz_nevyrizenou_korekturu($DOMid);
    $sql = "DELETE FROM vazebnost_vyz WHERE id=$vaz_id";
  }
  elseif($parent == 'podh'){
    $DOMid = "podhesli-$pid--vazebnost-$vaz_id--tvar";
    smaz_nevyrizenou_korekturu($DOMid);
    $DOMid = "podhesli-$pid--vazebnost-$vaz_id--komentar";
    smaz_nevyrizenou_korekturu($DOMid);
    $sql = "DELETE FROM podhesli_vazebnost WHERE id=$vaz_id";
  }else{
    $DOMid = "varianta-$pid--vazebnost-$vaz_id--tvar";
    smaz_nevyrizenou_korekturu($DOMid);
    $DOMid = "varianta-$pid--vazebnost-$vaz_id--komentar";
    smaz_nevyrizenou_korekturu($DOMid);
    $sql = "DELETE FROM vazebnost_var WHERE id=$vaz_id";
  }
  $res = mysql_query($sql) or die("Chyba DB! [f: smaz_vazebnost()] <p>".mysql_error()."</p><p>$sql</p>");
 }

 function uloz_slDruhy($parent, $pid, $slDruhy_arr){
  if ($parent == 'podh'){
    $parent = 'podh_vyz';
    $sd = 'podh_vyz_slov_druhy';
  }else{
    $sd = ($parent == 'vyz') ? 'slovneDruhy_vyznamu' : 'slovneDruhy_varianty';
  }
  $slDr_db = get($sd, $pid);
  if(hasValues($slDruhy_arr) || 1)
    foreach($slDruhy_arr as $slDr_id => $slDr_data){
//      if(!hasValues($slDr_data)) continue;
      if(is_numeric($slDr_id) && $slDr_id > 0) unset($slDr_db[array_search($slDr_id, $slDr_db)]);
      $slDr_id = uloz_slDruh($parent, $pid, $slDr_data, $slDr_id);
    }

  if(!empty($slDr_db))
    foreach($slDr_db as $slDr_id){
      smaz_slDruh($parent, $slDr_id, $pid);
    }
 }

 function uloz_slDruh($parent, $pid, $slDr_data, $slDr_id){
  if(!in_array($parent, array('var', 'vyz', 'podh_vyz'))) die('Fatalna chyba! [f: uloz_slDruh()]');
  if(!is_numeric($pid) || $pid <1 ) $pid = NULL;
  if ($parent == 'podh_vyz'){
    $fk = 'podh_id';
  }else{
    $fk = ($parent == 'vyz') ? 'vyz_id' : 'vid';
  }
  $sqlData[$fk] = $pid;
  $sqlData['komentar'] = "'".my_trim(text_db_preprocess($slDr_data['koment']))."'";
  if(!is_numeric($slDr_id) || $slDr_id<1) $slDr_id = 0;
  $slDr_id = sql_w($parent.'_slov_druhy_vyber_rel', $sqlData, $slDr_id);
  if ($parent == 'podh_vyz'){
    $sd = 'slov_druhy_podh';
  }else{
    $sd = 'slov_druhy'.(($parent == 'vyz') ? '_vyz' : '');
  }
  uloz_vyber_cis($sd, $slDr_data['cisVyber'], $slDr_id);
 }

 function smaz_slDruh($parent, $slDr_id, $pid = 0){
  if(!in_array($parent, array('var', 'vyz', 'podh_vyz'))) die('Fatalna chyba! [f: smaz_slDruh()]');
  if ($parent == 'podh_vyz'){
    $sd = 'slov_druhy_podh';
  }else{
    $sd = 'slov_druhy'.(($parent == 'vyz') ? '_vyz' : '');
  }
  smaz_vyber($sd, $slDr_id);
  if($parent == 'var'){
    $DOMid = "varianta-$pid--slovnyDruh-$slDr_id";
    smaz_nevyrizenou_korekturu($DOMid);
    $DOMid = "varianta-$pid--slovnyDruh-$slDr_id--komentar";
    smaz_nevyrizenou_korekturu($DOMid);
  } else if($parent== 'vyz'){
    $DOMid = "vyznam-$pid--slovnyDruh-$slDr_id";
    smaz_nevyrizenou_korekturu($DOMid);
    $DOMid = "vyznam-$pid--slovnyDruh-$slDr_id--komentar";
    smaz_nevyrizenou_korekturu($DOMid);
  } else{
    $DOMid = "podhesli-$pid--slovnyDruh-$slDr_id";
    smaz_nevyrizenou_korekturu($DOMid);
    $DOMid = "podhesli-$pid--slovnyDruh-$slDr_id--komentar";
    smaz_nevyrizenou_korekturu($DOMid);
  }
  $sql = "DELETE FROM ".$parent."_slov_druhy_vyber_rel WHERE id=$slDr_id";
  $res = mysql_query($sql) or die("Chyba DB! [f: smaz_slDruh()] <p>".mysql_error()."</p><p>$sql</p>");
 }

 function uloz_tvarChary($parent, $pid, $tvCh_arr){
  if(!in_array($parent, array('var', 'vyz', 'podh'))) die('Fatalna chyba! [f: uloz_tvarChary()]');
  if ($parent == 'podh'){
    $tvChV = 'tvarChary_podhesli';
  }else{
    $tvChV = ($parent == 'vyz') ? 'tvarChary_vyznamu' : 'tvarChary_varianty';
  }
  $tvCh_db = get($tvChV, $pid);
  if(hasValues($tvCh_arr) || 1){
    $ord = 0;
    foreach($tvCh_arr as $tvCh_id => $tvChData){
      $ord++;
//      if(!hasValues($tvChData)) continue;
      if(is_numeric($tvCh_id) && $tvCh_id > 0) unset($tvCh_db[array_search($tvCh_id, $tvCh_db)]);
      $tvCh_id = uloz_tvarChar($parent, $pid, $tvChData, $tvCh_id, $ord);
    }
  }
  if(!empty($tvCh_db))
    foreach($tvCh_db as $tvCh_id){
      smaz_tvarChar($parent, $tvCh_id, $pid);
    }
 }

 function uloz_tvarChar($parent, $pid, $tvChData, $tvCh_id, $ord){
  if(!in_array($parent, array('var', 'vyz', 'podh'))) die('Fatalna chyba! [f: uloz_tvarChar()]');
  if(!is_numeric($pid) || $pid <1 ) $pid = NULL;
  if ($parent == 'podh'){
    $tbl = 'podh_tvar_char_vyber_rel';
    $vid = 'podh_id';
  }elseif($parent == 'vyz'){
    $tbl = 'vyz_tvar_char_vyber_rel';
    $vid = 'vyz_id';
  }else{
    $tbl = 'var_tvar_char_vyber_rel';
    $vid = 'vid';
  }
  $sqlData[$vid] = $pid;
  $sqlData['sortorder'] = $ord;
  if(!is_numeric($tvCh_id) || $tvCh_id<1) $tvCh_id = 0;
  $tvCh_id = sql_w($tbl, $sqlData, $tvCh_id);

  uloz_tvarChar_koncovky($parent, $tvCh_id, $tvChData['koncovka']);

  if ($parent == 'podh'){
    $tvChv = 'tvar_char_podh';
  }else{
    $tvChv = ($parent == 'vyz') ? 'tvar_char_vyz' : 'tvar_char';
  }
  uloz_vyber_cis($tvChv, $tvChData['cisVyber'], $tvCh_id);
  /*
  if($parent == 'vyz'){
    echo "uloz_tvarChar";
    var_dump($parent); var_dump($tvChData);
  }
  */
 }

 function smaz_tvarChar($parent, $tvCh_id, $pid = 0){
  if(!in_array($parent, array('var', 'vyz', 'podh'))) die('Fatalna chyba! [f: smaz_tvarChar()]');
  if ($parent == 'podh'){
    $tvChv = 'tvar_char_podh';
  }else{
    $tvChv = ($parent == 'vyz') ? 'tvar_char_vyz' : 'tvar_char';
  }
  smaz_vyber($tvChv, $tvCh_id);
  if($parent == 'var'){
    $DOMid = "varianta-$pid--tvarChar-$tvCh_id";
    smaz_nevyrizenou_korekturu($DOMid);
  } else if($parent=='vyz'){
    $DOMid = "vyznam-$pid--tvarChar-$tvCh_id";
    smaz_nevyrizenou_korekturu($DOMid);
  } else{
    $DOMid = "podhesli-$pid--tvarChar-$tvCh_id";
    smaz_nevyrizenou_korekturu($DOMid);
  }
  if ($parent == 'podh'){
    $tvChKv = 'koncovky_tvCh_podh';
  }else{
    $tvChKv = ($parent == 'vyz') ? "koncovky_tvarChar_vyz" : "koncovky_tvarChar";
  }
  $x = get($tvChKv, $tvCh_id);
  foreach($x as $xid){
    if($parent == 'var'){
      $DOMid = "varianta-$pid--tvarChar-$tvCh_id--koncovka-$xid--tvar";
      smaz_nevyrizenou_korekturu($DOMid);
      $DOMid = "varianta-$pid--tvarChar-$tvCh_id--koncovka-$xid--komentar";
      smaz_nevyrizenou_korekturu($DOMid);
    } else if($parent == 'vyz'){
      $DOMid = "vyznam-$pid--tvarChar-$tvCh_id--koncovka-$xid--tvar";
      smaz_nevyrizenou_korekturu($DOMid);
      $DOMid = "vyznam-$pid--tvarChar-$tvCh_id--koncovka-$xid--komentar";
      smaz_nevyrizenou_korekturu($DOMid);
    } else{
      $DOMid = "podhesli-$pid--tvarChar-$tvCh_id--koncovka-$xid--tvar";
      smaz_nevyrizenou_korekturu($DOMid);
      $DOMid = "podhesli-$pid--tvarChar-$tvCh_id--koncovka-$xid--komentar";
      smaz_nevyrizenou_korekturu($DOMid);
    }
    smaz_tvarChar_koncovku($parent, $xid);
  }
  if ($parent == 'podh'){
    $tbl = 'podh_tvar_char_vyber_rel';
  }else{
    $tbl = ($parent == 'vyz') ? 'vyz_tvar_char_vyber_rel' : 'var_tvar_char_vyber_rel';
  }
  $sql = "DELETE FROM $tbl WHERE id=$tvCh_id";
  $res = mysql_query($sql) or die("Chyba DB! [f: smaz_tvarChar()] <p>".mysql_error()."</p><p>$sql</p>");
 }

 function uloz_tvarChar_koncovky($parent, $tvCh_id, $konc_arr){
  if(!in_array($parent, array('var', 'vyz', 'podh'))) die('Fatalna chyba! [f: uloz_tvarChar_koncovky()]');
  if ($parent == 'podh'){
    $tvChKv = 'koncovky_tvCh_podh';
  }else{
    $tvChKv = ($parent == 'vyz') ? "koncovky_tvarChar_vyz" : "koncovky_tvarChar";
  }
  $konc_db = get($tvChKv, $tvCh_id);
  if(hasValues($konc_arr) || 1){
    $ord = 0;
    foreach($konc_arr as $konc_id => $koncData){
      $ord++;
      if(is_numeric($konc_id) && $konc_id>0) unset($konc_db[array_search($konc_id, $konc_db)]);
      $konc_id = uloz_tvarChar_konc($parent, $tvCh_id, $koncData, $konc_id, $ord);
    }
  }
  if(!empty($konc_db)) foreach($konc_db as $konc_id) smaz_tvarChar_koncovku($parent, $konc_id);
 }

 function uloz_tvarChar_konc($parent, $tvCh_id, $koncData, $konc_id, $ord){
   if(!in_array($parent, array('var', 'vyz', 'podh'))) die('Fatalna chyba! [f: uloz_tvarChar_konc()]');
   if($parent == 'podh'){
    $tvChRelId = 'podh_tvch';
    $tbl = 'podh_vyz_koncovky_tvar_char';
   }elseif($parent == 'vyz'){
    $tvChRelId = 'vyz_tvar_char_rel_id';
    $tbl = 'koncovky_tvar_char_vyz';
   }else{
    $tvChRelId = 'var_tvar_char_rel_id';
    $tbl = 'koncovky_tvar_char';
   }
   $sqlData[$tvChRelId] = $tvCh_id;
   $sqlData['koncovka'] = "'".my_trim(text_db_preprocess($koncData['tvar']))."'";
   $sqlData['komentar'] = "'".my_trim(text_db_preprocess($koncData['komentar']))."'";
   $sqlData['sortorder'] = $ord;

   if(!is_numeric($konc_id) || $konc_id < 1) $konc_id = 0;
   return sql_w($tbl, $sqlData, $konc_id);
 }

 function smaz_tvarChar_koncovku($parent, $koncID){
  if(!in_array($parent, array('var', 'vyz', 'podh'))) die('Fatalna chyba! [f: smaz_tvarChar()]');
  if ($parent == 'podh'){
    $tbl = 'podh_vyz_koncovky_tvar_char';
  }else{
    $tbl = ($parent == 'vyz') ? 'koncovky_tvar_char_vyz' : 'koncovky_tvar_char';
  }
  $sql = "DELETE FROM $tbl WHERE id=$koncID";
  $res = mysql_query($sql) or die("Chyba DB! [f: smaz_tvarChar_koncovku()] <p>".mysql_error()."</p><p>$sql</p>");
 }

 function uloz_tvarCharySl($parent, $pid, $tvCh_arr){
  if(!in_array($parent, array('var', 'vyz', 'podh'))) die('Fatalna chyba! [f: uloz_tvarCharySl()]');
  if ($parent == 'podh'){
    $tvChV = 'tvarCharySl_podhesli';
  }else{
    $tvChV = ($parent == 'vyz') ? 'tvarCharySl_vyznamu' : 'tvarCharySl_varianty';
  }
  //$tvCh_db = get('tvarCharySl_varianty', $pid);
  $tvCh_db = get($tvChV, $pid);
  if(hasValues($tvCh_arr) || 1){
    $ord = 0;
    foreach($tvCh_arr as $tvCh_id => $tvChData){
      $ord++;
//      if(!hasValues($tvChData)) continue;
      if(is_numeric($tvCh_id) && $tvCh_id > 0) unset($tvCh_db[array_search($tvCh_id, $tvCh_db)]);
      $tvCh_id = uloz_tvarCharSl($parent, $pid, $tvChData, $tvCh_id, $ord);
    }
  }

  if(!empty($tvCh_db))
    foreach($tvCh_db as $tvCh_id){
      smaz_tvarCharSl($parent, $tvCh_id, $pid);
    }
 }

 function uloz_tvarCharSl($parent, $pid, $tvChData, $tvCh_id, $ord){
  if(!in_array($parent, array('var', 'vyz', 'podh'))) die('Fatalna chyba! [f: uloz_tvarCharSl()]');
  if(!is_numeric($pid) || $pid <1 ) $pid = NULL;
  if($parent == 'podh'){
    $tbl = 'podh_tvar_char_sl_vyber_rel';
    $vid = 'podh_id';
  }elseif($parent == 'vyz'){
    $tbl = 'vyz_tvar_char_sl_vyber_rel';
    $vid = 'vyz_id';
  }else{
    $tbl = 'var_tvar_char_sl_vyber_rel';
    $vid = 'vid';
  }

  $sqlData[$vid] = $pid;
  $sqlData['sortorder'] = $ord;
  if(!is_numeric($tvCh_id) || $tvCh_id<1) $tvCh_id = 0;
  $tvCh_id = sql_w($tbl, $sqlData, $tvCh_id);
  uloz_tvarCharSl_koncovky($parent, $tvCh_id, $tvChData['koncovka']);
  if ($parent == 'podh'){
    $tvChv = 'tvar_char_sl_podh';
  }else{
    $tvChv = ($parent == 'vyz') ? 'tvar_char_sl_vyz' : 'tvar_char_sl';
  }
  uloz_vyber_cis($tvChv, $tvChData['cisVyber'], $tvCh_id);
 }

 function smaz_tvarCharSl($parent, $tvCh_id, $pid = 0){
  if(!in_array($parent, array('var', 'vyz', 'podh'))) die('Fatalna chyba! [f: smaz_tvarCharSl()]');
  if ($parent == 'podh'){
    $tvChv = 'tvar_char_sl_podh';
  }else{
    $tvChv = ($parent == 'vyz') ? 'tvar_char_sl_vyz' : 'tvar_char_sl';
  }
  if($parent == 'var'){
    $DOMid = "varianta-$pid--tvarCharSl-$tvCh_id";
    smaz_nevyrizenou_korekturu($DOMid);
  } else if($parent == 'vyz') {
    $DOMid = "vyznam-$pid--tvarCharSl-$tvCh_id";
    smaz_nevyrizenou_korekturu($DOMid);
  } else{
    $DOMid = "podhesli-$pid--tvarCharSl-$tvCh_id";
    smaz_nevyrizenou_korekturu($DOMid);
  }
  smaz_vyber($tvChv, $tvCh_id);
  if ($parent == 'podh'){
    $tvChKv = 'koncovky_tvarCharSl_podh';
  }else{
    $tvChKv = ($parent == 'vyz') ? "koncovky_tvarCharSl_vyz" : "koncovky_tvarCharSl";
  }
  $x = get($tvChKv, $tvCh_id);
  foreach($x as $xid){
    if($parent == 'var'){
      $DOMid = "varianta-$pid--tvarCharSl-$tvCh_id--koncovka-$xid--tvar";
      smaz_nevyrizenou_korekturu($DOMid);
      $DOMid = "varianta-$pid--tvarCharSl-$tvCh_id--koncovka-$xid--komentar";
      smaz_nevyrizenou_korekturu($DOMid);
    } else if($parent=='vyz'){
      $DOMid = "vyznam-$pid--tvarCharSl-$tvCh_id--koncovka-$xid--tvar";
      smaz_nevyrizenou_korekturu($DOMid);
      $DOMid = "vyznam-$pid--tvarCharSl-$tvCh_id--koncovka-$xid--komentar";
      smaz_nevyrizenou_korekturu($DOMid);
    } else{
      $DOMid = "podhesli-$pid--tvarCharSl-$tvCh_id--koncovka-$xid--tvar";
      smaz_nevyrizenou_korekturu($DOMid);
      $DOMid = "podhesli-$pid--tvarCharSl-$tvCh_id--koncovka-$xid--komentar";
      smaz_nevyrizenou_korekturu($DOMid);
    }
    smaz_tvarCharSl_koncovku($parent, $xid);
  }
  if ($parent == 'podh'){
    $tbl = 'podh_tvar_char_sl_vyber_rel';
  }else{
    $tbl = ($parent == 'vyz') ? 'vyz_tvar_char_sl_vyber_rel' : 'var_tvar_char_sl_vyber_rel';
  }
  $sql = "DELETE FROM $tbl WHERE id=$tvCh_id";
  $res = mysql_query($sql) or die("Chyba DB! [f: smaz_tvarCharSl()] <p>".mysql_error()."</p><p>$sql</p>");
 }

 function uloz_tvarCharSl_koncovky($parent, $tvCh_id, $konc_arr){
  if(!in_array($parent, array('var', 'vyz', 'podh'))) die('Fatalna chyba! [f: uloz_tvarCharSl_koncovky()]');
  if ($parent == 'podh'){
    $tvChKv = 'koncovky_tvarCharSl_podh';
  }else{
    $tvChKv = ($parent == 'vyz') ? "koncovky_tvarCharSl_vyz" : "koncovky_tvarCharSl";
  }
  $konc_db = get($tvChKv, $tvCh_id);
  if(hasValues($konc_arr) || 1){
    $ord = 0;
    foreach($konc_arr as $konc_id => $koncData){
      $ord++;
      if(is_numeric($konc_id) && $konc_id>0) unset($konc_db[array_search($konc_id, $konc_db)]);
      $konc_id = uloz_tvarCharSl_konc($parent, $tvCh_id, $koncData, $konc_id, $ord);
    }
  }

  if(!empty($konc_db)) foreach($konc_db as $konc_id) smaz_tvarCharSl_koncovku($parent, $konc_id);
 }

 function uloz_tvarCharSl_konc($parent, $tvCh_id, $koncData, $konc_id, $ord){
   if(!in_array($parent, array('var', 'vyz', 'podh'))) die('Fatalna chyba! [f: uloz_tvarCharSl_konc()]');
   if($parent == 'podh'){
    $tvChRelId = 'podh_tvch_sl';
    $tbl = 'podh_vyz_koncovky_tvar_char_sl';
   }elseif($parent == 'vyz'){
    $tvChRelId = 'vyz_tvar_char_sl_rel_id';
    $tbl = 'koncovky_tvar_char_sl_vyz';
   }else{
    $tvChRelId = 'var_tvar_char_sl_rel_id';
    $tbl = 'koncovky_tvar_char_sl';
   }

   $sqlData[$tvChRelId] = $tvCh_id;
   $sqlData['koncovka'] = "'".my_trim(text_db_preprocess($koncData['tvar']))."'";
   $sqlData['komentar'] = "'".my_trim(text_db_preprocess($koncData['komentar']))."'";
   $sqlData['sortorder'] = $ord;

   if(!is_numeric($konc_id) || $konc_id < 1) $konc_id = 0;
   return sql_w($tbl, $sqlData, $konc_id);
 }

 function smaz_tvarCharSl_koncovku($parent, $koncID){
  if(!in_array($parent, array('var', 'vyz', 'podh'))) die('Fatalna chyba! [f: smaz_tvarCharSl_koncovku()]');
  if ($parent == 'podh'){
    $tbl = 'podh_vyz_koncovky_tvar_char_sl';
  }else{
    $tbl = ($parent == 'vyz') ? 'koncovky_tvar_char_sl_vyz' : 'koncovky_tvar_char_sl';
  }
  $sql = "DELETE FROM $tbl WHERE id=$koncID";
  $res = mysql_query($sql) or die("Chyba DB! [f: smaz_tvarCharSl_koncovku()] <p>".mysql_error()."</p><p>$sql</p>");
 }

function uloz_predvyklad($parent, $vyz_id, $predv_arr, $master=""){
  if($parent != 'vyz') die('Fatalna chyba! [f: uloz_predvyklad()]');
  $db_data = get('vyrazy_predvykladu'.$master, $vyz_id);
  $ord = 0;
  if (!isset($predv_arr)) $predv_arr = array();
  foreach ($predv_arr as $id => $val){
    //if (!$val['tvar']) continue;
    if($id && is_numeric($id)){
      unset($db_data[array_search($id, $db_data)]);
    }else{
      $id = 0;
    }
    $sqlData['vyz_id'] = $vyz_id;
    $sqlData['vyraz'] = "'".my_trim(text_db_preprocess($val['tvar']))."'";
    $sqlData['komentar'] = "'".my_trim(text_db_preprocess($val['komentar']))."'";
    $sqlData['sortorder'] = $ord;
    sql_w('vyrazy_predvykladu'.$master, $sqlData, $id);
    $ord++;
  }
  foreach($db_data as $db_id){
    $DOM_id = "vyznam-$vyz_id--vyraz_predvykladu.$master-$db_id";
    smaz_nevyrizenou_korekturu($DOM_id);
    $DOM_id = "vyznam-$vyz_id--komentar_predvykladu.$master-$db_id";
    smaz_nevyrizenou_korekturu($DOM_id);
    if($master=="_m")
    {
      smaz_tvar_predvykladu_m($db_id);
    }
    else
    {
      smaz_tvar_predvykladu($db_id);
    }
  }
}

function smaz_tvar_predvykladu_m($id){
  mysql_query('DELETE FROM vyrazy_predvykladu_m WHERE id='.mysql_escape_string($id));
}

function smaz_tvar_predvykladu($id){
  mysql_query('DELETE FROM vyrazy_predvykladu WHERE id='.mysql_escape_string($id));
}

function smaz_tvary_predvykladu($vyz_id){
  mysql_query('DELETE FROM vyrazy_predvykladu WHERE vyz_id='.mysql_real_escape_string($vyz_id));
}

 function uloz_vyznamy($hid, $vyznamy){
  $mainvyznamy_db = get('vyznamy_hesla', $hid);

  $subvyznamy_db = array();
  if ($mainvyznamy_db){
    $new_heslo = False;
    foreach($mainvyznamy_db as $vyz_id){
      $subvyznamy_db = array_merge($subvyznamy_db, get('podvyznamy_hesla', $hid, array('sortorder'), $vyz_id));
    }
  }else{ //heslo nema zadny vyznam => je nejspise nove
    $new_heslo = True;
  }

  $vyznamy_db = array_merge($mainvyznamy_db, $subvyznamy_db);

  $ord = 0;
  foreach($vyznamy as $vyz_id => $vyznam){
    $ord++;
    if(is_numeric($vyz_id) && $vyz_id > 0)
    {
      unset($vyznamy_db[array_search( $vyz_id, $vyznamy_db )]);
    }
    if($vyznam['vyz_pid'] == 'COPY')
    {
      $vyznam['vyz_pid'] = $prev_vyz_id;
      uloz_vyznam($hid, $vyznam, $vyz_id, $ord);
    }
    else
    {
      $prev_vyz_id = uloz_vyznam($hid, $vyznam, $vyz_id, $ord);
    }
  }
  if(!empty($vyznamy_db))
    foreach($vyznamy_db as $vyz_id){
      smaz_vyznam($vyz_id);
    }
 }

 function uloz_vyslovnosti_podhesli($podh_id, $vyslovnosti){
  $dbdata = get('podh_vyz_vyslovnost', $podh_id);
  if(!empty($vyslovnosti))
    foreach($vyslovnosti as $vysl_id => $vyslData){
      if(is_numeric($vysl_id) && $vysl_id > 0) unset($dbdata[array_search($vysl_id, $dbdata)]);
      $vysl_id = uloz_vyslovnost_podhesli($podh_id, $vyslData, $vysl_id);
    }

  if(!empty($dbdata))
    foreach($dbdata as $vysl_id){
      smaz_vyslovnost_podhesli($vysl_id, $podh_id);
    }
 }

 function uloz_vyslovnost_podhesli($podh_id, $vyslData, $vysl_id){
  $sqlData['podh_id'] = $podh_id;
  $sqlData['vyslovnost'] = "'".my_trim(text_db_preprocess($vyslData['text']))."'";
  $sqlData['komentar'] = "'".my_trim(text_db_preprocess($vyslData['komentar']))."'";

  if(!is_numeric($vysl_id) || $vysl_id < 1) $vysl_id = 0;
  return sql_w('podh_vyz_vyslovnost', $sqlData, $vysl_id);
 }

 function smaz_vyslovnost_podhesli($vysl_id, $podh_id=0){
  $DOMid = "podhesli-$podh_id--vyslovnost-$vysl_id--tvar";
  smaz_nevyrizenou_korekturu($DOMid);
  $DOMid = "podhesli-$podh_id--vyslovnost-$vysl_id--komentar";
  smaz_nevyrizenou_korekturu($DOMid);
  $sql = "DELETE FROM podh_vyz_vyslovnost WHERE id=$vysl_id;";
  $res = mysql_query($sql) or die("Chyba DB! [f: smaz_vyslovnost_podhesli()] <p>".mysql_error()."</p><p>$sql</p>");
 }

 function uloz_podhesli_vyznamu($vyz_id, $data, $podh_id){
  $sqlData['podhesli'] = "'".my_trim(text_db_preprocess($data['podhesli']))."'";
  $sqlData['komentar_pred'] = "'".my_trim(text_db_preprocess($data['komentar_pred']))."'";
  $sqlData['komentar_za'] = "'".my_trim(text_db_preprocess($data['komentar_za']))."'";
  $sqlData['komentar_tvarchar'] = "'".my_trim(text_db_preprocess($data['komentar_tvarchar']))."'";
  $sqlData['komentar_tvarchar_slovesa'] = "'".my_trim(text_db_preprocess($data['komentar_tvarchar_slovesa']))."'";
  $sqlData['vyz_id'] = $vyz_id;

  $podh_id = sql_w('podhesli_vyznamu', $sqlData, $podh_id);
  uloz_vyslovnosti_podhesli($podh_id, $data['vyslovnost']); //vyslovnost
  uloz_vazebnosti('podh', $podh_id, $data['vazebnost']); //valence/vazebnost
  uloz_slDruhy('podh', $podh_id, $data['slovny_druh']); //slovni druhy
  uloz_vyber_cis('gram_info_podh', $data['gram_info'], $podh_id); //upresnujici gramaticka informace
  uloz_vyber_cis('styl_kval_podh', $data['styl_kval'], $podh_id); //stylisticky kvalifikator
  uloz_vyber_cis('tematicke_okruhy_podh', $data['tematicke_okruhy'], $podh_id); //tematicke okruhy
  uloz_vyber_cis('obor_uziti_podh', $data['obor_uziti'], $podh_id); //obor/oblast uziti
  uloz_tvarChary('podh',$podh_id, $data['tvarChar']); //tvaroslovna charakteristika
  uloz_tvarCharySl('podh',$podh_id, $data['tvarCharSl']); //tvaroslovna charakteristika slovesa

 }

 function smaz_podhesli_vyznamu($podh_id, $vyz_id=False){
  $x = get('podh_vyz_vyslovnost', $podh_id);
  foreach ($x as $xid){
      smaz_vyslovnost_podhesli($xid, $podh_id);
  }
  $x = get('podh_vyz_slov_druhy', $podh_id);
  foreach($x as $xid){
      smaz_slDruh('podh_vyz', $xid, $vyz_id);
  }

  smaz_vazebnost('podh', $podh_id);


  $DOMid = "podhesli-$podh_id--gram_info";
  smaz_nevyrizenou_korekturu($DOMid);
  smaz_vyber('gram_info_podh',$podh_id);

  $DOMid = "podhesli-$podh_id--styl_kval";
  smaz_nevyrizenou_korekturu($DOMid);
  smaz_vyber('styl_kval_podh', $podh_id);

  $DOMid = "podhesli-$podh_id--tematicke_okruhy";
  smaz_nevyrizenou_korekturu($DOMid);
  smaz_vyber('tematicke_okruhy_podh', $podh_id);

  $DOMid = "podhesli-$podh_id--obor_uziti";
  smaz_nevyrizenou_korekturu($DOMid);
  smaz_vyber('obor_uziti_podh', $podh_id);

  $x = get('tvarChary_podhesli', $podh_id);
  foreach($x as $xid){
      smaz_tvarChar('podh',$xid, $podh_id);
  }
  $x = get('tvarCharySl_podhesli', $podh_id);
  foreach($x as $xid){
      smaz_tvarCharSl('podh', $xid, $podh_id);
  }

  $DOMid = "podhesli-$podh_id--komentar_tvarchar";
  smaz_nevyrizenou_korekturu($DOMid);

  $DOMid = "podhesli-$podh_id--komentar_tvarchar_slovesa";
  smaz_nevyrizenou_korekturu($DOMid);

  $DOMid = "podhesli-$podh_id--komentar_podhesli";
  smaz_nevyrizenou_korekturu($DOMid);

  $DOMid = "podhesli-$podh_id--komentar_podhesli_za";
  smaz_nevyrizenou_korekturu($DOMid);

  $DOMid = "podhesli-$podh_id--tvar_podhesli";
  smaz_nevyrizenou_korekturu($DOMid);


  dbq('DELETE FROM podhesli_vyznamu WHERE id='.$podh_id);
 }

 function uloz_skupinu_podhesli($vyz_id, $data){
  $dbdata = get('podhesli_vyznamu', $vyz_id);
  foreach($data as $podh_id => $podh_vyz){
    if(is_numeric($podh_id) && $podh_id > 0){
      unset($dbdata[array_search($podh_id, $dbdata)]);
    }
    $prev_podh_id = uloz_podhesli_vyznamu($vyz_id, $podh_vyz, $podh_id);
  }

  if(!empty($dbdata))
    foreach($dbdata as $podh_id){
      smaz_podhesli_vyznamu($podh_id);
    }
 }

 function smaz_propojeny_vyznam($id){
  dbq('DELETE FROM propojeni_vyznamu WHERE id='.mysql_real_escape_string($id));
 }

 function uloz_propojeny_vyznam($vyz_id, $link_id, $cil_id, $link){
     if ($link == 'NULL') $link = False;
  // k tomuto dojde v jedinďż˝m pďż˝ďż˝padďż˝:
  // dďż˝dďż˝m vďż˝znam z hesla, kterďż˝ jeďż˝tďż˝ nemďż˝ informace ve vyznamy_master
  // k uloďż˝enďż˝ propojení dojde na stranďż˝ druhďż˝ho hesla, nenďż˝ tedy potďż˝eba ho provďż˝dďż˝t znovu
  if (!is_numeric($link) && !is_bool($link)) return;
  $link_id = is_numeric($link_id) ? $link_id : 0;
  if (is_numeric($link)){ //vďż˝znam je dďż˝dďż˝nďż˝
    $wr['vyz_m_from'] = $link;
  }else{ //vďż˝znam nenďż˝ dďż˝dďż˝nďż˝
    $wr['vyz_from'] = $vyz_id;
  }
  if (is_numeric($cil_id)){ //vazba na existujďż˝cďż˝ heslo
    $wr['vyz_to'] = $cil_id;
    $wr['heslo_id'] = 'NULL';
    $wr['heslo_to'] = '""';
  }elseif(strpos($cil_id, '%') === 0){ //vazba na heslo s neexistujďż˝cďż˝m vďż˝znamem
    $wr['heslo_id'] = substr($cil_id, 1);
    $wr['heslo_to'] = '"'.dibi::fetchSingle('SELECT varianta FROM varianty WHERE hid = %i AND sortorder = 1', $wr['heslo_id']).'"';
  }else{ //vazba na neexistujďż˝cďż˝ heslo
    $wr['heslo_to'] = '"'.mysql_real_escape_string($cil_id).'"';
  }
  $id = sql_w('propojeni_vyznamu', $wr, $link_id);
  return $id;
 }

 function uloz_propojene_vyznamy($vyz_id, $data, $link){
  $dbdata = is_numeric($link) ? get('propojene_vyznamy_master', $link) : get('propojene_vyznamy', $vyz_id);
  if(is_array($data)){
    foreach($data as $link_id => $cil_id){
      if(is_numeric($link_id) && $link_id > 0){ //propojení jiďż˝ existovalo => je v db
        unset($dbdata[array_search($link_id, $dbdata)]);
      }
      $prev_link_id = uloz_propojeny_vyznam($vyz_id, $link_id, $cil_id, $link);
      // update id spanu na reďż˝lnďż˝ id v databďż˝zi


      if (!is_numeric($link_id)){
        if (is_numeric($link)){ //vďż˝znam je dďż˝dďż˝nďż˝
          $vyklad = db_fetchSingle('SELECT vyklad_vyznamu FROM vyznamy_master WHERE id='.$link);
          $vyklad = mysql_real_escape_string(str_replace('link-'.$link_id, 'link-'.$prev_link_id, $vyklad));
            $temp=text_db_preprocess(strip_tags($vyklad));
          dbq('UPDATE vyznamy_master SET vyklad_vyznamu="'.$vyklad.'", vyklad_vyznamu_bz="'.$temp.'" WHERE id='.$link);
        }else{ //vďż˝znam nenďż˝ dďż˝dďż˝nďż˝
          $vyklad = db_fetchSingle('SELECT vyklad_vyznamu FROM vyznamy WHERE id='.$vyz_id);
          $vyklad = mysql_real_escape_string(str_replace('link-'.$link_id, 'link-'.$prev_link_id, $vyklad));
            $temp=text_db_preprocess(strip_tags($vyklad));
          dbq('UPDATE vyznamy SET vyklad_vyznamu="'.$vyklad.'", vyklad_vyznamu_bz="'.$temp.'" WHERE id='.$vyz_id);
        }
      }
    }
  }

  if(!empty($dbdata)){
    foreach($dbdata as $link_id){
      smaz_propojeny_vyznam($link_id);
    }
  }
//  zpďż˝tnďż˝ kontrola konzistence
//  odstraďż˝uje typ "nenďż˝ v textu, je v DB"
  $newdata = is_numeric($link) ? get('propojene_vyznamy_master', $link) : get('propojene_vyznamy', $vyz_id);
  $newvyklad = is_numeric($link) ? dibi::fetchSingle('SELECT vyklad_vyznamu FROM vyznamy_master WHERE id=%i', $link) : dibi::fetchSingle('SELECT vyklad_vyznamu FROM vyznamy WHERE id=%i', $vyz_id);
  foreach ($newdata as $l) {
    if (strpos($newvyklad, 'link-'.$l) === False){
      smaz_propojeny_vyznam($l);
    }
  }
//  typ "nenďż˝ v DB, je v textu"
     $str = $newvyklad;
     $matches = array();
     $num = preg_match_all('/id=\"link-[0-9]+\"/', $str, $matches);
     if ($num) {
         $col = is_numeric($link) ? 'vyz_m_from' : 'vyz_from';
         $val = is_numeric($link) ? $link : $vyz_id;
         foreach ($matches[0] as $m) {
             $lid = substr(substr($m, 9), 0, -1);
             if (!dibi::fetchSingle('SELECT 1 FROM propojeni_vyznamu WHERE id = %i AND %n = %i', $lid, $col, $val)) {
                 $stringArr = array();
                 $span_start = strpos($str, '<span id="link-' . $lid . '"');
                 $text_start = strpos($str, '>', $span_start);
                 $text_end = strpos($str, '</span>', $text_start);
                 $stringArr[0] = substr($str, 0, $span_start); // text pďż˝ed
                 $stringArr[1] = substr($str, $span_start, ($text_start - $span_start) + 1); // otevďż˝racďż˝ span
                 $stringArr[2] = substr($str, $text_start + 1, ($text_end - $text_start) - 1); // text uvnitďż˝
                 $stringArr[3] = substr($str, $text_end, 7); // zavďż˝racďż˝ span
                 $stringArr[4] = substr($str, $text_end + 7); // text za
                 unset($stringArr[1], $stringArr[3]);
                 $new = implode('', $stringArr);
                 $temp=text_db_preprocess(strip_tags($new));
                 if (is_numeric($link)) {
                     dibi::query('UPDATE vyznamy_master SET vyklad_vyznamu = %s, vyklad_vyznamu_bz= %s WHERE id = %i', $new, $temp, $link);
                 } else {
                     dibi::query('UPDATE vyznamy SET vyklad_vyznamu = %s, vyklad_vyznamu_bz= %s  WHERE id = %i', $new, $temp, $vyz_id);
                 }
             }
         }
     }
 }

 function fix_vyznam_ord($vyz_id, $neword){
  return;
  $ord = db_fetchSingle('SELECT sortorder FROM vyznamy WHERE id='.$vyz_id);
  if ($ord != $neword){ //je potďż˝eba zmďż˝nit texty ve vďż˝kladech pďż˝ipojenďż˝ch vďż˝znamďż˝
    $conn = db_get_val_arr('SELECT v.id, vyklad_vyznamu FROM propojeni_vyznamu INNER JOIN vyznamy v ON vyz_from=v.id WHERE vyz_to='.$vyz_id, array('id' => 'vyklad_vyznamu'));
    foreach ($conn as $id => $vv){
      $stringArr = array();
      $span_start = strpos($vv, '<span id="link-'.$vyz_id.'"');
      $text_start = strpos($vv, '>', $span_start);
      $text_end = strpos($vv, '</span>', $text_start);
      $stringArr[0] = substr($vv, 0, $text_start+1);
      $stringArr[1] = substr($vv, $text_start+1, ($text_end-$text_start)-1);
      $tmp = explode(' ', trim($stringArr[1]));
      unset($tmp[count($tmp)-1]);
      $stringArr[1] = implode(' ', $tmp);
      $stringArr[2] = ' ' . $neword;
      $stringArr[3] = substr($vv, $text_end);
      $vyklad = mysql_real_escape_string(implode('', $stringArr));
        $temp=text_db_preprocess(strip_tags($vyklad));
      dbq('UPDATE vyznamy SET vyklad_vyznamu="'.$vyklad.'", vyklad_vyznamu_bz="'.$temp.'" WHERE id='.$id);
    }
  }
 }

 function vytvorit_vzor($vzor_id)
 {
  $sql="SELECT hid, predvyklad, zacatek_predvykladu, konec_predvykladu, metavyklad1, vyklad_vyznamu, vyklad_vyznamu_bz, metavyklad2
        FROM vyznamy
        WHERE id = ".$vzor_id;
        //var_dump($sql);
  $res = dbq($sql);
     $newID=0;
  if($rec = mysql_fetch_assoc($res)) {
      //$sqlData['predvyklad'] = "'".my_trim(text_db_preprocess($rec['predvyklad']))."'";
      $sqlData['zacatek_predvykladu'] = "'" . my_trim(text_db_preprocess($rec['zacatek_predvykladu'])) . "'";
      $sqlData['konec_predvykladu'] = "'" . my_trim(text_db_preprocess($rec['konec_predvykladu'])) . "'";
      $sqlData['metavyklad1'] = "'" . my_trim(text_db_preprocess($rec['metavyklad1'])) . "'";
      $sqlData['vyklad_vyznamu'] = "'" . my_trim(text_db_preprocess($rec['vyklad_vyznamu'])) . "'";
      $sqlData['vyklad_vyznamu_bz'] = "'" . my_trim(text_db_preprocess($rec['vyklad_vyznamu_bz'])) . "'";
      $sqlData['metavyklad2'] = "'" . my_trim(text_db_preprocess($rec['metavyklad2'])) . "'";
      $newID = sql_w('vyznamy_master', $sqlData);
      $sqlData2['hid'] = $rec['hid'];
      $sqlData2['vyklad_vyznamu_link '] = $newID;
      $sqlData2['metavyklad1_link'] = 1;
      $sqlData2['metavyklad2_link'] = 1;
      $sqlData2['predvyklad_link'] = 1;
      sql_w('vyznamy', $sqlData2, $vzor_id);

          dbq('UPDATE propojeni_vyznamu SET vyz_from=NULL, vyz_m_from='.$newID.' WHERE vyz_from='.$vzor_id);


        dibi::query('DELETE FROM `vyrazy_predvykladu_m` WHERE `vyz_id`=%i', $newID);
        $res2 = dibi::query('SELECT sortorder, vyraz, komentar FROM vyrazy_predvykladu WHERE `vyz_id`=%i', $vzor_id);
        foreach ($res2 as $n => $row) {
            $row["vyz_id"]= $newID;
            dibi::query('INSERT INTO `vyrazy_predvykladu_m`', $row);
        }

        dibi::query('DELETE FROM `metavyklad1_vyz_vyber_m` WHERE `vyz_id`=%i', $newID);
        $res2 = dibi::query('SELECT cis_id, jine, sortorder FROM metavyklad1_vyz_vyber WHERE `vyz_id`=%i', $vzor_id);
        foreach ($res2 as $n => $row)
        {
            $row["vyz_id"]= $newID;
            dibi::query('INSERT INTO `metavyklad1_vyz_vyber_m`', $row);
        }
  }
  return $newID;
 }

 function prevod_skupiny_predvyklad_link($vyz_id, $vyklad_vyznamu_link )
 {
        $res2 = dibi::query('SELECT zacatek_predvykladu, predvyklad, konec_predvykladu  FROM vyznamy_master WHERE `id`=%i', $vyklad_vyznamu_link);
        $predvyklad = $res2->fetchAll()[0];
        dibi::query('UPDATE `vyznamy` SET zacatek_predvykladu = %s', $predvyklad["zacatek_predvykladu"],", predvyklad= %s", $predvyklad["predvyklad"],", konec_predvykladu= %s", $predvyklad["konec_predvykladu"]," WHERE `id`=%i", $vyz_id);
        dibi::query('DELETE FROM `vyrazy_predvykladu` WHERE `vyz_id`=%i', $vyz_id);
        $res2 = dibi::query('SELECT sortorder, vyraz, komentar FROM vyrazy_predvykladu_m WHERE `vyz_id`=%i', $vyklad_vyznamu_link);
        foreach ($res2 as $n => $row) {
            $row["vyz_id"]= $vyz_id;
            dibi::query('INSERT INTO `vyrazy_predvykladu`', $row);
        }
 }

 function prevod_skupiny_metavyklad1_link($vyz_id, $vyklad_vyznamu_link )
 {
        dibi::query('UPDATE `vyznamy` SET metavyklad1 = (SELECT metavyklad1 FROM vyznamy_master WHERE `id`=%i', $vyklad_vyznamu_link,") WHERE `id`=%i", $vyz_id);
        dibi::query('DELETE FROM `metavyklad1_vyz_vyber` WHERE `vyz_id`=%i', $vyz_id);
        $res2 = dibi::query('SELECT cis_id, jine, sortorder FROM metavyklad1_vyz_vyber_m WHERE `vyz_id`=%i', $vyklad_vyznamu_link);
        foreach ($res2 as $n => $row) {
            $row["vyz_id"]= $vyz_id;
            dibi::query('INSERT INTO `metavyklad1_vyz_vyber`', $row);
        }
 }

 function prevod_skupiny_metavyklad2_link($vyz_id, $vyklad_vyznamu_link )
 {
      dibi::query('UPDATE `vyznamy` SET metavyklad2 = (SELECT metavyklad2 FROM vyznamy_master WHERE `id`=%i', $vyklad_vyznamu_link,") WHERE `id`=%i", $vyz_id);
}

 function prevod_skupiny_vyklad($vyz_id, $vyklad_vyznamu_link)
 {
    $res2 = dibi::query('SELECT vyklad_vyznamu, vyklad_vyznamu_bz  FROM vyznamy_master WHERE `id`=%i', $vyklad_vyznamu_link);
    $vyklad = $res2->fetchAll()[0];
    //dibi::query('UPDATE `propojeni_vyznamu` SET vyz_from = %i', $vyz_id, ', vyz_m_from= NULL WHERE `vyz_m_from`=%i', $vyklad_vyznamu_link);
    $links = dibi::fetchAll('SELECT id, vyz_to, heslo_to, heslo_id FROM propojeni_vyznamu WHERE vyz_m_from=%i', $vyklad_vyznamu_link);
    foreach ($links as $l) {
      $oldid = $l['id'];
      unset($l['id']);
      $l['vyz_from'] = $vyz_id;
      dibi::query('INSERT INTO propojeni_vyznamu', $l);
      $newid = dibi::insertId();
      $vyklad['vyklad_vyznamu'] = str_replace('id="link-'.$oldid.'"', 'id="link-'.$newid.'"', $vyklad['vyklad_vyznamu']);
    }
    dibi::query('UPDATE `vyznamy` SET vyklad_vyznamu = %s', $vyklad["vyklad_vyznamu"], ', vyklad_vyznamu_bz= %s', $vyklad["vyklad_vyznamu_bz"], ', vyklad_vyznamu_link=NULL WHERE `id`=%i', $vyz_id);
 }

 function prevod_skupiny($vyz_id)
 {
     $res = dibi::query('SELECT vyklad_vyznamu_link, predvyklad_link, metavyklad1_link, metavyklad2_link FROM `vyznamy` WHERE `id`=%i', $vyz_id);
     $link = $res->fetchAll();
     $link = $link[0];
     if($link["predvyklad_link"])
     {
        prevod_skupiny_predvyklad_link($vyz_id, $link["vyklad_vyznamu_link"]);
     }
     if($link["metavyklad1_link"])
     {
        prevod_skupiny_metavyklad1_link($vyz_id, $link["vyklad_vyznamu_link"]);
     }
     if($link["metavyklad2_link"])
     {
        prevod_skupiny_metavyklad2_link($vyz_id, $link["vyklad_vyznamu_link"]);
     }
     prevod_skupiny_vyklad($vyz_id, $link["vyklad_vyznamu_link"]);
     return $link["vyklad_vyznamu_link"];
 }

 function smaz_skupinu($link_id)
 {
    $res = dibi::query('SELECT COUNT(*)  FROM vyznamy WHERE `vyklad_vyznamu_link`=%i', $link_id);
    $pocet = $res->fetchSingle();
    if($pocet<2)
    {
      $res = dibi::query('SELECT id FROM vyznamy WHERE `vyklad_vyznamu_link`=%i', $link_id);
      $vyz_dva = $res->fetchSingle();
      prevod_skupiny($vyz_dva);
      dibi::query('DELETE FROM vyznamy_master WHERE `id`=%i', $link_id);
    }
 }

 function uloz_vzor($vzor_id, $data)
 {
    sql_w('vyznamy_master',$data,$vzor_id);
 }

 function smaz_vyznam_master($master_id){
  dbq('DELETE FROM vyrazy_predvykladu_m WHERE vyz_id='.$master_id);
  dbq('DELETE FROM metavyklad1_vyz_vyber_m WHERE vyz_id='.$master_id);
  dbq('UPDATE vyznamy SET vyklad_vyznamu_link=NULL WHERE vyklad_vyznamu_link='.$master_id);
  dbq('DELETE FROM propojeni_vyznamu WHERE vyz_m_from='.$master_id);
  dbq('DELETE FROM vyznamy_master WHERE id='.$master_id);
 }

 function uloz_vyznam($hid, $vyz_data, $vyz_id, $ord){
  $vyz_pid = NULL;
  if(is_numeric($vyz_data['vyz_pid']) && $vyz_data['vyz_pid']>0) $vyz_pid = $vyz_data['vyz_pid'];

  $sqlData['hid'] = $hid;
  if($vyz_pid>0)
  {
    $sqlData['pid'] = $vyz_pid;
  }
  $sqlData['sortorder'] = $ord;
  if (!$vyz_pid && is_numeric($vyz_id) && $vyz_id > 0){
    fix_vyznam_ord($vyz_id, $ord);
  }
  $sqlData['vystup'] = ($vyz_data['poradi_pro_vystup'] ? $vyz_data['poradi_pro_vystup'] : 0);
  $sqlData['komentar_tvarchar'] = "'".my_trim(text_db_preprocess($vyz_data['komentar_tvarchar']))."'";
  $sqlData['komentar_tvarchar_slovesa'] = "'".my_trim(text_db_preprocess($vyz_data['komentar_tvarchar_slovesa']))."'";
  //$sqlData['predvyklad'] = "'".my_trim(text_db_preprocess($vyz_data['predvyklad']))."'";
  //novďż˝ pďż˝edvďż˝klad                    isset($_POST['field'][$i]) ? 1 : 0;
  $sqlData['zacatek_predvykladu'] =  "'".my_trim(text_db_preprocess($vyz_data['zacatek_predvykladu']))."'";
  $sqlData['predvyklad_link'] = $vyz_data['predvyklad_link']=='on' ? 1 : 0;
  $sqlData['konec_predvykladu'] = "'".my_trim(text_db_preprocess($vyz_data['konec_predvykladu']))."'";
  //$sqlData['metavyklad1'] = "'".text_db_preprocess($vyz_data['metavyklad1'])."'"; //skonvertovane na ciselnik
  //var_dump($sqlData);
//  var_dump($vyz_data); die();
  if (isset($vyz_data['vyklad_vyznamu_link']) && $vyz_data['vyklad_vyznamu_link'] !== False)
  {
    if(is_numeric($vyz_data['vyklad_vyznamu_link'])||$vyz_data['vyklad_vyznamu_link']=="NULL")
    {
      $sqlData['vyklad_vyznamu_link '] = $vyz_data['vyklad_vyznamu_link'];
    }
    else
    {
      $sqlData['vyklad_vyznamu_link '] = vytvorit_vzor(substr($vyz_data['vyklad_vyznamu_link'], 3));
    }
    if($sqlData['vyklad_vyznamu_link ']!=0 && $sqlData['vyklad_vyznamu_link ']!= "NULL")
    {
      $sqlDataMaster['vyklad_vyznamu'] = "'".my_trim(text_db_preprocess($vyz_data['vyklad_vyznamu_master']))."'";
      $sqlDataMaster['vyklad_vyznamu_bz'] = "'".strip_tags(my_trim(text_db_preprocess($vyz_data['vyklad_vyznamu_master'])))." '";
      if($vyz_data['metavyklad1_link']=='on')
      {
        uloz_vyber_cis('metavyklad1_vyz_master',$vyz_data['metavyklad1_master'], $sqlData['vyklad_vyznamu_link ']);
      }
      if($vyz_data['metavyklad2_link']=='on')$sqlDataMaster['metavyklad2'] = "'".my_trim(text_db_preprocess($vyz_data['metavyklad2_master']))."'";
      if($vyz_data['predvyklad_link']=='on')
      {
        //var_dump($vyz_data); die();
        uloz_predvyklad('vyz', $sqlData['vyklad_vyznamu_link '], $vyz_data['vyraz_predvyk_master'], "_m");
        //$sqlDataMaster['predvyklad'] = "'".my_trim(text_db_preprocess($vyz_data['predvyklad_master']))."'";
        $sqlDataMaster['zacatek_predvykladu'] = "'".my_trim(text_db_preprocess($vyz_data['zacatek_predvykladu_master']))."'";
        $sqlDataMaster['konec_predvykladu'] = "'".my_trim(text_db_preprocess($vyz_data['konec_predvykladu_master']))."'";

      }
      uloz_vzor($sqlData['vyklad_vyznamu_link '], $sqlDataMaster);
      if (is_numeric($vyz_id)){ //pokud byl jiďż˝ vďż˝znam uloďż˝en, smaďż˝eme jeho odkazy
        dbq('DELETE FROM propojeni_vyznamu WHERE vyz_from='.$vyz_id.' OR vyz_to='.$vyz_id);
      }
    }else{ //nelinkujeme
      $old_link = isset($vyz_data['vyklad_vyznamu_link_old']) ? (int)text_db_preprocess($vyz_data['vyklad_vyznamu_link_old']) : 0;
      if ($old_link){ //bylo nalinkovďż˝no
        $link_cnt = db_fetchSingle('SELECT COUNT(id) FROM vyznamy WHERE vyklad_vyznamu_link='.$old_link);
        if ($link_cnt == 2){ //odebďż˝rďż˝m pďż˝edposlednďż˝ link
          $links = db_fetchAll('SELECT id, predvyklad_link, metavyklad1_link, metavyklad2_link FROM vyznamy WHERE vyklad_vyznamu_link='.$old_link.' AND id <> '.$vyz_id);
          $links = $links[0];
          $last_id = $links['id'];
          $master_data = db_fetchAll('SELECT zacatek_predvykladu, predvyklad, konec_predvykladu, metavyklad2, vyklad_vyznamu, vyklad_vyznamu_bz FROM vyznamy_master WHERE id='.$old_link);
          $master_data = $master_data[0];
          $wr = array(
            'vyklad_vyznamu' => $master_data['vyklad_vyznamu'],
            'vyklad_vyznamu_bz' => "'".strip_tags(my_trim(text_db_preprocess($master_data['vyklad_vyznamu'])))." '"
          );
          if ($links['predvyklad_link']){
            //$wr['predvyklad'] = "'".my_trim(text_db_preprocess($master_data['predvyklad']))."'";
            $wr['zacatek_predvykladu'] = "'".my_trim(text_db_preprocess($master_data['zacatek_predvykladu']))."'";
            $wr['konec_predvykladu'] = "'".my_trim(text_db_preprocess($master_data['konec_predvykladu']))."'";
            $predv_arr = db_fetchAll('SELECT vyraz, komentar FROM vyrazy_predvykladu_m WHERE vyz_id='.$old_link);
            $ord = 0;
            smaz_tvary_predvykladu($last_id);
            $props = db_fetchAll('SELECT id, vyz_to, heslo_to, heslo_id FROM propojeni_vyznamu WHERE vyz_m_from='.$old_link);
            foreach ($props as $prop) {
              $oldpropid = $prop['id'];
              unset($prop['id']);
              if (!$prop['vyz_to']){
                unset($prop['vyz_to']);
              }
              if (!$prop['heslo_id']){
                unset($prop['heslo_id']);
              }
              $prop['vyz_from'] = $last_id;
              $prop['heslo_to'] = "'".my_trim(text_db_preprocess($prop['heslo_to']))."'";
              $newpropid = sql_w('propojeni_vyznamu', $prop, 0);
              $wr['vyklad_vyznamu'] = str_replace('id="link-'.$oldpropid.'"', 'id="link-'.$newpropid.'"', $wr['vyklad_vyznamu']);
            }
            $predvData = array('vyz_id' => $last_id);
            foreach ($predv_arr as $predv) {
              $predvData['vyraz'] = "'".my_trim(text_db_preprocess($predv['vyraz']))."'";
              $predvData['komentar'] = "'".my_trim(text_db_preprocess($predv['komentar']))."'";
              $predvData['sortorder'] = $ord;
              sql_w('vyrazy_predvykladu', $predvData, $id);
              $ord++;
            }
          }
          if ($links['metavyklad1_link']){
            $linkedmv1 = db_get_val_arr('SELECT cis_id FROM metavyklad1_vyz_vyber_m WHERE vyz_id='.$old_link);
            uloz_vyber_cis('metavyklad1_vyz', $linkedmv1, $last_id);
          }
          if ($links['metavyklad2_link']){
            $wr['metavyklad2'] = "'".my_trim(text_db_preprocess($master_data['metavyklad2']))."'";
          }
          $wr['vyklad_vyznamu'] = "'".my_trim(text_db_preprocess($wr['vyklad_vyznamu']))."'";
          sql_w('vyznamy', $wr, $last_id);
          smaz_vyznam_master($old_link);
        }
      }
    }
  }else{
    $vyz_data['vyklad_vyznamu_link'] = False;
  }
  $sqlData['vyklad_vyznamu'] = "'".my_trim(text_db_preprocess($vyz_data['vyklad_vyznamu']))."'";
  $sqlData['vyklad_vyznamu_bz'] = "'".strip_tags(my_trim(text_db_preprocess($vyz_data['vyklad_vyznamu'])))." '";
  $sqlData['metavyklad2'] = "'".my_trim(text_db_preprocess($vyz_data['metavyklad2']))."'";
  $sqlData['metavyklad1_link'] = $vyz_data['metavyklad1_link']=='on' ? 1 : 0;
  $sqlData['metavyklad2_link'] = $vyz_data['metavyklad2_link']=='on' ? 1 : 0;
  //$sqlData['koncovka_gram_info'] = "'".text_db_preprocess($vyz_data['konc_gram_info'])."'"; //zrusene

  if (isset($vyz_data['typ_vystupu'])) $sqlData['typ_vystupu']=$vyz_data['typ_vystupu'];
  $vyz_id = sql_w('vyznamy', $sqlData, $vyz_id);

  //pouze prvnďż˝ podheslďż˝
  uloz_vyber_cis('styl_kval_vyz', $vyz_data['styl_kval'], $vyz_id);
  uloz_vyber_cis('tematicke_okruhy_vyz', $vyz_data['tematicke_okruhy'], $vyz_id);
  uloz_vyber_cis('obor_uziti_vyz',$vyz_data['obor_uziti'], $vyz_id);

  uloz_vazebnosti('vyz', $vyz_id, $vyz_data['vazebnost']); //valence/vazebnost


  //podheslďż˝
  uloz_skupinu_podhesli($vyz_id, $vyz_data['podh_vyz']);

  if (!isset($vyz_data['vyklad_link']) || !$vyz_data['vyklad_link']){
    $vyz_data['vyklad_link'] = array();
  }
  $link_data = is_numeric($sqlData['vyklad_vyznamu_link ']) ? $vyz_data['vyklad_master_link'] : $vyz_data['vyklad_link'];
  uloz_propojene_vyznamy($vyz_id, $link_data, $sqlData['vyklad_vyznamu_link ']);

  uloz_poznamky('vyz', $vyz_id, $vyz_data['extPozn']);
  //uloz_synonyma($vyz_id, $vyz_data['synonymum']);
  //uloz_antonyma($vyz_id, $vyz_data['antonymum']);
  uloz_exemplifikace($vyz_id, $vyz_data['exemplifikace']);
  uloz_slDruhy('vyz', $vyz_id, $vyz_data['slovny_druh']);
  uloz_tvarChary('vyz',$vyz_id, $vyz_data['tvarChar']);
  uloz_tvarCharySl('vyz',$vyz_id, $vyz_data['tvarCharSl']);
  uloz_predvyklad('vyz', $vyz_id, $vyz_data['vyraz_predvyk']);

  uloz_vyber_cis('gram_info_vyz', $vyz_data['gram_info'], $vyz_id);
  uloz_vyber_cis('metavyklad1_vyz',$vyz_data['metavyklad1'], $vyz_id);

  return $vyz_id;
 };

 function smaz_vyznam($vyz_id){
  fix_propojeni_vykladu($vyz_id);

  $DOMid = "vyznam-$vyz_id--komentar_podhesli";
  smaz_nevyrizenou_korekturu($DOMid);

  $DOMid = "vyznam-$vyz_id--tvar_podhesli";
  smaz_nevyrizenou_korekturu($DOMid);

  $DOMid = "vyznam-$vyz_id--komentar_tvarchar";
  smaz_nevyrizenou_korekturu($DOMid);

  $DOMid = "vyznam-$vyz_id--komentar_tvarchar_slovesa";
  smaz_nevyrizenou_korekturu($DOMid);

  $DOMid = "vyznam-$vyz_id--predvyklad";
  smaz_nevyrizenou_korekturu($DOMid);

  $DOMid = "vyznam-$vyz_id--zacatek_predvykladu";
  smaz_nevyrizenou_korekturu($DOMid);

  $DOMid = "vyznam-$vyz_id--konec_predvykladu";
  smaz_nevyrizenou_korekturu($DOMid);


  $DOMid = "vyznam-$vyz_id--metavyklad1";
  smaz_nevyrizenou_korekturu($DOMid);

  $DOMid = "vyznam-$vyz_id--vyklad_vyznamu";
  smaz_nevyrizenou_korekturu($DOMid);

  $DOMid = "vyznam-$vyz_id--metavyklad2";
  smaz_nevyrizenou_korekturu($DOMid);


  //zmaz aj subvyznamy
  $sql = "SELECT id FROM vyznamy WHERE pid = $vyz_id";
  $subvyz_ids = db_get_val_arr($sql);
  foreach($subvyz_ids as $subvyz_id){
     smaz_vyznam($subvyz_id);
  }

  $DOMid = "vyznam-$vyz_id--obor_uziti";
  smaz_nevyrizenou_korekturu($DOMid);
  smaz_vyber('obor_uziti_vyz',$vyz_id);

  $DOMid = "vyznam-$vyz_id--tematicke_okruhy";
  smaz_nevyrizenou_korekturu($DOMid);
  smaz_vyber('tematicke_okruhy_vyz',$vyz_id);

  $DOMid = "vyznam-$vyz_id--gram_info";
  smaz_nevyrizenou_korekturu($DOMid);
  smaz_vyber('gram_info_vyz',$vyz_id);

  $DOMid = "vyznam-$vyz_id--styl_kval";
  smaz_nevyrizenou_korekturu($DOMid);
  smaz_vyber('styl_kval_vyz',$vyz_id);

  $DOMid = "vyznam-$vyz_id--metavyklad1";
  smaz_nevyrizenou_korekturu($DOMid);
  smaz_vyber('metavyklad1_vyz',$vyz_id);

  $x = get('vazebnosti_vyznamu', $vyz_id); foreach($x as $xid) smaz_vazebnost('vyz', $xid, $vyz_id);
  //$x = get('synonyma_vyznamu', $vyz_id); foreach($x as $xid) smaz_synonymum($xid, $vyz_id);
  //$x = get('antonyma_vyznamu', $vyz_id); foreach($x as $xid) smaz_antonymum($xid, $vyz_id);
  $x = get('exempl_vyznamu', $vyz_id); foreach($x as $xid) smaz_exemplifikaci($xid, $vyz_id);
  $x = get('pozn_vyznamu', $vyz_id); foreach($x as $xid) smaz_poznamku('vyz', $xid, $vyz_id);
  $x = get('slovneDruhy_vyznamu', $vyz_id); foreach($x as $xid) smaz_slDruh('vyz', $xid, $vyz_id);
  $x = get('tvarChary_vyznamu', $vyz_id); foreach($x as $xid) smaz_tvarChar('vyz',$xid, $vyz_id);
  $x = get('tvarCharySl_vyznamu', $vyz_id); foreach($x as $xid) smaz_tvarCharSl('vyz', $xid, $vyz_id);

  $x = get('vyrazy_predvykladu', $vyz_id);
  foreach($x as $xid){
    $DOM_id = "vyznam-$vyz_id--vyraz_predvykladu-$xid";
    smaz_nevyrizenou_korekturu($DOM_id);
    $DOM_id = "vyznam-$vyz_id--komentar_predvykladu-$xid";
    smaz_nevyrizenou_korekturu($DOM_id);
  }
  smaz_tvary_predvykladu($vyz_id);

  $x = get('podhesli_vyznamu', $vyz_id); foreach($x as $xid) smaz_podhesli_vyznamu($xid);

  //zmaz samotny vyznam
  dbq('DELETE FROM propojeni_vyznamu WHERE vyz_from='.$vyz_id.' OR vyz_to='.$vyz_id);
  $sql = "DELETE FROM vyznamy WHERE id=$vyz_id";
  $res = mysql_query($sql) or die("Chyba DB! [f: smaz_vyznamy()] <p>".mysql_error()."</p><p>$sql</p>");
  osetri_prepojenia_pri_mazani("vyznam", $vyz_id);
 };

 function uloz_exemplifikace($vyz_id, $exempl_arr){
  $exempl_db = get('exempl_vyznamu', $vyz_id);
  $ord=0;
  if(!empty($exempl_arr))
    foreach($exempl_arr as $exempl_id => $exemplData){
      $ord++;
      if(is_numeric($exempl_id) && $exempl_id > 0) unset($exempl_db[array_search($exempl_id, $exempl_db)]);
      $exempl_id = uloz_exemplifikaci($vyz_id, $exemplData, $exempl_id, $ord);
    }

  if(!empty($exempl_db))
    foreach($exempl_db as $exempl_id){
      smaz_exemplifikaci($exempl_id, $vyz_id);
    }
 }

 function uloz_exemplifikaci($vyz_id, $exemplData, $exempl_id, $ord=-1){
  $sqlData['vyz_id'] = $vyz_id;
  if($ord>=0) $sqlData['sortorder'] = $ord;
  $sqlData['exemplifikace'] = "'".text_db_preprocess($exemplData['text'])."'";
  $sqlData['exemplifikace_bz'] = "'".strip_tags(text_db_preprocess($exemplData['text']))." '";
  if(isset($exemplData['vystup']))
    $sqlData['vystup'] = "'".text_db_preprocess($exemplData['vystup'])."'";

  if(!is_numeric($exempl_id) || $exempl_id < 1) $exempl_id = 0;
  return sql_w('exemplifikace', $sqlData, $exempl_id);
 }

 function smaz_exemplifikaci($exempl_id, $pid = 0){
  $DOMid = "vyznam-$pid--exemplifikacia-$exempl_id";
  smaz_nevyrizenou_korekturu($DOMid);
  $sql = "DELETE FROM exemplifikace WHERE id=$exempl_id";
  $res = mysql_query($sql) or die("Chyba DB! [f: smaz_exemplifikaci()] <p>".mysql_error()."</p><p>$sql</p>");
  osetri_prepojenia_pri_mazani("exemplifikace", $exempl_id);
 };

 function uloz_poznamky($parent, $pid, $pozn_arr){
  $pozn_db = ($parent=='vyz') ? get('pozn_vyznamu', $pid) : get('pozn_hesla', $pid);

  if(hasValues($pozn_arr))
    foreach($pozn_arr as $pozn_id => $poznData){
      if(utf8_trim(strip_tags($poznData['text']))==""){
         $poznData['type'] = 0;
      } else if($poznData['type'] == 0){
         $poznData['type'] = 7;
      }
      if(is_numeric($pozn_id) && $pozn_id > 0) unset($pozn_db[array_search($pozn_id, $pozn_db)]);
      $pozn_id = uloz_poznamku($parent, $pid, $poznData, $pozn_id);
    }
  if(!empty($pozn_db))
    foreach($pozn_db as $pozn_id){
      smaz_poznamku($parent, $pozn_id, $pid);
    }
 }

 function uloz_poznamku($parent, $pid, $poznData, $pozn_id){
  if($parent=='vyz'){
   $sqlData['vyz_id'] = $pid;
  }else{
   $sqlData['hid'] = $pid;
  }
  $sqlData['poznamka'] = "'".utf8_trim(my_trim(text_db_preprocess($poznData['text'])))."'";

  if(text_db_preprocess($poznData['type'])>=0)
  {
    $sqlData['cis_id'] = text_db_preprocess($poznData['type']);
  }

  if(!is_numeric($pozn_id) || $pozn_id < 1) $pozn_id = 0;
  return ($parent=='vyz') ? sql_w('ext_poznamky_vyz', $sqlData, $pozn_id) : sql_w('ext_poznamky_hes', $sqlData, $pozn_id);
 }

 function smaz_poznamku($parent, $pozn_id, $pid = 0){
  $sql = "DELETE FROM ".(($parent=='vyz')?"ext_poznamky_vyz":"ext_poznamky_hes")." WHERE id=$pozn_id";
  if($parent=='hes'){
     $DOMid = "heslo-$pid--extPozn-$pozn_id--text";
     smaz_nevyrizenou_korekturu($DOMid);
  } else{
    $DOMid = "vyznam-$pid--extPozn-$pozn_id--text";
    smaz_nevyrizenou_korekturu($DOMid);
  }
  $res = mysql_query($sql) or die("Chyba DB! [f: smaz_poznamku()] <p>".mysql_error()."</p><p>$sql</p>");
 }

 function get_hid_of_str($vyraz){
   $sql = "SELECT hid FROM varianty WHERE varianta='".text_db_preprocess($vyraz)."'";
   $res = dbq($sql);
   if(mysql_num_rows($res)==1) return mysql_result($res, 0, "hid");
   if(mysql_num_rows($res) >1) return db_get_val_arr($sql);

   return false;
 }

 function osetri_prepojenia_pri_mazani($place, $place_id){
   //momentalne funkcia zmaze prepojenie na danom mieste - nenechava slepe odkazy na neexistujuce hesla
   //inou moznostou moze byt len zmazanie hid, pripadne prepisanie miesta na heslo-0 (ka sa maze main) a ponechanie len *_str
   if(!is_numeric($place_id)) $place_id = -1;
   $place = text_db_preprocess($place);
   if($place=="heslo"){
     $sql = "SELECT id FROM hesla_rel WHERE main_hid='$place_id' OR slave_hid=$place_id";
     $hid_rels = db_get_val_arr($sql);
     foreach($hid_rels as $hid_rel){
       smaz_hidRel($hid_rel);
     }
   }else{
     $sql = "SELECT hesla_rel_id FROM hesla_rel_places WHERE place='$place' AND place_id=$place_id";
     $hid_rels = db_get_val_arr($sql);
     $sql = "DELETE FROM hesla_rel_places WHERE place='$place' AND place_id=$place_id";
     dbq($sql);
     foreach($hid_rels as $hid_rel){
       $sql = "SELECT COUNT(*) as c FROM hesla_rel_places WHERE hesla_rel_id=$hid_rel";
       $res = dbq($sql);
       if(mysql_result($res, 0,"c") < 1) smaz_hidRel($hid_rel);
     }
   }
 }

 function check_vyznam_neexistujici_link($heslo, $id_heslo, $vyz_id){
  dibi::query('UPDATE propojeni_vyznamu SET vyz_to=%i, heslo_to="", heslo_id=NULL WHERE heslo_to=%s', $vyz_id, $heslo);
 }

 function osetri_linkovanie_pri_editacii_varianty($var_id){
   if(!is_numeric($var_id)) return false;
   $var_info = get_db_values("varianty", array("hid", "varianta"), $var_id);
   $hid = $var_info["hid"];
   $var_str = $var_info["varianta"];

   //process mains
   $sql = "SELECT id FROM hesla_rel WHERE (main_str='$var_str' AND (main_hid=0 OR main_hid IS NULL))";
   $res = dbq($sql);
   $d = array();
   while($rec = mysql_fetch_assoc($res)){
     $d['main_hid'] = $hid;
     sql_w("hesla_rel", $d, $rec['id']);
     $sql = "UPDATE hesla_rel_places SET place_id=$hid WHERE hesla_rel_id=".$rec['id']." AND place='heslo' AND place_id=0";
     dbq($sql);
   }
   //process slaves
   $sql = "SELECT id FROM hesla_rel WHERE (slave_str='$var_str' AND (slave_hid=0 OR slave_hid IS NULL))";
   $res = dbq($sql);
   $d = array();
   while($rec = mysql_fetch_assoc($res)){
     $d['slave_hid'] = $hid;
     sql_w("hesla_rel", $d, $rec['id']);
   }
 }

 function fix_propojeni_vykladu($vyz){
  $conn = db_fetchAll('
    SELECT pv.id, vyz_from, v.vyklad_vyznamu, vm.vyklad_vyznamu AS vv_master, vm.id AS master_id
    FROM propojeni_vyznamu pv
      LEFT JOIN vyznamy v ON vyz_from = v.id
      LEFT JOIN vyznamy_master vm ON pv.vyz_m_from = vm.id
    WHERE vyz_to='.$vyz
  , array('id' => 'vyklad_vyznamu'));
  foreach ($conn as $v){
    if ($v['vv_master']){
      $vv = $v['vv_master'];
      $vyz = $v['master_id'];
      $master = True;
    }else{
      $vv = $v['vyklad_vyznamu'];
      $vyz = $v['vyz_from'];
      $master = False;
    }
    $id = $v['id'];
    $stringArr = array();
    $span_start = strpos($vv, '<span id="link-'.$id.'"');
    $text_start = strpos($vv, '>', $span_start);
    $text_end = strpos($vv, '</span>', $text_start);
    $stringArr[0] = substr($vv, 0, $span_start);
    $stringArr[1] = substr($vv, $text_start+1, ($text_end-$text_start)-1);
    $stringArr[2] = substr($vv, $text_end + 7); //preskocit "</span>"
    $vyklad = mysql_real_escape_string(implode('', $stringArr));
      $temp=text_db_preprocess(strip_tags($vyklad));
    if ($master){
      dbq('UPDATE vyznamy_master SET vyklad_vyznamu="'.$vyklad.'", vyklad_vyznamu_bz="'.$temp.'" WHERE id='.$vyz);
    }else{
      dbq('UPDATE vyznamy SET vyklad_vyznamu="'.$vyklad.'", vyklad_vyznamu_bz="'.$temp.'" WHERE id='.$vyz);
    }
  }
 }

 function is_heslo_in_hidRel($hid){
   if(!is_numeric($hid)) return false;
   $sql = "SELECT count(id) as cnt FROM hesla_rel WHERE main_hid=$hid || slave_hid=$hid";
   $res = dbq($sql);
   return mysql_result($res, 0, 'cnt') > 0;
 }


/* *********** UKLADANIE MAIN + SLAVE ************* */
function uloz_hidRels($hid, $hidRels)
{
  /*$hidRel_slave_DBids = get_hidRels($hid);
  $hidRel_master_DBids = get_hidRels(0, $hid);
  $hidRel_DBids = array_unique_merge((array)$hidRel_slave_DBids, (array)$hidRel_master_DBids);
  if(!empty($hidRels)){
    $ord = 0;
    foreach($hidRels as $hidRel_id => $hidRel_data)
    {
      if ($hidRel_data['rel_type']==HREL_TYPE_ant || $hidRel_data['rel_type']==HREL_TYPE_syn || $hidRel_data['rel_type']==HREL_TYPE_ant_przn || $hidRel_data['rel_type']==HREL_TYPE_syn_przn){
        continue;
      }
      $hidRel_id2=0;
      $ord++;
      $empty_master = (!isset($hidRel_data['main_hid']) || empty($hidRel_data['main_hid'])) && (!isset($hidRel_data['main_str']) || trim($hidRel_data['main_str'])=="");
      $empty_slave  = (!isset($hidRel_data['slave_hid']) || empty($hidRel_data['slave_hid'])) && (!isset($hidRel_data['slave_str']) || trim($hidRel_data['slave_str'])=="");
      $incomplete_rel = $empty_master || $empty_slave;
      $no_place = !isset($hidRel_data['hidRel_place']) || empty($hidRel_data['hidRel_place'][0]);
      if($hidRel_data['rel_type']==HREL_TYPE_ant || $hidRel_data['rel_type']==HREL_TYPE_syn || $hidRel_data['rel_type']==HREL_TYPE_odkazy || $hidRel_data['rel_type']==HREL_TYPE_ant_przn || $hidRel_data['rel_type']==HREL_TYPE_syn_przn)
      {
        $no_slave_place = !isset($hidRel_data['hidRel_slave_place']) || empty($hidRel_data['hidRel_slave_place'][0]);
      }
      else $no_slave_place=false;
      //err( $hidRel_id.",".$hidRel_data['main_hid'].",".$hidRel_data['slave_hid'].",".$hidRel_data['slave_str'].",".$hidRel_data['hidRel_place'][0].",".$hidRel_data['hidRel_slave_place'][0].",".$hidRel_data['rel_type'] );


      if(!$incomplete_rel && !$no_place && !$no_slave_place)
      {
        //if(is_numeric($hidRel_id))
          //err( "in".$hidRel_id.",".$hidRel_data['main_hid'].",".$hidRel_data['slave_hid']  );

        if(isset($hidRel_data['link_to_rel']))
        {
          $temp=explode('-',$hidRel_data['link_to_rel']);
          $hidRel_data['spojeno']=end($temp);
        }
        else
        {
          $hidRel_data['spojeno']=0;
        }
        $hidRel_id = uloz_hidRel($hidRel_data, $hidRel_id, $ord);
        $number = $hidRel_DBids[array_search($hidRel_id, $hidRel_DBids)];
        if($number==$hidRel_id)
        {
          unset($hidRel_DBids[array_search($hidRel_id, $hidRel_DBids)]);
        }
        if($hidRel_data['link_type']==2)
        {
          foreach($hidRels as $hidRel_id_2 => $hidRel_data2)
          {
            if($hidRel_id_2!=$hidRel_id)
            {
              if($hidRel_data2['rel_type']==='1' &&($hidRel_data2['hidRel_slave_place'][0]===$hidRel_data['hidRel_place'][0]) &&  ($hidRel_data2['hidRel_place'][0]===$hidRel_data['hidRel_slave_place'][0]) &&  $hidRel_data2['slave_hid']===$hidRel_data['main_hid'] &&  $hidRel_data2['main_hid']===$hidRel_data['slave_hid'])
              {
                $hidRel_id2=$hidRel_id_2;
                break;
              }
              else if ($hidRel_data2['rel_type']==='1' && $hidRel_data2['link_type']==3 &&($hidRel_data2['hidRel_slave_place'][0]==='0'||$hidRel_data['hidRel_place'][0]==='0' || $hidRel_data2['hidRel_place'][0]==='0'||$hidRel_data['hidRel_slave_place'][0]==='0') && $hidRel_data2['main_hid']===$hidRel_data['slave_hid'] &&  $hidRel_data2['slave_hid']===$hidRel_data['main_hid'])
              {
                $hidRel_id2=$hidRel_id_2;
                break;
              }
            }
          }
          $rnd = rand(0, 10000);
          //var_dump($hidRel_data);
          //var_dump($hidRel_id2);
          if($hidRel_id2==0)
          {
            $hidRel_id2 = "new$rnd";
            $hidRel_data2['hidRel_slave_place'] = $hidRel_data['hidRel_place'];
            $hidRel_data2['hidRel_place'] = $hidRel_data['hidRel_slave_place'];
            $hidRel_data2['link_type'] = 3;
            $hidRel_data2['main_hid'] = $hidRel_data['slave_hid'];
            $hidRel_data2['main_str'] = $hidRel_data['slave_str'];
            $hidRel_data2['slave_hid'] = $hidRel_data['main_hid'];
            $hidRel_data2['slave_str'] = $hidRel_data['main_str'];
            $hidRel_data2['rel_type'] = $hidRel_data['rel_type'];
            $hidRel_data2['spojeno'] = $hidRel_id;
            unset($hidRel_data2['note']); //nekopďż˝rovat poznďż˝mku
            $ord++;
            $hidRel_id2 = uloz_hidRel($hidRel_data2, $hidRel_id2, $ord);
            $hidRel_data['spojeno'] = $hidRel_id2;
            $hidRel_id = uloz_hidRel($hidRel_data, $hidRel_id, $ord-1);

          }
        }
        else if($hidRel_data['link_type']==3)
        {
          foreach($hidRels as $hidRel_id_2 => $hidRel_data2)
          {
            if($hidRel_id_2!=$hidRel_id)
            {
              if($hidRel_data2['rel_type']==='1' &&($hidRel_data2['hidRel_slave_place'][0]===$hidRel_data['hidRel_place'][0]) &&  ($hidRel_data2['hidRel_place'][0]===$hidRel_data['hidRel_slave_place'][0]) && $hidRel_data2['main_hid']===$hidRel_data['slave_hid'] &&  $hidRel_data2['slave_hid']===$hidRel_data['main_hid'])
              {
                $hidRel_id2=$hidRel_id_2;
                break;
              }
              else if ($hidRel_data2['rel_type']==='1' && $hidRel_data2['link_type']==2 &&($hidRel_data2['hidRel_slave_place'][0]==='0'||$hidRel_data['hidRel_place'][0]==='0' || $hidRel_data2['hidRel_place'][0]==='0'||$hidRel_data['hidRel_slave_place'][0]==='0') && $hidRel_data2['main_hid']===$hidRel_data['slave_hid'] &&  $hidRel_data2['slave_hid']===$hidRel_data['main_hid'])
              {
                $hidRel_id2=$hidRel_id_2;
                break;
              }
            }
          }
          $rnd = rand(0, 10000);
          //var_dump($hidRel_data);
          //var_dump($hidRel_id2);
          if($hidRel_id2==0)
          {
            $hidRel_id2 = "new$rnd";
            $hidRel_data2['hidRel_slave_place'] = $hidRel_data['hidRel_place'];
            $hidRel_data2['hidRel_place'] = $hidRel_data['hidRel_slave_place'];
            $hidRel_data2['link_type'] = 2;
            $hidRel_data2['main_hid'] = $hidRel_data['slave_hid'];
            $hidRel_data2['main_str'] = $hidRel_data['slave_str'];
            $hidRel_data2['slave_hid'] = $hidRel_data['main_hid'];
            $hidRel_data2['slave_str'] = $hidRel_data['main_str'];
            $hidRel_data2['rel_type'] = $hidRel_data['rel_type'];
            $hidRel_data2['spojeno'] = $hidRel_id;
            $ord++;
            unset($hidRel_data2['note']); //nekopďż˝rovat poznďż˝mku
            $hidRel_id2 = uloz_hidRel($hidRel_data2, $hidRel_id2, $ord);
            $hidRel_data['spojeno'] = $hidRel_id2;
            $hidRel_id = uloz_hidRel($hidRel_data, $hidRel_id, $ord);
          }
        }
      }

    }
  }

  //die();
  if(!empty($hidRel_DBids))
    foreach($hidRel_DBids as $hidRel_id){
      //var_dump($hidRel_id);
      smaz_hidRel($hidRel_id);
    } */
 }
 /* ******** UKLADANIE LEN SLAVE ************* */
 /*
 function uloz_hidRels($hid, $hidRels){
  $hidRel_slave_DBids = get_hidRels($hid);
  if(!empty($hidRels)){
    $ord = 0;
    foreach($hidRels as $hidRel_id => $hidRel_data){
      $ord++;
      $empty_slave  = (!isset($hidRel_data['slave_str']) || trim($hidRel_data['slave_str'])=="");
      $no_place = !isset($hidRel_data['hidRel_place']) || empty($hidRel_data['hidRel_place'][0]);
      if(is_numeric($hidRel_id) && $hidRel_id > 0 && !$empty_slave && !$no_place) unset($hidRel_slave_DBids[array_search($hidRel_id, $hidRel_slave_DBids)]);
      if(!$empty_slave && !$no_place) $hidRel_id = uloz_hidRel($hidRel_data, $hidRel_id, $ord);
    }
  }

  if(!empty($hidRel_slave_DBids))
    foreach($hidRel_slave_DBids as $hidRel_id){
      smaz_hidRel($hidRel_id);
    }
 }
 */

 /* *** PRACA S MAIN HESLAMI VYPNUTA *************
 function uloz_hidRel($hidRel_data, $hidRel_id, $ord){

  $sqlData = array();
  if(!is_numeric($hidRel_data['slave_hid']) || !is_numeric($hidRel_data['main_hid'])){
    err("Chybnďż˝ formďż˝t dat pďż˝i ukládání propojení hesel!"); return false;
  }

  if(trim($hidRel_data['main_str']) == trim($hidRel_data['slave_str']) || $hidRel_data['main_hid'] == $hidRel_data['slave_hid']){
    err("Odkazovďż˝nďż˝ na samo sebe je zakďż˝zďż˝no! Nďż˝kterďż˝ propojení nebyli uloďż˝eny."); return false;
  }

  //ULOZ SPOJENIE

  //editacia hlavnych hesiel (toto pripojene k...) ///// formulare editacie hlavnych hesiel so slaveov su disablenute, takze tento blok by sa nikdy nemal vykonat /////
  if(isset($hidRel_data['main_str'])){
    if(($hidRel_data['main_hid']>0 && print_heslo_str($hidRel_data['main_hid']) == trim($hidRel_data['main_str'])) || $hidRel_data['main_hid']==0){
      $sqlData["main_hid"] = ($hidRel_data['main_hid']==0) ? " null" : $hidRel_data['main_hid'];
      $sqlData["main_str"] = "'".trim($hidRel_data['main_str'])."'";
      $sqlData["slave_hid"] = $hidRel_data['slave_hid'];
      $sqlData["slave_str"] = "'".print_heslo_str($hidRel_data['slave_hid'])."'";
    }else{
      err("Pďż˝i ukládání propojení na hlavnďż˝ heslo \"".$hidRel_data['main_str']."\" došlo k chybě a odkaz se neuložil!");
      return FALSE;
    }
  }


  //editacia pripojenych hesiel (k tomu pripajam...)
  if(isset($hidRel_data['slave_str'])){
    if(($hidRel_data['slave_hid']>0 && print_heslo_str($hidRel_data['slave_hid']) == trim($hidRel_data['slave_str'])) || $hidRel_data['slave_hid']==0){
       $sqlData["slave_hid"] = ($hidRel_data['slave_hid']==0) ? " null" : $hidRel_data['slave_hid'];
       $sqlData["slave_str"] = "'".trim($hidRel_data['slave_str'])."'";
       $sqlData["main_hid"] = $hidRel_data['main_hid'];
       $sqlData["main_str"] = "'".print_heslo_str($hidRel_data['main_hid'])."'";
       $sqlData["sortorder"] = $ord;
    }else{
      err("Pďż˝i ukládání propojení na heslo \"".$hidRel_data['slave_str']."\" došlo k chybě a odkaz se neuložil!");
      return false;
    }
  }

  $sqlData['rel_type'] = text_db_preprocess($hidRel_data['rel_type']);


  if(!is_numeric($hidRel_id) || $hidRel_id < 1) $hidRel_id = 0;
  $hidRel_id = sql_w('hesla_rel', $sqlData, $hidRel_id);

  //ULOZ MIESTA SPOJENI v ramci hesla

  $hidRel_places = (array)$hidRel_data['hidRel_place'];

  //get places from db for specific relation
  $sql = "SELECT id, place, place_id FROM hesla_rel_places WHERE hesla_rel_id=$hidRel_id";
  $res = dbq($sql);
  $places_from_db = array();
  while($rec=mysql_fetch_assoc($res)){
    $place_str = $rec['place']; if($place_str!="heslo") $place_str.= "-".$rec["place_id"];
    $places_from_db[$rec['id']]=$place_str;
  }

  $sqlData = array();
  $sqlData['hesla_rel_id'] = $hidRel_id;
  foreach($hidRel_places as $hidRel_place){
    $IDinDB = array_search($hidRel_place, $places_from_db);
    if($IDinDB!==false){
      unset($places_from_db[array_search($hidRel_place, $places_from_db)]);
      continue;
    }
    $hidRel_place_arr = explode("-", $hidRel_place);
    $sqlData['place'] = "'".text_db_preprocess($hidRel_place_arr[0])."'";
    if($hidRel_place_arr[0]=="heslo"){
      $sqlData['place_id'] = (!empty($hidRel_data['main_hid'])) ? $hidRel_data['main_hid'] : 0;
    }else{
      $sqlData['place_id'] = text_db_preprocess($hidRel_place_arr[1]);
    }
    sql_w("hesla_rel_places",$sqlData);
  }
  if(!empty($places_from_db))
     foreach(array_keys($places_from_db) as $place_DBid){
       $sql = "DELETE FROM hesla_rel_places WHERE id=$place_DBid";
       dbq($sql);
     }

  //ULOZ TYPY ODKAZOV (LINIEK)

  //zatial upravene len pre sigle vyber
  if($hidRel_data['rel_type']==HREL_TYPE_odkazy){
   $sql = "SELECT id FROM hesla_rel_link_type_vyber WHERE hesla_rel_id=$hidRel_id";
   $res = dbq($sql);
   $hrltv_id = 0; if(mysql_num_rows($res)>0) $hrltv_id = mysql_result($res, 0, "id");
   $sqlData = array();
   $sqlData['cis_id'] = text_db_preprocess($hidRel_data['link_type']);
   $sqlData['hesla_rel_id'] = $hidRel_id;
   $sqlData['sortorder'] = 1;
   sql_w("hesla_rel_link_type_vyber",$sqlData, $hrltv_id);
  }

  return $hidRel_id;
 }
 */

 /* ************ UKLADANIE MAIN + SLAVE *************** */
 function uloz_hidRel($hidRel_data, $hidRel_id, $ord){
  $sqlData=array();
  if(!empty($hidRel_data['slave_kom'])){
    $sqlData['komentar']="'".$hidRel_data['slave_kom']."'";
  } else{
    $sqlData['komentar']="NULL";
  }

  $sqlData['poznamka']="NULL";
  if(!empty($hidRel_data['note'])){
    $sqlData['poznamka']="'".$hidRel_data['note']."'";
  }

  $sqlData['spojeno'] = $hidRel_data['spojeno'];


  if(!is_numeric($hidRel_data['slave_hid']) || !is_numeric($hidRel_data['main_hid'])){
    err("Chybný formát dat při ukládání propojení hesel!"); return false;
  }

  if($hidRel_data['main_hid'] == $hidRel_data['slave_hid']){
    err("Odkazování samo na sebe je zakázáno! Některá propojení nebyla uložena.");
    return false;
  }

  //ukladanie SLAVE odkazov
  if(isset($hidRel_data['slave_str']))
  {
    if(is_numeric($hidRel_data['slave_hid']) && $hidRel_data['slave_hid'] > 0){
      //over ci z dosleho HID dostaneme dosli STR
      $hl_var_id = get_hlavni_varianta_hesla($hidRel_data['slave_hid']);
      $hl_var_str = print_varianta_str($hl_var_id);
      $hl_var_str = text_html_preprocess($hl_var_str);
      if(my_trim(trim($hidRel_data['slave_str'])) == $hl_var_str){
        //ukladame HID ktory dorazil
        $sqlData["slave_hid"] = $hidRel_data['slave_hid'];
        $sqlData["slave_str"] = "'".print_heslo_str($hidRel_data['slave_hid'])."'";
      }else{
        //ak mame kladne hid, ale nekoresponduje s tim co bylo v textovem poli
        err("Při ukládání propojení na heslo \"".$hidRel_data['slave_str']."\" došlo k chybě a odkaz se neuložil! (".$hl_var_str.")");
        return false;
      }
        $sql = "SELECT MAX(sortorder2) ord FROM hesla_rel WHERE slave_hid=".$sqlData["slave_hid"];
        $res = dbq($sql);
        if(mysql_num_rows($res)==1)
        {
          $sqlData["sortorder2"] = mysql_result($res, 0, 'ord')+1;
        }
    }else{ //dosle HID <= 0
      $var_str = trim(text_db_preprocess($hidRel_data['slave_str']));
      $sql = "SELECT DISTINCT hid FROM varianty WHERE varianta='$var_str'";
      $res = dbq($sql);
      if(mysql_num_rows($res)>1){
        //nastane ak uzivatel vypise slovo, ktore sa nachadza vo viacerych heslach a nevyberie ho pritom zo zoznamu ktory ponuka naseptavac
        err("Při ukládání propojení na heslo \"".$hidRel_data['slave_str']."\" došlo k chybě a odkaz se neuložil! (Pravděpodobně se snažíte připojit slovo, které má víc homonym, a nevybrali jste ho z našeptávače.)");
        return false;
      }
      if(mysql_num_rows($res)==1){
        //ak je jednoznacne ku ktoremu HID patri dosle slovo (neexistuju homonymne slova, pod roznymi HID)

        $sqlData["slave_hid"] = mysql_result($res, 0, 'hid');
        //$sql = "SELECT MAX(sortorder2) ord FROM hid_rel WHERE slave_hid=".$sqlData["slave_hid"];
        $sql = "SELECT MAX(sortorder2) ord FROM hesla_rel WHERE slave_hid=".$sqlData["slave_hid"];
        $res = dbq($sql);
        if(mysql_num_rows($res)==1)
        {
          $sqlData["sortorder2"] = mysql_result($res, 0, 'ord')+1;
        }
        $hidRel_data['slave_hid'] = $sqlData["slave_hid"];
      }
      if(mysql_num_rows($res)==0){
        $sqlData["slave_hid"] = "null";
      }
    }
    if(empty($sqlData["slave_str"])) $sqlData["slave_str"] = "'".trim($hidRel_data['slave_str'])."'";
    $sqlData["main_hid"] = $hidRel_data['main_hid'];
    $sqlData["main_str"] = "'".print_heslo_str($hidRel_data['main_hid'])."'";
    $sqlData["sortorder"] = $ord;

  }

  //ukladanie MAIN odkazov
  if(isset($hidRel_data['main_str'])){
    if(is_numeric($hidRel_data['main_hid']) && $hidRel_data['main_hid'] > 0){
      //over ci z dosleho HID dostaneme dosli STR
      $hl_var_id = get_hlavni_varianta_hesla($hidRel_data['main_hid']);
      $hl_var_str = print_varianta_str($hl_var_id);
      $hl_var_str = text_html_preprocess($hl_var_str);
      if(my_trim(trim($hidRel_data['main_str'])) == $hl_var_str){
        //ukladame HID ktory dorazil
        $sqlData["main_hid"] = $hidRel_data['main_hid'];
        $sqlData["main_str"] = "'".print_heslo_str($hidRel_data['main_hid'])."'";
      }else{
        //ak mame kladne hid, ale nekoresponduje s tim co bylo v textovem poli
        err("Při ukládání propojení na heslo \"".$hidRel_data['main_str']."\" došlo k chybě a odkaz se neuložil!(".$hl_var_str.")");
        return false;
      }
    }else{ //dosle HID <= 0
      $var_str = trim(text_db_preprocess($hidRel_data['main_str']));
      $sql = "SELECT DISTINCT hid FROM varianty WHERE varianta='$var_str'";
      $res = dbq($sql);
      if(mysql_num_rows($res)>1){
        //nastane ak uzivatel vypise slovo, ktore sa nachadza vo viacerych heslach a nevyberie ho pritom zo zoznamu ktory ponuka naseptavac
        err("Při ukládání propojení na heslo \"".$hidRel_data['main_str']."\" došlo k chybě a odkaz se neuložil! (Pravdďż˝podobnďż˝ se snaďż˝ďż˝te pďż˝ipojit slovo, kterďż˝ mďż˝ vďż˝c homonym, a nevybrali jste ho z naďż˝eptďż˝vaďż˝e.)");
        return false;
      }
      if(mysql_num_rows($res)==1){
        //ak je jednoznacne ku ktoremu HID patri dosle slovo (neexistuju homonymne slova, pod roznymi HID)
        $sqlData["main_hid"] = mysql_result($res, 0, 'hid');
        $hidRel_data['main_hid']= $sqlData["main_hid"];
      }
      if(mysql_num_rows($res)==0){
        $sqlData["main_hid"] = "null";
      }
    }

    if(empty($sqlData["main_str"])) $sqlData["main_str"] = "'".trim($hidRel_data['main_str'])."'";
    if($hidRel_data['slave_hid']>0)$sqlData["slave_hid"] = $hidRel_data['slave_hid'];
    $sqlData["slave_str"] = "'".print_heslo_str($hidRel_data['slave_hid'])."'";
    $sqlData["sortorder2"] = $ord;
  }

  $sqlData['rel_type'] = text_db_preprocess($hidRel_data['rel_type']);

  if(!is_numeric($hidRel_id) || $hidRel_id < 1) $hidRel_id = 0;
  //var_dump($sqlData);
  $hidRel_id = sql_w('hesla_rel', $sqlData, $hidRel_id);

  //ULOZ MIESTA SPOJENI V HLAVNOM HESLE

  $hidRel_places = (array)$hidRel_data['hidRel_place'];

  //get places from db for specific relation
  $sql = "SELECT id, place, place_id FROM hesla_rel_places WHERE hesla_rel_id=$hidRel_id";
  $res = dbq($sql);
  $places_from_db = array();
  while($rec=mysql_fetch_assoc($res)){
    $place_str = $rec['place']; if($place_str!="heslo") $place_str.= "-".$rec["place_id"];
    $places_from_db[$rec['id']]=$place_str;
  }

  $sqlData = array();
  $sqlData['hesla_rel_id'] = $hidRel_id;
  foreach($hidRel_places as $hidRel_place)
  {
    $IDinDB = array_search($hidRel_place, $places_from_db);
    if($IDinDB!==false)
    {
      $ID = array_search($hidRel_place, $places_from_db);
      unset($places_from_db[$ID]);
      //err( "smaz".$ID  );
       $sql = "DELETE FROM hesla_rel_places WHERE id=$ID";
       dbq($sql);
      //continue;
    }
    $hidRel_place_arr = explode("-", $hidRel_place);
    $sqlData['place'] = "'".text_db_preprocess($hidRel_place_arr[0])."'";
    if($hidRel_place_arr[0]=="heslo")
    {
      $sqlData['place_id'] = (!empty($hidRel_data['main_hid'])) ? $hidRel_data['main_hid'] : 0;
    }
    else
    {
      $sqlData['place_id'] = text_db_preprocess($hidRel_place_arr[1]);
    }
    //var_dump($sqlData);
    sql_w("hesla_rel_places",$sqlData);
  }
   //break;
  if(!empty($places_from_db))
     foreach(array_keys($places_from_db) as $place_DBid)
     {
       //err( "smaz".$place_DBid  );
       $sql = "DELETE FROM hesla_rel_places WHERE id=$place_DBid";
       dbq($sql);
     }

  //ULOZ MIESTA SPOJENI VO VEDLAJSOM HESLE

  $hidRel_places = (array)$hidRel_data['hidRel_slave_place'];

  //get places from db for specific relation
  $sql = "SELECT id, place, place_id FROM hesla_rel_slave_places WHERE hesla_rel_id=$hidRel_id";
  $res = dbq($sql);
  $places_from_db = array();
  while($rec=mysql_fetch_assoc($res)){
    $place_str = $rec['place']; if($place_str!="heslo") $place_str.= "-".$rec["place_id"];
    $places_from_db[$rec['id']]=$place_str;
  }

  $sqlData = array();
  $sqlData['hesla_rel_id'] = $hidRel_id;
  foreach($hidRel_places as $hidRel_place){
    $IDinDB = array_search($hidRel_place, $places_from_db);
    if($IDinDB!==false){
      unset($places_from_db[array_search($hidRel_place, $places_from_db)]);
      continue;
    }
    if(!empty($hidRel_place)){
      $hidRel_place_arr = explode("-", $hidRel_place);
      $sqlData['place'] = "'".text_db_preprocess($hidRel_place_arr[0])."'";
      if($hidRel_place_arr[0]=="heslo"){
        $sqlData['place_id'] = (!empty($hidRel_data['slave_hid'])) ? $hidRel_data['slave_hid'] : 0;
      }else{
        $sqlData['place_id'] = text_db_preprocess($hidRel_place_arr[1]);
      }
      sql_w("hesla_rel_slave_places",$sqlData);
    }
  }
  if(!empty($places_from_db))
     foreach(array_keys($places_from_db) as $place_DBid){
       $sql = "DELETE FROM hesla_rel_slave_places WHERE id=$place_DBid";
        //err( "smaz".$place_DBid  );
       dbq($sql);
     }

  //ULOZ TYPY ODKAZOV (LINIEK)

  //zatial upravene len pre sigle vyber
  if($hidRel_data['rel_type']==HREL_TYPE_odkazy){
   $sql = "SELECT id FROM hesla_rel_link_type_vyber WHERE hesla_rel_id=$hidRel_id";
   $res = dbq($sql);
   $hrltv_id = 0; if(mysql_num_rows($res)>0) $hrltv_id = mysql_result($res, 0, "id");
   $sqlData = array();
   if($hidRel_data['link_type']=='jine')$hidRel_data['link_type']=0;
   if( text_db_preprocess($hidRel_data['link_type'])>0)
   {
    $sqlData['cis_id'] = text_db_preprocess($hidRel_data['link_type']);
   }
   $sqlData['hesla_rel_id'] = $hidRel_id;
   $sqlData['sortorder'] = 1;
   if($hidRel_data['link_type']==0)$sqlData['jine'] = "'".$hidRel_data['slave_jine_str']."'";

   sql_w("hesla_rel_link_type_vyber",$sqlData, $hrltv_id);
  }
  return $hidRel_id;
 }

 /* ************** UKLADANIE LEN SLAVE
 /*
 function uloz_hidRel($hidRel_data, $hidRel_id, $ord){
  $sqlData = array();
  if(!is_numeric($hidRel_data['slave_hid']) || !is_numeric($hidRel_data['main_hid'])){
    err("Chybnďż˝ formďż˝t dat pďż˝i ukládání propojení hesel!"); return false;
  }

  if($hidRel_data['main_hid'] == $hidRel_data['slave_hid']){
    err("Odkazovďż˝nďż˝ samo na sebe je zakďż˝zďż˝no! Nďż˝kterďż˝ propojení nebyla uloďż˝ena."); return false;
  }

  //LEN ukladanie SLAVE odkazov
  if(is_numeric($hidRel_data['slave_hid']) && $hidRel_data['slave_hid'] > 0){
    //over ci z dosleho HID dostaneme dosli STR
    $hl_var_id = get_hlavni_varianta_hesla($hidRel_data['slave_hid']);
    $hl_var_str = print_varianta_str($hl_var_id);
    if(trim($hidRel_data['slave_str']) == $hl_var_str){
      //ukladame HID ktory dorazil
      $sqlData["slave_hid"] = $hidRel_data['slave_hid'];
    }else{
      //ak mame kladne hid, ale nekoresponduje s tim co bylo v textovem poli
      err("Při ukládání propojení na heslo \"".$hidRel_data['slave_str']."\" došlo k chybě a odkaz se neuložil!");
      return false;
    }
  }else{ //dosle HID <= 0
    $var_str = trim(text_db_preprocess($hidRel_data['slave_str']));
    $sql = "SELECT DISTINCT hid FROM varianty WHERE varianta='$var_str'";
    $res = dbq($sql);
    if(mysql_num_rows($res)>1){
      //nastane ak uzivatel vypise slovo, ktore sa nachadza vo viacerych heslach a nevyberie ho pritom zo zoznamu ktory ponuka naseptavac
      err("Při ukládání propojení na heslo \"".$hidRel_data['slave_str']."\" došlo k chybě a odkaz se neuložil! (Pravdďż˝podobnďż˝ se snaďż˝ďż˝te pďż˝ipojit slovo, kterďż˝ mďż˝ vďż˝c homonym, a nevybrali jste ho z naďż˝eptďż˝vaďż˝e.)");
      return false;
    }
    if(mysql_num_rows($res)==1){
      //ak je jednoznacne ku ktoremu HID patri dosle slovo (neexistuju homonymne slova, pod roznymi HID)
      $sqlData["slave_hid"] = mysql_result($res, 0, 'hid');
    }
    if(mysql_num_rows($res)==0){
      $sqlData["slave_hid"] = "null";
    }
  }

  $sqlData["slave_str"] = "'".trim($hidRel_data['slave_str'])."'";
  $sqlData["main_hid"] = $hidRel_data['main_hid'];
  $sqlData["main_str"] = "'".print_heslo_str($hidRel_data['main_hid'])."'";
  $sqlData["sortorder"] = $ord;

  $sqlData['rel_type'] = text_db_preprocess($hidRel_data['rel_type']);

  if(!is_numeric($hidRel_id) || $hidRel_id < 1) $hidRel_id = 0;
  $hidRel_id = sql_w('hesla_rel', $sqlData, $hidRel_id);

  //ULOZ MIESTA SPOJENI v ramci hesla

  $hidRel_places = (array)$hidRel_data['hidRel_place'];

  //get places from db for specific relation
  $sql = "SELECT id, place, place_id FROM hesla_rel_places WHERE hesla_rel_id=$hidRel_id";
  $res = dbq($sql);
  $places_from_db = array();
  while($rec=mysql_fetch_assoc($res)){
    $place_str = $rec['place']; if($place_str!="heslo") $place_str.= "-".$rec["place_id"];
    $places_from_db[$rec['id']]=$place_str;
  }

  $sqlData = array();
  $sqlData['hesla_rel_id'] = $hidRel_id;
  foreach($hidRel_places as $hidRel_place){
    $IDinDB = array_search($hidRel_place, $places_from_db);
    if($IDinDB!==false){
      unset($places_from_db[array_search($hidRel_place, $places_from_db)]);
      continue;
    }
    $hidRel_place_arr = explode("-", $hidRel_place);
    $sqlData['place'] = "'".text_db_preprocess($hidRel_place_arr[0])."'";
    if($hidRel_place_arr[0]=="heslo"){
      $sqlData['place_id'] = (!empty($hidRel_data['main_hid'])) ? $hidRel_data['main_hid'] : 0;
    }else{
      $sqlData['place_id'] = text_db_preprocess($hidRel_place_arr[1]);
    }
    sql_w("hesla_rel_places",$sqlData);
  }
  if(!empty($places_from_db))
     foreach(array_keys($places_from_db) as $place_DBid){
       $sql = "DELETE FROM hesla_rel_places WHERE id=$place_DBid";
       dbq($sql);
     }

  //ULOZ TYPY ODKAZOV (LINIEK)

  //zatial upravene len pre sigle vyber
  if($hidRel_data['rel_type']==HREL_TYPE_odkazy){
   $sql = "SELECT id FROM hesla_rel_link_type_vyber WHERE hesla_rel_id=$hidRel_id";
   $res = dbq($sql);
   $hrltv_id = 0; if(mysql_num_rows($res)>0) $hrltv_id = mysql_result($res, 0, "id");
   $sqlData = array();
   $sqlData['cis_id'] = text_db_preprocess($hidRel_data['link_type']);
   $sqlData['hesla_rel_id'] = $hidRel_id;
   $sqlData['sortorder'] = 1;
   sql_w("hesla_rel_link_type_vyber",$sqlData, $hrltv_id);
  }

  return $hidRel_id;
 }
 */


 function smaz_hidRel($hidRel_id, $z_redakce = false){
  //ak sa jedna o odkazy -> zmazat aj typ linkovania
  $rel_type = get_db_values("hesla_rel","rel_type",$hidRel_id);
  if($rel_type == HREL_TYPE_odkazy){
    $sql = "DELETE FROM hesla_rel_link_type_vyber WHERE hesla_rel_id = $hidRel_id";
    dbq($sql);
    $DOMid = "link-$hidRel_id";
    if(!$z_redakce){
        smaz_nevyrizenou_korekturu($DOMid);
    }
  }

  if($rel_type == HREL_TYPE_prihnizdovani || $rel_type == HREL_TYPE_pripojovani){
    $DOMid = "nest-$hidRel_id";
    if($z_redakce){
        smaz_nevyrizenou_korekturu($DOMid);
    }
  }

  $DOMid = "";
  if($rel_type == HREL_TYPE_syn || $rel_type == HREL_TYPE_syn_przn){
    return;
    $DOMid = "hidRel-synonymum-slaves-$hidRel_id";
    if(!$z_redakce){
        smaz_nevyrizenou_korekturu($DOMid);
    }
  } else if($rel_type == HREL_TYPE_ant || $rel_type == HREL_TYPE_ant_przn){
    return;
    $DOMid = "hidRel-antonymum-slaves-$hidRel_id";
    if(!$z_redakce){
        smaz_nevyrizenou_korekturu($DOMid);
    }
  }

  //zmazat miesta
  $sql = "DELETE FROM hesla_rel_places WHERE hesla_rel_id=$hidRel_id";
  dbq($sql);

  $sql = "DELETE FROM hesla_rel_slave_places WHERE hesla_rel_id=$hidRel_id";
  dbq($sql);

  //smaz vztah
  $sql = "DELETE FROM hesla_rel WHERE id=$hidRel_id";
  $res = mysql_query($sql) or die("Chyba DB! [f: smaz_hidRel()] <p>".mysql_error()."</p><p>$sql</p>");
 }

 function get_subvyznam_num($vyz_id){
   /*
    dalo by sa optimalizovat tym ze by sa skontrolovalo, ci sortorder sa vzdy zapise od 1 a moze sa tym povazovat za vyz_num
   */
   $hid = get_db_values('vyznamy','hid', $vyz_id);
   $pid = get_db_values('vyznamy','pid', $vyz_id);
   $vyz_num = 0;
   $sql="SELECT id FROM vyznamy WHERE hid=$hid AND pid=$pid ORDER BY sortorder;";
   $vyz_ids = db_get_val_arr($sql);
   foreach($vyz_ids as $_vyz_id){
     $vyz_num++;
     if($_vyz_id == $vyz_id) return $vyz_num;
   }
   return false;
 }

 function is_subvyznam($vyz_id){
   $sql = "SELECT pid FROM vyznamy WHERE id=$vyz_id";
   $res = dbq($sql);
   return (mysql_num_rows($res)>0 && mysql_result($res, 0, 'pid'));
 }

 function subvyznamy_count($vyz_id){
   $sql = "SELECT count(id) as cnt FROM vyznamy WHERE pid=$vyz_id";
   $res = dbq($sql);
   return mysql_result($res, 0, 'cnt');
 }

 function get_subvyznamy($vyz_id){
   if(!is_numeric($vyz_id) || $vyz_id <= 0) return false;
   $sql = "SELECT id FROM vyznamy WHERE pid=$vyz_id ORDER BY sortorder";
   return db_get_val_arr($sql);
 }

 function track_navsteva_hesla($hid, $uid){
  $d = array();
  $d['hid'] = $hid;
  $d['uid'] = $uid;
  sql_w('track_navstevy_hesel', $d);
 }

 function get_requestUri_query_val($var){
   $uri_q = parse_url($_SERVER['REQUEST_URI'], PHP_URL_QUERY);
   parse_str($uri_q, $var_vals);
   return $var_vals[$var];
 }


 function copy_heslo($hid, $new_name){
  if(!is_numeric($hid) || $hid < 0) return false;
 }

?>
