<?php

function HTML_header($page_id, $title, $CSS=array(), $JS=array()){
    include 'HTML_header.php';
}

function HTML_footer($page_id){
    include 'HTML_footer.php';
}

function is_err(){
    return !empty($_SESSION['app_err']);
}

function err($err_msg){
    $_SESSION['app_err'][] = $err_msg;
}

function microtime_float(){
    list($usec, $sec) = explode(" ", microtime());
    return ((float)$usec + (float)$sec);
}


function print_errs(){
    if(isset($_SESSION['app_err']) && !empty($_SESSION['app_err'])){
        $html="<ol class='errList box redButtBox vmargin'>";
        foreach ($_SESSION['app_err'] as $err){
            $html.="<li><b>".$err."</b></li>";
        }
        $html.="</ol>";
        unset($_SESSION['app_err']);
    }
    return $html;
}

function set_nahrazeni_search($s, $f='heslo', $seznam=0, $xfilter=0){
    $_SESSION['nahrazeni_search']['query']  = $s;
    $_SESSION['nahrazeni_search']['field']  = $f;
    $_SESSION['nahrazeni_search']['seznam'] = $seznam;
    $_SESSION['nahrazeni_search']['xfilter'] = $xfilter;
}

function set_search($s, $f='heslo'){
    //unset_data_filter();
    set_first_page();
    $_SESSION['search']['query'] = $s;
    $_SESSION['search']['field'] = $f;
}

function set_first_page($section='heslar'){
    if(is_numeric($_SESSION['pager'][$section]['iPerPage']))
        set_pager($section, 1, $_SESSION['pager'][$section]['iPerPage']);
    else
        set_pager($section, 1);
}

function set_pager($section, $pg=1, $iPerPage=15){
    $_SESSION['pager'][$section]['iPerPage'] = $iPerPage;
    $_SESSION['pager'][$section]['page'] = $pg;
}

function pager_htmls($section, $num_rows){
    $found_info = '';
    $stats_info = '';
    if(!isset($_SESSION['pager'][$section])) set_pager($section);
    $iPerPage = ($_SESSION['pager'][$section]['iPerPage']>0) ? $_SESSION['pager'][$section]['iPerPage'] : $num_rows;
    $pg = $_SESSION['pager'][$section]['page'];
    $pageCount = 0;
    if($iPerPage!=0)
        $pageCount = ($num_rows % $iPerPage == 0) ? $num_rows/$iPerPage : (int)($num_rows/$iPerPage) + 1;
    switch($section){
        case 'heslar':
            $php_script = "heslar.php";
            break;

        case 'Korektury':
            $php_script = 'korektury.php';
            break;

        case 'Seznamy':
            $php_script = 'seznamy_hesel.php';
            break;

        case 'Najdi_a_nahrad':
            $php_script = 'najdi_a_nahrad.php';
            break;
    }
    $html_pages="";
    if($pageCount>0){
        if ($section == 'heslar' || $section == 'Korektury' || $section == 'Seznamy' || $section == 'Najdi_a_nahrad'){
            $found_info = 'Nalezeno <b class="zoomFont">'.$num_rows.'</b> záznamů.';
            $stats_info = '('.(($pg-1)*$iPerPage + 1).'-'.min($num_rows,(($pg)*$iPerPage)).'/'.$num_rows.')';
            $html_pages .= 'Stránka:';
            $start = '';
            $middle = '';
            $end = '';
            if ($pageCount < 15){
                for($i=1; $i<=$pageCount; $i++){
                    $cls = ($i == $pg) ? ' class="active_page"' : '';
                    $start .= '<a href="'.$php_script.'?act=setPage&pg='.$i.'"'.$cls.'>'.$i.'</a>&nbsp;';
                }
            }else{
                $li = max(1, $pg-3);
                $ri = min($pg + 3, $pageCount) + 1;
                for($i = $li; $i < $ri; $i++){
                    $cls = ($i == $pg) ? ' class="active_page"' : '';
                    $middle .= '<a href="'.$php_script.'?act=setPage&pg='.$i.'"'.$cls.'>'.$i.'</a>&nbsp;';
                }
                if ($li > 5){
                    for($i = 1; $i < 4; $i++){
                        $start .= '<a href="'.$php_script.'?act=setPage&pg='.$i.'">'.$i.'</a>&nbsp;';
                    }
                    $start .= '...&nbsp;';
                }else{
                    for($i = 1; $i < $li; $i++){
                        $start .= '<a href="'.$php_script.'?act=setPage&pg='.$i.'">'.$i.'</a>&nbsp;';
                    }
                }

                if ($ri < ($pageCount-3)){
                    for($i = ($pageCount-2); $i <= $pageCount; $i++){
                        $end .= '<a href="'.$php_script.'?act=setPage&pg='.$i.'">'.$i.'</a>&nbsp;';
                    }
                    $end = '...&nbsp;' . $end;
                }else{
                    for($i = $ri; $i <= $pageCount; $i++){
                        $end .= '<a href="'.$php_script.'?act=setPage&pg='.$i.'">'.$i.'</a>&nbsp;';
                    }
                }
                if ($pg > 1){
                    $start = '
            <a href="'.$php_script.'?act=setPage&pg=1">|&lt;</a>&nbsp;
            <a href="'.$php_script.'?act=setPage&pg='.($pg-1).'">&lt;</a>&nbsp;
            '.$start;
                }
                if ($pg < $pageCount){
                    $end = $end.'
            <a href="'.$php_script.'?act=setPage&pg='.($pg+1).'">&gt;</a>&nbsp;
            <a href="'.$php_script.'?act=setPage&pg='.$pageCount.'">&gt;|</a>&nbsp;
            ';
                }
                $end .= '
            <form class="page_input_form" action="" method="get">
              <input type="hidden" name="act" value="setPage" />
              <input class="page_input" type="text" name="pg" />
              <input type="submit" value="Jdi" />
            </form>
          ';
            }
            $html_pages .= $start.$middle.$end;
        }else{
            $html_pages.="<div class = 'pager_pages'>";
            $html_pages.="(".(($pg-1)*$iPerPage + 1)."-".min($num_rows,(($pg)*$iPerPage))."/".$num_rows.")";
            $html_pages.="&nbsp;Stránka: ";
            for($i=1; $i<=$pageCount; $i++){
                $cls = ($i == $pg) ? "class='active_page'" : "";
                $html_pages.="<a href='".$php_script."?act=setPage&pg=$i' $cls>$i</a>&nbsp;";
            }
            $html_pages.="</div>";
        }
    }

    $recCount_arr = array(15,30,50,100,500);
    $html_iPerPg="";
    $html_iPerPg.="<div class='pager_itemsPerPage'>";
    $html_iPerPg.="Položek na stránku: ";
    foreach($recCount_arr as $recCount){
        $actCls = ($_SESSION['pager'][$section]['iPerPage'] == $recCount) ? "class='actual'" : "";
        $link_text = $recCount;
        //if($recCount==0) $link_text = "vše";
        $html_iPerPg.="<a href='".$php_script."?act=setRowsPerPage&amp;rpp=$recCount' $actCls>$link_text</a>&nbsp;";
    }
    $html_iPerPg.="</div>";


    return array("pages"=>$html_pages, "itemsPerPage"=>$html_iPerPg, "found_info" => $found_info, "stats_info" => $stats_info);
}

function parse_pager($section){
    if(!isset($_SESSION['pager'][$section])) set_pager($section);

    $iPerPage = (!isset($_SESSION['pager'][$section]['iPerPage'])) ? 15 : $_SESSION['pager'][$section]['iPerPage'];
    $from = (empty($_SESSION['pager'][$section]['page'])) ? 0 : ($_SESSION['pager'][$section]['page'] - 1) * $iPerPage;

    return array('listFrom'=>$from, 'iPerPage'=>$iPerPage);
}

//spravne funguje ak je deep check TRUE ak je false moze byt problem s kontrolou prazdneho pola pomocou $value=""
function hasValues($input, $deepCheck = true) {
    foreach((array)$input as $value) {
        if(!is_array($value)) $value = trim($value);
        if(is_array($value) && $deepCheck) {
            if(hasValues($value, $deepCheck))
                return true;
        }
        elseif(!is_array($value) && $value!="")
            return true;
    }
    return false;
}

function print_mini_menu($opt = "inHead"){
    global $page_id;
    $menu_arr = array(); $menu="";
    if(is_admin(get_logged_user())) $menu_arr[]= "<a href='admin.php'>Správcovská sekce</a>";
    if($page_id!='heslar') $menu_arr[] = "<a href='heslar.php' >Heslář</a>";
    if($page_id!='xfilter' && is_role_uzivatel()) $menu_arr[] = "<a href='xfilter.php'>Filtry</a>";
    if($page_id!='najdi_a_nahrad' && is_admin(get_logged_user())) $menu_arr[] = "<a href='najdi_a_nahrad.php'>Najdi a nahraď</a>";
    if($page_id!='cis_edit' && is_role_uzivatel()) $menu_arr[] = "<a href='cis_edit.php'>Číselníky</a>";
    if(!empty($menu_arr)){
        if($opt == "inHead")
            $menu = "<img src='css/images/arrow_right_sx.png' alt='Menu' />&nbsp;";
        $menu.=implode("&nbsp;|&nbsp;", $menu_arr);
    }
    return $menu;
}

function ftime($time){
    return date("d.m.Y", strtotime($time));
}


function DOMinnerHTML($element){
    $innerHTML = "";
    $children = $element->childNodes;
    foreach ($children as $child)
    {
        $tmp_dom = new DOMDocument();
        $tmp_dom->appendChild($tmp_dom->importNode($child, true));
        $innerHTML.=trim($tmp_dom->saveHTML());
    }
    return $innerHTML;
}

/*
  Converts font sizes in the WYSIWYG editor output
  17px -> 12px
  13px -> 10px
  and removes unnecessary tags
*/
function handle_wysiwyg($inputStr, $to_pdf = true){
    global $multiOutput;
    $pdf = $to_pdf;
    if($multiOutput){
        $pdf = false;
    }
    $badSizes = array("font-size: large", "font-size: small", "font-size: 10px;", "font-size: 13px;","font-size: medium;","font-size: 17px;"/*,"[","]"*/);
    if(!$pdf){ //DOC, HTML vystup
        $goodSizes = array("font-size: 17px", "font-size: 13px;", "font-size: 13px;", "font-size: 13px;","font-size: 17px;","font-size: 17px;"/*,"<span class='petit'>[","]</span>"*/);
    } else{       //PDF vystup
        $goodSizes = array("font-size: 12px", "font-size: 10px;", "font-size: 10px;","font-size: 10px;","font-size: 12px;","font-size: 12px;" /*,"<span class='petit'>[","]</span>"*/);
    }
    $outputStr = preg_replace('#\s(lang)="[^"]+"#', '', $inputStr);
    $outputStr = str_replace($badSizes, $goodSizes, $outputStr);
    $outputStr = str_replace("<em class=\"hili\">", "<em>", $outputStr);
    $outputStr = str_replace("<em class=\"ex\">", "<em>", $outputStr);
    $outputStr = str_replace("<em class=\"st\">", "<em>", $outputStr);
    $outputStr = str_replace("<em class=\"darkred\">", "<em>", $outputStr);
    $outputStr = str_replace("<em class=\"coll\">", "<em>", $outputStr);
    $outputStr = str_replace("<em class=\"coll\" style=\"font-style: italic;\">", "<em>", $outputStr);
    $outputStr = str_replace(array("\r\n", "\n"),"",$outputStr);
    $outputStr = strip_tags($outputStr, "<span>,<em>,<strong>,<font>,<b>,<i>,<script>,<sup>,<sub>");
    $fonts = array(
        "<span class='petit'>",
        "<span class=\"petit\">",
        "<span style='font-size: 10px;'>",
        "<span style=\"font-size: 10px;\">",
        "<span style=\"font-size: 13px;\">",
        "<span style='font-size: 13px;'>",
        "<span style=\"font-size: 12px;\">",
        "<span style='font-size: 12px;'>",
        "<span style=\"font-size: 17px;\">",
        "<span style='font-size: 17px;'>");
    $spans = array("<span class='small'>",
        "<span class='small'>",
        "<span class='small'>",
        "<span class='small'>",
        "<span class='small'>",
        "<span class='small'>",
        "<span class='normalni'>",
        "<span class='normalni'>",
        "<span class='normalni'>",
        "<span class='normalni'>");
    $outputStr = str_replace($fonts, $spans, $outputStr);
    //odstraneni nadbytecne mezery na konci uvnitr span tagu
    $elems = explode("</span>", $outputStr);
    $outputStr = "";
    $cnt = count($elems);
    $last = 0;
    $i = 0;
    foreach($elems as $elem){
        $i++;
        $elem = strip_tags($elem);
        if(trim($elem)!=""){
            $last = $i;
        }
    }
    $i = 0;
    foreach($elems as $elem){
        $i++;
        if($i == $last){
            $elem = rtrim($elem);
        }
        if($i < $cnt){
            $outputStr .= $elem."</span>";
        } else{
            $outputStr .=$elem;
        }
    }



    return $outputStr;
}

/*
  mPDF library fails to render the following HTML code correctly:
  <p><em>Hudba má sedm tónů, nějaká <em>béčka</em> a křížky.</em></p>
  Replacing the <em> tags with corresponding CSS style works around the problem
*/
function fix_mPDF($inputStr){
    $badTags = array("<em>", "</em>", "<em style=\"");
    $goodTags = array("<span style='font-style:italic'>", "</span>", "<span style=\"font-style:italic ");
    $outputStr = str_replace($badTags, $goodTags, $inputStr);
    return $outputStr;
}

function text_db_preprocess($str){
    return mysql_real_escape_string($str);
}

function text_html_preprocess($str, $conv=False){
    if(is_string($str)){
        if ($conv){
            //$str = iconv('utf-8', 'windows-1250', $str);
        }
        $str = htmlspecialchars($str, ENT_QUOTES, 'utf-8', false);
        return $str;
    }
    return "";
}

function teaser($text, $l=50){
    return (strlen($text)>$l) ? substr($text,0,$l) . "..." : $text;
}

function translate_utf8ToW1250($str){
    return iconv("utf-8", "windows-1250", $str);
}

function escape_special_char(&$s){
    $s=str_replace(array( '[', ']', '^', '.', '\'', '+', '?', '$', '(', ')', '{', '}', '=', '!', '<', '>', '|', ':', '-'), array('\\\[', '\\\]', '[^]', '[.]', '[\]', '[+]', '[?]', '[$]', '[(]', '[)]', '[{]', '[}]', '[=]', '[!]', '[<]', '[>]', '[|]', '[:]', '[-]'), $s);
}

function array_unique_merge() {
    $args = func_get_args();
    return array_unique(call_user_func_array('array_merge', $args));
}

function my_arrayMap($callback,$arr1) {
    $results = array();
    $args    = array();
    if(func_num_args()>2)
        $args = (array) array_shift(array_slice(func_get_args(),2));
    foreach($arr1 as $key=>$value) {
        $temp = $args;
        array_unshift($temp,$value);
        if(is_array($value)) {
            array_unshift($temp,$callback);
            $results[$key] = call_user_func_array('my_arrayMap',$temp);
        } else {
            $results[$key] = call_user_func_array($callback,$temp);
        }
    }
    return $results;
}

function array_value_relative($array, $current_value, $offset = 1, $cyclic = TRUE) {
    $n = count($array); //number of items
    $current_key = array_search($current_value, $array); // find key current of current value

    $new_key = $current_key + $offset;
    if($cyclic){
        //workaround when index after offset is out of bounds (cyklic)
        if($new_key > $n-1) $new_key = $new_key - $n;
        if($new_key <   0 ) $new_key = $new_key + $n;
    }
    if(isset($array[$new_key]))
        return $array[$new_key];

    return false;
}

function arrayRecursiveDiff($aArray1, $aArray2) {
    $aReturn = array();

    foreach ($aArray1 as $mKey => $mValue) {
        if (array_key_exists($mKey, $aArray2)) {
            if (is_array($mValue)) {
                $aRecursiveDiff = arrayRecursiveDiff($mValue, $aArray2[$mKey]);
                if (count($aRecursiveDiff)) { $aReturn[$mKey] = $aRecursiveDiff; }
            } else {
                if ($mValue != $aArray2[$mKey]) {
                    $aReturn[$mKey] = $mValue;
                }
            }
        } else {
            $aReturn[$mKey] = $mValue;
        }
    }
    return $aReturn;
}

function replaceKeys2nonNumeric(array $input) {
    $return = array();
    foreach ($input as $key => $value) {
        if (is_numeric($key))
            $key = 'new'.$key;

        if (is_array($value))
            $value = replaceKeys2nonNumeric($value);

        $return[$key] = $value;
    }
    return $return;
}

function dbq($sql){
    $res = mysql_query($sql);
    if(!$res) die("<h3><font color='red'>Chyba DB! (".mysql_errno().") : </font></h3><p><b>".mysql_error()."</b></p><p>".$sql."</p>");
    return  $res;
}

function db_fetchSingle($sql){
    $res = dbq($sql);
    $arr = array();
    if($rec = mysql_fetch_row($res)){
        return $rec[0];
    }else{
        return False;
    }
}

function db_fetchAll($sql){
    $res = dbq($sql);
    $arr = array();
    while($rec = mysql_fetch_assoc($res)){
        $arr[] = $rec;
    }
    return $arr;
}

function sql_w_nonempty($tbl, $data, $id=0){
    $sql =  ($id>0) ? "UPDATE " : "INSERT INTO ";
    $sql .= $tbl." SET ";
    $write = False;
    foreach((array)$data as $col => $val){
        if (trim($val)){
            $write = True;
            $sql.= $col." = '".mysql_real_escape_string($val)."',";
        }
    }
    if (!$write){
        return;
    }
    $sql = substr($sql, 0, -1); //remove last comma
    $sql.= ($id>0) ? " WHERE id=$id" : "";
    //if($tbl=='ext_poznamky_vyz') var_dump($sql);
    $res = mysql_query($sql) or die("<h3><font color='red'>Chyba DB! (".mysql_errno().") : </font></h3><p><b>".mysql_error()."</b></p><p>".$sql."</p>");
    if($id<=0) $id = mysql_insert_id();
    return $id;
}

function sql_w($tbl, $data, $id=0){
    $sql =  ($id>0) ? "UPDATE " : "INSERT INTO ";
    $sql .= $tbl." SET ";
    foreach((array)$data as $col => $val){
        $sql.= $col." = ".$val.",";
    }
    $sql = substr($sql, 0, -1); //remove last comma
    $sql.= ($id>0) ? " WHERE id=$id" : "";
    //if($tbl=='ext_poznamky_vyz') var_dump($sql);
    $res = mysql_query($sql) or die("<h3><font color='red'>Chyba DB! (".mysql_errno().") : </font></h3><p><b>".mysql_error()."</b></p><p>".$sql."</p>");
    if($id<=0) $id = mysql_insert_id();
    return $id;
}

function sql_w_where($tbl, $data, $id, $column){
    $sql =  "UPDATE $tbl SET ";
    foreach((array)$data as $col => $val){
        $sql.= $col." = ".$val.",";
    }
    $sql = substr($sql, 0, -1); //remove last comma
    $sql.= " WHERE $column=$id";
    $res = mysql_query($sql) or die("<h3><font color='red'>Chyba DB! (".mysql_errno().") : </font></h3><p><b>".mysql_error()."</b></p><p>".$sql."</p>");
    return $res;
}

function check_db_values($table, $fields, $id){
    if(!is_numeric($id)) return false;
    $fields_str = (is_array($fields)) ? implode(", ", $fields) : $fields;
    $sql = 'SELECT '.$fields_str.' FROM '.$table.' WHERE id='.$id;
    $res = mysql_query($sql) or die('Query: '.$sql.'  failed: ' . mysql_error());
    if($res == false) return false;
    if(mysql_num_rows($res)==0){
        return false;
    }
    return true;
}

function get_db_values($table, $fields, $id){
    if ($GLOBALS['is_archive'] && !in_array($table, $GLOBALS['no_prefix']) && strpos($table, 'cis_') !== 0){
        $table = 'archive_' . $table;
    }
    if(!is_numeric($id)) return '';
    $_SESSION['debug_db_num']++;
    $fields_str = (is_array($fields)) ? implode(", ", $fields) : $fields;
    $sql = 'SELECT '.$fields_str.' FROM '.$table.' WHERE id='.$id;
    $res = mysql_query($sql) or die('Query: '.$sql.'  failed: ' . mysql_error());
    if(mysql_num_rows($res)==1) {
        $vals = (is_array($fields)) ? mysql_fetch_array($res) : mysql_result($res, 0, 0);
    } else {
        $vals = '';
    }
    return $vals;
}

function get_db_values_where($table, $fields, $column, $value, $multiple = false){
    $fields_str = (is_array($fields)) ? implode(", ", $fields) : $fields;
    if(is_numeric($value)){
        $sql = 'SELECT '.$fields_str.' FROM '.$table.' WHERE '.$column.'='.$value;
    } else{
        $sql = 'SELECT '.$fields_str.' FROM '.$table.' WHERE '.$column.'="'.$value.'"';
    }
    $res = mysql_query($sql) or die('Query: '.$sql.'  failed: ' . mysql_error());
    if(!$multiple){
        if(mysql_num_rows($res)==1) {
            $vals = (is_array($fields)) ? mysql_fetch_array($res) : mysql_result($res, 0, 0);
        } else {
            $vals = '';
        }
    } else {
        if(mysql_num_rows($res)>=1) {
            if(is_array($fields)){
                while($r = mysql_fetch_array($res))
                    $vals[] = $r;
            }
            else $vals = mysql_result($res, 0, 0);
        } else {
            $vals = '';
        }
    }
    return $vals;
}



function db_get_val_arr($sql, $a=array()){
    /*
     Example for var $a
     $a = array("id"=>"name");
     Will return array, where keys will be the IDs and values will be NAMEs from database rows
    */
    $res = dbq($sql);
    $arr = array();
    while($rec = mysql_fetch_array($res)){
        if(empty($a))
            $arr[] = $rec[0];
        else
            $arr[$rec[key($a)]] = $rec[$a[key($a)]];
    }
    return $arr;
}

function ecsapeStringsInArray(&$arr){
    foreach($arr as $key=>$value){
        if(!is_array($value)){
            $value = trim($value);
            $value = mysql_real_escape_string($value);
        }
        $arr[$key] = $value;
    }
}

function print_mess_popup()
{
    $text = file('Uvodni_ohl.txt');
    $mess_box = "<div id='popup_uvodni_zpr' class='popUp'  style='display:none'>";
    foreach ($text as $line) {
        $mess_box.= $line;
    }
    $mess_box.= "</div>";
    return($mess_box);
}

function validation_elms($val_def){
    $elms = "";
    foreach($val_def as $rule => $fields){
        foreach($fields as $field => $label){
            $elms .= "<input type='hidden' name='".$rule."[$field]' value='$label' />";
        }
    }
    return $elms;
}

function data_valid(&$data){
    $valid = TRUE;
    //REQUiRED FORM FIELD VALIDATION
    if(!empty($data['value_required']))
        foreach($data['value_required'] as $field => $label){
            if($data[$field]=='') {
                $_SESSION['form_val_err'][] = sprintf('Pole <i>%s</i> je povinné!', $label);
                $valid = FALSE;
            }
        }

    // EMAIL FORM FIELD VALIDATION
    if(!empty($data['validate_email'])){
        $email_regexp = '/^[\._0-9a-zA-Z-]+@[0-9a-zA-Z][-0-9a-zA-Z\.]*\.[a-zA-Z]{2,4}$/';
        foreach($data['validate_email'] as $field => $label){
            if (!preg_match($email_regexp, $data[$field])){
                $_SESSION['form_val_err'][] = sprintf('<i>%s</i> musí mít následující formát: xxxx@xxx.xx !', $label);
                $valid = FALSE;
            }
        }
    }

    // IDENTICAL VALUES FORM FIELD VALIDATION
    if(!empty($data['identical_values'])){
        reset($data['identical_values']);
        $etalon = $data[key($data['identical_values'])]; //get the "first" key of array
        foreach($data['identical_values'] as $field => $label){
            if($data[$field]!=$etalon){
                $_SESSION['form_val_err'][] = sprintf('Hodnoty polí <i>%s</i> se musí shodovat!', implode('", "', $data['identical_values']));
                $valid = FALSE;
                break;
            }
        }
    }

    // DIFFERENT VALUES FORM FIELD VALIDATION
    if(!empty($data['different_values'])){
        $values=array();
        foreach($data['different_values'] as $field => $label){
            $values[] = $data[$field];
        }
        $values_unique = array_unique($values);
        if(count($values_unique)!=count($values)){
            array_walk($data['different_values'],'t');
            $_SESSION['form_val_err'][] = sprintf('Hodnoty polí <i>%s</i> musí být různé!', implode('", "', $data['different_values']));
            $valid = FALSE;
        }
    }

    // VALIDATION FROM PHP FUNCTIONS MAY ALSO SET THE ERROR MESSAGE
    if(!empty($_SESSION['form_val_err'])) $valid = FALSE;

    // Keep already filled data!
    // always call f: print_form_validation_notice() for validated data to clear the errors container
    if(!$valid) $_SESSION['tmp_form_data'] = $data;

    return $valid;
}

function print_form_validation_notice($keepFormData=false){
    $html="";
    if(!empty($_SESSION['form_val_err'])){
        $html.="<div id='formValNotice'>";
        $html.="<ul class='errList box redButtBox vmargin'>";
        foreach($_SESSION['form_val_err'] as $note){
            $html.="<li>".$note."</li>";
        }
        $html.="</ul>";
        $html.="</div>";
        unset($_SESSION['form_val_err']);
    }
    if(!empty($_SESSION['form_val_ok'])){
        $html.="<div id='formValNotice'>";
        $html.="<ul class='okList'>";
        foreach($_SESSION['form_val_ok'] as $note){
            $html.="<li>".$note."</li>";
        }
        $html.="</ul>";
        $html.="</div>";
        unset($_SESSION['form_val_ok']);
        $keepFormData = false;
    }
    if(!$keepFormData) unset($_SESSION['tmp_form_data']);
    return $html;
}

function is_user_logged($usrID = 0){
    //Ak nieje prihlaseny ziadny user vrat FALSE 
    if(!isset($_SESSION['logged_usr'])) return false;
    else{//ak je prihlaseny falosny user vrat false
        $sql = 'SELECT id, role FROM uzivatel WHERE id='.mysql_real_escape_string($_SESSION['logged_usr']);
        $res = mysql_query($sql) or die($sql.'<br /><br />Query failed: ' . mysql_error());
        if (mysql_num_rows($res)<1) return false;
        else $_SESSION['role'] = mysql_fetch_assoc($res)['role'];
    }
    //Ak je iekto prihlaseny nas zaujima akykolvek user vrat TRUE
    if($usrID == 0) return true;
    //Ak je iekto prihlaseny a zaujima nas konkretny user
    if($usrID > 0) return ($usrID == $_SESSION['usr_id'])? true : false;
    //Ak kontrolovane cislo je nonsens (napriklad zaporne)
    return false;
}

function is_owner($hid){  //vlastnik hesla
    $owners = get_vybrane_hodnoty_ciselniku(ZPRACOVATELE, 'hes', $hid);
    if(in_array(get_logged_user(), array_keys($owners)) || is_admin(get_logged_user())) return true;
    return false;
}

function get_logged_user(){
    return $_SESSION['logged_usr'];
}

function get_user_name($uid){
    $d = get_db_values('uzivatel', array('jmeno', 'prijmeni'), $uid);
    if($d)
        return $d['jmeno']."&nbsp;".$d['prijmeni'];
    else
        return '';
}

function get_role(){
    if(defined('ROLE')){
        return ROLE;
    }
    $test = basename($_SERVER['PHP_SELF']);
    if(substr($test, 0, 3) == "web"){
        return WEB_UZIVATEL;
    }
    if(!is_null($_SESSION['role'])){
        return $_SESSION['role'];
    }
    return null;
}

function is_admin($uid){
    if(!is_numeric($uid)) return false;
    $sql = "SELECT admin FROM uzivatel WHERE id=$uid";
    $res = mysql_query($sql) or die($sql.'<br /><br />Query failed: ' . mysql_error());
    if(mysql_num_rows($res)==1) $adm = mysql_result($res, 0, 0);
    if($adm == '1') return true; else return false;
}

function is_hlred($uid = False)
{
    if (!$uid) {
        $uid = get_logged_user();
    }
    $res = dibi::fetchSingle('SELECT 1 FROM uzivatel WHERE id = %i AND role = %i', $uid, HLAVNI_REDAKTOR);
    return ($res == 1);
}

function is_role_uzivatel($role = False) {
    if ($role === False) {
        $role = get_role();
    }
    return ($role == UZIVATEL || $role == HLAVNI_REDAKTOR);
}

function get_role_uzivatel($implode = False) {
    $arr = array(UZIVATEL, HLAVNI_REDAKTOR);
    if ($implode !== False) {
        $arr = implode($implode, $arr);
    }
    return $arr;
}

/*
function fancyBoxSettings($type){
  $settings=array();
  switch($type){
   case 'nove_heslo':
    $settings["autoDimensions"] = "false";
    $settings["width"] = "350";
    $settings["height"] = "'auto'";
    break;
   default:
    $settings=array();
  }

  $settingsObj_str = "{";
  foreach($settings as $key => $val){
    $settingsObj_str .= "'$key':$val,";
  }
  $settingsObj_str = substr($settingsObj_str,0,-1);
  $settingsObj_str .= "}";

  return $settingsObj_str;
}
*/

function addFields_butt_ajax($add, $containerDOMid, $vars=array(), $name='záznam'){
    $html.="<div id='".$containerDOMid."_addButt' onClick='addFields_ajaxReq(\"$add\", \"$containerDOMid\", ".json_encode($vars).");' class='addRemFieldsButt whiteBG butt floatLeft'>+ přidat $name</div>";
    return $html;
}

function remFields_butt_ajax($hide='false'){
    return "<div class=\"removeRemFieldsButt center redBG butt\" onClick=\"JS_rem_field(this, 'multiInput', ".$hide.")\" >-</div>";
}

function get_id_zpracovatele($hid){
    if(!is_numeric($hid)) return array();
    $sql = "SELECT id FROM zpracovatel WHERE hid=$hid";
    $res = mysql_query($sql) or die($sql.'<br /><br />Query failed: ' . mysql_error());
    $zpracovatele = array();
    while($rec = mysql_fetch_assoc($res)){
        $zpracovatele[] = $rec['id'];
    }
    return $zpracovatele;
}

function get_zpracovatele($hid){
    if(!is_numeric($hid)) return array();
    $sql = "SELECT uid FROM zpracovatel WHERE hid=$hid";
    $res = mysql_query($sql) or die($sql.'<br /><br />Query failed: ' . mysql_error());
    $zpracovatele = array();
    while($rec = mysql_fetch_assoc($res)){
        $zpracovatele[] = $rec['uid'];
    }
    return $zpracovatele;
}


function smaz_zpracovatele($zprac_id){
    $sql = "DELETE FROM zpracovatel WHERE id=$zprac_id";
    $res = mysql_query($sql) or die("Chyba DB! [f: smaz_zpracovatele()] <p>".mysql_error()."</p><p>$sql</p>");
}

function heslo_existuje($heslo){
    $heslo = text_db_preprocess($heslo);
    $sql = "SELECT count(id) as cnt FROM varianty WHERE varianta='$heslo'";
    $res = mysql_query($sql) or die($sql.'<br /><br />Query failed: ' . mysql_error());
    return (mysql_result($res, 0, 'cnt') > 0);
}

function seznam_existuje($nazev){
    $nazev = text_db_preprocess($nazev);
    $sql = "SELECT COUNT(id) AS cnt FROM seznam_hesel WHERE nazev='$nazev'";
    $res = mysql_query($sql) or die($sql.'<br /><br />Query failed: ' . mysql_error());
    return (mysql_result($res, 0, 'cnt') > 0);
}

function get_multivariantni_hesla(&$pids = null, $count = 1){
    $hids = array();
    $sql = "SELECT DISTINCT (hid), varianty_bez_zavor, homonymie, h.pid  FROM varianty NATURAL JOIN (
                SELECT hid FROM varianty v GROUP BY hid HAVING COUNT( DISTINCT v.id ) > $count) t JOIN heslo h ON hid=h.id WHERE  heslar_id IN (" . implode(",", $_SESSION['aktivni_heslar']) . ")
            ORDER by varianty_bez_zavor ASC, homonymie ASC;";

    /*if(!isset($_SESSION['razeni_hesel'])) order_list_by();
    $ord_by = parse_ordering_array($_SESSION['razeni_hesel']);
    $col = parse_ordering_array_col($_SESSION['razeni_hesel']);

    $SQL_filter="";
    $filter = parse_data_filter("hesla");
    $search_q = trim($_SESSION['search']['query']);
    $Joins = array();
    if($filter!==false) {
     if($_SESSION['data_filter']["_filterName"]=="moje"){
       $Joins[] = "INNER JOIN zpracovatel u ON h.id=u.hid";
     }
     $SQL_filter .= $filter;
    }
    if($search_q!=""){
        $qs = new QuickSearch($_SESSION['search']['field']);
        $Joins = $qs->get_joins();
        if(!empty($SQL_filter)) $SQL_filter.= " AND ";
        $SQL_filter.= $qs->get_where_clause($_SESSION['search']['query']);
    }
   /* if(!empty($SQL_filter)){
        $sub_sql=" WHERE $SQL_filter "; //AND v.sortorder=1
    }
    //$j = implode(" ", $Joins);

    $sql = "SELECT DISTINCT subsql.hid FROM
(
	SELECT h.id as hid, v.varianta, $col
        FROM heslo h INNER JOIN
        (varianty v NATURAL JOIN (
        SELECT hid,varianta FROM varianty GROUP BY hid HAVING COUNT( DISTINCT id ) > 1 ORDER BY sortorder) as x)
        ON h.id = x.hid $j $sub_sql) subsql ORDER BY $ord_by";

    echo $sql;*/
    $temp_pids=array();
    $res = dbq($sql);
    while($rec = mysql_fetch_array($res)){
        if(!in_array($rec['hid'], $hids))
            $hids[] = $rec['hid'];
        $temp_pids[] = $rec['pid'];
    }

    if(!empty($SQL_filter)){
        if($pids!=null)
        {
            $qs_hesla = filtruj_hesla($SQL_filter, $Joins, $ord_by, $col);
            $result = prunik_poli_extra($hids, $qs_hesla, $temp_pids, $pids);
        }
        else
        {
            $qs_hesla = filtruj_hesla($SQL_filter, $Joins, $ord_by, $col);
            $result = prunik_poli($hids, $qs_hesla);
        }
        return $result;
    }
    else
    {
        $pids=$temp_pids;
    }
    return $hids;
}

function get_hesla_prl(&$pids = null){
    if(!isset($_SESSION['razeni_hesel'])) order_list_by();
    $temp_pids=array();
    $ord_by = parse_ordering_array($_SESSION['razeni_hesel']);
    $col = parse_ordering_array_col($_SESSION['razeni_hesel']);
    $filter = parse_data_filter("hesla");
    $search_q = trim($_SESSION['search']['query']);
    $Joins = array();
    $SQL_filter = "";
    if($filter!==false) {
        if($_SESSION['data_filter']["_filterName"]=="moje")
            $Joins[] = "INNER JOIN zpracovatel u ON h.id=u.hid";
        $SQL_filter .= $filter;
    }

    $qs_OBJ = new QuickSearch("varianta-slovnyDruh");
    $Joins = array_merge($Joins, $qs_OBJ->get_joins());
    if(!empty($SQL_filter)) $SQL_filter.= " AND ";
    $SQL_filter.= $qs_OBJ->get_where_clause("12");
    $SQL_filter="(".$SQL_filter.")AND heslar_id IN (" . implode(",", $_SESSION['aktivni_heslar']) . ") ";

    $hesla = array();
    $sub_sql ="SELECT h.id as hid, h.pid as pid, $col";
    $sub_sql.=" FROM heslo h";
    $sub_sql.=" INNER JOIN varianty v ON h.id=v.hid ".implode(" ", $Joins);
    $sub_sql.=" WHERE ".$SQL_filter." AND heslar_id IN (" . implode(",", $_SESSION['aktivni_heslar']) . ") "; //AND v.sortorder=1
    if (!is_role_uzivatel()){
        $sub_sql .= ' AND v.hid IN
      (SELECT hvs.hid
      FROM (hesla_v_seznamu hvs INNER JOIN seznam_hesel sh ON hvs.sid=sh.id) INNER JOIN seznam_hesel_uziv shu ON sh.id=shu.sid
      WHERE shu.uid = ' . get_logged_user() .'
      GROUP BY hvs.hid)';
    }
    $sub_sql.=" ORDER BY v.sortorder";

    $sql = "SELECT DISTINCT subsql.hid, varianta, pid FROM ($sub_sql) subsql  ORDER BY  $ord_by";

    $res = mysql_query($sql) or die("f: get_hesla() <br /><br /> $sql <br /><br /> <i>".mysql_error()."</i>");
    while($rec = mysql_fetch_assoc($res)){
        $hesla[] = $rec['hid'];
        $temp_pids[] = $rec['pid'];
        $sub_sql2 =" SELECT h.id as hid, v.varianta, h.pid as pid, $col";
        $sub_sql2.=" FROM heslo h";
        $sub_sql2.=" INNER JOIN varianty v ON h.id=v.hid ".implode(" ", $Joins);
        $sub_sql2.=" WHERE v.varianta LIKE CONCAT(LEFT('".$rec['varianta']."',LENGTH('".$rec['varianta']."')-1),'_') AND (cis_id = 6 OR cis_id = 19) "; //AND v.sortorder=1
        $sub_sql2.=" ORDER BY v.sortorder";
        $sql2 = "SELECT DISTINCT subsql.hid, pid  FROM ($sub_sql2) subsql ORDER BY  $ord_by";
        $res2 = mysql_query($sql2) or die("f: get_hesla() <br /><br /> $sql2 <br /><br /> <i>".mysql_error()."</i>");
        while($rec2 = mysql_fetch_assoc($res2)){
            $hesla[] = $rec2['hid'];
            $temp_pids[] = $rec2['pid'];
        }
    }

    if(!isset($_SESSION['razeni_hesel'])){
        order_list_by();
    }
    $SQL_filter = "";
    $filter = parse_data_filter("hesla");
    $search_q = trim($_SESSION['search']['query']);
    $Joins = array();
    if($filter!==false) {
        if($_SESSION['data_filter']["_filterName"]=="moje"){
            $Joins[] = "INNER JOIN zpracovatel u ON h.id=u.hid";
        }
        $SQL_filter .= $filter;
    }
    if($search_q!=""){
        $qs_OBJ = new QuickSearch($_SESSION['search']['field']);
        $Joins = array_merge($Joins, $qs_OBJ->get_joins($_SESSION['search']['query']));
        if(!empty($SQL_filter)){
            $SQL_filter.= " AND ";
        }
        $SQL_filter.= $qs_OBJ->get_where_clause($_SESSION['search']['query']);
        $SQL_filter="(".$SQL_filter.")AND heslar_id IN (" . implode(",", $_SESSION['aktivni_heslar']) . ") ";
    }

    if(!empty($SQL_filter)){
        if($pids!=null)
        {
            $qs_hesla = filtruj_hesla($SQL_filter, $Joins, $ord_by, $col);
            $result = prunik_poli_extra($hesla, $qs_hesla, $temp_pids, $pids);
        }
        else
        {
            $qs_hesla = filtruj_hesla($SQL_filter, $Joins, $ord_by, $col);
            $result = prunik_poli($hesla, $qs_hesla);
        }
        return $result;
    }
    else
    {
        $pids=$temp_pids;
    }
    return $hesla;
}

function prunik_poli($A, $B){
    $C = array();
    foreach($A as $a){
        if(in_array($a, $B)){
            $C[] = $a;
        }
    }
    return $C;
}

function prunik_poli_extra($A, $B, $Adva, &$Cdva){
    $C = array();
    foreach($A as $index=>$a){
        if(in_array($a, $B)){
            $C[] = $a;
            $Cdva[] = $Adva[$index];
        }
    }
    return $C;
}

function filtruj_hesla($SQL_filter, $Joins, $ord_by, $col, &$pids = null){
    if($col!="")
    {
        $sub_sql ="SELECT h.id as hid, h.pid, v.sortorder, $col";
    }
    else
    {
        $sub_sql ="SELECT h.id as hid, h.pid,  v.sortorder ";
    }
    $sub_sql.=" FROM heslo h";

    $sub_sql.=" INNER JOIN varianty v ON h.id=v.hid ".implode(" ", $Joins);
    if(!empty($SQL_filter))
    {
        $sub_sql.=" WHERE ".$SQL_filter; //AND v.sortorder=1
    }
    else
    {
        $sub_sql.=" WHERE pid is NULL";
    }
    if (!is_role_uzivatel()){
        $sub_sql .= ' AND v.hid IN
      (SELECT hvs.hid
      FROM (hesla_v_seznamu hvs INNER JOIN seznam_hesel sh ON hvs.sid=sh.id) INNER JOIN seznam_hesel_uziv shu ON sh.id=shu.sid
      WHERE shu.uid = ' . get_logged_user() .'
      GROUP BY hvs.hid)';
    }
    $sub_sql.=" ORDER BY v.sortorder";

    if($ord_by!="")
    {
        $sql = "SELECT DISTINCT (subsql.hid), pid FROM ($sub_sql) subsql  ORDER BY  $ord_by";
    }
    else
    {
        $sql = "SELECT DISTINCT (subsql.hid), pid FROM ($sub_sql) subsql  ORDER BY sortorder";
    }
    //$sql = "SELECT DISTINCT subsql.hid FROM (($sub_sql) UNION ALL (SELECT h.id as hid, v.varianta, $col FROM ($sub_sql) as test INNER JOIN varianty v2 ON test.hid=v2.hid WHERE v2.varianta REGEXP CONCAT(LEFT(v.varianta,LENGTH(v.varianta)),'.') AND (cis_id = 6 OR cis_id = 19))) as subsql ORDER BY  $ord_by";
    $res = mysql_query($sql) or die("f: filtruj_hesla() <br /><br /> $sql <br /><br /> <i>".mysql_error()."</i>");
    $hesla = array();
    $uid = get_logged_user();
    $videna = array();
    if($_SESSION['data_filter']['_dataID']=='hesla' && $_SESSION['data_filter']['_filterName']== "nevidel_jsem"){ 
        $videna = videna_hesla($uid);
    }
        
    while($rec = mysql_fetch_assoc($res)){
        $pridej = true;
        if($_SESSION['data_filter']['_dataID']=='hesla' && $_SESSION['data_filter']['_filterName']== "nevidel_jsem"){
           if(in_array($rec['hid'], $videna)){
               $pridej = false;
           }
        }
        if($pridej){
            $hesla[] = $rec['hid'];
            $pids[] = $rec['pid'];
        }
    }
    return $hesla;
}

function get_hesla($forced=False, &$pids = null, $heslare_id=-1)
{
    //ak je nastaveny filter hesiel s korekturou -> na to mam inu funkciu -> treba ju pouzit

    if ($forced){
        return $forced;
    }
    $_SESSION['search']['morphodita_ok'] = true;
    if($_SESSION['data_filter']['_dataID']=='hesla' && $_SESSION['data_filter']['_filterName']=='special'){
        return get_hesla_prl($pids);
    }
    if($_SESSION['data_filter']['_dataID']=='hesla' && $_SESSION['data_filter']['_filterName']=='multivariant'){
        return get_multivariantni_hesla($pids, 1);
    } else if($_SESSION['data_filter']['_dataID']=='hesla' && $_SESSION['data_filter']['_filterName']=='multivariant3'){
        return get_multivariantni_hesla($pids, 2);
    }
    if(!isset($_SESSION['razeni_hesel'])) order_list_by();
    $ord_by = parse_ordering_array($_SESSION['razeni_hesel']);
    $col = parse_ordering_array_col($_SESSION['razeni_hesel']);
    $filter = parse_data_filter("hesla");
    if($_SESSION['data_filter']['_dataID']=='hesla' && $_SESSION['data_filter']['_filterName']=='nove_korektury'){
        $new_corr_uids = Redakce::get_hesla_s_korekci_pro_zpracovatele(get_logged_user(), $pids, $ord_by, $col);
        if(!empty($new_corr_uids)){ return $new_corr_uids;}
    }
    //ak je nastaveny xFilter -> pouzijem vyberovu funkciu v triede xFilter

    //jinak jdu normalne vybirat z hesel
    if(isset($_SESSION['search']['query'])){
        $search_q = trim($_SESSION['search']['query']);
    }else{
        $search_q="";
    }
    $Joins = array();
    $Joins[] = "INNER JOIN heslare heslar ON h.heslar_id=heslar.id";
    $SQL_filter="";
    if($filter!==false) {
        if($_SESSION['data_filter']["_filterName"]=="moje"){
            $Joins[] = "INNER JOIN zpracovatel u ON h.id=u.hid";
        }
        $SQL_filter .= $filter;
    }
    if($search_q!=""){
        $qs_OBJ = new QuickSearch($_SESSION['search']['field']);
        $Joins = array_merge($Joins, $qs_OBJ->get_joins($_SESSION['search']['query']));
        if(!empty($SQL_filter)) $SQL_filter.= " AND ";
        $SQL_filter.= "((".$qs_OBJ->get_where_clause($_SESSION['search']['query']);
        if($_SESSION['search']['field']=="vyznam-vyklad_vyznamu")
        {
            $SQL_filter.= ") OR (";
            $qs_OBJ = new QuickSearch("vyznam-vyklad_vyznamu-master");
            $Joins[] =  'LEFT JOIN vyznamy_master vm ON vm.id = vyz.vyklad_vyznamu_link' ;
            $SQL_filter.= $qs_OBJ->get_where_clause($_SESSION['search']['query']);
        }
        $SQL_filter.= ")) AND heslar_id IN (" . implode(",", $_SESSION['aktivni_heslar']) . ") ";
    }
    if($_SESSION['data_filter']['_dataID']=='hesla' && $_SESSION['data_filter']['_filterName']=='odm_kor')
    {
        $Joins[] = ' JOIN aktual_stav_korektur ask ON h.id=ask.hid ';
        if(!empty($SQL_filter)) $SQL_filter.= " AND ";
        $SQL_filter.= " ask.status=".REJECTED_BY_EDITOR." ";
    }

    if($_SESSION['data_filter']['_dataID']=='hesla' && $_SESSION['data_filter']['_filterName']=='xFilter')
    {
        $xF = new xFilter();
        if(is_numeric($_SESSION['data_filter']['_filterValue']))
        {
            $xF_hesla = $xF->get_hesla($_SESSION['data_filter']['_filterValue']);
        }
        else
        {
            err("Chyba nastavení xfiltru, prosím nastavte požadovaný filtr znovu a zaznamenejte zprávu pod nápisem error log");
            var_dump("--------------------------------------");
            var_dump("error log");
            var_dump($_SESSION['data_filter']['_filterValue']);
            var_dump("--------------------------------------");
        }
        if(!empty($xF_hesla))
        {
            $ord_by = parse_ordering_array($_SESSION['razeni_hesel']);
            $col = parse_ordering_array_col($_SESSION['razeni_hesel']);
            $heslaarr=join(',',$xF_hesla);
            $sub_sql =" SELECT h.id as hid, h.pid, $col";
            $sub_sql.=" FROM heslo h";
            $sub_sql.=" INNER JOIN varianty v ON h.id=v.hid ".implode(" ", $Joins);
            if($heslare_id>=0){
                $sub_sql.=" WHERE h.id IN ($heslaarr) AND heslar_id  = " . $heslare_id. "  ";
            }
            else{
                $sub_sql.=" WHERE h.id IN ($heslaarr) AND heslar_id IN (" . implode(",", $_SESSION['aktivni_heslar']) . ") ";
            }
            if(!empty($SQL_filter)){
                $sub_sql.=" AND $SQL_filter "; //AND v.sortorder=1
            }
            if (!is_role_uzivatel()){
                $sub_sql .= ' AND v.hid IN 
          (SELECT hvs.hid
          FROM (hesla_v_seznamu hvs INNER JOIN seznam_hesel sh ON hvs.sid=sh.id) INNER JOIN seznam_hesel_uziv shu ON sh.id=shu.sid
          WHERE shu.uid = ' . get_logged_user() .'
          GROUP BY hvs.hid)';
            }
            $sub_sql.=" ORDER BY v.sortorder";
            $sql = "SELECT DISTINCT (subsql.hid), pid  FROM ($sub_sql) subsql ORDER BY $ord_by";
            $hesla=array();
            $res = mysql_query($sql) or die("f: get_hesla() <br /><br /> $sql <br /><br /> <i>".mysql_error()."</i>");
            while($rec = mysql_fetch_assoc($res)){
                $hesla[] = $rec['hid'];
                $pids[] = $rec['pid'];
            }
            return $hesla;
        }
        return $xF_hesla;
    }
    if(!empty($SQL_filter)) {
        if($heslare_id>=0){
            $SQL_filter .= " AND heslar_id = " . $heslare_id. "  ";
        }
        else{
            $SQL_filter .= " AND heslar_id IN (" . implode(",", $_SESSION['aktivni_heslar']) . ") ";
        }
    }
    else{
        if($heslare_id>=0){
            $SQL_filter = " heslar_id = " . $heslare_id. "  ";
        }
        else{
            $SQL_filter = " heslar_id IN (" . implode(",", $_SESSION['aktivni_heslar']) . ") ";
        }
    }
    $hesla = filtruj_hesla($SQL_filter, $Joins, $ord_by, $col, $pids);
    if($search_q!="" && ($_SESSION['search']['field']=="vyznam-predvyklad" || $_SESSION['search']['field']=="vyznam-metavyklad1" ||$_SESSION['search']['field']=="vyznam-vyklad_vyznamu" ||$_SESSION['search']['field']=="vyznam-metavyklad2")){
        $SQL_filter="";
        $Joins = array();
        if($filter!==false) {
            if($_SESSION['data_filter']["_filterName"]=="moje"){
                $Joins[] = "INNER JOIN zpracovatel u ON h.id=u.hid";
            }
            $SQL_filter = $filter;
        }
        $qs_OBJ = new QuickSearch($_SESSION['search']['field']."-master");
        $Joins = array_merge($Joins, $qs_OBJ->get_joins($_SESSION['search']['query']));
        if(!empty($SQL_filter)) $SQL_filter.= " AND ";
        $SQL_filter.= $qs_OBJ->get_where_clause($_SESSION['search']['query']);
        $SQL_filter="(".$SQL_filter.")AND heslar_id IN (" . implode(",", $_SESSION['aktivni_heslar']) . ") ";

        $hesla = array_merge($hesla,filtruj_hesla($SQL_filter, $Joins, $ord_by, $col, $pids));
    }
    return $hesla;
}

function get_subhids($pid)
{
    $sql = "SELECT id FROM heslo WHERE pid=$pid";
    return db_get_val_arr($sql);
}

function get_podhesli_vyznamu($vyz_id){
    $sql = "SELECT id FROM podhesli_vyznamu WHERE vyz_id=$vyz_id";
    return db_get_val_arr($sql);
}

/*
 * Vrati pole HID pripojenych/prihnizdovanych k zadanemu master_hid
 */
function get_hids_pripojeni($master_hid){
    $sql = "SELECT DISTINCT `slave_hid` FROM `hesla_rel` WHERE `main_hid` = $master_hid AND (rel_type = ".HREL_TYPE_pripojovani." OR rel_type = ".HREL_TYPE_prihnizdovani.");";
    $slaves = db_fetchAll($sql);
    return $slaves;
}


/*
  Vrati id vyznamu hesla $hid, ktere jsou zarazeny do HTML, resp PDF vystup
  (parametr $to_pdf)
  Podvyznamy nejsou zapocitavany!
*/
function get_vyznamy_count($hid, $to_pdf){
    global $_VYSTUP; //typ vystupu, konstanty.php
    if(is_null($hid) || empty($hid)) return "";
    $sql = "SELECT id FROM vyznamy WHERE hid=$hid AND pid IS NULL ";
    if($to_pdf){
        $sql .="AND typ_vystupu = ". TISTENY;
    }else{
        $sql .="AND (typ_vystupu = ". TISTENY ." OR typ_vystupu = ". ELEKTRONICKY .")";
    }
    $sql.=" ORDER BY sortorder";
    return db_get_val_arr($sql);
}

function print_varianta_str($var_id, $with_hom=true){
    if (!$var_id) return;
    $var_info = get_db_values('varianty', array('varianta', 'homonymie'), $var_id);
    $hom = ""; if($with_hom && trim($var_info['homonymie'])!="") $hom = " [".$var_info['homonymie']."]";
    return $var_info['varianta'].$hom;
}

function print_heslo_str($hid, $odkaz = null){
    if(!is_numeric($hid)) return false;
    if ($GLOBALS['is_archive']){
        $sql = "SELECT id FROM archive_varianty WHERE hid=$hid ORDER BY sortorder";
    }else{
        $sql = "SELECT id FROM varianty WHERE hid=$hid ORDER BY sortorder";
    }
    $var_ids = db_get_val_arr($sql);
    $str_arr = array();
    foreach($var_ids as $var_id){
        if($odkaz == true){
            $str_arr[] = print_varianta_str($var_id, false);
            break; //u odkazu se tiskne pouze prvni varianta
        }
        $str_arr[] = print_varianta_str($var_id);
    }
    return implode(", ", $str_arr);
}

function print_heslo_str_spec($hid){
    if(!is_numeric($hid)) return false;
    $sql = "SELECT id FROM varianty WHERE hid=$hid ORDER BY sortorder";
    $var_ids = db_get_val_arr($sql);
    $str_arr = array();
    foreach($var_ids as $var_id){
        $sql2 = "SELECT cis_id FROM typ_hesla_var_vyber WHERE vid=".$var_id;
        $cis_ids = db_get_val_arr($sql2);
        $nenalezeno=true;
        foreach($cis_ids as $cis_id)
        {
            if($cis_id==1 || $cis_id==5 || $cis_id==7)
            {
                $slovDruhy_db = get('slovneDruhy_varianty', $var_id);
                $slovDruhy = array();
                foreach($slovDruhy_db as $slDr_id){
                    $slovDruhy[] = implode(get_vybrane_hodnoty_ciselniku(SLOV_DRUHY, 'var', $slDr_id), ", ");
                }
                $slovDruhy = implode($slovDruhy, ", ");
                $str_arr[] = print_varianta_str($var_id)." (".$slovDruhy.")";
                $nenalezeno=false;
                break;
            }
        }
        if($nenalezeno)$str_arr[] = print_varianta_str($var_id);
    }
    return implode(", ", $str_arr);
}

function printRedBox($print="false", $h = 0, $v = 0){
    $file = $_SERVER["SCRIPT_NAME"];
    $output = "";
    if(strpos($file, "tisk_hesel")){
        $output = " AND (typ_vystupu = '".ELEKTRONICKY."' OR typ_vystupu = '".TISTENY."')";
    }
    $html="";
    if(!$h){
        $vyz_id = json_decode($_COOKIE["upraveny_vyznam"]);
        $hid = json_decode($_COOKIE["upraveny_vyznam_hid"]);
        if($vyz_id==NULL || $hid==NULL)
        {
            unset($_COOKIE["upraveny_vyznam"]);
            unset($_COOKIE["upraveny_vyznam_hid"]);
            ($_COOKIE["upraveny_vyznam"] = 0);
            ($_COOKIE["upraveny_vyznam_hid"] = 0);
            setcookie('upraveny_vyznam', null, -1, '/');
            setcookie('upraveny_vyznam_hid', null, -1, '/');
        }
        if (empty($vyz_id[0]) || empty($hid[0]))
        {
            unset($_COOKIE["upraveny_vyznam"]);
            unset($_COOKIE["upraveny_vyznam_hid"]);
            ($_COOKIE["upraveny_vyznam"] = 0);
            ($_COOKIE["upraveny_vyznam_hid"] = 0);
            setcookie('upraveny_vyznam', null, -1, '/');
            setcookie('upraveny_vyznam_hid', null, -1, '/');
        }
    } else{
        $vyz_id = $v;
        $hid = $h;
    }

    if($vyz_id!=NULL && $hid!=NULL)
    {
        if (!empty($vyz_id[0]) && !empty($hid[0]))
        {
            if(!is_array($vyz_id))
            {
                if(substr($vyz_id,0,3)=="new")
                {
                    return $html;
                }
                if(substr($vyz_id,0,1)=="m")
                {
                    $result = dibi::query("SELECT id, hid, sortorder, pid, typ_vystupu FROM vyznamy WHERE vyklad_vyznamu_link=".substr($vyz_id,1));
                    $vyz_ids =  $result->fetchAll();
                    foreach($vyz_ids as $vids)
                    {
                        $linky = uprava_ant_syn_counter($vids["hid"], $vids["id"]);
                        $hlv = get_hlavni_varianta_hesla($vids["hid"]);
                        $vyz_var = print_varianta_str($hlv);
                        if($vids["pid"]>0)
                        {
                            $query = dibi::query("SELECT typ_vystupu FROM vyznamy WHERE id=".$vids["pid"]);
                            $vystup = $query->fetchSingle();
                            if($vystup == NEZARAZENO && !empty($output))
                            {
                                $num = "(nez.)";
                            }
                            else
                            {
                                $result2 = dibi::query("SELECT COUNT(*) FROM vyznamy WHERE (pid=0 OR pid is NULL) AND hid=".$vids["hid"]." AND sortorder<=".$vids["sortorder"].$output);
                                $result =  dibi::query("SELECT COUNT(*) FROM vyznamy WHERE pid=".$vids["pid"]." AND sortorder<=".$vids["sortorder"]);
                                $vyz = $result2-> fetchSingle();
                                $sub = $result->fetchSingle();
                                $num = $vyz."S".$sub;
                            }
                        }
                        else
                        {
                            if($vids["typ_vystupu"] == NEZARAZENO && !empty($output))
                            {
                                $num = "(nez.)";
                            }
                            else
                            {
                                if(array_key_exists("hid", $vids) && $vids!="hid")
                                {
                                    $result = dibi::query("SELECT COUNT(*) FROM vyznamy WHERE (pid=0 OR pid is NULL) AND hid=" . $vids["hid"] . " AND sortorder<=" . $vids["sortorder"] . $output);
                                    $num = $result->fetchSingle();
                                }
                                else
                                {
                                    $num = 1;
                                }
                            }
                        }
                        if(count($linky)>0)
                        {
                            //foreach($vyznamy as $vyz_id) $i++;
                            $html.='<div id="upravy_ant_syn_bar_'.$vids["id"].'" title="Hesla ke kontrole" class="redBox"><div class="clickable floatLeft"  onClick="upravy_ant_syn('.$vids["hid"].','.$vids["id"].','.$print.')"> <img src="css/images/odkaz.png" alt="otevřít"/>&nbsp;<b>'.count($linky).'</b> Hesla, spojená s <b>'.$vyz_var.'</b> '.$num.', ke kontrole &nbsp;</div><span onClick="clear_upravy_ant_syn('.$vids["hid"].','.$vids["id"].')" class="clickable"><img src="css/images/close.png" alt="zavřít"/></span></div>';
                        }
                        else
                        {
                            $html.='<script type="text/javascript"> clear_upravy_ant_syn('.$vids["hid"].','.$vids["id"].')</script>';
                        }
                    }
                }
                else
                {
                    $result = dibi::query("SELECT sortorder, hid, pid, typ_vystupu FROM vyznamy WHERE id=".$vyz_id);
                    $data =  $result->fetchAll();
                    if($data[0]["pid"]>0)
                    {
                        $query = dibi::query("SELECT typ_vystupu FROM vyznamy WHERE id=".$data[0]["pid"]);
                        $vystup = $query->fetchSingle();
                        if($vystup == NEZARAZENO && !empty($output)){
                            $num = "(nez.)";
                        } else{
                            $result2 = dibi::query("SELECT COUNT(*) FROM vyznamy WHERE (pid=0 OR pid is NULL) AND hid=".$data[0]["hid"]." AND sortorder<=".$data[0]["sortorder"].$output);
                            $result =  dibi::query("SELECT COUNT(*) FROM vyznamy WHERE pid=".$data[0]["pid"]." AND sortorder<=".$data[0]["sortorder"]);
                            $vyz = $result2->fetchSingle();
                            $sub = $result->fetchSingle();
                            $num = $vyz."S".$sub;
                        }
                    }
                    else
                    {
                        if($data[0]["typ_vystupu"] == NEZARAZENO && !empty($output)){
                            $num = "(nez.)";
                        }
                        else
                        {
                            if(isset($data[0]["sortorder"]) && isset($data[0]["hid"]))
                            {
                                $result = dibi::query("SELECT COUNT(*) FROM vyznamy WHERE (pid=0 OR pid is NULL) AND hid=".$data[0]["hid"]." AND sortorder<=".$data[0]["sortorder"].$output);
                                $num = $result->fetchSingle();
                            }
                            else
                            {
                                $num=1;
                            }
                        }
                    }
                    $linky = uprava_ant_syn_counter($hid, $vyz_id);
                    $hlv = get_hlavni_varianta_hesla($hid);
                    $vyz_var = print_varianta_str($hlv);
                    if(count($linky)>0)
                    {
                        $html.='<div id="upravy_ant_syn_bar_'.$vyz_id.'" title="Hesla ke kontrole" class="redBox"><div class="clickable floatLeft"  onClick="upravy_ant_syn('.$hid.','.$vyz_id.','.$print.')"> <img src="css/images/odkaz.png" alt="otevřít"/>&nbsp;<b>'.count($linky).'</b> Hesla, spojená s <b>'.$vyz_var.'</b> '.$num.', ke kontrole &nbsp;</div><span onClick="clear_upravy_ant_syn('.$hid.','.$vyz_id.')" class="clickable"><img src="css/images/close.png" alt="zavřít"/></span></div>';
                    }
                    else
                    {
                        $html.='<script type="text/javascript"> clear_upravy_ant_syn('.$hid.','.$vyz_id.')</script>';
                    }
                }
            }
            else
            {
                foreach($vyz_id as $key => $vid)
                {
                    if(substr($vid,0,3)!="new")
                    {
                        if(substr($vid,0,1)=="m")
                        {
                            $result = dibi::query("SELECT id, hid, sortorder, pid, typ_vystupu FROM vyznamy WHERE vyklad_vyznamu_link=".substr($vid,1));
                            $vyz_ids =  $result->fetchAll();
                            foreach($vyz_ids as $vids)
                            {
                                $linky = uprava_ant_syn_counter($vids["hid"], $vids["id"]);
                                $hlv = get_hlavni_varianta_hesla($vids["hid"]);
                                $vyz_var = print_varianta_str($hlv);
                                if($vids["pid"]>0)
                                {
                                    $query = dibi::query("SELECT typ_vystupu FROM vyznamy WHERE id=".$vids["pid"]);
                                    $vystup = $query->fetchSingle();
                                    if($vystup == NEZARAZENO && !empty($output)){
                                        $num = "(nez.)";
                                    } else{
                                        $result2 = dibi::query("SELECT COUNT(*) FROM vyznamy WHERE (pid=0 OR pid is NULL) AND hid=".$vids["hid"]." AND sortorder<=".$vids["sortorder"].$output);
                                        $result =  dibi::query("SELECT COUNT(*) FROM vyznamy WHERE pid=".$vids["pid"]." AND sortorder<=".$vids["sortorder"]);
                                        $vyz = $result2->fetchSingle();
                                        $sub = $result->fetchSingle();
                                        $num = $vyz."S".$sub;
                                    }
                                }
                                else
                                {
                                    if($vids["typ_vystupu"] == NEZARAZENO && !empty($output)){
                                        $num = "(nez.)";
                                    } else{
                                        $result = dibi::query("SELECT COUNT(*) FROM vyznamy WHERE (pid=0 OR pid is NULL) AND hid=".$vids["hid"]." AND sortorder<=".$vids["sortorder"].$output);
                                        $num = $result->fetchSingle();
                                    }
                                }
                                if(count($linky)>0)
                                {
                                    $html.='<div id="upravy_ant_syn_bar_'.$vids["id"].'" title="Hesla ke kontrole" class="redBox"><div class="clickable floatLeft"  onClick="upravy_ant_syn('.$vids["hid"].','.$vids["id"].','.$print.')"> <img src="css/images/odkaz.png" alt="otevřít"/>&nbsp;<b>'.count($linky).'</b> Hesla, spojená s <b>'.$vyz_var.'</b> '.$num.', ke kontrole &nbsp;</div><span onClick="clear_upravy_ant_syn('.$vids["hid"].','.$vids["id"].')" class="clickable"><img src="css/images/close.png" alt="zavřít"/></span></div>';
                                }
                                else
                                {
                                    $html.='<script type="text/javascript"> clear_upravy_ant_syn('.$vids["hid"].','.$vids["id"].')</script>';
                                }
                            }
                        }
                        else
                        {
                            $result = dibi::query("SELECT sortorder, pid, hid, typ_vystupu FROM vyznamy WHERE id=".$vid);
                            $data =  $result->fetchAll();
                            if(!empty($data))
                            {
                                if($data[0]["pid"]>0)
                                {
                                    $query = dibi::query("SELECT typ_vystupu FROM vyznamy WHERE id=".$data[0]["pid"]);
                                    $vystup = $query->fetchSingle();
                                    if($vystup == NEZARAZENO && !empty($output)){
                                        $num = "(nez.)";
                                    } else{
                                        $result2 = dibi::query("SELECT COUNT(*) FROM vyznamy WHERE (pid=0 OR pid is NULL) AND hid=".$data[0]["hid"]." AND sortorder<=".$data[0]["sortorder"].$output);
                                        $result =  dibi::query("SELECT COUNT(*) FROM vyznamy WHERE pid=".$data[0]["pid"]." AND sortorder<=".$data[0]["sortorder"]);
                                        $vyz = $result2->fetchSingle();
                                        $sub = $result->fetchSingle();
                                        $num = $vyz."S".$sub;
                                    }
                                }
                                else
                                {
                                    if($data[0]["typ_vystupu"] == NEZARAZENO && !empty($output)){
                                        $num = "(nez.)";
                                    } else{
                                        $result = dibi::query("SELECT COUNT(*) FROM vyznamy WHERE (pid=0 OR pid is NULL) AND hid=".$data[0]["hid"]." AND sortorder<=".$data[0]["sortorder"].$output);
                                        $num = $result->fetchSingle();
                                    }
                                }
                            }
                            if(array_key_exists($key, $hid))
                            {
                                $linky = uprava_ant_syn_counter($hid[$key], $vid);
                                if(count($linky)>0)
                                {
                                    if (!empty($hid[$key]))
                                    {
                                        $hlv = get_hlavni_varianta_hesla($hid[$key]);
                                        $vyz_var = print_varianta_str($hlv);
                                        $html.='<div id="upravy_ant_syn_bar_'.$vid.'" title="Hesla ke kontrole" class="redBox"><div class="clickable floatLeft"  onClick="upravy_ant_syn('.$hid[$key].','.$vid.','.$print.')"> <img src="css/images/odkaz.png" alt="otevřít"/>&nbsp;<b>'.count($linky).'</b> Hesla, spojená s <b>'.$vyz_var.'</b> '.$num.', ke kontrole &nbsp;</div><span onClick="clear_upravy_ant_syn('.$hid[$key].','.$vid.')" class="clickable"><img src="css/images/close.png" alt="zavřít"/></span></div>';
                                    }
                                    else
                                    {
                                        $html.='<script type="text/javascript"> clear_upravy_ant_syn('.$hid[$key].','.$vid.')</script>';
                                    }
                                }
                                else
                                {
                                    $html.='<script type="text/javascript"> clear_upravy_ant_syn('.$hid[$key].','.$vid.')</script>';
                                }
                            }
                            else
                            {
                                $html.='<script type="text/javascript"> clear_upravy_ant_syn('.$hid[$key].','.$vid.')</script>';
                            }
                        }
                    }
                }
            }
        }
    }
    if($v!=0){
        return $num;
    }
    return $html;
}

function getLinkCount($vyz_id=0,$hid=0){
    $count=0;
    if($vyz_id==0)
    {
        $vyz_id = json_decode($_COOKIE["upraveny_vyznam"]);
        $hid = json_decode($_COOKIE["upraveny_vyznam_hid"]);
        if($vyz_id!=NULL && $hid!=NULL)
        {
            if(!is_array ($vyz_id))
            {
                $linky = uprava_ant_syn_counter($hid, $vyz_id);
                $count=count($linky);
            }
            else
            {
                foreach($vyz_id as $key => $vid)
                {
                    $linky = uprava_ant_syn_counter($hid[$key], $vid);
                    $count = $count+count($linky);
                }
            }
        }
    }
    else if($vyz_id>0)
    {
        $linky = uprava_ant_syn_counter($hid, $vyz_id);
        $count = count($linky);
    }
    return $count;
}

function save_ant_syn_uprav_session($hid, $vid)
{
    if(!isset($_COOKIE['upraveny_vyznam_hid']))
    {
        setcookie('upraveny_vyznam_hid',json_encode(array($hid)), time()+360000);
        setcookie('upraveny_vyznam',json_encode(array($vid)), time()+350000);
    }
    else
    {
        $tempH = json_decode($_COOKIE['upraveny_vyznam_hid']);
        $tempV = json_decode($_COOKIE['upraveny_vyznam']);
        if(!is_array($tempH))
        {
            if($hid!=$tempH && $vid!=$tempV)
            {
                $tempH[]=$hid;
                $tempV[]=$vid;
                setcookie('upraveny_vyznam_hid',json_encode($tempH), time()+360000);
                setcookie('upraveny_vyznam',json_encode($tempV), time()+350000);
            }
        }
        else if(!in_array($hid, $tempH) || !in_array($vid, $tempV))
        {
            $tempH[]=$hid;
            $tempV[]=$vid;
            setcookie('upraveny_vyznam_hid',json_encode($tempH), time()+360000);
            setcookie('upraveny_vyznam',json_encode($tempV), time()+350000);
        }
    }
}

function print_vyznam_str($rid, $Master=true){
    if(!is_numeric($rid)) return false;
    if($Master)$sql = "SELECT vz.pid pid, hrp.place_id plid1, vz.id plid2 FROM (hesla_rel hr JOIN hesla_rel_places hrp ON hr.id=hrp.hesla_rel_id) JOIN vyznamy vz ON hr.main_hid=vz.hid WHERE hr.id=$rid ORDER BY vz.sortorder";
    else $sql = "SELECT vz.pid pid, hrp.place_id plid1, vz.id plid2 FROM (hesla_rel hr JOIN hesla_rel_slave_places hrp ON hr.id=hrp.hesla_rel_id) JOIN vyznamy vz ON hr.slave_hid=vz.hid WHERE hr.id=$rid ORDER BY vz.sortorder";
    $txt="";
    $res = mysql_query($sql);
    if(mysql_num_rows($res)>1)
    {
        $num=0;
        while($rec = mysql_fetch_assoc($res))
        {
            if($rec["pid"]==0)
            {
                $num=$num +1;
                $numsv=0;
                if($rec["plid1"]==$rec["plid2"])$txt=" - ".$num;
            }
            else
            {
                $numsv=$numsv+1;
                if($rec["plid1"]==$rec["plid2"])$txt=" - ".$num;
            }
        }
    }
    return $txt;
}


function get($what, $fk, $orderBy=array(), $parent=''){
    if(!is_array($orderBy)) $orderBy = (array)$orderBy;
    $pid = "";
    switch($what){
        case 'varianty_hesla':         $tbl = 'varianty';                  $fk_name = 'hid';                     break;
        case 'vyznamy_hesla':          $tbl = 'vyznamy';                   $fk_name = 'hid'; $pid='AND pid IS NULL';   break;
        case 'podvyznamy_hesla':       $tbl = 'vyznamy';                   $fk_name = 'hid'; $pid='AND pid='.$parent;   break;
        case 'tvarChary_varianty':     $tbl = 'var_tvar_char_vyber_rel';   $fk_name = 'vid';                     break;
        case 'tvarChary_vyznamu':      $tbl = 'vyz_tvar_char_vyber_rel';   $fk_name = 'vyz_id';                  break;
        case 'tvarChary_podhesli':     $tbl = 'podh_tvar_char_vyber_rel';  $fk_name = 'podh_id';                 break;
        case 'tvarCharySl_varianty':   $tbl = 'var_tvar_char_sl_vyber_rel';$fk_name = 'vid';                     break;
        case 'tvarCharySl_vyznamu':    $tbl = 'vyz_tvar_char_sl_vyber_rel';$fk_name = 'vyz_id';                  break;
        case 'tvarCharySl_podhesli':   $tbl = 'podh_tvar_char_sl_vyber_rel';$fk_name = 'podh_id';                break;
        case 'koncovky_tvarChar':      $tbl = 'koncovky_tvar_char';        $fk_name = 'var_tvar_char_rel_id';    break;
        case 'koncovky_tvarChar_vyz':  $tbl = 'koncovky_tvar_char_vyz';    $fk_name = 'vyz_tvar_char_rel_id';    break;
        case 'koncovky_tvCh_podh':     $tbl = 'podh_vyz_koncovky_tvar_char';$fk_name = 'podh_tvch';              break;
        case 'koncovky_tvarCharSl':    $tbl = 'koncovky_tvar_char_sl';     $fk_name = 'var_tvar_char_sl_rel_id'; break;
        case 'koncovky_tvarCharSl_vyz':$tbl = 'koncovky_tvar_char_sl_vyz'; $fk_name = 'vyz_tvar_char_sl_rel_id'; break;
        case 'koncovky_tvarCharSl_podh':$tbl = 'podh_vyz_koncovky_tvar_char_sl';$fk_name = 'podh_tvch_sl';       break;
        case 'vyslovnosti_varianty':   $tbl = 'vyslovnost_var';            $fk_name = 'vid';                     break;
        case 'slovneDruhy_varianty':   $tbl = 'var_slov_druhy_vyber_rel';  $fk_name = 'vid';                     break;
        case 'slovneDruhy_vyznamu':    $tbl = 'vyz_slov_druhy_vyber_rel';  $fk_name = 'vyz_id';                  break;
        case 'slovneDruhy_podhesli':   $tbl = 'podh_vyz_slov_druhy_vyber_rel';  $fk_name = 'podh_id';            break;
        case 'vazebnosti_varianty':    $tbl = 'vazebnost_var';             $fk_name = 'vid';                     break;
        case 'vazebnosti_vyznamu':     $tbl = 'vazebnost_vyz';             $fk_name = 'vyz_id';                  break;
        case 'vazebnosti_podhesli':    $tbl = 'podhesli_vazebnost';        $fk_name = 'podh_id';                 break;
        case 'exempl_vyznamu':         $tbl = 'exemplifikace';             $fk_name = 'vyz_id';                  break;
        case 'pozn_hesla':             $tbl = 'ext_poznamky_hes';          $fk_name = 'hid';                     break;
        case 'pozn_vyznamu':           $tbl = 'ext_poznamky_vyz';          $fk_name = 'vyz_id';                  break;
        case 'vyrazy_predvykladu':     $tbl = 'vyrazy_predvykladu';        $fk_name = 'vyz_id';                  break;
        case 'vyrazy_predvykladu_m':   $tbl = 'vyrazy_predvykladu_m';      $fk_name = 'vyz_id';                  break;
        case 'podhesli_vyznamu':       $tbl = 'podhesli_vyznamu';          $fk_name = 'vyz_id';                  break;
        case 'podh_vyz_vyslovnost':    $tbl = 'podh_vyz_vyslovnost';       $fk_name = 'podh_id';                 break;
        case 'podh_vyz_slov_druhy':    $tbl = 'podh_vyz_slov_druhy_vyber_rel';       $fk_name = 'podh_id';       break;
        case 'propojene_vyznamy':      $tbl = 'propojeni_vyznamu';         $fk_name = 'vyz_from';                break;
        case 'propojene_vyznamy_master':$tbl = 'propojeni_vyznamu';        $fk_name = 'vyz_m_from';              break;
    }
    if(empty($orderBy)) $orderBy[] = "id";
    if(!is_numeric($fk)) $fk=0;
    if ($GLOBALS['is_archive'] && !in_array($tbl, $GLOBALS['no_prefix'])){
        $tbl = 'archive_'.$tbl;
        try {
            $ids = dibi::fetchPairs('SELECT id FROM %n WHERE %n=%s %sql ORDER BY %sql', $tbl, $fk_name, $fk, $pid, implode(', ', $orderBy));
        } catch (Exception $e) {
            if ($e->getCode() == MYSQL_TABLE_NOT_EXISTS){ //archivní tabulka neexistuje
                $ids = array();
            }else{
                var_dump($e);
                exit();
            }
        }
    }else{
        $sql = "SELECT id FROM $tbl WHERE $fk_name=$fk $pid ORDER BY ".implode(", ", $orderBy);
        $res = mysql_query($sql) or die("Chyba DB! [f: get($what)] <p>".mysql_error()."</p><p>$sql</p>");
        $ids = array();
        while($rec=mysql_fetch_assoc($res)){
            $ids[] = $rec['id'];
        }
    }
    return $ids;
}

function get_hid_hlavni_varianty($hl_var, $multiple = false){
    $hid = get_db_values_where('varianty', 'hid', 'varianta', $hl_var, $multiple);
    return $hid;
}

function get_hid_pro_homonymii_I($lemma){
      $hid = "";
      $query = "SELECT hid FROM heslo h LEFT JOIN varianty v ON h.id=v.hid WHERE LOWER(varianta) = BINARY LOWER('".$lemma."') AND (v.homonymie=1 OR v.homonymie IS NULL or v.homonymie='')";
      $res = mysql_query($query) or die('Query: '.$query.'  failed: ' . mysql_error());
      if(mysql_num_rows($res)>=1) {
          $hid = mysql_result($res, 0, 0);
      }
       
      if(is_array($hid)){
          $hid = $hid[0];
      }
      return $hid;
}

function get_hlavni_varianta_hesla($hid){
    if ($GLOBALS['is_archive']){
        $sql = "SELECT id FROM archive_varianty WHERE hid=$hid AND sortorder=1";
    }else{
        $sql = "SELECT id FROM varianty WHERE hid=$hid AND sortorder=1";
    }
    $res = mysql_query($sql) or die("Chyba DB! [f: get_hlavni_varianta_hesla()] <p>".mysql_error()."</p><p>$sql</p>");
    return (mysql_fetch_array($res) > 0) ? mysql_result($res, 0, "id") : false;
}


function get_hesla_by_jine(&$pids = null){
  global $_CIS_VYBER, $CIS_VYB_PATH_2_HID; //defined in konstanty.php
  $hids = array();
  $filter_vals = parse_data_filter("jine_in_hesla");
  $cis = $filter_vals['cis'];
  $jine_val = $filter_vals['jine_val'];

  //pre kazdy vyber ciselniku var/vyz/hes
  foreach($_CIS_VYBER[$cis] as $vyber_tbl){
   //generate joins
   $joins_arr = array(); $t=1;
   foreach($CIS_VYB_PATH_2_HID[$vyber_tbl] as $tbl){
     if($tbl['tbl']=='heslo') continue; //tabulku heslo uz netreba prijoinovat
     $joins_arr[] = "LEFT JOIN ".$tbl['tbl']." t$t ON t".($t-1).".".$tbl['fk']."=t$t.id";
     $t++;
   };
   $joins = implode(" ", $joins_arr);
   //build SQL
   $column = "hid";
   if($vyber_tbl == "hesla_rel_link_type_vyber"){
    $column = "main_hid";
   }
   if($pids!=null)
   {
      $sql = "SELECT DISTINCT ($column), pid FROM $vyber_tbl t0 $joins WHERE t0.jine='$jine_val' AND cis_id IS NULL";
   }
   else
   {
      $sql = "SELECT DISTINCT ($column) FROM $vyber_tbl t0 $joins WHERE t0.jine='$jine_val' AND cis_id IS NULL";
   }

   $res = mysql_query($sql) or die("DB Error! [get_hesla_by_jine($vyber_tbl)]<p>".mysql_error()."</p><p>".$sql."</p>");
   //get UIDs
   $temp_hids = array();
   if($pids!=null)
   {
     $temp_pids = array();
     while($rec = mysql_fetch_assoc($res))
     {
      if($rec[$column]!=NULL)
      {
        $temp_hids[]=$rec[$column];
        $temp_pids[] = $rec["pid"];
      }
     }
     $pids = array_unique_merge($pids, $temp_pids);
   }
   else
   {
     while($rec = mysql_fetch_assoc($res))
     {
      if(!empty($rec[$column])){
        $temp_hids[]=$rec[$column];
      }
     }
   }
   //merge UIDs
   $hids = array_unique_merge($hids, $temp_hids);
  }
  return $hids;
}

function get_links_for_hid($hid){
    $link_ids = array();
    if(is_numeric($hid) && $hid > 0){
        $query = dibi::query('SELECT DISTINCT [vyklad_vyznamu_link] FROM [vyznamy] WHERE [hid] = %i', $hid);
        $res = $query->fetchAll();
        foreach($res as $id){
            if(is_numeric($id[vyklad_vyznamu_link]) && $id[vyklad_vyznamu_link] > 0){
                $link_ids[] = $id[vyklad_vyznamu_link];
            }
        }
    }
    return $link_ids;
}


function get_hodnoty_ciselniku($cis, $jine = true){
    global $_CIS_TBL, $_CIS_VAL_COL; //defined in konstanty.php
   /*
    switch($cis){
     case ZPRACOVATELE:     $tbl='uzivatel';             $col = 'login'; $jine = false; break;
     case TYP_EXT_POZN:     $tbl='cis_typ_ext_pozn';     $col = 'typ'; $jine = false; break;
     case TYP_HESLA:        $tbl='cis_typ_hesla';        $col = 'typ_hesla'; break;
     case SLOV_DRUHY:       $tbl='cis_slov_druhy';       $col = 'slovny_druh'; break;
     case TVAR_CHAR:        $tbl='cis_tvar_char';        $col = 'tvar_char'; break;
     case TVAR_CHAR_SL:     $tbl='cis_tvar_char_sl';     $col = 'tvar_char_sl'; break;
     case STYL_KVAL:        $tbl='cis_styl_kval';        $col = 'styl_kval'; break;
     case GRAM_INFO:        $tbl='cis_gram_info';        $col = 'gram_info'; break;
     case TEMATICKE_OKRUHY: $tbl='cis_tematicke_okruhy'; $col = 'tematicke_okruhy'; break;
     case PUVOD:            $tbl='cis_puvod';            $col = 'puvod'; break;
     case OBOR_UZITI:       $tbl='cis_obor_uziti';       $col = 'obor_uziti'; break;
     case METAVYKLAD1:      $tbl='cis_metavyklad1';      $col = 'metavyklad1'; break;
    }
    */
   
    $tbl = $_CIS_TBL[$cis];
    $col = $_CIS_VAL_COL[$cis];
    if(in_array($cis, array(ZPRACOVATELE, TYP_EXT_POZN, PROPRII))) $jine = false;
    $sortorder = ($cis==ZPRACOVATELE) ? "login, " : "sortorder, ";
    $wh = ($cis==ZPRACOVATELE) ? "WHERE role=0 " : "";
    $sql = "SELECT id, $col FROM $tbl ".$wh."ORDER BY $sortorder id";
    //var_dump($tbl, $sql);
    $res = mysql_query($sql) or die("Chyba DB! [f:get_hodnoty_ciselniku()]<p>Cis: $cis</p><p>$sql</p><p>".mysql_error()."</p>");
    $hodnoty = array();
    while($rec = mysql_fetch_assoc($res)){
        $hodnoty[$rec['id']] = $rec[$col];
    }
    if($jine) $hodnoty['jine']='jiné';
    return $hodnoty;
}

function get_vybrane_hodnoty_ciselniku($cis, $parent, $pid){
    $cis_fk = 'cis_id';
    $jine = true;
    switch($cis){
        case ZPRACOVATELE:
            $pid_col_name='hid';
            $cis_tbl='uzivatel';
            $cis_col='login';
            $cis_vyber_tbl='zpracovatel';
            $cis_fk = 'uid';
            $jine=false;
            break;
        /*
        case 'typ_ext_pozn':
         $pid_col_name=($parent=='vyz') ? 'vyz_id' : 'hid';
         $cis_tbl='cis_typ_ext_pozn';
         $cis_col='typ';
         $cis_vyber_tbl=($parent=='vyz') ? 'ext_poznamky_vyz' : 'ext_poznamky_var';
         $cis_fk = 'cis_id';
         $jine=false;
         break;
        */
        case TYP_HESLA:
            $pid_col_name='vid';
            $cis_tbl='cis_typ_hesla';
            $cis_col='typ_hesla';
            $cis_vyber_tbl='typ_hesla_var_vyber';
            $cis_fk = 'cis_id';
            break;
        case SLOV_DRUHY:
            switch ($parent) {
                case 'vyz':
                    $pid_col_name = 'vyz_slov_druhy_vyber_rel_id';
                    $cis_vyber_tbl = 'slov_druhy_vyber_vyz';
                    break;
                case 'var':
                    $pid_col_name = 'var_slov_druhy_vyber_rel_id';
                    $cis_vyber_tbl = 'slov_druhy_vyber';
                    break;
                case 'podh':
                    $pid_col_name = 'podh_rel_id';
                    $cis_vyber_tbl = 'podh_vyz_slov_druhy';
                    break;
            }
            $cis_tbl='cis_slov_druhy';
            $cis_col='slovny_druh';
            $cis_fk = 'cis_id';
            break;
        case TVAR_CHAR:
            switch ($parent) {
                case 'vyz':
                    $pid_col_name = 'vyz_tvar_char_vyber_rel_id';
                    $cis_vyber_tbl = 'tvar_char_vyber_vyz';
                    break;
                case 'var':
                    $pid_col_name = 'var_tvar_char_vyber_rel_id';
                    $cis_vyber_tbl = 'tvar_char_vyber';
                    break;
                case 'podh':
                    $pid_col_name = 'podh_tvch_rel_id';
                    $cis_vyber_tbl = 'podh_tvar_char_vyber';
                    break;
            }
            $cis_tbl='cis_tvar_char';
            $cis_col='tvar_char';
            $cis_fk = 'cis_id';
            break;
        case TVAR_CHAR_SL:
            switch ($parent) {
                case 'vyz':
                    $pid_col_name = 'vyz_tvar_char_sl_vyber_rel_id';
                    $cis_vyber_tbl = 'tvar_char_sl_vyber_vyz';
                    break;
                case 'var':
                    $pid_col_name = 'var_tvar_char_sl_vyber_rel_id';
                    $cis_vyber_tbl = 'tvar_char_sl_vyber';
                    break;
                case 'podh':
                    $pid_col_name = 'podh_tvch_sl_rel_id';
                    $cis_vyber_tbl = 'podh_tvar_char_sl_vyber';
                    break;
            }
            $cis_tbl='cis_tvar_char_sl';
            $cis_col='tvar_char_sl';
            $cis_fk = 'cis_id';
            break;
        case STYL_KVAL:
            switch ($parent) {
                case 'vyz':
                    $pid_col_name = 'vyz_id';
                    $cis_vyber_tbl = 'styl_kval_vyz_vyber';
                    break;
                case 'var':
                    $pid_col_name = 'vid';
                    $cis_vyber_tbl = 'styl_kval_var_vyber';
                    break;
                case 'podh':
                    $pid_col_name = 'podh_id';
                    $cis_vyber_tbl = 'styl_kval_podh_vyber';
                    break;
            }
            $cis_tbl='cis_styl_kval';
            $cis_col='styl_kval';
            $cis_fk = 'cis_id';
            break;
        case GRAM_INFO:
            switch ($parent) {
                case 'vyz':
                    $pid_col_name = 'vyz_id';
                    $cis_vyber_tbl = 'gram_info_vyz_vyber';
                    break;
                case 'var':
                    $pid_col_name = 'vid';
                    $cis_vyber_tbl = 'gram_info_var_vyber';
                    break;
                case 'podh':
                    $pid_col_name = 'podh_id';
                    $cis_vyber_tbl = 'podh_vyz_gram_info';
                    break;
            }
            $cis_tbl='cis_gram_info';
            $cis_col='gram_info';
            $cis_fk = 'cis_id';
            break;
        case TEMATICKE_OKRUHY:
            switch ($parent) {
                case 'vyz':
                    $pid_col_name = 'vyz_id';
                    $cis_vyber_tbl = 'tematicke_okruhy_vyz_vyber';
                    break;
                case 'var':
                    $pid_col_name = 'vid';
                    $cis_vyber_tbl = 'tematicke_okruhy_var_vyber';
                    break;
                case 'podh':
                    $pid_col_name = 'podh_id';
                    $cis_vyber_tbl = 'tematicke_okruhy_podh_vyber';
                    break;
            }
            $cis_tbl='cis_tematicke_okruhy';
            $cis_col='tematicke_okruhy';
            $cis_fk = 'cis_id';
            break;
        case PUVOD:
            $pid_col_name='vid';
            $cis_tbl='cis_puvod';
            $cis_col='puvod';
            $cis_vyber_tbl='puvod_var_vyber';
            $cis_fk = 'cis_id';
            break;
        case OBOR_UZITI:
            switch ($parent) {
                case 'vyz':
                    $pid_col_name = 'vyz_id';
                    $cis_vyber_tbl = 'obor_uziti_vyz_vyber';
                    break;
                case 'var':
                    $pid_col_name = 'vid';
                    $cis_vyber_tbl = 'obor_uziti_var_vyber';
                    break;
                case 'podh':
                    $pid_col_name = 'podh_id';
                    $cis_vyber_tbl = 'obor_uziti_podh_vyber';
                    break;
            }
            $cis_tbl='cis_obor_uziti';
            $cis_col='obor_uziti';
            $cis_fk = 'cis_id';
            break;
        case METAVYKLAD1:
            $pid_col_name='vyz_id';
            $cis_tbl='cis_metavyklad1';
            $cis_col='metavyklad1';
            $cis_vyber_tbl='metavyklad1_vyz_vyber';
            $cis_fk = 'cis_id';
            break;
        case METAVYKLAD1_M:
            $pid_col_name='vyz_id';
            $cis_tbl='cis_metavyklad1';
            $cis_col='metavyklad1';
            $cis_vyber_tbl='metavyklad1_vyz_vyber_m';
            $cis_fk = 'cis_id';
            break;
        case TYP_LINKOVANI:
            $pid_col_name='hesla_rel_id';
            $cis_tbl='cis_hesla_rel_link_type';
            $cis_col='link_type';
            $cis_vyber_tbl='hesla_rel_link_type_vyber';
            $cis_fk = 'cis_id';
            //$jine = false;
            break;
        case KONEC_ZAHLAVI:
            $pid_col_name='hid';
            $cis_tbl='cis_konec_zahlavi';
            $cis_col='konec_zahlavi';
            $cis_vyber_tbl='konec_zahlavi_vyber';
            $cis_fk = 'cis_id';
            break;
    }
    if ($GLOBALS['is_archive'] && !in_array($cis_vyber_tbl, $GLOBALS['no_prefix']) && strpos($cis_vyber_tbl, 'cis_') !== 0){
        $cis_vyber_tbl = 'archive_' . $cis_vyber_tbl;
    }
    if(!is_numeric($pid) || $pid < 1)
    {
        $sql = " SELECT $cis_vyber_tbl.$cis_fk, $cis_tbl.$cis_col as cisCol ".(($jine) ? ", $cis_vyber_tbl.jine" : "")."
             FROM $cis_vyber_tbl LEFT JOIN $cis_tbl ON $cis_tbl.id=$cis_vyber_tbl.$cis_fk
             WHERE $pid_col_name IS NULL
             ORDER BY ".$cis_vyber_tbl.".sortorder";
        $pid = NULL;
    }
    else
    {
        $sql = " SELECT $cis_vyber_tbl.$cis_fk, $cis_tbl.$cis_col as cisCol ".(($jine) ? ", $cis_vyber_tbl.jine" : "")."
             FROM $cis_vyber_tbl LEFT JOIN $cis_tbl ON $cis_tbl.id=$cis_vyber_tbl.$cis_fk
             WHERE $pid_col_name=$pid
             ORDER BY ".$cis_vyber_tbl.".sortorder";
    }

    if ($GLOBALS['is_archive']){
        if (!dibi::fetchSingle('SHOW TABLES LIKE %s', $cis_vyber_tbl)){
            return array();
        }
    }
    $res = mysql_query($sql) or die("Chyba DB! [f:get_vybrane_hodnoty_ciselniku()] <p>$sql</p><p>".mysql_error()."</p>");
    $vybrane = array();

    while($rec = mysql_fetch_assoc($res))
    {
        if($rec[$cis_fk]==0)
        {
            if(!empty($rec['jine'])) $vybrane['jine'] = ($rec['jine']);
            else $vybrane['jine'] = "";
        }
        else
        {
            $vybrane[$rec[$cis_fk]] = ($rec['cisCol']);
        }
    }
    return $vybrane;
}

function cis_ids_attach_values($cis_vyberu, $vyber){
    global $_CIS_TBL, $_CIS_VAL_COL; //defined in konstanty.php
    /*
    switch($cis_vyberu){
      case TYP_HESLA:       $tbl = 'cis_typ_hesla';       $col = 'typ_hesla'; break;
      case STYL_KVAL:       $tbl = 'cis_styl_kval';       $col = 'styl_kval'; break;
      case GRAM_INFO:       $tbl = 'cis_gram_info';       $col = 'gram_info'; break;
      case TEMATICKE_OKRUHY:$tbl = 'cis_tematicke_okruhy';$col = 'tematicke_okruhy'; break;
      case PUVOD:           $tbl = 'cis_puvod';           $col = 'puvod'; break;
      case OBOR_UZITI:      $tbl = 'cis_obor_uziti';      $col = 'obor_uziti'; break;
      case SLOV_DRUHY:      $tbl = 'cis_slov_druhy';      $col = 'slovny_druh'; break;
      case TVAR_CHAR:       $tbl = 'cis_tvar_char';       $col = 'tvar_char'; break;
      case TVAR_CHAR_SL:    $tbl = 'cis_tvar_char_sl';    $col = 'tvar_char_sl'; break;
      case METAVYKLAD1:     $tbl = 'cis_metavyklad1';     $col = 'metavyklad1'; break;
    }*/

    $cisVals = array();
    foreach($vyber as $i => $id){
        if(!is_numeric($i)){
            if(!empty($vyber['jine'])) $cisVals['jine'] = $vyber['jine'];
        }else{
            //$cisVals[$id] = get_db_values($tbl,$col,$id);
            $cisVals[$id] = get_db_values($_CIS_TBL[$cis_vyberu],$_CIS_VAL_COL[$cis_vyberu],$id);
        }
    }
    return $cisVals;
}

function uzavri_visici_korektury($hid, $debug = true){
    $kids1 = Redakce::get_nove_korekce_hesla($hid);
    $kids2 = Redakce::get_zamitnute_korekce_hesla($hid);
    $kids = array_unique_merge($kids1, $kids2);
    foreach($kids as $kid){
      $val = "";
      $query = "SELECT field, field_val_id, field_DOMid, val_orig, val_new, note FROM korektura WHERE id = '$kid'";
      $note = "";
      $vid = get_hlavni_varianta_hesla($hid);
      $D = get_db_values('varianty', array('varianta'), $vid);
      if(!empty($D)){
        $hid_ok = true;
        $varianta = $D["varianta"];
      }
      else{
        $varianta = '-';
        $hid_ok = false;
        $note = 'Smazané heslo ';
      }
      $result = dbq($query);
      $R = new Redakce($kid);
      //nezarazuj korektury ze stareho systemu antonym/synonym
      if(($R->field=="vyznam-synonymum-synonymum") ||
         ($R->field=="vyznam-antonymum-antonymum") ||
         ($R->field=="odkaz-synonymum") ||
         ($R->field=="odkaz-antonymum")){
        $note = "Ant/Syn ze starého systému";
      }
    else{
        $table = $field = $val = '';
        if(empty($R->cis)){
          $val = get_db_values($R->tbl, $R->db_field, $R->val_id);
        }
        else{

          $val = get_vybrane_hodnoty_ciselniku($R->cis, $R->var_vyz, $R->val_id);
        }
        if($val=="" || (!empty($R->cis) && empty($val))){
           if($hid_ok && $R->field=="heslo-lexikograficka_poznamka"){
               continue;
           }

           $val = '[empty]';
           $note .= 'Smazané pole';
        }
      }
      while($row = mysql_fetch_array($result)){
        if(!empty($note)){
          $cnt++;
          if($debug){
            $stav = "nová";
            if(in_array($kid, $kids2)){
                $stav = "zamítnutá";
            }
            echo "\r\n<div class='deadCorrectionsBox orangeBox'>";
            echo "\r\n<h2>$cnt) Heslo: $hid ($varianta)</h2>\r\n";
            echo "\r\n<div class='buttBox blueButtBox floatRight'><a href='./visici_korektury.php?close=$kid'>Uzavřít</a></div>";
            if($hid_ok){
              echo "\r\n<div class='buttBox blueButtBox floatRight'><a href=\"./".LEMMA_FORM_ROUTER.".php?hid=$hid\">Detail hesla</a></div>";
            }


            $name = $R->name;
            if(empty($name)){
              $name = $row['field'];
            }
            echo "\r\n<ul>\r\n<li>ID korektury: $kid</li>\r\n<li>Typ: $name</li>\r\n<li>Původní hodnota: $row[val_orig]</li>\r\n<li>Nová hodnota: $row[val_new] $new_val</li>\r\n<li>Poznámka od redaktora: $row[note]</li>\r\n<li>$note</li><li>$stav</li>\r\n</ul>";
            echo $R->print_korektury_hist($row['field_DOMid']);
            echo "</div>";
          } else{
              $R = new Redakce($kid);
              if(in_array($kid, $kids1)){
                $R->set_status(REJECTED_BY_EDITOR, $kid, text_db_preprocess('Korektura byla zamítnuta jako visící'));
              }
              $R->set_status(CLOSED_BY_CORRECTOR, $kid, text_db_preprocess('Korektura byla uzavrena jako visící'));
     
          }
          echo $kid."<br />"; 
        }
      }
    }
}

function smaz_nevyrizenou_korekturu($field_id){
    if(Redakce::field_has_opened_correction($field_id)){
        $sql = "DELETE FROM korektura WHERE field_DOMid='$field_id';";
        $res = mysql_query($sql) or die("Chyba DB! [f: smaz_nevyrizenou_korekturu()] <p>".mysql_error()."</p><p>$sql</p>");
    }
}

function smaz_heslo($hid){
    require_once('archive_fx.php');
    $aid = archive_default($hid, $is_user=False, $comment='Smazání hesla');
    dibi::query('UPDATE archive_heslo SET f_deleted=1 WHERE id=%i', $aid);
    if(!is_numeric($hid) || $hid<1) return false;
    $x = get('varianty_hesla', $hid); foreach($x as $xid) smaz_variantu($xid);
    $x = get('vyznamy_hesla', $hid); foreach($x as $xid) smaz_vyznam($xid);
    $DOMid = "heslo-$hid--do_vystupu";
    smaz_nevyrizenou_korekturu($DOMid);
    $DOMid = "heslo-$hid--stav";
    smaz_nevyrizenou_korekturu($DOMid);
    $DOMid = "heslo-$hid--lexikograficka_poznamka";
    smaz_nevyrizenou_korekturu($DOMid);
    $x = get('pozn_hesla', $hid);
    foreach($x as $xid){
        smaz_poznamku('hes', $xid, $hid);
    }
    $x = get_id_zpracovatele($hid); foreach($x as $xid) smaz_zpracovatele($xid);
    $sql = "DELETE FROM heslo WHERE id=$hid";
    $res = mysql_query($sql) or die("Chyba DB! [f: smaz_vyznamy()] <p>".mysql_error()."</p><p>$sql</p>");
    osetri_prepojenia_pri_mazani("heslo", $hid);
}

function set_stav_hesla($hid, $stav){
    if(!is_numeric($hid) || !is_numeric($stav) || $hid < 0 || $stav < 0) return false;
    $sqlData['stav'] = $stav;
    sql_w('heslo', $sqlData, $hid);
}

function set_data_filter($dataID, $data_filter_name, $value){
    unset_data_filter();
    set_first_page();
    $_SESSION['data_filter']['_dataID'] = $dataID;
    $_SESSION['data_filter']['_filterName'] = $data_filter_name;
    $_SESSION['data_filter']['_filterValue'] = $value;
    switch($dataID){
        case 'hesla':
            if($data_filter_name=='datum'){ //datum zmeny
                $datum_filter = array();
                if(!empty($value[0])) $datum_filter[] = "h.uts >= '".$value[0]."'";
                if(!empty($value[1])) $datum_filter[] = "h.uts <= '".$value[1]."' + INTERVAL 1 DAY";
                $datum_filter_str = implode(" AND ", $datum_filter);
            }
            if($data_filter_name=='datum_vytvoreni'){ //datum vytvoreni
                $datum_filter = array();
                if(!empty($value[0])) $datum_filter[] = "h.cts >= '".$value[0]."'";
                if(!empty($value[1])) $datum_filter[] = "h.cts <= '".$value[1]."' + INTERVAL 1 DAY";
                $datum_filter_str = implode(" AND ", $datum_filter);
            }

            if($data_filter_name=='oznacene' && empty($value)) $value=array(0);

            $filters = array(
                "moje"=>"u.uid=$value",
                "oznacene"=>"h.id IN (".implode(", ", (array)$value).")",
                "datum"=> $datum_filter_str,
                "datum_vytvoreni"=> $datum_filter_str ,
                "seznam" => "h.id IN (SELECT hid FROM hesla_v_seznamu WHERE sid=".$value.")"
            );
            break;
        case 'jine_in_hesla':
            $filters = array("fiter_vals_arr"=>$value);
            break;
    }
    $_SESSION['data_filter'][$dataID] = $filters[$data_filter_name];
}

function unset_data_filter($dataID=0){
    if(isset($_SESSION['data_filter']['_filterName'])) unset($_SESSION['data_filter']['_filterName']);
    if(isset($_SESSION['data_filter']['_dataID'])) unset($_SESSION['data_filter']['_dataID']);
    if($dataID==0)
        unset($_SESSION['data_filter']);
    else
        if(isset($_SESSION['data_filter'][$dataID])) unset($_SESSION['data_filter'][$dataID]);
}

function parse_data_filter($dataID){
    if(!isset($_SESSION['data_filter'][$dataID]) || empty($_SESSION['data_filter'][$dataID]))
        return false;

    $filter = $_SESSION['data_filter'][$dataID];

    return $filter;
}

function order_list_by($orderBy='', $asc_desc='ASC'){
    $default_ord = array();
    $default_ord = array(
        'heslo' => array('ordBy' => 'v.varianta', 'asc_desc' => 'ASC'),
        'hom'   => array('ordBy' => 'v.homonymie', 'asc_desc' => 'ASC'),
        'uts'   => array('ordBy' => 'h.uts'  , 'asc_desc' => 'DESC')
    );
    if(!isset($_SESSION['razeni_hesel']) || empty($orderBy))
        $_SESSION['razeni_hesel'] = $default_ord;
    else{
        $v = $_SESSION['razeni_hesel'][$orderBy];
        $v['asc_desc'] = $asc_desc;
        unset($_SESSION['razeni_hesel'][$orderBy]);
        $_SESSION['razeni_hesel']=array_merge(array($orderBy => $v), $_SESSION['razeni_hesel']);
        //var_dump($_SESSION['razeni_hesel']);
    }
}

function parse_ordering_array($ord_arr)
{
    $ord_str = "";
    foreach($ord_arr as $dbCol => $ordering)
    {
        //$ord_str.=", REPLACE(REPLACE(REPLACE(REPLACE(".$ordering['ordBy'].", '(', ''), ')', ''), '[', ''), ']', '')".$ordering['asc_desc']; //ignorov�n� z�vorek
        //$ord_str.= ", IF(LOCATE('(', ".$ordering['ordBy'].")=1, RIGHT(".$ordering['ordBy'].", LENGTH(".$ordering['ordBy'].")- 1 - LOCATE(')', ".$ordering['ordBy'].")),IF(LOCATE('[', ".$ordering['ordBy'].")=1,RIGHT(".$ordering['ordBy'].", LENGTH(".$ordering['ordBy'].")- 1 - LOCATE(']', ".$ordering['ordBy'].")) ,".$ordering['ordBy']."))".$ordering['asc_desc']; //p�eskakov�n� z�vorek i s obsahem
        $ordering['ordBy']=substr($ordering['ordBy'],strpos($ordering['ordBy'], '.')+1);
        if($ordering['ordBy']=='varianta')
        {
            $ord_str .= ", varianta ".$ordering['asc_desc'].", varianta COLLATE utf8_czech_w2 ".$ordering['asc_desc'];
        }
        else
        {
            $ord_str .= ",".implode(" ", $ordering); // ordering is array where first is na item to order by, and the second item is a sorting type ASC/DESC
        }
    }
    $ord_str[0] = " ";
    return $ord_str;
}

function parse_ordering_array_col($ord_arr)
{
    $ord_str = "";
    foreach($ord_arr as $dbCol => $ordering)
    {
        //$ord_str.=", REPLACE(REPLACE(REPLACE(REPLACE(".$ordering['ordBy'].", '(', ''), ')', ''), '[', ''), ']', '')".$ordering['asc_desc']; //ignorování závorek
        //$ord_str.= ", IF(LOCATE('(', ".$ordering['ordBy'].")=1, RIGHT(".$ordering['ordBy'].", LENGTH(".$ordering['ordBy'].")- 1 - LOCATE(')', ".$ordering['ordBy'].")),IF(LOCATE('[', ".$ordering['ordBy'].")=1,RIGHT(".$ordering['ordBy'].", LENGTH(".$ordering['ordBy'].")- 1 - LOCATE(']', ".$ordering['ordBy'].")) ,".$ordering['ordBy']."))".$ordering['asc_desc']; //přeskakování závorek i s obsahem
        //if($ordering['ordBy']=='v.varianta')$ordering['ordBy']= 'v.varianta';
        $ord_str .= ",".$ordering['ordBy']; // ordering is array where first is na item to order by, and the second item is a sorting type ASC/DESC
    }
    $ord_str[0] = " ";
    return $ord_str;
}


function is_external_user($uid){
    $d = get_db_values('uzivatel', array('role'), $uid);
    if($d){
        return ($d['role']==ODBORNIK || $d['role']==NAHLIZENI);
    }else{
        return false;
    }
}

//////   B L O K O V A N I E   H E S L A   ///////

function block_heslo($hid){

    if(!is_numeric($hid) || $hid < 1 /*|| strpos($_SERVER['REQUEST_URI'], "formular_hesla.php") === false*/) return false;
    if(get_heslo_block_stat($hid)===false){
        remove_heslo_block($hid);
        //externiste nemaji blokovat heslo
        //http://www.foxcom.cz/support/ts/view.php?id=630
        if(is_external_user(get_logged_user())){
            return;
        }
        $d = array();
        $d['hid'] = $hid;
        $d['uts'] = "NOW()";
        $d['uid'] = get_logged_user();
        $d['ip'] = "'".$_SERVER['REMOTE_ADDR']."'";

        sql_w('hesla_online', $d);
    }
}

function is_me_blocking_heslo($hid){
    if(!is_numeric($hid) || $hid < 1) return false;
    $sql = "SELECT count(*) as cnt FROM hesla_online WHERE hid=$hid AND uid=".get_logged_user();
    $res = dbq($sql);
    return mysql_result($res, 0, "cnt") + 0 > 0;
}

function get_heslo_block_stat($hid){
    if(!is_numeric($hid) || $hid < 1) return false;
    //externiste nemaji blokovat heslo
    //http://www.foxcom.cz/support/ts/view.php?id=630
    if(is_external_user(get_logged_user())){
        return false;
    }
    $sql = "SELECT * FROM hesla_online WHERE hid=$hid AND DATE_SUB(NOW(),INTERVAL 1 MINUTE) <= uts";
    $res = dbq($sql);
    if(mysql_num_rows($res) < 1) return false; //ak heslo nie je blokovane vrat false
    else{
        //ak je heslo blokovane vrat informacie o blokovani
        return array(
            "uid"=>mysql_result($res, 0, 'uid'),
            "cts"=>mysql_result($res, 0, 'cts'),
            "ip"=>mysql_result($res, 0, 'ip')
        );
    }
}

function remove_heslo_block($hid){
    if(!is_numeric($hid) || $hid < 1) return false;
    $sql = "DELETE FROM hesla_online WHERE hid=$hid";
    dbq($sql); //pri refreshi mazat
    return $hid;
}

function update_heslo_block_uts($hid){
    if(!is_numeric($hid) || $hid < 1) return false;
    $sql = "UPDATE hesla_online SET uts = NOW() WHERE hid=$hid";
    dbq($sql);
    return $hid;
}

function update_heslo_uts($hid){
    if(!is_numeric($hid) || $hid < 1) return false;
    $sql = "UPDATE heslo SET uts = NOW() WHERE id=$hid";
    dbq($sql);
    return $hid;
}

function printJS_sending_ImHere_msg($hid){
    $js="
      <script type='text/javascript'>
        var hidOnlineUpdInterval;
        $(function(){
          hidOnlineUpdInterval = setInterval(function(){update_heslo_block_uts($hid)},30000);
        })
      </script>
    ";
    return $js;
}


function test_timeout(){
    $status =   connection_status();
    //echo "Script ended with connection status $status";
    if($status == CONNECTION_TIMEOUT){
        echo "<p>Došlo k překročení maximální doby povolené pro běh skriptu.</p>";
    }
}

/*
  Trims Unicode whitespaces
  see discussion at
  http://stackoverflow.com/questions/4166896/trim-unicode-whitespace-in-php-5-2
*/
function utf8_trim($inputStr){
  $outputStr = preg_replace('/^[\pZ\pC]+|[\pZ\pC]+$/u','',$inputStr);
  return $outputStr;
}

/*
  Removes redundand whitespaces from given string
  - all whitespaces from beginning and end of argument
  - converts sequence of spaces into single space
*/
function my_trim($inputStr){
    $outputStr = trim($inputStr);
    //converts &nbsp; and new lines entity into normal space
    $outputStr = str_replace(array( "&nbsp;", '\r', '\n', '\r\n'), " ", $outputStr);
    //replaces multiple white spaces (\s+) with single space
    //$outputStr = preg_replace('!\s+!', ' ', $outputStr);
    //$outputStr = preg_replace("/[[:blank:]]+/"," ",$outputStr);
    return $outputStr;
}

/*
  Fixes the most common problems with typography:
  - converts " ," to ","
  - converts " ." to "."
  - converts " ;" to ";"
  - converts " :" to ":"
  - converts " “" to "“"
  - converts "„ " to "„"
  - converts three dots into &hellip; HTML entity
*/
function fix_typography($inputStr){
    $outputStr = my_trim($inputStr);
    //removes typographically incorrect spaces
    $badSpaces = array(" :", " ,", " .", " ;", "„ ", " “", "...");
    $goodSpaces = array(":", ",", ".", ";", "„", "“", "&hellip;");
    $outputStr = str_replace($badSpaces, $goodSpaces, $outputStr);
    //spojovnik
    $outputStr = str_replace(" - ", " &#8211; ", $outputStr);
    //jednopismenne predlozky/spojky
    $badSpaces = array(" a ", " i ", " o ", " u ", " k ", " s ", " v ", " z ");
    $goodSpaces = array(" a&nbsp;", " i&nbsp;", " o&nbsp;", " u&nbsp;", " k&nbsp;", " s&nbsp;", " v&nbsp;", " z&nbsp;");
    $outputStr = str_replace($badSpaces, $goodSpaces, $outputStr);
    //cisla a data
    // http://stackoverflow.com/questions/11072161/php-regular-expression-for-replacing-space-between-digits-with-hard-breaking-sp
    $pattern = '/(?<=\d)(\.?)\s(?=\d[^>]*(<|$))/';
    $outputStr = preg_replace($pattern, '$1&nbsp;', $outputStr);
    return $outputStr;
}

function strip_duplicate_tags($html){
    $html = trim($html);
    if(empty($html))
        return '';
    $dom = new DOMDocument;
    $dom->preserveWhiteSpace = false;
    $dom->formatOutput = false;
    $dom->encoding = 'utf8';
    $dom->loadHTML($html);

    $xp = new DOMXPath($dom);

    //remove empty textnodes - if necessary at all
    // (in case remove WS: [normalize-space()=""])
    foreach($xp->query('//text()[""]') as $i => $tn){
        $tn->parentNode->removeChild($tn);
    }

    // all child elements with same name as parent element and being
    // the only child element.
    $r = $xp->query('body//*/child::*[name(.)=name(..) and count(../child::*)=1]');
    foreach($r as $i => $dupe){
        while($dupe->childNodes->length){
            $child = $dupe->firstChild;
            $dupe->removeChild($child);
            //echo "[$dupe->nodeValue]";
            $dupe->parentNode->appendChild($child);
        }
        $dupe->parentNode->removeChild($dupe);
    }
    return $dom->saveHTML();
    //return  iconv("windows-1250", "UTF-8//TRANSLIT", $dom->saveHTML());
    //return iconv('UTF-8', 'WINDOWS-1250//TRANSLIT', $dom->saveHTML());
}

function get_user_list(){
    $sql = '
    SELECT id, CONCAT(jmeno, " ", prijmeni) AS name, login
    FROM uzivatel
    WHERE active=1  AND role NOT IN ('. get_role_uzivatel(',') . ')';
    $res = dbq($sql);
    $return = array();
    while($rec = mysql_fetch_assoc($res)){
        $return[] = $rec;
    }
    return $return;
}

function get_list_for_ext_user($uid, $login=False, $insert=True){
    if (!$uid){
        return 0;
    }
    $res = dbq('SELECT id FROM seznam_hesel WHERE vlastnik='.$uid);
    if (mysql_num_rows($res)){ //existuje seznam
        $val = mysql_fetch_row($res);
        $sid = $val[0];
    }else{
        if (!$insert){
            return 0;
        }
        if (!$login){
            $login = get_db_values('uzivatel', 'login', $uid);
        }
        $sid = sql_w('seznam_hesel', array('nazev' => '"Hesla uživatele '.$login.'"', 'nazev_bd' => '"'.bd('"Hesla uživatele '.$login.'"').'"', 'vlastnik' => $uid));
        sql_w('seznam_hesel_uziv', array('uid' => $uid, 'sid' => $sid));
    }
    return $sid;
}

function check_seznam_owner($sid){
    $sid = mysql_real_escape_string($sid);
    $res = dbq('SELECT 1 FROM seznam_hesel WHERE id='.$sid.' AND vlastnik='.get_logged_user());
    return mysql_num_rows($res);
}

function get_vyznam_podhesli($podh_id){
    return db_fetchSingle('SELECT vyz_id FROM podhesli_vyznamu WHERE id='.$podh_id);
}

function is_seznam_filter(){
    if (isset($_SESSION['data_filter']['_filterName']) && $_SESSION['data_filter']['_filterName'] == 'seznam'){
        return $_SESSION['data_filter']['_filterValue'];
    }else{
        return 0;
    }
}

function get_vyznam_num($vyz_id){
    /*
     dalo by sa optimalizovat tym ze by sa skontrolovalo, ci sortorder sa vzdy zapise od 1 a moze sa tym povazovat za vyz_num
    */
    $hid = get_db_values('vyznamy','hid', $vyz_id);
    if(is_null($hid) || empty($hid))
        return false;
    $vyz_num = 0;
    $sql="SELECT id FROM vyznamy WHERE hid=$hid AND pid IS NULL ORDER BY sortorder;";
    $vyz_ids = db_get_val_arr($sql);
    foreach($vyz_ids as $_vyz_id){
        $vyz_num++;
        if($_vyz_id == $vyz_id) return $vyz_num;
    }
    return false;
}

function print_vyznam_links_to($vyz_id, $skupinka = false){
    $col = "vyz_from";
    $target_hids = array();
    if($skupinka && $skupinka != 'NULL'){
        $col = "vyz_m_from";
        $vyz_id = $skupinka;
    }
    $sql = dibi::query("SELECT * FROM [propojeni_vyznamu] WHERE [$col] = %i", $vyz_id);
    $res = $sql->fetchAll();
    $html = "";
    foreach($res as $row){
        $vyz_to = $row['vyz_to'];
        $vyz_num = get_vyznam_num($vyz_to);
        $sql2 = dibi::query('SELECT vyz.hid, vyz.vyklad_vyznamu_link, varianta FROM vyznamy vyz INNER JOIN varianty vr ON vyz.hid=vr.hid AND vr.sortorder=1 WHERE vyz.id=%i', $vyz_to);
        $res2 = $sql2->fetchAll();
        foreach($res2 as $heslo){
            if(!empty($html)){
                $html.=", ";
            }
            if($heslo['vyklad_vyznamu_link'] > 0){
                $sql3 = dibi::query('SELECT vyz.hid, varianta FROM vyznamy vyz INNER JOIN varianty vr ON vyz.hid=vr.hid AND vr.sortorder=1 WHERE vyz.vyklad_vyznamu_link=%i', $heslo['vyklad_vyznamu_link']);
                $res3 = $sql3->fetchAll();
                $sk = array();
                $html.="skupina <span class='nobold'>(";
                foreach($res3 as $h){
                    if(!in_array($h['hid'], $target_hids)){
                        $target_hids[] = $h['hid'];
                        $sk[] = "\r\n<a href='".LEMMA_FORM_ROUTER.".php?hid=".$h['hid']."#vyznam-".$vyz_to."' target='_blank'>".$h['varianta']." ".$vyz_num."</a>";
                    }
                }
                $html.=implode(", ", $sk).")</span>";
            }
            else{
                if(!in_array($heslo['hid'], $target_hids)){
                    $target_hids[] = $heslo['hid'];
                }
                $html.="\r\n<a href='".LEMMA_FORM_ROUTER.".php?hid=".$heslo['hid']."#vyznam-".$vyz_to."' target='_blank'>".$heslo['varianta']." ".$vyz_num."</a>";
            }
        }
    }
    if(!empty($html)){
        $html ='<div class="varovani">Významy, na něž je odkázáno v tomto významu: <p>'.$html.' <a target="_blank" href="heslar.php?force_entries='.implode(',', $target_hids).'" class="showall">Zobrazit vše</a></p></div>';
    }
    return $html;
}

function print_vyznam_links($arr){
    $links = array();
    $ltmp = array();
    $return = '';
    foreach ($arr as $l) {
        if (!isset($l['hid'])){ //skupina
            $tmp = array();
            foreach ($l as $grp) {
                $links[] = $grp['hid'];
                $tmp[] = '<a target="_blank" href="'.LEMMA_FORM_ROUTER.'.php?hid='.$grp['hid'].'">'.$grp['varianta'].' '.get_vyznam_num($grp['vyz_id']).'</a>';
            }
            $ltmp[] = 'skupina <span class="nobold">(' . implode(', ', $tmp) . ')</span>';
            unset($tmp);
        }else{
            $links[] = $l['hid'];
            $ltmp[] = '<a target="_blank" href="'.LEMMA_FORM_ROUTER.'.php?hid='.$l['hid'].'">'.$l['varianta'].' '.get_vyznam_num($l['vyz_id']).'</a>';
        }
    }
    $return = implode(', ', $ltmp);
    $return .= '. <a target="_blank" href="heslar.php?force_entries='.implode(',', $links).'" class="showall">Zobrazit vše</a>';
    return $return;
}

function get_vyznam_links($vyz){
    $return = array();
    $links = dibi::fetchAll('
    SELECT vyz_from, vyz_m_from, v.hid, vr.varianta, v.id AS vyz_id
    FROM `propojeni_vyznamu` pv
      LEFT JOIN (`vyznamy` v INNER JOIN varianty vr ON v.hid=vr.hid AND vr.sortorder=1)
      ON pv.vyz_from=v.id
    WHERE `vyz_to`=%i
  ', $vyz);
    foreach ($links as $l){
        if ($l['vyz_m_from']){
            $hids = dibi::fetchAll('SELECT vz.hid, varianta, vz.id AS vyz_id FROM vyznamy vz INNER JOIN varianty vr ON vz.hid=vr.hid AND vr.sortorder=1 WHERE vyklad_vyznamu_link=%i', $l['vyz_m_from']);
            $return[] = $hids;
        }else{
            $return[] = array('varianta' => $l['varianta'], 'hid' => $l['hid'], 'vyz_id' => $l['vyz_id']);
        }
    }
    return $return;
}

function check_vyznam_link($vyz){
    $return = array();
    if (is_numeric($vyz) && $vyz){
        $return = db_get_val_arr('SELECT hid FROM propojeni_vyznamu INNER JOIN vyznamy v ON v.id=vyz_from WHERE vyz_to='.$vyz);
        if (!$return){ //je něco připojeno ve skupině?
            $return = db_get_val_arr('SELECT hid FROM vyznamy v INNER JOIN propojeni_vyznamu ON vyklad_vyznamu_link=vyz_m_from WHERE vyz_to='.$vyz.' LIMIT 1');
        }
    }
    return $return;
}

function check_vyznam_link_from($vyz){
    $return = array();
    if (is_numeric($vyz) && $vyz){
        $return = db_get_val_arr('SELECT hid FROM propojeni_vyznamu INNER JOIN vyznamy v ON v.id=vyz_to WHERE vyz_from='.$vyz);
        if (!$return){ //je něco připojeno ve skupině?
            $return = db_get_val_arr('SELECT hid FROM vyznamy v INNER JOIN propojeni_vyznamu ON vyklad_vyznamu_link=vyz_m_from WHERE vyz_to='.$vyz.' LIMIT 1');
        }
    }
    return $return;
}

function is_sublemma($vid){
  $var_podh = get_db_values("varianty", "f_varianta", $vid);
  if($var_podh == 0){
    return true;
  }
  return false;
}

function get_disabled_cls($hid){
    $vystup = get_db_values("heslo", "vystup", $hid);
    if($vystup == NEZARAZENO){
        return "disabled";
    }
    return '';
}

function get_deployment(){
    $dir = __DIR__;
    $srv = LOCAL;
    if(strpos($dir, 'alexis.fox1.cz')!==false){
        $srv = PRODUCTION;
    } else if(strpos($dir, 'alexis-vyvoj.fox1.cz')!==false){
        $srv = DEVELOPMENT;
    }
    return $srv;
    /*if(defined('SERVER')){
        return SERVER;
    }
    $srv = $_SERVER['SERVER_NAME'];
    if(strpos($srv, '-vyvoj')){
      return DEVELOPMENT;
    }
    if(strpos($srv, 'alexis')){
      return PRODUCTION;
    }
    return LOCAL;*/
}

function buildDOMid($vars, $multiInput=False){
    $len = count($vars);
    $dom = $vars[0];
    $inp = $vars[0];
    for ($i=1; $i < $len; $i++) {
        $inp .= '['.$vars[$i].']';
        if ($i % 2){
            $dom .= '-'.$vars[$i];
        }else{
            $dom .= '--'.$vars[$i];
        }
    }
    $inp .= $multiInput ? '[]' : '';
    return array('dom' => $dom, 'input_name' => $inp);
}

function form_ciselniku_TPL($HTMLdata){
    return '
  <div class="form_vyber_z_ciselniku">
  <table>
    <tr>
     <td rowspan="2">'.$HTMLdata['sb_ciselnik'].'</td>
     <td style="vertical-align: bottom">'.$HTMLdata['arr_toVyber'].'</td>
     <td rowspan="2">'.$HTMLdata['sb_cisVyber'].'</td>
     <td>'.$HTMLdata['arr_up'].'</td>
    </tr>
    <tr>
     <td>'.$HTMLdata['arr_toCis'].'</td>
     <td style="vertical-align: bottom">'.$HTMLdata['arr_down'].'</td>
    </tr>
    <tr>
     <td>'.$HTMLdata['butt_submit'].'</td>
     <td>&nbsp;</td>
     <td>'.$HTMLdata['field_extraOpt'].'</td>
     <td>&nbsp;</td>
    </tr>
  </table>
  </div>
 ';
}

function print_new_corrections_box($hid, $master = true){
    $corrections = Redakce::get_nove_korekce_hesla($hid);
    $group_corrections = Redakce::get_nove_korekce_skupinky($hid);
    foreach($group_corrections as $correction){
        if(!in_array($correction, $corrections)){
            $corrections[] = $correction;
        }
    }
    $vyznamy = get('vyznamy_hesla', $hid, array('sortorder'));
    if(!$master && empty($corrections)) return "";
    $opened = false;
    $count = 0;
    $html = "";
    $uid = get_logged_user();
    $link_ids = get_links_for_hid($hid);

    foreach($corrections as $kor_id){
        $label = '';

        $kor_data = get_db_values('korektura', array('field', 'field_DOMid', 'field_val_id', 'corrector', 'val_new'), $kor_id);
        $latest_id = Redakce::get_last_correction_id($kor_data['field_DOMid']);
        $is_corrected = $latest_id>0 && Redakce::is_new_correction($latest_id);
        if(!$is_corrected)
            continue;
        if(in_array($kor_id, $group_corrections)){

            if((substr($kor_data['field'], -strlen("_master"))!="_master") && ($kor_data['field']!='vyznam-link')){
                continue;
            }
            if($kor_data[field]=='vyznam-link'){
                $test = explode("^", $kor_data['val_new']);
                if($test[3]!='1'){
                    continue;
                }
            }
            else if(!in_array($kor_data['field_val_id'],  $link_ids)){
                if($kor_data['field']=="vyznam-vyraz_predvykladu_master" ||
                    $kor_data['field']=="vyznam-komentar_predvykladu_master"){
                    if(!Redakce::over_korekce_predvykladu($kor_data['field'],
                        $kor_data['field_DOMid'],
                        $link_ids,
                        $kor_data['field_val_id'])){
                        continue;
                    }
                }
                else{
                    continue;
                }
            }
        }

        if(!$opened){
            if($master){
                $html.= "\r\n<div class='orangeBox newCorrectionsBox'>\r\n";
                $html.="<span class=\"newCorrectionBoxTitle\">Seznam aktivních korektur</span>\r\n";
            }
            $html.= "\t<ul>\r\n";
            $opened = true;
        }


        $R = new Redakce($kor_id);
        //zacileni korektury
        /*
        $korektori = $R->get_korektori($kor_id, $hid);
        if(!in_array($uid, $korektori)){
          continue;
        }
        */

        //netiskni visici korektury antonym/synonym ze stareho systemu
        if(($R->tbl === 'synonyma') || ($R->tbl === 'antonyma') || ($R->field === 'odkaz-synonymum'))
            continue;

        //netiskni visici korektury stareho podhesli vyznamu
        if(($R->field === 'vyznam-komentar_podhesli') || ($R->field === 'vyznam-podhesli') || ($R->field==='vyznam-predvyklad') || ($R->field==='vyznam-predvyklad_master'))
            continue;

        if($R->field == "varianta-komentar_tvaru"){
                 //pole je blokovane, nezobrazuj pro nej info o korekture
              if(!is_field_enabled($hid, "varianta-komentar_tvaru")){
                continue;
              }
        }

        /*
        if($R->name === 'Exemplifikace'){
          $vyz = get_db_values('exemplifikace', 'vyz_id', $kor_data['field_val_id']);
          $index = array_search($vyz, $vyznamy);
          $num = 0;
          $index_podvyznamu = 0;
          if($index===false){
            foreach($vyznamy as $vyznam){
              $num++;
              $subvyznamy = get_subvyznamy($vyznam);
              $index_podvyznamu = array_search($vyz, $subvyznamy);
              if($index_podvyznamu!==false){
                $index_podvyznamu++;
                $label = " (podvýznam $index_podvyznamu významu $num)";
                break;
              }
            }
          }
          if($index!==false){
            $index++;
            $label = " (význam $index)";
          }
        } else if($R->name === "výklad významu"){
          $index_vyznamu = array_search($kor_data['field_val_id'], $vyznamy);
          if($index_vyznamu!==false){
            $index_vyznamu++;
            $label = " $index_vyznamu";
          }
        }*/
        $vyz_str = "";
        $cislo_varianty = "";
        $podh = false;
        if(substr($R->field, 0, strlen("vyznam"))=="vyznam"){
            $parts = explode("-", $kor_data['field_DOMid']);
            $vid = $parts[1];
            if(!is_numeric($vid))
            {
                $vid = $parts[2];
            }
            if(is_numeric($vid))
            {
                $vyz_num = printRedBox(false, $hid, $vid);
            }
            $vyz_str = " (význam $vyz_num) ";
        } else if(substr($R->field, 0, strlen("podhesli"))=="podhesli"){
            $parts = explode("-", $kor_data['field_DOMid']);
            $podh_id = $parts[1];
            if(is_numeric($podh_id) && $podh_id > 0){
                $vid = get_db_values("podhesli_vyznamu", "vyz_id", $podh_id);
                $vyz_num = printRedBox(false, $hid, $vid);
                $vyz_str = " (význam $vyz_num) ";
            }
        } else if(substr($R->field, 0, strlen("varianta"))=="varianta"){
            $parts = explode("-", $kor_data['field_DOMid']);
            $vid = $parts[1];
            $varianty = get('varianty_hesla', $hid, array('sortorder'));
            $index_v = 0;
            $index_p = 0;
            foreach($varianty as $varianta){
                $podh = is_sublemma($varianta);
                if($podh){
                  $index_p++;
                } else{
                  $index_v++;
                }
                if($varianta == $vid){
                    if($podh){
                      $cislo_varianty = " $index_p ";
                    } else{
                      $cislo_varianty = " $index_v ";
                    }
                    break;
                }
            }
        }
        $name = $R->name;
        if($R->field=='varianta-tvar'){
          $name = ($podh ? "podheslí" : $R->name);
        } else if($podh){
         $name = str_replace(array("varianty", "variantě"), array("podheslí", "podheslí"), $R->name);
        }
        //$name = ($podh ? "podheslí" : $R->name);
        $kor_label = $name.$cislo_varianty.$vyz_str." <span class='label'>[zadal(a) ".get_user_name($kor_data['corrector'])." ]</span>";
        $html.= "\t\t<li class='".$kor_data['field_DOMid']."'>$kor_label</li>\r\n";
        $count++;
    }
    if($opened){
        $html.="\t</ul>\r\n";
        if($count == 0 && $master){
            $html = "<div class='orangeBox newCorrectionsBox'>\r\n";
        }
    }
    if($master){
        $slaves = get_hids_pripojeni($hid);
        //ticket 500 - pripojene/prihnizdovane neexistujici heslo
        foreach($slaves as $slave){
            if(is_null($slave[slave_hid]) || !is_numeric($slave[slave_hid])){
                continue;
            }
            $list = print_new_corrections_box($slave[slave_hid], false);
            if(!empty($list)){
                if(!$opened){
                    $opened = true;
                    $html.="\r\n<div class='orangeBox newCorrectionsBox'>\r\n";
                }
                $heslo = text_html_preprocess(get_db_values('varianty','varianta', get_hlavni_varianta_hesla($slave[slave_hid])));
                $html.="<span class=\"newCorrectionBoxTitle\">Seznam aktivních korektur připojeného/přihnízdovaného hesla <a href=\"".LEMMA_FORM_ROUTER.".php?hid=$slave[slave_hid]\">$heslo</a></span>\r\n";
                $html.=$list;
                $count++;
            }
        }

    }

    if($master){
        if($opened){
            $html.= "</div><!-- newCorrectionBox -->\r\n";
        }
    }
    if($count == 0)
        $html = '';

    return $html;
}

function is_field_enabled($hid, $field){
   $result = dibi::query('SELECT [enabled] FROM [field_control] WHERE [hid] = %i AND [field] = %i', $hid, $field);
  $val = $result->fetchSingle();
  if(is_numeric($val) && $val == 1){
    return true;
  }
  return false;
}

function track_ulozeni_hesla($hid, $uid)
{
    $d = array();
    $d['hid'] = $hid;
    $d['uid'] = $uid;
    sql_w('track_ukladani_hesel', $d);
}

function clear_subhids($hid, &$hesla)
{
    $lop=0;
    $change=true;
    while($lop<20 &&$change)
    {
        $change=false;
        $lop++;
        if(in_array($hid, $hesla))
        {
            $i = array_search($hid, $hesla);
            for($j=2; $j>-3; $j--)
            {
                if(($i+$j>=0)&($i+$j<sizeof($hesla)))
                {
                    $sql = "SELECT h.pid as pid
                FROM heslo h
                WHERE h.id = ".$hesla[$i+$j];
                    $res = dbq($sql);
                    if($rs = mysql_fetch_array($res))
                    {
                        if($rs["pid"]>0)
                        {
                            if(!in_array($rs["pid"],$hesla))
                            {
                                array_splice($hesla, $i+$j, 0, $rs["pid"] );
                                $j++;
                            }
                            unset($hesla[$i+$j]);
                            $change=true;
                            $j++;
                            $hesla = array_values($hesla);
                        }
                    }
                }
            }
        }
        else
        {
            $sql = "SELECT h.pid as pid
            FROM heslo h
            WHERE h.id = ".$hid;
            $res = dbq($sql);
            if($rs = mysql_fetch_array($res))
            {
                $i = array_search($rs['pid'],$hesla);
                for($j=2; $j>-3; $j--)
                {
                    if(($i+$j>=0)&($i+$j<sizeof($hesla)))
                    {
                        $sql = "SELECT h.pid as pid
                  FROM heslo h
                  WHERE h.id = ".$hesla[$i+$j];
                        $res = dbq($sql);
                        if($rs = mysql_fetch_array($res))
                        {
                            if($rs["pid"]>0)
                            {
                                if(!in_array($rs["pid"],$hesla))
                                {
                                    array_splice($hesla, $i+$j, 0, $rs["pid"] );
                                    $j++;
                                }
                                unset($hesla[$i+$j]);
                                $change=true;
                                $j++;
                                $hesla = array_values($hesla);
                            }
                        }
                    }
                }
            }
        }
    }
}

function add_subhids(&$index, &$hesla)
{
    $hpid = isset($hesla[$index]) ? $hesla[$index] : 0;
    $sql = "SELECT h.id as id
            FROM heslo h LEFT JOIN varianty v ON v.hid=h.id
            WHERE h.pid = ".$hpid." AND v.sortorder=1
            ORDER BY v.varianta ASC";
    $res = dbq($sql);
    $sub_hesla = array();
    while($rs = mysql_fetch_array($res))
    {
        if(!in_array($rs['id'], $hesla))
        {
            $sub_hesla[] = $rs['id'];
        }
        else
        {
            unset($hesla[array_search($rs['id'],$hesla)]);
            //$index--;
            $hesla = array_values($hesla);
            $sub_hesla[] = $rs['id'];
        }
    }
    $index=array_search($hpid,$hesla);
    $index++;
    array_splice( $hesla, $index, 0, $sub_hesla );
    $index=$index+sizeof($sub_hesla);
}

/*
 Zadane pole obsahuji id vyznamu doplni o id podvyznamu
*/
function vygeneruj_podvyznamy($hid, $vyznamy){
    $vyznamy_tmp = array();
    $idx = 0;
    foreach($vyznamy as $vyz_id){
        $vyznamy_tmp[$idx]['ID'] = $vyz_id;
        //$vyznamy_tmp[$idx]['MASTER'] = true;
        $vyznamy_tmp[$idx]['MASTER'] = 0;
        $podvyznamy = get('podvyznamy_hesla', $hid, array('sortorder'), $vyz_id);

        foreach($podvyznamy as $podvyz_id){
            $idx++;
            $vyznamy_tmp[$idx]['ID'] = $podvyz_id;
            //$vyznamy_tmp[$idx]['MASTER'] = false;
            $vyznamy_tmp[$idx]['MASTER'] = $vyz_id;
        }
        $idx++;
    }
    return $vyznamy_tmp;
}

/*
 * Videl uzivatel uid heslo hid?
 */

function heslo_videno($hid, $uid){
   $result = dibi::query('SELECT COUNT(*) FROM [videna_hesla] WHERE [uid] = %i AND [hid] = %i', $uid, $hid);                                                   
   $count = $result->fetchSingle();
   return (is_numeric($count) && $count > 0);
}

/*
 * Seznam hesel, ktere videl uzivatel uid
 */
function videna_hesla($uid){
    $result = dibi::query('SELECT [hid] FROM [videna_hesla] WHERE [uid] = %i', $uid);
    $hids = array();
    foreach ($result as $row){
        $hids[] = $row['hid'];
    }
    unset($result);
    return $hids;
}

/*
 * Nastavi heslo $hid jako (ne)prohlednuto uzivatelem $uid 
 */
function heslo_prohlednuto($hid, $uid, $videno){
    if($videno){
        $arr = array(
            'uid' => $_POST['uid'],
            'hid' => $_POST['hid']
        );  
        dibi::query('INSERT INTO [videna_hesla]', $arr);
    } else{
        dibi::query("DELETE FROM [videna_hesla] WHERE [uid] = %i AND [hid] = %i", $_POST['uid'], $_POST['hid']);
    }
}



?>
