<?php
require_once('common.php');
require_once('fx.php');
require_once('formular_hesla_fx.php');
require_once('morphodita_fx.php');
require_once('search.php');
require_once('cls/redakce.class.php');
require_once('cls/xFilter.class.php');
$page_id = 'heslar';

function print_ord_ctrls($ordby){
    reset($_SESSION['razeni_hesel']); // make sure array pointer is at first element
    $firstKey = key($_SESSION['razeni_hesel']);
    //var_dump($_SESSION['listOrderingOnCli'][$firstKey]['asc_desc']);
    return "
      <table class='order_ctrl_tbl'>
        <tr>
          <td>
            <a href='heslar.php?act=order&ordby=$ordby&dsc=0'>
              <img src='css/images/".(($firstKey==$ordby && ($_SESSION['razeni_hesel'][$firstKey]['asc_desc']=='ASC')) ? "arrow_ord_asc_2.gif":"arrow_ord_asc_1.gif" )."' alt='Seřadit vzestupně'>
            </a>
          </td>
          <td>
            <a href='heslar.php?act=order&ordby=$ordby&dsc=1'>
              <img src='css/images/".(($firstKey==$ordby && ($_SESSION['razeni_hesel'][$firstKey]['asc_desc']=='DESC')) ? "arrow_ord_dsc_2.gif":"arrow_ord_dsc_1.gif" )."' alt='Seřadit sestupně' />
            </a>
          </td>
        </tr>
      </table>
    ";
}

function formular_noveho_hesla(){
    $html="";
    $html.="<div id='popUp_noveHeslo' title='Založení nového hesla' class='popUp'>";
    $html.="<form id='formular_noveho_hesla' method='post' action='#' onSubmit='return confirm_NoveHeslo(this.heslo.value)'>";
    $html.=" <input type='text' name='heslo' value='' maxlength='255' />";
    $html.=" <input type='hidden' name='act' value='nove_heslo' />";
    //$html.=" <input type='submit' class='ui-button ui-widget ui-state-default ui-corner-all ui-button-text-only' name='' value='OK' />";
    $html.="</form>";
    $html.="</div>";

    return $html;
}

function uloz_novy_seznam($nazev, $uid, $prepsat=0, $att_users=False){
    if($_SESSION['data_filter']['_dataID'] == 'jine_in_hesla'){
        $hesla = get_hesla_by_jine();
    }else{
        $hesla = get_hesla();
    }
    if ($prepsat){
        $prepsat = text_db_preprocess($prepsat);
        dbq('DELETE FROM hesla_v_seznamu WHERE sid='.$prepsat);
        $sid = $prepsat;
    }else{
        $nazev = text_db_preprocess($nazev);
        $sid = sql_w('seznam_hesel', array('nazev' => '"'.$nazev.'"', 'nazev_bd' => '"'.bd($nazev).'"','vlastnik' => $uid));
        sql_w('seznam_hesel_uziv', array('sid' => $sid, 'uid' => $uid));
    }
    foreach ($hesla as $h){
        sql_w('hesla_v_seznamu', array('hid' => $h, 'sid' => $sid));
    }
    if ($att_users){
        foreach ($att_users as $u) {
            sql_w('seznam_hesel_uziv', array('sid' => $sid, 'uid' => $u));
        }
    }
}

function list_active_corrections($hid, $master = true){
    $corrections = Redakce::get_nove_korekce_hesla($hid);
    $group_corrections = Redakce::get_nove_korekce_skupinky($hid);
    foreach($group_corrections as $correction){
        if(!in_array($correction, $corrections)){
            $corrections[] = $correction;
        }
    }
    $caption = '';
    $pocet = 0;
    //$uid = get_logged_user();
    $link_ids = get_links_for_hid($hid);

    if($master){
        $caption = "Heslo obsahuje aktivní korektury";
    }
    if(!empty($corrections)){
        foreach($corrections as $kor_id){
            $kor_data = get_db_values('korektura', array('corrector', 'field', 'field_val_id', 'field_DOMid', 'val_new'), $kor_id);
            $latest_id = Redakce::get_last_correction_id($kor_data['field_DOMid']);
            $is_corrected = $latest_id>0 && Redakce::is_new_correction($latest_id);
            if(!$is_corrected){
                continue;
            }


            if(in_array($kor_id, $group_corrections)){
                if(substr($kor_data['field'], -strlen("_master"))!="_master" && $kor_data['field']!="vyznam-link"){
                    continue;
                }
                if($kor_data['field']=='vyznam-link'){
                    $test = explode("^", $kor_data['val_new']);
                    if($test[3]!='1'){
                        continue;
                    }
                }
                else if(!in_array($kor_data['field_val_id'],  $link_ids)){
                    if($kor_data['field']=="vyznam-vyraz_predvykladu_master" ||
                        $kor_data['field']=="vyznam-komentar_predvykladu_master"){
                        if(!Redakce::over_korekce_predvykladu($kor_data['field'],
                            $kor_data['field_DOMid'],
                            $link_ids,
                            $kor_data['field_val_id'])){
                            continue;
                        }
                    }
                    else{
                        continue;
                    }
                }
            }

            $R = new Redakce($kor_id);

            //zacileni korektury
            /*$korektori = $R->get_korektori($kor_id, $hid);
            if(!in_array($uid, $korektori)){
              continue;
            }
            */

            //netiskni visici korektury antonym/synonym ze stareho systemu
            if(($R->tbl === 'synonyma') || ($R->tbl === 'antonyma') || ($R->field === 'odkaz-synonymum'))
                continue;

            //netiskni visici korektury stareho podhesli vyznamu
            if(($R->field === 'vyznam-komentar_podhesli') || ($R->field === 'vyznam-podhesli') || ($R->field==='vyznam-predvyklad') || ($R->field==='vyznam-predvyklad_master'))
                continue;
                

            $korektor = get_user_name($kor_data['corrector']);
            $name = $R->name;
            if($R->field == "varianta-tvar"){
              if(is_sublemma($kor_data['field_val_id'])){
                $name = "podheslí";
              }
            } else if(substr($R->field, 0, 3) == 'var'){
              preg_match('/\d+/', $kor_data['field_DOMid'], $matches);
              if(is_numeric($matches[0]) && is_sublemma($matches[0])){
                $name = str_replace(array("varianty", "variantě"), array("podheslí", "podheslí"), $R->name);
              }
            }
            if($R->field == "varianta-komentar_tvaru"){
              //pole je blokovane, nezobrazuj pro nej info o korekture
              if(!is_field_enabled($hid, "varianta-komentar_tvaru")){
                continue;
              }
            }
            if(!empty($korektor)){
                $kor_label = $name." [Zadal(a): $korektor]";
            }else{
                $kor_label = $name;
            }
            $pocet++;
            $caption.= "\r\n$kor_label";
        }
    }

    $count=0;
    if($master){
        if($pocet === 0){
            $caption = "";
        }
        $slaves = get_hids_pripojeni($hid);
        foreach($slaves as $slave){
            if(is_null($slave["slave_hid"]) || !is_numeric($slave["slave_hid"])){
                continue;
            }
            $list = list_active_corrections($slave["slave_hid"], false);
            if(!empty($list)){
                $heslo = text_html_preprocess(get_db_values('varianty','varianta', get_hlavni_varianta_hesla($slave["slave_hid"])));
                if(!empty($caption)){
                    $caption .= "\r\n";

                }
                $caption.="Seznam aktivních korektur připojeného/přihnízdovaného hesla $heslo";
                $caption.=$list;
                $count++;
            }
        }

    }
    return $caption;
}

function print_heslar_row($hid, $parent_hid=0, $nbsp="", $rozbal=FALSE, $barva=FALSE, $heslo=0, $link='')
{
    global $_CIS_TBL,$_CIS_VAL_COL;
    //$videna = videna_hesla(get_logged_user());
    $videno = heslo_videno($hid, get_logged_user());
    $html="";
    $stavClass="";
    $role = get_role();
    $hid_sel_cls = (isset($_SESSION['hid_selection']) && in_array($hid, $_SESSION['hid_selection'])) ? "rowSelected" : "";
    $h = get_db_values('heslo',array('cts', 'uts', 'stav', 'vystup', 'heslar_id'),$hid);
    $varianty = get('varianty_hesla', $hid, array('sortorder'));
    $stav = dibi::fetchSingle('SELECT stav FROM heslo_stav WHERE hid = %i ORDER BY id DESC LIMIT 1', $hid);
    if (!$stav) {
        $stav = 1;
    }
    if($h['stav']==NOVE)         $stavClass='noveHeslo';
    if($h['stav']==ROZPRACOVANE) $stavClass='rozpracHeslo';
    if($h['stav']==DOKONCENE)    $stavClass='dokoncHeslo';
    $cis_sl_druhov = get('slovneDruhy_varianty', $varianty[0]);
    $sl_druhy = array();

    $nezar="&nbsp;";
    if($h['vystup']==0)
    {
        $nezar="<div class='nezar'>o</div>";
    }

    foreach($cis_sl_druhov as $cis_sl_druhu){
        $sl_druhy = array_unique(array_merge($sl_druhy, get_vybrane_hodnoty_ciselniku(SLOV_DRUHY, 'var', $cis_sl_druhu)));
    }
    $hl_var_data = get_db_values('varianty', array('varianta', 'homonymie', 'neosemantismus'), $varianty[0]);
    if(empty($hl_var_data['neosemantismus']))
    {
        $hl_var_is_neo = false;
    }
    else
    {
        $hl_var_is_neo = ($hl_var_data['neosemantismus']=='1') ? true : false;
    }
    $varianty_str = array();
    foreach($varianty as $var_id){
        $is_neo = (get_db_values('varianty', 'neosemantismus', $var_id)=='1')?true:false;
        if($varianty[0] != $var_id) $varianty_str[] = get_db_values('varianty', 'varianta', $var_id).(($is_neo)?NEO:"");
    }
    $zpracovatele = get_vybrane_hodnoty_ciselniku(ZPRACOVATELE, 'hes', $hid);
    if(is_owner($hid)){
        $del_butt_html = "
      <a href='heslar.php?act=smazHeslo&amp;hid=$hid' onClick=\"return check_heslo_delete($hid, '".$hl_var_data['varianta']."')\" class='delLink'>
       <img src='css/images/del.png' alt='Smazat' />
      </a>
    ";
    }else{
        $del_butt_html = "&nbsp;";
    }
    $sl_druhy = my_arrayMap('text_html_preprocess', $sl_druhy);
    $varianty_str = my_arrayMap('text_html_preprocess', $varianty_str);
    $zpracovatele = my_arrayMap('text_html_preprocess', $zpracovatele);

    //subhids workaround
    $has_subhids = count(get_subhids($hid)) > 0;
    //$parent_hid = get_db_values('heslo', 'pid', $hid);
    $is_subhid = $parent_hid > 0;
    $subhid_class = "subhid_of-$parent_hid";
    $toggle_subhids_butt = "&nbsp;";
    if($has_subhids)
    {
        if($rozbal)
        {
            $toggle_subhids_butt = "<img src='css/images/small_minus.png' title='Rozbal podhesla' data-phid='$hid' class='hideSubHids clickable' />";
        }
        else
        {
            $toggle_subhids_butt = "<img src='css/images/small_plus.png' title='Rozbal podhesla' data-phid='$hid' class='showSubHids clickable' />";
        }
    }
    $hide_subhid_cls = ""; if($is_subhid and !$rozbal) $hide_subhid_cls = "hidden_subhid";
    if(!empty($nbsp)) $nbsp.="<img src='css/images/tree_branch.gif' />&nbsp;";
    $Sbarva="";
    if(is_array($heslo))
    {
        if(in_array($hid,$heslo)&&$barva&&$is_subhid) $Sbarva="style='background-color:#F8FF59;'";
    }
    else
    {

        if($hid==$heslo&&$barva&&$is_subhid) $Sbarva="style='background-color:#F8FF59;'";
    }

   $hide_subhid_cls = ""; if($is_subhid and !$rozbal) $hide_subhid_cls = "hidden_subhid";
   if(!empty($nbsp)) $nbsp.="<img src='css/images/tree_branch.gif' />&nbsp;";
   $Sbarva="";
      if(is_array($heslo))
      {
          if(in_array($hid,$heslo)&&$barva&&$is_subhid) $Sbarva="style='background-color:#F8FF59;'";
      }
      else
      {
          if($hid==$heslo&&$barva&&$is_subhid) $Sbarva="style='background-color:#F8FF59;'";
      }

   $html=" <tr class='$hid_sel_cls $hide_subhid_cls $subhid_class'>";
   $html.="  <td><div class='heslo_semafor heslo_semafor_".$stav." active heslo_semafor_small' title='".getSemaforTitle($stav)."'>".$stav."</div></td>";
   $html.="  <td>$nezar</td>";
   $html.="  <td>$toggle_subhids_butt</td>";
   $doc = '';
   if ($role == NAHLIZENI){
    $href = 'tisk_hesel_new.php?hid='.$hid.'&amp;action=export';
    $add = ' target="_blank"';
    $pdf = '';
   }elseif ($role == ODBORNIK){
    $href = 'tisk_hesel_new.php?hid='.$hid;
    $add = '';
    $pdf = '<a href="tisk_hesel_new.php?hid='.$hid.'&amp;page=heslo_varianty&amp;action=export" target="_blank" title="Tiskový výstup (PDF)" class="pdf_heslar_butt">&nbsp;</a>';
    $doc = '<a href="tisk_hesel_new.php?hid='.$hid.'&amp;page=heslo_varianty&amp;action=preview" target="_blank" title="Tiskový výstup (Word)" class="word_heslar_butt">&nbsp;</a>';
   }else{
    $href = LEMMA_FORM_ROUTER . '.php?hid='.$hid.($link ? '&amp;'.$link : '');
    $add = '';
    $pdf = '';
   }
    $heslar_typ = get_db_values($_CIS_TBL[PROPRII], array($_CIS_VAL_COL[PROPRII]), $h['heslar_id']);
   $html.="  <td >".$pdf.$doc."$nbsp<a href='".$href."' class='idRel' rel='$hid' $Sbarva".$add.">".text_html_preprocess($hl_var_data['varianta'])."</a>".(($hl_var_is_neo)?NEO:"")."</td>";

    $html.="  <td>".$hl_var_data['homonymie']."</td>";
    $html.="  <td>".implode("<br />", $sl_druhy)."</td>";
    $html.="  <td>".implode("<br />", $varianty_str)."</td>";
    if($role!=ODBORNIK && $role!=NAHLIZENI){
      $html.="  <td>".implode("<br />", $zpracovatele)."</td>";
    }
    $html.="  <td>".ftime($h['cts'])."</td>";
    $html.="  <td>".ftime($h['uts'])."</td>";
    if(sizeof($_SESSION['aktivni_heslar'])>1)$html.="  <td>".$heslar_typ[$_CIS_VAL_COL[PROPRII]]."</td>";
    if(!empty($newColHeader) && !empty($newCol)) $html.=$newCol;

    if(($role != ODBORNIK) && ($role != NAHLIZENI)){
        $caption = list_active_corrections($hid);
        if(empty($caption)){
            $html.="\r\n<td>&nbsp;</td>";
        } else{
            $html.="\r\n<td><img src='./css/images/edit.png' alt='aktivní korektury' title='$caption' /></td>";
        }
    }
    if($role == ODBORNIK || $role == UZIVATEL || $role == HLAVNI_REDAKTOR){
        if($videno){
            $html.="\r\n<td><td><img src='./css/images/active_on.png' alt='aktivní korektury' title='Viděl/a jsem' /></td>";
        } else{
            $html.="\r\n<td><td><img src='./css/images/active_off.png' alt='aktivní korektury' title='Neviděl/a jsem' /></td>";
        }
    }
    $html.="\r\n<td>$del_butt_html</td>";
    $html.="\r\n</tr>";
    return $html;
}

function _print_sub_hesla($pid, $nbsp="", $rozbal=FALSE, $barva=FALSE, $heslo=0){
    $sql = "SELECT h.id as id
            FROM heslo h LEFT JOIN varianty v ON v.hid=h.id
            WHERE h.pid = $pid AND v.sortorder=1
            ORDER BY v.varianta";
    $res = dbq($sql);

    $list_rows = "";
    //$nbsp.="&nbsp;&#9658;&nbsp;";
    $nbsp.="&nbsp;";
    while($rs = mysql_fetch_array($res)){
        $list_rows .= print_heslar_row($rs['id'], $pid, $nbsp, $rozbal, $barva, $heslo);
        $list_rows .= _print_sub_hesla($rs['id'], $nbsp, $rozbal, $barva, $heslo);
    }
    return $list_rows;
}

function typ_heslare()
{
    $html="<div id='blok_typ_heslare' class=' '>";
    $cisAll = get_hodnoty_ciselniku(PROPRII,false);
    $vnitrek="";
    $vnitrek2=""; 
    foreach($cisAll as $id => $type){
        if(in_array($id,$_SESSION['aktivni_heslar']))
        {
            $vnitrek.='<li style="white-space: nowrap" >
                    <input type="checkbox" class="jeden_typ" checked value="'.$id.'"  id="'.$type.'"/> '.$type.'
                </li>';
            if(!empty($vnitrek2))$vnitrek2.=', ';
            $vnitrek2.='<span style="white-space: nowrap" class="typ_heslare" title="'.$type.'"><b>'.$type.'</b></span>';
            $vnitrek2.='<span  title="'.$type.'_cislo" style=" padding-right: 0px;width: 0px;visibility: hidden">0</span>';
        }
        else
        {
            $vnitrek.='<li style="white-space: nowrap" >
                        <input type="checkbox" class="jeden_typ" value="'.$id.'" id="'.$type.'"/> '.$type.'
                        </li>';
        }
    }
    $vnitrek.='<li> 
            <form class="floatLeft" id="formular_typ_heslare" onSubmit="javascript:ukaz_vyber() ">
              <input type="submit" value="Aplikuj">
              </form>
                </li> ';
    $html.='<dl class="dropdown floatLeft">  
            <dt>
            <a href="#">
              <span class="hida" style="display: none;"></span>    
              <p class="multiSel">'.$vnitrek2.'</p>  
            </a>
            </dt> 
            <dd>
                <div id="popUp_typ_heslare" class="mutliSelect">
                    <ul>';
    $html.=$vnitrek.'</ul> 
                </div>
            </dd>
        </dl>';
    $html.="</div>";
    return $html;
}

function seznam_hesel($forced=False){

    $pids=array();
    //$pg = isset($_GET['pg']) ? $_GET['pg'] : 1;
    global $_CIS, $_CIS_TBL, $_CIS_VAL_COL, $_VYSTUP;
    $role = get_role();

    $co_hledam = "";
    if ($forced){
        $hesla = get_hesla($forced, $pids);
        $forced_link = 'forced_entries='.implode(',', $forced);
    }else{
        $forced_link = '';
        if($_SESSION['data_filter']['_dataID']=='jine_in_hesla'){
            $hesla = get_hesla_by_jine($pids);
            $hodnota_jine = text_html_preprocess($_SESSION['data_filter']['_filterValue']['jine_val']);
            if(empty($hodnota_jine)){
                $hodnota_jine = "nezadáno";
            }
            $co_hledam = "<td>Číselník: <b>".$_CIS[$_SESSION['data_filter']['_filterValue']['cis']]."</b> Hodnota \"jiné\": <b>".$hodnota_jine."</b></td>";
            $co_hledam.= "<td><a href='heslar.php?act=data_filter&filter=0' class='cancelSearch'></a></td>";
        }else{
            $hesla = get_hesla(false, $pids);
        }
    }

    //var_dump($pids);
    //var_dump($hesla);
    $correctures_indicator = "";
   if(count(Redakce::get_hesla_s_korekci_pro_zpracovatele(get_logged_user()))>0){
        $correctures_indicator = "<a href='heslar.php?act=data_filter&filter=nove_korektury' class='new_corrections_indicator' title='Hesla s aktivní korekturou pro uživatele'></a>";
    }
        
    $msgs_indicator = "";
    if (is_role_uzivatel()) $msgs_indicator = "<a href='korektury.php' class='msgs_indicator' title='Zprávy z redakčního modulu'></a>";

    $pocet=0;

    if (!empty($hesla)){
        foreach(array_values($hesla) as $v)
        {
            $new_hesla[$v] = 1;
        }
    }
    $pids_to_print=array();
    $rozbalene=array();
    $cnt = count($hesla);
    for($i=0; $i < $cnt; $i++)
    {
        if($pids[$i] > 0 )
        { //pokud má rodiče 
            $parent_in = isset($new_hesla[$pids[$i]]);
            if(!$parent_in){ //pokud rodič není v seznamu hesel
                $parent_in =  in_array($pids[$i],$pids_to_print);
                if(!$parent_in){ //pokud rodič není v seznamu hesel, která se budou tisknout
                    $pids_to_print[]=$pids[$i];
                    $pocet++;
                }
            }
            $rozbalene[]=$pids[$i];
        }
        else
        { //pokud nemá rodiče
            $pids_to_print[]=$hesla[$i];
            $pocet++;
        }
    }
    /*for($i=0; $i<count($hesla); $i++){
      $parent_hid = get_db_values('heslo', 'pid', $hesla[$i]);
      $is_subhid = $parent_hid > 0;
      if($is_subhid){ //pokud má rodiče
        $parent_in = in_array($parent_hid,$hesla);
        if(!$parent_in){ //pokud rodič není v seznamu hesel
          $parent_in = in_array($parent_hid,$pids_to_print);
          if(!$parent_in){ //pokud rodič není v seznamu hesel, která se budou tisknout
            $pids_to_print[]=$parent_hid;
            $pocet++;
          }
        }
      }else{ //pokud nemá rodiče
        $pids_to_print[]=$hesla[$i];
        $pocet++;
      }
    }     */
    $pocet_hesel = $pocet;
    $pagerHTML = pager_htmls('heslar', $pocet_hesel);
    $filter_name = $_SESSION['data_filter']['_filterName'];
    $filter_date_from = "";
    $filter_date_to = "";
    if($filter_name==='datum' || $filter_name==='datum_vytvoreni'){
        $filter_date_from = (!empty($_SESSION['data_filter']['_filterValue'][0])) ? ftime($_SESSION['data_filter']['_filterValue'][0]) : "";
        $filter_date_to   = (!empty($_SESSION['data_filter']['_filterValue'][1])) ? ftime($_SESSION['data_filter']['_filterValue'][1]) : "";
    }
    $sel_cnt = count($_SESSION['hid_selection']);
    if(empty($filter_name)) $filter_name = 0;
    if(isset($_SESSION['search']['query']) && $_SESSION['search']['query']!="" && isset($_SESSION['search']['field']) && $_SESSION['search']['field']!=""){
        $qsObj = new QuickSearch($_SESSION['search']['field']);
        $field = $qsObj->name;
        $query = $_SESSION['search']['query'];
        if($qsObj->type == 'cis') $query = get_db_values($_CIS_TBL[$qsObj->cis], $_CIS_VAL_COL[$qsObj->cis], $query);
        if($qsObj->type == 'select') $query = $qsObj->custom_vals[$query];
        $co = text_html_preprocess($query);     
        if(empty($co)){
            if($qsObj->type == "cis" && $qsObj->cis == TEMATICKE_OKRUHY){
                $co = "neoborové";
            } else{
                $co = "jiné";
            }
        }
        if(empty($co_hledam)) $co_hledam = ((isset($_SESSION['search']['query']) && $_SESSION['search']['query']!="") ? "<td>Hledám<b><i>\"".$co."\"</i></b> v poli <b>".$field."</b></td><td><a href='heslar.php?act=cancel_search' class='cancelSearch'></a></td>" :"");

        //osetrenie noveho stlpca
        /*
        if($qsObj->id!='heslo' && $qsObj->id!='varianta-slovnyDruh' && ($qsObj->type=='cis' || $qsObj->type=='txt_ac')){
          $newColHeader = "<th>".$field."</th>";
          $newCol = "<td>".text_html_preprocess($query)."</td>";
        }
        */
    }
    //var_dump($filter_name);
    //var_dump($co_hledam);
    //var_dump($co_hledam);
    $html="";
    $html.="
    <div id='heslar_top_left' class='floatLeft'>
     <div>
      <div style='float: left;margin-bottom: 20px'>
        ".(is_role_uzivatel() ? "<a href='#' onClick=\"javascript: return noveHesloDlg('popUp_noveHeslo')\" class='buttBox greenButtBox hmargin'><span><b>Nové heslo</b></span></a>" : "")."
      </div>
      <div class='clear'></div>
    ";
    $html .= "
      <!--
      <form action='#' method='get' class='floatLeft'>
       <table cellspacing=0><tr>
       <td><input type='text' name='search_q' value='".((isset($_SESSION['search']['query']) && $_SESSION['search']['query']!="") ? $_SESSION['search']['query'] : "")."' style='padding: 1px 0;'/></td>
       <td><input type='hidden' name='act' value='search' /></td>
       <td><input type='image' src='css/images/search.png' /></td>
       </tr></table>
      </form>
      <a href='heslar.php?act=cancel_search' class='cancelSearch floatLeft'></a>
      -->

      <table class='floatLeft qs_tbl'><tr><td><div class='qSearch_butt clickable'></div></td>$co_hledam</tr></table>
      <div style='margin-top:3px; float: left;'>
      <form id='filterHesel' action='#' method='get' class='floatLeft' >
       <input type='hidden' name='act' value='data_filter' />
       <input type='submit' value='Aplikuj' />
       <select name='filter' class='floatLeft'>
        <option value='0'>                                                                -- Vyber filtr -- </option>
    ";
    if (isset($_SESSION['data_filter']['_filterName']) && $_SESSION['data_filter']['_filterName'] == 'seznam'){
        $seznam_name = db_fetchSingle('SELECT nazev FROM seznam_hesel WHERE id='.mysql_real_escape_string($_SESSION['data_filter']['_filterValue']));
        $html .= "
        <option value='0' selected='selected'>Seznam hesel \"".$seznam_name."\"</option>
      ";
    }else{
        $seznam_name = '';
    }
    
    $html .= "
        <!--<option value='0'>                                                                Nefiltrovat </option>-->
        ".(is_role_uzivatel() ? "<option value='moje' ".(($filter_name==='moje')?"selected=selected":"").">        Moje Hesla  </option>" : '')."
        <option value='oznacene' ".(($filter_name==='oznacene')?"selected=selected":"").">Označené    </option>
        <option value='vse'>                                                              Vše         </option>
        <option value='datum' ".(($filter_name==='datum')?"selected=selected":"").">      od-do (změna)</option>
        <option value='datum_vytvoreni' ".(($filter_name==='datum_vytvoreni')?"selected=selected":"")."> od-do (vznik)</option>
        ".(is_role_uzivatel() ? "<option value='xFilter' ".(($filter_name==='xFilter')?"selected=selected":"").">xFiltr</option>" : '');
        if($role == ODBORNIK || $role == UZIVATEL || $role == HLAVNI_REDAKTOR){
            $html.="<option value='nevidel_jsem' ".(($filter_name==='nevidel_jsem')?"selected=selected":"").">Neviděl/a jsem</option>";
        }
    $who = get_logged_user();
    if($who==3 || $who==1 || $who==15 || $who==23){
        $html.="<option value='special' ".(($filter_name==='Special')?"selected=selected":"").">Special</option>";
    }
    //multivariantní filtr
    if(is_role_uzivatel()){
        $html.="<option value='multivariant' ".(($filter_name==='multivariant')?"selected=selected":"").">Multivariantní hesla</option>";
        $html.="<option value='multivariant3' ".(($filter_name==='multivariant3')?"selected=selected":"").">Multivariantní hesla (3+ varianty)</option>";
        $html.="<option value='odm_kor' ".(($filter_name==='odm_kor')?"selected=selected":"").">Hesla s odmítnutou korekturou</option>";
    }
    $html.="</select>
       <div id='date_filter_fields' class='floatLeft hmargin filterPopUpFilds' style='display: ".(($filter_name==='datum' || $filter_name==='datum_vytvoreni')?"block":"none")."'>
        od:<input id='date_filter_form' type='text' name='filter_date_from' value='$filter_date_from' size='9' />
        do:<input id='date_filter_to' type='text' name='filter_date_to' value='$filter_date_to' size='9' />

       </div>
       <div id='xFilterSelector_container' class='floatLeft hmargin filterPopUpFilds' style='display: ".(($filter_name==='xFilter')?"block":"none")."'>
        <div class='floatLeft'>".xFilter::selector('xFilter_id', $_SESSION['data_filter']['_filterValue'])."</div>
       </div>
      </form>
      
      </div>
      </div>
    </div>
    <div id='heslar_top_right' class='floatRight'>
      <div class='row1'>
      ";

    if(is_role_uzivatel()){
        $html .= '
            <a href="tab_export.php" class="floatRight tabExport_butt" target="_blank" title="Tabulkový výstup">&nbsp;</a>
        ';
    }

      if (is_admin(get_logged_user())){
          $html .= '
        <a href="xml_export.php" class="floatRight xmlExport_butt" target="_blank" title="XML výstup">&nbsp;</a>
      ';
      }
      
    if (is_role_uzivatel() || $role == ODBORNIK){
        $html .= "
        <a href='tisk_hesel_new.php?page=heslo_varianty&action=preview&amp;souvisl=1' class='floatRight' id='previewButt-souvisl' title='Souvislý tiskový výstup (Word)'></a>
        <a href='tisk_hesel_new.php?page=heslo_varianty&amp;action=preview' class='floatRight' id='previewButt-nesouvisl' title='Nesouvislý tiskový výstup (Word)'></a>
      ";
    }

    $html .= "
      <a href='tisk_hesel_new.php?page=heslo_varianty&action=export&amp;souvisl=1' class='floatRight' id='pdfButt-souvisl' title='Souvislý tiskový výstup (PDF)'></a>
      <a href='tisk_hesel_new.php?page=heslo_varianty&amp;action=export' class='floatRight' id='pdfButt' title='Nesouvislý tiskový výstup (PDF)'></a>";
    if ($role != NAHLIZENI){
        $html .= "
        <!--<a href='tisk_hesel.php?page=heslo_varianty' class='floatRight' id='printButt'></a>-->  <!-- povodne div (tak fungoval qTip) -->
         <div style='display: none'> <!-- div pre qTip, ktory je momentalne disable-nuty -->
          <ul class='printMenu'>
           <li><a href='tisk_hesel.php?page=heslo_varianty' target='_blank'>Heslář s variantami</a></li>
           <li><a href='tisk_hesel.php?page=heslo' target='_blank'>Náhled pro zpracovatele – maximální</a></li>
          </ul>
         </div>
        <a href='tisk_hesel_new.php?page=heslo_varianty&amp;souvisl=1' class='floatRight' id='printButtNew-souvisl' title='Souvislý tiskový náhled (HTML) s redakčním modulem'></a>
        <a href='tisk_hesel_new.php?page=heslo_varianty' class='floatRight' id='printButtNew' title='Nesouvislý tiskový náhled (HTML) s redakčním modulem'></a>
       ";
    }
    $html .= '</div><div class="row2">';
    if(is_admin(get_logged_user())){
        $usrs = get_user_list();
        $html .= '
        <div id="items2user_icon" title="Přiřazení hesel uživatelům"></div>
        <div id="i2u_arrow"></div>
        <div id="items2user_block" class="orangeBox">
      ';
        if ($usrs){
            $sez = is_seznam_filter();
            $html .= '
            <div>
            <div id="i2u_buttons">
              <input type="button" id="i2u_submit" name="i2u_submit" class="buttBox greenButtBox" value="Přiřaď" onClick="seznam_create_popup(1, '.$sez.');" />
              <input type="button" id="i2u_cancel" class="buttBox blueButtBox" value="Zruš" />
            </div>
            <div id="i2u_info">
        ';
            if ($sez){
                $html .= ' *přiřadí uživatele k seznamu<br />' . $seznam_name;
                $html .= '<input type="hidden" id="i2u_users_only" name="users_only" value="'.$sez.'" />';
            }else{
                $html .= ' *přiřadí '.$pocet_hesel.' hesel vybraným uživatelům';
            }

            $html .= '
            </div>
            <div id="i2u_items">
        ';
            foreach ($usrs as $u){
                $html .= '
            <div class="items2user_item">
              <input class="i2u_check" type="checkbox" name="user_check[]" value="'.$u['id'].'" login="'.$u['login'].'" />
            '.$u['name'].'
            </div>
          ';
            }

            $html .= '
            </div>
          </div>
        ';
        }else{
            $html .= 'Neexistují uživatelé, kterým by bylo možné přiřadit hesla.';
        }
        $html .= '</div>';
    }
    if (is_role_uzivatel()){
        $html .=
            $correctures_indicator.' '.$msgs_indicator.
            '<a class="seznamy_hesel_icon" href="seznamy_hesel.php" title="Zobrazit seznamy hesel"></a>
        <div class="uloz_seznam_icon" onClick="seznam_create_popup(0);" title="Uložit aktuální výběr do seznamu"></div>
        <div id="popUp_novySeznam" title="Nový seznam hesel" class="popUp"></div>
      ';
    }
    
    $html .= "</div></div>
      <div class='clear'></div>
      <div class='floatLeft'>
        ".typ_heslare()."
      </div>";
    
    $pager_block = '
      <div class="heslar_pager_block">
          <div>
            <div class="floatLeft">'.$pagerHTML['found_info'].'</div>
            <div class="floatRight">'.$pagerHTML['stats_info'].'</div>
          </div>
          <div style="clear:both;">
            <div class="pager_pages floatLeft">'.$pagerHTML['pages'].'</div>
            <div class="floatRight">'.$pagerHTML['itemsPerPage'].'</div>
          </div>
      </div>
     ';
    $html.="
      </div>
      <div class='clear'></div>";
     if($_SESSION['search']['morphodita_ok']==false){
        $html .="Komunikace s externím lematizátorem selhala";
     }
      $html.=$pager_block;


    $html.="<div class='clear'></div>";
    $html.="<div id='heslar_container' class='orangeBox'>";
    $html.="<table class='w100 stripeMe' id='heslar' cellspacing=0>";
    $html.=" <thead>";
    $html.="  <tr>";
    $html.="   <th>&nbsp;</th>";
    $html.="   <th>zař.</th>";
    $html.="   <th style='width: 16px'>&nbsp;</th>";
    $html.="   <th><div class='floatLeft'>heslo</div>".print_ord_ctrls('heslo')."</th>";
    $html.="   <th>hom.</th>";
    $html.="   <th>sl. druh</th>";
    $html.="   <th>varianty/podheslí</th>";
    if($role!=ODBORNIK && $role!=NAHLIZENI){
      $html.="   <th>zpracovatel</th>";
    }
    $html.="   <th>vytvořeno</th>";
    $html.="   <th>změněno</th>";
    if(sizeof($_SESSION['aktivni_heslar'])>1)$html.="   <th>heslar</th>";
    if(!empty($newColHeader) && !empty($newCol)) $html.=$newColHeader;
    if(get_role()!=ODBORNIK && get_role()!=NAHLIZENI){
        $html.="    <th title='Aktivní korektury'>kor.</th>";
    }
    $html.="   <th>&nbsp;</th>";
    if($role == ODBORNIK || $role == UZIVATEL || $role == HLAVNI_REDAKTOR){
        $html .= "\r\n<th>Viděno</th>";
    }
    $html.="  </tr>";
    $html.=" </thead>";

    $html.="<tbody>";
    $pager = parse_pager('heslar'); if($pager['iPerPage']==0) $pager['iPerPage']=count($hesla);
    //$last=0;
    /*$rozbalene=array();
    for($i=0; $i<count($hesla); $i++){
      $parent_hid = get_db_values('heslo', 'pid', $hesla[$i]);
      $is_subhid = $parent_hid > 0;
      if($is_subhid){
        $rozbalene[]=$parent_hid;
      }
    }            */
    //var_dump($rozbalene);
    //var_dump($hesla);
    for($i=$pager['listFrom']; $i<min($pager['listFrom']+$pager['iPerPage'], count($pids_to_print)); $i++){
        $rozbal= in_array($pids_to_print[$i],$rozbalene);
        $html.=print_heslar_row($pids_to_print[$i], 0, $nbsp="", $rozbal, !empty($_SESSION['search']['query']) ||!empty($_SESSION['data_filter']) , $hesla, $forced_link);
        $html.=_print_sub_hesla($pids_to_print[$i], $nbsp="", $rozbal, !empty($_SESSION['search']['query']) ||!empty($_SESSION['data_filter']) , $hesla);
    }
    $html.=" </tbody>";
    $html.="</table>";
    $html.="</div>";
    $html .= $pager_block;
    if (is_role_uzivatel()){
        $html.="<a href='#' onClick=\"javascript:return noveHesloDlg('popUp_noveHeslo')\" class='buttBox greenButtBox floatLeft hmargin'><span><b>Nové heslo</b></span></a>";
    }
    $html.="<div id='selectionInfo' ".(($sel_cnt==0)?"style='display: none'":"").">
              <img src='css/images/select_all.gif' border='0' id='hid_select_all_butt' class='clickable' onClick='javascript: hid_select_all()' alt='Označit vše' />
              Označených <span class='cnt'>$sel_cnt</span> položek.
              &nbsp;<img src='css/images/close.png' border='0' id='hid_unselect_all_butt' class='clickable' onClick='javascript: hid_unselect_all()' alt='Zrušit označení' />
            </div>";
    return $html;
}

function update_hid_sel($hid, $add=true){
    //by sa hodil test ci take hid existuje
    if(!is_numeric($hid)) return false;
    if(isset($_SESSION['hid_selection'])){
        if($add && array_search($hid, $_SESSION['hid_selection'])===false) $_SESSION['hid_selection'][] = $hid;
        else unset($_SESSION['hid_selection'][array_search($hid, $_SESSION['hid_selection'])]);
    }else{
        $_SESSION['hid_selection'] = array($hid);
    }
    return true;
}

if(isset($_POST['act']))
    switch($_POST['act']){
        case 'confirm_NoveHeslo':  //ajax
            $heslo_existuje = heslo_existuje(trim($_POST['heslo']));
            echo ($heslo_existuje) ? "1" : "0";
            exit;
        case 'confirm_novySeznam':  //ajax
            $seznam_existuje = seznam_existuje(trim($_POST['nazev']));
            echo ($seznam_existuje) ? "EXISTS" : "OK";
            exit;
        case 'nove_heslo':
            $hid = uloz_nove_heslo(trim($_POST['heslo']), get_logged_user());
            if($hid !== false) header("Location: ".LEMMA_FORM_ROUTER.".php?hid=$hid");
            break;
        case 'novy_seznam':
            $att_users = isset($_POST['att_users']) ? $_POST['att_users'] : False;
            uloz_novy_seznam(trim($_POST['seznam_nazev']), get_logged_user(), $_POST['prepsat_seznam'], $att_users);
            //header("Location: formular_hesla.php?hid=$hid");
            break;
        case 'update_hid_sel':
            $add = ($_POST['add_hid']=='1') ? true : false;
            $status = update_hid_sel($_POST['hid'], $add);
            if($status) echo count($_SESSION['hid_selection']); else echo "-1";
            exit;
        case 'unselect_hid_sel':
            unset($_SESSION['hid_selection']);
            exit;
        case 'select_hid_sel':
            unset($_SESSION['hid_selection']);
            if($_SESSION['data_filter']['_dataID'] == 'jine_in_hesla'){
                $_SESSION['hid_selection'] = get_hesla_by_jine();
            }else{
                $_SESSION['hid_selection'] = get_hesla();
            }
            echo count($_SESSION['hid_selection']);
            exit;
        case 'check_heslo_for_hidRel':
            $stat = is_heslo_in_hidRel($_POST['hid']);
            $resp = 0; if($stat) $resp = 1;
            echo $resp;
            exit;
    }
elseif(isset($_GET['act']))
    switch($_GET['act']){
        case 'order':
            $asc_desc = (isset($_GET['dsc']) && $_GET['dsc']=='1') ? 'DESC' : 'ASC';
            $orderBy = (isset($_GET['ordby'])) ? $_GET['ordby'] : "";
            order_list_by($orderBy, $asc_desc);
            break;
        case 'smazHeslo':
            if(!is_owner($_GET['hid'])) break;
            smaz_heslo($_GET['hid']);
            if(in_array($_GET['hid'], (array)$_SESSION['hid_selection']))
                unset($_SESSION['hid_selection'][array_search($_GET['hid'], $_SESSION['hid_selection'])]);
            break;
        case 'setPage':
            $pg = (empty($_GET['pg'])) ? 1 : $_GET['pg'];
            if(!empty($_SESSION['pager']['heslar']['iPerPage']))
                set_pager('heslar', $pg, $_SESSION['pager']['heslar']['iPerPage']);
            else
                set_pager('heslar', $pg);
            break;
        case 'setRowsPerPage':
            set_pager('heslar', 1, $_GET['rpp']);
            break;
        case 'zmen_aktivni_heslar':
            $_SESSION['aktivni_heslar']=array();
            $_SESSION['aktivni_heslar'][]=$_GET['cislo_hesl'];
        case 'search':
            /*var_dump($_SESSION['data_filter']);
            $filter_name=$_SESSION['data_filter']['_filterName'];
            $filterval = $_SESSION['data_filter']['_filterValue'];
            var_dump($filter_name);         */

            if(isset($_SESSION['data_filter']['_dataID']) && $_SESSION['data_filter']['_dataID'] === "jine_in_hesla"){
                unset_data_filter();
            }
            set_search($_GET['search_q'], $_GET['qs_field_select']);
            /*if($filter_name=='xFilter')
            {
                  set_data_filter("hesla", 'xFilter', $filterval);
            }  */
            break;
        case 'cancel_search':
            if(isset($_SESSION['search']['query'])) unset($_SESSION['search']['query']);
            break;
        case 'data_filter':
            if(isset($_GET['filter']))
                switch($_GET['filter']){
                    case '0':
                        //var_dump("unset");
                        unset_data_filter("hesla");
                        break;
                    case 'moje':
                        set_data_filter("hesla", "moje", get_logged_user());
                        break;
                    case 'oznacene':
                        if (isset($_GET['entries'])){
                            $_SESSION['hid_selection'] = array_unique(explode(',', $_GET['entries']));
                        }
                        set_data_filter("hesla", "oznacene", $_SESSION['hid_selection']);
                        break;
                    case 'vse':
                        unset_data_filter("hesla");
                        set_pager('heslar', 1, 500);
                        break;
                    case 'datum':
                    case 'datum_vytvoreni':
                        $interval[0] = (!empty($_GET['filter_date_from'])) ? date("Y-m-d", strtotime($_GET['filter_date_from'])) : 0 ;
                        $interval[1] = (!empty($_GET['filter_date_to']))   ? date("Y-m-d", strtotime($_GET['filter_date_to'])) : 0 ;
                        if($interval[0]!=0 || $interval[1]!=0)
                            set_data_filter("hesla", $_GET['filter'], $interval);
                        break;
                    case 'nove_korektury':
                        set_data_filter("hesla", "nove_korektury", "");
                        break;
                    case 'xFilter':
                        set_data_filter("hesla", 'xFilter', $_GET['xFilter_id']);
                        break;
                    case 'special':
                        set_data_filter("hesla", 'special', "");
                        break;
                    case 'nevidel_jsem':
                        set_data_filter("hesla", "nevidel_jsem", "");
                        break;
                    case 'multivariant':
                        set_data_filter("hesla", "multivariant", "");
                        break;
                    case 'multivariant3':
                        set_data_filter("hesla", "multivariant3", "");
                        break;
                    case 'odm_kor':
                        set_data_filter("hesla", "odm_kor", "");
                        break;
                    case 'hid_by_jine':
                        unset($_SESSION['search']['query']);
                        set_data_filter("jine_in_hesla", "fiter_vals_arr", array('cis'=>$_GET['cis'], 'jine_val'=>$_GET['val']));
                        break;
                    case 'seznam':
                        set_data_filter("hesla", "seznam", mysql_real_escape_string($_GET['seznam']));
                        break;
                }
            break;
    }

if (isset($_POST['i2u_submit'])){
    if($_SESSION['data_filter']['_dataID'] == 'jine_in_hesla'){
        $att_hesla = get_hesla_by_jine();
    }else{
        $att_hesla = get_hesla();
    }
    $att_users = $_POST['user_check'];
    foreach ($att_users as $u){
        $u = mysql_real_escape_string($u);
        $sid = get_list_for_ext_user($u);
        foreach ($att_hesla as $h){
            dbq('INSERT INTO `hesla_v_seznamu` (`sid`, `hid`) VALUES ('.$sid.', '.mysql_real_escape_string($h).') ON DUPLICATE KEY UPDATE `hid`=`hid`');
        }
    }
}
if(isset($_GET['show_mess']))
{
    if($_GET['show_mess']=='false')
    {
        echo print_mess_popup();
    }
}
$css['screen'][]='js/jQueryUI/css/ui-lightness/jquery-ui-1.11.2.custom.css';
$css['screen'][]='css/heslar.css';
$css['screen'][]='css/semafor.css';
$js[]='js/jquery.js';
$js[]='js/jquery.qtip.js';
$js[]='js/jQueryUI/jquery-ui-1.11.2.custom.min.js';
$js[]='js/common.js';
$js[]='js/heslar.js';
$js[]='js/shortcut.js';
$js[]='js/search.js';

HTML_Header($page_id,'Alexis - heslář', $css, $js);
if(empty($_SESSION['aktivni_heslar']))
{
    $_SESSION['aktivni_heslar']=["1"];
}
$_SESSION['debug_db_num'] = 0;
if(is_err()) echo print_errs();
if (is_role_uzivatel()) echo formular_noveho_hesla();
$forced_entries = isset($_GET['force_entries']) ? explode(',', $_GET['force_entries']) : False;
echo seznam_hesel($forced_entries);
echo print_search_form();
HTML_Footer($page_id);
//var_dump($_SESSION['debug_db_num']);
?>
