var hid = $('#hlavniFormularHesla').data('hid'),
    cdoAjax = 'cls/cdo/cdo_ajax.php',
    cdoContentType = 'application/x-www-form-urlencoded; charset=UTF-8';

function getHid() {
    var hid = $('#hlavniFormularHesla').data('hid');
    return hid ? hid : $('#CDOreload_btn').data('hid');
}

function endsWith(str, suffix) {
    return str.indexOf(suffix, str.length - suffix.length) !== -1;
}

function reorderElements(parentDom, list) {
    var suff = '',
        wrapperDom = parentDom;
    if (parentDom == 'vyznam') {
        wrapperDom = 'vyznamy';
        suff = '--outerWrap';
    }
    var editors = [];
    $.each(list, function (index, item) {
        item += suff;
        $('#' + parentDom + '-' + item).find('.cdoEditor').each(function (index, el) {
            editors.push($(el).attr('id'));
        });
        $.each(editors, function (i, ed) {
            tinyMCE.execCommand('mceRemoveEditor', false, ed);
        });
        $('#' + parentDom + '-' + item).appendTo('#' + wrapperDom);
        $.each(editors, function (i, ed) {
            tinyMCE.execCommand('mceAddEditor', false, ed);
        });
    });
}

function removeEditorsInElement(parentDom) {
    $('#' + parentDom).find('.cdoEditor').each(function (index, el) {
        tinyMCE.get($(el).attr('id')).remove();
    });
}

function zobrazVarovani(el) {
    $('#varovani-wrapper').dialog({
        autoOpen: true,
        modal: true,
        width: 'auto',
        position: {my: 'center', at: 'center'},
        open: function (event, ui) {

        },
        close: function (event, ui) {
            $(this).dialog('destroy');
            $('#varovani-wrapper').html('');
            $(el).focus();
        },
        buttons: {
            'OK': function () {
                $(this).dialog('destroy');
                $('#varovani-wrapper').html('');
                $(el).focus();
            }
        }
    });
}

function varovaniSkup(el, id) {
    var warn_el = el;
    if ($(el).attr('id') && $(el).attr('id').indexOf('vyklad_vyznamu') > -1) {
        warn_el = $('#' + $(el).attr('id') + '---helperIdCpy');
    }
    if ($(warn_el).hasClass('warned')) {
        return false;
    }
    $.ajax({
        url: cdoAjax,
        type: 'post',
        contentType: cdoContentType,
        data: {
            type: 'varovani_skup',
            data: id,
            hid: getHid()
        },
        success: function (data) {
            if (data === 'EMPTY') {
                ;
            } else {
                $('#varovani-wrapper').html(data);
                zobrazVarovani(el);
                console.log('addclass');
                $(warn_el).addClass('warned');
            }
        },
        error: function (jqXHR, textStatus, errorThrown) {
            console.log(textStatus, errorThrown);
        }
    });
}

function reload_cdo() {
    $.ajax({
        url: cdoAjax,
        type: 'post',
        contentType: cdoContentType,
        data: {
            type: 'reload_cdo',
            data: getHid(),
            hid: getHid()
        },
        success: function (data) {
            window.location.reload();
        },
        error: function (jqXHR, textStatus, errorThrown) {
            console.log(textStatus, errorThrown);
        }
    });
}

function save_cdo() {
    $.ajax({
        url: cdoAjax,
        type: 'post',
        contentType: cdoContentType,
        data: {
            type: 'save_cdo',
            data: getHid(),
            hid: getHid()
        },
        success: function (data) {
            $('#testarea').html(data);
            if (data == 'OK') {
                window.location.reload();
            }
        },
        error: function (jqXHR, textStatus, errorThrown) {
            console.log(textStatus, errorThrown);
        }
    });
}

function add_fields(dom) {
    $.ajax({
        url: cdoAjax,
        type: 'post',
        contentType: cdoContentType,
        data: {
            type: 'add_fields',
            domId: dom,
            hid: getHid()
        },
        success: function (data) {
            if (dom == 'vyznam') {
                dom = 'vyznamy';
            } else if (endsWith(dom, 'subvyznamy')) {
                $('#' + dom).find('.nosubvyznam').remove();
            }
            $('#' + dom).append(data);
            CDO_setNeedConfirm();
        },
        error: function (jqXHR, textStatus, errorThrown) {
            console.log(textStatus, errorThrown);
        }
    });
}

function copy_last_var() {
    $.ajax({
        url: cdoAjax,
        type: 'post',
        contentType: cdoContentType,
        data: {
            type: 'copy_last_var',
            hid: getHid()
        },
        success: function (data) {
            $('#varianta').append(data);
            CDO_setNeedConfirm();
        },
        error: function (jqXHR, textStatus, errorThrown) {
            console.log(textStatus, errorThrown);
        }
    });
}

function rm_field(dom, data) {
    if (confirm('Opravdu odebrat?')) {
        $.ajax({
            url: cdoAjax,
            type: 'post',
            contentType: cdoContentType,
            dataType: 'json',
            data: {
                type: 'rm_field',
                domId: dom,
                hid: getHid(),
                data: data
            },
            success: function (data) {
                if (data.status == -1000) {
                    removeEditorsInElement(dom);
                    $('#' + dom).remove();
                    CDO_setNeedConfirm();
                } else {
                    alert(data.message);
                }
            },
            error: function (jqXHR, textStatus, errorThrown) {
                console.log(textStatus, errorThrown);
            }
        });
    }
}

function save_vyber_ciselniku(fid) {
    var data = [], tmp = [], dom = [];
    tmp = fid.split('--');
    $.each(tmp, function (idx, val) {
        dom.push(val.split('-'));
    });
    var texts = [];
    $('#' + fid + '--cisVyber option').each(function (index, el) {
        if (el.value == 'jine') {
            data.push($('#' + fid + '--jine').val());
            texts.push($('#' + fid + '--jine').val());
        } else {
            data.push(el.value);
            texts.push(el.text);
        }
    });
    $('#' + fid + '--valsNum').html(data.length);
    $.ajax({
        url: cdoAjax,
        type: 'post',
        contentType: cdoContentType,
        data: {
            type: 'ciselnik',
            domId: fid,
            hid: getHid(),
            data: data
        },
        success: function (data) {
            $('#' + fid + '--list').html(data);
            CDO_setNeedConfirm();
        },
        error: function (jqXHR, textStatus, errorThrown) {
            console.log(textStatus, errorThrown);
        }
    });
}

function fromArchive(dom) {
    $.ajax({
        url: cdoAjax,
        type: 'post',
        contentType: cdoContentType,
        data: {
            type: 'fromArchive',
            hid: getHid(),
            domId: dom
        },
        success: function (data) {
            console.log(getHid(), dom);
        },
        error: function (jqXHR, textStatus, errorThrown) {
            console.log(textStatus, errorThrown);
        }
    });
}

function fromArchiveFull() {
    $.ajax({
        url: cdoAjax,
        type: 'post',
        contentType: cdoContentType,
        data: {
            type: 'fromArchiveFull',
            hid: getHid(),
            domId: 0
        },
        success: function (data) {
            console.log(getHid(), data);
        },
        error: function (jqXHR, textStatus, errorThrown) {
            console.log(textStatus, errorThrown);
        }
    });
}

function toArchive() {
    var comment = prompt('Ulo�it tuto verzi hesla do archivu?\r\nP�idejte koment�� k verzi.');
    if (comment != null) {
        console.log('archi');
        $('*').css('cursor', 'wait');
        $('body').append('<div id="overlay"></div>');
        $.ajax({
            url: cdoAjax,
            type: 'post',
            contentType: cdoContentType,
            dataType: 'json',
            data: {
                type: 'toArchive',
                hid: getHid(),
                data: comment
            },
            success: function (data) {
                console.log(data);
                alert(data.status);
                $('*').css('cursor', '');
                $('#overlay').remove();
            },
            error: function (jqXHR, textStatus, errorThrown) {
                console.log(textStatus, errorThrown);
            }
        });
    }
}

function CDO_setNeedConfirm() {
    console.log('Nastaveno setNeedConfirm');
    $('#hlavniFormularHesla').data('needConfirm', 1);
}

function CDO_unsetNeedConfirm() {
    $('#hlavniFormularHesla').data('needConfirm', 0);
}

function save_input(el, dom) {
    if (dom === undefined) {
        return false;
    }
    if (el === false) {
        el = $('#' + dom);
    }
    if ($(el).attr('name') == 'stav' && $(el).hasClass('corrected')) {
        return false;
    }
    var data;
    if ($(el).hasClass('cdoEditor')) {
        data = tinyMCE.get($(el).attr('id')).getContent();
    } else if ($(el).attr('type') == 'text' || $(el).attr('type') == 'radio' || $(el).is('textarea') || $(el).attr('type') == 'hidden') {
        data = $(el).val();
    } else if ($(el).attr('type') == 'checkbox') {
        data = $(el).is(':checked') ? 1 : 0;
    } else if ($(el).data('type') == 'img') {
        data = $(el).data('val');
    }
    $.ajax({
        url: cdoAjax,
        type: 'post',
        contentType: cdoContentType,
        //dataType: 'json',
        data: {
            type: 'input',
            hid: getHid(),
            domId: dom,
            data: data
        },
        success: function (data) {
            if (endsWith(dom, '_link')) {
                var wrapper = dom.replace('_link', '--wrapper');
                if (data && $('#' + wrapper).length > 0) {
                    $('#' + wrapper).html(data);
                }
            }
            //CDO_setNeedConfirm();
        },
        error: function (jqXHR, textStatus, errorThrown) {
            console.log(textStatus, errorThrown);
        }
    });
}

function save_extpozn(dom, pozn, typ) {
    $.ajax({
        url: cdoAjax,
        type: 'post',
        contentType: cdoContentType,
        data: {
            type: 'extpozn',
            hid: getHid(),
            domId: dom,
            data: {pozn: pozn, typ: typ}
        },
        success: function (typText) {
            $('#' + dom + '--textDisp').html(pozn);
            if (!typText) {
                typText = '&nbsp;';
            }
            $('#' + dom + '--typeDisp').html(typText);
            CDO_setNeedConfirm();
        },
        error: function (jqXHR, textStatus, errorThrown) {
            console.log(textStatus, errorThrown);
        }
    });
}

function show_heslo_copy_form() {
    $.ajax({
        url: cdoAjax,
        type: 'post',
        contentType: cdoContentType,
        data: {
            type: 'heslo_copy_form',
            hid: getHid()
        },
        success: function (data) {
            $('#kopieHesla_popUp')
                .html(data)
                .dialog({
                    autoOpen: true,
                    modal: true,
                    width: 'auto',
                    position: {my: 'center', at: 'center'},
                    open: function (event, ui) {

                    },
                    close: function (event, ui) {
                        $('#kopieHesla_popUp').html('');
                        $(this).dialog('destroy');
                    },
                    buttons: {
                        'OK': function () {
                            $('#kopieHesla_form').submit();
                        }
                    }
                });
        },
        error: function (jqXHR, textStatus, errorThrown) {
            console.log(textStatus, errorThrown);
        }
    });
}

function check_sem_req(dom, el) {
    var checks = {}, type;
    $('.heslo_semafor_chbox').each(function (index, el) {
        checks[$(el).data('code')] = $(el).is(':checked') ? 1 : 0;
    });
    if ($('body').attr('id') == 'tisk_page') {
        type = 'check_semafor_tisk';
        hid = dom.split('-')[1];
    } else {
        hid = getHid();
        type = 'check_semafor';
    }
    $.ajax({
        url: cdoAjax,
        type: 'post',
        contentType: cdoContentType,
        dataType: 'json',
        data: {
            type: type,
            hid: hid,
            domId: dom,
            data: {
                stav: $('#semafor_stav_input').val(),
                checks: checks
            }
        },
        success: function (data) {
            if (data.chhidden) {
                $('.heslo_semafor_chb').addClass('hidden');
            } else {
                $('.heslo_semafor_chb').removeClass('hidden');
            }
            if (data.chdisabled) {
                $('.heslo_semafor_chbox').prop('disabled', true);
            } else {
                $('.heslo_semafor_chbox').prop('disabled', false);
            }
            if (data.webhidden) {
                $('.heslo_semafor_chb_web').addClass('hidden');
                $('.heslo_semafor_chbox_web').prop('checked', false);
            } else {
                $('.heslo_semafor_chb_web').removeClass('hidden');
            }
            if (data.webchecked) {
                $('.heslo_semafor_chbox_web').prop('checked', true).prop('disabled', true);
            } else {
                $('.heslo_semafor_chbox_web').prop('disabled', false);
            }
            $.each(data.stavy, function (index, val) {
                if (val) {
                    $('.heslo_semafor_edit.heslo_semafor_' + index).removeClass('disabled');
                } else {
                    $('.heslo_semafor_edit.heslo_semafor_' + index).addClass('disabled');
                }
            });
        }
    });
}

function save_semafor(dom) {
    var checks = {}, type, hid;
    $('.heslo_semafor_chbox,.heslo_semafor_chbox_web').each(function (index, el) {
        checks[$(el).data('code')] = $(el).is(':checked') ? 1 : 0;
    });
    if ($('body').attr('id') == 'tisk_page') {
        type = 'update_semafor_tisk';
        hid = dom.split('-')[1];
    } else {
        hid = getHid();
        type = 'update_semafor';
    }
    $.ajax({
        url: cdoAjax,
        type: 'post',
        contentType: cdoContentType,
        data: {
            type: type,
            hid: hid,
            domId: dom,
            data: {
                stav: $('#semafor_stav_input').val(),
                checks: checks
            }
        },
        success: function (data) {
            $('#semafor_wrapper_' + hid).html(data);
        }
    });
}

function show_semafor_editor(dom, el) {
    if ($(el).hasClass('is_corrected')) {
        alert('Pole obsahuje korekturu! Pro editace pole, prosím, vraťte korekturu korektorovi, nebo ji aplikujte.');
        return false;
    }
    var popupDom = dom + '_popUp', hid, type;
    if ($('body').attr('id') == 'tisk_page') {
        type = 'editor_semafor_tisk';
        hid = dom.split('-')[1];
    } else {
        hid = getHid();
        type = 'editor_semafor';
    }
    $.ajax({
        url: cdoAjax,
        type: 'post',
        contentType: cdoContentType,
        data: {
            type: type,
            hid: hid,
            domId: dom
        },
        success: function (data) {
            $('#' + popupDom)
                .html(data)
                .dialog({
                    autoOpen: true,
                    modal: true,
                    width: 'auto',
                    position: {my: 'center', at: 'center'},
                    open: function (event, ui) {

                    },
                    close: function (event, ui) {
                        $('#' + popupDom).html('');
                        $(this).dialog('destroy');
                    },
                    buttons: {
                        'OK': function () {
                            save_semafor(dom);
                            $(this).dialog('destroy');
                        }
                    }
                });
        },
        error: function (jqXHR, textStatus, errorThrown) {
            console.log(textStatus, errorThrown);
        }
    });
}

function show_editor_ciselniku(dom, el, archive) {
    if ($(el).hasClass('is_corrected')) {
        alert('Pole obsahuje korekturu! Pro editace pole, prosím, vraťte korekturu korektorovi, nebo ji aplikujte.');
        return false;
    }
    var popupDom = dom + '_popUp';
    $.ajax({
        url: cdoAjax,
        type: 'post',
        contentType: cdoContentType,
        data: {
            type: 'editor_ciselniku',
            hid: getHid(),
            domId: dom
        },
        success: function (data) {
            $('#' + popupDom)
                .html(data)
                .dialog({
                    autoOpen: true,
                    modal: true,
                    width: 'auto',
                    position: {my: 'center', at: 'center'},
                    open: function (event, ui) {

                    },
                    close: function (event, ui) {
                        $('#' + popupDom).html('');
                        $(this).dialog('destroy');
                    },
                    buttons: {
                        'OK': function () {
                            if (!archive) {
                                save_vyber_ciselniku(dom);
                            }
                            $(this).dialog('destroy');
                        }
                    }
                });
        },
        error: function (jqXHR, textStatus, errorThrown) {
            console.log(textStatus, errorThrown);
        }
    });
}

function show_editor_extPozn(dom, el) {
    if ($(el).hasClass('is_corrected')) {
        alert('Pole obsahuje korekturu! Pro editace pole, prosím, vraťte korekturu korektorovi, nebo ji aplikujte.');
        return false;
    }
    var popupDom = dom + '_popUp';
    $.ajax({
        url: cdoAjax,
        type: 'post',
        contentType: cdoContentType,
        data: {
            type: 'editor_extpozn',
            hid: getHid(),
            domId: dom
        },
        success: function (data) {
            $('#' + popupDom)
                .html(data)
                .dialog({
                    autoOpen: true,
                    modal: true,
                    width: 'auto',
                    position: {my: 'center', at: 'center'},
                    open: function (event, ui) {
                    },
                    close: function (event, ui) {
                        tinyMCE.get(dom + '--text').remove();
                        $('#' + popupDom).html('');
                        $(this).dialog('destroy');
                    },
                    focus: function (event, ui) {
                        CDO_initTinyMCE('#' + dom + '--text');
                    },
                    buttons: {
                        'OK': function () {
                            var pozn = tinyMCE.get(dom + '--text').getContent(),
                                typ = $('#' + dom + '--type').val();
                            save_extpozn(dom, pozn, typ);
                            $(this).dialog('destroy');
                        }
                    }
                });
        },
        error: function (jqXHR, textStatus, errorThrown) {
            console.log(textStatus, errorThrown);
        }
    });
}

function moveItem(dom, id, dir) {
    $.ajax({
        url: cdoAjax,
        type: 'post',
        contentType: cdoContentType,
        dataType: 'json',
        data: {
            type: 'order_move_' + dir,
            hid: getHid(),
            domId: dom,
            data: id
        },
        success: function (ordered) {
            if (ordered.status == -1000) {
                reorderElements(dom, ordered.data);
            }
        },
        error: function (jqXHR, textStatus, errorThrown) {
            console.log(textStatus, errorThrown);
        }
    });
}

function save_order(dom, ordered) {
    $.ajax({
        url: cdoAjax,
        type: 'post',
        contentType: cdoContentType,
        data: {
            type: 'save_order',
            hid: getHid(),
            domId: dom,
            data: ordered
        },
        success: function (data) {
            reorderElements(dom, ordered);
            CDO_setNeedConfirm();
        },
        error: function (jqXHR, textStatus, errorThrown) {
            console.log(textStatus, errorThrown);
        }
    });
}

function show_order_editor(dom) {
    var popupDom = dom + '_orderPopUp',
        selectDom = dom + '--orderer';
    $.ajax({
        url: cdoAjax,
        type: 'post',
        contentType: cdoContentType,
        data: {
            type: 'editor_poradi',
            hid: getHid(),
            domId: dom
        },
        success: function (data) {
            $('#' + popupDom)
                .html(data)
                .dialog({
                    autoOpen: true,
                    modal: true,
                    width: 'auto',
                    position: {my: 'center', at: 'center'},
                    open: function (event, ui) {

                    },
                    close: function (event, ui) {
                        $('#' + popupDom).html('');
                        $(this).dialog('destroy');
                    },
                    buttons: {
                        'OK': function () {
                            var ordered = [];
                            $('#' + selectDom + ' > option').each(function (index, el) {
                                ordered.push($(el).val());
                            });
                            save_order(dom, ordered);
                            $('#' + popupDom).html('');
                            $(this).dialog('destroy');
                        }
                    }
                });
        },
        error: function (jqXHR, textStatus, errorThrown) {
            console.log(textStatus, errorThrown);
        }
    });
}

// Skupinky
function pridat_do_skupiny_dlg(id) {

    $.ajax({
        url: cdoAjax,
        type: 'post',
        contentType: cdoContentType,
        data: {
            type: 'skupina_dlg',
            hid: getHid(),
            domId: id
        },
        success: function (data) {
            $('#vyznam-' + id + '--skupinaPopUp').html(data);
            selectize(id, '#select-vyklad-' + id);
            $('#vyznam-' + id + '--skupinaPopUp').children('.popUp').dialog({
                autoOpen: true,
                modal: true,
                width: 'auto',
                position: {my: 'center', at: 'center'},
                open: function (event, ui) {

                },
                close: function (event, ui) {
                    $('#vyznam-' + id + '--skupinaPopUp').html('');
                    $(this).dialog('destroy');
                },
                buttons: {
                    'OK': function () {
                        var v = $('#select-vyklad-' + id).val();
                        $.ajax({
                            url: cdoAjax,
                            type: 'post',
                            contentType: cdoContentType,
                            data: {
                                type: 'skupina',
                                hid: getHid(),
                                domId: id,
                                data: v
                            },
                            success: function (data) {
                                if (data) {
                                    tinyMCE.execCommand('mceRemoveEditor', true, 'vyznam-' + id + '--vyklad_vyznamu');
                                    $('#vyznam-' + id + '--skupina_blok').html(data);
                                }
                            },
                            error: function (jqXHR, textStatus, errorThrown) {
                                console.log(textStatus, errorThrown);
                            }
                        });
                        $('#vyznam-' + id + '--skupinaPopUp').html('');
                        $(this).dialog('destroy');
                    }
                }
            });
        },
        error: function (jqXHR, textStatus, errorThrown) {
            console.log(textStatus, errorThrown);
        }
    });
}

function odebrat_ze_skupiny(id) {
    if (confirm('Opravdu odebrat ze skupiny?')) {
        $.ajax({
            url: cdoAjax,
            type: 'post',
            contentType: cdoContentType,
            data: {
                type: 'skupina_odebrat',
                hid: getHid(),
                domId: id
            },
            success: function (data) {
                tinyMCE.execCommand('mceRemoveEditor', true, 'vyznam-' + id + '--vyklad_vyznamu_master');
                $('#vyznam-' + id + '--skupina_blok').html(data);
                CDO_setNeedConfirm();
            },
            error: function (jqXHR, textStatus, errorThrown) {
                console.log(textStatus, errorThrown);
            }
        });
    }
}

function print_odkazy(h_id, type) {
    $.ajax({
        url: 'formular_hesla_ajax.php',
        type: 'post',
        contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
        data: {
            act: type,
            hid: h_id
        },
        success: function (data) {
            if (type == 'odkaz_s') {
                $('#main_odkazy').html(data);
            }
            else if (type == 'odkazy') {
                $('#slave_odkazy').html(data);
            }
        },
        error: function (jqXHR, textStatus, errorThrown) {
            console.log(textStatus, errorThrown);
        }
    });
}

//////// LINKOVANI, PRIHNIZDOVAVANI A PRIPOJOVANI
function confirm_link_dialog_cdo(domid, dialog) {
    var order = 1;
    var parts = domid.split('-');
    var typ = parts[parts.length - 1];
    if (typ == 'synonyma_main' || typ == 'antonyma_main' || typ == 'synonyma_slave' || typ == 'antonyma_slave') {
        var data = {}, data_row = {}, tmp, tmp_place_id, tmp_place_id2;
        if (typ == 'synonyma_slave' || typ == 'antonyma_slave') //syn/ant z druhé strany
        {
            $(dialog).find('.multiInput.hidRel').each(function (index, el) {
                if ($(el)[0].style.display != "none") {
                    tmp = $(this).attr('id').split('--');
                    data_row.id = tmp[3].split('-')[1];
                    data_row.main_str = $(el).find('[name*=main_str]').val();
                    data_row.main_hid = $(el).find('[name*=main_hid]').val();
                    data_row.slave_hid = tmp[2];
                    data_row.slave_str = "";
                    data_row.sortorder2 = order;
                    data_row.komentar = $(el).find('[name*=slave_kom]').val();
                    data_row.poznamka = "";
                    tmp_place_id = $(el).find('[name*=hidRel_place]').val().split(',')[1];
                    data_row.main_places = {};
                    if (typeof tmp_place_id == 'undefined') {
                        tmp_place_id = "new" + Math.floor((Math.random() * 10000) + 1);
                    }
                    data_row.main_places[tmp_place_id] = {};
                    data_row.main_places[tmp_place_id].id = tmp_place_id;
                    data_row.main_places[tmp_place_id].place = $(el).find('[name*=hidRel_place]').val().split(',')[0].split('-')[0];
                    data_row.main_places[tmp_place_id].place_id = $(el).find('[name*=hidRel_place]').val().split(',')[0].split('-')[1];
                    tmp_place_id2 = $(el).find('[name*=hidRel_slave_place]').val().split(',')[1];
                    data_row.slave_places = {};
                    if (typeof tmp_place_id2 == 'undefined') {
                        tmp_place_id2 = "new" + Math.floor((Math.random() * 10000) + 1);
                        data_row.slave_places[tmp_place_id2] = {};
                        data_row.slave_places[tmp_place_id2].id = tmp_place_id2;
                        data_row.slave_places[tmp_place_id2].place = tmp[0].split('-')[0];
                        data_row.slave_places[tmp_place_id2].place_id = tmp[0].split('-')[1];
                    }
                    else {
                        data_row.slave_places[tmp_place_id2] = {};
                        data_row.slave_places[tmp_place_id2].id = tmp_place_id2;
                        data_row.slave_places[tmp_place_id2].place = $(el).find('[name*=hidRel_slave_place]').val().split(',')[0].split('-')[0];
                        data_row.slave_places[tmp_place_id2].place_id = $(el).find('[name*=hidRel_slave_place]').val().split(',')[0].split('-')[1];
                    }

                    data_row.rel_type = $(el).find('[name*=rel_type]:checked').val();
                    order++;
                    if ((data_row.main_hid != 0 || (data_row.main_str) != "")) {
                        data[data_row.id] = data_row;
                    }
                    data_row = {};
                }
            });
        }
        else  //synonymum / antonymum
        {
            if ($(dialog).find('.multiInput.hidRel').length > 0) {
                $(dialog).find('.multiInput.hidRel').each(function (index, el) {
                    tmp = $(this).attr('id').split('--');
                    data_row.id = tmp[3].split('-')[1];
                    data_row.main_str = "";
                    data_row.main_hid = tmp[2];
                    data_row.slave_str = $(el).find('[name*=slave_str]').val();
                    data_row.slave_hid = $(el).find('[name*=slave_hid]').val();
                    data_row.sortorder = order;
                    data_row.komentar = $(el).find('[name*=slave_kom]').val();
                    data_row.poznamka = "";
                    tmp_place_id = $(el).find('[name*=hidRel_place]').val().split(',')[1];
                    data_row.main_places = {};
                    if (typeof tmp_place_id == 'undefined') {
                        tmp_place_id = "new" + Math.floor((Math.random() * 10000) + 1);
                        data_row.main_places[tmp_place_id] = {};
                        data_row.main_places[tmp_place_id].id = tmp_place_id;
                        data_row.main_places[tmp_place_id].place = tmp[1].split('-')[1];
                        data_row.main_places[tmp_place_id].place_id = tmp[0].split('-')[1];
                    }
                    else {
                        data_row.main_places[tmp_place_id] = {};
                        data_row.main_places[tmp_place_id].id = tmp_place_id;
                        data_row.main_places[tmp_place_id].place = $(el).find('[name*=hidRel_place]').val().split(',')[0].split('-')[0];
                        data_row.main_places[tmp_place_id].place_id = $(el).find('[name*=hidRel_place]').val().split(',')[0].split('-')[1];
                    }
                    var hrpval = $(el).find('[name*=hidRel_slave_place]').val();
                    tmp_place_id = hrpval.split(',')[1];
                    var placeIdent = hrpval.split(',')[0].split('-');
                    if (placeIdent[0] == 'heslo') {
                        placeIdent[1] = data_row.slave_hid;
                    }
                    data_row.slave_places = {};
                    if (typeof tmp_place_id == 'undefined') tmp_place_id = "new" + Math.floor((Math.random() * 10000) + 1);
                    data_row.slave_places[tmp_place_id] = {};
                    data_row.slave_places[tmp_place_id].id = tmp_place_id;
                    data_row.slave_places[tmp_place_id].place = placeIdent[0];
                    data_row.slave_places[tmp_place_id].place_id = placeIdent[1];
                    data_row.rel_type = $(el).find('[name*=rel_type]:checked').val();
                    order++;
                    if ((data_row.slave_hid != 0 || (data_row.slave_str) != "")) {
                        data[data_row.id] = data_row;
                    }
                    data_row = {};
                });
            }
        }
        save_links_cdo(domid, data, typ);
        $(dialog).dialog('close');
        return false;
    }
    else if (typ == 'propojeni_s') {
        var data = {}, data_row = {}, tmp;
        $(dialog).find('.multiInput.hidRel').each(function (index, el) {
            if ($(el)[0].style.display != "none") {
                data_row.id = $(this).attr('id').split('-')[3];
                data_row.main_str = $(el).find('[name*=main_str]').val();
                data_row.main_hid = $(el).find('[name*=main_hid]').val();
                data_row.slave_str = "";
                data_row.slave_hid = $(el).find('[name*=slave_hid]').val();
                data_row.sortorder2 = order;
                data_row.komentar = $(el).find('[name*=slave_kom]').val();
                data_row.poznamka = "";

                tmp = $(this).attr('id').split('--');
                tmp_place_id = $(el).find('[name*=hidRel_place]').val().split(',')[1];
                data_row.main_places = {};
                if (typeof tmp_place_id == 'undefined') {
                    tmp_place_id = "new" + Math.floor((Math.random() * 10000) + 1);
                }
                data_row.main_places[tmp_place_id] = {};
                data_row.main_places[tmp_place_id].id = tmp_place_id;
                data_row.main_places[tmp_place_id].place = $(el).find('[name*=hidRel_place]').val().split(',')[0].split('-')[0];
                data_row.main_places[tmp_place_id].place_id = $(el).find('[name*=hidRel_place]').val().split(',')[0].split('-')[1];
                tmp_place_id = $(el).find('[name*=hidRel_slave_place]').val().split(',')[1];
                data_row.slave_places = {};
                if (typeof tmp_place_id == 'undefined') {
                    tmp_place_id = "new" + Math.floor((Math.random() * 10000) + 1);
                    data_row.slave_places[tmp_place_id] = {};
                    data_row.slave_places[tmp_place_id].id = tmp_place_id;
                    data_row.slave_places[tmp_place_id].place = "heslo";
                    data_row.slave_places[tmp_place_id].place_id = data_row.slave_hid;
                }
                else {
                    data_row.slave_places[tmp_place_id] = {};
                    data_row.slave_places[tmp_place_id].id = tmp_place_id;
                    data_row.slave_places[tmp_place_id].place = $(el).find('[name*=hidRel_slave_place]').val().split(',')[0].split('-')[0];
                    data_row.slave_places[tmp_place_id].place_id = $(el).find('[name*=hidRel_slave_place]').val().split(',')[0].split('-')[1];
                }
                data_row.rel_type = $(el).find('[name*=rel_type]:checked').val();
                order++;
                if ((data_row.slave_hid != 0 || (data_row.slave_str) != "")) {
                    data[data_row.id] = data_row;
                }
                data_row = {};
            }
        });
        save_links_cdo(domid, data, typ);
        $(dialog).dialog('close');
        return false;
    }
    else if (typ == 'propojeni') {
        var data = {}, data_row = {}, tmp;
        $(dialog).find('.multiInput.hidRel').each(function (index, el) {
            if ($(el)[0].style.display != "none") {
                data_row.id = $(this).attr('id').split('-')[6];
                data_row.main_str = "";
                data_row.main_hid = $(el).find('[name*=main_hid]').val();
                data_row.slave_str = $(el).find('[name*=slave_str]').val();
                data_row.slave_hid = $(el).find('[name*=slave_hid]').val();
                data_row.sortorder = order;
                data_row.komentar = "";
                data_row.poznamka = "";
                tmp = $(el).find('[name*=hidRel_place]').val().split(',')[0].split('-');
                tmp_place_id = $(el).find('[name*=hidRel_place]').val().split(',')[1];
                data_row.main_places = {};
                if (typeof tmp_place_id == 'undefined') {
                    tmp_place_id = "new" + Math.floor((Math.random() * 10000) + 1);
                }
                data_row.main_places[tmp_place_id] = {};
                data_row.main_places[tmp_place_id].id = tmp_place_id;
                data_row.main_places[tmp_place_id].place = tmp[0];
                data_row.main_places[tmp_place_id].place_id = tmp[1];
                tmp_place_id = $(el).find('[name*=hidRel_slave_place]').val().split(',')[1];
                data_row.slave_places = {};
                if (typeof tmp_place_id == 'undefined') {
                    tmp_place_id = "new" + Math.floor((Math.random() * 10000) + 1);
                    data_row.slave_places[tmp_place_id] = {};
                    data_row.slave_places[tmp_place_id].id = tmp_place_id;
                    data_row.slave_places[tmp_place_id].place = "heslo";
                    data_row.slave_places[tmp_place_id].place_id = data_row.slave_hid;
                }
                else {
                    data_row.slave_places[tmp_place_id] = {};
                    data_row.slave_places[tmp_place_id].id = tmp_place_id;
                    data_row.slave_places[tmp_place_id].place = $(el).find('[name*=hidRel_slave_place]').val().split(',')[0].split('-')[0];
                    data_row.slave_places[tmp_place_id].place_id = $(el).find('[name*=hidRel_slave_place]').val().split(',')[0].split('-')[1];
                }
                data_row.rel_type = $(el).find('[name*=rel_type]:checked').val();
                order++;
                if ((data_row.slave_hid != 0 || (data_row.slave_str) != "")) {
                    data[data_row.id] = data_row;
                }
                data_row = {};
            }
        });
        save_links_cdo(domid, data, typ);
        $(dialog).dialog('close');
        return false;
    }
    else if (typ == 'odk_slave') {
        var data = {}, data_row = {}, place_row = {}, tmp;
        $(dialog).find('.multiInput.hidRel').each(function (index, el) {
            if ($(el)[0].style.display != "none") {
                data_row.id = $(this).attr('id').split('-')[5];
                data_row.main_str = $(el).find('[name*=main_str]').val();
                data_row.main_hid = $(el).find('[name*=main_hid]').val();
                data_row.slave_str = "";
                data_row.slave_hid = $(el).find('[name*=slave_hid]').val();
                data_row.link_types = {};
                tmp = $(el).find('[name*=link_type]').val().split(',');
                if (tmp[0] == 0) {
                    tmp[0] = 'jine';
                }
                data_row.link_types[tmp[0]] = {};
                data_row.link_types[tmp[0]]['id'] = tmp[0];
                data_row.link_types[tmp[0]]['link_type_id'] = tmp[0];
                data_row.link_types[tmp[0]]['link_type'] = $(el).find('[name*=link_type]')[0].selectedOptions[0].innerHTML;
                data_row.link_types[tmp[0]]['jine_text'] = $(el).find('.jineText').val();
                data_row.spojeno = $(el).find('[name*=link_to_rel]').val();
                data_row.sortorder2 = order;
                data_row.komentar = "";
                data_row.poznamka = $(el).find('[name*=note]').val();
                data_row.main_places = {};
                $(el).find('[name*=hidRel_place]').val().forEach(function (el, index, array) {
                    tmp_place_id = el.split(',')[1];
                    tmp = el.split(',')[0].split('-');
                    if (typeof tmp_place_id == 'undefined') {
                        tmp_place_id = "new" + Math.floor((Math.random() * 10000) + 1);
                    }
                    data_row.main_places[tmp_place_id] = {};
                    data_row.main_places[tmp_place_id].id = tmp_place_id;
                    data_row.main_places[tmp_place_id].place = tmp[0];
                    data_row.main_places[tmp_place_id].place_id = tmp[1];
                });
                data_row.slave_places = {};
                $(el).find('[name*=hidRel_slave_place]').val().forEach(function (el, index, array) {
                    tmp_place_id = el.split(',')[1];
                    if (typeof tmp_place_id == 'undefined') {
                        tmp_place_id = "new" + Math.floor((Math.random() * 10000) + 1);
                    }
                    data_row.slave_places[tmp_place_id] = {};
                    data_row.slave_places[tmp_place_id].id = tmp_place_id;
                    data_row.slave_places[tmp_place_id].place = el.split(',')[0].split('-')[0];
                    data_row.slave_places[tmp_place_id].place_id = el.split(',')[0].split('-')[1];
                });
                data_row.rel_type = 1;
                order++;
                if ((data_row.slave_hid != 0 || (data_row.slave_str) != "")) {
                    data[data_row.id] = data_row;
                }
                data_row = {};
            }
        });
        save_links_cdo(domid, data, typ);
        $(dialog).dialog('close');
        return false;
    }
    else if (typ == 'odk_main') {
        var data = {}, data_row = {}, place_row = {}, tmp;
        $(dialog).find('.multiInput.hidRel').each(function (index, el) {
            if ($(el)[0].style.display != "none") {
                data_row.slave_hid = $(el).find('[name*=slave_hid]').val();
                data_row.id = $(this).attr('id').split('-')[5];
                data_row.slave_str = $(el).find('[name*=slave_str]').val();
                data_row.main_hid = $(el).find('[name*=main_hid]').val();
                data_row.poznamka = $(el).find('[name*=note]').val();
                data_row.link_types = {};
                tmp = $(el).find('[name*=link_type]').val().split(',');
                if (tmp[0] == 0) {
                    tmp[0] = 'jine';
                }
                data_row.link_types[tmp[0]] = {};
                data_row.link_types[tmp[0]]['id'] = tmp[0];
                data_row.link_types[tmp[0]]['link_type_id'] = tmp[0];
                data_row.link_types[tmp[0]]['link_type'] = $(el).find('[name*=link_type]')[0].selectedOptions[0].innerHTML;
                data_row.link_types[tmp[0]]['jine_text'] = $(el).find('.jineText').val();
                data_row.spojeno = $(el).find('[name*=link_to_rel]').val();
                if ($(el).find('[name*=link_to_rel]').val() != "") {
                    data_row.link_to_rel = $(el).find('[name*=link_to_rel]').val();
                }
                if (data_row.link_type == 0) {
                    data_row.link_jine_text = $(el).find('[name*=slave_jine_str]').val();
                }
                data_row.main_places = {};
                $(el).find('[name*=hidRel_place]').val().forEach(function (el, index, array) {
                    tmp_place_id = el.split(',')[1];
                    tmp = el.split(',')[0].split('-');
                    if (typeof tmp_place_id == 'undefined') {
                        tmp_place_id = "new" + Math.floor((Math.random() * 10000) + 1);
                    }
                    data_row.main_places[tmp_place_id] = {};
                    data_row.main_places[tmp_place_id].id = tmp_place_id;
                    data_row.main_places[tmp_place_id].place = tmp[0];
                    data_row.main_places[tmp_place_id].place_id = tmp[1];
                });
                data_row.slave_places = {};
                $(el).find('[name*=hidRel_slave_place]').val().forEach(function (el, index, array) {
                    tmp_place_id = el.split(',')[1];
                    if (typeof tmp_place_id == 'undefined') {
                        tmp_place_id = "new" + Math.floor((Math.random() * 10000) + 1);
                    }
                    data_row.slave_places[tmp_place_id] = {};
                    data_row.slave_places[tmp_place_id].id = tmp_place_id;
                    data_row.slave_places[tmp_place_id].place = el.split(',')[0].split('-')[0];
                    data_row.slave_places[tmp_place_id].place_id = el.split(',')[0].split('-')[1];
                });
                data_row.rel_type = 1;
                data_row.sortorder = order;
                order++;
                data[data_row.id] = data_row;
                data_row = {};
            }
        });
        save_links_cdo(domid, data, typ);
        $(dialog).dialog('close');
        return false;
    } else {
        $(dialog).dialog('close');
        return false;
    }
}

function save_links_cdo(domid, indata, type) {
    $.ajax({
        url: cdoAjax,
        type: 'post',
        contentType: cdoContentType,
        data: {
            type: "link",
            hid: getHid(),
            domId: domid,
            data: indata
        },
        success: function (data) {
            var parsed = domid.split('-');
            var vid = parsed[1];
            if (type == 'odk_main') {
                $('#main_odkazy').html(data);
                $.ajax({
                    url: cdoAjax,
                    type: 'post',
                    contentType: cdoContentType,
                    data: {
                        type: "refreshlink",
                        hid: getHid(),
                        domId: domid.substring(0, domid.indexOf("--odk_main")) + "--odk_slave",
                    },
                    success: function (data2) {
                        $('#slave_odkazy').html(data2);
                    }
                });
            }
            else if (type == 'propojeni_s') {
                $('#slave_pripojeni').html(data);
            }
            else if (type == 'odk_slave') {
                $('#slave_odkazy').html(data);
                $.ajax({
                    url: cdoAjax,
                    type: 'post',
                    contentType: cdoContentType,
                    data: {
                        type: "refreshlink",
                        hid: getHid(),
                        domId: domid.substring(0, domid.indexOf("--odk_slave")) + "--odk_main",
                    },
                    success: function (data2) {
                        $('#main_odkazy').html(data2);
                    }
                });
            }
            else if (type == 'propojeni') {
                if (parsed.length > 4) {
                    $('#' + parsed[0] + '-' + parsed[1] + '--' + parsed[3] + '-' + parsed[4] + '-propojeni_wrapper').html(data);
                }
                else {
                    $('#' + parsed[0] + '-' + parsed[1] + '-propojeni_wrapper').html(data);
                }
            }
            else if (type == 'synonyma_main') {
                $('#vyznam-' + vid + '-syn_wrapper').html(data);
            }
            else if (type == 'antonyma_main') {
                $('#vyznam-' + vid + '-ant_wrapper').html(data);
            }
            else if (type == 'synonyma_slave') {
                $('#' + parsed[0] + '-' + vid + '-s_syn_wrapper').html(data);
            }
            else if (type == 'antonyma_slave') {
                $('#' + parsed[0] + '-' + vid + '-s_ant_wrapper').html(data);
            }
            CDO_setNeedConfirm();
        },
        error: function (jqXHR, textStatus, errorThrown) {
            console.log(textStatus, errorThrown);
        }
    });
}

function save_links(indata) {
    $.ajax({
        url: 'save_ajax.php',
        type: 'post',
        contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
        data: {
            group: indata.type,
            data: indata
        },
        success: function (data) {
            if (indata.type == 'pripojeni') {
                $('#pripojeni-' + indata.main_place + '-' + indata.main_place_id + '-wrapper').html(data);
            }
            else if (indata.type == 'odkaz_m') {
                $('#main_odkazy').html(data);
            }
            else if (indata.type == 'propojeni_s') {
                $('#slave_pripojeni').html(data);
            }
            else if (indata.type == 'odkaz_s') {
                $('#slave_odkazy').html(data);
                print_odkazy(indata.parid, indata.type);
            }
            else if (indata.type == 'odkazy') {
                $('#main_odkazy').html(data);
                print_odkazy(indata.parid, indata.type);
            }
            else if (indata.type == 'synonymum') {
                $('#vyznam-' + indata.vyz_id + '-syn_wrapper').html(data);
            }
            else if (indata.type == 'antonymum') {
                $('#vyznam-' + indata.vyz_id + '-ant_wrapper').html(data);
            }
            else if (indata.type == 'ant_syn_slave') {
                if (indata.vyz_id === '0') {
                    $('#heslo_ant_syn_wrapper').html(data);
                }
                else {
                    $('#vyznam-' + indata.vyz_id + '-antsyn_slave_wrapper').html(data);
                }
            }
        },
        error: function (jqXHR, textStatus, errorThrown) {
            console.log(textStatus, errorThrown);
        }
    });
}

function CDO_showVyznamLinkPopUp(vyz, link_id) {
    $('#vyznamlinkPopUp').dialog({
        autoOpen: true,
        modal: true,
        width: 'auto',
        close: function (event, ui) {
            $('#vyznamlinkPopUp').html('');
            $(this).dialog('destroy');
        },
        focus: function (event, ui) {
            var dialogIndex = parseInt($(this).parent().css("z-index"), 10);
            console.log(dialogIndex);
            $(this).find(".ui-autocomplete-input").each(function (i, obj) {
                $(obj).autocomplete("widget").css("z-index", dialogIndex + 1);
            });
        },
        buttons: {
            "OK": function () {
                var l = $('.ozs_select_opt:selected').length,
                    heslo = $.trim($('.ac_vyznam_text').val()),
                    nhid = parseInt($('.ac_vyznam_text').attr('hid'), 10),
                    tvyz = -1,
                    dlg = this;
                if (l == 1) {
                    tvyz = $('.ozs_select_opt:selected').val();
                } else if (l == 0 && heslo != '') {

                } else {
                    alert('Neplatné zadání.');
                    return false;
                }
                $.ajax({
                    url: cdoAjax,
                    type: 'post',
                    contentType: cdoContentType,
                    dataType: 'json',
                    data: {
                        type: 'save_vyznam_link',
                        hid: getHid(),
                        vyznam: vyz,
                        target_vyznam: tvyz,
                        target_hid: nhid,
                        target_heslo: heslo,
                        link: link_id
                    },
                    success: function (data) {
                        //$('#testarea').html(data);
                        var el;
                        if (data.type == 'new') {
                            tinymce.activeEditor.formatter.apply('linked_format');
                            el = tinymce.activeEditor.dom.get('new_vyznam_link');
                        } else if (data.type == 'edit') {
                            el = tinymce.activeEditor.dom.get('link-' + link_id);
                        } else if (data.type == 'delete') {
                            if (link_id) {
                                el = tinymce.activeEditor.dom.get('link-' + link_id);
                                $(el).contents().unwrap();
                            }
                        }

                        if (data.type != 'delete') {
                            $(el).attr('title', 'Připojeno k: ' + heslo);
                            $(el).attr('id', 'link-' + data.link_id);
                            $(el).attr('rel', data.link_id);
                        }
                        save_input($('#' + data.dom), data.dom);
                        $('#vyznamlinkPopUp').html('');
                        $(dlg).dialog('destroy');
                    },
                    error: function (jqXHR, textStatus, errorThrown) {
                        console.log(textStatus, errorThrown);
                    }
                });
            }
        }
    });
}

// TinyMCE
function CDO_initTinyMCE(selector, readonly, type, id) {
    if (typeof(readonly) === 'undefined') {
        readonly = 0;
    }


    tinyMCE.init({
        selector: selector,
        readonly: readonly,
        disabled: 0,
        content_css: "css/tinymce.css",
        language: "cs",
        mode: "exact",
        theme: "modern",
        plugins: "paste, autoresize, noneditable",
        paste_as_text: true,
        paste_text_sticky: true,
        paste_strip_class_attributes: "all",
        paste_convert_headers_to_strong: true,
        entity_encoding: "raw",
        autoresize_on_init: true,
        autoresize_min_height: "35px",
        autoresize_max_height: "500px",
        menubar: false,
        statusbar: false,
        toolbar: "bold italic fontsizeselect superscript_butt subscript_butt brackets_butt quot_butt ellip_butt | removeformat undo redo vyznamlink",
        initItalicClass: "mceEditor_italic",
        initPetitClass: "mceEditor_petit",
        initCDOClass: "cdoEditor",
        CDOtype: type,
        CDOid: id,
        noneditable_noneditable_class: 'vyznam_link_text',
        fontsize_formats: '13px 17px',
        formats: {
            linked_format: {inline: 'span', attributes: {'id': 'new_vyznam_link'}, classes: 'vyznam_link_text'}
        },
        setup: function (ed) {
            CDO_setupTinyMCE(ed);
        }
    });
}

function CDO_setupTinyMCE(ed) {
    if ($('#' + ed.id).hasClass('corrected')) {
        ed.settings.readonly = 1;
    }
    if ((ed.id).indexOf('vyklad_vyznamu') > 0) {
        ed.addButton('vyznamlink', {
            title: 'Propojit s významem',
            image: 'css/images/arrow_ord_asc_1.gif',
            onclick: function () {
                var rng = ed.selection.getRng();
                var start = rng.startOffset,
                    end = rng.endOffset,
                    seltext = ed.selection.getContent({format: 'text'}),
                    selhtml = ed.selection.getContent({format: 'html'});
                //kontrola
                if (end - start == 0) {
                    alert('Neplatný výběr');
                    return false;
                }
                if (selhtml.indexOf('span') < 0) {
                    var vid = ed.id.split('-');
                    vid = vid[1]; //id významu
                    var master = 0;
                    if (ed.id.indexOf('master') > -1) {
                        master = 1;
                    }
                    $.ajax({
                        url: cdoAjax,
                        type: 'post',
                        contentType: cdoContentType,
                        data: {
                            type: 'vyznam_link',
                            text: seltext,
                            hid: getHid(),
                            vyznam: vid
                        },
                        success: function (data) {
                            $('#vyznamlinkPopUp').html(data);
                            CDO_showVyznamLinkPopUp(vid, 0);
                        }
                    });
                } else {
                    alert('Tento výběr již obsahuje vazbu.');
                }
            }
        });
        ed.on('change', function (e) {
            var vid = ed.id.split('-');
            vid = vid[1];
            if ($.inArray(vid, notify_linked) < 0) {
                $.ajax({
                    url: 'formular_hesla_ajax.php',
                    type: 'post',
                    dataType: 'json',
                    data: {
                        act: 'check_vyznam_link',
                        vyz: vid
                    },
                    success: function (data) {
                        if (data.length > 0) {
                            notify_vyznam = true;
                            notify_linked = notify_linked.concat(data);
                        }
                    }
                });
            }
        });
    }
    ed.addButton('superscript_butt', {
        title: 'Horní index',
        image: tinymce.baseURL + '/themes/modern/img/tb_superscript.png',
        onclick: function () {
            ed.focus();
            ed.undoManager.add();
            ed.selection.setContent('<sup>' + ed.selection.getContent() + '</sup>');
            ed.undoManager.add();
            ed.nodeChanged();
        }
    });
    ed.addButton('subscript_butt', {
        title: 'Dolní index',
        image: tinymce.baseURL + '/themes/modern/img/tb_subscript.png',
        onclick: function () {
            ed.focus();
            ed.undoManager.add();
            ed.selection.setContent('<sub>' + ed.selection.getContent() + '</sub>');
            ed.undoManager.add();
            ed.nodeChanged();
        }
    });
    ed.addButton('brackets_butt', {
        title: 'Brackets button',
        image: tinymce.baseURL + '/themes/modern/img/tb_brackets.png',
        onclick: function () {
            ed.focus();
            ed.undoManager.add();
            ed.selection.setContent('<span style=\'font-size: 13px; font-style:normal\' >[' + ed.selection.getContent() + ']</span>');
            ed.undoManager.add();
            ed.nodeChanged();
        }
    });
    ed.addButton('quot_butt', {
        title: 'Quotation button',
        image: tinymce.baseURL + '/themes/modern/img/tb_quots.png',
        onclick: function () {
            ed.focus();
            ed.undoManager.add();
            ed.selection.setContent('&bdquo;' + ed.selection.getContent() + '&ldquo;');
            ed.undoManager.add();
            ed.nodeChanged();
        }
    });
    ed.addButton('braces_butt', {
        title: 'Braces button',
        image: tinymce.baseURL + '/themes/modern/img/tb_braces.png',
        onclick: function () {
            ed.focus();
            ed.undoManager.add();
            ed.selection.setContent('{' + ed.selection.getContent() + '}');
            ed.undoManager.add();
            ed.nodeChanged();
        }
    });
    ed.addButton('ellip_butt', {
        title: 'Ellipsis button',
        image: tinymce.baseURL + '/themes/modern/img/tb_ellip.png',
        onclick: function () {
            ed.focus();
            ed.undoManager.add();
            ed.selection.setContent(ed.selection.getContent() + '&hellip;');
            ed.undoManager.add();
            ed.nodeChanged();
        }
    });
    ed.addButton('pipe_butt', {
        title: 'Pipe button',
        image: tinymce.baseURL + '/themes/modern/img/tb_pipe.png',
        onclick: function () {
            ed.focus();
            ed.undoManager.add();
            ed.selection.setContent(ed.selection.getContent() + '|');
            ed.undoManager.add();
            ed.nodeChanged();
        }
    });
    ed.addButton('tilde_butt', {
        title: 'Tilde button',
        image: tinymce.baseURL + '/themes/modern/img/tb_tilde.png',
        onclick: function () {
            ed.focus();
            ed.undoManager.add();
            ed.selection.setContent(ed.selection.getContent() + '~');
            ed.undoManager.add();
            ed.nodeChanged();
        }
    });
    ed.on('init', function (evt) {
        ed.pasteAsPlainText = true;
        if (ed.settings.readonly == 1) {
            ed.getBody().style.backgroundColor = '#FDDFCD';
        }
    });

    ed.on('LoadContent', function (evt) {
        //
    });

    ed.on('click', function (e) {
        var res = ed.id.split('-');
        var vyz_id = ed.settings.CDOid;
        var hid = getHid();
        if (ed.settings.CDOtype == 'vyklad') {
            varovaniSkup(ed, ed.settings.CDOid);

            if (last_edit != ed.id) {
                //check_syn_ant_change(vyz_id, hid);
                ant_syn_check_fnc(vyz_id, res);
                last_edit = ed.id;
            }
        }
        set_focused_var_for_search(ed.id);
        var el = $(e.target);
        res = ed.id.split('-');
        if ($(el).hasClass('vyznam_link_text')) { //klik na propojený text
            if (ed.getBody().contentEditable == 'true') {
                var id = $(el).attr('id').split('-'); //id elementu
                id = id[1];
                var edId = ed.id.split('-');
                var vid = edId[1]; //id v?znamu
                var master = (ed.id.indexOf('master') > -1 ? 1 : 0);
                $.ajax({
                    url: cdoAjax,
                    type: 'post',
                    data: {
                        type: 'vyznam_link',
                        hid: getHid(),
                        link: id,
                        text: $(el).text(),
                        vyznam: vid
                    },
                    success: function (data) {
                        $('#vyznamlinkPopUp').html(data);
                        CDO_showVyznamLinkPopUp(vid, id);
                    }
                });
            }
        }
    });

    ed.on('change', function (o) {
        //setNeedConfirm(true);
    });

    ed.on('keydown', function (o) {
        var selhtml = ed.selection.getContent({format: 'html'});
        if (selhtml.indexOf('<span id="link-') > -1) {
            o.preventDefault();
            o.stopPropagation();
            return false;
        }
    });
    ed.on('focus', function (o) {
        if ($.inArray(ed.settings.initItalicClass, ed.targetElm.classList) > -1 && !ed.queryCommandState('Italic')) {
            ed.execCommand('Italic', false);
        }
    });
    ed.on('blur', function (o) {
        if ($.inArray(ed.settings.initCDOClass, ed.targetElm.classList) > -1) {
            var dom;
            if (ed.id.indexOf('--text') > 0) {
                dom = ed.id.substring(0, ed.id.indexOf('--text'));
            } else {
                dom = ed.id;
            }
            save_input($('#' + ed.id), dom);
        }
    });
}

$(document).on('click', '.heslo_semafor_edit', function (e) {
    if ($(this).hasClass('disabled')) {
        return false;
    }
    $('#semafor_stav_input').val($(this).data('stav'));
    $('.heslo_semafor_edit').removeClass('active');
    $(this).addClass('active');
    check_sem_req($(this).data('dom'), $(this));
});
