var last_edit;

function array_diff (arr1) {
    // http://kevin.vanzonneveld.net
    // +   original by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +   improved by: Sanjoy Roy
    // +    revised by: Brett Zamir (http://brett-zamir.me)
    // *     example 1: array_diff(['Kevin', 'van', 'Zonneveld'], ['van', 'Zonneveld']);
    // *     returns 1: {0:'Kevin'}
    var retArr = {},
        argl = arguments.length,
        k1 = '',
        i = 1,
        k = '',
        arr = {};

    arr1keys: for (k1 in arr1) {
        for (i = 1; i < argl; i++) {
            arr = arguments[i];
            for (k in arr) {
                if (arr[k] === arr1[k1]) {
                    // If it reaches here, it was found in at least one array, so try next value
                    continue arr1keys;
                }
            }
            retArr[k1] = arr1[k1];
        }
    }

    return retArr;
}


function setCookie(name, value, expires, path, domain, secure){
    if (!expires){expires = new Date()}
    document.cookie = name + "=" + escape(value) +
        ((expires == null) ? "" : "; expires=" + expires.toGMTString()) +
        ((path == null) ? "" : "; path=" + path) +
        ((domain == null) ? "" : "; domain=" + domain) +
        ((secure == null) ? "" : "; secure")
}

function getCookie(name) {
    var arg = name + "=";
    var alen = arg.length;
    var clen = document.cookie.length;
    var i = 0;
    while (i < clen) {
        var j = i + alen;
        if (document.cookie.substring(i, j) == arg){
            return getCookieVal(j)
        }
        i = document.cookie.indexOf(" ", i) + 1;
        if (i == 0) break
    }
    return null
}

function getCookieVal(offset){
    var endstr = document.cookie.indexOf (";", offset);
    if (endstr == -1)
        endstr = document.cookie.length;
    return unescape(document.cookie.substring(offset, endstr))
}

function deleteCookie(name,path,domain){
    document.cookie = name + "=" +
        ((path == null) ? "" : "; path=" + path) +
        ((domain == null) ? "" : "; domain=" + domain) +
        "; expires=Thu, 01-Jan-00 00:00:01 GMT"
}

function makeArrayFromObj(obj) {
    var i;
    var arr = new Array();
    for(var key in obj){
        arr.push(obj[key]);
    }
    return arr;
}

function showVyznamLinkPopUp(){
  $('#vyznamlinkPopUp').dialog({
    autoOpen: false,
    modal: true,
    width: 'auto',
    close: function( event, ui ){
      clear_vyznamlink_popup();
      $(this).dialog('destroy');
    },
    focus: function(event, ui){
            var dialogIndex = parseInt($(this).parent().css("z-index"), 10);
            $(this).find(".ui-autocomplete-input").each(function (i, obj) {
              $(obj).autocomplete("widget").css("z-index", dialogIndex + 1);
            });
    },
    buttons: {
        "OK": function() {
              $('#confirm_vyz_link_button').click();
              $( this ).dialog( "close" );
        }
      }
  });
  $( "#vyznamlinkPopUp").dialog( "open" );
}

/*
  Vlozi zadany symbol na pozici kurzoru v text area s danym editor_id
*/
function insert_symbol(symbol, editor_id){
  var txtarea = document.getElementById(editor_id);
    var scrollPos = txtarea.scrollTop;
    var strPos = 0;
    var br = ((txtarea.selectionStart || txtarea.selectionStart == '0') ?
        "ff" : (document.selection ? "ie" : false ) );
    if (br == "ie") {
        txtarea.focus();
        var range = document.selection.createRange();
        range.moveStart ('character', -txtarea.value.length);
        strPos = range.text.length;
    }
    else if (br == "ff") strPos = txtarea.selectionStart;

    var front = (txtarea.value).substring(0,strPos);
    var back = (txtarea.value).substring(strPos,txtarea.value.length);
    //vloz symbol na pozici kurzoru
    txtarea.value=front+symbol+back;

    strPos = strPos + symbol.length;
    if (br == "ie") {
        txtarea.focus();
        var range = document.selection.createRange();
        range.moveStart ('character', -txtarea.value.length);
        range.moveStart ('character', strPos);
        range.moveEnd ('character', 0);
        range.select();
    }
    else if (br == "ff") {
        txtarea.selectionStart = strPos;
        txtarea.selectionEnd = strPos;
        txtarea.focus();
    }
    txtarea.scrollTop = scrollPos;
}


function toggle_visibility(hid){
  e = document.getElementById('subvarianty-'+hid);
  if(e.className == 'hidden'){
    e.className = "";
    document.getElementById('toggle-'+hid).className = 'small_minus';
  } else{
    e.className = "hidden";
    document.getElementById('toggle-'+hid).className = 'small_plus';
  }
}

function toggle_history(kid){
  e = document.getElementById('korektura'+kid);
  if(e.className == 'korektury_hist hidden'){
    e.className = "korektury_hist";
    document.getElementById('toggle'+kid).className = 'small_minus';
  } else{
    e.className = "korektury_hist hidden";
    document.getElementById('toggle'+kid).className = 'small_plus';
  }
}


function getUrlVariable(url, variable){
  var vars = url.split("&");
  for (var i=0;i<vars.length;i++) {
    var pair = vars[i].split("=");
    if(pair[0] == variable){
      return pair[1];
    }
  }
  return(false);
}

function select_options(selector){
  $('#'+selector+' > option').each(function(index, val) {
      $(val).attr('selected', 'selected');
  });
}

function clear_upravy_ant_syn(hid, viz){
    if($("#popup_uprava_ant_syn").hasClass('ui-dialog-content'))$("#popup_uprava_ant_syn").dialog("close");
    var sh = JSON.parse(getCookie("upraveny_vyznam_hid"));
    var sv = JSON.parse(getCookie("upraveny_vyznam"));
    var expdate = new Date ();
    var showPop = false;
    var sh_index = sh.indexOf(hid.toString());
    var sv_index = sv.indexOf(viz.toString());
    expdate.setTime (expdate.getTime() + (expdays*24*60*60*1000)); // expiry date
    if(((sh_index > -1)&&(sv_index > -1)))
    {
      sh.splice(sv_index,1);
      sv.splice(sv_index,1);
      setCookie("upraveny_vyznam_hid", JSON.stringify(sh), expdate);
      setCookie("upraveny_vyznam", JSON.stringify(sv), expdate);
      $('#upravy_ant_syn_bar_'+viz).hide();
    }
}

  function check_syn_ant_change(vid, hid)//kromě ant a syn kontroluje i zda jsou ve skupině
  {
    if (typeof hid == 'undefined')
    {
      var $_GET = {};
      if(document.location.toString().indexOf('?') !== -1) {
          var query = document.location
                         .toString()
                         // get the query string
                         .replace(/^.*?\?/, '')
                         // and remove any existing hash string (thanks, @vrijdenker)
                         .replace(/#.*$/, '')
                         .split('&');

          for(var i=0, l=query.length; i<l; i++) {
             var aux = decodeURIComponent(query[i]).split('=');
             $_GET[aux[0]] = aux[1];
          }
      }
      hid = $_GET["hid"];
    }
    var sh = JSON.parse(getCookie("upraveny_vyznam_hid"));
    var sv = JSON.parse(getCookie("upraveny_vyznam"));
    var expdate = new Date ();
    var showPop = false;
    expdate.setTime (expdate.getTime() + (expdays*24*60*60*1000)); // expiry date
    if(sh == null || typeof sh == 'undefined' )
    {
      setCookie("upraveny_vyznam_hid", JSON.stringify(new Array(hid)), expdate);
      setCookie("upraveny_vyznam", JSON.stringify(new Array(vid)), expdate);
    }
    else if(!((sh.indexOf(hid) > -1)&&(sv.indexOf(vid) > -1)))
    {
      sh.push(hid);
      sv.push(vid);
      setCookie("upraveny_vyznam_hid", JSON.stringify(sh), expdate);
      setCookie("upraveny_vyznam", JSON.stringify(sv), expdate);
    }
      $.ajax({
        url: "formular_hesla.php",
        async: false,
        type: "POST",
        data	: {"act":"print_ant_syn_uprav_session"},
        contentType: "application/x-www-form-urlencoded; charset=utf-8",
        success: function(data){
          $("#upravy_ant_syn_container").html(data);
          /*$(document.getElementById("uprava_ant_syn_wrapper")).replaceWith("<div id='uprava_ant_syn_wrapper'>"+ ant_syn_uprav_sticky+"</div>");
          $(document.getElementById("uprava_ant_syn_wrapper_popup")).replaceWith("<div id='uprava_ant_syn_wrapper_popup'  class='scroller'>"+ ant_syn_uprav_sticky+"</div>");
          if(ant_syn_uprav_sticky!="<div><div></div><div></div><div></div><div></div><div></div></div>") showPop=true;*/
        }
      });
  }

function ant_syn_check_fnc(vid, res)
{
      if(res[res.length-1]=="metavyklad2_master")
      {
        print_varovani_skupiny(vid,"metavyklad2");
      }
      else if(res[res.length-1]=="vyklad_vyznamu_master" || res[res.length-1]=="vyklad_vyznamu")
      {
        print_varovani_skupiny(vid,"vyklad");
      }
      else
      {
        print_varovani_skupiny(vid,"predvyklad");
      }

      $.ajax({
        url: "formular_hesla.php",
        async: false,
        type: "POST",
        data	: {"act":"get_linked_vyzn", "vid":vid},
        contentType: "application/x-www-form-urlencoded; charset=utf-8",
        success: function(data)
        {
          var vids = JSON.parse(data);
            for(var i=0;i<vids.length;i++)
            {
              check_syn_ant_change(vids[i]["id"].toString(),vids[i]["hid"].toString());
            }
        }
      });
      check_syn_ant_change(vid);
}



//inicializuje TinyMCE editor a pripravi funkcionalitu pro linkovani vyznamu
function setupTinyMCE(ed){
    if ($('#' + ed.id).hasClass('corrected')) {
        ed.settings.readonly = 1;
    }
    if ((ed.id).indexOf('vyklad_vyznamu') > 0){
        ed.addButton('vyznamlink', {
          title : 'Propojit s významem',
          image : 'css/images/arrow_ord_asc_1.gif',
          onclick : function() {
            var rng = ed.selection.getRng();
            var start = rng.startOffset,
                end = rng.endOffset,
                seltext = ed.selection.getContent({format:'text'});
                selhtml = ed.selection.getContent({format:'html'});
                selarr = seltext.split(' ');
            //kontrola
            if (selhtml.indexOf('span') < 0){
              var vid = ed.id.split('-');
              vid = vid[1]; //id významu
              var master = 0;
              if (ed.id.indexOf('master') > -1){
                master = 1;
              }
              $.ajax({
                url: 'formular_hesla_ajax.php',
                type:'post',
                contentType: 'application/x-www-form-urlencoded;charset=utf-8',
                data:{
                  act: 'vyznam_link',
                  start: start,
                  end: end,
                  text: seltext,
                  vyznam: vid,
                  master: master
                },
                success: function(data){
                  $('#vyznamlinkPopUp').html(data);
                  showVyznamLinkPopUp();
                  //Popup.showModal('vyznamlinkPopUp');
                }
              });
            }else{
              alert('Tento výběr již obsahuje vazbu.');
            }
          }
        });
        ed.on('change', function(e){
          var vid = ed.id.split('-');
          vid = vid[1];
          if ($.inArray(vid, notify_linked) < 0){
            $.ajax({
              url: 'formular_hesla_ajax.php',
              type: 'post',
              dataType: 'json',
              data:{
                act: 'check_vyznam_link',
                vyz: vid
              },
              success: function(data){
                if (data.length > 0){
                  notify_vyznam = true;
                  notify_linked = notify_linked.concat(data);
                }
              }
            });
          }
        });
      }
		ed.addButton('superscript_butt', {
        title: 'Horní index',
        image: tinymce.baseURL + '/themes/modern/img/tb_superscript.png',
        onclick: function () {
            ed.focus();
            ed.undoManager.add();
            ed.selection.setContent('<sup>' + ed.selection.getContent() + '</sup>');
            ed.undoManager.add();
            ed.nodeChanged();
        }
    });
	 ed.addButton('subscript_butt', {
        title: 'Dolní index',
        image: tinymce.baseURL + '/themes/modern/img/tb_subscript.png',
        onclick: function () {
            ed.focus();
            ed.undoManager.add();
            ed.selection.setContent('<sub>' + ed.selection.getContent() + '</sub>');
            ed.undoManager.add();
            ed.nodeChanged();
        }
    });
    ed.addButton('brackets_butt', {
        title: 'Brackets button',
        image: tinymce.baseURL + '/themes/modern/img/tb_brackets.png',
        onclick: function () {
            ed.focus();
            ed.undoManager.add();
            ed.selection.setContent('<span style=\'font-size: 13px; font-style:normal\' >[' + ed.selection.getContent() + ']</span>');
            ed.undoManager.add();
            ed.nodeChanged();
        }
    });
    ed.addButton('quot_butt', {
        title: 'Quotation button',
        image: tinymce.baseURL + '/themes/modern/img/tb_quots.png',
        onclick: function(){
            ed.focus();
            ed.undoManager.add();
            ed.selection.setContent('&bdquo;' + ed.selection.getContent() + '&ldquo;');
            ed.undoManager.add();
            ed.nodeChanged();
        }
    });
    ed.addButton('braces_butt', {
        title: 'Braces button',
        image: tinymce.baseURL + '/themes/modern/img/tb_braces.png',
        onclick: function(){
            ed.focus();
            ed.undoManager.add();
            ed.selection.setContent('{' + ed.selection.getContent() + '}');
            ed.undoManager.add();
            ed.nodeChanged();
        }
    });
    ed.addButton('ellip_butt', {
        title: 'Ellipsis button',
        image: tinymce.baseURL + '/themes/modern/img/tb_ellip.png',
        onclick: function(){
            ed.focus();
            ed.undoManager.add();
            ed.selection.setContent(ed.selection.getContent() + '&hellip;');
            ed.undoManager.add();
            ed.nodeChanged();
        }
    });
    ed.addButton('pipe_butt', {
        title: 'Pipe button',
        image: tinymce.baseURL + '/themes/modern/img/tb_pipe.png',
        onclick: function(){
            ed.focus();
            ed.undoManager.add();
            ed.selection.setContent(ed.selection.getContent() + '|');
            ed.undoManager.add();
            ed.nodeChanged();
        }
    });
    ed.addButton('tilde_butt', {
        title: 'Tilde button',
        image: tinymce.baseURL + '/themes/modern/img/tb_tilde.png',
        onclick: function(){
            ed.focus();
            ed.undoManager.add();
            ed.selection.setContent(ed.selection.getContent() + '~');
            ed.undoManager.add();
            ed.nodeChanged();
        }
    });
      ed.on('init', function(evt) {
          ed.pasteAsPlainText = true;
          if (ed.settings.readonly == 1) {
              ed.getBody().style.backgroundColor = '#FDDFCD';
          }
      });

      ed.on('LoadContent', function(evt) {
          //
      });

      ed.on('click', function(e) {
          var res = ed.id.split('-');
          var vyz_id = 0;
          var kor_hid=0;
          if($('#' + ed.id).closest('.vyznam').length){
            vyz_id = $('#' + ed.id).closest('.vyznam').attr('id').split('-')[1];
          }
          else{
              if ($('#' + ed.id).closest('.subvyznam').length) {
                  vyz_id = $('#' + ed.id).closest('.subvyznam').attr('id').split('-')[1];
              }
              else{
                  if ($('#' + ed.id).closest('.corrector_form').length) {
                      vyz_id = $('#' + ed.id).closest('.corrector_form').find(".mceEditor").attr('id').split('-')[1];
                      kor_hid = $('#' + ed.id).closest('.corrector_form').attr('id').split('-')[1];
                  }
              }
          }
          if(last_edit!=ed.id)
          {
            if(res[res.length-1]=="vyklad_vyznamu_master" || res[res.length-1]=="vyklad_vyznamu" )
            {
                if(kor_hid!=0)
                {
                    check_syn_ant_change(vyz_id,kor_hid);
                }
                else
                {
                    check_syn_ant_change(vyz_id);
                }
              ant_syn_check_fnc(vyz_id, res);
              last_edit=ed.id;
            }
          }
          set_focused_var_for_search(ed.id);
          refreshTimer();
          var el = $(e.target);
          res = ed.id.split('-');
          if ($(el).hasClass('vyznam_link_text')){ //klik na propojený text
            if (ed.getBody().contentEditable == 'true'){
              var id = $(el).attr('id').split('-'); //id elementu
              id = id[1];
              var edId = ed.id.split('-');
              var vid = edId[1]; //id v?znamu
              var master = (ed.id.indexOf('master') > -1 ? 1 : 0);
              $.ajax({
                url: 'formular_hesla_ajax.php',
                type:'post',
                data:{
                  act: 'vyznam_link',
                  relid: id,
                  trg: $('.vyklad_link_input[rel='+id+']').val(),
                  text: $(el).text(),
                  vyznam: vid,
                  master: master
                },
                success: function(data){
                  $('#vyznamlinkPopUp').html(data);
                  showVyznamLinkPopUp();
                  //Popup.showModal('vyznamlinkPopUp');
                }
              });
            }
          }
      });

      ed.on('change', function(o) {
        //setNeedConfirm(true);
      });

      ed.on('keydown', function(o){
        var selhtml = ed.selection.getContent({format:'html'});
        if (selhtml.indexOf('<span id="link-') > -1){
          o.preventDefault();
          o.stopPropagation();
          return false;
        }
      });
      ed.on('focus', function(o){
          if ($.inArray(ed.settings.initItalicClass, ed.targetElm.classList) > -1 && !ed.queryCommandState('Italic')) {
              ed.execCommand('Italic', false);
          }
          if($.inArray(ed.settings.initPetitClass, ed.targetElm.classList) > -1 && !ed.queryCommandState('fontSize')){
              ed.execCommand('fontSize', false, "13px");
          }
      });
        ed.on('blur', function (o) {
        if ($.inArray(ed.settings.initCDOClass, ed.targetElm.classList) > -1) {
            var dom;
            if (ed.id.indexOf('--text') > 0) {
                dom = ed.id.substring(0, ed.id.indexOf('--text'));
            } else {
                dom = ed.id;
            }
            save_input($('#' + ed.id), dom);
        }
    });
}
