

function initTinyMCE(selector, readonly) {
    if (typeof(readonly) === 'undefined') {
        readonly = 0;
    }
    tinyMCE.init({
        selector: selector,
        readonly: readonly,
        disabled: 0,
        content_css: "css/tinymce.css",
        language: "cs",
        mode: "exact",
        theme: "modern",
        plugins: "paste, autoresize, noneditable",
        paste_as_text: true,
        paste_text_sticky: true,
        paste_strip_class_attributes: "all",
        paste_convert_headers_to_strong: true,
        entity_encoding: "raw",
        autoresize_on_init: true,
        autoresize_min_height: "35px",
        autoresize_max_height: "500px",
        menubar: false,
        statusbar: false,
        toolbar: "bold italic fontsizeselect brackets_butt quot_butt ellip_butt | removeformat undo redo",
        initItalicClass: "mceEditor_italic",
        initPetitClass: "mceEditor_petit",
        fontsize_formats: '13px 17px 23px',
        setup: function (ed) {
            setupTinyMCE(ed);
        }
    });
}

$(function(){
    $('form').on('submit', function () {
        tinyMCE.triggerSave();
        var ed;
        for (var i = 0; i < tinymce.editors.length; i++) {
            ed = tinymce.editors[i];
            if ($('#' + ed.id).length > 0) {
                ed.save();
            }
        }
        var data = $('#text_info')[0].value;
        $.ajax({
            type:       'POST',
            cache:      false,
            url:        'uprava_info.php',
            data:       {act:"ulozit",data:data},
            success:    function(odezva){
                $("#dialog").html(odezva);
                $("#dialog").dialog("open");
            }
        });
        return false;
    });
    var instance = tinyMCE.get("#text_info");
    if (instance) {
        instance.remove();
    }
    $(function() {
        $( "#dialog" ).dialog({
            autoOpen: false,
                buttons: [
                {
                    text: "OK",
                    click: function() {
                        $( this ).dialog( "close" );
                    }
                }
            ]
        });
    });
    initTinyMCE("#text_info");
});
