<?php

require_once 'konstanty.php';

function preview_vazebnosti($vazebnosti){
    $res = array();
    
    foreach($vazebnosti as $vazebnost){
        $vaz = text_html_preprocess($vazebnost['text']);
        $vaz = trim(strip_tags($vaz));
        $vaz_kom = text_html_preprocess($vazebnost['komentar']);
        $vaz_kom = trim(strip_tags($vaz_kom));
        $s = ((!empty($vaz_kom))?"<span class='komentar'>$vaz_kom</span>\r\n":"").$vaz;
        if(!empty($s)){
            $res[] = $s; 
        }
    }
    return $res;
}

function preview_ciselniku($vyber, $ciselnik){
    $res = array();
    foreach($vyber as $cis_id){
        if(is_numeric($cis_id)){
            $res[] = $ciselnik[$cis_id];
        } else if(!empty($cis_id)){
            $res[] = trim(text_html_preprocess($cis_id));
        }
    }
    return $res;
}

function preview_tvarChar_varianty($tvarChar, $ciselnik, $slovesa = false){
    $res = array();
    $infix = "";
    if($slovesa){
        $infix = "Sl";
    }
    foreach($tvarChar as $tvCh){
        $koncovky = $tvCh['koncovka'];
        $vyber = "<span class='varianta-tvarChar".$infix."'>";
        $delim = "";
        foreach($tvCh['cisVyber'] as $cis_id){
            if(is_numeric($cis_id)){
                $vyber.=$delim.$ciselnik[$cis_id];
            } else if(!empty ($cis_id)){
                $vyber.=$delim.trim(text_html_preprocess($cis_id));
            }
            $delim = ", ";
        }
        $vyber.="</span>";
        $delim = "";
        foreach($koncovky as $koncovka){
              $tvar = trim(text_html_preprocess($koncovka['tvar']));
              $kom = trim(text_html_preprocess($koncovka['komentar']));
              if(!empty($kom) || !empty($tvar)){
                  $vyber.=$delim;
              }
              if(!empty($kom)){
                $vyber.=" <span class='varianta-tvarChar".$infix."-koncovka-komentar'>$kom</span>";
              }
              if(!empty($tvar)){
                  $vyber.=" <span class='varianta-tvarChar".$infix."-koncovka-tvar'>$tvar</span>";
              }
              $delim = ",";
        }
        $vyber_stripped = strip_tags($vyber);
        if(!empty($vyber_stripped)){
            $res[] = $vyber;
        }
    }
    return $res;
}

function preview_slDruhu($slDruhy, $ciselnik){
    $res = array();
    foreach($slDruhy as $slDruh){
        if(!empty($slDruh['komentar'])){
            $kom = trim(text_html_preprocess($slDruh['komentar']));
            $res[] = "<span class='sl_druhy_kom'>$kom</span>";
        }
        foreach($slDruh['cisVyber'] as $cis_id){
            if(is_numeric($cis_id)){
                $res[] = $ciselnik[$cis_id];
            } else if(!empty($cis_id)){
                $res[] = trim(text_html_preprocess($cis_id));
            }
        }
    }
    return $res;
}

function preview_vyslovnosti($vyslovnosti){
    $res = array();
    
    foreach($vyslovnosti as $vyslovnost){
        $vysl = trim(text_html_preprocess($vyslovnost['text'])); 
        $vysl_kom = trim(text_html_preprocess($vyslovnost['komentar']));          
        $s = ((!empty($vysl_kom))?"<span class='komentar'>$vysl_kom</span>\r\n":"").$vysl; 
        if(!empty($s)){
            $res[] = $s; 
        }
    }
    return $res;
}

function preview_varianty($data, $reduce){
    global $_TYP_HESLA;
    $html = "\r\n<span class='varianty'>";
    $cisloVarianty = 0;
    $pocetVariant = count(data);
    $sluc = false;
    
    $variantyArray = array();
    $slDruhyArray = array();
    $tvarCharArray = array();
    $tvarCharSlArray = array();
    $puvodArray = array();
    $gramInfoArray = array();
    $oborArray = array();
    $stylKvalArray = array();
    $tematickeOkruhyArray = array();
    $prvniRegVyskytArray = array();
    $komentarTvarcharArray = array();
    $komentarTvarcharSlovesaArray = array();
    $vyslovnostArray = array();
    $vazebnostArray = array();
    
    $slDruhy_ciselnik = get_hodnoty_ciselniku(SLOV_DRUHY);
    $stylKval_ciselnik = get_hodnoty_ciselniku(STYL_KVAL);
    $gramInfo_ciselnik = get_hodnoty_ciselniku(GRAM_INFO);
    $obor_ciselnik = get_hodnoty_ciselniku(OBOR_UZITI);
    $puvod_ciselnik = get_hodnoty_ciselniku(PUVOD);
    $tvarChar_ciselnik = get_hodnoty_ciselniku(TVAR_CHAR);
    $tvarChar_sl_ciselnik = get_hodnoty_ciselniku(TVAR_CHAR_SL);
    
    
    foreach($data as $v){
       $variantyArray[] = $v['heslo_var']; 
    }
    if(($pocetVariant > 1) && (count(array_unique($variantyArray)) == 1) && $reduce){
        $sluc = true;
    }
    
    unset($variantyArray);
    $variantyArray = array();
    
    foreach($data as $v){
       $cisloVarianty++;
       
       //varianta s komentari
       $var = my_trim(text_html_preprocess($v['heslo_var']));
       $variantyArray[] = $var;
       $var_kom = text_html_preprocess(trim($v['komentar_varianty']));
       $var_kom_za = text_html_preprocess(trim($v['komentarza_varianty']));
       
       //homonymie
       $homonym = (trim($v['homonymie'])!="")? "&nbsp;".number_to_roman(text_html_preprocess($v['homonymie'])):""; 
       
       //neosemantismus 
       $is_neo = ($v['neosemantismus']=='1') ? true : false;
       $neo_sign = (($is_neo) ? "".NEO : ""); 
        
       //podhesli s komentari
       $podhesli = text_html_preprocess(trim($v['podhesli']));
       $podhesli_kom = text_html_preprocess(trim($v['komentar_podhesli']));                
        
       
       //typ hesla
       $typ_hesla = $v['typ_hesla'][0];
       $typHesla_cisVyber_str = $_TYP_HESLA[$typ_hesla];
       
       $header = "";
       if($cisloVarianty == 1){
          $sign = print_sign($typHesla_cisVyber_str, $jednoslovne);
          $header.=$sign; 
       }
       
       $header.="^^komentar$cisloVarianty^^ ";
       
        if(($sluc && $cisloVarianty == 1) || (!$sluc)){
           if(/*($cisloVarianty == 1) &&*/ !empty($var_kom))
              $header.="\r\n<span class='varianta-label'>".$var_kom."</span>\r\n";

           $typHesla_stripped = strip_tags($typHesla_cisVyber_str); 
           if($typHesla_stripped==$_TYP_HESLA[SOUSLOVI])
             $header.="<span class='souslovi'>".$var.$neo_sign.$homonym."</span>";
           else if($typHesla_stripped==$_TYP_HESLA[FRAZEM])
             $header.="<span class='frazem'>".$var.$neo_sign.$homonym."</span>";
           else if($typHesla_stripped==$_TYP_HESLA[VICESLOVNE])
             $header.="<span class='viceslovne'>".$var.$neo_sign.$homonym."</span>";
           else
             $header.="<span class='heslo'>".$var.$neo_sign.$homonym."</span>";
            
            if(!empty($var_kom_za))
              $header.="\r\n<span class='varianta-label'>".$var_kom_za."</span>";
            if($podhesli!=""){ //label: podhesli
              $header.="\r\n".((!empty($podhesli_kom))?"\r\n<span class='komentar'>".$podhesli_kom."</span>":"")."\r\n<span class='podhesli'>".$podhesli."</span>"; 
            }  
          }
       
       $komentarTvarcharArray[$cisloVarianty][] = trim(text_html_preprocess($v['komentar_tvarchar']));
       $komentarTvarcharSlovesaArray[$cisloVarianty][] = trim(text_html_preprocess($v['komentar_tvarchar_slovesa']));
       $tvarCharArray[$cisloVarianty] = preview_tvarChar_varianty($v['tvarChar'], $tvarChar_ciselnik);    
       $tvarCharSlArray[$cisloVarianty] = preview_tvarChar_varianty($v['tvarCharSl'], $tvarChar_sl_ciselnik, true);
       $slDruhyArray[$cisloVarianty] = preview_slDruhu($v['slovny_druh'], $slDruhy_ciselnik);
       $vyslovnostArray[$cisloVarianty] = preview_vyslovnosti($v['vyslovnost']);   
       $stylKvalArray[$cisloVarianty] = preview_ciselniku($v['styl_kval'], $stylKval_ciselnik);   
       $gramInfoArray[$cisloVarianty] = preview_ciselniku($v['gram_info'], $gramInfo_ciselnik);
       $oborArray[$cisloVarianty] = preview_ciselniku($v['obor_uziti'], $obor_ciselnik);
       $puvodArray[$cisloVarianty] = preview_ciselniku($v['puvod'], $puvod_ciselnik);
       $prvniRegVyskytArray[$cisloVarianty][] = trim(text_html_preprocess($v['prvni_registr_vyskyt']));
       $vazebnostArray[$cisloVarianty] = preview_vazebnosti($v['vazebnost']);       
       
       $template=$header;
       if(!$sluc){    
              $template.="^^vyslovnost$cisloVarianty^^";                      
              $template.="^^komentar_tvarchar$cisloVarianty^^";   
              $template.="^^komentar_tvarchar_slovesa$cisloVarianty^^";   
              $template.="^^tvCh$cisloVarianty^^";
              $template.="^^tvChSl$cisloVarianty^^";
              $template.="^^sl_druh$cisloVarianty^^";
              $template.="^^gramInfoUpres$cisloVarianty^^";
              $template.="^^puvod$cisloVarianty^^";
              $template.="^^oborUziti$cisloVarianty^^";
              $template.="^^stylKval$cisloVarianty^^";
            
            $vyznamy_novy_radek = false;
            if($jednoslovne && ($cisloVarianty == count($varianty)) && $vazebnostArray[$cisloVarianty]!==null){//$varianty není definováno
              $template.="\r\n<br />";
              $vyznamy_novy_radek = true;      
            }

              $template.="^^vazebnost$cisloVarianty^^";                          
              $template.="^^prvniRegVyskyt$cisloVarianty^^";
            
        } else{
          for($cisloVarianty = 1; $cisloVarianty <= $pocetVariant; $cisloVarianty++){
            if($vyslRemove && $cisloVarianty == 1){//$vyslRemove není definováno
              $template.="^^vyslovnost$pocetVariant^^";
            } else if(!$vyslRemove){ 
              $template.="^^vyslovnost$cisloVarianty^^";
            }
            $template.="^^komentar_tvarchar$cisloVarianty^^
            ^^komentar_tvarchar_slovesa$cisloVarianty^^
            ^^tvCh$cisloVarianty^^             
            ^^tvChSl$cisloVarianty^^
            ^^sl_druh$cisloVarianty^^
            ^^gramInfoUpres$cisloVarianty^^
            ^^puvod$cisloVarianty^^
            ^^oborUziti$cisloVarianty^^
            ^^stylKval$cisloVarianty^^";
          }        
        }
        $remove="";
        print_duplicities($reduce, $komentarTvarcharArray, "komentar_tvarchar", $template, true);
        print_duplicities($reduce, $komentarTvarcharSlovesaArray, "komentar_tvarchar_slovesa", $template, true);
        print_tvCh($reduce, $tvarCharArray, $template, $remove, $variantyArray, $slDruhyArray, $stylKvalArray);
        //print_tvCh($reduce, $tvarCharArray, $template, $remove, $sluc);
        print_duplicities($reduce, $tvarCharSlArray, "tvChSl", $template, $remove, "(", ")");
        print_duplicities($reduce, $slDruhyArray, "sl_druh", $template, true);
        print_duplicities($reduce, $gramInfoArray, "gramInfoUpres", $template, true);      
        print_duplicities($reduce, $vyslovnostArray, "vyslovnost", $template, $vyslRemove, "[", "]");
        print_duplicities($reduce, $puvodArray, "puvod", $template, true, "&lt;", "&gt;");
        print_duplicities($reduce, $oborArray, "oborUziti", $template, true);
        
        $stylKval = implode(array_filter($stylKvalArray[1]), ', ');
        if(($pocetVariant == 2) && (empty($stylKval) || is_null($stylKval))){
          $stylKval = implode(array_filter($stylKvalArray[2]), ', ');
          $stylKval = "<span class='stylKval'>$stylKval</span>";
          $template = str_replace("{komentar2}",$stylKval,$template);
        }
        else{
          remove_duplicities($stylKvalArray);
          print_duplicities($reduce, $stylKvalArray, "stylKval", $template, true);    
        }
        print_duplicities($reduce, $vazebnostArray, "vazebnost", $template, true, "(", ")");
        print_duplicities($reduce, $prvniRegVyskytArray, "prvniRegVyskyt", $template, true);
        
        $template = trim(preg_replace('/\s*\^\^[^^]*\^\^/', '', $template));


        if(!empty($template)){
          $html.="\r\n".$template;
        }
    }
    
    $html.="\r\n</span>";
    return $html;
}

function preview_exemplifikace($exemplifikace){
    $res = array();
    foreach($exemplifikace as $e){
        if($e['vystup']==TISTENY){
            $res[] = my_trim($e['text']);
        }
    }
    return " \r\n".implode("<p>&nbsp;</p>", $res);
}

function preview_predvykladu($zacatek, $konec, $vyrazy){
    $zacatek_predvykladu = trim(text_html_preprocess($zacatek));
    $konec_predvykladu = trim(text_html_preprocess($konec));
    $vyrazy_predvykladu = array();
    $html = "";
    
    foreach($vyrazy as $vyraz){
        $v = "";
        $tvar = trim(text_html_preprocess($vyraz['tvar']));
        $komentar = trim(text_html_preprocess($vyraz['komentar']));
        if(!empty($tvar)){
            $v.="\r\n<span class='predvyklad_vyraz'>$tvar</span>";
        }
        if(!empty($komentar)){
            $v.="\r\n<span class='predvyklad_komentar'>$komentar</span>";
        }
        if(!empty($v)){
            $vyrazy_predvykladu[] = $v;
        }
    }
    if(!empty($zacatek_predvykladu)){
        $html.="<span class='predvyklad_zacatek'>$zacatek_predvykladu</span>";
    }
    
    if(!empty($vyrazy_predvykladu)){
        $html.=implode(", ", $vyrazy_predvykladu);
    }
    
    if(!empty($konec_predvykladu)){
        $html.="\r\n<span class='predvyklad_konec'>$konec_predvykladu</span>";
    }
    
    if(!empty($html)){
        $html = "\r\n<span class='normalni'>(</span>$html<span class='normalni'>)</span>";
    }
    
    return $html;
}

function preview_podhesli($podhesli){
    $html = "";
    
    $slDruh_cis = get_hodnoty_ciselniku(SLOV_DRUHY);
    $stylKval_cis = get_hodnoty_ciselniku(STYL_KVAL);
    $oborUziti_cis = get_hodnoty_ciselniku(OBOR_UZITI);
    $gramInfo_cis = get_hodnoty_ciselniku(GRAM_INFO);
    $tvarChar_cis = get_hodnoty_ciselniku(TVAR_CHAR);
    $tvarCharSl_cis = get_hodnoty_ciselniku(TVAR_CHAR_SL);
    
    foreach($podhesli as $p){
        $komentar_pred = trim(text_html_preprocess($p['komentar_pred']));
        $tvar = trim(text_html_preprocess($p['podhesli']));
        $komentar_za = trim(text_html_preprocess($p['komentar_za']));
        $vyslovnost = preview_vyslovnosti($p['vyslovnost']);
        $slDruh = preview_slDruhu($p['slovny_druh'], $slDruh_cis);
        $stylKval = preview_ciselniku($p['styl_kval'], $stylKval_cis);
        $oborUziti = preview_ciselniku($p['obor_uziti'], $oborUziti_cis);
        $gramInfo = preview_ciselniku($p['gram_info'], $gramInfo_cis);
        $vazebnost = preview_vazebnosti($p['vazebnost']);
        $komentar_tvarChar = trim(text_html_preprocess($p['komentar_tvarchar']));
        $tvarChar = preview_tvarChar_varianty($p['tvarChar'], $tvarChar_cis);
        $komentar_tvarCharSl = trim(text_html_preprocess($p['komentar_tvarchar_slovesa']));
        $tvarCharSl = preview_tvarChar_varianty($p['tvarCharSl'], $tvarCharSl_cis, true);
       
        
        if(!empty($gramInfo)){ //label upresnujici gramaticke informace
           $html.="\r\n<span class='gramInfo'>".implode(", ", $gramInfo)."</span>";
        }
        
        if(!empty($komentar_pred)){
           $html.="\r\n<span class='podhesli_komentar'>$komentar_pred</span>";
        }
                              
        if(!empty($tvar)){
           $html.="\r\n<span class='podhesli'>$tvar</span>";
        }
               
        if(!empty($komentar_za)){
           $html.="\r\n<span class='podhesli_komentar'>$komentar_za</span>";
        }
        
        if(!empty($komentar_tvarChar)){ //label: komentář tvaroslovné charakteristiky
           $html.="\r\n<span class='komentar_tvarchar'>$komentar_tvarChar</span>";
        }
        
        $tvarChar_str = trim(implode(", ", $tvarChar));
        if(!empty($tvarChar_str)){ //label: tvaroslovna charakteristika
           $html.="\r\n(".$tvarChar_str.")";
        }
        
        if(!empty($komentar_tvarCharSl)){ //label: komentář tvaroslovné charakteristiky slovesa
           $html.="\r\n<span class='komentar_tvarchar'>$komentar_tvarCharSl</span>";
        }
        
        $tvarCharSl_str = trim(implode(", ", $tvarCharSl));
        if(!empty($tvarCharSl_str)){ //label: tvaroslovna charakteristika slovesa
           $html.="\r\n(".$tvarCharSl_str.")";
        }
        
        if(!empty($vyslovnost)){ //label výslovnost
           $html.="\r\n<span class='vyslovnost'>[".implode(", ", $vyslovnost)."]</span>";
        }
        
        if(!empty($slDruh)){ //label slovni druh
           $html.="\r\n<span class='sl_druh'>".implode(", ", $slDruh)."</span>";
        }
        
        if(!empty($oborUziti)){ //label obor uziti
           $html.="\r\n<span class='oborUziti'>".implode(", ", $oborUziti)."</span>";
        }
        
        if(!empty($vazebnost)){ //label vazebnost
           $html.="\r\n<span class='vazebnost'>(".implode(", ", $vazebnost).")</span>";
        }
        
        if(!empty($stylKval)){ //label stylisticky kvalifikator
           $html.="\r\n<span class='stylKval'>".implode(", ", $stylKval)."</span>";
        }
    }
    
    return $html;
}

function preview_vyznamu($vyznamy){
    $html = "";
    $delim="";
    $pocetVyznamu = $cisloVyznamu = 0;
    foreach($vyznamy as $v){
        //var_dump($v);
        if($v['typ_vystupu']==TISTENY && $v['pid']==0){
            $pocetVyznamu++;
        }
    }
    foreach($vyznamy as $v){
        if($v['typ_vystupu']!=TISTENY){
            continue; 
        }
        $cislo_vyznamu = "";
        if($v[pid]!=0){
            $cislo_vyznamu = "\r\n<span class=\"vyz_count\">&bull;</span>";
        } else{
            if($pocetVyznamu > 1){
                $cisloVyznamu++;
                $cislo_vyznamu = "\r\n<span class=\"vyz_count\">$cisloVyznamu</span>";
            }
        }
        
        $podhesli = trim(text_html_preprocess($v['podhesli']));
        $podhesli_komentar = trim(text_html_preprocess($v['komentar']));
        $nove_podhesli = preview_podhesli($v['podh_vyz']);
        
        $oborUziti_cis = get_hodnoty_ciselniku(OBOR_UZITI);
        $stylKval_cis = get_hodnoty_ciselniku(STYL_KVAL);
        $gramInfo_cis = get_hodnoty_ciselniku(GRAM_INFO);
        $slDruh_cis = get_hodnoty_ciselniku(SLOV_DRUHY);
        $metavyklad_cis = get_hodnoty_ciselniku(METAVYKLAD1);
        $tvarChar_cis = get_hodnoty_ciselniku(TVAR_CHAR);
        $tvarCharSl_cis = get_hodnoty_ciselniku(TVAR_CHAR_SL);
        
        $komentar_tvarChar = trim(text_html_preprocess($v['komentar_tvarchar']));
        $komentar_tvarCharSl = trim(text_html_preprocess($v['komentar_tvarchar_slovesa']));
        
        $tvarChar = preview_tvarChar_varianty($v['tvarChar'], $tvarChar_cis);
        $tvarCharSl = preview_tvarChar_varianty($v['tvarCharSl'], $tvarCharSl_cis, true);
        $slDruhy = preview_slDruhu($v['slovny_druh'], $slDruh_cis);
        $vazebnost = preview_vazebnosti($v['vazebnost']);
        $oborUziti = preview_ciselniku($v['obor_uziti'], $oborUziti_cis);
        $stylKval = preview_ciselniku($v['styl_kval'], $stylKval_cis);
        $gramInfo = preview_ciselniku($v['gram_info'], $gramInfo_cis);
        $predvyklad = trim(text_html_preprocess($v['predvyklad']));
        $novy_predvyklad = preview_predvykladu($v['zacatek_predvykladu'], $v['konec_predvykladu'], $v['vyraz_predvyk']);
        $metavyklad1 = preview_ciselniku($v['metavyklad1'], $metavyklad_cis);
        $metavyklad2 = trim(text_html_preprocess($v['metavyklad2']));
        
        $vyklad_vyznamu = handle_wysiwyg($v['vyklad_vyznamu']);
        $exemplifikace = preview_exemplifikace($v['exemplifikace']);
        
        $vyznam_str = "";
        if(!empty($cislo_vyznamu)){
           $vyznam_str.=$cislo_vyznamu;    //$cislo_vyznamu uz je naformatovane
        }
        
        if(!empty($nove_podhesli)){
            $vyznam_str.=$nove_podhesli;
        }
        
        if($podhesli!=""){ //label: podheslí
              $vyznam_str.=(($podhesli_komentar!="")?"\r\n<span class='podhesli_komentar'>".$podhesli_komentar."</span>" : "")."\r\n<span class='podhesli'>".$podhesli."</span>";        
        }
        
        if(!empty($gramInfo)){ //label: upřesňující gram. info
            $vyznam_str.="\r\n<span class='gramInfo'>".implode(", ", $gramInfo)."</span>";
        }
        
        
        if(!empty($komentar_tvarChar)){ //label: komentář tvaroslovné charakteristiky
           $vyznam_str.="\r\n<span class='komentar_tvarchar'>$komentar_tvarChar</span>";
        }
        
        $tvarChar_str = trim(implode(", ", $tvarChar));
        if(!empty($tvarChar_str)){ //label: tvaroslovna charakteristika
           $vyznam_str.="\r\n(".$tvarChar_str.")";
        }
        
        if(!empty($komentar_tvarCharSl)){ //label: komentář tvaroslovné charakteristiky slovesa
           $vyznam_str.="\r\n<span class='komentar_tvarchar'>$komentar_tvarCharSl</span>";
        }
        
        $tvarCharSl_str = trim(implode(", ", $tvarCharSl));
        if(!empty($tvarCharSl_str)){ //label: tvaroslovna charakteristika slovesa
           $vyznam_str.="\r\n(".$tvarCharSl_str.")";
        }
        
        if(!empty($slDruhy)){ //label: slovní druh
            $vyznam_str.="\r\n<span class='sl_druh'>".implode(", ", $slDruhy)."</span>";
        }
        
        
        if(!empty($vazebnost)){ //label: vazebnost
            $vyznam_str.="\r\n<span class='vazebnost'>(".implode(", ", $vazebnost).")</span>";          
        }
      
        if(!empty($oborUziti)){ //label: obor/oblast užití
           $vyznam_str.="\r\n<span class='oborUziti'>".implode(", ", $oborUziti)."</span>";
        }
        if(!empty($stylKval)){ //label: stylistický kvalifikátor
              $vyznam_str.="\r\n<span class='stylKval'>".implode(", ", $stylKval)."</span>";
        }
        
        if($predvyklad!=""){ //label: předvýklad
              $vyznam_str.="\r\n<span class='predvyklad'>(".$predvyklad.")</span>";
        }
        
        if(!empty($novy_predvyklad)){
            $vyznam_str.=$novy_predvyklad;
        }
        
        $metavyklad1_cisVyber_str = implode(", ", $metavyklad1);
        if(!empty($metavyklad1)){ //label: metavýklad 1
            $vyznam_str.="\r\n<span class='metavyklad'>".$metavyklad1_cisVyber_str."</span>";
            //ticket 458: Pokud po metavykladu nasleduje synonymum/antonymum, musi mezi nimi byt strednik
            /*
            if(strip_tags($vyklad_vyznamu)=="" && (!empty($syn_odkazy) || !empty($ant_odkazy))){
              $vyznam_str.="<span class='komentar'>;</span> ";
            }
            */
        }
           
        //dvojtecka za metavykladem 1 (pouze pokud neni zadano syn./ant.)
        if((substr(strip_tags($metavyklad1_cisVyber_str), 0, 7) == "přechýl") /*&& (empty($syn_odkazy) && empty($ant_odkazy))*/){
            $vyznam_str.="<span class='normal_size'>:</span>";
        }
        
        
        if(strip_tags($vyklad_vyznamu)!=""){ //label: výklad významu
           $vyklad_vyznamu = strip_block_tags($vyklad_vyznamu);
           $vyznam_str.="\r\n<span class='vyznam'>".$vyklad_vyznamu.$delim."</span>";
        }
        
        if($metavyklad2!=""){ //label: metavýklad 2
           $vyznam_str.="\r\n<span class='metavyklad2'>".$metavyklad2."</span>";
         }
        
        $exemplifikace = strip_block_tags($exemplifikace);
        $test = trim(strip_tags($exemplifikace));
        if(!empty($test)){
           $vyznam_stripped = trim(strip_tags($vyznam_str));
           if(!empty($vyznam_str) && ($vyznam_stripped[strlen($vyznam_stripped)-1])!=":")
              $vyznam_str.="<span class='normal_size'>:</span><span class='exeplifikace'>".$exemplifikace."</span>";
           else
              $vyznam_str.="<span class='exeplifikace'>".$exemplifikace."</span>"; 
        }
        
        
        $html.=$vyznam_str;
    }
    return $html;
}

function preview($data){
    $css['screen'] = array();
    $css['all'][] = 'css/common.css';
    $css['all'][] = 'css/tisk_hesel_pdf.css';
    $js="";
    $page_id="Alexis-livepreview";
    HTML_Header($page_id,'Alexis - živý náhled', $css, $js);

    echo "<h1>Live preview test</h1>";
    //debug
    echo microtime()."<br />";
 
    $html = preview_varianty($data['varianta'], $data['redukovat']);
    $html .= preview_vyznamu($data['vyznam']);
    //var_dump($data);
    echo $html;
    //debug
    echo "<br />".microtime()."<br />";
    
    HTML_footer($page_id);
    //return $html;
}

?>
