<?php
function httpRequest($service, $params) {
  // Params are a map from names to values
  $host = "lindat.mff.cuni.cz";
  $port = 80;
  $method = "POST";
  $paramStr = "";
  foreach ($params as $name => $val) {
    //$name = iconv("windows-1250", "UTF-8//TRANSLIT", $name);
    //$val  = iconv("windows-1250", "UTF-8//TRANSLIT", $val);
    $paramStr .= $name . "=";
    $paramStr .= urlencode($val);
    $paramStr .= "&";
  }

  // Create the connection
  $sock = @fsockopen($host, $port);
  if(!$sock){
    //echo "Nepodarilo se otevrit socket!<br />";
    return false;
  }

  fputs($sock, "$method $service HTTP/1.1\r\n");
  fputs($sock, "Host: $host\r\n");
  fputs($sock, "Content-type: " .
               "application/x-www-form-urlencoded\r\n");
  fputs($sock, "Content-length: " .
                strlen($paramStr) . "\r\n");
  fputs($sock, "Connection: close\r\n\r\n");
  fputs($sock, $paramStr);

  // Buffer the result
  $result = "";
  while (!feof($sock)) {
    $result .= fgets($sock,65535);
  }

  fclose($sock);
  return $result;
}

function extract_json($response){
  $start = strpos($response, "{");
  $end = strrpos( $response, "}");
  $len = $end - $start + 1;
  $json = substr($response, $start, $len);
  //echo "<br/>".$json."<br/>";
  $res =  json_decode($json);
  if(json_last_error()!=JSON_ERROR_NONE){
    return false;
  }
  return $res;
}

function generuj_tvary($heslo){
  if(empty($heslo)){
    return false;
  }
  $resp = httpRequest("/services/morphodita/api/generate",
  array("data" => $heslo, "output" => "json"));
  if(!$resp){
    return false;
  }

  $tvary = array();
  $tvary[] = $heslo;
  $json = extract_json($resp);
  if(!$json){
//    echo "Chyba";
    return false;
  }
  $res = (array)$json;
  foreach($res['result'][0] as $row){
    $r = (array)$row;
    //$form = iconv("UTF-8//TRANSLIT", "windows-1250", $r['form']);
    $tvary[] = $r['form'];
  }
  $tvary = array_unique($tvary);
  return $tvary;
}

function lematizuj_text($text, $min_delka = 0){
  if(empty($text)){
    return false;
  }
  $resp = httpRequest("/services/morphodita/api/analyze",
    array("data" => $text, "output" => "json"));

  $json = extract_json($resp);
  if(!$json){
    //echo "Chyba pri prevodu do formatu JSON";
    return false;
  }
  $data = array();
  $res = (array)$json;
  foreach($res['result'][0] as $slovo){
    $s = (array)$slovo;
    $a = (array)$s['analyses'];
    $info = (array)$a[0];
    $lemma = $info['lemma'] ;
    $tag = $info['tag'];
    $token =  $s['token'] ;
    $radek = array();
    $radek['lemma'] = $lemma;
    $radek['tag'] = $tag;
    if(!$min_delka || ($min_delka > 0 && strlen($token) >= $min_delka)){
      $data[$token] = $radek;
    }
  }
  return $data;
}

function zakladni_tvar($slovo){
  $tvary = lematizuj_text($slovo);
  if($tvary){
    $lemma = $tvary[$slovo]['lemma'];
    $pos = strpos($lemma, "_");
    if($pos){
      $lemma = substr($lemma, 0, $pos);
    }

    $pos2 = strpos($lemma, "-");
    if($pos2){
      $lemma = substr($lemma, 0, $pos2);
    }

    return $lemma;
  }
  return false;
}

function zakladni_tvar_hid($slovo){

    $result = dibi::query("SELECT [hid] FROM [lematizator_cache] WHERE [tvar] =  %s", $slovo);
    $val = $result->fetchSingle();
    if($val && is_numeric($val)){
        return $val;
    }

    $zakladni_tvar = zakladni_tvar($slovo);
    $heslo_id = 0;
    if($zakladni_tvar){
        $heslo_id = get_hid_pro_homonymii_I($zakladni_tvar);
       /* $heslo_id = get_hid_hlavni_varianty($zakladni_tvar, true);
        if(is_array($heslo_id)){
            $heslo_id = $heslo_id[0];
        }
        */
    }

    if(intval($heslo_id) > 0){
       $arr = array(
        'hid' => $heslo_id,
        'tvar'  => $slovo,
        'zakladni_tvar' => $zakladni_tvar,
        );
        dibi::query('INSERT INTO [lematizator_cache]', $arr);
    }

    return $heslo_id;
}

function tokenizuj_html($html){
    $tokenizovano = "";
    $html = str_replace("\xc2\xa0", "&nbsp;", $html);
    $pieces = (explode("<", $html));
    foreach($pieces as $piece){
        $pos = strpos($piece, ">");
        if($pos){
            $tag = "<".substr($piece, 0, $pos+1);
            $piece = substr($piece, $pos+1);
        }

        $merged_piece = "";
        if($piece && !empty(trim($piece))){
            $piece = str_replace("&nbsp;", "| ", $piece);
            $words = explode(" ", $piece);
            foreach($words as $w){
                $prefix = "";
                if($w[0] == "(" || $w[0] == "["){
                    $prefix = $w[0];
                    $w = substr($w, 1);
                }
                $suffix = "";
                $last = $w[strlen($w) - 1];
                if($last == ")" || $last == "]" || $last == "/" || $last == "," || $last == "|" ){
                    if($last!="|"){
                        $suffix = $last;
                    }
                    $w = substr($w, 0, -1);
                }
                $test = trim($w, ".");
                $space = ($last == "|" ? "&nbsp;" : " ");
                if(strpos($w, "(")){
                    $space = "";
                }

                if($w != "&bull;" && $w!="&loz;" && $w!="&#9633;" && $w!="/" && $w!="&hellip;" && !empty($w) && !is_numeric($test)){
                    $merged_piece.=$prefix."<span class='word'>".$w."</span>".$suffix.$space;
                } else{
                    $merged_piece.=$prefix.$w.$suffix.$space;
                }

            }

        }
        $tokenizovano .= $tag.$merged_piece;
    }
    //odstraneni nadbytecnych zavorek pred carkou a zavorkami
    $tokenizovano = str_replace(array("( ", " </span>,", "</span> </span><span class='normal_size'>)", "</span> <span style='font-style:italic'>,", " </span></span>,"),
                                array("(", "</span>,",  "</span></span><span class='normal_size'>)", "</span><span style='font-style:italic'>,", "</span></span>,"), $tokenizovano);
    return $tokenizovano;
}

//Priklady pouziti:
//$test = "banka, která přijímá krátkodobé vklady a poskytuje krátkodobé úvěry, uchovává cennosti a pronajímá bezpečnostní schránky";
//$res = lematizuj_text($test, 2);
//$slovo = "bankovky";
//$res = zakladni_tvar($slovo);
//var_dump($res);

?>
