<?php
include_once 'common.php'; 
include_once 'cls/quick_search.class.php'; 

$searchFields = QuickSearch::get_search_fields(get_role());
//$QS = new QuickSearch('varianta-typ_hesla');
//var_dump($QS->cis);

function print_field_select($sel_field_id="heslo", $bez_cisl=false, $bez_podheslí=false){
  global $searchFields;
  $html = ""; $opt_hes = ""; $opt_var = ""; $opt_vyz = ""; 
  $opt_podh="";
  $html.= "<select id='qs_field_select' name='qs_field_select'>";
  foreach($searchFields as $field){
    $qsObj = new QuickSearch($field);
    if((($qsObj->type!="select")||$bez_cisl==false)&&(($qsObj->name!="podvýznam")||$bez_podheslí==false))
    {
      $selected = "";
      if($sel_field_id == $field) $selected = "selected";
      switch($qsObj->group){
        case 'hes': $opt_hes.="<option value='$field' $selected>".$qsObj->name."</option>"; break;
        case 'var': $opt_var.="<option value='$field' $selected>".$qsObj->name."</option>"; break;
        case 'vyz': $opt_vyz.="<option value='$field' $selected>".$qsObj->name."</option>"; break;
        case 'podh': $opt_podh.="<option value='$field' $selected>".$qsObj->name."</option>"; break;
      }
    }
  }
  $html.="<optgroup label='Heslo'>$opt_hes</optgroup>";
  if (is_role_uzivatel()){
    $html.="<optgroup label='Varianta'>$opt_var</optgroup>";
    $html.="<optgroup label='Význam'>$opt_vyz</optgroup>";
    $html.="<optgroup label='Podheslí významu'>$opt_podh</optgroup>";
  }
  $html.= "</select>";
  
  return $html;
}


function print_search_query_field($sel_field_id='heslo', $selected="", $najdi_a_nahrad=false){
  $html = "";
  $qsObj = new QuickSearch($sel_field_id); 
  if(($qsObj->type=='cis' && !empty($qsObj->cis)) || ($qsObj->type=='select' && !empty($qsObj->custom_vals))){
    if($qsObj->type=='cis'){ 
        
      $vals = get_hodnoty_ciselniku($qsObj->cis, false);
      if($qsObj->cis == TEMATICKE_OKRUHY){
        $vals[0] = "neoborové";
      }
    }else{
      $vals = $qsObj->custom_vals;
    }  
    $html.="<select name='search_q' id='qs_query_sel'>";
    foreach($vals as $val_id => $val){
      if($selected==$val_id)
      {
        $html.="<option value='$val_id' selected=\"selected\">".text_html_preprocess($val)."</option>";
      }
      else
      {
        $html.="<option value='$val_id'>".text_html_preprocess($val)."</option>";
      }
    }
    if( $qsObj->id!="heslo-extPozn-typeDisp"
     && $qsObj->id!="heslo-stav"
     && $qsObj->id!="heslo-do_vystupu"
     && $qsObj->id!="zpracovatele"
     && $qsObj->id!="vyznam-extPozn-typeDisp"
     && !$najdi_a_nahrad){
      $html.="<option value='jine'>jiné</option>";
    }
    $html.="</select>";
  }elseif($qsObj->type=='txt_ac'){
    //$html.= "<label for='qs_query_ac'>Vyhledat slovo:</label>";
    $html.= "<input type='text' name='search_q' id='qs_query_ac' value='$selected' />";
  }else{
    //$html.= "<label for='qs_query'>Vyhledat slovo:</label>";
    $html.= "<input type='text' name='search_q' id='qs_query' value='$selected' />";
  }
  return $html;
}

function print_search_form($refferer=page_HESLAR){
  
  $html ="";
  $html.="<div id='qSearch_popUp' title='Rychlé vyhledávání' class='popUp'>";
  $html.="<p style='color: gray; font-size: smaller'>Spuštěno z ".(($refferer==page_HESLAR) ? "hesláře" : "karty")."</p>";
  $html.="<form action='heslar.php' method='get' name='quickSearch' id='quickSearch_form' ".(($refferer==page_KARTA) ? "target='_blank'" : "").">";
  $html.="<table style='margin-top: 20px'>";
  $html.="<tr>";
  $html.="<td><label for='qs_field_select'>hledáme v</label></td><td id='qSerach_fieldSelect'>".print_field_select()."</td>";
  $html.="</tr>";
  $html.="<tr>";
  $html.="<td><label>výraz</label></td><td id='qSerach_queryField'>".print_search_query_field()."</td>";
  $html.="</tr>";
  $html.="</table>";
  $html.="<input type='submit' value='Hledej' class='clickable' style='margin-top: 20px' onClick=\"javascript: return allow_search_submit()\" />";
  $html.="<input type='hidden' name='act' value='search' />";
  $html.="</form>";
  $html.="</div>";
  
  return $html;
}

if(isset($_POST['act'])){
  switch($_POST['act']){
    case 'get_field_select': 
      header('Content-Type: text/html; charset=utf-8');
      echo print_field_select($_POST['select_field']);  
      exit;  
    case 'get_query_field':   
      header('Content-Type: text/html; charset=utf-8');
      echo print_search_query_field($_POST['select_field'],"",$_POST['nan']);
      exit;     
  }
}

?>
