<?php
header('Content-Type: text/html; charset=utf-8');
require_once('common.php');
require_once('cls/cdo_include.php');

function order_list_by_seznam_hesel($orderBy='', $asc_desc='ASC')
{
  $default_ord = array(
      'nazev' => array('ordBy' => 'nazev', 'asc_desc' => 'ASC'),
      'login'   => array('ordBy' => 'login'  , 'asc_desc' => 'ASC'),
      'stamp'   => array('ordBy' => 'stamp'  , 'asc_desc' => 'DESC'),
      'prirazeno'   => array('ordBy' => 'prirazeno'  , 'asc_desc' => 'DESC'),
      'externista'   => array('ordBy' => 'is_externista, externista'  , 'asc_desc' => 'DESC')
  );
  if(!isset($_SESSION['razeni_hesel_seznam_hesel']) || empty($orderBy))
    $_SESSION['razeni_hesel_seznam_hesel'] = $default_ord;
  else
  {
    $v = $_SESSION['razeni_hesel_seznam_hesel'][$orderBy];
    $v['asc_desc'] = $asc_desc;
    unset($_SESSION['razeni_hesel_seznam_hesel'][$orderBy]);
    $_SESSION['razeni_hesel_seznam_hesel']=array_merge(array($orderBy => $v), $_SESSION['razeni_hesel_seznam_hesel']);
  }
}


function print_ord_ctrls_szn($ordby,$desc){
  return "
      <table class='order_ctrl_tbl'>
        <tr>
          <td>
            <a href='seznamy_hesel.php?act=order&ordby=$ordby&dsc=0'>
              <img src='css/images/".(($desc=='ASC') ? "arrow_ord_asc_2.gif":"arrow_ord_asc_1.gif" )."' alt='Seřadit vzestupně'>
            </a>
          </td>
          <td>
            <a href='seznamy_hesel.php?act=order&ordby=$ordby&dsc=1'>
              <img src='css/images/".(($desc=='DESC') ? "arrow_ord_dsc_2.gif":"arrow_ord_dsc_1.gif" )."' alt='Seřadit sestupně' />
            </a>
          </td>
        </tr>
      </table>
    ";
}

function get_prirazeno($seznam_id, $user=0, $externiste=false)
{
  if(is_null($user))
  {
    $user=0;
  }
  if($externiste)
  {
    return dibi::fetchPairs('
        SELECT u2.login
        FROM seznam_hesel s
        LEFT JOIN seznam_hesel_uziv shu ON s.id=sid
        LEFT JOIN uzivatel u2 ON shu.uid=u2.id
        WHERE (u2.role=1 or u2.role=2) AND u2.id!='.$user.' AND s.id='.$seznam_id.'
      ');
  }
  else
  {
    return dibi::fetchPairs('
        SELECT u2.login
        FROM seznam_hesel s
        LEFT JOIN seznam_hesel_uziv shu ON s.id=sid
        LEFT JOIN uzivatel u2 ON shu.uid=u2.id
        WHERE u2.role=0 AND u2.id!='.$user.' AND s.id='.$seznam_id.'
      ');
  }
}

function get_custom_seznamy($usr, $filters=NULL)
{
  $where = prepare_filter($usr, $filters);
  if (isset($_SESSION['pager']['Seznamy']['iPerPage']) && $_SESSION['pager']['Seznamy']['iPerPage']){
    $lmt = $_SESSION['pager']['Seznamy']['iPerPage'];
  }else{
    $lmt = 30;
  }

  if (isset($_SESSION['pager']['Seznamy']['page']) && $_SESSION['pager']['Seznamy']['page']){
    $ofs = ($_SESSION['pager']['Seznamy']['page']-1)*$lmt;
  }else{
    $ofs = 0;
  }

  $return = array();
  if(is_numeric($usr) && $usr>0)
  {
    if(!empty($_SESSION['razeni_hesel_seznam_hesel']))
    {
      reset($_SESSION['razeni_hesel_seznam_hesel']);
      $order_list=current($_SESSION['razeni_hesel_seznam_hesel'])["ordBy"]." ".current($_SESSION['razeni_hesel_seznam_hesel'])["asc_desc"];
      while (next($_SESSION['razeni_hesel_seznam_hesel']) !== FALSE)
      {
        $order_list=$order_list.", ".current($_SESSION['razeni_hesel_seznam_hesel'])["ordBy"]." ".current($_SESSION['razeni_hesel_seznam_hesel'])["asc_desc"];
      }
    }
    else
    {
      $order_list="";
    }
    if(is_admin($usr))
    {
      $res = dbq('
        SELECT s.id, nazev, stamp, u.id as userId, u.login, 1 AS mine, f_public,  GROUP_CONCAT(IF(u2.role=0 AND u2.id!=vlastnik,u2.login,NULL) SEPARATOR \', \') as prirazeno, GROUP_CONCAT(IF((u2.role=1 OR u2.role=2) AND u2.id!=vlastnik,u2.login,NULL) SEPARATOR \', \') as externista, IF(GROUP_CONCAT(IF((u2.role=1 OR u2.role=2) AND u2.id!=vlastnik,u2.login,NULL) SEPARATOR \', \') IS NULL, 1, 0) as is_externista
        FROM seznam_hesel s LEFT JOIN uzivatel u ON vlastnik=u.id
        LEFT JOIN seznam_hesel_uziv shu ON s.id=sid
        LEFT JOIN uzivatel u2 ON shu.uid=u2.id
        WHERE s.id IN (SELECT s.id
        FROM seznam_hesel s LEFT JOIN uzivatel u ON vlastnik=u.id
        LEFT JOIN seznam_hesel_uziv shu ON s.id=sid
        LEFT JOIN uzivatel u2 ON shu.uid=u2.id
        WHERE '.$where.')
        GROUP BY s.id '.(empty($order_list)?'':('ORDER BY ')).$order_list.' LIMIT '.$ofs.','.$lmt);
    }
    else
    {
      $res = dbq('SELECT s.id, nazev, stamp, u.login, IF(vlastnik='.$usr.', 1, 0) AS mine, f_public, GROUP_CONCAT(IF(u2.role=0 AND u2.id!=vlastnik,u2.login,NULL) SEPARATOR \', \') as prirazeno, GROUP_CONCAT(IF((u2.role=1 OR u2.role=2) AND u2.id!=vlastnik,u2.login,NULL) SEPARATOR \', \') as externista, IF(GROUP_CONCAT(IF((u2.role=1 OR u2.role=2) AND u2.id!=vlastnik,u2.login,NULL) SEPARATOR \', \') IS NULL, 1, 0) as is_externista
        FROM seznam_hesel s LEFT JOIN uzivatel u ON vlastnik=u.id
        LEFT JOIN seznam_hesel_uziv shu ON s.id=sid
        LEFT JOIN uzivatel u2 ON shu.uid=u2.id
        WHERE s.id IN (SELECT s.id
        FROM seznam_hesel s LEFT JOIN uzivatel u ON vlastnik=u.id
        LEFT JOIN seznam_hesel_uziv shu ON s.id=sid
        LEFT JOIN uzivatel u2 ON shu.uid=u2.id
        WHERE (vlastnik='.$usr.' OR EXISTS(SELECT 1 FROM seznam_hesel_uziv WHERE sid=s.id AND uid='.$usr.') OR f_public=1)
        AND '.$where.')
        GROUP BY s.id '.(empty($order_list)?'':('ORDER BY ')).$order_list.' LIMIT '.$ofs.','.$lmt);
    }
    while ($a = mysql_fetch_assoc($res)) {
      $id = $a['id'];
      unset($a['id']);
      $return[$id] = $a;
    }
  }
  return $return;
}

function prepare_filter($usr, $filter)
{
  if(empty($filter["nazev"]))
  {
    $sql_filter=" 1 ";
  }
  else
  {
      $temp = bd($filter["nazev"]);
      $sql_filter=" lower(nazev_bd) LIKE lower('%".$temp."%') ";
  }
  $sql_filter.=" AND ";
  if(empty($filter["autor"]))
  {
    $sql_filter.=" 1 ";
  }
  else
  {
    $sql_filter.=" lower(u.login) LIKE lower('%".$filter["autor"]."%') ";
  }
  $sql_filter.=" AND ";
  if(empty($filter["priz"]))
  {
    $sql_filter.=" 1 AND ";
    if(empty($filter["ext"]))
    {
      $sql_filter.=" 1 ";
    }
    else
    {
      $sql_filter.=" lower(u2.login) LIKE lower('%".$filter["ext"]."%') AND u2.role!=0 ";
    }
  }
  else
  {
    if(empty($filter["ext"]))
    {
      $sql_filter.=" lower(u2.login) LIKE lower('%".$filter["priz"]."%') AND u2.role=0  ";
    }
    else
    {
      $sql_filter.=" ((lower(u2.login) LIKE lower('%".$filter["priz"]."%') AND u2.role=0) AND (lower(u2.login) LIKE lower('%".$filter["ext"]."%') AND u2.role!=0  )) ";
    }
  }
  $sql_filter.=" AND ";
  if(empty($filter["typ"]))
  {
    $sql_filter.=" 1 ";
  }
  else
  {
    if($filter["typ"]==0)
    {
      $sql_filter.=" 1 ";
    }
    elseif($filter["typ"]==1)
    {
      $sql_filter.=" f_public=1  ";
    }
    elseif($filter["typ"]==2)
    {
      if(is_admin($usr))
      {
        $sql_filter .= " f_public=0 ";
      }
      else
      {
        $sql_filter .= " f_public=0 AND vlastnik=".$usr." ";
      }
    }
    elseif($filter["typ"]==3)
    {
      if(!is_admin($usr))
      {
        $sql_filter .= " f_public=0 AND vlastnik!=".$usr." ";
      }
      else
      {
        $sql_filter .= " 0 ";
      }
    }
  }
  return $sql_filter;
}
function print_stav_select($selected)
{
  return "<select id='custom_seznamy_typ' name='filter'>
            <option value='0' ".(($selected==0) ? "selected='selected'" : "").">nefiltrovat</option>
            <option value='1' ".(($selected==1) ? "selected='selected'" : "").">Veřejný</option>
            <option value='2' ".(($selected==2) ? "selected='selected'" : "").">Neveřejný</option>
            <option value='3' ".(($selected==3) ? "selected='selected'" : "").">Přiřazený</option>
           </select>";
}

function custom_seznamy($filter=NULL){
  if(empty($filter))
  {
    $filter= $_SESSION["seznam_hesel_filtr"];
    $filter= (array)json_decode($filter);
  }
  /*$filter["nazev"]= iconv('utf-8', 'windows-1250', $filter["nazev"]);
  $filter["autor"]= iconv('utf-8', 'windows-1250', $filter["autor"]);
  $filter["priz"]= iconv('utf-8', 'windows-1250', $filter["priz"]);
  $filter["ext"]= iconv('utf-8', 'windows-1250', $filter["ext"]);*/
  $where = prepare_filter(get_logged_user(), $filter);
  $cnt = dibi::fetchSingle('
      SELECT COUNT(DISTINCT s.id)
        FROM seznam_hesel s LEFT JOIN uzivatel u ON vlastnik=u.id
        LEFT JOIN seznam_hesel_uziv shu ON s.id=sid
        LEFT JOIN uzivatel u2 ON shu.uid=u2.id
        WHERE '.$where.'
    ');
  $sez = get_custom_seznamy(get_logged_user(), $filter);
  $pagerHTML = pager_htmls('Seznamy', $cnt);
  $pager_block = '
    <div class="heslar_pager_block">
        <div>
          <div class="floatLeft">'.$pagerHTML['found_info'].'</div>
          <div class="floatRight">'.$pagerHTML['stats_info'].'</div>
        </div>
        <div style="clear:both;">
          <div class="pager_pages floatLeft">'.$pagerHTML['pages'].'</div>
          <div class="floatRight">'.$pagerHTML['itemsPerPage'].'</div>
        </div>
    </div>
  ';
  //$pager_block = '';
  $html = '
    <div class="clear"></div>
    '.$pager_block.'
    <div id="custom_seznamy_container" class="orangeBox">
      <table class="w100 stripeMe" id="custom_seznamy" cellspacing="0">
      <thead>
        <tr>
          <th style=\'width: 18%\'><div class="floatLeft">Název</div> '.print_ord_ctrls_szn("nazev",$_SESSION['razeni_hesel_seznam_hesel']["nazev"]["asc_desc"]).'</th>
          <th style=\'width: 14%\'><div class="floatLeft">Autor</div> '.print_ord_ctrls_szn("login",$_SESSION['razeni_hesel_seznam_hesel']["login"]["asc_desc"]).'</th>
          <th style=\'width: 12%\'><div class="floatLeft">Stav</div></th>
          <th style=\'width: 14%\'><div class="floatLeft">Vytvořeno</div> '.print_ord_ctrls_szn("stamp",$_SESSION['razeni_hesel_seznam_hesel']["stamp"]["asc_desc"]).'</th>
          <th style=\'width: 20%\'><div class="floatLeft">Přiřazeno</div> '.print_ord_ctrls_szn("prirazeno",$_SESSION['razeni_hesel_seznam_hesel']["prirazeno"]["asc_desc"]).'</th>
          <th style=\'width: 20%\'><div class="floatLeft">Externisté</div> '.print_ord_ctrls_szn("externista",$_SESSION['razeni_hesel_seznam_hesel']["externista"]["asc_desc"]).'</th>
          <th>&nbsp</th>
        </tr>
        <tr>
          <th><input style="width:90%" id="custom_seznamy_nazev" type="text" class="ac_seznam_filter_text_name" name="filter" value="'.$filter["nazev"].'"/></th>
          <th><input style="width:80%" id="custom_seznamy_autor" type="text" class="ac_seznam_filter_text" name="filter" value=\''.$filter["autor"].'\'/></th>
          <th>'.print_stav_select($filter["typ"]).'</th>
          <th></th>
          <th><div class="floatLeft"><input id="custom_seznamy_pr" type="text" class="ac_seznam_filter_text_pr" name="filter" value=\''.$filter["priz"].'\'/></th>
          <th><div class="floatLeft"><input id="custom_seznamy_ext" type="text" class="ac_seznam_filter_text_ex" name="filter" value=\''.$filter["ext"].'\'/></th>
          <th>&nbsp</th>
        </tr>
      </thead>
      <tbody>
  ';
  //'.print_ord_ctrls_szn("prirazeno",$_SESSION['razeni_hesel_seznam_hesel']["prirazeno"]["asc_desc"]).'
  //'.print_ord_ctrls_szn("externista",$_SESSION['razeni_hesel_seznam_hesel']["externista"]["asc_desc"]).'
  foreach ($sez as $id => $s){
    if ($s['f_public']){
      $stav = 'Veřejný';
    }else{
      if ($s['mine']){
        $stav = 'Neveřejný';
      }else{
        $stav = 'Přiřazený';
      }
    }
    /*$prirazeno=implode(", ",get_prirazeno($id, $s['userId']));
    $externiste=implode(", ",get_prirazeno($id, $s['userId'], true));*/
    $html .= '
      <tr>
        <td><a href="heslar.php?act=data_filter&amp;filter=seznam&amp;seznam='.$id.'" rel="">'.$s['nazev'].'</a></td>
        <td>'.$s['login'].'</td>
        <td>'.$stav.'</td>
        <td>'.$s['stamp'].'</td>
        <td>'.$s['prirazeno'].'</td>
        <td>'.$s['externista'].'</td>
        <td>
    ';
    if (is_admin(get_logged_user())){
      $html .= '
        <img src="css/images/users_green.png" alt="Přiřadit externistům" title="Přiřadit externistům" width="19" height="19" id="edit_seznam_hesel_ext" rel="'.$id.'" />
      ';
    }
    if ($s['mine']){
      $html .= '
        <img src="css/images/users_blue.png" alt="Přiřadit uživatelům" title="Přiřadit uživatelům" width="19" height="19" id="edit_seznam_hesel" rel="'.$id.'" />
        <a href="seznamy_hesel.php?act=smaz_seznam&amp;sid='.$id.'" onClick="return confirm(\'Opravdu smazat?\');">
          <img src="css/images/del.png" alt="Smazat" title="Smazat" />
        </a>
      ';
    }

    $html .= '
        </td>
      </tr>
    ';
  }
  $html .= '
        </tbody>
      </table>
    </div>
    <div id="seznamheselPopUp" title="Přiřazení seznamu hesel" class="popUp"></div>
  ';

  return $html;
}

function seznam_popup($sid, $users=True){
  $sid = mysql_real_escape_string($sid);
  if (check_seznam_owner($sid) || (is_admin(get_logged_user()))){
    $sez = get_db_values('seznam_hesel', array('nazev', 'f_public'), $sid);
    $html = '
      <div>
        <form action="" method="post" id="att_seznam_user_form"><div>
          <h4>Seznam "'.$sez['nazev'].'"</h4>
          <div class="clear">
    ';
    if ($users){
      if ($sez['f_public']){
        $ch[0] = ' checked="checked"';
        $ch[1] = '';
      }else{
        $ch[0] = '';
        $ch[1] = ' checked="checked"';
      }
      $html .= '
        <div class="floatLeft">
          <div>
            <input type="radio" name="sez_verejny" value="1"'.$ch[0].' />Veřejný
          </div>
          <div>
            <input type="radio" name="sez_verejny" value="0"'.$ch[1].' />Neveřejný
          </div>
        </div>
      ';
    }
    $html .= '
            <div class="floatRight">
              <div class="form_vyber_z_ciselniku">
                <table>
                  <tbody>
                  <tr>
                  <td rowspan="2">
                    <select multiple="multiple" class="sbCiselnik" id="prirad_uziv_cis" name=""'.($ch[0] ? ' disabled="disabled"' : '').'>
    ';
    $sql = 'SELECT id, login, role FROM uzivatel WHERE 1';
    if ($users){
      $where = ' AND role IN (' . get_role_uzivatel(',') . ')';
    }else{
      $where = ' AND role NOT IN (' . get_role_uzivatel(',') . ')';
    }
    $sql .= $where;
    $att_users = db_get_val_arr('SELECT id, login FROM uzivatel WHERE id IN (SELECT uid FROM seznam_hesel_uziv WHERE sid='.$sid.') '.$where.' ', array('id'=>'login'));
    if ($att_users){
      $sql .= ' AND id NOT IN ('.implode(',',array_keys($att_users)).')';
    }
    $sql .= ' ORDER BY login ASC';
    $uzs = db_fetchAll($sql);
    $html .= '
    <optgroup label="'.($users ? 'uživatelé' : 'externisté').'"></optgroup>
  ';
    foreach ($uzs as $uz){
      $html .= '
      <option value="'.$uz['id'].'">'.$uz['login'].'</option>
    ';
    }
    $html .= '
      </select>
    </td>
     <td style="vertical-align: bottom">
      <input id="" type="button" name="" value="&gt;&gt;" onclick="Selectbox.moveSelectedOptions(document.getElementById(\'prirad_uziv_cis\'), document.getElementById(\'prirad_uziv_vyber\'), false)">
     </td>
     <td rowspan="2">
      <select multiple="multiple" class="sbCisVyber" id="prirad_uziv_vyber" name="seznam_uziv[]" '.($ch[0] ? ' disabled="disabled"' : '').'>
            ';
    foreach ($att_users as $i => $r){
      $html .= '
      <option value="'.$i.'">'.$r.'</option>
    ';
    }
    $html .= '
                      </select>
                     </td>
                     <td></td>
                    </tr>
                    <tr>
                      <td>
                        <input type="button" name="" value="&lt;&lt;" onclick="Selectbox.moveSelectedOptions(document.getElementById(\'prirad_uziv_vyber\'), document.getElementById(\'prirad_uziv_cis\'), false)">
                      </td>
                     <td style="vertical-align: bottom"></td>
                    </tr>
                    <tr>
                      <td><input type="button" value="Vybrat vše" onclick="select_options(\'prirad_uziv_cis\');" /></td>
                      <td></td>
                      <td><input type="button" value="Vybrat vše" onclick="select_options(\'prirad_uziv_vyber\');" /></td>
                    </tr>
                  </tbody></table>
                </div>
              </div>
            </div>
          </div>
          <div class="clear">
            <input type="hidden" name="act" value="'.($users ? 'uprav_seznam' : 'uprav_seznam_ext').'" />
            <input type="hidden" name="sid" value="'.$sid.'" />
          </div>
        </div></form>
    ';
  }else{
    $html = '
      <div>Pro úpravu tohoto seznamu nemáte oprávnění</div>
    ';
  }
  $html .= '</div>';
  return $html;
}

if (isset($_POST['act'])){ //ajax
  $act = $_POST['act'];
  $sid = $_POST['sid'];
  if ($act == 'sez_popup'){
    echo seznam_popup($sid, $_POST['users']);
  }
  elseif($act == 'sez_filter')
  {
    $_SESSION['seznam_hesel_filtr']=json_encode($_POST);
    set_pager('Seznamy', 1);
    echo custom_seznamy($_POST);
  }
}
?>