<?php
require_once('common.php');
require_once('fx.php');
require_once('cls/redakce.class.php');
require_once('cls/quick_search.class.php');
require_once('cls/cdo_include.php');
$page_id = 'tab_export';

function constructHeaders(&$levels, $fields, $level = 0, $padding = 0)
{
    if (!isset($levels[$level])) {
        $levels[$level] = array();
    }
    $cnt = array_sum($levels[$level]);
    if (is_array($fields)) {
        $sum = 0;
        for ($i = $cnt; $i < $padding; $i++) {
            $levels[$level]['##' . rand(1, 100)] = 1;
        }
        $cnt = array_sum($levels[$level]);
        foreach ($fields as $f => $sub) {
            $tmp = constructHeaders($levels, $sub, $level + 1, $cnt);
            $cnt += 1;
            $sum += $tmp;
            if (isset($levels[$level][$f])) {
                $levels[$level][$f . '##' . rand(1, 100)] = $tmp;
            } else {
                $levels[$level][$f] = $tmp;
            }
        }
        return $sum;
    } else {
        $levels[$level]['##' . rand(1, 100)] = 1;
        return 1;
    }
}

function csvForm()
{
    $html = '
        <form action="tab_export.php?act=csv" method="post" target="_blank">
            <div>
                <input class="blueButtBox buttBox" type="submit" value="CSV export">
            </div>
        </form>
    ';
    return $html;
}

function printTable($headers, $data)
{
    $html = '<table id="tab_data">';
    $len = array_sum($headers[0]);
    $html .= '<tr>';
    foreach ($headers as $hrow) {
        foreach ($hrow as $h => $csp) {
            $tmp = explode('##', $h);
            if ($tmp[0]) {
                $h = $tmp[0];
            } else {
                $h = '';
            }
            $html .= '<th colspan="' . $csp . '">' . $h . '</th>';
        }
        $currlen = array_sum($hrow);
        for ($i = $currlen; $i < $len; $i++) {
            $html .= '<th></th>';
        }
        $html .= '</tr>';
    }
    foreach ($data as $heslo) {
        $class = 'first_hrow';
        foreach ($heslo as $row) {
            $html .= '<tr class="' . $class . '">';
            foreach ($row as $d) {
                $html .= '<td>' . $d . '</td>';
            }
            $html .= '</tr>';
            $class = '';
        }
    }
    $html .= '</table>';
    return $html;
}

function getFields($parent = 0)
{
    if ($parent) {
        $fields = dibi::fetchAll('
            SELECT id, name, label
            FROM form_field f INNER JOIN form_field_parent p ON f.id = p.child_id
            WHERE p.parent_id = %i
            ORDER BY priority DESC
        ', $parent);
    } else {
        $fields = dibi::fetchAll('
            SELECT id, name, label
            FROM form_field f LEFT JOIN form_field_parent p ON f.id = p.child_id
            WHERE p.parent_id IS NULL
            ORDER BY priority DESC
        ');
    }
    foreach ($fields as $i => $f) {
        $fields[$i]['fields'] = getFields($f['id']);
        if ($f['name'] == 'tvar_char') {
            $tvch = dibi::fetchAll('SELECT 0 AS id, tvar_char AS name, tvar_char AS label FROM cis_tvar_char ORDER BY sortorder');
            $jine = new DibiRow(array(
                'id' => 0,
                'name' => 'jine',
                'label' => 'jiné'
            ));
            $tvch[] = $jine;
            $fields[$i]['fields'] = $tvch;
        } elseif ($f['name'] == 'tvar_char_sl') {
            $tvch = dibi::fetchAll('SELECT 0 AS id, tvar_char_sl AS name, tvar_char_sl AS label FROM cis_tvar_char_sl ORDER BY sortorder');
            $jine = new DibiRow(array(
                'id' => 0,
                'name' => 'jine',
                'label' => 'jiné'
            ));
            $tvch[] = $jine;
            $fields[$i]['fields'] = $tvch;
        }
    }

    return $fields;
}

function printNew($fields)
{
    if (isset($_SESSION['data_filter'], $_SESSION['data_filter']['_dataID']) && $_SESSION['data_filter']['_dataID'] == 'jine_in_hesla') {
        $hesla = get_hesla_by_jine();
    } else {
        $hesla = get_hesla();
    }
    $list = new CDOList($hesla);
    $data = $list->tabExport($fields);
    if (!isset($_SESSION['cdolist'])) {
        $_SESSION['cdolist'] = array();
    }
    $_SESSION['cdolist']['table_raw_data'] = $data;
    return csvForm() . $list->tabHtml($data);
}

function printNewCsv()
{
    $list = new CDOList();
    $list->tabCsv($_SESSION['cdolist']['table_raw_data']);
}

function printFields($fields, $parent = '')
{
    $html = '';
    if ($parent) {
        $prefix = $parent . '--';
        $cls = 'chb_block';
        $label = '';
        $ccls = 'chb';
    } else {
        $prefix = '';
        $cls = 'chb_block_main';
        $label = 'main';
        $ccls = '';
    }
    $podhesli = False;
    foreach ($fields as $i => $f) {
        $val = $prefix . $f['name'];
        if ($val == 'vyznam--podhesli') {
            continue;
        }
        $valArr = explode('--', $val);
        $padd = 5 * count($valArr);
        $name = 'fields[' . implode('][', $valArr) . ']';
        $chb = '
            <div class="' . $ccls . '" style="margin-left: ' . $padd . 'px">
            <label class="' . $label . '">
                <input id="' . $val . '" class="field_chb" type="checkbox" name="' . $name . '" value="1" onchange="check_parent(this, \'' . $parent . '\')">
                <span>' . $f['label'] . '</span>
            </label>
            </div>
        ';
        if (isset($f['fields']) && $f['fields']) {
            $suff = '';
            if ($f['name'] == 'varianta') {
                $suff = '
                    <div style="margin-left: 5px">
                    <label class="main">
                        <input id="ext_pozn" class="field_chb" type="checkbox" name="fields[ext_pozn]" value="1">
                        <span>Externí poznámky k heslu</span>
                    </label>
                    </div>
                    <div style="margin-left: 5px">
                    <label class="main">
                        <input id="heslo-vystup" class="field_chb" type="checkbox" name="fields[vystup]" value="1">
                        <span>Výstup hesla</span>
                    </label>
                    </div>
                ';
            }
            $html .= '
                <div class="' . $cls . ' ' . $f['name'] . '">
                    <div>' . $chb . '</div>
                    ' . printFields($f['fields'], $val) . $suff . '
                </div>
            ';
            if ($f['name'] == 'vyznam') {
                foreach ($f['fields'] as $j => $sf) {
                    if ($sf['name'] == 'podhesli' && isset($sf['fields'])) {
                        $podhesli = $sf['fields'];
                        break;
                    }
                }
                $html .= '
                    <div class="' . $cls . ' podhesli">
                        <div>
                            <div style="margin-left: ' . $padd . 'px">
                                <label class="main">
                                    <input id="vyznam--podhesli" class="field_chb" type="checkbox" name="fields[vyznam][podhesli]" value="1" onchange="check_parent(this, \'vyznam\')">
                                    <span>Podheslí významu</span>
                                </label>
                            </div>
                        </div>
                        ' . printFields($podhesli, 'vyznam--podhesli') . '
                    </div>
                ';
            }
        } else {
            $html .= $chb;
        }
        if ($podhesli) {

        }
    }

    return $html;
}

$css['screen'][] = 'js/jQueryUI/css/ui-lightness/jquery-ui-1.11.2.custom.css';
$css['screen'][] = 'css/tab_export.css';
$js[] = 'js/jquery.js';
$js[] = 'js/jquery.livequery.js';
$js[] = 'js/jquery.qtip.js';
$js[] = 'js/jQueryUI/jquery-ui-1.11.2.custom.min.js';
$js[] = 'js/tab_export.js';

$html = '';
$act = isset($_GET['act']) ? $_GET['act'] : 'fields';
if ($act == 'table') {
    $fields = array('Heslo' => 1);
    $fields = array_merge($fields, $_POST['fields']);
    if (isset($_SESSION['data_filter'], $_SESSION['data_filter']['_dataID']) && $_SESSION['data_filter']['_dataID'] == 'jine_in_hesla') {
        $hesla = get_hesla_by_jine();
    } else {
        $hesla = get_hesla();
    }
    $data = array();
    $tmp = array();
    $tmp2 = array();
    $headers = array();
    $topheaders = array();
    $_SESSION['table'] = array(
        'data' => array()
    );
    foreach ($hesla as $h) {
        $cdo = new CDO(CDOin_DB, $h);
        $resp = $cdo->tabExport($tmp, $fields, WRAP_CORRECTION);
        $resp2 = $cdo->tabExport($tmp2, $fields);
        $headers = $resp->data['headers'];
        $data[] = $resp->data['data'];
        $_SESSION['table']['data'][] = $resp2->data['data'];
        unset($cdo);
    }
    $levels = array();
    constructHeaders($levels, $fields);
    $html .= csvForm();
    $numcols = array_sum($levels[0]);
    foreach ($data as $i => $hrow) {
        foreach ($hrow as $j => $row) {
            $cnt = count($row);
            if ($cnt < $numcols) {
                for ($k = $cnt; $k < $numcols; $k++) {
                    $data[$i][$j][] = '';
                    $_SESSION['table']['data'][$i][$j][] = '';
                }
            }
        }
    }
    $html .= printTable($levels, $data);
    $_SESSION['table']['headers'] = $levels;
} elseif ($act == 'tableNew') {
    $html = printNew($_POST['fields']);
} elseif ($act == 'fields') {
    $fields = getFields();
    $html .= '
        <div id="fields_form_wrapper">
        <form method="post" action="tab_export.php?act=tableNew">
            <div>
                <input class="blueButtBox buttBox" type="submit" value="Export">
                <div id="fields_form_div" class="orangeBox">
                ' . printFields($fields) . ' 
                </div>
                <input class="blueButtBox buttBox" type="submit" value="Export">
            </div>
        </form>
        </div>
    ';
} elseif ($act == 'csv') {
    printNewCsv();
}
if ($html) {
    HTML_header($page_id, 'Alexis - tabulkový export', $css, $js);
    echo $html;
    HTML_footer($page_id);
}