<?php
require_once('common.php');
require_once('formular_hesla_fx.php');
require_once('morphodita_fx.php');
require_once('search.php');
require_once('cls/redakce.class.php');
require_once('cls/xFilter.class.php');
require_once('tisk_hesel_fx.php');
require_once('live_preview.php');

function is_archive()
{
    return isset($_GET['archid']);
}

function getArchid()
{
    return $_GET['archid'];
}

$page_id = 'formular_hesla';
$hid = 0;
$archid = 0;
if(isset($_GET['hid']) && is_numeric($_GET['hid'])){
    $hid = $_GET['hid'];
    $cdo = new Heslo();
    if (isset($_GET['archid'])){
        $archid = $_GET['archid'];
        $cdo->loadFromArchive($hid, $_GET['archid']);
    }else{
        $cdo->load($hid);
    }
}

//blokovanie hesla
$heslo_block_stat = get_heslo_block_stat($hid);
$heslo_is_blocked = ($heslo_block_stat!==false && !is_me_blocking_heslo($hid));
if($heslo_is_blocked){
    $uname = get_user_name($heslo_block_stat['uid']);
    $since = date("H:i", strtotime($heslo_block_stat['cts']));
    $ip = $heslo_block_stat['ip'];
    $block_text = "S heslem teď pracuje <i>$uname</i>, a to od $since. Žádné změny nebudou uloženy.";
    err($block_text);
} else {
    $_SESSION['CDO'][$hid] = $cdo;
}

$redakce_popups = "";

function aktivni_korektura_alert(){
    return "onClick=\"alert('Pole obsahuje korekturu! Pro editace pole, prosím, vraťte korekturu korektorovi, nebo ji aplikujte.'); return false;\"";
}

function get_TinyMCE_disable_script($ed_id){
    return "
      tinyMCE.get('$ed_id').getBody().style.backgroundColor = '#FDDFCD';
      tinyMCE.get('$ed_id').getBody().contentEditable = false;
      var Tools = [\"toolbar1\", \"toolbar2\", \"toolbar3\"];
      for (var i in Tools) {
         if(typeof tinyMCE.get('$ed_id').controlManager.get(Tools[i])!=='undefined'){
           var ct = tinyMCE.get('$ed_id').controlManager.get(Tools[i]).controls;
           for (var j in ct){
             if(typeof ct[j].setDisabled === 'function')
              ct[j].setDisabled(true);
           }
         }
      }";
}

function print_live_preview_box($hid = 0){
    $html = "";
    $dummy = null;
    $heslo = tisk_hesla(true, $hid, 0, true, true, $dummy);
    $html.="<div id='stickyfooter' class='orangeBox'>
                <div class='floatRight'><img src='css/images/minimize.png' class='mini-max-ico clickable minimize_preview' alt='Skrýt živý náhled'></div>
                    <h3>Živý náhled</h3>
                    <div class='pdf scroller'>$heslo</div>
                </div>
                ";
    /*$html.="<div id='stickyfooter_minimized'>
                <span class='maximize_preview'>Zobrazit živý náhled</span>
            </div>
            ";*/
    return $html;
}

function print_sticky_header($cdo){
    global $next_hid, $prev_hid;
    $heslo = $cdo->get_hlavni_varianta();
    $hid = $cdo->hid;
    $html="";
    //JS
    $js="
    <script type='text/javascript'>
      $(function(){
        // Check the initial Poistion of the Sticky Header
        var stickyHeaderTop = $('#stickyheader').offset().top - 40;
        var stickyHeaderW   = $('#stickyheader').parent().width() - 40; //40px = 2*(borderWidth+padding)
        $('#stickyheader').css({position: 'static', top: '0px', display: 'none'});
        $(window).scroll(function(){
          if( $(window).scrollTop() > stickyHeaderTop ) {
            $('#stickyheader').css({position: 'fixed', top: '0px', display: 'block', visibility: 'visible', width: stickyHeaderW+'px'});
          }else{
            $('#stickyheader').css({position: 'static', top: '0px', display: 'none'});
          }
        });
        });
        </script>
  ";
    //CSS
    $css = "";
    //HTML
    $html.="
     <div id='stickyheader' class='orangeBox'>
      <table style='width: 100%'>
        <tr>
          <td>
            <h1 class='floatLeft'>".$heslo.$cdo->get_homonymie_str()."</h1>   <br/>
            <div class='floatLeft' style='margin-left: 40px;'>
              <a href='formular_hesla.php?hid=$prev_hid' title='předchozí frazém'><img src='css/images/prev.png' alt='&lt;&lt;'/></a>
              <a href='formular_hesla.php?hid=$next_hid' title='další frazém'><img src='css/images/next.png' alt='&gt;&gt;' /></a>
            </div>
          </td>
          <td style='text-align: right;".($cdo->is_archive() ? ' display:none;' : '')."'>
            <input type='submit' value='uložit' class='blueButtBox buttBox floatRight' />
            <!--<span class='blueButtBox buttBox floatRight' id='preview_butt' />Preview</span>-->
            <a href='archiv.php?hid=$hid' class='archive_view_icon' target='_blank' title='Zobrazit archiv verzí'>&nbsp;</a>
              <a class='archive_save_icon' hid='$hid' title='Uložit tuto verzi do archivu'>&nbsp;</a>
            <span class='live_butt' title='Zobrazit/skrýt živý náhled'>&nbsp;</span>
            ".(is_admin(get_logged_user()) ? '<a href="xml_export.php?hid='.$hid.'" class="xmlExport_butt" target="_blank" title="XML výstup">&nbsp;</a>' : '')."
            <a href='tisk_hesel_new.php?hid=$hid&amp;page=heslo_varianty&amp;action=preview' class='preview_butt' target='_blank' title='Tiskový výstup (Word)'>&nbsp;</a>
            <a href='tisk_hesel_new.php?hid=$hid&amp;page=heslo_varianty&amp;action=export' target='_blank' class='exportHesla_butt' title='Tiskový výstup (PDF)'>&nbsp;</a>
            <a href='tisk_hesel_new.php?hid=$hid&amp;page=heslo_varianty' target='_blank' class='nahledHesla_butt' title='Tiskový náhled (HTML) s redakčním modulem'>&nbsp;</a>
            <a href='heslar.php' class='heslar_butt' title='Návrat do hesláře'>&nbsp;</a>
            <div class='qSearch_butt clickable' title='Rychlé vyhledávání'></div>
          </td>
        </tr>
      </table>
    </div>
    ";
    return $js.$css.$html;
}

function form_ciselniku($cis, $vyber, $form_id, $form_name){
    $html = '
    <div id="'.$form_id.'_popUp" title="Výběr hodnot z číselníku" class="popUp" data-form_id="'.$form_id.'" data-form_name="'.$form_name.'" data-cis="'.$cis.'"></div>
    <div id="'.$form_id.'_inputs">
  ';
    foreach ($vyber as $id => $v) {
        $html .= '
      <input type="hidden" name="'.$form_name.'[]" value="'.$id.'" data-opt="'.$v.'" />
    ';
    }
    $html .= '
    </div>
    '.($cis == ZPRACOVATELE ? '' : '<input type="hidden" id="'.$form_id.'_input-jine" name="'.$form_name.'[jine]" value="'.(isset($vyber['jine']) ? $vyber['jine'] : '').'" />');
    return $html;
}

function nahled_ciselniku($cdo, $HTMLdata, $form_id, &$corrected = false){
    $is_corrected = false; $corrected_flag=""; $corrected_cls = "";
    echo highlight_new_correction(False, $form_id, $is_corrected, $corrected_flag, $corrected_cls);

    $varovani="";
    if (strpos($form_id, 'metavyklad1_master') !== FALSE)
    {
        $vids=explode("-",$form_id);
        $varovani = '<div style="display:none" id="meta1-varovani-'.$vids[1].'">'.get_varovani_link_fnc($vids[1], 'metavyklad1').'</div>';
    }

    if($varovani!="")
    {
        $onClick = "onClick=\"print_varovani_skupiny_meta1(true,'".$form_id."_popUp',".$vids[1].", this);\"";
    }
    else
        $onClick = "onClick=\"JS_showEditorCiselniku('".$form_id."_popUp', this)\"";
    $html="";
    $html.="
    <table class='w100 ciselnik'><tr>
     <td class='border padd flatBox cisView $corrected_cls' id='".$form_id."--list'>".$HTMLdata['firstVals'];
    if(strpos($corrected_flag, "corr_label.png")!==FALSE){
        $html.=$corrected_flag;
    }
    $html .= $varovani;
    $html.="</td>
     <th>";
    if(strpos($corrected_flag, "history.png")!==FALSE){
        $html.=$corrected_flag;
    }
    $html.="<table class='floatLeft' style='border-spacing: 0;'>
        <tr><td id='".$form_id."--cisView' class='center bold yellowBG border butt sqr".($is_corrected ? ' is_corrected' : '')."' $onClick>E</td></tr>
        <tr><td id='".$form_id."--valsNum' class='center bold blueBG border sqr'>".$HTMLdata['valsNum']."</td></tr>
       </table>
     </th>
   </table>";
    $corrected = $is_corrected;
    return $html;
}

function getCisFirstVals($vyber, $pocet=2, $glue='<br />'){
    $html="";
    if(empty($vyber)) return "";
    $vyber = my_arrayMap('text_html_preprocess', $vyber);
    foreach ($vyber as $i => $v) {
        $vyber[$i] = '<span>' . $v . '</span>';
    }
    return implode($glue, array_slice($vyber,0,$pocet));
}

function print_typPozn_sb($form_id, $form_name, $selVal = 0){
    $cisAll = get_hodnoty_ciselniku(TYP_EXT_POZN);
    $html="";
    $html.="<select id='$form_id--type' name=".$form_name."[type]>";
  //  $html.="<option value='0'>&nbsp;</option>";
    foreach($cisAll as $id => $type){
        $sel = ($selVal==$id) ? "selected='selected'" : "";
        $html.="<option value='$id' $sel>$type</option>";
    }
    $html.="</select>";
    return $html;
}

function hlavicka_formularu_hesla($cdo){
    global $_STAV_HESLA, $_VYSTUP;
    global $next_hid, $prev_hid;
    $hid = $cdo->hid;
    $hinfo = $cdo->get_header_data();
    $heslo = $hinfo['hlavni_varianta'];
    $homonymie_str = $hinfo['homonymie_str'];
    $parent_heslo=$hinfo['parent_heslo'];
    $parent_heslo_hid = $hinfo['pid'];
    $vytvoreno = $hinfo['cts'];
    $zmeneno = $hinfo['uts'];
    $lexgraf_pozn = text_html_preprocess($hinfo['lexgraf_pozn']);
    $pozn_odbornik = text_html_preprocess($hinfo['pozn_odbornik']);
    $reduction_checked = '';
    if($hinfo['redukce'])
        $reduction_checked = 'checked';
    $do_vystupu_checked[NEZARAZENO] = ($hinfo['vystup'] == NEZARAZENO)? "checked" : "";
    $do_vystupu_checked[NEZARAZENO_FRAZ] = ($hinfo['vystup'] == NEZARAZENO_FRAZ)? "checked" : "";
    $do_vystupu_checked[ELEKTRONICKY] = ($hinfo['vystup'] == ELEKTRONICKY)? "checked" : "";
    $do_vystupu_checked[TISTENY] = ($hinfo['vystup'] == TISTENY)? "checked" : "";
    if($hinfo['stav'] == NOVE) {$stav = $_STAV_HESLA[NOVE]; $stavClass='noveHeslo';}
    if($hinfo['stav'] == ROZPRACOVANE) {$stav = $_STAV_HESLA[ROZPRACOVANE]; $stavClass='rozpracHeslo';}
    if($hinfo['stav'] == DOKONCENE) {$stav = $_STAV_HESLA[DOKONCENE]; $stavClass='dokoncHeslo';}
    $zpracovatele_formID = 'zpracovatele';
    $zpracovatele_vyber = $cdo->get_vybrane_hodnoty_ciselniku(ZPRACOVATELE, 'hes', $hid);
    $zpracovatele_str = implode(", ",$zpracovatele_vyber);
    $nahled_cis_data['valsNum'] = count($zpracovatele_vyber);
    $nahled_cis_data['firstVals'] = getCisFirstVals($zpracovatele_vyber);

    //KOREKTURY
    $is_corrected_stav = false; $corrected_flag_stav = ""; $corrected_cls_stav="";
    echo highlight_new_correction($cdo, "heslo-$hid--stav", $is_corrected_stav, $corrected_flag_stav, $corrected_cls_stav);
    $stav_onclick = is_archive() ? "" : "onClick=\"JS_update_stav_hesla(".$hid.", this)\"";
    if($is_corrected_stav) $stavClass .= ' is_corrected';

    $is_corrected_vystup = false; $corrected_flag_vystup = ""; $corrected_cls_vystup="";
    echo highlight_new_correction($cdo, "heslo-$hid--do_vystupu", $is_corrected_vystup, $corrected_flag_vystup, $corrected_cls_vystup);

    $is_corrected_heslar = false; $corrected_flag_heslar = ""; $corrected_cls_heslar="";
    echo highlight_new_correction($cdo, "heslo-$hid--heslar", $is_corrected_heslar, $corrected_flag_heslar, $corrected_cls_heslar);

    $is_corrected_lexgraf_pozn = false; $corrected_flag_lexgraf_pozn = ""; $corrected_cls_lexgraf_pozn = "";
    echo highlight_new_correction($cdo, "heslo-$hid--lexikograficka_poznamka", $is_corrected_lexgraf_pozn, $corrected_flag_lexgraf_pozn, $corrected_cls_lexgraf_pozn);

    $is_corrected_odbornik_pozn = false; $corrected_flag_odbornik_pozn = ""; $corrected_cls_odbornik_pozn = "";
    echo highlight_new_correction($cdo, "heslo-$hid--poznamka_odbornik", $is_corrected_odbornik_pozn, $corrected_flag_odbornik_pozn, $corrected_cls_odbornik_pozn);


    $html="";
    if($corrected_cls_vystup=='corrected')
    {
        if(($hinfo['vystup'] == NEZARAZENO))
            $html.="<input type='hidden' name='do_vystupu' value='".NEZARAZENO."' />";
        if(($hinfo['vystup'] == NEZARAZENO_FRAZ))
            $html.="<input type='hidden' name='do_vystupu' value='".NEZARAZENO_FRAZ."' />";
        if(($hinfo['vystup'] == ELEKTRONICKY))
            $html.="<input type='hidden' name='do_vystupu' value='".ELEKTRONICKY."' />";
        if(($hinfo['vystup'] == TISTENY))
            $html.="<input type='hidden' name='do_vystupu' value='".TISTENY."' />";
    }
    if (LEMMA_FORM_ROUTER !== 'formular_hesla') {
        $html .= '<h1>TOTO JE STARÁ VERZE FORMULÁŘE HESLA, POUŽÍVEJTE POUZE, POKUD VÍTE, CO DĚLÁTE.</h1>';
    }
    $html.="
      <div class='orangeBox'>
       <table class='w100'>
        <tr>
         <td style='width: 65%'>
          <h1 class='floatLeft'>".$heslo.$homonymie_str."</h1>
          <div class='floatLeft' style='margin-left: 60px;'>
            <a href='formular_hesla.php?hid=$prev_hid' title='předchozí heslo'><img src='css/images/prev.png' alt='&lt;&lt;'/></a>
            <a href='formular_hesla.php?hid=$next_hid' title='další heslo'><img src='css/images/next.png' alt='&gt;&gt;'/></a>
          </div>
          <div class='clear'></div>
          <div style='margin-bottom: 20px;'>
           <span class='label'>Toto heslo podřadit (jako variantu frazému) pod: </span>
           <br />
           <input id='parent_heslo' type='text' name='parent_heslo' value='$parent_heslo' class='ac_heslo_field' size='58' />
           <input id='parent_heslo-hid' type='hidden' name='parent_heslo_hid' value='$parent_heslo_hid' />
          </div>
          <div class='clear floatLeft'>
          <div class='  floatLeft correctableFieldContainer $corrected_cls_vystup' id='heslo-$hid--do_vystupu---helperIdCpy'>
           $corrected_flag_vystup
           <div class='floatLeft label'>do výstupu: </div>
           <div class='floatLeft searchThisFieldOnClick' id='heslo-$hid--do_vystupu'>
            <input type='radio' name='do_vystupu' value='".NEZARAZENO."' class='noBorder' ".$do_vystupu_checked[NEZARAZENO]."/> <label class='thinLabel'>".$_VYSTUP[NEZARAZENO]."</label> <br />
            <input type='radio' name='do_vystupu' value='".NEZARAZENO_FRAZ."' class='noBorder' ".$do_vystupu_checked[NEZARAZENO_FRAZ]."/> <label class='thinLabel'>".$_VYSTUP[NEZARAZENO_FRAZ]."</label> <br />
            <input type='radio' name='do_vystupu' value='".TISTENY."' class='noBorder' ".$do_vystupu_checked[TISTENY]." /> <label class='thinLabel'>".$_VYSTUP[TISTENY]."</label> <br />
            <input type='radio' name='do_vystupu' value='".ELEKTRONICKY."' class='noBorder' ".$do_vystupu_checked[ELEKTRONICKY]." /> <label class='thinLabel'>".$_VYSTUP[ELEKTRONICKY]."</label> <br />
           </div>
          </div>
          <div class='  floatLeft correctableFieldContainer $corrected_cls_heslar' id='heslo-$hid--heslar---helperIdCpy'>
           $corrected_flag_heslar
           <div class='floatLeft label'>typ hesláře: </div>
           <div class='floatLeft searchThisFieldOnClick' id='heslo-$hid--heslar'>";

    $cisAll = get_hodnoty_ciselniku(PROPRII,false);
    foreach($cisAll as $id => $type){
        if($id==$hinfo["heslar"])
        {
            $html.="<input type='radio' name='typ_heslare' value='".$id."' class='noBorder' checked/> <label class='thinLabel'>".$type."</label> <br />";
        }
        else
        {
            $html.="<input type='radio' name='typ_heslare' value='".$id."' class='noBorder'/> <label class='thinLabel'>".$type."</label> <br />";
        }
    }
           $html.="</div>
           </div>
           <div class='clear'></div>
          </div>
         </td>
         <td class='lightBG padd smallFont flatBox' style='width: 35%'>
            <div class='floatLeft'>
             Zpracovatel:&nbsp;$zpracovatele_str <br />
             Stav: <span id='stav' class='$corrected_cls_stav'>$stav</span>
                   <span class='correctableFieldContainer inlineFlag' id='heslo-$hid--stav'>$corrected_flag_stav</span><br />
             Vytvořeno: $vytvoreno <br />
             Změněno: $zmeneno
            </div>
            <div class='floatRight semafor butt $stavClass' $stav_onclick >
              <input type='hidden' name='stav' value='".$hinfo['stav']."' />
            </div>
         </td>
        </tr>
       </table>
       <div class='hspace'></div>
       <div>
        <label for='hid-$hid--lexikograficka_poznamka'>lexikografická poznámka (nejde do slovníku)</label> <br />
        <div id='heslo-$hid--lexikograficka_poznamka---helperIdCpy' class='correctableFieldContainer'>
          $corrected_flag_lexgraf_pozn
          <textarea name='lexikograficka_poznamka' id='hid-$hid--lexikograficka_poznamka' class='lightBG w100fix padd flatBox autosize $corrected_cls_lexgraf_pozn' rows='3'>$lexgraf_pozn</textarea>
        </div>
       </div>
        <div class='pozn_odb_wrap'>
        <div class='pozn_odb_show clickable label'><img src='css/images/roll_out.png' alt='Rozbalit' />Poznámka pro odborníka (nejde do slovníku)</div>
        <div class='correctableFieldContainer pozn_odb_block' style='display:none;'>
          <label>Poznámka pro odborníka (nejde do slovníku)</label>
          <div id='heslo-$hid--poznamka_odbornik---helperIdCpy' class='correctableFieldContainer'>
          $corrected_flag_odbornik_pozn
          <textarea name='poznamka_odbornik' id='hid-$hid--poznamka_odbornik' class='lightBG w100fix padd flatBox autosize $corrected_cls_odbornik_pozn' rows='3'>$pozn_odbornik</textarea>
          </div>
          <div class='pozn_odb_hide label clickable'><img src='css/images/roll_in.png' alt='Skrýt' />Skrýt</div>
        </div>
       </div>
       <div class='hspace'></div>
       <div class='label'>zpracovatel:</div>
       <div class='floatLeft' style='width:360px'>
        ".nahled_ciselniku($cdo, $nahled_cis_data, $zpracovatele_formID)."
       </div>
       ".form_ciselniku(ZPRACOVATELE, $zpracovatele_vyber, $zpracovatele_formID, $zpracovatele_formID)."
       <div".($cdo->is_archive() ? ' style="display:none;"' : '').">
         <div class='redukce'>
           <label>Redukovat duplicity v tiskovém náhledu</label>
           <input type='checkbox' id='reduction' value='1' name='redukovat' $reduction_checked />
         </div>
         <a href='archiv.php?hid=$hid' class='archive_view_icon' target='_blank' title='Zobrazit archiv verzí'>&nbsp;</a>
              <a class='archive_save_icon' hid='$hid' title='Uložit tuto verzi do archivu'>&nbsp;</a>
         <span class='live_butt' title='Zobrazit/skrýt živý náhled'>&nbsp;</span>
         ".(is_admin(get_logged_user())? '<a href="xml_export.php?hid='.$hid.'" class="xmlExport_butt" target="_blank" title="XML výstup">&nbsp;</a>' : '')."
         <a href='tisk_hesel_new.php?hid=$hid&amp;page=heslo_varianty&amp;action=preview' class='preview_butt' target='_blank' title='Tiskový výstup (Word)'>&nbsp;</a>
         <a href='tisk_hesel_new.php?hid=$hid&amp;page=heslo_varianty&amp;action=export' id='pdf_export' target='_blank' class='exportHesla_butt' title='Tiskový výstup (PDF)'>&nbsp;</a>
         <a href='tisk_hesel_new.php?hid=$hid&amp;page=heslo_varianty' target='_blank' class='nahledHesla_butt' title='Tiskový náhled (HTML) s redakčním modulem'>&nbsp;</a>
         <a href='korektury_historie.php?hid=$hid' class='history_butt' title='Historie korektur hesla' target='_blank'>&nbsp;</a>

         <a href='heslar.php' class='heslar_butt' title='Heslář'>&nbsp;</a>
         <div class='qSearch_butt clickable' title='Rychlé vyhledávání'></div>
       </div>
       ".($cdo->is_archive() ? '<img class="archive_load_icon" aid="'.getArchid().'" src="css/images/archive-up.png" alt="Nahrát" title="Nahrát verzi z archivu" />' : '');
    $html.=" <div class='clear'></div>";
    $html.="</div>";
    return $html;
}

function vyslovnost($cdo, $parent, $multiContainerDOMid, $pid, $pid2=False, $vysl_id=0){
    $created = False;
    if($vysl_id==0){
        $created = True;
        $vysl_id = $cdo->add_empty('vyslovnost', $parent, $pid, $pid2);
    }
    if ($parent == 'var'){
        $input_name = 'varianta['.$pid.'][vyslovnost]['.$vysl_id.']';
    }elseif($parent == 'podh') {
        $multiContainerDOMid = 'podhesli-'.$pid.'--vyslovnost';
        $input_name = 'vyznam['.$pid2.'][podh_vyz]['.$pid.'][vyslovnost]['.$vysl_id.']';
    }else{
        return '';
    }

    $text = ""; $koment = "";
    if(!$created) {
        $d = $cdo->get_part('vyslovnost_'.$parent, $pid, $vysl_id);
        $text = text_html_preprocess($d['vyslovnost']);
        $koment = text_html_preprocess($d['komentar']);
    }

    $is_corrected = false; $corrected_flag = ""; $corrected_cls="";
    echo highlight_new_correction($cdo, "$multiContainerDOMid-$vysl_id--tvar", $is_corrected, $corrected_flag, $corrected_cls);
    $is_corrected_kom = false; $corrected_flag_kom = ""; $corrected_cls_kom="";
    echo highlight_new_correction($cdo, "$multiContainerDOMid-$vysl_id--komentar", $is_corrected_kom, $corrected_flag_kom, $corrected_cls_kom);

    $multiHtml= "<div class='multiInput correctableFieldContainer' id='$multiContainerDOMid-$vysl_id' >";

    //$multiHtml.= addFields_butt_ajax('vyslovnost', $multiContainerDOMid, array('var_id'=>$var_id))."&nbsp";
    $multiHtml.= remFields_butt_ajax();
    $multiHtml.= "
    <span id='$multiContainerDOMid-$vysl_id--tvar' class='correctableFieldContainer'>
      $corrected_flag
      <input type='text' name='".$input_name."[text]' value='$text' class='textField $corrected_cls' style='width: 50px' />&nbsp;
    </span>";
    $multiHtml.= "
    <span class='label'>kom.:</span>
    <span id='$multiContainerDOMid-$vysl_id--komentar' class='correctableFieldContainer'>
     $corrected_flag_kom
     <input type='text' name='".$input_name."[komentar]' value='$koment' class='textField $corrected_cls_kom' style='width: 125px' />
    </span>";
    $multiHtml.= "</div>";
    return $multiHtml;
}

function vyslovnosti($cdo, $parent, $pid, $pid2=False){
    if ($parent == 'var'){
        $multiContainerDOMid = 'varianta-'.$pid.'--vyslovnost';
        $ajax_par = array('parent' => 'var', 'pid' => $pid, 'pid2' => 0);
    }elseif ($parent == 'podh'){
        $multiContainerDOMid = 'podh_vyz-'.$pid.'--vyslovnost';
        $ajax_par = array('parent' => 'podh', 'pid' => $pid, 'pid2' => $pid2);
    }else{
        return '';
    }
    $vyslovnosti_ids = $cdo->get_part('vyslovnosti_'.$parent, $pid);
    $html="";
    $html.="<div id='$multiContainerDOMid' class='multiContainer'>";
    if(empty($vyslovnosti_ids)){
        $html.= vyslovnost($cdo, $parent, $multiContainerDOMid, $pid, $pid2, 0);
    }else{
        foreach($vyslovnosti_ids as $vysl_id){
            $html.= vyslovnost($cdo, $parent, $multiContainerDOMid, $pid, $pid2, $vysl_id);
        }
    }
    $html.="</div>";
    $html.="<div class='tlacitkoRemField' style='left:-27px'>";
    $html.= addFields_butt_ajax('vyslovnost', $multiContainerDOMid, $ajax_par, 'výslovnost');
    $html.= "</div>";
    return $html;
}

function slovne_druhy($cdo, $parent, $pid, $pid2=False){
    if ($parent == 'var'){
        $multiContainerDOMid = "varianta-$pid--slovnyDruh";
        $ajax_req = 'slovny_druh';
        $ajax_par = array('var_id' => $pid);
    }elseif ($parent == 'vyz'){
        $multiContainerDOMid = "vyznam-$pid--slovnyDruh";
        $ajax_par = array('vyz_id' => $pid);
        $ajax_req = 'slovny_druh_vyz';
    }elseif ($parent == 'podh'){
        $multiContainerDOMid = "podhesli-$pid--slovnyDruh";
        $ajax_par = array('podh_id' => $pid, 'vyz_id' => $pid2);
        $ajax_req = 'podhesli_slovni_druh';
    }else{
        return '';
    }
    $html="";
    $html.="<div id='$multiContainerDOMid' class='multiContainer'>";
    $slovDruhy_db = $cdo->get_part('slov_druhy_'.$parent, $pid, $pid2);
    if(empty($slovDruhy_db)){
        $html.=slovny_druh($cdo, $multiContainerDOMid, $parent, $pid, 0, $pid2);
    }else{
        foreach($slovDruhy_db as $slDr_id){
            $html.=slovny_druh($cdo, $multiContainerDOMid, $parent, $pid, $slDr_id, $pid2);
        }
    }
    $html.="</div>";
    $html.="<div class='tlacitkoRemField' >";
    //$html.=addFields_butt_ajax($ajax_req, $multiContainerDOMid, $ajax_par, 'slovní druh');
    $html.="</div>";
    return $html;
}

function slovny_druh($cdo, $multiContainerDOMid, $parent, $pid, $slDruh_id=0, $add_id=False){
    if(is_numeric($slDruh_id) && $slDruh_id > 0) {
        $koment = text_html_preprocess($cdo->get_part('slov_druh_komentar_'.$parent, $pid, $slDruh_id));
    }else{
        $koment = '';
        $slDruh_id = $cdo->add_empty('slovni_druh', $parent, $pid);
    }
    if ($parent == 'var'){
        $input = 'varianta['.$pid.'][slovny_druh]['.$slDruh_id.']';
    }elseif ($parent == 'vyz') {
        $input = 'vyznam['.$pid.'][slovny_druh]['.$slDruh_id.']';
    }elseif ($parent == 'podh') {
        $input = 'vyznam['.$add_id.'][podh_vyz]['.$pid.'][slovny_druh]['.$slDruh_id.']';
    }else{
        return '';
    }
    $input_vyber = $input . '[cisVyber]';
    $input_koment = $input . '[koment]';
    $cis_vyber = $cdo ? $cdo->get_vybrane_hodnoty_ciselniku(SLOV_DRUHY, $parent, $pid, $slDruh_id) : array();
    $nahled_cis_data['valsNum'] = count($cis_vyber);
    $nahled_cis_data['firstVals'] = getCisFirstVals($cis_vyber);
    $multiHtml .="<div class='multiInput' id='$multiContainerDOMid-$slDruh_id' >";
    //$multiHtml.= addFields_butt_ajax('slovny_druh', $multiContainerDOMid, array('var_id'=>$var_id))."&nbsp";
    //$multiHtml.= remFields_butt_ajax();
    $multiHtml .=
        "<div class='floatLeft' style='width: 120px;'>"
        .nahled_ciselniku($cdo, $nahled_cis_data, "$multiContainerDOMid-$slDruh_id").
        "</div>";
    $multiHtml .= form_ciselniku(SLOV_DRUHY, $cis_vyber, "$multiContainerDOMid-$slDruh_id", $input_vyber);
    $fieldID = "$multiContainerDOMid-$slDruh_id--komentar";
    $is_corrected_kom = false; $corrected_flag_kom = ""; $corrected_cls_kom="";
    echo highlight_new_correction($cdo, $fieldID, $is_corrected_kom, $corrected_flag_kom, $corrected_cls_kom);

    //$multiHtml.="<label for='$fieldID'>komentář slovního druhu ...</label>";
    $multiHtml.="<span id='$fieldID' class='correctableFieldContainer'>
                  $corrected_flag_kom
                  <input type='text' name='".$input_koment."' value='$koment' class='textField clearingInput $corrected_cls_kom' style='width:240px' />
                </span>";
    $multiHtml.="</div>";
    $multiHtml.="<div class='clear'></div>";
    //$multiHtml.='<script type=\'text/javascript\'>$(\'#'.$fieldID.'\').clearingInput({blurClass: \'inFieldLabel\'});</script>';
    return $multiHtml;
}

function koncovka_tvaroslovnej_char($cdo, $multiContainerDOMid, $parent, $pid, $tvCh_id, $konc_id=0, $add_id=0){
    if(!in_array($parent, array('var', 'vyz', 'podh'))) die('Fatální chyba! [f: koncovka_tvaroslovnej_char()]');
    if ($parent == 'podh'){
        $v = 'vyznam['.$add_id.'][podh_vyz]';
        $d = $cdo->get_part('koncovka_tvarchar_podh', $pid, $tvCh_id, $konc_id);
    }elseif ($parent == 'vyz'){
        $v = 'vyznam';
        $d = $cdo->get_part('koncovka_tvarchar_vyz', $pid, $tvCh_id, $konc_id);
    }else{ //varianta
        $v = 'varianta';
        $d = $cdo->get_part('koncovka_tvarchar_var', $pid, $tvCh_id, $konc_id);
    }
    if ($konc_id){
        $text = text_html_preprocess($d['koncovka']);
        $koment = text_html_preprocess($d['komentar']);
    }else{
        $text = '';
        $koment = '';
        $konc_id = $cdo->add_empty('koncovka_tvarchar', $parent, $tvCh_id, $pid);
    }

    $is_corrected = false; $corrected_flag = ""; $corrected_cls="";
    echo highlight_new_correction($cdo, "$multiContainerDOMid-$konc_id--tvar", $is_corrected, $corrected_flag, $corrected_cls);
    $is_corrected_kom = false; $corrected_flag_kom = ""; $corrected_cls_kom="";
    echo highlight_new_correction($cdo, "$multiContainerDOMid-$konc_id--komentar", $is_corrected_kom, $corrected_flag_kom, $corrected_cls_kom);
    $multiHtml = "
    <div id='$multiContainerDOMid-$konc_id' class='multiInput'>
     ".remFields_butt_ajax()."
     <span id='$multiContainerDOMid-$konc_id--tvar' class='correctableFieldContainer'>
      $corrected_flag
      <input type='text' name='".$v."[$pid][tvarChar][$tvCh_id][koncovka][$konc_id][tvar]' value='$text' class='textField value2sort $corrected_cls' style='width: 50px' />
     </span>
     <span id='$multiContainerDOMid-$konc_id--komentar' class='correctableFieldContainer'>
      $corrected_flag_kom
      <input type='text' name='".$v."[$pid][tvarChar][$tvCh_id][koncovka][$konc_id][komentar]' value='$koment' class='textField $corrected_cls_kom' style='width: 150px' />
     </span>
    </div>
   ";
    return $multiHtml;
}

function koncovky_tvaroslovnej_char($cdo, $parent, $pid, $tvCh_id, $add_id=0){
    if(!in_array($parent, array('var', 'vyz', 'podh'))) die('Fatální chyba! [f: koncovky_tvaroslovnej_char()]');
    if ($parent == 'podh'){
        $v = 'podhesli';
        $konc_arr_db = $cdo->get_part('koncovky_tvarchar_podh', $pid, $tvCh_id);
    }elseif ($parent == 'vyz'){
        $v = 'vyznam';
        $konc_arr_db = $cdo->get_part('koncovky_tvarchar_vyz', $pid, $tvCh_id);
    }else{ //varianta
        $v =  'varianta';
        $konc_arr_db = $cdo->get_part('koncovky_tvarchar_var', $pid, $tvCh_id);
    }
    $multiContainerDOMid = "$v-$pid--tvarChar-$tvCh_id--koncovka";
    $html="";
    $html.="<div id='$multiContainerDOMid' class='multiContainer'>";
    $html.=  "<div class='smallFont'>
              <div class='floatLeft' style='width: 75px'>
                tvar
                <img src='css/images/mini_reorder.png' style='border:0; margin-left: 5px' class='clickable' onClick=\"JS_show_ordering_sb('$multiContainerDOMid', 'multiInput')\" alt='Uspořádat' />
              </div>
              <div class='floatLeft'>komentáře</div>
             </div>";
    $html.=  "<div class='clear'></div>";
    if(empty($konc_arr_db)){
        $html.=koncovka_tvaroslovnej_char($cdo, $multiContainerDOMid, $parent, $pid, $tvCh_id, 0, $add_id);
    }else{
        foreach($konc_arr_db as $konc_id){
            $html.=koncovka_tvaroslovnej_char($cdo, $multiContainerDOMid, $parent, $pid, $tvCh_id, $konc_id, $add_id);
        }
    }
    $html.="</div>";
    $html.="<div class='tlacitkoRemField'  style='left:-27px'>";
    $html.=addFields_butt_ajax('tvar_char_konc', $multiContainerDOMid, array('parent'=>$parent, 'pid'=>$pid, 'tvCh_id'=>$tvCh_id, 'add_id'=>$add_id), 'tvar');
    $html.="</div>";
    return $html;
}

function tvaroslovna_char($cdo, $multiContainerDOMid, $parent, $pid, $tvCh_id=0, $add_id=0){
    if(!in_array($parent, array('var', 'vyz', 'podh'))) die('Fatální chyba! [f: tvaroslovna_char()]');
    if ($tvCh_id){
        $cis_vyber = $cdo->get_vybrane_hodnoty_ciselniku(TVAR_CHAR, $parent, $pid, $tvCh_id);
    }else{
        $cis_vyber = array();
        $tvCh_id = $cdo->add_empty('tvarchar', $parent, $pid);
    }
    $nahled_cis_data['valsNum'] = count($cis_vyber);
    $nahled_cis_data['firstVals'] = getCisFirstVals($cis_vyber);

    $multiHtml="<div class='multiInput' id='$multiContainerDOMid-$tvCh_id'>";
    //$multiHtml.= addFields_butt_ajax('tvar_char', $multiContainerDOMid, array('parent'=>$parent, 'pid'=>$pid))."&nbsp";
    $multiHtml.= remFields_butt_ajax();

    if ($parent == 'podh'){
        $v = 'vyznam['.$add_id.'][podh_vyz]';
    }else{
        $v = ($parent=='vyz') ? 'vyznam' : 'varianta';
    }
    $multiHtml.= "<div class='floatLeft' style='width: 120px;'>
                 <div class='smallFont'>typ</div>
                 <div class='clear'>
                  <input type='hidden' value='".text_html_preprocess(getCisFirstVals($cis_vyber,2,"; "))."' class='value2sort' />
                 </div>
                 ".nahled_ciselniku($cdo, $nahled_cis_data, "$multiContainerDOMid-$tvCh_id")."
                 ".form_ciselniku(TVAR_CHAR, $cis_vyber, "$multiContainerDOMid-$tvCh_id", $v."[$pid][tvarChar][$tvCh_id][cisVyber]")."
                </div>";
    //$multiHtml.= "<div class='vspace' style='width: 25px'>&nbsp;</div>";
    $multiHtml.= "<div class='floatLeft margin4addButt'>".koncovky_tvaroslovnej_char($cdo, $parent, $pid, $tvCh_id, $add_id)."</div>";
    $multiHtml.= "<div class='hspace'></div>";
    $multiHtml.="</div>";
    return $multiHtml;
}

function tvaroslovne_char($cdo, $parent, $pid, $add_id=0){
    if(!in_array($parent, array('var', 'vyz', 'podh'))) die('Fatální chyba! [f: tvaroslovne_char()]');
    $rnd = rand(0, 10000);
    //$var_id = (is_numeric($var_id) && $var_id > 0) ? $var_id : "new$rnd";
    if ($parent == 'podh'){
        $cdo ? $tvChs_db = $cdo->get_part('tvarchary_podh', $pid) : array();
        $v = 'podhesli';
    }elseif ($parent == 'vyz'){
        $tvChs_db = $cdo->get_part('tvarchary_vyz', $pid);
        $v = 'vyznam';
    }else{ //varianta
        $tvChs_db = $cdo->get_part('tvarchary_var', $pid);
        $v = 'varianta';
    }
    $multiContainerDOMid = "$v-$pid--tvarChar";
    $html="";
    $html.="<img src='css/images/mini_reorder.png' style='border:0; margin-left: 5px' class='clickable floatLeft' onClick=\"JS_show_ordering_sb('$multiContainerDOMid', 'multiInput')\" alt='Uspořádat' />";
    $html.="<div class='label floatLeft'>tvaroslovná charakteristika</div>";
    //$html.="<div class='floatLeft vspace' style='width: 25px'>&nbsp;</div>";
    $html.="<div id='$multiContainerDOMid' class='multiContainer floatLeft margin4addButt' >";
    if(empty($tvChs_db)){
        $html.=tvaroslovna_char($cdo, $multiContainerDOMid, $parent, $pid, 0, $add_id);
    }else{
        foreach($tvChs_db as $tvCh_id){
            $html.=tvaroslovna_char($cdo,$multiContainerDOMid, $parent, $pid, $tvCh_id, $add_id);
        }
    }
    $html.="</div>";
    $html.="<div class='tlacitkoRemField'>";
    $html.=addFields_butt_ajax('tvar_char', $multiContainerDOMid, array('parent'=>$parent, 'pid'=>$pid, 'add_id'=>$add_id), 'charakteristiku');
    $html.="</div>";
    return $html;
}

function koncovka_tvaroslovnej_char_slovesa($cdo, $multiContainerDOMid, $parent, $pid, $tvCh_id, $konc_id=0, $add_id=0){
    if(!in_array($parent, array('var', 'vyz', 'podh'))) die('Fatální chyba! [f: koncovka_tvaroslovnej_char_slovesa()]');
    if ($parent == 'podh'){
        $v = 'vyznam['.$add_id.'][podh_vyz]';
        $d = $cdo->get_part('koncovka_tvarchar_sl_podh', $pid, $tvCh_id, $konc_id);
    }elseif ($parent == 'vyz'){
        $v = 'vyznam';
        $d = $cdo->get_part('koncovka_tvarchar_sl_vyz', $pid, $tvCh_id, $konc_id);
    }else{ //varianta
        $v = 'varianta';
        $d = $cdo->get_part('koncovka_tvarchar_sl_var', $pid, $tvCh_id, $konc_id);
    }
    if ($konc_id){
        $text = text_html_preprocess($d['koncovka']);
        $koment = text_html_preprocess($d['komentar']);
    }else{
        $text = '';
        $koment = '';
        $konc_id = $cdo->add_empty('koncovka_tvarchar_sl', $parent, $tvCh_id, $pid);
    }

    $is_corrected = false; $corrected_flag = ""; $corrected_cls="";
    echo highlight_new_correction($cdo, "$multiContainerDOMid-$konc_id--tvar", $is_corrected, $corrected_flag, $corrected_cls);

    $is_corrected_kom = false; $corrected_flag_kom = ""; $corrected_cls_kom="";
    echo highlight_new_correction($cdo, "$multiContainerDOMid-$konc_id--komentar", $is_corrected_kom, $corrected_flag_kom, $corrected_cls_kom);

    $multiHtml = "
    <div id='$multiContainerDOMid-$konc_id' class='multiInput'>
     ".remFields_butt_ajax()."
     <span id='$multiContainerDOMid-$konc_id--tvar' class='correctableFieldContainer'>
      $corrected_flag
      <input type='text' name='".$v."[$pid][tvarCharSl][$tvCh_id][koncovka][$konc_id][tvar]' value='$text' class='textField value2sort $corrected_cls' style='width: 50px' />
     </span>
     <span id='$multiContainerDOMid-$konc_id--komentar' class='correctableFieldContainer'>
      $corrected_flag_kom
      <input type='text' name='".$v."[$pid][tvarCharSl][$tvCh_id][koncovka][$konc_id][komentar]' value='$koment' class='textField $corrected_cls_kom' style='width: 150px' />
     </span>
    </div>
   ";
    return $multiHtml;
}

function koncovky_tvaroslovnej_char_slovesa($cdo, $parent, $pid, $tvCh_id, $add_id=0){
    if(!in_array($parent, array('var', 'vyz', 'podh'))) die('Fatální chyba! [f: koncovky_tvaroslovnej_char_slovesa()]');
    $rnd = rand(0, 10000);
    if ($parent == 'podh'){
        $v = 'podhesli';
        $konc_arr_db = $cdo->get_part('koncovky_tvarchar_sl_podh', $pid, $tvCh_id);
    }elseif ($parent == 'vyz'){
        $v = 'vyznam';
        $konc_arr_db = $cdo->get_part('koncovky_tvarchar_sl_vyz', $pid, $tvCh_id);
    }else{ //varianta
        $v =  'varianta';
        $konc_arr_db = $cdo->get_part('koncovky_tvarchar_sl_var', $pid, $tvCh_id);
    }
    $multiContainerDOMid = "$v-$pid--tvarCharSl-$tvCh_id--koncovka";  $html="";
    $html.="<div id='$multiContainerDOMid' class='multiContainer '>";
    $html.=  "<div class='smallFont'>
              <div class='floatLeft' style='width: 75px'>
               tvar
               <img src='css/images/mini_reorder.png' style='border:0; margin-left: 5px' class='clickable' onClick=\"JS_show_ordering_sb('$multiContainerDOMid', 'multiInput')\" alt='Uspořádat' />
              </div>
            <div class='floatLeft'>komentáře</div>
           </div>";
    $html.=  "<div class='clear'></div>";
    if(empty($konc_arr_db) && empty($form_data)){
        $html.=koncovka_tvaroslovnej_char_slovesa($cdo, $multiContainerDOMid, $parent, $pid, $tvCh_id, 0, $add_id);
    }else{
        if(!empty($form_data)){
            foreach($form_data as $d){
                $html.=koncovka_tvaroslovnej_char_slovesa($cdo, $multiContainerDOMid, $parent, $pid, $tvCh_id, 0, $add_id);
                $master = false;
            }
        }elseif(!empty($konc_arr_db)){
            foreach($konc_arr_db as $konc_id){
                $html.=koncovka_tvaroslovnej_char_slovesa($cdo, $multiContainerDOMid, $parent, $pid, $tvCh_id, $konc_id, $add_id);
                $master = false;
            }
        }
    }
    $html.="</div>";
    $html.="<div class='tlacitkoRemField'  style='left:-27px'>";
    $html.=addFields_butt_ajax('tvar_char_konc_sl', $multiContainerDOMid, array('parent'=>$parent, 'pid'=>$pid, 'tvCh_id'=>$tvCh_id, 'add_id'=>$add_id), 'tvar');
    $html.="</div> ";
    return $html;
}

function vyraz_predvykladu($cdo, $multiContainerDOMid, $vid, $konc_id, $link=False){
    if(is_numeric($konc_id) && $konc_id > 0) {
        $d = $cdo->get_part('vyraz_predvykladu', $konc_id, $vid);
        $text = text_html_preprocess($d['vyraz']);
        $koment = text_html_preprocess($d['komentar']);
    }else{
        if ($link){
            $konc_id = $cdo->add_empty('vyraz_predvykladu_master', 'vyz', $link);
        }else{
            $konc_id = $cdo->add_empty('vyraz_predvykladu', 'vyz', $vid);
        }
        $text = '';
        $koment = '';
    }
    $is_corrected = false;
    $corrected_flag = '';
    $corrected_cls = '';
    if ($link){
        $DOMid = 'vyznam-'.$link.'--vyraz_predvykladu_master-'.$konc_id;
        $DOMid_kom = 'vyznam-'.$link.'--komentar_predvykladu_master-'.$konc_id;
        $inp = 'vyznam['.$vid.'][vyraz_predvyk_master]['.$konc_id.'][tvar]';
        $inp_kom = 'vyznam['.$vid.'][vyraz_predvyk_master]['.$konc_id.'][komentar]';
    }else{
        $DOMid = 'vyznam-'.$vid.'--vyraz_predvykladu-'.$konc_id;
        $DOMid_kom = 'vyznam-'.$vid.'--komentar_predvykladu-'.$konc_id;
        $inp = 'vyznam['.$vid.'][vyraz_predvyk]['.$konc_id.'][tvar]';
        $inp_kom = 'vyznam['.$vid.'][vyraz_predvyk]['.$konc_id.'][komentar]';
    }
    echo highlight_new_correction(False, $DOMid, $is_corrected, $corrected_flag, $corrected_cls);
    $is_corrected_kom = false;
    $corrected_flag_kom = '';
    $corrected_cls_kom = '';
    echo highlight_new_correction(False, $DOMid_kom, $is_corrected_kom, $corrected_flag_kom, $corrected_cls_kom);
    $multiHtml = '
    <div id="'.$multiContainerDOMid.'-'.$konc_id.'" class="multiInput vyznam-'.$vid.'--tvary_predvykladu">
     '.remFields_butt_ajax().'
      <span id="'.$DOMid.'---helperIdCpy" class="correctableFieldContainer">
      '.$corrected_flag.'
       <input type="text" name="'.$inp.'" id="'.$DOMid.'" value="'.$text.'" class="vyraz_tvar ant_syn_check textField value2sort '.$corrected_cls.'" style="width: 50px" />
      </span>
      <span id="'.$DOMid_kom.'---helperIdCpy" class="correctableFieldContainer">
      '.$corrected_flag_kom.'
      <input type="text" name="'.$inp_kom.'" id="'.$DOMid_kom.'" value="'.$koment.'" class="vyraz_komentar ant_syn_check textField '.$corrected_cls_kom.'" style="width: 150px" />
      </span>
    </div>
   ';
    return $multiHtml;
}

function predvyklad_blok($cdo, $vyz_id, $link_id, $predvyklad_link){
    $d = $cdo->get_part('vyznam', $vyz_id);
    $predvyklad = $d['predvyklad'];
    $zacatek_predvykladu = $d['zacatek_predvykladu'];
    $konec_predvykladu = $d['konec_predvykladu'];

    $html = '
    <tr>
      <td colspan="2">
        <label>Předvýklad</label><br />
  ';

    if ($link_id){
        $html .= '
      <div id="vyznam-'.$vyz_id.'--predvyklad---checkbox_div" class="predvyklad-checkbox_div">
        Převzít předvýklad
        <input style="display:inline" id="vyznam-'.$vyz_id.'--predvyklad-checkbox" vyz="'.$vyz_id.'" link="'.$link_id.'" orig="'.$predvyklad_link.'"
        class="predvyklad-checkbox lcheckbox" type="checkbox"'.($predvyklad_link==1?' checked="checked"':'').' name="vyznam['.$vyz_id.'][predvyklad_link]"/>
      </div>
    ';
    }

    $is_predvykladVyz_corrected = false;
    $predvykladVyz_corrected_flag = "";
    $predvykladVyz_corrected_cls="";
    $html .= '
      </td>
    </tr>
    <tr>
      <td colspan="2">
        <table class="predvyklad_table">
          <tr>
            <td>
              <label>začátek předvýkladu</label>
  ';
    if($link_id && $predvyklad_link == 1){ //pokud je linkovaný předvýklad
        $skupiny_dis=$skupiny_dis||$is_zacatek_predvykladVyz_corrected;

        $blokuj_checkbox_predvykladu = false;
        $is_zacatek_predvykladVyz_master_corrected = false;
        $zacatek_predvykladVyz_master_corrected_flag = "";
        $zacatek_predvykladVyz_master_corrected_cls="";
        echo highlight_new_correction(False, "vyznam-$link_id--zacatek_predvykladu_master", $is_zacatek_predvykladVyz_master_corrected, $zacatek_predvykladVyz_master_corrected_flag, $zacatek_predvykladVyz_master_corrected_cls);

        $skupiny_dis=$skupiny_dis||$is_zacatek_predvykladVyz_master_corrected;
        if($is_zacatek_predvykladVyz_master_corrected){
            $blokuj_checkbox_predvykladu = true;
        }
        $html .= '
      <div id="vyznam-'.$link_id.'--zacatek_predvykladu_master---helperIdCpy" class="correctableFieldContainer zacatek_predvykladu_master_wrapper">'.
            $zacatek_predvykladVyz_master_corrected_flag.'
        <input type="text" name="vyznam['.$vyz_id.'][zacatek_predvykladu_master]" id="vyznam-'.$link_id.'--zacatek_predvykladu_master" class="ant_syn_check zacatek_predvykladu_master '.$zacatek_predvykladVyz_master_corrected_cls.'" value="'.$zacatek_predvykladu.'" />
      </div>
    ';
    }else{ //pokud není linkovaný předvýklad
        $is_zacatek_predvykladVyz_corrected = false;
        $zacatek_predvykladVyz_corrected_flag = "";
        $zacatek_predvykladVyz_corrected_cls="";
        echo highlight_new_correction($cdo, "vyznam-$vyz_id--zacatek_predvykladu", $is_zacatek_predvykladVyz_corrected, $zacatek_predvykladVyz_corrected_flag, $zacatek_predvykladVyz_corrected_cls);
        $html .= '
      <div id="vyznam-'.$vyz_id.'--zacatek_predvykladu---helperIdCpy" class="correctableFieldContainer zacatek_predvykladu_wrapper">'.
            $zacatek_predvykladVyz_corrected_flag.'
        <input type="text" name="vyznam['.$vyz_id.'][zacatek_predvykladu]" id="vyznam-'.$vyz_id.'--zacatek_predvykladu" class="ant_syn_check '.$zacatek_predvykladVyz_corrected_cls.'" value="'.$zacatek_predvykladu.'" />
      </div>
    ';
    }
    $html .= '
    </td>
    <td class="ant_syn_check">
      <div id="vyznam-'.$vyz_id.'--komentar_predvykladu_wrapper" class="  komentar_predvykladu_wrapper">
        '.vyrazy_predvykladu($cdo, $vyz_id, ($link_id && $predvyklad_link == 1 ? $link_id : False)).'
      </div>
    </td>
    <td>
      <label>konec předvýkladu</label>
  ';

    if($link_id && $predvyklad_link == 1){ //pokud je linkovaný předvýklad
        $is_konec_predvykladVyz_master_corrected = false;
        $konec_predvykladVyz_master_corrected_flag = "";
        $konec_predvykladVyz_master_corrected_cls="";
        echo highlight_new_correction(False, "vyznam-$link_id--konec_predvykladu_master", $is_konec_predvykladVyz_master_corrected, $konec_predvykladVyz_master_corrected_flag, $konec_predvykladVyz_master_corrected_cls);
        $skupiny_dis=$skupiny_dis||$is_konec_predvykladVyz_master_corrected;
        if($is_konec_predvykladVyz_master_corrected){
            $blokuj_checkbox_predvykladu = true;
        }
        $html .= '
      <div id="vyznam-'.$link_id.'--konec_predvykladu_master---helperIdCpy" class="correctableFieldContainer konec_predvykladu_master_wrapper">'.
            $konec_predvykladVyz_master_corrected_flag.'
        <input type="text" name="vyznam['.$vyz_id.'][konec_predvykladu_master]" id="vyznam-'.$link_id.'--konec_predvykladu_master" class="ant_syn_check '.$konec_predvykladVyz_master_corrected_cls.' konec_predvykladu_master" value="'.$konec_predvykladu.'" />
      </div>
    ';
    }else{ //pokud není linkovaný předvýklad
        $is_konec_predvykladVyz_corrected = false;
        $konec_predvykladVyz_corrected_flag = "";
        $konec_predvykladVyz_corrected_cls="";
        echo highlight_new_correction($cdo, "vyznam-$vyz_id--konec_predvykladu", $is_konec_predvykladVyz_corrected, $konec_predvykladVyz_corrected_flag, $konec_predvykladVyz_corrected_cls);
        $skupiny_dis=$skupiny_dis||$is_konec_predvykladVyz_corrected;
        $html.= '
      <div id="vyznam-'.$vyz_id.'--konec_predvykladu---helperIdCpy" class="correctableFieldContainer konec_predvykladu_wrapper">'.
            $konec_predvykladVyz_corrected_flag.'
        <input type="text" name="vyznam['.$vyz_id.'][konec_predvykladu]" id="vyznam-'.$vyz_id.'--konec_predvykladu" class="ant_syn_check '.$konec_predvykladVyz_corrected_cls.'" value="'.$konec_predvykladu.'" />
      </div>
    ';
    }
    $html.= '
            </td>
          </tr>
        </table>
      </td>
    </tr>
  ';

    if($blokuj_checkbox_predvykladu){
        $html = str_replace("^^placeholder^^", aktivni_korektura_alert(), $html);
    }else{
        $html = str_replace("^^placeholder^^", "", $html);
    }

    return $html;
}

function metavyklad1_blok($cdo, $vyz_id, $link_id, $metavyklad1_link){
    $metavyklad1_cisVyber = $cdo->get_vybrane_hodnoty_ciselniku(METAVYKLAD1, 'vyz', $vyz_id);
    $metavyklad1_nahledCisData['valsNum'] = count($metavyklad1_cisVyber);
    $metavyklad1_nahledCisData['firstVals'] = getCisFirstVals($metavyklad1_cisVyber);
    $blokuj_checkbox_metavykladu1 = false;
    $html = '
    <tr>
    <td class="label">metavýklad 1:<br/>
  ';

    if ($link_id){
        $html .= '
      <div id="vyznam-'.$vyz_id.'--metavyklad1-checkbox_div"  class="metavyklad1-checkbox_div">
        Převzít
        <input ^^placeholder^^
          id="vyznam-'.$vyz_id.'--metavyklad1-checkbox" vyz="'.$vyz_id.'" link="'.$link_id.'"
          class="metavyklad1-checkbox lcheckbox" master="'.$link_id.'"
          style="display:inline" type="checkbox" '.($metavyklad1_link == 1 ? 'checked="checked"' : '').' name="vyznam['.$vyz_id.'][metavyklad1_link]"/>
      </div>
    ';
    }
    $html .= '
        </td>
        <td>
        <div id="vyznam-'.$vyz_id.'--metavyklad1_wrapper" class=" metavyklad1_wrapper">
  ';
    if ($link_id && $metavyklad1_link){
        $html .= nahled_ciselniku($cdo, $metavyklad1_nahledCisData, 'vyznam-'.$link_id.'--metavyklad1_master', $blokuj_checkbox_metavykladu1) .
            form_ciselniku(METAVYKLAD1, $metavyklad1_cisVyber, 'vyznam-'.$link_id.'--metavyklad1_master', 'vyznam['.$vyz_id.'][metavyklad1_master]');
    }else{
        $html .= nahled_ciselniku($cdo, $metavyklad1_nahledCisData, 'vyznam-'.$vyz_id.'--metavyklad1') .
            form_ciselniku(METAVYKLAD1, $metavyklad1_cisVyber, 'vyznam-'.$vyz_id.'--metavyklad1', 'vyznam['.$vyz_id.'][metavyklad1]');
    }
    $html .= '
        </div>
  ';
    if($blokuj_checkbox_metavykladu1){
        if($d["metavyklad1_link"]==1)$skupiny_dis=true;
        $html = str_replace("^^placeholder^^", aktivni_korektura_alert(), $html);
    } else{
        $html = str_replace("^^placeholder^^", "", $html);
    }
    $html.= '
              </td>
             </tr>
  ';
    return $html;
}

function metavyklad2_blok($cdo, $vyz_id, $link_id, $metavyklad2_link){
    $html="";
    $d = $cdo->get_part('vyznam', $vyz_id);
    $metavyklad2 = $d["metavyklad2"];
    $metavyklad2_readonly = "";
    $metavyklad2_checkbox = '';
    $blokuj_checkbox_metavykladu2 = false;

    if ($link_id)
    {
        $metavyklad2_checkbox = '<div id="vyznam-'.$vyz_id.'--metavyklad2-checkbox_div" class="metavyklad2-checkbox_div">
            Převzít
            <input ^^placeholder^^ id="vyznam-'.$vyz_id.'--metavyklad2-checkbox" class="metavyklad2-checkbox lcheckbox"  vyz="'.$vyz_id.'" link="'.$link_id.'"
            '.$metavyklad2_readonly.' style="display:inline" '.($metavyklad2_link == 1 ? 'checked' : '').' type="checkbox" name="vyznam['.$vyz_id.'][metavyklad2_link]"/>
          </div>';
    }
    if ($link_id && $metavyklad2_link == 1){
        $is_metavyklad2_master_corrected = false;
        $metavyklad2_master_corrected_flag = "";
        $metavyklad2_master_corrected_cls="";
        echo highlight_new_correction(False, "vyznam-$link_id--metavyklad2_master", $is_metavyklad2_master_corrected, $metavyklad2_master_corrected_flag, $metavyklad2_master_corrected_cls);
        if($is_metavyklad2_master_corrected){
            $blokuj_checkbox_metavykladu2 = true;
        }
        $html .= '
      <tr>
        <td colspan="2">
          <label for="vyznam-'.$link_id.'--metavyklad2_master">metavýklad 2</label><br/>'.$metavyklad2_checkbox.
            '<div id="vyznam-'.$link_id.'--metavyklad2_master---helperIdCpy" class="ant_syn_check correctableFieldContainer metavyklad2_master_wrapper">
           '.$metavyklad2_master_corrected_flag.'
           <textarea name="vyznam['.$vyz_id.'][metavyklad2_master]" id="vyznam-'.$link_id.'--metavyklad2_master"
            class="ant_syn_check metavyklad2_master lightBG flatBox w100fix padd oneRowTextarea '.$metavyklad2_master_corrected_cls.' metavyklad2txt">'.$metavyklad2.'</textarea>
          </div>
    ';
    }
    else
    {
        $is_metavyklad2_corrected = false;
        $metavyklad2_corrected_flag = "";
        $metavyklad2_corrected_cls="";
        echo highlight_new_correction($cdo, "vyznam-$vyz_id--metavyklad2", $is_metavyklad2_corrected, $metavyklad2_corrected_flag, $metavyklad2_corrected_cls);
        if($metavyklad2_corrected_flag){
            $blokuj_checkbox_metavykladu2 = true;
            $metavyklad2_readonly = aktivni_korektura_alert();
        }
        $html .= '
      <tr>
        <td colspan="2">
          <label for="vyznam-'.$vyz_id.'--metavyklad2">metavýklad 2</label><br/>'.$metavyklad2_checkbox.
            '<div id="vyznam-'.$vyz_id.'--metavyklad2---helperIdCpy" class="ant_syn_check correctableFieldContainer metavyklad2_wrapper">
           '.$metavyklad2_corrected_flag.'
           <textarea name="vyznam['.$vyz_id.'][metavyklad2]" id="vyznam-'.$vyz_id.'--metavyklad2"
            class="ant_syn_check lightBG flatBox w100fix padd oneRowTextarea '.$metavyklad2_corrected_cls.' metavyklad2txt" >'.$metavyklad2.'</textarea>
          </div>
    ';
    }
    $html .= '</td></tr>';
    if($blokuj_checkbox_metavykladu2){
        if($d["metavyklad2_link"]==1)$skupiny_dis=true;
        $html = str_replace("^^placeholder^^", aktivni_korektura_alert(), $html);
    } else{
        $html = str_replace("^^placeholder^^", "", $html);
    }
    return $html;
}

function vyklad_vyznamu_blok($cdo, $vyz_id, $vyklad_vyznamu_link, $new_created=False){
    $html="";
    $d = $cdo->get_part('vyznam', $vyz_id);
    $vyklad_vyznamu = $d['vyklad_vyznamu'];
    $link_id = $vyklad_vyznamu_link;
    $is_vyklad_corrected = false; $vyklad_corrected_flag = ""; $vyklad_corrected_cls="";

    $vyz_mlink_flags = '';

    if(is_numeric($vyklad_vyznamu_link) && $vyklad_vyznamu_link > 0)
    {
        $vyklad_vyznamu_link_text = get_linked_vyznam_text($vyklad_vyznamu_link, $vyklad_vyznamu_link_hid, $vyklad_vyznamu_link_var, $vyz_id);
        $vyklad_vyznamu_display="none";
        $vyklad_vyznamu_link_display="block";
        $is_vyznam_link_corrected = false;
        $blokuj_vyklad_vyznamu = false;
        $vyznam_mlink_corrected_flag = "";
        $vyznam_link_corrected_cls="";
        $vyznam_link_ids = array();
        if(is_numeric($vyz_id)){
            $vyznam_link_ids = get_links($vyklad_vyznamu_link, True);
        }
        $left = 20;
        foreach($vyznam_link_ids as $vyznam_link_id){
            echo highlight_new_correction(False, "vyznam-link-$vyznam_link_id", $is_vyznam_link_corrected, $vyznam_mlink_corrected_flag, $vyznam_link_corrected_cls, $left);
            $vyz_mlink_flags .= $vyznam_mlink_corrected_flag;
            $left = $left + 20;
            if($is_vyznam_link_corrected){
                $blokuj_vyklad_vyznamu = true;
            }
        }

        echo highlight_new_correction(false, "vyznam_master-$link_id--vyklad_vyznamu", $is_vyklad_corrected, $vyklad_corrected_flag, $vyklad_corrected_cls);

        $skupiny_dis=$blokuj_vyklad_vyznamu||$is_vyklad_corrected;
    }
    else
    {
        $vyklad_vyznamu_link = "NULL";
        $vyklad_vyznamu_link_text = "";
        $vyklad_vyznamu_display="block";
        $vyklad_vyznamu_link_display="none";
    }

    $html.=" <tr class='static'>";
    $html.="   <td  colspan='2'>";
    $html.=" <label>výklad významu</label>";

    $readonly = "";
    $disabled = "";
    $buttonClass = "greenButtBox";
    echo highlight_new_correction($cdo, "vyznam-$vyz_id--vyklad_vyznamu", $is_vyklad_corrected_hl, $vcf, $vcc);

    if($is_vyklad_corrected){
        $readonly = "readonly";
        $disabled = "disabled";
        $buttonClass = "greyButtBox";
    }else if($is_vyklad_corrected_hl){
        $disabled = "disabled";
        $buttonClass = "greyButtBox";
    }else if($skupiny_dis){
        $disabled = "disabled";
        $buttonClass = "greyButtBox";
    }
    if($vyklad_vyznamu_link_var!=""){
        $hesla_ze_skupinky = explode(",", $vyklad_vyznamu_link_var);
        $html .= "<input id='vyznam-$vyz_id--tlacitko_skupiny' value='Odebrat ze skupiny' $disabled class='$buttonClass buttBox  floatRight ' type='button' onclick='odebrat_ze_skupiny_old($vyz_id, \"$link_id\")' />";
        if(is_array($hesla_ze_skupinky) && count($hesla_ze_skupinky) > 2)
        {
            $pocet = count($hesla_ze_skupinky) - 2;
            if($pocet < 5)
            {
                $pocet_str = " další &gt;&gt;";
            } else{
                $pocet_str = " dalších &gt;&gt;";
            }
            $nahled_skupinky = "<div id='vyznam-$vyz_id--div_nahled_skupiny'>".$hesla_ze_skupinky[0] . ", ". $hesla_ze_skupinky[1] . "<span class='clickable' onclick='rozbal_skupinku($vyz_id)'> a ". $pocet.$pocet_str."</span></div>";
            $html .= "<div id='vyznam-$vyz_id--div_skupina' style='display:block'>
                    <div style='float:left' >Heslo je součástí skupiny hesel: <br>$nahled_skupinky</div>
                    <div id='vyznam-$vyz_id--div_cela_skupina' style='display:none'>$vyklad_vyznamu_link_var</div>
                  </div>";
        }
        else
        {
            $html .= "
            <div id='vyznam-$vyz_id--div_skupina' style='display:block'>
                <div style='float:left' >Heslo je součástí skupiny hesel: <br>$vyklad_vyznamu_link_var</div>
            </div>
        ";
        }
    }else{
        $html .= "<input id='vyznam-$vyz_id--tlacitko_skupiny' value='Přidat do skupiny' $disabled class='$buttonClass buttBox floatRight ' type='button' onclick='show_uprava_skupin(\"skupina-vyklad-$vyz_id-$num_popUp\" )' />";
        //$html .= "<div style='display:block'><div style='float:left' >Výklad významu převzít z hesla: <br> <input id='vyznam-$vyz_id--link_text' $readonly style='float:left' type='text' name='link_text' value='' class='ac_link_text $vyklad_corrected_cls' size='22' /></div>";
    }

    //konec popupu
    $html .= " </td></tr><tr class='static'><td colspan='2'>";

    $list_links = get_vyznam_links($vyz_id);
    $num_links = count($list_links);
    if ($num_links>0)
    {
        $html .= '
      <div class="varovani">
        Významy odkazující na tento význam: <p>'.print_vyznam_links($list_links).'</p>
      </div>';
    }
    $html.=print_vyznam_links_to($vyz_id, $vyklad_vyznamu_link);

    if (is_numeric($vyklad_vyznamu_link))//výklad je linkovaný
    {
        $html .= '
        <div id="vyznam_master-'.$vyz_id.'--vyklad_vyznamu---helperIdCpy" class="correctableFieldContainer">
          '.$vyklad_corrected_flag.' '.$vyz_mlink_flags.'
          <input type="hidden"  name="vyznam-'.$vyz_id.'--id" value='.$vyz_id.' id="vyznam-'.$vyz_id.'--vyklad_vyznamu_id" class="vyklad_vyznamu_id ">
          <input type="hidden"  name="vyznam['.$vyz_id.'][vyklad_vyznamu_link_old]" value="'.$vyklad_vyznamu_link.'" id="vyznam-'.$vyz_id.'--vyklad_vyznamu_link_old" />
          <input type="hidden"  name="vyznam['.$vyz_id.'][vyklad_vyznamu_link]" value='.$vyklad_vyznamu_link.' id="vyznam-'.$vyz_id.'--vyklad_vyznamu_link" class="vyklad_vyznamu_link ">

          <textarea name="vyznam['.$vyz_id.'][vyklad_vyznamu_master]" id="vyznam-'.$link_id.'--vyklad_vyznamu_master"
            class="lightBG flatBox w100fix padd mceEditor MCEtxt '.$vyklad_corrected_cls.' '.$vyznam_link_corrected_cls.'" rows="1">'.$vyklad_vyznamu.'</textarea>
          <div id="vyznam-'.$vyz_id.'_master--links" class="vyznam-master-links" master="'.$link_id.'" vyz="'.$vyz_id.'">
      ';
        $vlinks = db_get_val_arr('SELECT id, IFNULL(vyz_to, IF(heslo_id IS NULL, heslo_to, CONCAT("%", heslo_id))) AS trg FROM propojeni_vyznamu WHERE vyz_m_from='.$vyklad_vyznamu_link, array('id'=>'trg'));
        foreach ($vlinks as $id => $trg){
            $html .= '<input class="vyklad_link_input" type="hidden" name="vyznam['.$vyz_id.'][vyklad_master_link]['.$id.']" value="'.$trg.'" rel="'.$id.'" />';
        }
        $html .= '
          </div>
        </div>
      ';
    }
    else
    { //výklad významu není linkovaný
        $is_vyznam_link_corrected = false;
        $blokuj_vyklad_vyznamu = false;
        $vyznam_link_corrected_flag = "";
        $vyznam_link_corrected_cls="";
        $vyznam_link_ids = get_links($vyz_id);
        $left = 20;
        foreach($vyznam_link_ids as $vyznam_link_id){
            echo highlight_new_correction($cdo, "vyznam-link-$vyznam_link_id", $is_vyznam_link_corrected, $vyznam_link_corrected_flag, $vyznam_link_corrected_cls);
            $html.="<div class='correctableFieldContainer' id='vyznam-link-$vyznam_link_id---helperIdCpy' style='left:".$left."px;'>$vyznam_link_corrected_flag</div>";
            if($is_vyznam_link_corrected){
                $left = $left + 20;
                $blokuj_vyklad_vyznamu = true;
            }
        }
        echo highlight_new_correction($cdo, 'vyznam-'.$vyz_id.'--vyklad_vyznamu', $is_vyklad_corrected, $vyklad_corrected_flag, $vyklad_corrected_cls);
        if($is_vyklad_corrected || $blokuj_vyklad_vyznamu){
            $is_vyklad_corrected = true;
            $vyklad_corrected_cls = "corrected";
        }
        $html .= '
        <div id="vyznam-'.$vyz_id.'--vyklad_vyznamu---helperIdCpy" class="correctableFieldContainer MCEtxt">
          '.$vyklad_corrected_flag.'
          <input type="hidden"  name="vyznam-'.$vyz_id.'--id" value='.$vyz_id.' id="vyznam-'.$vyz_id.'--vyklad_vyznamu_id" class="vyklad_vyznamu_id ">
          <input type="hidden"  name="vyznam['.$vyz_id.'][vyklad_vyznamu_link_old]" value="'.$vyklad_vyznamu_link.'" id="vyznam-'.$vyz_id.'--vyklad_vyznamu_link_old" />
          <input type="hidden"  name="vyznam['.$vyz_id.'][vyklad_vyznamu_link]" value='.$vyklad_vyznamu_link.' id="vyznam-'.$vyz_id.'--vyklad_vyznamu_link" class="vyklad_vyznamu_link ">
          <textarea name="vyznam['.$vyz_id.'][vyklad_vyznamu]" id="vyznam-'.$vyz_id.'--vyklad_vyznamu"
            class="lightBG flatBox w100fix padd mceEditor '.$vyklad_corrected_cls.' '.$vyznam_link_corrected_cls.' MCEtxt" rows="1">'.$vyklad_vyznamu.'</textarea>
          <div id="vyznam-'.$vyz_id.'--links">
      ';
        $vlinks = db_get_val_arr('SELECT id, IFNULL(vyz_to, IF(heslo_id IS NULL, heslo_to, CONCAT("%", heslo_id))) AS trg FROM propojeni_vyznamu WHERE vyz_from='.$vyz_id, array('id'=>'trg'));
        foreach ($vlinks as $id => $trg){
            $html .= '<input class="vyklad_link_input" type="hidden" name="vyznam['.$vyz_id.'][vyklad_link]['.$id.']" value="'.$trg.'" rel="'.$id.'" />';
        }
        $html .= '
          </div>
        </div>
      ';
    }
    $html .= '</td></tr>';
    $html .= '<script type="text/javascript">';
    if ($new_created) $html .= '
        initTinyMCE("#vyznam-'.$vyz_id.'--vyklad_vyznamu");
        minimax_vyznamov("min", $("#vyznam-'.$vyz_id.'"));
        $("#subvyznamy-'.$vyz_id.'").parent(".subvyznamy_container").hide();
    ';
    $html .= '</script>';
    return $html;
}

function vyrazy_predvykladu($cdo, $vid, $link=False){
    if ($link){
        $multiContainerDOMid = 'vyznam-'.$link.'--vyrazPredv_master--koncovka';
    }else{
        $multiContainerDOMid = 'vyznam-'.$vid.'--vyrazPredv--koncovka';
    }
    $html='';
    $html .= '
    <div id="'.$multiContainerDOMid.'" class="multiContainer">
      <div class="smallFont">
        <div class="floatLeft" style="width: 75px">výraz
          <img src="css/images/mini_reorder.png" style="border:0; margin-left: 5px" class="clickable" onClick="JS_show_ordering_sb(\''.$multiContainerDOMid.'\', \'multiInput\')" alt="Uspořádat" />
        </div>
        <div class="floatLeft">komentáře</div>
      </div>
    <div class="clear"></div>
  ';

    $arr_db = $cdo->get_part('vyrazy_predvykladu', $vid);
    if(empty($arr_db)){
        $html .= vyraz_predvykladu($cdo, $multiContainerDOMid, $vid, 0, $link);
    }else{
        foreach($arr_db as $konc_id){
            $html .= vyraz_predvykladu($cdo, $multiContainerDOMid, $vid, $konc_id, $link);
        }
    }

    $html .= '</div>';
    $html .= '<div class="tlacitkoRemField" style="left:-27px">';
    $html .= addFields_butt_ajax('vyraz_predvykladu', $multiContainerDOMid, array('pid'=>$vid, 'link'=>intval($link)), 'výraz');
    //$html .= '<div onClick="addVyrazPredvykladu(this)" class="addRemFieldsButt whiteBG butt floatLeft">+ přidat výraz</div>';
    $html .= '</div>';
    return $html;
}


function vyraz_predvykladu_neditovatelne($multiContainerDOMid, $vid, $konc_id, $master){
    if(is_numeric($konc_id) && $konc_id > 0) {
        $d = get_db_values('vyrazy_predvykladu', array('vyraz', 'komentar'), $konc_id);
        $text = text_html_preprocess($d['vyraz']);
        $koment = text_html_preprocess($d['komentar']);
    }
    $DOMid = "vyznam-$vid--vyraz_predvykladu-link";
    $DOMid_kom = "vyznam-$vid--komentar_predvykladu-link";
    $multiHtml = '
    <div class="row">
      <div class="wrapper col"  style="width: 60px">
      '.$text.' &nbsp;
      </div>
      <div class="wrapper col" style="width: 140px" >
      '.$koment.' &nbsp;
      </div>
    </div>
   ';
    return $multiHtml;
}

function vyrazy_predvykladu_neditovatelne($vid)
{
    $multiContainerDOMid = 'vyznam-'.$vid.'--vyrazPredv--koncovka';
    $html='';
    $html .= '
    <div class="tabulkaKomentaru"  style="width: 250px">
      <div class="smallFont row">
        <div class="floatLeft col" style="width: 60px">výraz</div>
        <div class="floatLeft col"  style="width: 140px">komentáře</div>
      </div>
  ';
    $arr_db = get('vyrazy_predvykladu', $vid, array('sortorder'));
    $master = true;
    if(empty($arr_db))
    {
        $html .= vyraz_predvykladu_neditovatelne($multiContainerDOMid, $vid, 0, $master);
    }
    else
    {
        foreach($arr_db as $konc_id){
            $html .= vyraz_predvykladu_neditovatelne($multiContainerDOMid, $vid, $konc_id, $master);
            $master = false;
        }
    }
    $html.='</div>';
    return $html;
}

function vyraz_predvykladu_master($multiContainerDOMid, $vid, $konc_id, $master, $vid_m){
    $rnd = rand(0, 10000);
    $konc_id = (($konc_id==0) ? 'new'.$rnd : $konc_id);
    if(is_numeric($konc_id) && $konc_id > 0)
    {
        if(is_numeric($vid))
        {
            $d = get_db_values('vyrazy_predvykladu_m', array('vyraz', 'komentar'), $konc_id);
        }
        else
        {
            $d = get_db_values('vyrazy_predvykladu', array('vyraz', 'komentar'), $konc_id);
            $konc_id = 'new'.$rnd;
        }
        $text = text_html_preprocess($d['vyraz']);
        $koment = text_html_preprocess($d['komentar']);
    }

    $is_corrected = false;
    $corrected_flag = '';
    $corrected_cls = '';
    $DOMid = "vyznam-$vid--vyraz_predvykladu_master-$konc_id";
    echo highlight_new_correction(false, $DOMid, $is_corrected, $corrected_flag, $corrected_cls);
    $onClick = '';
    if($is_corrected){
        $onClick = "readonly onClick=\"alert('Pole obsahuje korekturu! Pro editace pole, prosím, vraťte korekturu korektorovi, nebo ji aplikujte.');\"";
    }


    $is_corrected_kom = false;
    $corrected_flag_kom = '';
    $corrected_cls_kom = '';
    $DOMid_kom = "vyznam-$vid--komentar_predvykladu_master-$konc_id";
    echo highlight_new_correction(false, $DOMid_kom, $is_corrected_kom, $corrected_flag_kom, $corrected_cls_kom);
    $onClick_kom = '';
    if($is_corrected_kom){
        $onClick_kom = "readonly onClick=\"alert('Pole obsahuje korekturu! Pro editace pole, prosím, vraťte korekturu korektorovi, nebo ji aplikujte.');\"";
    }

    $multiHtml = '
    <div id="'.$multiContainerDOMid.'-'.$konc_id.'" class="multiInput vyznam-'.$vid_m.'--tvary_predvykladu_m">
     '.remFields_butt_ajax().'
      <span id="'.$DOMid.'---helperIdCpy" class="correctableFieldContainer">
      '.$corrected_flag.'
       <input type="text" '.$onClick.' name="vyznam['.$vid_m.'][vyraz_predvyk_master]['.$konc_id.'][tvar]" id="'.$DOMid.'" value="'.$text.'" class=" textField value2sort '.$corrected_cls.'" style="width: 50px" />
      </span>
      <span id="'.$DOMid_kom.'---helperIdCpy" class="correctableFieldContainer">
      '.$corrected_flag_kom.'
      <input type="text" '.$onClick_kom.' name="vyznam['.$vid_m.'][vyraz_predvyk_master]['.$konc_id.'][komentar]" id="'.$DOMid_kom.'" value="'.$koment.'" class="  textField '.$corrected_cls_kom.'" style="width: 150px" />
      </span>
    </div>
   ';
    return "$multiHtml";
}

function vyrazy_predvykladu_master($vid, $vid_m){
    $multiContainerDOMid = 'vyznam-'.$vid.'--vyrazPredv_master--koncovka';
    $html='';
    $html .= '
    <div id="'.$multiContainerDOMid.'" class="multiContainer">
      <div class="smallFont">
        <div class="floatLeft" style="width: 75px">výraz
          <img src="css/images/mini_reorder.png" style="border:0; margin-left: 5px" class="clickable" onClick="JS_show_ordering_sb(\''.$multiContainerDOMid.'\', \'multiInput\')" alt="Uspořádat" />
        </div>
        <div class="floatLeft">komentáře</div>
      </div>
    <div class="clear"></div>
  ';
    if(is_numeric($vid))
    {
        $arr_db = get('vyrazy_predvykladu_m', $vid, array('sortorder'));
    }
    else
    {
        $arr_db = get('vyrazy_predvykladu', substr($vid,3), array('sortorder'));
    }
    $master = true;
    if(empty($arr_db)){
        $html .= vyraz_predvykladu_master($multiContainerDOMid, $vid, 0, $master, $vid_m);
    }else{
        foreach($arr_db as $konc_id){
            $html .= vyraz_predvykladu_master($multiContainerDOMid, $vid, $konc_id, $master, $vid_m);
            $master = false;
        }
    }

    $html .= '</div>';
    $html .= '<div class="tlacitkoRemField" style="left:-27px">';
    $html .= addFields_butt_ajax('vyraz_predvykladu_master', $multiContainerDOMid, array('pid'=>$vid_m), 'výraz');
    //$html .= '<div onClick="addVyrazPredvykladu(this)" class="addRemFieldsButt whiteBG butt floatLeft">+ přidat výraz</div>';
    $html .= '</div>';
    return "$html";
}


function jeden_vyraz_predvykladu($multiContainerDOMid, $parent, $vyz_id, $konc_id=0, $form_data=array(), $master=false, $dedeni=""){
    if($parent != 'vyz') die('Fatálna chyba! [f: jeden_vyraz_predvykladu()]');
    $rnd = rand(0, 10000);
    $konc_id = (($konc_id==0) ? "new$rnd" : $konc_id);
    if(is_numeric($konc_id) && $konc_id > 0) {
        $d = get_db_values('vyrazy_predvykladu', array('vyraz', 'komentar'), $konc_id);
        $text = text_html_preprocess($d['vyraz']);
        $koment = text_html_preprocess($d['komentar']);
    }
    if(!empty($form_data)){
        $text = $form_data['tvar'];
        $koment = $form_data['komentar'];
    }
    $v = ($parent=='vyz') ? 'vyznam' : 'varianta';
    /*$is_corrected = false; $corrected_flag = ""; $corrected_cls="";
    echo highlight_new_correction($cdo, "$multiContainerDOMid-$konc_id--tvar", $is_corrected, $corrected_flag, $corrected_cls);
    $is_corrected_kom = false; $corrected_flag_kom = ""; $corrected_cls_kom="";
    echo highlight_new_correction($cdo, "$multiContainerDOMid-$konc_id--komentar", $is_corrected_kom, $corrected_flag_kom, $corrected_cls_kom);*/
    $multiHtml = '
    <div id="'.$multiContainerDOMid.'-'.$konc_id.'" class="multiInput vyznam-'.$vyz_id.'--tvary_predvykladu'.$dedeni.'">
     '.remFields_butt_ajax().'
     <span id="'.$multiContainerDOMid.'-'.$konc_id.'--tvar" class="correctableFieldContainer">
      '.$corrected_flag.'
      <input type="text" name="vyznam['.$vyz_id.'][vyraz_predvyk'.$dedeni.']['.$konc_id.'][tvar]" value="'.$text.'" class="textField value2sort '.$corrected_cls.'" style="width: 50px" />
     </span>
     <span id="'.$multiContainerDOMid.'-'.$konc_id.'--komentar" class="correctableFieldContainer">
      '.$corrected_flag_kom.'
      <input type="text" name="vyznam['.$vyz_id.'][vyraz_predvyk'.$dedeni.']['.$konc_id.'][komentar]" value="'.$koment.'" class="textField '.$corrected_cls_kom.'" style="width: 150px" />
     </span>
    </div>
   ';
    return $multiHtml;
}

function tvaroslovna_char_slovesa($cdo, $multiContainerDOMid, $parent, $pid, $tvCh_id=0, $add_id=False){
    if(!in_array($parent, array('var', 'vyz', 'podh'))) die('Fatální chyba! [f: tvaroslovna_char_slovesa()]');
    if ($tvCh_id){
        $cis_vyber = $cdo->get_vybrane_hodnoty_ciselniku(TVAR_CHAR_SL, $parent, $pid, $tvCh_id);
    }else{
        $cis_vyber = array();
        $tvCh_id = $cdo->add_empty('tvarchar_sl', $parent, $pid);
    }
    $nahled_cis_data['valsNum'] = count($cis_vyber);
    $nahled_cis_data['firstVals'] = getCisFirstVals($cis_vyber);
    $rnd = rand(0, 10000);
    $tvCh_id = (($tvCh_id==0) ? "new$rnd" : $tvCh_id);
    $multiHtml="<div class='multiInput' id='$multiContainerDOMid-$tvCh_id'>";
    //$multiHtml.= addFields_butt_ajax('tvar_char_sl', $multiContainerDOMid, array('parent'=>$parent, 'pid'=>$pid))."&nbsp";
    $multiHtml.= remFields_butt_ajax();
    if ($parent == 'podh'){
        $v = 'vyznam['.$add_id.'][podh_vyz]';
    }else{
        $v = ($parent=='vyz') ? 'vyznam' : 'varianta';
    }
    $multiHtml.= "<div class='floatLeft' style='width: 120px;'>
                 <div class='smallFont'>typ</div>
                 <div class='clear'>
                  <input type='hidden' value='".text_html_preprocess(getCisFirstVals($cis_vyber, 2, "; "))."' class='value2sort' />
                 </div>
                 ".nahled_ciselniku($cdo, $nahled_cis_data, "$multiContainerDOMid-$tvCh_id")."
                 ".form_ciselniku(TVAR_CHAR_SL, $cis_vyber, "$multiContainerDOMid-$tvCh_id", $v."[$pid][tvarCharSl][$tvCh_id][cisVyber]")."
                </div>";
    //$multiHtml.= "<div class='vspace' style='width: 25px'>&nbsp;</div>";
    $multiHtml.= "<div class='floatLeft margin4addButt'>".koncovky_tvaroslovnej_char_slovesa($cdo, $parent, $pid, $tvCh_id, $add_id)."</div>";
    $multiHtml.= "<div class='hspace'></div>";
    $multiHtml.="</div>";
    return $multiHtml;
}

function tvaroslovne_char_slovesa($cdo, $parent, $pid, $add_id=0){
    if(!in_array($parent, array('var', 'vyz', 'podh'))) die('Fatální chyba! [f: tvaroslovne_char_slovesa()]');
    $rnd = rand(0, 10000);
    //$var_id = (is_numeric($var_id) && $var_id > 0) ? $var_id : "new$rnd";
    if ($parent == 'podh'){
        $cdo ? $tvChs_db = $cdo->get_part('tvarchary_sl_podh', $pid) : array();
        $v = 'podhesli';
    }elseif ($parent == 'vyz'){
        $tvChs_db = $cdo->get_part('tvarchary_sl_vyz', $pid);
        $v = 'vyznam';
    }else{ //varianta
        $tvChs_db = $cdo->get_part('tvarchary_sl_var', $pid);
        $v = 'varianta';
    }
    $multiContainerDOMid = "$v-$pid--tvarCharSl";
    $html="";
    $html.="<img src='css/images/mini_reorder.png' style='border:0; margin-left: 5px' class='clickable floatLeft' onClick=\"JS_show_ordering_sb('$multiContainerDOMid', 'multiInput')\" alt='Uspořádat' />";
    $html.="<div class='label'>tvaroslovná charakteristika slovesa</div>";
    //$html.="<div class='floatLeft vspace' style='width: 25px'>&nbsp;</div>";
    $html.="<div id='$multiContainerDOMid' class='multiContainer floatLeft margin4addButt'>";
    if(empty($tvChs_db)){
        $html.=tvaroslovna_char_slovesa($cdo, $multiContainerDOMid, $parent, $pid, 0, $add_id);
    }else{
        foreach($tvChs_db as $tvCh_id){
            $html.=tvaroslovna_char_slovesa($cdo, $multiContainerDOMid, $parent, $pid, $tvCh_id, $add_id);
        }
    }

    $html.="</div>";
    $html.="<div class='tlacitkoRemField' >";
    $html.=addFields_butt_ajax('tvar_char_sl', $multiContainerDOMid, array('parent'=>$parent, 'pid'=>$pid, 'add_id'=>$add_id), 'charakteristiku');
    $html.="</div>";
    return $html;
}

function vazebnost($cdo, $multiContainerDOMid, $parent, $id, $vaz_id=0, $add_id=False){
    // parent = 'vyz' | 'var'
    if ($parent == 'podh'){
        $parentName = 'vyznam['.$add_id.'][podh_vyz]';
    }else{
        $parentName = ($parent=='vyz') ? 'vyznam' : 'varianta';
    }
    $created = False;
    if($vaz_id==0) $created = True;

    if(!$created) {
        $d = $cdo->get_part('vazebnost_'.$parent, $id, $vaz_id);
        $text = text_html_preprocess($d['vazebnost']);
        $koment = text_html_preprocess($d['komentar']);
    }else{
        $vaz_id = $cdo->add_empty('vazebnost', $parent, $id);
        $text = '';
        $koment = '';
    }

    $is_corrected = false; $corrected_flag = ""; $corrected_cls="";
    $DOMid = "$multiContainerDOMid-$vaz_id--tvar";
    echo highlight_new_correction($cdo, $DOMid, $is_corrected, $corrected_flag, $corrected_cls);

    $is_corrected_kom = false; $corrected_flag_kom = ""; $corrected_cls_kom = "";
    $DOMidKom = "$multiContainerDOMid-$vaz_id--komentar";
    echo highlight_new_correction($cdo, $DOMidKom, $is_corrected_kom, $corrected_flag_kom, $corrected_cls_kom);

    $multiHtml = "<div class='multiInput' id='$multiContainerDOMid-$vaz_id' >";
    //$multiHtml.= addFields_butt_ajax('vazebnost', $multiContainerDOMid, array('parent'=>$parent, 'parent_id'=>$id))."&nbsp";
    //$multiHtml.= remFields_butt_ajax();
    //$multiHtml .= " <span id='$multiContainerDOMid-$vaz_id--tvar' class='correctableFieldContainer'>$corrected_flag<input type='text' name='".$parentName."[$id][vazebnost][$vaz_id][text]' value='$text' class='textField $corrected_cls' style='width: ".(($parent=='vyz')?"445px":"280px")."' /></span>";
    $multiHtml .= "<div class='center butt blueBG symbolButt' onclick='insert_symbol(\"|\", \"$multiContainerDOMid-$vaz_id--tvar--helperCpy\")'>|</div>
                 <div class='center butt blueBG symbolButt' onclick='insert_symbol(\"~\", \"$multiContainerDOMid-$vaz_id--tvar--helperCpy\")'>~</div>
                 <div class='center butt blueBG symbolButt' onclick='insert_symbol(\"{}\", \"$multiContainerDOMid-$vaz_id--tvar--helperCpy\")'>{}</div>
                 <div class='center butt blueBG symbolButt' onclick='insert_symbol(\"„“\", \"$multiContainerDOMid-$vaz_id--tvar--helperCpy\")'>„“</div><div>&nbsp;</div>";
    $multiHtml .= "
    <div id='$DOMid' class='correctableFieldContainer'>
      $corrected_flag
      <textarea name='".$parentName."[$id][vazebnost][$vaz_id][text]' id='$DOMid--helperCpy' class='flatBox lightBG padd oneRowTextarea autosize $corrected_cls' style='width: ".(($parent=='podh' || $parent == 'vyz')?"775px":"350px")."'>$text</textarea>
    </div>";
    //if($parent!='vyz') $multiHtml .= "<br/>";
    $multiHtml .= " <span class='label'>kom.:</span></br><span id='$DOMidKom' class='correctableFieldContainer'>$corrected_flag_kom<input type='text' name='".$parentName."[$id][vazebnost][$vaz_id][komentar]' value='$koment' class='textField $corrected_cls_kom' style='width: ".(($parent=='vyz')?"780px":"310px")."; margin: 5px 0 5px 0;' /></span>";
    $multiHtml .= "</div>";
    return $multiHtml;
}

function vazebnosti($cdo, $parent, $id, $add_id=False){
    if ($parent == 'podh'){
        $parentName = 'podhesli';
        $vazebnosti_db_ids = $cdo->get_part('vazebnosti_podh', $id);
    }elseif ($parent == 'vyz'){
        $parentName = 'vyznam';
        $vazebnosti_db_ids = $cdo->get_part('vazebnosti_vyz', $id);
    }elseif ($parent == 'var'){
        $parentName = 'varianta';
        $vazebnosti_db_ids = $cdo->get_part('vazebnosti_var', $id);
    }else{
        return '';
    }
    $multiContainerDOMid = "$parentName-$id--vazebnost";
    $html="";
    $html.="<div id='$multiContainerDOMid' class='multiContainer'>";
    if(empty($vazebnosti_db_ids)) {
        $html.= vazebnost($cdo, $multiContainerDOMid, $parent, $id, 0, $add_id);
    }else{
        foreach($vazebnosti_db_ids as $vaz_id){
            $html.= vazebnost($cdo, $multiContainerDOMid, $parent, $id, $vaz_id, $add_id);
        }
    }
    $html.="</div>";
    $html.="<div class='tlacitkoRemField'>";
    //$html.=addFields_butt_ajax('vazebnost', $multiContainerDOMid, array('parent'=>$parent, 'parent_id'=>$id, 'add_id'=>$add_id),'valenci/vazebnost');
    $html.="</div>";

    return $html;
}

function okomentovany_tvar($cdo, $var_id){
    $DOMid = "varianta-$var_id--komentar_tvaru";
    $d = $cdo->get_part('varianta', $var_id);
    $text = $d['komentar_tvaru'];
    $is_corrected = false;
    $corrected_flag = "";
    $corrected_cls="";
    echo highlight_new_correction($cdo, "varianta-$var_id--komentar_tvaru", $is_corrected, $corrected_flag, $corrected_cls);

    $html="
    <div class='clear'></div>
    <div id='$DOMid---helperIdCpy' class='correctableFieldContainer'>
     $corrected_flag
     <textarea id='$DOMid--text' name='varianta[$var_id][komentar_tvaru]' class='greenBG $mceEditor $corrected_cls' rows='3' style='width:797px;height:100px;'>$text</textarea>
      $html_korekt";


    $html .= "<script type='text/javascript'>";
    $html .= "initTinyMCE('#".$DOMid."--text');";
    $html .= "</script>";

    $html.="</div>";
    return $html;
}

function varianta($cdo, $hid, $var_id=0){
    global $_PORADI_VYSTUP; //define in konstanty.php

    $is_neosem = false;
    $homonym= "";
    $varianta="";
    $komentar="";
    //$podhesli="";
    //$komentar_podhesli = "";
    $check = array(PODHESLI_CIS => "checked='checked'");
    $prvni_reg_vyskyt="";
    $komentar_tvarchar="";
    $komentar_tvarchar_slovesa="";
    $f_var = 1;
    if(is_numeric($var_id) && $var_id > 0) {
        $d = $cdo->get_part('varianta', $var_id);
        $is_neosem = ($d['neosemantismus']=='1') ? true : false;
        $homonym = text_html_preprocess($d['homonymie']);
        $varianta = text_html_preprocess($d['varianta']);
        $komentar = text_html_preprocess($d['komentar']);
        $komentarza = text_html_preprocess($d['komentar_za']);
        //$podhesli = $d['podhesli'];
        //$komentar_podhesli = $d['komentar_podhesli'];
        $komentar_tvarchar = text_html_preprocess($d['komentar_tvarchar']);
        $komentar_tvarchar_slovesa = text_html_preprocess($d['komentar_tvarchar_slovesa']);
        $prvni_reg_vyskyt = text_html_preprocess($d['prvni_reg_vyskyt']);
        $f_var = $d['f_varianta'];
    }else{
        $var_id = $cdo->add_empty('varianta', 'hes', $hid);
    }
    if(isset($_SESSION['form_tmp_data'])){
        $d = $_SESSION['form_tmp_data'];
        $is_neosem = ($d['neosemantismus']=='1') ? true : false;
        $homonym = $d['homonymie'];
        $varianta = $d['heslo_var'];
        $komentar = $d['komentar_varianty'];
        $komentarza = $d['komentarza_varianty'];
        //$podhesli = $d['podhesli'];
        //$komentar_podhesli = $d['komentar_podhesli'];
        $prvni_reg_vyskyt = $d['prvni_registr_vyskyt'];
        $komentar_tvarchar = $d['komentar_tvarchar'];
        $komentar_tvarchar_slovesa = $d['komentar_tvarchar_slovesa'];
        $f_var = $d['f_varianta'];
    }


    $typHesla_cisVyber = $cdo->get_vybrane_hodnoty_ciselniku(TYP_HESLA, 'var', $var_id);
    if(isset($_SESSION['form_tmp_data'])) $typHesla_cisVyber = cis_ids_attach_values(TYP_HESLA, $d['typ_hesla']);
    $typHesla_nahledCisData['valsNum'] = count($typHesla_cisVyber);
    $typHesla_nahledCisData['firstVals'] = getCisFirstVals($typHesla_cisVyber);

    $stylKval_cisVyber = $cdo->get_vybrane_hodnoty_ciselniku(STYL_KVAL, 'var', $var_id);
    if(isset($_SESSION['form_tmp_data'])) $stylKval_cisVyber = cis_ids_attach_values(STYL_KVAL, $d['styl_kval']);
    $stylKval_nahledCisData['valsNum'] = count($stylKval_cisVyber);
    $stylKval_nahledCisData['firstVals'] = getCisFirstVals($stylKval_cisVyber);

    $gramInfo_cisVyber = $cdo->get_vybrane_hodnoty_ciselniku(GRAM_INFO, 'var', $var_id);
    if(isset($_SESSION['form_tmp_data'])) $gramInfo_cisVyber = cis_ids_attach_values(GRAM_INFO, $d['gram_info']);
    $gramInfo_nahledCisData['valsNum'] = count($gramInfo_cisVyber);
    $gramInfo_nahledCisData['firstVals'] = getCisFirstVals($gramInfo_cisVyber);

    $tematickeOkruhy_cisVyber = $cdo->get_vybrane_hodnoty_ciselniku(TEMATICKE_OKRUHY, 'var', $var_id);
    if(isset($_SESSION['form_tmp_data'])) $tematickeOkruhy_cisVyber = cis_ids_attach_values(TEMATICKE_OKRUHY, $d['tematicke_okruhy']);
    $tematickeOkruhy_nahledCisData['valsNum'] = count($tematickeOkruhy_cisVyber);
    $tematickeOkruhy_nahledCisData['firstVals'] = getCisFirstVals($tematickeOkruhy_cisVyber);

    $puvod_cisVyber = $cdo->get_vybrane_hodnoty_ciselniku(PUVOD, 'var', $var_id);
    if(isset($_SESSION['form_tmp_data'])) $puvod_cisVyber = cis_ids_attach_values(PUVOD, $d['puvod']);
    $puvod_nahledCisData['valsNum'] = count($puvod_cisVyber);
    $puvod_nahledCisData['firstVals'] = getCisFirstVals($puvod_cisVyber);

    $oborUziti_cisVyber = $cdo->get_vybrane_hodnoty_ciselniku(OBOR_UZITI, 'var', $var_id);
    if(isset($_SESSION['form_tmp_data'])) $oborUziti_cisVyber = cis_ids_attach_values(OBOR_UZITI, $d['obor_uziti']);
    $oborUziti_nahledCisData['valsNum'] = count($oborUziti_cisVyber);
    $oborUziti_nahledCisData['firstVals'] = getCisFirstVals($oborUziti_cisVyber);

    $varianta_is_corrected = false; $varianta_corrected_flag=""; $varianta_corrected_cls = "";
    echo highlight_new_correction($cdo, "varianta-$var_id--tvar", $varianta_is_corrected, $varianta_corrected_flag, $varianta_corrected_cls);

    $homonym_is_corrected = false; $homonym_corrected_flag=""; $homonym_corrected_cls = "";
    echo highlight_new_correction($cdo, "varianta-$var_id--homonymie", $homonym_is_corrected, $homonym_corrected_flag, $homonym_corrected_cls);

    $komentar_is_corrected = false; $komentar_corrected_flag=""; $komentar_corrected_cls = "";
    echo highlight_new_correction($cdo, "varianta-$var_id--komentar", $komentar_is_corrected, $komentar_corrected_flag, $komentar_corrected_cls);

    $komentarza_is_corrected = false; $komentarza_corrected_flag=""; $komentarza_corrected_cls = "";
    echo highlight_new_correction($cdo, "varianta-$var_id--komentarza", $komentarza_is_corrected, $komentarza_corrected_flag, $komentarza_corrected_cls);


    $podhesli_is_corrected = false; $podhesli_corrected_flag=""; $podhesli_corrected_cls = "";
    echo highlight_new_correction($cdo, "varianta-$var_id--tvar_podhesli", $podhesli_is_corrected, $podhesli_corrected_flag, $podhesli_corrected_cls);

    $kom_podhesli_is_corrected = false; $kom_podhesli_corrected_flag=""; $kom_podhesli_corrected_cls = "";
    echo highlight_new_correction($cdo, "varianta-$var_id--komentar_podhesli", $kom_podhesli_is_corrected, $kom_podhesli_corrected_flag, $kom_podhesli_corrected_cls);

    $komentar_tvarchar_is_corrected = false;
    $komentar_tvarchar_corrected_flag = "";
    $komentar_tvarchar_corrected_cls = "";
    echo highlight_new_correction($cdo, "varianta-$var_id--komentar_tvarchar", $komentar_tvarchar_is_corrected, $komentar_tvarchar_corrected_flag, $komentar_tvarchar_corrected_cls);

    $komentar_tvarchar_slovesa_is_corrected = false;
    $komentar_tvarchar_slovesa_corrected_flag = "";
    $komentar_tvarchar_slovesa_corrected_cls = "";
    echo highlight_new_correction($cdo, "varianta-$var_id--komentar_tvarchar_slovesa", $komentar_tvarchar_slovesa_is_corrected, $komentar_tvarchar_slovesa_corrected_flag, $komentar_tvarchar_slovesa_corrected_cls);


    $prvniRegVyskyt_is_corrected = false;
    $prvniRegVyskyt_corrected_flag = "";
    $prvniRegVyskyt_corrected_cls = "";
    echo highlight_new_correction($cdo, "varianta-$var_id--prvni_registr_vyskyt", $prvniRegVyskyt_is_corrected, $prvniRegVyskyt_corrected_flag, $prvniRegVyskyt_corrected_cls);

    $html="";
    $html.="
   <div class='varianta w50 floatLeft ' id='varianta-$var_id' rel='".$var_id."'>
    <div class='orangeBox'>
     <table>
     <thead></thead>
     <tbody class='data-group' group='var_main' parent-id='".$var_id."' data-prefix='varianta[".$var_id."]'>
      <tr>
       <td>
   ";
    if ($cdo->is_archive()) {
        $str = $f_var ? 'Varianta' : 'Podheslí';
        $html .= "
            <h2>$str</h2>
         ";
    } else {
        $html .= "
            <img class='var_podh_switch' src='css/images/butt_varianta_switch_".$f_var.".png' alt='var/podh' />
            <input type='hidden' name='varianta[$var_id][f_varianta]' value='".$f_var."' />
         ";
    }
    $html .= "
       </td>
       <td>
        <div>
          <div id='var_main-".$var_id."' class='data-group-status'></div>
          <span class='label'>neosémantismus:</span>
          <input type='checkbox' name='varianta[$var_id][neosemantismus]' value='1' class='noBorder' ".(($is_neosem)?"checked":"")." />&nbsp;
        </div>
        <div>
          <span class='label'>homonymie:</span>
          <span id='varianta-$var_id--homonymie' class='correctableFieldContainer'>
            $homonym_corrected_flag<input type='text' name='varianta[$var_id][homonymie]' value='$homonym' class='textField $homonym_corrected_cls' style='width: 45px' />
          </span>
        </div>
       </td>
      </tr>
      <tr>
       <td><span class='label'>heslo (var.):</span></td>
       <td>
        <span id='varianta-$var_id--tvar' class='correctableFieldContainer'>
         $varianta_corrected_flag<input type='text' name='varianta[$var_id][heslo_var]' value='$varianta' class='w100 textField value2sort $varianta_corrected_cls' />
        </span>
       </td>
      </tr>
      <tr>
       <td><span class='label'>komentář před:</span></td>
       <td>
        <span id='varianta-$var_id--komentar' class='correctableFieldContainer'>
         $komentar_corrected_flag<input type='text' name='varianta[$var_id][komentar_varianty]' value='$komentar' class='w100 textField $komentar_corrected_cls' />
        </span>
       </td>
      </tr>
      <tr>
       <td><span class='label'>komentář za:</span></td>
       <td>
        <span id='varianta-$var_id--komentarza' class='correctableFieldContainer'>
         $komentarza_corrected_flag<input type='text' name='varianta[$var_id][komentarza_varianty]' value='$komentarza' class='w100 textField $komentarza_corrected_cls' />
        </span>
       </td>
      </tr>
      </tbody>
      <tr>
       <td><span class='label'>typ hesla:</span></td>
       <td>
        ".nahled_ciselniku($cdo, $typHesla_nahledCisData, "varianta-$var_id--typ_hesla")."
        ".form_ciselniku(TYP_HESLA, $typHesla_cisVyber, "varianta-$var_id--typ_hesla", "varianta[$var_id][typ_hesla]")."
       </td>
      </tr>
      <tr>
       <td><span class='label'>výslovnost:</span></td>
       <td>".vyslovnosti($cdo, 'var', $var_id)."</td>
      </tr>";

      $style = "";
      if(!is_field_enabled($hid, "varianta--komentar_tvaru")){
        $style.="style='display:none'";
      }

     $html.="
      <tr $style>
        <td colspan='2'><span class='label'>okomentované tvary:</span></td>
      </tr>
      <tr $style>
        <td colspan='2'>".okomentovany_tvar($cdo, $var_id)."</td>
      </tr>";

      $html.="<tr>
       <td colspan='2'>
        <span class='label' style='margin-right: 80px'>slovní druh:</span>
        <span class='label' >komentář slovního druhu:</span>
        ".slovne_druhy($cdo, 'var', $var_id)."
       </td>
      </tr>

      <tr>
       <td colspan='2'>".tvaroslovne_char($cdo, 'var',$var_id)."</td>
      </tr>


      <tr>
       <td colspan='2'><span class='label'>komentář k&nbsp;tvaroslovné charakteristice:</span><br />
         <div id='varianta-$var_id--komentar_tvarchar' class='correctableFieldContainer'>
          $komentar_tvarchar_corrected_flag
          <input type='text' name='varianta[$var_id][komentar_tvarchar]' value='$komentar_tvarchar' class='w100 textField $komentar_tvarchar_corrected_cls' />
         </div>
       </td>
      </tr>


      <tr>
       <td colspan='2'>".tvaroslovne_char_slovesa($cdo, 'var', $var_id)."</td>
      </tr>


      <tr>
       <td colspan='2'><span class='label'>komentář k&nbsp;tvaroslovné charakteristice slovesa:</span><br />
         <div id='varianta-$var_id--komentar_tvarchar_slovesa' class='correctableFieldContainer'>
          $komentar_tvarchar_slovesa_corrected_flag
          <input type='text' name='varianta[$var_id][komentar_tvarchar_slovesa]' value='$komentar_tvarchar_slovesa' class='w100 textField $komentar_tvarchar_slovesa_corrected_cls' />
         </div>
       </td>
      </tr>


      <tr>
       <td colspan='2'><span class='label'>valence/vazebnost:</span><br />".vazebnosti($cdo, 'var', $var_id)."</td>
      </tr>
      <tr>
       <td><span class='label'>stylistický kvalifikátor:</span></td>
       <td>
        ".nahled_ciselniku($cdo, $stylKval_nahledCisData, "varianta-$var_id--styl_kval")."
        ".form_ciselniku(STYL_KVAL, $stylKval_cisVyber, "varianta-$var_id--styl_kval", "varianta[$var_id][styl_kval]")."
       </td>
      </tr>
      <tr>
       <td colspan='2'>
        <table class='w100'>
         <tr>
          <td style='width: 49%'>
           <div class='label'>upřesňující gram. inf.</div>
           ".nahled_ciselniku($cdo, $gramInfo_nahledCisData, "varianta-$var_id--gram_info")."
           ".form_ciselniku(GRAM_INFO, $gramInfo_cisVyber, "varianta-$var_id--gram_info", "varianta[$var_id][gram_info]")."
          <td style='width: 49%'>
           <div class='label'>tematické okruhy:</div>
           ".nahled_ciselniku($cdo, $tematickeOkruhy_nahledCisData, "varianta-$var_id--tematicke_okruhy")."
           ".form_ciselniku(TEMATICKE_OKRUHY, $tematickeOkruhy_cisVyber, "varianta-$var_id--tematicke_okruhy", "varianta[$var_id][tematicke_okruhy]")."
          </td>
         </tr>
         <tr>
          <td style='width: 49%'>
           <div class='label'>původ:</div>
           ".nahled_ciselniku($cdo, $puvod_nahledCisData, "varianta-$var_id--puvod")."
           ".form_ciselniku(PUVOD, $puvod_cisVyber, "varianta-$var_id--puvod", "varianta[$var_id][puvod]")."
          </td>
          <td style='width: 49%'>
           <div class='label'>obor/oblast užití:</div>
           ".nahled_ciselniku($cdo, $oborUziti_nahledCisData, "varianta-$var_id--obor_uziti")."
           ".form_ciselniku(OBOR_UZITI, $oborUziti_cisVyber, "varianta-$var_id--obor_uziti", "varianta[$var_id][obor_uziti]")."
          </td>
         </tr>
        </table>
       </td>
      <tr>
       <td><span class='label'>první registr. výskyt:</span></td>
       <td>
         <div id='varianta-$var_id--prvni_registr_vyskyt' class='correctableFieldContainer'>
          $prvniRegVyskyt_corrected_flag
          <input type='text' name='varianta[$var_id][prvni_registr_vyskyt]' value='$prvni_reg_vyskyt' class='w100 textField $prvniRegVyskyt_corrected_cls' />
         </div>
       </td>
      </tr>
     </table>
     <!--<div class='hspaceXXL'></div>-->
     <div class='hspaceM'></div>

     <div><input type='button' onClick=\"javascript: return JS_rem_field(this,'varianta')\" value='smazat tuto variantu' class='buttBox redButtBox needToConfirmOnClick' /></div>
    </div>
   </div>
  ";

    return $html;
}

function varianty($cdo){
    $varianty = $cdo->get_part('varianty');
    $hid = $cdo->get_hid();
    $varianty_html = "";
    if(empty($varianty)) $varianty_html = varianta($cdo, $hid);
    foreach($varianty as $var_id){
        $varianty_html .= varianta($cdo, $hid, $var_id);
        $last_var_id = $var_id;
    }

    $html="";
    $html.="
    <div>
     <div id='hlavickaVariant'>
      <h2 class='floatLeft'>Varianty hesla</h2>
      <div class='floatRight'".($cdo->is_archive() ? ' style="display:none;"' : '').">
       <input type='button' id='pridejVariantu_butt' onClick='addFields_ajaxReq(\"varianta\", \"varianty\", {\"hid\": ".$cdo->get_hid()."})' value='přidej variantu' class='buttBox greenButtBox clickable' />
       <input type='button' id='pridejKopiiVarianty_butt' rel='".$last_var_id."' onClick='addFields_ajaxReq(\"varianta_copy\", \"varianty\", {\"hid\": ".$cdo->get_hid()."})' value='přidej variantu jako kopii poslední' class='buttBox greenButtBox clickable' />
       <input type='button' id='seradVarianty' onClick=\"JS_show_ordering_sb('varianty', 'varianta')\" value='pořadí' class='buttBox yellowButtBox clickable' />
       &nbsp;<input type='submit' value='uložit' class='blueButtBox buttBox floatRight' />
      </div>
     </div>
     <div class='hspace'></div>
     <div id='varianty'>$varianty_html</div>
    </div>";

    return $html;
}

function externi_poznamka($cdo, $multiContainerDOMid, $parent, $id, $pozn_id=0){
    // $parent = vyz | hes
    $text = ""; $pozn_type = "obec.";
    if(is_numeric($pozn_id) && $pozn_id > 0) {
        $tbl = ($parent == 'vyz') ? 'ext_poznamka_vyz' : 'ext_poznamka_hes';
        $pozn = $cdo->get_part($tbl, $pozn_id, $id);
        $pozn_data['poznamka'] = $pozn['poznamka'];
        $pozn_data['cis_id'] = $pozn['cis_id'];
        $pozn_type = $pozn['typ'];
        if(empty($pozn_type)) $pozn_type = "&nbsp;";
        $text = $pozn_data['poznamka'];
    }else{
        $pozn_id = $cdo->add_empty('ext_poznamka', $parent, $id);
        $pozn_data['cis_id'] = 7;
        $pozn_type = 'obec.';
    }
    $dom_id = "$multiContainerDOMid-$pozn_id";
    $dom_name = (($parent=='vyz') ? "vyznam[$id][extPozn][$pozn_id]":"extPozn[$pozn_id]");
    $is_corrected = false; $corrected_flag = ""; $corrected_cls="";
    echo highlight_new_correction($cdo, "$multiContainerDOMid-$pozn_id--text", $is_corrected, $corrected_flag, $corrected_cls);
    $onClick = "onClick=\"JS_showEditorCiselniku('".$dom_id."_popUp', this);\"";
    $multiHtml .= "<div class='multiInput' id='$dom_id' >";
    //$multiHtml.= addFields_butt_ajax('extPozn', $multiContainerDOMid, array('parent'=>$parent, 'parent_id'=>$id), true, $dom_id."--text")."&nbsp";
    $multiHtml.= remFields_butt_ajax();
    $multiHtml .= " <div class='vspace'>&nbsp;</div>";
    $multiHtml .= $corrected_flag;
    $multiHtml .= " <div id='$dom_id--textDisp' class='border flatBox floatLeft inputFont padd extPozn correctableFieldContainer $corrected_cls' style='width: 720px; min-height: 18px' >".$text."</div>";
    $multiHtml .= " <div class='vspace'>&nbsp;</div>";
    $multiHtml .= " <div id='$dom_id--typeDisp' class='border flatBox paddS floatLeft extPozn' style='width: 50px'>$pozn_type</div>";
    $multiHtml .= " <div class='vspace'>&nbsp;</div>";
    if (!$cdo->is_archive()) {
        $multiHtml .= " <div class='center bold butt sqr yellowBG border flatBox floatLeft".($is_corrected ? ' is_corrected' : '')."' $onClick>E</div>";
    }
    $multiHtml .= " <div class='hspace'></div>";
    $multiHtml .= "</div>";
    $multiHtml .="
    <div id='".$dom_id."_popUp' class='popUp' title='Editor externí poznámky' style='width: 700px;'>
      <textarea id='".$dom_id."--text' name='".$dom_name."[text]' class='mceEditor_petit' style='width:690px' rows='6'>$text</textarea>
      ".print_typPozn_sb($dom_id, $dom_name, $pozn_data['cis_id'])."
    </div>
  ";
    return $multiHtml;
}

function externi_poznamky($cdo, $parent,$id){
    // $parent = vyz | hes
    $parentName = ($parent=='vyz') ? 'vyznam' : 'heslo';
    $extPozn_ids = $cdo->get_part('ext_poznamky_'.$parent, $id);
    $rnd = rand(0, 10000);
    $multiContainerDOMid = "$parentName-".(($id==0) ? "new$rnd" : $id)."--extPozn";
    $html="";
    $html.="<div class='label'>externí poznámky k ".(($parent=='vyz') ? "významu" : "heslu")."</div>";
    if(($parent!='vyz')) $html.="<div class='orangeBox'>";
    $html.="<div id='$multiContainerDOMid' class='multiContainer margin4addButt'>";
    if(empty($extPozn_ids)){
        $html.= externi_poznamka($cdo, $multiContainerDOMid, $parent, $id, 0);
    }else{
        foreach($extPozn_ids as $pozn_id){
            $html.= externi_poznamka($cdo, $multiContainerDOMid, $parent, $id, $pozn_id);
        }
    }
    if($parent!='vyz')
    {
        $html.="</div>";
        $html.="<div class='tlacitkoRemField'>";
        $html.=addFields_butt_ajax('extPozn', $multiContainerDOMid, array('parent'=>$parent, 'parent_id'=>$id), 'poznámku');
        $html.="</div> ";
        $html.="</div>";
    }
    else
    {
        $html.="</div>";
        $html.="<div class='tlacitkoRemField'>";
        $html.=addFields_butt_ajax('extPozn', $multiContainerDOMid, array('parent'=>$parent, 'parent_id'=>$id), 'poznámku');
        $html.="</div> ";
    }
    return $html;
}

function synonyma($cdo, $hid, $vyz_id){
    $html=print_hid_rel_ant_syn_forms($cdo, $hid, $vyz_id, 'synonymum');

    return $html;
}

function antonyma($cdo, $hid, $vyz_id){
    $html=print_hid_rel_ant_syn_forms($cdo, $hid, $vyz_id, 'antonymum');

    return $html;
}

function exemplifikacia($cdo, $multiContainerDOMid, $vyz_id, $exempl_id=0, $master=false){
    $is_in_subvyz = is_subvyznam((is_numeric($vyz_id) && $vyz_id > 0) ? $vyz_id : 0);

    $text = "";
    $vystupCheck = array(TISTENY => "checked='checked'");
    if(is_numeric($exempl_id) && $exempl_id > 0) {
        $d = $cdo->get_part('jedna_exemplifikace', $exempl_id, $vyz_id);
        $text = $d['exemplifikace'];
        if(is_numeric($d['vystup']) && $d['vystup']>=0){
            $vystupCheck = array();
            $vystupCheck[$d['vystup']] =  "checked='checked'";
        }
        $created = False;
    }else{
        $exempl_id = $cdo->add_empty('exemplifikace', 'vyz', $vyz_id);
        $vystupCheck = array(2 => 'checked="checked"');
        $created = True;
    }
    $DOMid = "$multiContainerDOMid-$exempl_id";

    $is_exempl_corrected = false; $exempl_corrected_flag = ""; $exempl_corrected_cls="";
    echo highlight_new_correction($cdo, "vyznam-$vyz_id--exemplifikacia-$exempl_id", $is_exempl_corrected, $exempl_corrected_flag, $exempl_corrected_cls);

    $multiHtml.= "<div class='multiInput' id='$DOMid'>";
    //$multiHtml.= addFields_butt_ajax('exemplifikacia', $multiContainerDOMid, array('vyz_id'=>$vyz_id))."&nbsp";
    $multiHtml.= remFields_butt_ajax();
    $mceEditor = $created ? 'mceEditorNew' : 'mceEditor';
    $multiHtml .= "
    <div>
     <div class='floatLeft label'>Exemplifikace</div>
     <div class='floatRight'>
      <span class='label'>do výstupu:</span>
      <input id='$DOMid--vystup-".NEZARAZENO."' type='radio' name='vyznam[$vyz_id][exemplifikace][$exempl_id][vystup]' value='".NEZARAZENO."' class='noBorder' ".$vystupCheck[NEZARAZENO]." /><label for='$DOMid--vystup-".NEZARAZENO."' class='thin'>nezařazeno</label>
      <input id='$DOMid--vystup-".TISTENY."' type='radio' name='vyznam[$vyz_id][exemplifikace][$exempl_id][vystup]' value='".TISTENY."' class='noBorder' ".$vystupCheck[TISTENY]." /><label for='$DOMid--vystup-".TISTENY."' class='thin'>tištěný + elektronický</label>
      <input id='$DOMid--vystup-".ELEKTRONICKY."' type='radio' name='vyznam[$vyz_id][exemplifikace][$exempl_id][vystup]' value='".ELEKTRONICKY."' class='noBorder' ".$vystupCheck[ELEKTRONICKY]." /><label for='$DOMid--vystup-".ELEKTRONICKY."' class='thin'>elektronický</label>
     </div>
    </div>
    <div class='clear'></div>
    <div id='vyznam-$vyz_id--exemplifikacia-$exempl_id---helperIdCpy' class='correctableFieldContainer'>
     $exempl_corrected_flag
     <textarea id='$DOMid--text' name='vyznam[$vyz_id][exemplifikace][$exempl_id][text]' class='greenBG $mceEditor mceEditor_italic $exempl_corrected_cls' rows='3' style='width:797px;height:100px;'>$text</textarea>
      $html_korekt";

    $num = get_db_values("exemplifikace", "sortorder", $exempl_id);
    if($is_in_subvyz)$multiHtml .= print_hid_rel_pripojeni_slave_forms($cdo, "exemplifikaceSV", $exempl_id, $num);
    else $multiHtml .= print_hid_rel_pripojeni_slave_forms($cdo, "exemplifikace", $exempl_id, $num);

    $multiHtml .= "<script type='text/javascript'>";
    if ($created) $multiHtml .= "initTinyMCE('#".$DOMid."--text');";
    $multiHtml .= "</script>";

    $multiHtml.="</div>";
    $multiHtml.="
    <div class='sortingArrows'>
     <a href='#' onClick='javascript: return JS_moveUp(this, \"multiInput\")' class='moveUp'><img src='css/images/arrow_up.png' border='0' alt='Posunout výše' /></a><br />
     <a href='#' onClick='javascript: return JS_moveDown(this, \"multiInput\")' class='moveDown'><img src='css/images/arrow_down.png' border='0' alt='Posunout níže' /></a>
    </div>";
    $multiHtml.= "<div class='hspace'></div>";
    $multiHtml.= "</div>";
    return $multiHtml;
}

function exemplifikacie($cdo, $vyz_id){
    $exempl_ids = $cdo->get_part('exemplifikace', $vyz_id);

    $multiContainerDOMid = "vyznam-$vyz_id--exemplifikacia";
    $html="";
    $html.="<div id='$multiContainerDOMid' class='multiContainer margin4addButt margin4orderArrows'>";
    $master = true;
    if(empty($exempl_ids)){
        $html.= exemplifikacia($cdo, $multiContainerDOMid, $vyz_id, 0, $master);
    }else{
        foreach($exempl_ids as $exempl_id){
            $html.= exemplifikacia($cdo, $multiContainerDOMid, $vyz_id, $exempl_id, $master);
            $master = false;
        }
    }
    $html.="</div>";
    $html.="<div class='tlacitkoRemField'>";
    $html.=addFields_butt_ajax('exemplifikacia', $multiContainerDOMid, array('vyz_id'=>$vyz_id), 'exemplifikaci');
    $html.="</div>";

    return $html;
}


function get_selectize_data($hid, $start=1)
{
    $option = array();
    $temp = array();

    if($start>0)
    {
        $sql_f2 = "
      SELECT v.id, IF(vm.id IS NOT NULL, vm.vyklad_vyznamu, v.vyklad_vyznamu) AS vyklad_vyznamu, sortorder, pid, vyklad_vyznamu_link
      FROM vyznamy v LEFT JOIN vyznamy_master vm ON v.vyklad_vyznamu_link=vm.id
      WHERE v.hid=".$hid." ORDER BY sortorder ASC
    ";
        $res_f2 = dbq($sql_f2);
        $temp = array();
        $temp[] = $rec_f["varianta"];
        $vyzn=1;
        $sub_vyz=1;
        while($rec_f2 = mysql_fetch_assoc($res_f2))
        {
            //"vyznam";
            //"value";
            //"vyklad_vyznamu";
            if($rec_f2["pid"]==0)
            {
                $temp[] = "Vyznam ".$vyzn.":";
                $vyzn++;
                $sub_vyz=1;
            }
            else
            {
                $temp[] = "Subvyznam ".$sub_vyz.":";
                $sub_vyz++;
            }
            if($rec_f2["vyklad_vyznamu_link"]>0)
            {
                $temp[] = $rec_f2["vyklad_vyznamu_link"];
                $varovani = "";
                $result = dibi::query("SELECT id, hid FROM vyznamy WHERE vyklad_vyznamu_link = ".$rec_f2["vyklad_vyznamu_link"]);
                $vyz_ids =  $result->fetchAll();
                foreach($vyz_ids as $data)
                {
                    $result_num = dibi::query("SELECT sortorder FROM vyznamy WHERE id = ".$data["id"]);
                    $counter = $result_num->fetchSingle();
                    $varovani .= text_html_preprocess(get_db_values('varianty','varianta', get_hlavni_varianta_hesla($data["hid"])))." ".$counter.", ";
                }
                $varovani = substr($varovani,0,-2);
                $temp[] = "<p style='color: #ff0000;'>Význam náleží skupině hesel $varovani</p><br>".$rec_f2["vyklad_vyznamu"];
            }
            else
            {
                $temp[] = "new".$rec_f2["id"];
                $temp[] = $rec_f2["vyklad_vyznamu"];
            }
        }
        $option[] = implode($temp, "|-|");
    }
    else
    {
        $sql_f2 = "SELECT id, vyklad_vyznamu, sortorder, pid, vyklad_vyznamu_link FROM vyznamy v WHERE v.hid=".$hid." ORDER BY sortorder ASC";
        $res_f2 = dbq($sql_f2);
        $temp = array();
        $temp[] = $rec_f["varianta"];
        if($rec_f2 = mysql_fetch_assoc($res_f2))
        {
            $temp[] = "nalinkovat";
            $temp[] = $rec_f2["vyklad_vyznamu_link"];
            $temp[] = "";
        }
        $option[] = implode($temp, "|-|");
    }
    return implode($option, "ˇˇˇ");
}


function get_linked_vyznam($vyz_id=0, &$vyz_hid, &$vyz_var, $tento_vyz_id=0)
{
    global $redakce_popups;
    $link_id = dibi::fetchSingle('SELECT vyklad_vyznamu_link FROM vyznamy WHERE id=%i', $tento_vyz_id);
    if (!$link_id){
        $link_id = $tento_vyz_id;
    }
    if(is_numeric($vyz_id))
    {
        $sql_f = "SELECT vm.vyklad_vyznamu, vm.predvyklad, vm.zacatek_predvykladu, vm.konec_predvykladu, vm.metavyklad1, vm.metavyklad2, v.hid FROM vyznamy_master vm JOIN vyznamy v ON v.vyklad_vyznamu_link=vm.id  WHERE vm.id=".$vyz_id;
        $out;
        $res_f = dbq($sql_f);
        if($rec_f = mysql_fetch_assoc($res_f))
        {
            $vyz_hid = $rec_f["hid"];
            $hl_var_id = get_hlavni_varianta_hesla($vyz_hid);
            $vyz_var = print_varianta_str($hl_var_id);
            $metavyklad1_cisVyber = get_vybrane_hodnoty_ciselniku(METAVYKLAD1_M, 'vyz', $vyz_id);
            $metavyklad1_nahledCisData['valsNum'] = count($metavyklad1_cisVyber);
            $metavyklad1_nahledCisData['firstVals'] = getCisFirstVals($metavyklad1_cisVyber);
            $out=$rec_f;
        }
        while($rec_f = mysql_fetch_assoc($res_f))
        {
            $vyz_hid = $rec_f["hid"];
            $hl_var_id = get_hlavni_varianta_hesla($vyz_hid);
            $vyz_var = $vyz_var.", ".print_varianta_str($hl_var_id);
            $metavyklad1_cisVyber = get_vybrane_hodnoty_ciselniku(METAVYKLAD1_M, 'vyz', $vyz_id);
            $metavyklad1_nahledCisData['valsNum'] = count($metavyklad1_cisVyber);
            $metavyklad1_nahledCisData['firstVals'] = getCisFirstVals($metavyklad1_cisVyber);
        }
        $out[]=vyrazy_predvykladu_master($vyz_id, $tento_vyz_id);
        //echo($vyz_id);
        $out[]="<div id='vyznam-$tento_vyz_id--metavyklad1_link_wrapper' style='display:block' class='wrapper metavyklad1_link_wrapper'>
                 ".nahled_ciselniku($cdo, $metavyklad1_nahledCisData, "vyznam-$link_id--metavyklad1_master")."
                 ".form_ciselniku(METAVYKLAD1, $metavyklad1_cisVyber, "vyznam-$link_id--metavyklad1_master", "vyznam[$tento_vyz_id][metavyklad1_master]")."
                </div>";
        $str = '';
        if ($vyz_id > 0){
            $vlinks = db_get_val_arr('SELECT id, IFNULL(vyz_to, IF(heslo_id IS NULL, heslo_to, CONCAT("%", heslo_id))) AS trg FROM propojeni_vyznamu WHERE vyz_m_from='.$vyz_id, array('id' => 'trg'));
            foreach ($vlinks as $id => $vt) {
                $str .= '<input class="vyklad_link_input" type="hidden" name="vyznam['.$tento_vyz_id.'][vyklad_master_link]['.$id.']" value="'.$vt.'" rel="'.$id.'">';
            }
        }
        $out[] = $str;
        return implode($out, "|").$redakce_popups;
    }
    else
    {
        $sql_f = "SELECT vyklad_vyznamu, predvyklad, zacatek_predvykladu, konec_predvykladu, metavyklad1, metavyklad2, hid FROM vyznamy v WHERE v.id=".substr($vyz_id,3);
        $res_f = dbq($sql_f);
        if($rec_f = mysql_fetch_assoc($res_f))
        {
            $vyz_hid = $rec_f["hid"];
            $hl_var_id = get_hlavni_varianta_hesla($vyz_hid);
            $vyz_var = print_varianta_str($hl_var_id);
            $rec_f[]=vyrazy_predvykladu_master($vyz_id, $tento_vyz_id);
            $metavyklad1_cisVyber = get_vybrane_hodnoty_ciselniku(METAVYKLAD1, 'vyz', substr($vyz_id,3));
            $metavyklad1_nahledCisData['valsNum'] = count($metavyklad1_cisVyber);
            $metavyklad1_nahledCisData['firstVals'] = getCisFirstVals($metavyklad1_cisVyber);
            $rec_f[]="<div id='vyznam-$tento_vyz_id--metavyklad1_link_wrapper' style='display:block' class='wrapper metavyklad1_link_wrapper'>
                 ".nahled_ciselniku($cdo, $metavyklad1_nahledCisData, "vyznam-$link_id--metavyklad1_master")."
                 ".form_ciselniku(METAVYKLAD1, $metavyklad1_cisVyber, "vyznam-$link_id--metavyklad1_master", "vyznam[$tento_vyz_id][metavyklad1_master]")."
                </div>";
            $str = '';
            $vlinks = db_get_val_arr('SELECT id, IFNULL(vyz_to, IF(heslo_id IS NULL, heslo_to, CONCAT("%", heslo_id))) AS trg FROM propojeni_vyznamu WHERE vyz_from='.substr($vyz_id,3), array('id' => 'trg'));
            foreach ($vlinks as $id => $vt) {
                $str .= '<input class="vyklad_link_input" type="hidden" name="vyznam['.$tento_vyz_id.'][vyklad_master_link]['.$id.']" value="'.$vt.'" rel="'.$id.'">';
            }
            $rec_f[] = $str;
            return implode($rec_f, "|").$redakce_popups;
        }
    }
    return "";
}

//rozšířené podheslí významu
function skupina_podhesli($cdo, $vyz_id){
    $podhesli = $cdo->get_part('podhesli_vyznamu', $vyz_id);
    $html = '';
    if(empty($podhesli)){
        $html .= podhesli($cdo, 0, $vyz_id, True);
    }else{
        $html .= podhesli($cdo, $podhesli[0], $vyz_id, True);
        unset($podhesli[0]);
        foreach ($podhesli as $p){
            $html .= podhesli($cdo, $p, $vyz_id, False);
        }
    }
    return $html;
}

function podhesli($cdo, $podh, $vyz_id, $first=False){
    if (is_numeric($podh) && $podh > 0){
        $d = $cdo->get_part('jedno_podhesli', $podh);
    }else{
        $podh = $cdo->add_empty('podhesli', 'vyz', $vyz_id);
        $d = array();
        $d['komentar_pred'] = '';
        $d['podhesli'] = '';
        $d['komentar_za'] = '';
        $d['komentar_tvarchar'] = '';
        $d['komentar_tvarchar_slovesa'] = '';
    }
    $gramInfo_cisVyber = $cdo->get_vybrane_hodnoty_ciselniku(GRAM_INFO, 'podh', $podh);
    if(isset($_SESSION['form_tmp_data'])) $gramInfo_cisVyber = cis_ids_attach_values(GRAM_INFO, $d['gram_info']);
    $gramInfo_nahledCisData['valsNum'] = count($gramInfo_cisVyber);
    $gramInfo_nahledCisData['firstVals'] = getCisFirstVals($gramInfo_cisVyber);
    $stylKval_cisVyber = $cdo->get_vybrane_hodnoty_ciselniku(STYL_KVAL, 'podh', $podh);
    $stylKval_nahledCisData['valsNum'] = count($stylKval_cisVyber);
    $stylKval_nahledCisData['firstVals'] = getCisFirstVals($stylKval_cisVyber);
    $tematickeOkruhy_cisVyber = $cdo->get_vybrane_hodnoty_ciselniku(TEMATICKE_OKRUHY, 'podh', $podh);
    $tematickeOkruhy_nahledCisData['valsNum'] = count($tematickeOkruhy_cisVyber);
    $tematickeOkruhy_nahledCisData['firstVals'] = getCisFirstVals($tematickeOkruhy_cisVyber);
    $oborUziti_cisVyber = $cdo->get_vybrane_hodnoty_ciselniku(OBOR_UZITI, 'podh', $podh);
    $oborUziti_nahledCisData['valsNum'] = count($oborUziti_cisVyber);
    $oborUziti_nahledCisData['firstVals'] = getCisFirstVals($oborUziti_cisVyber);

    $is_podhesli_corrected = false;
    $podhesli_corrected_flag = "";
    $podhesli_corrected_cls="";

    $is_komentar_pred_corrected = false;
    $komentar_pred_corrected_flag = "";
    $komentar_pred_corrected_cls="";

    $is_komentar_za_corrected = false;
    $komentar_za_corrected_flag = "";
    $komentar_za_corrected_cls="";

    $html = '
    <div id="podhesli-'.$podh.'" class="podhesli_vyznamu">
    <fieldset>
    <legend>Podheslí významu</legend>
    <div style="clear:both;padding:10px;">
    <div class="floatRight podhesli_keepshow"><img src="css/images/minimize.png" class="clickable minimize_podhesli" alt="Minimalizovat podheslí" /></div>
      <table class="podhesli_keepshow">
        <tr>
          <td>
            <label for="podh_vyz-'.$podh.'--kompred">komentář</label><br />';
    echo highlight_new_correction($cdo, "podhesli-$podh--komentar_podhesli", $is_komentar_pred_corrected, $komentar_pred_corrected_flag, $komentar_pred_corrected_cls);
    $html.='<span id="podhesli-'.$podh.'--komentar_podhesli" class="correctableFieldContainer">
              '.$komentar_pred_corrected_flag.'<input id="podh_vyz-'.$podh.'--kompred" type="text" name="vyznam['.$vyz_id.'][podh_vyz]['.$podh.'][komentar_pred]" value="'.$d['komentar_pred'].'" class="textField '.$komentar_pred_corrected_cls.'" style="width: 150px" maxlength="255" />
            </span>
          </td>';

    $html.= '<td>
            <label for="podhesli-'.$podh.'--tvarpodh">podheslí</label><br />';
    echo highlight_new_correction($cdo, "podhesli-$podh--tvar_podhesli", $is_podhesli_corrected, $podhesli_corrected_flag, $podhesli_corrected_cls);
    $html.='<span id="podhesli-'.$podh.'--tvar_podhesli" class="correctableFieldContainer">
             '.$podhesli_corrected_flag.'<input id="podhesli-'.$podh.'--tvarpodh" type="text" name="vyznam['.$vyz_id.'][podh_vyz]['.$podh.'][podhesli]" value="'.$d['podhesli'].'" class="textField '.$podhesli_corrected_cls.'" style="width: 430px" />
            </span>
          </td>
          <td>
            <label for="podhesli-'.$podh.'--komza">komentář</label><br />';
    echo highlight_new_correction($cdo, "podhesli-$podh--komentar_podhesli_za", $is_komentar_za_corrected, $komentar_za_corrected_flag, $komentar_za_corrected_cls);

    $html.='<span id="podhesli-'.$podh.'--komentar_podhesli_za" class="correctableFieldContainer">
              '.$komentar_za_corrected_flag.'<input id="podhesli-'.$podh.'--komza" type="text" name="vyznam['.$vyz_id.'][podh_vyz]['.$podh.'][komentar_za]" value="'.$d['komentar_za'].'" class="textField '.$komentar_za_corrected_cls.'" style="width: 150px" maxlength="255" />
            </span>
          </td>
        </tr>
      </table>
      <table style="width:470px;">
        <tr>
          <td><span class="label">výslovnost:</span></td>
          <td>'.vyslovnosti($cdo, 'podh', $podh, $vyz_id).'</td>
        </tr>
      </table>
      <table style="width:470px;">
      <tr>
       <td colspan="2">
         <table class="w100"><tr>
          <td><span class="label">valence/vazebnost:</span><br/>'.vazebnosti($cdo, 'podh', $podh, $vyz_id).'</td>
         </tr></table>
       </td>
      </tr>
      <tr>
       <td>
        <table class="w100">
         <tr>
          <td class="label">stylistický kvalifikátor:</td>
          <td>
           '.nahled_ciselniku($cdo, $stylKval_nahledCisData, 'podhesli-'.$podh.'--styl_kval').'
           '.form_ciselniku(STYL_KVAL, $stylKval_cisVyber, 'podhesli-'.$podh.'--styl_kval', 'vyznam['.$vyz_id.'][podh_vyz]['.$podh.'][styl_kval]').'
          </td>
         </tr>
        </table>
       </td>
       <td>
        <table class="w100">
         <tr>
          <td class="label">tematické okruhy:</td>
          <td>
           '.nahled_ciselniku($cdo, $tematickeOkruhy_nahledCisData, 'podhesli-'.$podh.'--tematicke_okruhy').'
           '.form_ciselniku(TEMATICKE_OKRUHY, $tematickeOkruhy_cisVyber, 'podhesli-'.$podh.'--tematicke_okruhy', 'vyznam['.$vyz_id.'][podh_vyz]['.$podh.'][tematicke_okruhy]').'
          </td>
         </tr>
        </table>
       </td>
      </tr>
      <tr>
       <td>
        <table class="w100">
         <tr>
          <td class="label">obor/oblast užití:</td>
          <td>
           '.nahled_ciselniku($cdo, $oborUziti_nahledCisData, 'podhesli-'.$podh.'--obor_uziti').'
           '.form_ciselniku(OBOR_UZITI, $oborUziti_cisVyber, 'podhesli-'.$podh.'--obor_uziti', 'vyznam['.$vyz_id.'][podh_vyz]['.$podh.'][obor_uziti]').'
          </td>
         </tr>
        </table>
       </td>
       <td>
        &nbsp;
       </td>
      </tr>
      </table>
      <table class="w100">
        <tr>
          <td>
            <span class="label" style="margin-right: 80px">slovní druh:</span>
            <span class="label" >komentář slovního druhu:</span>
            '.slovne_druhy($cdo, 'podh', $podh, $vyz_id).'
          </td>
          <td style="width: 49%">
           <div class="label">upřesňující gram. inf.:</div>
           '.nahled_ciselniku($cdo, $gramInfo_nahledCisData, 'podhesli-'.$podh.'--gram_info').'
           '.form_ciselniku(GRAM_INFO, $gramInfo_cisVyber, 'podhesli-'.$podh.'--gram_info', "vyznam[".$vyz_id."][podh_vyz][$podh][gram_info]").'
          </td>
        </tr>
        <tr>
             <td style="width: 50%">
              '.tvaroslovne_char($cdo, 'podh', $podh, $vyz_id).'
             </td>
             <td>
              '.tvaroslovne_char_slovesa($cdo, 'podh', $podh, $vyz_id).'
             </td>
        </tr>
  ';
    $is_komentar_tvarchar_corrected = false;
    $komentar_tvarchar_corrected_flag = "";
    $komentar_tvarchar_corrected_cls="";
    echo highlight_new_correction($cdo, "podhesli-$podh--komentar_tvarchar", $is_komentar_tvarchar_corrected, $komentar_tvarchar_corrected_flag, $komentar_tvarchar_corrected_cls);
    $html.= '
    <tr>
     <td colspan="2">
      <label>komentář k tvaroslovné charakteristice</label><br />
      <div id="podhesli-'.$podh.'--komentar_tvarchar" class="correctableFieldContainer">
       '.$komentar_tvarchar_corrected_flag.'
       <input type="text" name="vyznam['.$vyz_id.'][podh_vyz]['.$podh.'][komentar_tvarchar]" id="podhesli-'.$podh.'--komentar_tvarchar---helperIdCpy" class="lightBG flatBox w100 padd '.$komentar_tvarchar_corrected_cls.'" value="'.$d['komentar_tvarchar'].'" />
      </div>
     </td>
    </tr>
    ';

    $is_komentar_tvarchar_slovesa_corrected = false;
    $komentar_tvarchar_slovesa_corrected_flag = "";
    $komentar_tvarchar_slovesa_corrected_cls="";
    echo highlight_new_correction($cdo, "podhesli-$podh--komentar_tvarchar_slovesa", $is_komentar_tvarchar_slovesa_corrected, $komentar_tvarchar_slovesa_corrected_flag, $komentar_tvarchar_slovesa_corrected_cls);
    $html.= '
    <tr>
     <td colspan="2">
      <label>komentář k tvaroslovné charakteristice slovesa</label><br />
      <div id="podhesli-'.$podh.'--komentar_tvarchar_slovesa" class="correctableFieldContainer">
       '.$komentar_tvarchar_slovesa_corrected_flag.'
       <input type="text" name="vyznam['.$vyz_id.'][podh_vyz]['.$podh.'][komentar_tvarchar_slovesa]" id="podhesli-'.$podh.'--komentar_tvarchar_slovesa---helperIdCpy" class="lightBG flatBox w100 padd '.$komentar_tvarchar_slovesa_corrected_cls.'" value="'.$d['komentar_tvarchar_slovesa'].'" />
      </div>
     </td>
    </tr>
  </table>
  '.($first ? '' : '<input value="Smazat podheslí" class="redButtBox buttBox floatRight" type="button" onclick="JS_rem_field(this, \'podhesli_vyznamu\')" />').'
  </div>
  </fieldset>
  </div>
  ';


    return $html;
}

//konec rozšířeného podheslí významu

function vyznam($cdo, $vyz_id=0, $hid, $num="", $pid=0){
    global $_PORADI_VYSTUP;
    global $quick_nav; //defined in vyznamy()
    //var_dump($vyz_id);
    $issub = $pid > 0;

    $skupiny_dis=false;

    $komentar = "";
    $check = array(PODHESLI_CIS => "checked='checked'");
    $predvyklad = "";
    $komentar_tvarchar = "";
    $komentar_tvarchar_slovesa = "";
    //$metavyklad1 ="";
    //$vyklad_vyznamu ="";
    //$vyklad_vyznamu_link =0;
    $vyklad_vyznamu_link_hid =0;
    $vyklad_vyznamu_link_var ="";
    $metavyklad2 ="";
    $konc_gram_info = "";

    $vystupCheck = array(TISTENY => "checked");
    if(is_numeric($vyz_id) && $vyz_id > 0) {
        $new_created = 0;
        $first=false;
        $d = $cdo->get_part('vyznam', $vyz_id);
        $komentar = $d['komentar'];
        if(is_numeric($d['vystup']) && $d['vystup']>=0) {
            $check=array(); $check[$d['vystup']] = "checked='checked'";
        }
        $komentar_tvarchar = $d['komentar_tvarchar'];
        $komentar_tvarchar_slovesa = $d['komentar_tvarchar_slovesa'];
        //$metavyklad1 = $d['metavyklad1'];
        //var_dump($d);

        $vyklad_vyznamu = $d['vyklad_vyznamu'];
        //$metavyklad2 = $d['metavyklad2'];
        $konc_gram_info = $d['koncovka_gram_info'];

        if(is_numeric($d['typ_vystupu']) && $d['typ_vystupu']>=0){
            $vystupCheck = array();
            $vystupCheck[$d['typ_vystupu']] =  "checked";
        }
    }
    else
    {
        $vyz_id = $cdo->add_empty('vyznam', 'hes', $hid, $pid);
        $new_created = 1;
        //$vyklad_vyznamu_link = 0;
        $vyklad_vyznamu_link_text = "";
        $vyklad_vyznamu_display="block";
        $vyklad_vyznamu_link_display="none";
        $first=false;
        $d['predvyklad_link'] = 1;
        $d['metavyklad1_link'] = 1;
        $d['metavyklad2_link'] = 1;
    }

    $gramInfo_cisVyber = $cdo->get_vybrane_hodnoty_ciselniku(GRAM_INFO, 'vyz', $vyz_id);
    $gramInfo_nahledCisData['valsNum'] = count($gramInfo_cisVyber);
    $gramInfo_nahledCisData['firstVals'] = getCisFirstVals($gramInfo_cisVyber);

    $html="";
    $html.="<div class='vyznam-wrapper' id='vyznam-$vyz_id-wrapper'>";
    if(!$issub) $html.="<div class='vyznamy_quick_nav'>$quick_nav</div>";
    if($issub)$html.="<div class='subvyznam maximized box greyBox' id='vyznam-$vyz_id'>";
    else      $html.="<div class='vyznam orangeBox maximized' id='vyznam-$vyz_id'>";

    $html.="<a name='vyznam-$vyz_id'></a>";
    if($issub)
        $html.="<h3 class='floatLeft'>Výklad podvýznamu $num</h3>";
    else
        $html.="<h3 class='floatLeft'>Výklad významu $num</h3>";


    $html.="<input type='hidden' value='Význam $num' class='value2sort' />";
    $html.="<input type='hidden' value='$pid' name='vyznam[$vyz_id][vyz_pid]' />";
    $html.="<div class='floatRight' ><img src='css/images/minimize.png' class='mini-max-ico clickable minimize_vyznam' alt='Minimalizovat význam' /></div>";
    $DOMid="vyznam-$vyz_id";

    if($issub){

        $html.="<table class='small_updown_arrows floatLeft hmargin'>
               <tr><td class='up clickable' onClick='javascript: return JS_moveUp(this, \"vyznam-wrapper\")'></td></tr>
               <tr><td class='down clickable' onClick='javascript: return JS_moveDown(this, \"vyznam-wrapper\")'></td></tr>
             </table>";
        $html.="<input id='$DOMid--typ_vystupu' type='hidden' name='vyznam[$vyz_id][typ_vystupu]' value='".TISTENY."'  />";
        $html.="<div >&nbsp";
        $html.="</div>";
    }
    else
    {

        $html.="
   <div class='clear'></div>
   <div>
     <div class=''>
      <span class='label'>do výstupu:</span>
      <input id='$DOMid--typ_vystupu-".NEZARAZENO."' type='radio' name='vyznam[$vyz_id][typ_vystupu]' value='".NEZARAZENO."' class='noBorder' ".$vystupCheck[NEZARAZENO]." /><label for='$DOMid--typ_vystupu-".NEZARAZENO."' class='thin'>nezařazeno</label>
      <input id='$DOMid--typ_vystupu-".TISTENY."' type='radio' name='vyznam[$vyz_id][typ_vystupu]' value='".TISTENY."' class='noBorder' ".$vystupCheck[TISTENY]." /><label for='$DOMid--typ_vystupu-".TISTENY."' class='thin'>tištěný + elektronický</label>
      <input id='$DOMid--typ_vystupu-".ELEKTRONICKY."' type='radio' name='vyznam[$vyz_id][typ_vystupu]' value='".ELEKTRONICKY."' class='noBorder' ".$vystupCheck[ELEKTRONICKY]." /><label for='$DOMid--typ_vystupu-".ELEKTRONICKY."' class='thin'>elektronický</label>
     </div>
    </div>";
    }
    $html .= '
    <div class="skupina_podhesli_wrapper">
      <div id="skupina_podhesli_vyz-'.$vyz_id.'" class="skupina_podhesli">'.skupina_podhesli($cdo, $vyz_id).'</div>
      <input value="Přidej podheslí" class="greenButtBox buttBox floatRight" type="button" onclick="addFields_ajaxReq(\'podhesli\', \'skupina_podhesli_vyz-'.$vyz_id.'\',{vyz_id:\''.$vyz_id.'\', hid:'.$cdo->get_hid().'})" />
    </div>
   ';
    $html.="<table class='vyznam_tbl w100 clear'>
            <tr>
              <td colspan='2'>";
    //2015-04-22 zakazano stare podhesli
    /*
    $is_corrected_podhesli = false; $corrected_flag_podhesli = ""; $corrected_cls_podhesli="";
    echo highlight_new_correction($cdo, "vyznam-$vyz_id--tvar_podhesli", $is_corrected_podhesli, $corrected_flag_podhesli, $corrected_cls_podhesli);
    $is_corrected_komentar_podhesli = false; $corrected_flag_komentar_podhesli = ""; $corrected_cls_komentar_podhesli="";
    echo highlight_new_correction($cdo, "vyznam-$vyz_id--komentar_podhesli", $is_corrected_komentar_podhesli, $corrected_flag_komentar_podhesli, $corrected_cls_komentar_podhesli);
    $html.=" <tr>
               <td colspan='2'>
                <table><tr>
                  <td>
                   <label for='vyznam-$vyz_id--podhesli'>podheslí</label><br />
                   <span id='vyznam-$vyz_id--tvar_podhesli---helperIdCpy' class='correctableFieldContainer'>
                    $corrected_flag_podhesli
                    <input id='vyznam-$vyz_id--tvar_podhesli' type='text' name='vyznam[$vyz_id][podhesli]' value='$podhesli' class='textField $corrected_cls_podhesli' style='width: 430px' />
                   </span>
                  </td>
                  <td>
                   <label for='vyznam-$vyz_id--komentar_podhesli'>komentář</label><br />
                   <span id='vyznam-$vyz_id--komentar_podhesli---helperIdCpy' class='correctableFieldContainer'>
                     $corrected_flag_komentar_podhesli
                     <input id='vyznam-$vyz_id--komentar_podhesli' type='text' name='vyznam[$vyz_id][komentar]' value='$komentar' class='textField $corrected_cls_komentar_podhesli' style='width: 230px' maxlength='255' />
                   </span>
                  </td>
                  <td>
                  </td>
                 </tr>
                 </table>
   ";
   */

    $stylKval_cisVyber = $cdo->get_vybrane_hodnoty_ciselniku(STYL_KVAL, 'vyz', $vyz_id);
    $tematickeOkruhy_cisVyber = $cdo->get_vybrane_hodnoty_ciselniku(TEMATICKE_OKRUHY, 'vyz', $vyz_id);
    $oborUziti_cisVyber = $cdo->get_vybrane_hodnoty_ciselniku(OBOR_UZITI, 'vyz', $vyz_id);

    $stylKval_nahledCisData['valsNum'] = count($stylKval_cisVyber);
    $stylKval_nahledCisData['firstVals'] = getCisFirstVals($stylKval_cisVyber);
    $tematickeOkruhy_nahledCisData['valsNum'] = count($tematickeOkruhy_cisVyber);
    $tematickeOkruhy_nahledCisData['firstVals'] = getCisFirstVals($tematickeOkruhy_cisVyber);
    $oborUziti_nahledCisData['valsNum'] = count($oborUziti_cisVyber);
    $oborUziti_nahledCisData['firstVals'] = getCisFirstVals($oborUziti_cisVyber);
    $html .= '
  <table style="width:470px;">
      <tr>
       <td colspan="2">
         <table class="w100"><tr>
          <td><span class="label">valence/vazebnost:</span><br/>'.vazebnosti($cdo, 'vyz', $vyz_id).'</td>
         </tr></table>
       </td>
      </tr>
      <tr>
       <td>
        <table class="w100">
         <tr>
          <td class="label">stylistický kvalifikátor:</td>
          <td>
           '.nahled_ciselniku($cdo, $stylKval_nahledCisData, 'vyznam-'.$vyz_id.'--styl_kval').'
           '.form_ciselniku(STYL_KVAL, $stylKval_cisVyber, 'vyznam-'.$vyz_id.'--styl_kval', 'vyznam['.$vyz_id.'][styl_kval]').'
          </td>
         </tr>
        </table>
       </td>
       <td>
        <table class="w100">
         <tr>
          <td class="label">tematické okruhy:</td>
          <td>
           '.nahled_ciselniku($cdo, $tematickeOkruhy_nahledCisData, 'vyznam-'.$vyz_id.'--tematicke_okruhy').'
           '.form_ciselniku(TEMATICKE_OKRUHY, $tematickeOkruhy_cisVyber, 'vyznam-'.$vyz_id.'--tematicke_okruhy', 'vyznam['.$vyz_id.'][tematicke_okruhy]').'
          </td>
         </tr>
        </table>
       </td>
      </tr>
      <tr>
       <td>
        <table class="w100">
         <tr>
          <td class="label">obor/oblast užití:</td>
          <td>
           '.nahled_ciselniku($cdo, $oborUziti_nahledCisData, 'vyznam-'.$vyz_id.'--obor_uziti').'
           '.form_ciselniku(OBOR_UZITI, $oborUziti_cisVyber, 'vyznam-'.$vyz_id.'--obor_uziti', 'vyznam['.$vyz_id.'][obor_uziti]').'
          </td>
         </tr>
        </table>
       </td>
       <td>
        &nbsp;
       </td>
      </tr>
      </table>

  ';

    $html .= "
              </td>
            </tr>";
    $html.= "<tr>
             <td>
              <span class='label' style='margin-right: 80px'>slovní druh:</span>
              <span class='label' >komentář slovního druhu:</span>
              ".slovne_druhy($cdo, 'vyz', $vyz_id)."
             </td>
             <td>
              <table class='w100'>
               <tr>
                <td class='label'>upřesňující gram. inf.:</td>
                <td>
                 ".nahled_ciselniku($cdo, $gramInfo_nahledCisData, "vyznam-$vyz_id--gram_info")."
                 ".form_ciselniku(GRAM_INFO, $gramInfo_cisVyber, "vyznam-$vyz_id--gram_info", "vyznam[$vyz_id][gram_info]")."
                </td>
               </tr>
               <!--
               <tr>
                <td class='smallFont' style='text-align: right'>koncovka:</td>
                <td><input type='text' name='vyznam[$vyz_id][konc_gram_info]' value='$konc_gram_info' maxlength='45' style='width: 255px'/></td>
               </tr>
               -->
              </table>
             </td>
            </tr>";
    $html.= "<tr>
             <td style='width: 50%'>
              ".tvaroslovne_char($cdo, 'vyz', $vyz_id)."
             </td>
             <td>
              ".tvaroslovne_char_slovesa($cdo, 'vyz', $vyz_id)."
             </td>
            </tr>";

    $is_komentar_tvarchar_corrected = false;
    $komentar_tvarchar_corrected_flag = "";
    $komentar_tvarchar_corrected_cls="";
    echo highlight_new_correction($cdo, "vyznam-$vyz_id--komentar_tvarchar", $is_komentar_tvarchar_corrected, $komentar_tvarchar_corrected_flag, $komentar_tvarchar_corrected_cls);
    $html.=" <tr>
             <td colspan='2'>
              <label for='vyznam-$vyz_id--komentar_tvarchar'>komentář k tvaroslovné charakteristice</label><br />
              <div id='vyznam-$vyz_id--komentar_tvarchar---helperIdCpy' class='correctableFieldContainer'>
               $komentar_tvarchar_corrected_flag
               <input type='text' name='vyznam[$vyz_id][komentar_tvarchar]' id='vyznam-$vyz_id--komentar_tvarchar' class='lightBG flatBox w100fix padd $komentar_tvarchar' value='$komentar_tvarchar' />
              </div>
             </td>
            </tr>";

    $is_komentar_tvarchar_slovesa_corrected = false;
    $komentar_tvarchar_slovesa_corrected_flag = "";
    $komentar_tvarchar_slovesa_corrected_cls="";
    echo highlight_new_correction($cdo, "vyznam-$vyz_id--komentar_tvarchar_slovesa", $is_komentar_tvarchar_slovesa_corrected, $komentar_tvarchar_slovesa_corrected_flag, $komentar_tvarchar_slovesa_corrected_cls);
    $html.=" <tr>
             <td colspan='2'>
              <label for='vyznam-$vyz_id--komentar_tvarchar_slovesa'>komentář k tvaroslovné charakteristice slovesa</label><br />
              <div id='vyznam-$vyz_id--komentar_tvarchar_slovesa---helperIdCpy' class='correctableFieldContainer'>
               $komentar_tvarchar_slovesa_corrected_flag
               <input type='text' name='vyznam[$vyz_id][komentar_tvarchar_slovesa]' id='vyznam-$vyz_id--komentar_tvarchar_slovesa' class='lightBG flatBox w100fix padd  $komentar_tvarchar_slovesa' value='$komentar_tvarchar_slovesa' />
              </div>
             </td>
            </tr>";
    $html .= '<tbody id="vyznam-'.$vyz_id.'--predvyklad_blok" class="predvyklad_blok">';
    $link_id = $vyz_id;
    if(is_numeric($d['vyklad_vyznamu_link']) && $d['vyklad_vyznamu_link'] > 0){
        $link_id = $d['vyklad_vyznamu_link'];
        $html .= "<tr><td><div id='vyznam-".$vyz_id."--link_group' link='".$link_id."'></div></td></tr>";
    }else{
        $html .= "<tr><td><div id='vyznam-".$vyz_id."--link_group' link='".$vyz_id."'></div></td></tr>";
    }
    $html .= '
      '.predvyklad_blok($cdo, $vyz_id, $d['vyklad_vyznamu_link'], $d['predvyklad_link']).'
    </tbody>
  ';
    $html.= '
    <tr>
      <td colspan="2">
        <table id="vyznam-'.$vyz_id.'--metavyklad1_blok" class="w100 metavyklad1_blok">
          '.metavyklad1_blok($cdo, $vyz_id, $d['vyklad_vyznamu_link'], $d['metavyklad1_link']).'
        </table>
      </td>
    </tr>
    ';
    // VÝKLAD_VÝZNAMU
    $html .= '<tbody id="vyznam-'.$vyz_id.'--vyklad_vyznamu_blok" class="vyklad_vyznamu_blok">
      '.vyklad_vyznamu_blok($cdo, $vyz_id, $d['vyklad_vyznamu_link'], $new_created).'
    </tbody>
  ';

    // METAVÝKLAD 2
    $html .= '<tbody id="vyznam-'.$vyz_id.'--metavyklad2_blok" class="metavyklad2_blok">
      '.metavyklad2_blok($cdo, $vyz_id, $d['vyklad_vyznamu_link'], $d['metavyklad2_link']).'
    </tbody>
  ';

    $html.=" <tr><td colspan='2' id='vyznam-".$vyz_id."-antsyn_slave_wrapper'> " ;
    if($issub)
    {
        $html.=print_hid_rel_ant_syn_forms($cdo, $hid, $vyz_id, 'podvyznam', 'mains');
    }
    else
    {
        $html.=print_hid_rel_ant_syn_forms($cdo, $hid, $vyz_id, 'vyznam', 'mains');
    }
    $html.="</td></tr>";
    $html.=" <tr>
             <td id='vyznam-".$vyz_id."-syn_wrapper'>".synonyma($cdo, $hid, $vyz_id)."</td>
             <td id='vyznam-".$vyz_id."-ant_wrapper'>".antonyma($cdo, $hid, $vyz_id)."</td>
            </tr>";
    $html.=" <tr>
             <td colspan='2'><div class='hspace'>&nbsp;</div>".exemplifikacie($cdo, $vyz_id)."</td>
            </tr>";
    $html.=" <tr>
             <td colspan='2'>".externi_poznamky($cdo, 'vyz', $vyz_id)."</td>
            </tr>";
    $html.="</table>";
    //uprava skupin popup
    if($issub){
        $str = 'podvýznam';
        $html .= "";
    }else{
        $str = 'význam';
    }
    $html .= '
        <div title="Úprava skupiny pro '.$str.' '.$num.'" class="popUp skupina-vyklad" id="skupina-vyklad-'.$vyz_id.'-'.$num_popUp.'" style="display:none">
            <span class="lable">Zdrojové slovo: </span>
            <div class="selectize-control" style="margin-bottom: 10px; overflow:hidden;">
                <input id="vyznam-'.$vyz_id.'--link_text" style="float:left" type="text" name="link_text" value="" class="ac_link_text '.$vyklad_corrected_cls.'" size="40" />
            </div>
            <span class="lable">Výběr významu: </span>
            <select class="vyznam_link_select" style="float:left" id="select-vyklad-'.$vyz_id.'-'.$num.'" placeholder="Linkování významu"></select>
            <div style="margin-top: 20px">
                <span style="color: red; margin-left: 10px; font-size: 10px; vertical-align:bottom;">* změny se okamžite uloží do databáze</span>
            </div>
        </div>
        <input id="vyznam--'.$vyz_id.'--link_text-hid" style="float:right" type="hidden" name="link_text_hid" value='.$vyklad_vyznamu_link_hid.'  class="vyklad_vyznamu_link_hid"  />
        <div class="hspace">&nbsp;</div>
  ';
    if(is_numeric($vyz_id) && $vyz_id > 0  )
    {
        if($issub)
        {
            $html.=print_hid_rel_pripojeni_slave_forms($cdo, "subvyznam", $vyz_id, $num);
        }
        else
        {
            $html.=print_hid_rel_pripojeni_slave_forms($cdo, "vyznam", $vyz_id, $num);
        }
    }
    $html.="
    <div>
     <input type='button' onClick=\"javascript: return remove_vyznam(this,'".(($issub)?'subvyznam':'vyznam')."', '".$vyz_id."')\" value='smazat význam' class='buttBox redButtBox needToConfirmOnClick floatRight' />
    </div>";
    $html.="<div class='clear'></div>";
    $html.="</div>";
    $html.= '
      </div>
      <script type="text/javascript">
        selectize('.$vyz_id.', "#select-vyklad-'.$vyz_id.'-'.$num.'", '.$new_created.');
      </script>

    ';
    if (!$issub){
        $html .= subvyznamy($cdo, $vyz_id, $hid);
    }

    return $html;
}

function vyznamy($cdo, $heslo_id)
{
    global $quick_nav; $quick_nav = "";
    $vyznamy = $cdo->get_part('vyznamy');
    $vyznamy_html = "";
    if(empty($vyznamy)) $vyznamy_html .= vyznam($cdo, 0, $heslo_id);
    $i = 1; $num = 0;
    foreach($vyznamy as $vyz_id){
        $quick_nav.="<a href='#vyznam-$vyz_id'>[&nbsp;".$i++."&nbsp;]</a>&nbsp;";  //global var used in vyznam()
        $num++;
        $vyznamy_html .= "<div class='jeden_vyznam' id='vyznam-$vyz_id-jeden'>";
        $vyznamy_html .= vyznam($cdo, $vyz_id, $heslo_id, $num);
        //if(is_numeric($vyz_id) && $vyz_id >0) $vyznamy_html .= subvyznamy($cdo, $vyz_id, $heslo_id);
        $vyznamy_html .= "</div>";
    }
    $html = "";
    $html.= "
   <div>
     <h2 class='floatLeft'>Významy</h2>
     <div class='minimax_vyznam_all floatLeft'>
       [ <a href='#' class='maximize_vyznam_all clickable'>Rozbalit</a> ::
         <a href='#' class='minimize_vyznam_all clickable'>Sbalit</a> ]
      </div>
      <div class='floatRight'>
        <input type='button' id='seradVyznamy' onClick=\"JS_show_ordering_sb('vyznamy', 'jeden_vyznam')\" value='pořadí' class='buttBox yellowButtBox clickable' />
     </div>
     <div class='hspace'></div>";
    $html.= '<div id="heslo_ant_syn_wrapper">'.print_hid_rel_ant_syn_forms($cdo, $heslo_id, 0, 'heslo', 'mains').'</div>';
    $html.="<div class='clear'></div><div id='vyznamy'>$vyznamy_html</div>
    </div>";
    return $html;
}

function subvyznamy($cdo, $vyz_id, $hid)
{
    $vyz_num = get_vyznam_num($vyz_id);
    $sub_vyz_ids = $cdo->get_part('subvyznamy', $vyz_id);
    $subvyz_count = count($sub_vyz_ids);
    $html ="";
    $html.="<div class='subvyznamy_outer_wraper'>";
    if($subvyz_count <= 0)
    {
        $html.="<div class='show_subvyznamy clickable label floatRight'><img src='css/images/roll_out.png' alt='Zobrazit podvýznamy' />Ukaž podvýznamy významu $vyz_num ($subvyz_count)</div><div class='clear'></div>";
        $html.="<div class='subvyznamy_container' style='display: block;'>";
    }
    else
    {
        $html.="<div class='show_subvyznamy2 clickable label floatRight'><img src='css/images/roll_out.png' alt='Zobrazit podvýznamy' />Ukaž podvýznamy významu $vyz_num ($subvyz_count)</div><div class='clear'></div>";
        $html.="<div class='subvyznamy_container2' style='display: block;'>";
    }
    $html.=" <div id='subvyznamy-$vyz_id' class='subvyznamy multiContainer'>";
    if($subvyz_count <= 0) $html.="<div class='nosubvyznam greyInfo box'>Význam $vyz_num nemá podvýznamy.</div>";
    else
    {
        $num = 1;
        foreach($sub_vyz_ids as $sub_vyz_id)
        {
            $html.= vyznam($cdo, $sub_vyz_id, $hid, $num, $vyz_id);
            $num = $num + 1;
        }
    }
    $html.=" </div>";
    if($subvyz_count <= 0)
    {
        $html.=" <div class='add_subvyznam label clickable floatLeft' onClick='addFields_ajaxReq(\"subvyznam\", \"subvyznamy-$vyz_id\", ".json_encode(array('pid'=>$vyz_id, 'hid'=>$hid)).")'><img src='css/images/green_plus.png' alt='Přidat' />&nbsp;Přidej podvýznam k významu $vyz_num</div>";
        $html.=" <div class='hide_subvyznamy label clickable floatRight'><img src='css/images/roll_in.png' alt='Skrýt podvýznamy' />Skrýt</div>";
    }
    else
    {
        $html.=" <div class='add_subvyznam label clickable floatLeft' onClick='addFields_ajaxReq(\"subvyznam\", \"subvyznamy-$vyz_id\", ".json_encode(array('pid'=>$vyz_id, 'hid'=>$hid)).")'><img src='css/images/green_plus.png' alt='Přidat' />&nbsp;Přidej podvýznam k významu $vyz_num</div>";
        $html.=" <div class='hide_subvyznamy2 label clickable floatRight'><img src='css/images/roll_in.png' alt='Skrýt podvýznamy' />Skrýt</div>";
    }
    $html.="</div>";
    $html.="<div class='clear'></div>";
    $html.="</div>";
    return $html;
}

function formular_hesla($cdo){
    $heslo_id = $cdo->hid;
    $html="<form action='formular_hesla.php' method='post' name='hlavni_formular_hesla' id='hlavniFormularHesla' data-hid='".$heslo_id."' hid='".$heslo_id."' data-archive='".$cdo->is_archive()."'>";
    $html.=hlavicka_formularu_hesla($cdo);
    $html.="<div class='vmargin'>".print_sticky_header($cdo)."</div>";
    $html.="<div class='hspace'></div>";
    $html.="<div class='main_rels'>";
    $html.=" <div class='show_main_rels clickable label'><img src='css/images/roll_out.png' alt='Rozbalit' />Ukaž hesla, která odkazují na toto heslo, resp. ke kterým je připojeno/přihnízdováno toto heslo</div>";
    $html.=" <div class='main_rels_boxes' style='display: none'>";
//  $cdo->load_part("propojeni_odkazy_h",$heslo_id);
    $html.=" <div id='slave_pripojeni'>";
    $html.=   print_pripojene_hesla($cdo, $heslo_id);
    $html.="</div>";
    $html.="  <div class='hspace'></div><div class='hspace'></div>";
    $html.=" <div id='slave_odkazy'>";
    $html.=   print_odkazy_smerujuce_k_heslu($cdo, $heslo_id);
    $html.=" </div>";
    $html.="  <div class='hspace'></div> ";
    $html.="  <div class='hide_main_rels label clickable'><img src='css/images/roll_in.png' alt='Skrýt' />Skrýt</div>";
    $html.=" </div>";
    $html.="</div>";
    $html.="<div class='hspaceXXL'>&nbsp;</div>";
    $html.=varianty($cdo);
    $html.="<div class='hspace'></div> ";
    $html.=externi_poznamky($cdo, 'hes', $heslo_id);
    $html.="<div class='hspace'></div> ";
    $html.="<div class='padd'><input type='submit' value='uložit' class='blueButtBox buttBox floatRight' /><div class='clear'></div></div> ";
    $html.="<div class='hspaceXXL'></div> ";
    $html.=vyznamy($cdo, $heslo_id);
    $html .= '
    <div class="padd">
      <input type="button" id="pridejVyznam_butt" onClick="addFields_ajaxReq(\'vyznam\', \'vyznamy\', {\'hid\':'.$heslo_id.'})" value="přidej význam" class="buttBox greenButtBox padd vmargin" />
      <div class="clear"></div>
    </div>
    ';
    $html.= print_hid_rel_pripojeni_slave_forms($cdo, "heslo", $heslo_id);
    $html.="<br/>".print_hid_rel_odkazy_slave_forms($cdo, $heslo_id);
    $html.="<div class='padd'>
    <input type='submit' value='uložit' class='blueButtBox buttBox vmargin floatRight' />
    <input type='button' value='uložit kopii' class='uloz_kopii_hesla blueButtBox buttBox vmargin hmargin floatRight' />
    <div class='clear'></div></div>
    ";
    $html.="<input type='hidden' name='act' value='save' />";
    $html.="<input type='hidden' name='hid' value='$heslo_id' />";
    $html.="<input id='preview_flag'  type='hidden' name='preview_flag'  value='0' />";
    $html.="<input id='autoSave_flag' type='hidden' name='autosave_flag' value='0' />";
    $html.="</form>";

    $html.="<iframe id='iframe_saver' name='iframe_saver' style='display:none'></iframe> "; //pre autosave
    return $html;
}

function get_linked_vyzn_fnc($vid)
{
    $result = dibi::query("SELECT vyklad_vyznamu_link FROM vyznamy WHERE id = ".$vid);
    $link = $result->fetchSingle();
    if($link>0)
    {
        $result = dibi::query("SELECT id, hid FROM vyznamy WHERE vyklad_vyznamu_link = ".$link);
        $vyz_ids =  $result->fetchAll();
        return json_encode($vyz_ids);
    }
    return 0;
}

function get_varovani_link_fnc($link, $typ)
{
    if (!is_numeric($link)){
        return '';
    }

    $html = "";
    if($link>0)
    {
        $html = "<div class='varovani_skupina'><h3>Varování</h3>Změny se projeví také v heslech:  ";
        $result = dibi::query("SELECT id, hid FROM vyznamy WHERE vyklad_vyznamu_link = ".$link);
        $vyz_ids =  $result->fetchAll();
        $temp_array=array();
        foreach($vyz_ids as $data)
        {
            $result_num = dibi::query("SELECT sortorder FROM vyznamy WHERE id = ".$data["id"]);
            $counter = $result_num->fetchSingle();
            $temp_array[] = "<a href='formular_hesla.php?hid=".$data["hid"]."' class='clickable'>".text_html_preprocess(get_db_values('varianty','varianta', get_hlavni_varianta_hesla($data["hid"])))." ".$counter."</a>";
        }
        $html.=implode(", ", $temp_array)."</div>";
        return $html;
    }
    return $html;
}

function get_varovani_linked_vyzn_fnc($vid, $typ, $is_link=False)
{
    if (!is_numeric($vid)){
        return '';
    }

    $result = dibi::query("SELECT vyklad_vyznamu_link FROM vyznamy WHERE id = ".$vid);
    $html = "";
    $link = $result->fetchSingle();
    if($link>0)
    {
        $html = "<div class='varovani_skupina'><h3>Varování</h3>Změny se projeví také v heslech:  ";
        $result = dibi::query("SELECT id, hid FROM vyznamy WHERE vyklad_vyznamu_link = ".$link);
        $vyz_ids =  $result->fetchAll();
        $temp_array=array();
        foreach($vyz_ids as $data)
        {
            $result_num = dibi::query("SELECT sortorder FROM vyznamy WHERE id = ".$data["id"]);
            $counter = $result_num->fetchSingle();
            $temp_array[] = "<a href='formular_hesla.php?hid=".$data["hid"]."' class='clickable'>".text_html_preprocess(get_db_values('varianty','varianta', get_hlavni_varianta_hesla($data["hid"])))." ".$counter."</a>";
        }
        $html.=implode(", ", $temp_array)."</div>";
        return $html;
    }
    return $html;
}

function formular_kopie_hesla($hid){
    $html="";
    $html.="<div id='popUp_kopieHesla' title='Vytvoření kopie hesla' class='popUp'>";
    $html.="<form id='formular_kopie_hesla' method='post' action='#'>";
    $html.=" <input type='text' name='heslo' value='' maxlength='255' />";
    $html.=" <input type='hidden' name='hid' value='$hid' />";
    //$html.=" <input type='submit' name='submit' value='Vytvoř kopii' />";
    $html.="</form>";
    $html.="</div>";

    return $html;
}

function save_varCopy_session($form_data, $ajax=false){
    if($ajax) $form_data = $form_data;
    //$form_data = my_arrayMap('text_html_preprocess', $form_data);
    $_SESSION['form_tmp_data'] = $form_data;
}

function multiInput($multiInputContainer, $add, $cnt="", $post_vars=array()){
    $hid = $post_vars['hid'];
    switch ($add){
        case 'varianta':
            return varianta($_SESSION['CDO'][$hid], $_POST['hid']);
            break;
        case 'varianta_copy':
            $vid_new = $_SESSION['CDO'][$hid]->load_varianta_copy($_POST['vid'], $_POST['hid']);
            return varianta($_SESSION['CDO'][$hid], $_POST['hid'], $vid_new);
            break;
        case 'vyznam':
            return vyznam($_SESSION['CDO'][$hid], 0, $_POST['hid'], $cnt);
            break;
        case 'podhesli':
            return podhesli($_SESSION['CDO'][$hid], 0, $post_vars['vyz_id'], False);
            break;
        case 'subvyznam':
            return vyznam($_SESSION['CDO'][$hid], 0, $_POST['hid'], $cnt, $_POST['pid']);
            break;
        case 'vyslovnost':
            return vyslovnost($_SESSION['CDO'][$hid], $_POST['parent'], $multiInputContainer, $_POST['pid'], $_POST['pid2']);
            break;
        case 'slovny_druh':
            return slovny_druh($_SESSION['CDO'][$hid], $multiInputContainer, 'var', $_POST['var_id']);
            break;
        case 'slovny_druh_vyz':
            return slovny_druh($_SESSION['CDO'][$hid], $multiInputContainer, 'vyz', $_POST['vyz_id']);
            break;
        case 'podhesli_slovni_druh':
            return slovny_druh($_SESSION['CDO'][$hid], $multiInputContainer, 'podh', $_POST['podh_id'], 0, $_POST['vyz_id']);
            break;
        case 'tvar_char':
            return tvaroslovna_char($_SESSION['CDO'][$hid], $multiInputContainer, $_POST['parent'], $_POST['pid'], 0, $_POST['add_id']);
            break;
        case 'tvar_char_konc':
            return koncovka_tvaroslovnej_char($_SESSION['CDO'][$hid], $multiInputContainer, $_POST['parent'], $_POST['pid'], $_POST['tvCh_id'], 0, $_POST['add_id']);
            break;
        case 'tvar_char_sl':
            return tvaroslovna_char_slovesa($_SESSION['CDO'][$hid], $multiInputContainer, $_POST['parent'], $_POST['pid'], 0, $_POST['add_id']);
            break;
        case 'tvar_char_konc_sl':
            return koncovka_tvaroslovnej_char_slovesa($_SESSION['CDO'][$hid], $multiInputContainer, $_POST['parent'], $_POST['pid'], $_POST['tvCh_id'], 0, $_POST['add_id']);
            break;
        case 'vazebnost':
            return vazebnost($_SESSION['CDO'][$hid], $multiInputContainer, $_POST['parent'], $_POST['parent_id'], 0, $_POST['add_id']);
            break;
        case 'extPozn':
            return externi_poznamka($_SESSION['CDO'][$hid], $multiInputContainer, $_POST['parent'], $_POST['parent_id']);
            break;
        // case 'vyslovnost':
        //  return vyslovnost(False, $multiInputContainer, $_POST['vyz_id']);
        //  break;
        case 'exemplifikacia':
            return exemplifikacia($_SESSION['CDO'][$hid], $multiInputContainer, $_POST['vyz_id']);
            break;
        case 'hidRel':
            if($_POST['hidRel_type']=='prilink_slave')
                return print_hid_rel_pripojeni_slave($multiInputContainer, $_POST['main_hid'], $_POST['place'], $_POST['place_id']);
            if($_POST['hidRel_type']=='prilink_main')
                return print_hid_rel_pripojeni_main($multiInputContainer, $_POST['slave_hid']);
            if($_POST['hidRel_type']=='odkaz_slave')
                return print_hid_rel_odkazy_slave($multiInputContainer, $_POST['main_hid']);
            if($_POST['hidRel_type']=='odkaz_main')
                return print_hid_rel_odkazy_main($multiInputContainer, $_POST['slave_hid']);
            if($_POST['hidRel_type']=='ant_syn_slave')
                return print_hid_rel_ant_syn_slave($multiInputContainer, $_POST['main_hid'], 0, $_POST['place'], $_POST['place_id']);
            if($_POST['hidRel_type']=='ant_syn_main')
                return print_hid_rel_ant_syn_main($multiInputContainer, $_POST['slave_hid'], "vyznam", 0, $_POST['place_id']);
            if($_POST['hidRel_type']=='CDO_prilink_slave')
                return CDO_print_hid_rel_pripojeni_main($multiInputContainer, $_POST['slave_hid']);
            if($_POST['hidRel_type']=='CDO_prilink_main')
                return CDO_print_hid_rel_pripojeni_slave($multiInputContainer, $_POST['main_hid'], $_POST['place'], $_POST['place_id']);
            if($_POST['hidRel_type']=='CDO_odkaz_slave')
                return CDO_print_hid_rel_odkazy_slave($multiInputContainer, $_POST['main_hid']);
            if($_POST['hidRel_type']=='CDO_odkaz_main')
                return CDO_print_hid_rel_odkazy_main($multiInputContainer, $_POST['slave_hid']);
            if($_POST['hidRel_type']=='CDO_ant_syn_slave')
            {
                if($_POST['place']=="antonymum")
                {
                    $link = new CDO_Link(CDOin_DB,HREL_TYPE_ant, false, false, false, $_POST['hid']);
                }
                else
                {
                    $link = new CDO_Link(CDOin_DB,HREL_TYPE_syn, false, false, false, $_POST['hid']);
                }
                return $link->CDO_print_hid_rel_ant_syn_slave($multiInputContainer);
            }
            if($_POST['hidRel_type']=='CDO_ant_syn_main')
            {
                if($_POST['place']=="antonymum")
                {
                    $link = new CDO_Link(CDOin_DB,HREL_TYPE_ant, true, false, false, $_POST['hid']);
                    $typeString='ant';
                }
                else
                {
                    $link = new CDO_Link(CDOin_DB,HREL_TYPE_syn, true, false, false, $_POST['hid']);
                    $typeString='syn';
                }
                return $link-> CDO_print_hid_rel_ant_syn_main($multiInputContainer,0,0,$typeString);
            }
            break;
        case 'vyraz_predvykladu':
            return vyraz_predvykladu($_SESSION['CDO'][$hid], $multiInputContainer, $_POST['pid'], 0, $_POST['link']);
            break;
        case 'vyraz_predvykladu_master':
            return jeden_vyraz_predvykladu($multiInputContainer, 'vyz', $_POST['pid'], 0, array(), false, "_master");
            break;
    }
}


/**************************************************************************************************************
 * OUTPUT
 **************************************************************************************************************/

if(isset($_POST['act'])){
    switch ($_POST['act']){
        case 'update_stav_hesla':
            set_stav_hesla($_POST['hid'], $_POST['stav']);
            if(isset($_POST['ajax']) && $_POST['ajax']=='1') {
                exit;
            }else{
                header("Location: formular_hesla.php?hid=".$_POST['hid']);
                exit;
            }
        case 'save_varCopy_session':
            header('Content-Type: text/html; charset=utf-8');
            save_varCopy_session(array_shift($_POST['varianta']), $_POST['ajax']=="1");
            exit;
        case 'save_ant_syn_uprav_session':
            header('Content-Type: text/html; charset=utf-8');
            save_ant_syn_uprav_session($_POST['hid'], $_POST['vid']);
            echo print_sticky_side_ant_syn();
            exit;
        case 'remove_ant_syn_uprav_session':
            $_COOKIE['upraveny_vyznam_hid'] = 0;
            $_COOKIE['upraveny_vyznam'] = 0;
            exit;
        case 'clear_tmp_form_data':
            header('Content-Type: text/html; charset=utf-8');
            if(isset($_SESSION['form_tmp_data'])) unset($_SESSION['form_tmp_data']);
            exit;
        case 'addFields':
            header('Content-Type: text/html; charset=utf-8');
            $post_vars = $_POST;
            unset($post_vars['multiInputContainer'], $post_vars['add'], $post_vars['cnt']);
            echo multiInput($_POST['multiInputContainer'], $_POST['add'], $_POST['cnt'], $post_vars);
            exit;
        case 'get_hidRel_placeSelector':
            $hid = 0;
            if(isset($_POST['main_hid'])) {$slave=false; $hid = $_POST['main_hid']; if(!is_numeric($hid)) $hid=0;}
            if(isset($_POST['slave_hid'])) {$slave=true; $hid = $_POST['slave_hid']; if(!is_numeric($hid)) $hid=0;}
            header('Content-Type: text/html; charset=utf-8');
            echo print_hidRel_placeSelector($hid, $_POST['form_id'], $_POST['form_name'], "heslo", (isset($_POST['only_vyznamy']) && $_POST['only_vyznamy']==1), $slave);
            exit;
        case 'get_hidRel_placeSelector_ant_syn':
            $hid = 0;
            if(isset($_POST['main_hid'])) {$slave=false; $hid = $_POST['main_hid']; if(!is_numeric($hid)) $hid=0;}
            if(isset($_POST['slave_hid'])) {$slave=true; $hid = $_POST['slave_hid']; if(!is_numeric($hid)) $hid=0;}
            header('Content-Type: text/html; charset=utf-8');
            echo print_hidRel_placeSelector_ant_syn($hid, $_POST['form_id'], $_POST['form_name'], "heslo", (isset($_POST['only_vyznamy']) && $_POST['only_vyznamy']==1), $slave);
            exit;
        case 'get_selectize_data':
            header('Content-Type: text/html; charset=utf-8');
            echo   get_selectize_data($_POST['hid']);
            exit;
        case 'prepare_popup':
            header('Content-Type: text/html; charset=utf-8');
            echo print_dok_nedok_popup($_POST['hid_rel_id'], $_POST['link_type'],  ($_POST['slave_str']),  ($_POST['main_str']), $_POST['spravny_link_type']);
            exit;
        case 'get_linked_vyznam':
            header('Content-Type: text/html; charset=utf-8');
            echo get_linked_vyznam($_POST['vyznam_id'], $vyklad_vyznamu_link_hid, $vyklad_vyznamu_link_var, $_POST['vyznam_id_this']);
            //echo "[<div id='redakce_popups_ajax'>".$redakce_popups."</div>]";
            exit;
        case 'save':
            //var_dump($_POST);die();
            $heslo_block_stat = get_heslo_block_stat($_POST['hid']);
            $heslo_is_blocked = ($heslo_block_stat!==false && !is_me_blocking_heslo($_POST['hid']));
            if($heslo_is_blocked){
                if($_POST['ajax']=='1'){echo "Saving blocked..."; exit;}
                else{header("Location: formular_hesla.php?SESSION_NAME=".session_name()."&hid=".$_POST['hid']); exit;}
            }else{
                if($_POST['ajax']=='1') $_POST = $_POST;
                if($_POST['preview_flag']=='1'){
                    preview($_POST);
                    exit;
                }
                uloz_heslo($_POST);//die("in formular_hesla() L:2376");
                if($_POST['ajax']!='1') {
                    if($_POST['autosave_flag']!='1') track_ulozeni_hesla($_POST['hid'], get_logged_user());
                    header("Location: formular_hesla.php?SESSION_NAME=".session_name()."&hid=".$_POST['hid']);
                }
                else echo "Saved...";
                exit;
            }
        case 'save_as_copy':
            unset($_POST['hidRel']); //nekopirovat propojeni
            $hl_var = get_hlavni_varianta_hesla($_POST['hid']); //identifikovat hlavni variantu
            $sqlData=array();$sqlData['uts'] = "NOW()";
            $hid = sql_w('heslo', $sqlData);//vytvorit novy hid
            $_POST['hid'] = $hid; //staremu heslu dat novy hid - aby sa data z formularu ulozili pod novym hid
            $_POST['varianta'][$hl_var]['heslo_var'] = $_POST['nove_heslo']; //v datach z originalneho hesla prepisat hlavnu variantu na nove heslo
            $_POST = replaceKeys2nonNumeric($_POST); //ciselne kluce (vacsinou IDcka casti stareho hesla) prepisat na neciselne, cim sa v ukladacich funkciach budu javit ako nove
            foreach($_POST['vyznam'] as $key => $value)
            {
                if($_POST['vyznam'][$key]['vyz_pid']>0)
                    $_POST['vyznam'][$key]['vyz_pid'] = 'COPY';
            } //ulozit informace stareho hesla pod novym hid, s novou hodnotou "heslo_var" v hlavnej variante
            uloz_heslo($_POST);
            header("Location: formular_hesla.php?hid=".$hid); //presmerovat na nove heslo
            exit;
        case 'remove_heslo_block':
            remove_heslo_block($_POST['hid']);
            exit;
        case 'update_heslo_block_uts':
            update_heslo_block_uts($_POST['hid']);
            exit;
        case 'count_ant_syn_uprav_session':
            save_ant_syn_uprav_session($_POST['hid'], $_POST['vid']);
            echo getLinkCount($_POST['vid'], $_POST['hid']);
            exit;
        case 'print_ant_syn_uprav_session':
            header('Content-Type: text/html; charset=utf-8');
            echo printRedBox();
            exit;
        case 'get_linked_vyzn':
            header('Content-Type: text/html; charset=utf-8');
            echo get_linked_vyzn_fnc($_POST['vid']);
            exit;
        case 'get_varovani_linked_vyzn':
            header('Content-Type: text/html; charset=utf-8');
            echo get_varovani_linked_vyzn_fnc($_POST['vid'], $_POST['typ']);
            exit;
        case 'get_predvyklad':
            $cdo = new Heslo();
            $cdo->load_part('predvyklad', $_POST['vyz']);
            header('Content-Type: text/html; charset=utf-8');
            echo predvyklad_blok($cdo, $_POST['vyz'], $_POST['link'], 0);
            exit;
        case 'get_predvyklad_m':
            $cdo = new Heslo();
            $cdo->load_part('predvyklad_m', $_POST['vyz'], $_POST['link']);
            header('Content-Type: text/html; charset=utf-8');
            echo predvyklad_blok($cdo, $_POST['vyz'], $_POST['link'], 1);
            exit;
        case 'get_metavyklad1':
            $cdo = new Heslo();
            $cdo->load_part('metavyklad1', $_POST['vyz']);
            header('Content-Type: text/html; charset=utf-8');
            echo metavyklad1_blok($cdo, $_POST['vyz'], $_POST['link'], 0);
            exit;
        case 'get_metavyklad1_m':
            $cdo = new Heslo();
            $cdo->load_part('metavyklad1_m', $_POST['vyz'], $_POST['link']);
            header('Content-Type: text/html; charset=utf-8');
            echo metavyklad1_blok($cdo, $_POST['vyz'], $_POST['link'], 1);
            exit;
        case 'get_metavyklad2':
            $cdo = new Heslo();
            $cdo->load_part('metavyklad2', $_POST['vyz']);
            header('Content-Type: text/html; charset=utf-8');
            echo metavyklad2_blok($cdo, $_POST['vyz'], $_POST['link'], 0);
            exit;
        case 'get_metavyklad2_m':
            $cdo = new Heslo();
            $cdo->load_part('metavyklad2_m', $_POST['vyz'], $_POST['link']);
            header('Content-Type: text/html; charset=utf-8');
            echo metavyklad2_blok($cdo, $_POST['vyz'], $_POST['link'], 1);
            exit;
        case 'get_vyklad_vyznamu':
            $cdo = new Heslo();
            $cdo->load_part('vyklad_vyznamu', $_POST['vyz']);
            header('Content-Type: text/html; charset=utf-8');
            echo vyklad_vyznamu_blok($cdo, $_POST['vyz'], $_POST['link']);
            exit;
        case 'get_vyklad_vyznamu_m':
            $cdo = new Heslo();
            $cdo->load_part('vyklad_vyznamu_m', $_POST['vyz'], $_POST['link']);
            header('Content-Type: text/html; charset=utf-8');
            echo vyklad_vyznamu_blok($cdo, $_POST['vyz'], $_POST['link']);
            exit;
        default:
            var_dump($_POST);
            die('died - UKNOWN ACT');
    }
}
else
{
    if(isset($_GET['hid']) && is_numeric($_GET['hid']) && $_GET['hid']>0 && !is_archive()) block_heslo($_GET['hid']);
    //if(isset($_GET['phid']) && is_numeric($_GET['phid']) && $_GET['phid']>0) $_COOKIE["upraveny_vyznam_hid"]=$_GET['phid'];
    //else unset($_COOKIE["upraveny_vyznam_hid"]);
    //if(isset($_GET['pvyz_id']) && is_numeric($_GET['pvyz_id']) && $_GET['pvyz_id']>0) $_COOKIE["upraveny_vyznam"]=$_GET['pvyz_id'];
    //else unset($_COOKIE["upraveny_vyznam"]);
}

$css['screen'][]='js/jQueryUI/css/ui-lightness/jquery-ui-1.11.2.custom.css';
$css['screen'][]='css/tisk_hesel_html.css';
$css['screen'][]='css/common.css';
$css['screen'][]='css/formular_hesla.css';
$css['screen'][]='css/redakce.css';
$css['screen'][]='css/selectize.css';
$js[]='js/jquery.js';
$js[]='js/jquery.livequery.js';
$js[]='js/jquery.clearinginput.js';
$js[]='js/jquery.autosize.js';
$js[]='js/jQueryUI/jquery-ui-1.11.2.custom.min.js';
$js[]='js/addFieldsAjax.js';
$js[]='js/selectbox.js';
// $js[]='js/tiny_mce/tiny_mce_src.js';
$js[] = 'js/tiny_mce_425/tinymce.min.js';
$js[]='js/sort_domEls.js';
$js[]='js/search.js';
$js[]='js/common.js';
$js[]='js/formular_hesla.js';
$js[]='js/shortcut.js';
$js[]='js/jquery.tinysort.js';
$js[]='js/jquery.tinysort.charorder.js';
$js[]='js/standalone/selectize.js';
$js[]='js/cdo.js';

HTML_Header($page_id,'Alexis - karta', $css, $js);
if (is_role_uzivatel()){
    if(empty($hid) || !is_numeric($hid)){
        header("Location: heslar.php");
        exit();
    }
    if (!$cdo->is_archive()) {
        if (isset($_GET['forced_entries'])) {
            $hesla = explode(',', $_GET['forced_entries']);
        } else {
            $hesla = ($_SESSION['data_filter']['_dataID'] == 'jine_in_hesla') ? get_hesla_by_jine() : get_hesla();
        }


        clear_subhids($hid, $hesla);
        if (in_array($hid, $hesla)) {
            $i = array_search($hid, $hesla);
        } else {
            $sql = "SELECT h.pid as pid
                FROM heslo h
                WHERE h.id = " . $hid;
            $res = dbq($sql);
            if ($rs = mysql_fetch_array($res)) {
                $i = array_search($rs['pid'], $hesla);
                if ($i == 0 && $rs['pid'] != NULL) {
                    if ($rs['pid'] != NULL) {
                        $sql2 = "SELECT h.id as hid
                      FROM heslo h
                      WHERE h.pid = " . $rs['pid'];
                        $res2 = dbq($sql2);
                        while ($rs2 = mysql_fetch_array($res2)) {
                            if (array_search($rs2['hid'], $hesla) !== false) {
                                array_splice($hesla, array_search($rs2['hid'], $hesla), 0, $rs['pid']);
                                $i = array_search($rs['pid'], $hesla) + 1;
                                break;
                            }
                        }
                    } else {
                        $sql2 = "SELECT h.id as hid
                      FROM heslo h
                      WHERE h.pid = " . $hid;
                        $res2 = dbq($sql2);
                        while ($rs2 = mysql_fetch_array($res2)) {
                            if (array_search($rs2['hid'], $hesla) !== false) {
                                array_splice($hesla, array_search($rs2['hid'], $hesla), 0, $hid);
                                $i = array_search($rs['pid'], $hesla);
                                break;
                            }
                        }
                    }
                } else {
                    $sql2 = "SELECT h.id as hid
                      FROM heslo h
                      WHERE h.pid = " . $hid;
                    $res2 = dbq($sql2);
                    while ($rs2 = mysql_fetch_array($res2)) {
                        if (array_search($rs2['hid'], $hesla) !== false) {
                            array_splice($hesla, array_search($rs2['hid'], $hesla), 0, $hid);
                            $i = array_search($rs['pid'], $hesla);
                            break;
                        }
                    }
                }
            }
        }
        //$i--;
        $i2 = $i;
        $i = $i - 1;
        if ($i >= 0) {
            add_subhids($i, $hesla);
            add_subhids($i, $hesla);
            add_subhids($i, $hesla);
        } else {
            $i = count($hesla) - 2;
            add_subhids($i, $hesla);
            $i = 0;
            add_subhids($i, $hesla);
            add_subhids($i, $hesla);
        }

        /*casto sa bude stavat, ze sa vyfiltruju hesla podla nejakeho pola a to pole sa zmeni, tym padom po ulozeni
          uz nebude vyhovovat filtru a f:array_value_relative() nenajde to heslo v zozname a vrati hodnoty vzhladom k prvemu prvku
          v zozname. V takom pripade je treba osetrit, aby ak zmizne prvok z filtru, tak sa pouzili posledne pouzite prev, next hodnoty */

        if (array_search($hid, $hesla) !== false) {
            $next_hid = array_value_relative($hesla, $hid, 1);
            $prev_hid = array_value_relative($hesla, $hid, -1);
            //uloz posledne hodnoty
            $_SESSION['prev_hid'] = $prev_hid;
            $_SESSION['next_hid'] = $next_hid;

        } else {
            $next_hid = $_SESSION['next_hid'];

            $prev_hid = $_SESSION['prev_hid'];
        }

        if (is_err()) echo print_errs();
        echo print_new_corrections_box($hid);
        //echo print_live_preview_box($hid);
        //$temp_sticky = print_sticky_side_ant_syn();
        $upravy_as_cnt = getLinkCount();
        echo "<div id='popup_uprava_ant_syn' class='popUp' style='display:none'>
                          <h3>Měníte výklad, který je navázán na následující ant./syn.</h3>
                          <div id='uprava_ant_syn_wrapper_popup' class='scroller'>
                          </div>
                          <input type='button' value='upravit' class='aktivovat_upravy blueButtBox buttBox vmargin hmargin floatRight' />
                          <input type='button' value='nekontrolovat' class='zavri_upravy blueButtBox buttBox vmargin hmargin floatRight' />
                      </div>
                      ";
        echo '<div id="upravy_ant_syn_container" class="ant_syn_container_cor">';
        if ($upravy_as_cnt > 0) {
            echo printRedBox();
        }
        echo '</div>';
    } else {
        $tmp_prev = $cdo->prev_arch_entry();
        $tmp_next = $cdo->next_arch_entry();
        $prev_hid = $tmp_prev ? $cdo->get_hid() . '&amp;archid=' . $tmp_prev : False;
        $next_hid = $tmp_next ? $cdo->get_hid() . '&amp;archid=' . $tmp_next : False;
    }

    echo formular_hesla($cdo);
    if (!$cdo->is_archive()){
        track_navsteva_hesla($hid, get_logged_user());
    }
    echo print_search_form(page_KARTA);
    echo " <div id='odkazy-hidRelPopUp-dok-nedok' name='odkazy-hidRelPopUp-dok-nedok' class='popUp hidRel_popUp hidRel_popUp_dok_nedok'>
    </div>";
    echo "<div id='redakce_popups'></div>";
    echo "<div id='vyznamlinkPopUp' title='Odkaz na základové slovo' class='popUp hidRel_popUp PopupDiv'></div>";
    echo "<div id='varPopUp' class='orangeBox popUp' style='display:none'></div>";
    echo "
   <div class='popUp' id='savingProgress_popUp'>
   <table><tr>
    <td><img src='css/images/loading.gif' alt='Pracuji' /></td>
    <th>Ukládám...</th>
   </tr></table>
   </div>";
    echo "<div class='popUp' id='varovani_popUp' style='display:none'>
   </div>";
    echo formular_kopie_hesla($hid);



    if(is_me_blocking_heslo($hid)) echo printJS_sending_ImHere_msg($hid);
}else{
    ;
}
HTML_Footer($page_id);

?>
