<?php

include_once('cls/redakce.class.php');
include_once('cls/xFilter.class.php');
include_once('cls/cache.class.php');
include_once('morphodita_fx.php');


function check_web_published($hid){
    $result = dibi::query('SELECT [value] FROM [heslo_check_stav] WHERE [hid] = %i AND [checkid] = %i', $hid, 10);
    $answer = $result->fetchSingle();
    return (!is_null($answer) && $answer === 1);

}

function check_link($hid){
    $result = dibi::query('SELECT [vystup] FROM [heslo] WHERE [id] = %i', $hid);
    $answer = $result->fetchSingle();
    if($answer != TISTENY){
        return false; //do webu jdou jen tistena hesla
    }
    return check_web_published($hid);
    //$authors = get_zpracovatele($hid);
    //return (in_array(39, $authors));
}

/**
 * Highlight a string in text without corrupting HTML tags
 *
 * @author      Aidan Lister <aidan@php.net>
 * @version     3.1.1
 * @link        http://aidanlister.com/2004/04/highlighting-a-search-string-in-html-text/
 * @param       string          $text           Haystack - The text to search
 * @param       array|string    $needle         Needle - The string to highlight
 */
function str_highlight($text, $needle, $lemma)
{
    $highlight = '<span title="'.$lemma.'">\1</span>';
    $pattern = '#(?!<.*?)(%s)(?![^<>]*?>)#';
    //$x = '<?';
    $sl_pattern = '#<a\s(?:.*?)>(%s)</a>#';

    $needle = (array) $needle;
    foreach ($needle as $needle_s) {
        $needle_s = preg_quote($needle_s);
        // Escape needle with whole word check
        $needle_s = '\b' . $needle_s . '\b';
        $regex = sprintf($pattern, $needle_s);
        //var_dump($regex, $highlight);
        $text = preg_replace($regex, $highlight, $text);
    }

    return $text;
}

function lematizace($vstup){
    return $vstup;
    $vstup_stripped = strip_tags($vstup);
    $tokeny = lematizuj_text($vstup_stripped, 2);
    if(!$tokeny){
        return $vstup_stripped;
    }
    foreach($tokeny as $token => $info){
        $vstup = str_highlight($vstup, $token, $info['lemma']);
        //$pattern = '/\b('.$token.')\b/';
        //$vstup = preg_replace($pattern, "<span title='".$info['lemma']."'>$token</span>", $vstup);
        //$vstup = str_replace($token, "<span title='".$info['lemma']."'>$token</span>", $vstup);
        //var_dump($vstup);
    }
    return $vstup;
}

/*
 nahradi strednik v textu ve formatu HTML zadanou entitou
*/
function bulletizace($str, $entity = "&bull;"){
    $parts = explode('<', $str);
    $res = '';
    foreach($parts as $part){
      $pos = strpos($part, '>');
      if($pos){
        $tag = '<'.substr($part, 0, $pos+1);
        $text = substr($part, $pos+1);
      } else{
        $tag = '';
        $text = $part;
      }
      if(!$text){
        $text = '';
      }
      //vyescapovani entit
      $text = str_replace(array("&nbsp;", "&hellip;", "&#8211;", ";'", ';"'), array("&nbsp", "&hellip", "&#8211", "[]'", '[]"'), $text);
      $text = str_replace(";", " $entity", $text);
      $text = str_replace(array("&nbsp", "&hellip", "&#8211", "[]'", '[]"'), array("&nbsp;", "&hellip;", "&#8211;", ";'", ';"'), $text);
      $res.=$tag.$text;
    }
    return $res;
}

/*
  Ziska seznam pripojeni a prihnizdovani ve formatu pro tiskovy vystup
*/
function vytvor_pripojene($place, $place_id, $num=0, $to_pdf, &$bileZony, $pid, $master = true, $parent = true, $web = false, $prazdny_vyznam = false){
    GLOBAL $hid;
    global $master;
    global $processed_hids;
    global $processed_rel_ids;
    Global $heslar;
    $clsSuffix = "";

    if($heslar != HESLAR_HLAVNI){
        $clsSuffix = "Prop";
    }
    $master_hid = $pid;
    $pripojene = "";
    if(!$master){
        //$master_hid = $hid;
        unset($processed_hids);
        $processed_hids = array();
        $processed_hids[] = $hid;
    } else{
        //$master_hid = $pid;
    }
    if(is_null($processed_rel_ids)){
        $processed_rel_ids = array();
    }
    $hidRel_id = "$place-$place_id";
    //get cislo vyznamu, pokud jde o exemplifikace
    //$vyznam_with_num = "";
    $last_sign = "";
    $disabled_cls = "";
    //$bileZony = array();
    if($place == 'exemplifikace'){
        $vyz_id = get_db_values('exemplifikace', 'vyz_id', $place_id);
        $vyz_num = get_vyznam_num($vyz_id);
        //$vyznam_with_num = " (V".$vyz_num.")";
    }
    //if($place == 'podvyznam') $place = 'vyznam';
    $hidRels_propojeni = get_hidRels($master_hid, 0, array(HREL_TYPE_prihnizdovani, HREL_TYPE_pripojovani), $place, $place_id);

    if(!empty($hidRels_propojeni)){
        $pripojene = "";
        $pocetPripojeni = count($hidRels_propojeni);
        $cisloPripojeni = 0;
        //spocitat zarazene slavy
        if($to_pdf || $web){
            $pocetPripojeni = 0;
            foreach($hidRels_propojeni as $hidRel_DBid){
                $slave = get_db_values("hesla_rel", array("slave_hid"), $hidRel_DBid);
                if(is_numeric($slave['slave_hid'])){
                    $vystup = get_db_values("heslo", "vystup", $slave['slave_hid']);
                    if($vystup == TISTENY){
                        $pocetPripojeni++;
                    }
                    if($web && !check_web_published($slave['slave_hid'])){
                        $pocetPripojeni--;
                    }
                } else{
                    $pocetPripojeni++;
                }
            }
        }
        foreach($hidRels_propojeni as $hidRel_DBid){
            $disabled_cls = "";
            $skip = false;
            $pripojene_info = get_db_values("hesla_rel", array("slave_str", "slave_hid", "rel_type"), $hidRel_DBid);
            if(is_numeric($pripojene_info['slave_hid'])){
                $disabled_cls = get_disabled_cls($pripojene_info['slave_hid']);
                if($to_pdf && !empty($disabled_cls)){
                    //continue;
                    $skip = true;
                    //if($web){
                        continue;
                    //}
                }
                if($web && !check_web_published($pripojene_info['slave_hid'])){
                    continue;
                }
            }
            if(!$parent){
                if(is_numeric($pripojene_info['slave_hid'])){
                    $sql = "SELECT * FROM hesla_rel WHERE main_hid=".$pripojene_info['slave_hid']." AND slave_hid=".$hid.";";
                    $res = mysql_fetch_array(dbq($sql));
                    if(!empty($res)){
                        //continue;
                        $skip = true;
                    }
                }
            }
            if(in_array($hidRel_DBid, $processed_rel_ids)){
                $skip = true; //smycka
            } else{
                $processed_rel_ids[] = $hidRel_DBid;
            }

            if($web){
                if($place!="heslo"){
                    if(!$prazdny_vyznam){
                        $pripojene.="<hr class='vskipSmall' />";
                        //$pripojene.="<span class='tabaa'></span><span class='pripoj'></span>";
                    }

                } else{
                    $pripojene.="<hr class='vskipSmall' />";
                  /*
                    if($prazdny_vyznam){
                        $pripojene.="<hr class='vskipSmall' />";
                    } else{
                        $pripojene.="<hr class='vskipMedium'>";
                    }
                   */
                }
            }

            $cisloPripojeni++;

            $typ = $pripojene_info['rel_type'];
            if($typ == HREL_TYPE_pripojovani && $pid > 0 && $master){
                if(!$skip){
                    $pripojene.="<br />";
                }
            }
            $sign = print_hidRel_sign(False, $hidRel_DBid);
            if($web){
                if(empty($sign)){
                    $sign = "<span style='visibility:hidden'>&bull;</span>";
                }
                $margin = '';
                if($sign == "&#9656;"){
                    $margin = "style='margin-right: 0;'";
                }
                $sign = "<span class='vyz_count' $margin>$sign</span>";
            }

            if($place == "vyznam" && $prazdny_vyznam){
                $sign = "";
            }
             $pocet_vyznamu = count(get_vyznamy_count($pripojene_info['slave_hid'], true));

            if(!$skip){
                if($place=="exemplifikace" && $sign==$last_sign && !$web)
                    $pripojene .= "\r\n";
                else{
                    if(!empty($pripojene)){
                        $pripojene.="\r\n";
                    }
                    if(!empty($sign)){
                        if($web && $pocet_vyznamu == 1){
                            $sign = "<span class='pripoj_wrapper'>".$sign;
                        }
                        if($web && strip_tags($sign)=="&#9656;"){
                            $pripojene.=$sign;
                        } else if(!$web){
                            $pripojene.= $sign."&nbsp;";
                        } else{
                            $pripojene.= $sign."<span class='frazem_odsazeni'></span>";
                        }
                    }
                }
            }


            $last_sign = $sign;
            if(!empty($disabled_cls)){
                $pripojene.="<span class='$disabled_cls'>";
            }
            if($pripojene_info['slave_hid']>0){
                /*
       if(!$to_pdf){
          $pripojene.= "<span class='pripojeni'><a href='tisk_hesel_new.php?hid=".$pripojene_info['slave_hid']."&page=heslo_varianty'>".$pripojene_info['slave_str']."</a></span>";
       } else {
          $pripojene.= "<span class='pripojeni'>".$pripojene_info['slave_str']."</span>";
       }
       */
                if(!$skip){
                    $bilaZona = "";
                    $p = trim(tisk_hesla(true, $pripojene_info['slave_hid'], 0, $to_pdf, false, $bilaZona, true, $hidRel_DBid, $pripojene_info['slave_hid'], $web));
                    if($web && $pocet_vyznamu == 1){
                        //uzavreno pred tiskem exemplifikace ve fci tisk_hesla
                       // $p = $p."</span>";
                    }
                    $pripojene.=$p;
                    $bileZony .= $bilaZona;
                }

                if($pocetPripojeni > 1 && $cisloPripojeni < $pocetPripojeni){
                    if(empty($disabled_cls)){
                        if($web)
                            $pripojene.="<br />";
                        else if($place=="exemplifikace")
                            $pripojene.="; ";
                        else
                            $pripojene.="<br />";
                    }
                }
                if(!in_array($hidRel_DBid, $processed_rel_ids)){
                    // if(array_search($pripojene_info['slave_hid'], $processed_hids)===FALSE){
                    $processed_hids[] = $pripojene_info['slave_hid'];
                    $res = "";
                    //$res = vytvor_pripojene($place, $pripojene_info['slave_hid'], $num, $to_pdf, $bileZony, $pripojene_info['slave_hid'], false, false, $web);
                    $bilaZona = "";
                    $res = vytvor_pripojene($place, $pripojene_info['slave_hid'], $num, $to_pdf, $bilaZona, $pripojene_info['slave_hid'], false, false, $web);
                    $bileZony .= $bilaZona;
                    if(!empty($res)){
                        $pripojene.="\r\n".$res;
                    }
                }
            }
            else
            {  // pripojeni/prihnizdovani nezalozeneho hesla
                $pripojene_tmp = $pripojene_info['slave_str'];
                if(!$to_pdf){
                    $DOMid = "nest-$hidRel_DBid";
                    handle_correction($hid, $DOMid, 'nest', $hidRel_DBid, $pripojene_tmp, 'span', 0);
                    $pripojene .= "<span class='heslo$clsSuffix odkaz'>$pripojene_tmp</span>";
                } else{
                    $pripojene .= "<span class='heslo$clsSuffix nepodtrzeny_odkaz'>$pripojene_tmp</span>";
                }
            }
            if($web){
                if($place!="heslo"){
                    $pripojene.="</span>";
                }
            }
            if(!empty($disabled_cls)){
                $pripojene.="</span>";
            }
        }
        $test = fix_typography(strip_tags($pripojene));
        if(empty($test)){
            $pripojene = "";
        }

    }
    return $pripojene;
}

function upravy_ant_syn_redakce()
{
    $upravy_as_cnt = getLinkCount();
    $html = "<div id='popup_uprava_ant_syn' class='orangeBox popUp' style='display:none'>
                      <h3>Měníte výklad, který je navázán na následující ant./syn.</h3>
                      <div id='uprava_ant_syn_wrapper_popup' class='scroller'>
                      </div>
                      <input type='button' value='upravit' class='aktivovat_upravy blueButtBox buttBox vmargin hmargin floatRight' />
                      <input type='button' value='nekontrolovat' class='zavri_upravy blueButtBox buttBox vmargin hmargin floatRight' />
                  </div>
                  ";
    $html .=  '<div id="upravy_ant_syn_container" class="ant_syn_container_cor ">';
    if($upravy_as_cnt>0)
    {
        $html .=  printRedBox("true");
    }
    $html .=  '</div>';
    return $html;
}

function naformatuj_varianty($odkazy_info, $hid = 0, $redakce=false, $slave_hid='', $web=false, $types=null){
    GLOBAL $_TYP_HESLA;
    Global $heslar;
    $clsSuffix = "";
    if($heslar != HESLAR_HLAVNI){
        $clsSuffix = "Prop";
    }
    $varianty = get('varianty_hesla', $odkazy_info, array('sortorder'));
    $label = '';
    $pocet_Variant = 0;
    $res =  dbq("SELECT COUNT(*) FROM `varianty` WHERE hid='$odkazy_info' AND f_varianta='1'");
    $pocet_Variant = mysql_fetch_array($res)[0];
    $cislo_Varianty = 0;
    foreach($varianty as $varianta){
        $cislo_Varianty++;
        $D = get_db_values('varianty', array('varianta', 'podhesli', 'f_varianta', 'homonymie'), $varianta);
        //netisknout v odkazech podhesli
        if($D['f_varianta']==0 || (empty($D['varianta']) && !empty($D['podhesli']))){
            continue;
        }
        $var = text_html_preprocess(trim($D['varianta']));
        $typHesla_cisVyber = get_vybrane_hodnoty_ciselniku(TYP_HESLA, 'var', $varianta);
        $typHesla_stripped = strip_tags(text_html_preprocess(implode(", ", $typHesla_cisVyber)));
        if($typHesla_stripped==$_TYP_HESLA[SOUSLOVI])
            $class='souslovi'.$clsSuffix;
        else if($typHesla_stripped==$_TYP_HESLA[FRAZEM])
            $class='frazem'.$clsSuffix;
        else if($typHesla_stripped==$_TYP_HESLA[VICESLOVNE])
            $class='viceslovne'.$clsSuffix;
        else
            $class='heslo'.$clsSuffix;

        if($redakce){
            $DOMid = "varianta-$varianta--tvar";
            handle_correction($hid, $DOMid, 'varianta-tvar', $varianta, $var, 'span', $slave_hid);
            $label.=$var;
        }
        else if($web)
        {
            if(check_link($hid) && !is_slave($hid)){
                $hl_var_data = get_db_values('varianty', array('varianta', 'homonymie'), $varianta);
                $label.= '<a id="hid-'.$hid.'" class="'.$class.' clickable" href="heslo/'.$hl_var_data['varianta'].'--'.$hl_var_data['homonymie'].'/'.$hid.'"><span class="'.$class.' clickable">'.$var.'</span></a>';
            } else{
                $label.= '<span id="hid-'.$hid.'" class="'.$class.'">'.$var.'</span>';
            }

        }
        else{
            $label.="\r\n<span class='$class'>$var</span>";
        }

        if($types!="odkaz"){
            $homonymie = "";
            if(!empty($D['homonymie'])){
                $homonymie = number_to_roman($D['homonymie']);
                $label.="\r\n<span class='heslo$clsSuffix'>$homonymie</span>";
            }
        } else{
            break; //pro odkaz se tiskne jen prvni varianta
        }


        if($pocet_Variant > 1 && $cislo_Varianty < $pocet_Variant)
            $label.="<span class='oddelovac'>, </span>";
    }
    if(substr($label, -2) == ', '){
        $label = substr($label, 0, -2);
    }
    return $label;
}

/*
  Ziska seznam odkazu pro heslo $hid ve formatu pro tiskovy vystup
*/
function vytvor_odkazy($hid, $to_pdf, $new=false, $web=false){
    GLOBAL $_TYP_HESLA;

    Global $heslar;
    $clsSuffix = "";
    if($heslar != HESLAR_HLAVNI){
        $clsSuffix = "Prop";
    }
    //$odkazy = str_replace('%content%', "<i>Odkazy na hesla</i>", $odkaz_click_tpl);
    $hidRels_odkazy = get_hidRels($hid, 0, array(HREL_TYPE_odkazy));
    $odkazy = "";
    $cls = "odkaz";
    if($to_pdf)
        $cls = "nepodtrzeny_odkaz";
    if(!empty($hidRels_odkazy)){
        $cisloOdkazu = 0;
        $pocetOdkazu = count($hidRels_odkazy);
        foreach($hidRels_odkazy as $hidRel_DBid){
            $odkaz = '';
            $cisloOdkazu++;
            $odkaz_types = get_vybrane_hodnoty_ciselniku(TYP_LINKOVANI, "hes", $hidRel_DBid);
            $odkaz_info = get_db_values("hesla_rel", array("slave_str", "slave_hid", "poznamka"), $hidRel_DBid);
            $note = trim(text_html_preprocess($odkaz_info['poznamka']));
            /*if(!$web)
     {
        $odkaz.=print_hidRel_sign($hidRel_DBid);
     }*/
            $disabled_cls = "";
            if(is_numeric($odkaz_info['slave_hid']) && $odkaz_info['slave_hid'] > 0){
                $disabled_cls = get_disabled_cls($odkaz_info['slave_hid']);
                if(!empty($disabled_cls) && $to_pdf){
                    //$pocetOdkazu--;
                    continue;
                }
            }
            $types = implode(", ", $odkaz_types);

            if($web && ($types=="zdrob." || $cisloOdkazu == 1)){
                $vid = get_hlavni_varianta_hesla($hid);
                $sql = "SELECT cis_id FROM typ_hesla_var_vyber WHERE vid=".$vid;
                $cis_ids = db_get_val_arr($sql);
                $br = true;
                foreach($cis_ids as $cis_id)
                {
                    if($cis_id == ODKAZOVE){
                        $br = false;
                        break;
                    }
                }
                if($br){
                    $odkaz .= "<hr class='vskipMedium' />";
                }
            }

            if(!empty($disabled_cls)){
                $odkaz.="<span class='disabled'>";
            }

            if(!empty($types) /*&& $web*/ && $types!="odkaz"){
                if($types!="verb. subst./adj." && $types!="vícesl."){
                    $odkaz.="\r\n<span class='komentar'>$types</span>";
                }
            }

            $odkaz .= "\r\n<span class='cislaOdkazu'>";
            if(count(get_vyznamy_count($hid, $to_pdf)) > 1){
                $cislo = print_hidRel_vyznam_nums(False, $hidRel_DBid, false, false, true);
                if(!empty($cislo)){
                    $odkaz.="$cislo";
                }
            }
            $odkaz.=" &rarr; </span>";

            /*if(!empty($types) && !$web && $types!="odkaz"){
        $odkaz.="\r\n<span class='komentar'>$types</span>";
      } */
            if($types=="verb. subst./adj."){
                $odkaz .= "\r\n<span class='small'>i</span>\r\n";
            }
            if($note != ""){
                $odkaz .= "\r\n<span class='small'>$note</span>\r\n";
            }



            $label = naformatuj_varianty($odkaz_info['slave_hid'], $odkaz_info['slave_hid'], false, "", $web, $types);

            if(!empty($label))
                $odkaz_info['slave_str'] = "$label";

            if($types=="odkaz")
            {
                $temp = explode(",", $odkaz_info['slave_str']);
                $odkaz_info['slave_str'] = $temp[0];
            }
            if($odkaz_info['slave_hid']>0){
                if(!$to_pdf){
                    if($new){
                        $odkaz.="\r\n<span class='heslo$clsSuffix odkaz'>".$odkaz_info['slave_str']."</span>";
                    }
                    else{
                        $odkaz.="\r\n<span class='heslo$clsSuffix $cls'>".$odkaz_info['slave_str']."</span>";
                    }
                }
                else
                    $odkaz.="\r\n<span class='heslo$clsSuffix $cls'>".$odkaz_info['slave_str']."</span>";
            }
            else{
                $odkaz.="\r\n<span class='heslo$clsSuffix nepodtrzeny_odkaz'>".$odkaz_info['slave_str']."</span>";
            }
            //pouze jeden zarazeny vyznam?
            if(count(get_vyznamy_count($odkaz_info['slave_hid'], $to_pdf)) > 1){
                $cisla=trim(print_hidRel_vyznam_nums(False, $hidRel_DBid, true, false, true)); //true: slave places;
                //false: master places
            }
            else{
                $cisla = '';
            }

            if(!empty($cisla)){

                $odkaz.="\r\n<span class='cislaOdkazuKHeslu'>".$cisla."</span>";
            }

            if(!$to_pdf){
                $DOMid = "link-$hidRel_DBid";
                handle_correction($hid, $DOMid, 'link', $hidRel_DBid, $odkaz);
            }
            if(!empty($disabled_cls)){
                $odkaz.="</span><!-- disabled cls -->";
            }
            $odkazy.=$odkaz;
            if($web)
            {
                $odkazy.="<br />";
            }
            else
            {
                if($pocetOdkazu > 1 && $cisloOdkazu < $pocetOdkazu){
                    $odkazy.=", ";
                }
            }
        }
    }
    //posledni odkaz je nezarazeny a nejde tedy do PDF -> odstranit carku na konci
    if($to_pdf && !$web){
        if(substr($odkazy, -2)==", ")
            $odkazy = substr($odkazy, 0, strlen($odkazy)-2);
    }
    return $odkazy;
}

function vyznam_number($vyz_id, $to_pdf){
    $heslo = get_db_values("vyznamy", array("hid"), $vyz_id);
    if(!$heslo){
        return '';
    }
    $heslo = $heslo[0];
    $sql = "SELECT `id`,`typ_vystupu`,`pid` FROM `vyznamy` WHERE `hid` = $heslo ORDER BY `sortorder`;";
    $res = mysql_query($sql) or die('Query: '.$sql.'  failed: ' . mysql_error());
    $pocet_zarazenych_vyz = 0;
    $vyznamy = array();
    $vystup = -1;

    while($row = mysql_fetch_array($res)){
        //echo "$row[id] $row[pid] $row[typ_vystupu]<br />";
        if($row['pid']==0){ //vyznam
            $vystup = $row['typ_vystupu'];
            if($to_pdf && $vystup==TISTENY){
                $pocet_zarazenych_vyz++;
                $vyznamy[$pocet_zarazenych_vyz] = $row['id'];
            }
            if(!$to_pdf && ($vystup==TISTENY || $vystup==ELEKTRONICKY)){
                $pocet_zarazenych_vyz++;
                $vyznamy[$pocet_zarazenych_vyz] = $row['id'];
            }
        }

        if($row['id']==$vyz_id){
            if($to_pdf && $vystup!=TISTENY)
                return -1;
            if(!$to_pdf && $vystup!=TISTENY && $vystup!=ELEKTRONICKY)
                return -1;
            $result = $pocet_zarazenych_vyz;
        }
    }

    if($pocet_zarazenych_vyz > 1)
        return $result;
    else
        return ''; //pouze jeden zarazeny vyznam, nepise se tedy cislo
}


function vytvor_odkazy_k_ant_syn($hid, $vyz_id, $typ, $to_pdf, $web){
    if($typ=='antonymum')
        $hidRels_odkazy = get_hidRels($hid, 0, array(HREL_TYPE_ant, HREL_TYPE_ant_przn),'ant',$vyz_id);
    else
        $hidRels_odkazy = get_hidRels($hid, 0, array(HREL_TYPE_syn, HREL_TYPE_syn_przn),'syn',$vyz_id);

    if(empty($hidRels_odkazy))
        return '';

    $cls = "odkaz";
    if($to_pdf)
        $cls = "nepodtrzeny_odkaz";
    //$odkazy = "";

    $odkazy_ntrl = array();
    $odkazy_przn = array();
    foreach($hidRels_odkazy as $hidRel_DBid){
        $odkaz = '';
        $homonymie = false;
        /*if(!empty($odkazy))
      $odkazy.=", ";
    */
        $odkazy_info = get_db_values("hesla_rel", array("slave_str", "slave_hid", "komentar", "rel_type"), $hidRel_DBid);
        if(empty($odkazy_info['slave_str'])){
            continue;
        }
        if($odkazy_info['komentar']){
            $odkaz_komentar = $odkazy_info['komentar'];
            $odkaz.="\r\n<span class='komentar'>$odkaz_komentar</span>";
        }

        if(is_numeric($odkazy_info['slave_hid']) && $odkazy_info['slave_hid'] > 0){
            $var_info = get_db_values_where('varianty', array('varianta', 'homonymie'), 'hid', $odkazy_info['slave_hid'], true);
            $slave_str = "";
            $var_array = array();
            foreach($var_info as $var){
                if(in_array($var['varianta'], $var_array)){
                        continue;
                }

                if(!empty($slave_str))
                    $slave_str.=", ";
                $slave_str .= $var['varianta'];
                $var_array[] = $var['varianta'];
                if(!empty($var['homonymie'])){
                    $slave_str.=" ".number_to_roman($var['homonymie']);
                    $homonymie = true;
                }
            }
        }
        else{
            $slave_str = $odkazy_info['slave_str'];
        }
        $typ_odkazu = get_db_values_where("hesla_rel_slave_places", array("place", "place_id"), "hesla_rel_id", $hidRel_DBid);
        $cislo_vyznamu = '';
        if($typ_odkazu['place']==='vyznam'){
            $cislo_vyznamu = vyznam_number($typ_odkazu['place_id'], $to_pdf);
            //syn./ant. k nezarazenemu vyznamu nepujde do vystupu
            if($cislo_vyznamu===-1)
                continue;
            if(!empty($cislo_vyznamu)){
                if($homonymie)
                    $delim = "/";
                else
                    $delim = " ";
                $cislo_vyznamu = $delim.$cislo_vyznamu;
            }
        };
        if($odkazy_info['slave_hid']>0){
            //$odkazy.="\r\n<a href='tisk_hesel.php?hid=".$odkazy_info['slave_hid']."&amp;page=heslo_varianty'>$slave_str</a>";
            if($web)
            {
                if(check_link($odkazy_info['slave_hid']) && !is_slave($odkazy_info['slave_hid'])){
                    $varianty = get('varianty_hesla', $odkazy_info['slave_hid'], array('sortorder'));
                    $hl_var_data = get_db_values('varianty', array('varianta', 'homonymie'), $varianty[0]);
                    $odkaz .= '<a id="hid-'.$odkazy_info['slave_hid'].'" class="clickable" href="heslo/'.$hl_var_data['varianta'].'--'.$hl_var_data['homonymie'].'/'.$odkazy_info['slave_hid'].'"><span class="clickable synonymum">'."\r\n".$slave_str.$cislo_vyznamu.'</span></a>';
                } else{
                    $odkaz .= '<span id="hid-'.$odkazy_info['slave_hid'].'">'."\r\n".$slave_str.$cislo_vyznamu.'</span>';
                }
            } else{
                $odkaz.="\r\n$slave_str$cislo_vyznamu";
            }
        } else{
            $odkaz.="\r\n$slave_str$cislo_vyznamu";
        }

        if(!$to_pdf){
            $DOMid = "hidRel-$typ-slaves-$hidRel_DBid";
            handle_correction($hid, $DOMid, $typ, $hidRel_DBid, $odkaz, 'span', $odkazy_info['slave_hid']);
        } else{
            if($odkazy_info['rel_type']==HREL_TYPE_ant || $odkazy_info['rel_type']==HREL_TYPE_ant_przn){
                $odkaz = "<span class='antonymum'>$odkaz</span>";
            } else{
                $odkaz = "<span class='synonymum'>$odkaz</span>";
            }
        }
        if($odkazy_info['rel_type']==HREL_TYPE_syn_przn || $odkazy_info['rel_type']==HREL_TYPE_ant_przn){
            $odkazy_przn[] = $odkaz;
        } else{
            $odkazy_ntrl[] = $odkaz;
        }
        //$odkazy.=$odkaz;
    }
    $odkazy_neutralni = implode(", ", $odkazy_ntrl);
    $odkazy_priznakove = implode(", ", $odkazy_przn);

    $odkazy = $odkazy_neutralni;
    if(!empty($odkazy_priznakove) && !empty($odkazy_neutralni)){
        $odkazy.="; ";
    }
    $odkazy.=$odkazy_priznakove;
    return $odkazy;
}

/*
  Vraci znak, ktery se vytiskne pred heslem:
  - ctverecek pro souslovi
  - kosoctverec pro frazem
*/
function print_sign($typHesla, &$jednoslovne){
    global $_TYP_HESLA;
    $res = "";
    $typHesla = strip_tags($typHesla);
    if($typHesla == $_TYP_HESLA[SOUSLOVI]){
        $res.="\r\n&#9633;&nbsp;"; //ctverecek
        $jednoslovne = false;
    }
    else if($typHesla == $_TYP_HESLA[VICESLOVNE]){
        $res.="\r\n&#9633;&nbsp;"; //ctverecek
        $jednoslovne = false;
    }
    else if($typHesla == $_TYP_HESLA[FRAZEM]){
        $res.="\r\n&loz;&nbsp;"; //kosoctverec
        $jednoslovne = false;
    }
    return $res;
}

/*
  Removes block tags from the HTML code passed as $inputStr parameter
*/
function strip_block_tags($inputStr){
    $badtags = array("<p>",'<p title="vysvětlivka">',/*'<span title="vysvětlivka">',*/ "</p>", "<div>", "</div>", "<br />", "<br>");
    $outputStr = str_replace($badtags, "", $inputStr);
    return $outputStr;
}

/*
  Converts given number to roman numerals
  based on http://www.go4expert.com/articles/roman-php-t4948/
*/
function number_to_roman($n){
    $result = '';
    // Declare a lookup array that we will use to traverse the number:
    $lookup = array('M' => 1000, 'CM' => 900, 'D' => 500, 'CD' => 400,
        'C' => 100, 'XC' => 90, 'L' => 50, 'XL' => 40,
        'X' => 10, 'IX' => 9, 'V' => 5, 'IV' => 4, 'I' => 1);

    foreach ($lookup as $roman => $value)
    {
        // Determine the number of matches
        $matches = intval($n / $value);

        // Store that many characters
        $result .= str_repeat($roman, $matches);

        // Substract that from the number
        $n = $n % $value;
    }

    // The Roman numeral should be built, return it
    return $result;
}

function remove(&$pole, $hodnota){
    for($i = 1; $i <= count($pole)-1; $i++){
        $idx = array_search($hodnota, $pole[$i]);
        $pole[$i][$idx]=null;
    }
}

/*
  Odstrani duplicitni hodnoty z pole x
*/
function remove_duplicities_orig(&$x){
    $size = count($x[1]);
    if($x[1]){
        foreach($x[1] as $item){
            $matches = 0;
            for($j = 2; $j <= count($x); $j++){
                if($x[$j]!=null){
                    $key = array_search($item, $x[$j]);
                    if($key!==FALSE) $matches++;
                    else break;
                }
            }
            if($matches==count($x)-1) remove($x, $item);
        }
    }
}

/*
  Odstrani po skupinach duplicitni hodnoty z pole x
*/
function remove_duplicities(&$x, $reverse = false){
    if(!is_array($x)){
        return;
    }
    //$size = count($x[1]);
    $size = count($x);
    if($size == 1 && empty($x)){
        return;
    }

    for($i = 1; $i <= $size; $i++){
        if(empty($x[$i])){
            continue;
        }
        $idx = 0;
        for($j = $i+1; $j <= $size; $j++){
            if($x[$i]==$x[$j]){
                $idx = $j - 1;
            }
            else{
                break;
            }

        }
        if(!$reverse){
            for($j = $i; $j <= $idx; $j++){
                $x[$j] = null;
            }
        } else{
            for($j = $i+1; $j <= $idx+1; $j++){
                $x[$j] = null;
            }
        }
    }
}



function popup(){
    return "\r\n<div id='correctionPopUp' class='popUp' title='Redakční modul'>
            <div class='popupContent'>
            </div>
          </div>"
        ;
}

/*
  Zredukuje a vytiskne informaci o tvaroslovne charakteristice variant
*/
function print_tvCh($redukuj, $tvCh, &$html, $remove, $varianty, $slDr, $stylKval, &$komentare){
    if($remove && $redukuj){
        remove_duplicities($tvCh);
        remove_duplicities($slDr);
    }

    if($redukuj){
        //ticket 507 (heslo autoshow)
        //if(isset($tvCh[1][0]) && is_null($tvCh[1][0]) && (strip_tags($tvCh[2][0])==="neskl.") && (count($tvCh)==2) /*&& !is_null($tvCh[0][0])*/){
        if((is_null($tvCh[1]) || (isset($tvCh[1][0]) && is_null($tvCh[1][0]))) /*&& (strip_tags($tvCh[2][0])==="neskl.")*/ && (count($tvCh)==2)){
            if(!empty($slDr[1]) && !empty($slDr[2])){

                $sd1 = implode(',', array_filter($slDr[1]));
                $sd2 = implode(',', array_filter($slDr[2]));
                if(!empty($sd1)){
                    $tvCh[1] = $tvCh[2];
                    $tvCh[2] = array();
                }
            }
        }
    }


    $first = true;
    $i_array = array();
    foreach($tvCh as $i => $sd){

        if(!is_array($sd)){
            continue;
        }
        $sd = array_values(array_filter($sd)); //odstraneni null prvku a precislovani
        if(isset($sd[0])){
            $str = strip_tags($sd[0]);
        } else{
            $str = "";
        }
        if($str=='neskl.' ||  empty($str)){
            if($varianty[$i]==$varianty[$i-1]){
                if($redukuj){
                    $komentar = "";
                    if(isset($komentare[$i]) && !isset($komentare[$i - 1])){
                        $komentar = '<span class="komentar_tvarchar">'.implode("", $komentare[$i]).'</span>\r\n';
                        unset($komentare[$i]);
                    }
                    $html = str_replace("^^tvCh$i^^", "<span class='small'>i</span>\r\n".$komentar."<span class='small'>".$str."</span>^^tvCh$i^^", $html);
                } else {
                    $html = str_replace("^^tvCh$i^^", "<span class='small'>".$str."</span>^^tvCh$i^^", $html);
                }
            }
            else if(!empty($str)){
                $html = str_replace("^^tvCh$i^^", "\r\n<span class='small'>".$str."</span>^^tvCh$i^^", $html);
            }
            $first = false;
            array_shift($sd); //odstran neskl.
        }
        else if($varianty[$i]==$varianty[$i-1]){
            if($redukuj){
              $i_array[] = $i;
              $html = str_replace("^^tvCh$i^^", "<span class='small'>i</span>\r\n^^tvCh$i^^", $html);
            }
        }
        //else
        //{
        $str = '';
        $opened = false;
        if(isset($sd[0])){
            $tmp = explode("|",str_replace("> <", ">|<", $sd[0])); //vstup z prvniho ciselniku
            $test = strip_tags($tmp[0]);
            if($test=="2. j." || $test=="2. mn."){
                array_shift($tmp); //odstran 2. j. z pole
                $str = implode($tmp, " "); //zpracuj tvar pro 2. j.
                array_shift($sd); //odstran data zadana z prvniho ciselniku
            }
        }
        //otevreni zavorky
        if(isset($sd[0]) && !is_null($sd[0]) && $sd[0]!==''){
            $sd[0] = " <span class='normal_size'>(</span>".$sd[0];
            $opened = true;
        }
        $str .= implode($sd,', ');
        if($str){

		    $sk = "";
            if(!$first && $varianty[$i]==$varianty[$i-1]){
                $slDr1 = empty($slDr[$i-1]) ? "" : implode("", $slDr[$i-1]);
                $slDr2 = empty($slDr[$i]) ? "" : implode("", $slDr[$i]);
                $tvCh1 = empty($tvCh[$i - 1]) ? "" : implode("", $tvCh[$i - 1]);
                $tvCh2 = empty($tvCh[$i]) ? "" : implode("", $tvCh[$i]);
                if($tvCh1 == $tvCh2 || $slDr1 == $slDr2){
                    //nebylo jiz i vytisteno jinym pravidlem?
                    if($redukuj && !in_array($i, $i_array)){
                        $delim = " <span class='small'>i</span> ";
                    }
                }
                if(empty($stylKval[$i-1]) && !empty($stylKval[$i])){
                    $sk="\r\n^^stylKvalPred$i^^";
                    $html = str_replace("^^stylKvalPred$i^^", "", $html);
                }
            }
            else
                $delim = "";
            if($opened)
                $html = str_replace("^^tvCh$i^^", "$delim$sk\r\n<span class='tvCh'>".$str."<span class='normal_size'>)</span></span>", $html);
            else
                $html = str_replace("^^tvCh$i^^", "$delim\r\n<span class='tvCh'>".$str."</span>", $html);

            $first = false;
        }
        else
            $html = str_replace("^^tvCh$i^^","",$html);
        //}
    }
}

function druhy_pruchod($variantyArray, $pocetVariant, $template, $web){
    $pieces = array();
    $merged_pieces = array();
    $id = "";
    if($web){
        $z = strpos($template, "print_heslo(");
        if($z){
            $s = substr($template, $z + strlen("print_heslo("));
            $k = strpos($s, ")");
            if($k){
                $id = substr($s, 0, $k);
            }
        }
    }
    for($cisloVarianty = 1; $cisloVarianty <= $pocetVariant; $cisloVarianty++){
        $z = strpos($template, "%%Z$cisloVarianty") + 5;
        $k = strpos($template, "%%K$cisloVarianty");
        if($web){
            $pieces[$cisloVarianty] = strip_tags(substr($template, $z, $k-$z), "<span>");
        } else{
            $pieces[$cisloVarianty] = substr($template, $z, $k-$z);
        }
    }
    $index = 1;
    for($cisloVarianty = 1; $cisloVarianty <= $pocetVariant; $cisloVarianty++){

        if(isset($merged_pieces[$index])){
            $merged_pieces[$index].=$pieces[$cisloVarianty];
        } else{
            $merged_pieces[$index] =$pieces[$cisloVarianty];
        }
        if(isset($variantyArray[$cisloVarianty+1]) && $variantyArray[$cisloVarianty]!=$variantyArray[$cisloVarianty+1]){
            $index++;
        }
    }
    for($i = 1; $i < count($merged_pieces); $i++){
        $i1 = strpos($merged_pieces[$i], "</span>")+7;
        $s1 = trim(substr($merged_pieces[$i], $i1));
        $len = strlen($s1) - 1;
        if(isset($s1[$len]) && $s1[$len]==","){
            $s1 = substr($s1, 0, $len);
        }
        $i2 = strpos($merged_pieces[$i+1], "</span>")+8;
        $s2 = substr($merged_pieces[$i+1], $i2);
        if(!empty($s1) && (strpos($s2, $s1)===0)){
            $merged_pieces[$i] = substr_replace($merged_pieces[$i], "", $i1, strlen($s1));
        }
    }
    $result = fix_typography(implode("", $merged_pieces));
    if(strpos($result, 'frazem') > 0){
        $result = mb_ereg_replace('/\s\s+/', ' ', $result);//konzultace s Vláďou nutná- problém v hesle `a jour  4456
        $result = str_replace("< ", "<span class='frazem-oddelovac'> n. </span>", $result);
    }
    $result = str_replace(array("<,", "span><<span"), array("</span>,", "span> / </span><span"), $result);
    if($web){
        if(!empty($id)){
            $varianty = get('varianty_hesla', $id, array('sortorder'));
            foreach($varianty as $varianta){
                $D = get_db_values('varianty', array('varianta', 'homonymie'), $varianta);
                $var = text_html_preprocess(trim($D['varianta']));
                $hl_var_data = get_db_values('varianty', array('varianta', 'homonymie'), $varianty);
                $result = str_replace($var,'<a id="hid-'.$id.'" class="clickable" href="heslo/'.$hl_var_data['varianta'].'--'.$hl_var_data['homonymie'].'/'.$id.'">'.$var.'</a>', $result);
            }
        }
    }
    return $result;
}


/*
 *  Upresneni pravidla 2:
 *  na konci zahlavi vygenerovat polozku, ktera je vlozena
 *  v poli stylisticky kvalifikator shodne pro vsechny varianty
 */
function priprav_stylKval(&$stylKvalArray, $pocetVariant){
    $sk = $stylKvalArray[1];
    $stylKvalPostfix = "";
    foreach($sk as $key => $val){
        $flag = true;
        for($i = 1; $i <= $pocetVariant; $i++){
            if(empty($stylKvalArray[$i][$key])){
                $flag = false;
                break;
            }
        }

        if($flag){
            if(!empty($stylKvalPostfix)){
                $stylKvalPostfix.=", ";
            }
            $stylKvalPostfix.=$val;
            for($i = 1; $i <= $pocetVariant; $i++){
                unset($stylKvalArray[$i][$key]);
            }
        }
    }
    if(!empty($stylKvalPostfix)){
        $stylKvalPostfix = "<span class='stylKval'>$stylKvalPostfix</span>";
    }
    return $stylKvalPostfix;
}

function redukuj_vyslovnost($variantyArray, $slDruhyArray, $tvarCharArray, $pocetVariant, &$vyslovnostArray){
    $slDruhyArrayTest = array();
    $tvarCharArrayTest = array();

    foreach($slDruhyArray as $idx => $slDr){
        sort($slDr);
        $slDruhyArrayTest[] = implode($slDr,"|");
    }

    foreach($tvarCharArray as $idx => $tvChr){
        sort($tvChr);
        $tvarCharArrayTest[$idx] = implode($tvChr,"|");
    }

    //redukce vyslovnosti
    for($cisloVarianty = 2; $cisloVarianty <= $pocetVariant; $cisloVarianty++){
        //ruzne vyslovnosti
        if(!isset($vyslovnostArray[$cisloVarianty])){
            $vyslovnostArray[$cisloVarianty] = "";
        }
        if(!isset($vyslovnostArray[$cisloVarianty-1])){
            $vyslovnostArray[$cisloVarianty - 1] = "";
        }
        if($vyslovnostArray[$cisloVarianty]!=$vyslovnostArray[$cisloVarianty-1]){
            continue;
        }

        //stejne varianty
        if($variantyArray[$cisloVarianty]==$variantyArray[$cisloVarianty-1]){
            continue;
        }

        //ruzne varianty - ruzne tvarchar => neredukovat vyslovnost
        if(!empty($tvarCharArrayTest[$cisloVarianty]) && ($tvarCharArrayTest[$cisloVarianty]!=$tvarCharArrayTest[$cisloVarianty-1])){
            continue;
        }

        //ruzne varianty - ruzne sl. druhy => neredukovat vyslovnost
        //ruzne varianty - ruzne tvarchar => neredukovat vyslovnost
        if(!empty($slDruhyArrayTest[$cisloVarianty]) && ($slDruhyArrayTest[$cisloVarianty]!=$slDruhyArrayTest[$cisloVarianty-1])){
            continue;
        }

        //vlastni redukce
        $vyslovnostArray[$cisloVarianty-1] = null;

    }
}

//slouzi pro snizeni poctu variant ze 4 na 2
function reduceArray(&$a, $move){
    if($move){
        $a[2] = $a[3];
    }
    unset($a[3]);
    unset($a[4]);
}

function print_duplicities($redukuj, $duplicities, $class, &$html, $delim1='', $delim2='', $reverse = false, $varPodhArray = null){
    if($class=='stylKval' &&
        (empty($duplicities[1]) || ($duplicities[1]!=$duplicities[2]))){
        $class = 'stylKvalPred';
        $reverse = true;
    }

    if($redukuj){
        if($class!="vyslovnost"){
            remove_duplicities($duplicities, $reverse);
        }
    }

    foreach($duplicities as $i => $sd){
        $str = '';
        if($class==='sl_druh'){
            if(is_array($sd)){
                $str = array_shift($sd);
            }
            if(!empty($str)) $str.="\r\n";
        }
        if($class==='puvod'){
            if(is_array($sd)){
                $str .= text_html_preprocess(implode((array_filter($sd)),', '));
            }
        }
        else{
            if(is_array($sd)){
                $str .= implode((array_filter($sd)),', ');
            }
        }

        if($class == 'varianta'){
            $str = $sd;
        }

        if($str){
            if($class=='varianta'){
                $html = str_replace("^^".$class.$i."^^", $str, $html);
            } else{
                if($class=='stylKvalPred' && $i == 1){
                    $html = str_replace("^^stylKval1^^", "\r\n<span class='stylKval'>".$str."</span>", $html);
                }
                else if($class=="gramInfoUpres"){
							if($varPodhArray[$i]==0 && ($str=="mn." || $str == "pomn." || $str=="zprav. mn.")){
			               $html = str_replace("^^".$class."Special".$i."^^", "\r\n<span class='$class'>$delim1".$str."$delim2</span>", $html);
							}  else{
								$html = str_replace("^^".$class.$i."^^", "\r\n<span class='$class'>$delim1".$str."$delim2</span>", $html);

							}
                }
                else{
                    $html = str_replace("^^".$class.$i."^^", "\r\n<span class='$class'>$delim1".$str."$delim2</span>", $html);
                }
            }
        }
        else
            $html = str_replace("^^".$class.$i."^^","",$html);

    }
}

function handle_correction($hid, $DOMid, $field_id, $pid, &$fieldStr, $tag='span', $slave_id = ''){
    Global $heslar;
    $clsSuffix = "";
    if($heslar != HESLAR_HLAVNI){
        $clsSuffix = "Prop";
    }
    $R = new Redakce($field_id, $pid);
    static $id = 0;
    $kor_id = Redakce::get_last_correction_id($DOMid);
    $is_waiting4editor = $kor_id>0 && Redakce::is_new_correction($kor_id);
    $is_rejected = $kor_id>0 && Redakce::is_rejected_by_editor($kor_id);
    if($is_rejected){
        $state_cls = "rejectedByEditor";
        $customHtmlAtts = "data-kor_id=$kor_id";
    }else{
        if($is_waiting4editor){
            $state_cls = "waiting4editor";
            $customHtmlAtts = "data-kor_id=$kor_id";
        }else{
            $state_cls = "newCorrection";
            $customHtmlAtts = "data-kor_id=0 data-hid=$hid data-field_id=$field_id data-pid=$pid";
        }
    }
    if(in_array($field_id, array('heslo-extPozn-text', 'vyznam-vyklad_vyznamu', 'vyznam-exemplifikacia-text', 'vyznam-extPozn-text', 'varianta-vazebnost-tvar', 'vyznam-vazebnost-tvar'))) $DOMid = $DOMid."Disp";
    if(in_array($field_id, array('heslo', 'podhesli', 'pripojeni', 'hesloProp'))) $field_id = $field_id.$clsSuffix;
    //$tag = 'span'; // if($R->type=='rtext') $tag='div';
    if(isset($_GET['action']) && ($_GET['action']=='export'))
        $fieldStr = "<$tag class='$field_id'>".$fieldStr."</$tag>";
    else{
        $DOMid=$id."_".$DOMid;
        $fieldStr = "<$tag id='$DOMid' class='korektura $state_cls $field_id' $customHtmlAtts data-slave-id='$slave_id'>".$fieldStr."</$tag>";
    }
    $id++;
}

function handle_correction_vyznamu($vyklad_vyznamu, $hid, $links, $group, $val_id, $DOMid){
    $field_id = $group ? "vyznam-vyklad_vyznamu_master" : "vyznam-vyklad_vyznamu";
    if(!empty($links) && !Redakce::field_has_opened_correction($DOMid)){
        $blokRedakciVyznamu = false;

        foreach($links as $link){
            $stringArr = split_vyznam($vyklad_vyznamu, $link);
            if(Redakce::field_has_opened_correction("vyznam-link-$link")){
                $blokRedakciVyznamu = true;
            }
            handle_correction($hid, "vyznam-link-$link", 'vyznam-link', $link, $stringArr[1]);
            $vyklad_vyznamu = implode("", $stringArr);
        }
        if(!$blokRedakciVyznamu){
            $vyklad_cpy = "";
            $prefix = '';
            $sufix = $vyklad_vyznamu;
            for($i = 1; $i <= count($links); $i++){
                $start = strpos($sufix, "<span id=");
                $end = strpos($sufix, "</span>", $start);
                $prefix = substr($sufix, 0, $start);
                $link_txt = substr($sufix, $start, $end - $start + 7);
                $sufix = substr($sufix, $end + 7);
                handle_correction($hid, $DOMid, $field_id, $val_id, $prefix);
                $vyklad_cpy.=$prefix.$link_txt;
            }
            handle_correction($hid, $DOMid, $field_id, $val_id, $sufix);
            $vyklad_vyznamu = $vyklad_cpy.$sufix;
        }


    } else{
        handle_correction($hid, $DOMid, $field_id, $val_id, $vyklad_vyznamu);
    }
    return $vyklad_vyznamu;
}

function add_css_class(&$fieldStr, $class, $tag='span'){
    $fieldStr = "<$tag class='$class'>".$fieldStr."</$tag>";
}


/*
  Pomocna funkce pro spravne ceske abecedni razeni
*/
function mb_strcoll($arg1, $arg2){
    return strcoll(iconv('UTF-8', 'WINDOWS-1250//TRANSLIT', $arg1), iconv('UTF-8', 'WINDOWS-1250//TRANSLIT', $arg2));
}

/*
  Testuje, zda zadane HID tvori vzestupnou posloupnost hesel
  (pro jedine vybrane heslo vraci false)
*/
function souvisly_vyber($hids){
    $souvisle = true;
    if(count($hids)==1)
        $souvisle = false;
    else{
        $h1 = '';
        setlocale(LC_ALL, 'cs_CZ');
        foreach($hids as $hid){
            $var_id = get_hlavni_varianta_hesla($hid);
            $D = get_db_values('varianty', array('varianta'), $var_id);
            $h2 = text_html_preprocess(trim($D['varianta']));
            if(strcoll($h2, $h1) < 0){
                $souvisle = false;
                break;
            }
            $h1 = $h2;
        }
    }
    return $souvisle;
}

/*
 Testuje, zda heslo s danym $slave_hid je pripojeno prihnizdeno k nejakemu
 master heslu
*/
function is_slave($slave_hid){
    $hidRel_mains = get_hidRels(0, $slave_hid, array(HREL_TYPE_pripojovani, HREL_TYPE_prihnizdovani));
    $slave = false;
    if(!empty($hidRel_mains)){
        $slave=true;
    }
    return $slave;
}

function handle_correction_old($hid, $DOMid, $field_id, $pid, &$fieldStr){
    $R = new Redakce($field_id, $pid);
    $kor_id = Redakce::get_last_correction_id($DOMid);
    $is_waiting4editor = $kor_id>0 && Redakce::is_new_correction($kor_id);
    $is_rejected = $kor_id>0 && Redakce::is_rejected_by_editor($kor_id);
    if($is_rejected){
        $state_cls = "rejectedByEditor";
        $customHtmlAtts = "data-kor_id=$kor_id";
    }else{
        if($is_waiting4editor){
            $state_cls = "waiting4editor";
            $customHtmlAtts = "data-kor_id=$kor_id";
        }else{
            $state_cls = "newCorrection";
            $customHtmlAtts = "data-kor_id=0 data-hid=$hid data-field_id=$field_id data-pid=$pid";
        }
    }
    if(in_array($field_id, array('heslo-extPozn-text', 'vyznam-vyklad_vyznamu', 'vyznam-exemplifikacia-text', 'vyznam-extPozn-text'))) $DOMid = $DOMid."Disp";
    $tag = 'span'; if($R->type=='rtext') $tag='div';
    $fieldStr = "<$tag id='$DOMid' class='korektura $state_cls' $customHtmlAtts>".$fieldStr."</$tag>";
}

function typ_hesla($hid, $var_id, $to_pdf){
    global $_TYP_HESLA;
    $DOMid = "varianta-$var_id--typ_hesla";
    $typHesla_cisVyber = get_vybrane_hodnoty_ciselniku(TYP_HESLA, 'var', $var_id);
    $typHesla_cisVyber_str = text_html_preprocess(implode(", ", $typHesla_cisVyber));
    if(!$to_pdf){
        handle_correction($hid, $DOMid, 'varianta-typ_hesla', $var_id, $typHesla_cisVyber_str);
    }
    return $typHesla_cisVyber_str;
}


function gramaticke_info_vyznamu($hid, $vyz_id, $to_pdf){
    $DOMid = "vyznam-$vyz_id--gram_info";
    $gramInfo_cisVyber = get_vybrane_hodnoty_ciselniku(GRAM_INFO, 'vyz', $vyz_id);
    $gramInfo_cisVyber_str = text_html_preprocess(implode(", ", $gramInfo_cisVyber));
    if(!$to_pdf && !empty($gramInfo_cisVyber)){
        handle_correction($hid, $DOMid, 'vyznam-gram_info', $vyz_id, $gramInfo_cisVyber_str);
    }
    return $gramInfo_cisVyber_str;
}

function gramaticke_info_podhesli($hid, $podh_id, $to_pdf){
    $DOMid = "podhesli-$podh_id--gram_info";
    $gramInfo_cisVyber = get_vybrane_hodnoty_ciselniku(GRAM_INFO, 'podh', $podh_id);
    $gramInfo_cisVyber_str = text_html_preprocess(implode(", ", $gramInfo_cisVyber));
    if(!$to_pdf && !empty($gramInfo_cisVyber)){
        handle_correction($hid, $DOMid, 'podhesli-gram_info', $podh_id, $gramInfo_cisVyber_str);
    }
    return $gramInfo_cisVyber_str;
}

function tvar_char_podhesli($hid, $podh_id, $to_pdf){
    $tvCh_str = "";
    $tvChs = get('tvarChary_podhesli', $podh_id, 'sortorder');
    $ok2open = false;
    $opened = false;
    $first = true;
    $result = "";

    foreach($tvChs as $tvCh_id){
    	$ok2open = true;
        $tvChs_vyber = get_vybrane_hodnoty_ciselniku(TVAR_CHAR, 'podh', $tvCh_id);
        if(!empty($tvChs_vyber)){
            $DOMid = "podhesli-$podh_id--tvarChar-$tvCh_id";
            $tvCh_str = implode(", ", $tvChs_vyber);
            if(!$to_pdf){
                handle_correction($hid, $DOMid, 'podhesli-tvarChar', $tvCh_id, $tvCh_str);
            }
            if($to_pdf && !$opened && ($tvCh_str != "2. j." && $tvCh_str!="2. mn." && $tvCh_str!="neskl.") && !$opened){
                $opened = true;
                $first = true;
                if(empty($result)){
                        $result = "<span class='normal_size'>(</span>";
                } else{
                        $result .= " <span class='normal_size'>(</span>";
                }
            }
            if($to_pdf && ($tvCh_str == "2. j." || $tvCh_str == "2. mn.")){
                $tvCh_str = ""; //2. j. 2. mn. se netiskne v PDF
            } else{
                $tvCh_str = "<span class='tvCh-typ'>$tvCh_str</span>";
            }
        }


        $koncofky_ids = get('koncovky_tvCh_podh', $tvCh_id, 'sortorder');
        $koncofky = array();
        foreach($koncofky_ids as $konc_id){
            $konc = get_db_values('podh_vyz_koncovky_tvar_char', 'koncovka', $konc_id);
            $konc_kom = get_db_values('podh_vyz_koncovky_tvar_char', 'komentar', $konc_id);
            if(trim($konc)!=""){
                $DOMid = "podhesli-$podh_id--tvarChar-$tvCh_id--koncovka-$konc_id--tvar";
                $konc = text_html_preprocess($konc);
                if(!$to_pdf){
                    handle_correction($hid, $DOMid, 'podhesli-tvarChar-koncovka-tvar', $konc_id, $konc);
                }
            }

            if(!empty($konc_kom)){
                $konc_kom = text_html_preprocess($konc_kom);
                $DOMid = "podhesli-$podh_id--tvarChar-$tvCh_id--koncovka-$konc_id--komentar";
                if(!$to_pdf){
                    handle_correction($hid, $DOMid, 'podhesli-tvarChar-koncovka-komentar', $konc_id, $konc_kom);
                }
            }
            //if(!empty($konc)) $konc = " ".$konc;
            if(!empty($konc_kom)){
                $koncofky[] = "<span class='varianta-tvarChar-koncovka-komentar'>$konc_kom</span>\r\n".$konc;
            } else if(!empty($konc)){
                $koncofky[] = $konc;
            }
            //$koncofky[] = ((!empty($konc_kom))?"<span class='varianta-tvarChar-koncovka-komentar'>$konc_kom</span>":"").$konc;
        }

        if(!empty($koncofky) && !empty($tvCh_str)) $tvCh_str.="&nbsp;";
        $tvCh_str.= implode(",&nbsp;", $koncofky);
        if(trim($tvCh_str)!=""){
            if(!$first){
		$result .= ", ".$tvCh_str;
            } else{
		$result .= $tvCh_str;
            }
            $first = false;
        }

    }
    if($opened){
        $result.="<span class='normal_size'>)</span>";
    }
    if(!$to_pdf && !empty($result)){
        $result = "<span class='normal_size'>(</span>$result<span class='normal_size'>)</span>";
    }
    return $result;
}

function tvar_char_sl_podhesli($hid, $podh_id, $to_pdf){
    $tvChSl_arr = array();
    $tvChSl_str = "";
    $tvChSls = get('tvarCharySl_podhesli', $podh_id, 'sortorder');
    foreach($tvChSls as $tvChSl_id){
        $tvChSls_vyber = get_vybrane_hodnoty_ciselniku(TVAR_CHAR_SL, 'podh', $tvChSl_id);
        if(!empty($tvChSls_vyber)){
            $DOMid = "podhesli-$podh_id--tvarCharSl-$tvChSl_id";
            $tvChSl_str = text_html_preprocess(implode(", ", $tvChSls_vyber));
            if(!$to_pdf){
                handle_correction($hid, $DOMid, 'podhesli-tvarCharSl', $tvChSl_id, $tvChSl_str);
            }
            $tvChSl_str = "<span class='tvCh-typ'>$tvChSl_str</span>";
        }
        $koncofky_ids = get('koncovky_tvarCharSl_podh', $tvChSl_id, 'sortorder');
        $koncofky = array();
        foreach($koncofky_ids as $konc_id){
            $konc = get_db_values('podh_vyz_koncovky_tvar_char_sl', 'koncovka', $konc_id);
            $konc_kom = get_db_values('podh_vyz_koncovky_tvar_char_sl', 'komentar', $konc_id);
            if(trim($konc)!=""){
                $DOMid = "podhesli-$podh_id--tvarCharSl-$tvChSl_id--koncovka-$konc_id--tvar";
                $konc = text_html_preprocess($konc);
                if(!$to_pdf){
                    handle_correction($hid, $DOMid, 'podhesli-tvarCharSl-koncovka-tvar', $konc_id, $konc);
                }
                if(!empty($konc_kom)){
                    $konc_kom = text_html_preprocess($konc_kom);
                    $DOMid = "podhesli-$podh_id--tvarCharSl-$tvChSl_id--koncovka-$konc_id--komentar";
                    if(!$to_pdf){
                        handle_correction($hid, $DOMid, 'podhesli-tvarCharSl-koncovka-komentar', $konc_id, $konc_kom);
                    }
                }
                $koncofky[] = ((!empty($konc_kom))?"<span class='komentar'>$konc_kom</span>\r\n":"").$konc;
            }
        }
        if(!empty($koncofky) && !empty($tvChSl_str)) $tvChSl_str.="&nbsp;";
        $tvChSl_str.= implode(",&nbsp;", $koncofky);
        if(trim($tvChSl_str)!=""){
            $tvChSl_arr[] = $tvChSl_str;
        }
    }
    return $tvChSl_arr;
}


function stylisticky_kvalifikator($hid, $id, $to_pdf, $prefix = "vyz"){
    global $preview;
    $place = "vyznam";
    if($prefix === "podh"){
        $place = "podhesli";
    }
    $DOMid = "$place-$id--styl_kval";
    $stylKval_cisVyber = get_vybrane_hodnoty_ciselniku(STYL_KVAL, $prefix, $id);
    $stylKval_cisVyber_str = text_html_preprocess(implode(", ", $stylKval_cisVyber));
    if((!$to_pdf) && !empty($stylKval_cisVyber)){
        handle_correction($hid, $DOMid, "$place-styl_kval", $id, $stylKval_cisVyber_str);
    }
    if($preview){
        $stylKval_cisVyber_str = str_replace("&#9651;", "<span style='font-size:17px;'>&#9651;</span>", $stylKval_cisVyber_str);
    }
    return $stylKval_cisVyber_str;
}


function tematicke_okruhy($hid, $id, $to_pdf, $prefix="vyz"){
    $place = "vyznam";
    if($prefix==="podh"){
        $place = "podhesli";
    }
    $DOMid = "$place-$id--tematicke_okruhy";
    $tematickeOkruhy_cisVyber = get_vybrane_hodnoty_ciselniku(TEMATICKE_OKRUHY, $prefix, $id);
    $tematickeOkruhy_cisVyber_str = text_html_preprocess(implode(", ", $tematickeOkruhy_cisVyber));
    if((!$to_pdf)){
        if(empty($tematickeOkruhy_cisVyber)){
            $tematickeOkruhy_cisVyber_str = "--neoborové--";
        }
        handle_correction($hid, $DOMid, "$place-tematicke_okruhy", $id, $tematickeOkruhy_cisVyber_str);
    }
    return $tematickeOkruhy_cisVyber_str;
}

function vyslovnost_podhesli($hid, $podh_id, $to_pdf){
    $vyslovnosti_ids = get('podh_vyz_vyslovnost', $podh_id);
    $vyslovnosti_arr = array();
    foreach($vyslovnosti_ids as $vysl_id){
        $Dvysl = get_db_values('podh_vyz_vyslovnost', array('vyslovnost', 'komentar'), $vysl_id);
        $vysl = text_html_preprocess($Dvysl['vyslovnost']);
        $vysl_kom = text_html_preprocess($Dvysl['komentar']);
        if(trim($vysl)!=""){
            $DOMid = "podhesli-$podh_id--vyslovnost-$vysl_id--tvar";
            if(!$to_pdf){
                handle_correction($hid, $DOMid, 'podhesli-vyslovnost-tvar', $vysl_id, $vysl);
            }
            if(!empty($vysl_kom)){
                $DOMid = "podhesli-$podh_id--vyslovnost-$vysl_id--komentar";
                if(!$to_pdf){
                    handle_correction($hid, $DOMid, 'podhesli-vyslovnost-komentar', $vysl_id, $vysl_kom);
                }
            }
            $s = ((!empty($vysl_kom))?"<span class='komentar'>$vysl_kom</span>\r\n":"").$vysl;
            $vyslovnosti_arr[] = $s;
        }
    }
    return $vyslovnosti_arr;
}

function slovni_druh_podhesli($hid, $podh_id, $to_pdf){
    $sl_Druhy = get('slovneDruhy_podhesli', $podh_id);
    $sl_druhy_str = $sl_Druhy_vyber = array();
    foreach($sl_Druhy as $slDruh_id){
        $DOMid = "podhesli-$podh_id--slovnyDruh-$slDruh_id";
        $sl_druhy_raw = get_vybrane_hodnoty_ciselniku(SLOV_DRUHY, 'podh', $slDruh_id);
        $sl_druhy = text_html_preprocess(implode(", ", $sl_druhy_raw));
        if(!$to_pdf){
            handle_correction($hid, $DOMid, 'podhesli-slovnyDruh', $slDruh_id, $sl_druhy);
        }
        $sl_druhy_kom = get_db_values('podh_vyz_slov_druhy_vyber_rel', 'komentar', $slDruh_id);
        if(!empty($sl_druhy_raw)){
            if(!empty($sl_druhy_kom)){
                $DOMid = "podhesli-$podh_id--slovnyDruh-$slDruh_id--komentar";
                if(!$to_pdf){
                    handle_correction($hid, $DOMid, 'podhesli-slovnyDruh-komentar', $slDruh_id, $sl_druhy_kom);
                }
            }
            $sl_druhy_str[] = ((!empty($sl_druhy_kom))?"<span class='komentar'>$sl_druhy_kom</span>\r\n":"").$sl_druhy;
        }
    }
    return $sl_druhy_str;
}

function vazebnost_podhesli($hid, $podh_id, $to_pdf){
    $vazebnosti_podh_ids = get('vazebnosti_podhesli', $podh_id);
    $vazebnosti_podh_arr = array();
    foreach($vazebnosti_podh_ids as $vaz_id){
        $vaz = text_html_preprocess(get_db_values('podhesli_vazebnost', 'vazebnost', $vaz_id));
        $vaz = strip_tags($vaz);
        $vaz_kom = text_html_preprocess(get_db_values('podhesli_vazebnost', 'komentar', $vaz_id));
        if(trim($vaz)!=""){
            $DOMid = "podhesli-$podh_id--vazebnost-$vaz_id--tvar";
            $vaz = text_html_preprocess($vaz);
            if(!$to_pdf){
                handle_correction($hid, $DOMid, 'podhesli-vazebnost-tvar', $vaz_id, $vaz);
            }
            if(!empty($vaz_kom)){
                $DOMid = "podhesli-$podh_id--vazebnost-$vaz_id--komentar";
                if(!$to_pdf){
                    handle_correction($hid, $DOMid, 'podhesli-vazebnost-komentar', $vaz_id, $vaz_kom);
                }
            }
            $vazebnosti_podh_arr[] = ((!empty($vaz_kom))?"<span class='komentar'>$vaz_kom</span>\r\n":"").$vaz;
        }
    }
    return $vazebnosti_podh_arr;
}

function obor_uziti($hid, $id, $to_pdf, $prefix="vyz"){
    $place = "vyznam";
    if($prefix === "podh"){
        $place = "podhesli";
    }
    $DOMid = "$place-$id--obor_uziti";
    $oborUziti_cisVyber = get_vybrane_hodnoty_ciselniku(OBOR_UZITI, $prefix, $id);
    $oborUziti_cisVyber_str = text_html_preprocess(implode(", ", $oborUziti_cisVyber));
    if((!$to_pdf) && !empty($oborUziti_cisVyber)){
        handle_correction($hid, $DOMid, "$place-obor_uziti", $id, $oborUziti_cisVyber_str);
    }
    return $oborUziti_cisVyber_str;
}


function over_vystup($hesla, $souvisle, $to_pdf, $vystup){
    if(count($hesla) > 1 && $souvisle){
        if($to_pdf){
            if($vystup!=TISTENY){
                return false;
            }
        } else{
            if($vystup == NEZARAZENO || $vystup == NEZARAZENO_FRAZ){
                return false;
            }
        }
    }
    return true;
}

function over_filtr(){
    if(isset($_SESSION['data_filter'])){
        if($_SESSION['data_filter']['_filterName']=="oznacene"){
            return true;
        }
    }
    return false;
}


function je_viceslovne($hid){
    global $_TYP_HESLA;
    $var_id = get_hlavni_varianta_hesla($hid);
    $typHesla_cisVyber = get_vybrane_hodnoty_ciselniku(TYP_HESLA, 'var', $var_id);
    $typHesla_cisVyber_str = text_html_preprocess(implode(", ", $typHesla_cisVyber));
    if(strpos($typHesla_cisVyber_str, "víceslovné") !== false){
        return true;
    }
    return false;

}

function tisk_hesla($aj_varianty, $hid, $vid, $to_pdf, $master, &$bilaZona, $redakce = true, $hidRel_id = 0, $slave_hid = 0, $www=false, $hesla=array()){
    global $web;
    Global $heslar;
    $clsSuffix = "";
    if($heslar != HESLAR_HLAVNI){
        $clsSuffix = "Prop";
    }
    //definovane v konstanty.php
    global $_STAV_HESLA;
    global $_VYSTUP;
    global $_TYP_HESLA;
    global $preview;
    global $processed_rel_ids;
    $role = get_role();
    $html = "";
    $vyznamy_novy_radek = false;
    $podhesli_vyznamu_cls = "podhesli";
    //$heslar = get_db_values('heslo', 'heslar_id', $hid);

    if($master){
        $processed_rel_ids = array();
    }
    $cacheable = true;
    $souvisle = null;
    if(isset($_GET['souvisl'])){
        $souvisle = $_GET['souvisl'];
    }
    if(is_null($souvisle) || empty($souvisle)) $souvisle = 0;

    $var_temp = get_db_values('varianty',array('varianta, sortorder, homonymie'),$vid);
    if(!isset($var_temp['sortorder']))  $var_temp['sortorder']=1;

    if($var_temp['sortorder']=='1' || $master==false)
    {
        if(!$to_pdf)
            $popUp = "";
        $jednoslovne = true;
        $subhids = get_subhids($hid); //id podrazenych hesel
        $bileZony = ""; //kody pro bile zony pripojenych/prihnizdenych hesel
        $bilaZona = ""; //kod pro do bile zony
        $hinfo = get_db_values('heslo',array('cts, uts, stav, vystup, lexgraf_pozn, pozn_odbornik, redukce'),$hid);
        //provadet redukci duplicit v PDF nahledu?
        $reduce = $hinfo['redukce'];
        $pdf_tmp = $to_pdf;

        $do_vystupu = $_VYSTUP[$hinfo['vystup']];
        if(!over_vystup($hesla, $souvisle, $to_pdf, $hinfo['vystup'])){
            return;
        }

        if(($souvisle) && (count($hesla) > 1)){
            if($master && je_viceslovne($hid) && $heslar==HESLAR_HLAVNI){
                return;
            }
        }


        $varianty = get('varianty_hesla', $hid, array('sortorder'));
        if(!$aj_varianty){
            $varianty = (array)$varianty[0];
        }
        $stav = $_STAV_HESLA[$hinfo['stav']];
        $zpracovatele_vyber = get_vybrane_hodnoty_ciselniku(ZPRACOVATELE, 'hes', $hid);
        $zpracovatele_str = implode(", ",$zpracovatele_vyber);

        $header = array();
        $komentareArray = array();
        $variantyArray = array();
        $varPodhArray = array();
        $komentareZaArray = array();
        $komentarTvaruArray = array();
        $slDruhyArray = array();
        $tvarCharArray = array();
        $tvarCharSlArray = array();
        $puvodArray = array();
        $gramInfoArray = array();
        $oborArray = array();
        $stylKvalArray = array();
        $tematickeOkruhyArray = array();
        $prvniRegVyskytArray = array();
        $komentarTvarcharArray = array();
        $komentarTvarcharSlovesaArray = array();
        $vyslovnostArray = array();
        $vazebnostArray = array();
        $separatorArray = array();

        //PUVOD
        $DOMid = "heslo-$hid--konec_zahlavi";
        $konec_zahlavi_cisVyber = get_vybrane_hodnoty_ciselniku(KONEC_ZAHLAVI, 'heslo', $hid);
        $konec_zahlavi_cisVyber_str = text_html_preprocess(implode(", ", $konec_zahlavi_cisVyber));
        if(!$to_pdf)
           handle_correction($hid, $DOMid, 'heslo-konec_zahlavi', $hid, $konec_zahlavi_cisVyber_str);

        if($master){
            if($to_pdf)
                $html.="\r\n<!-- VARIANTY -->";
            else
                $html.="\r\n<div class='pdf'><!-- VARIANTY -->\r\n<span class='varianty'>";
        }

        if(!$reduce && !$web){
            //$to_pdf = false;
        }

        $cisloVarianty = 0;
        $pocetVariant = count($varianty);
        foreach($varianty as $var_id){
            $D = get_db_values('varianty', array('varianta'), $var_id);
            $var = text_html_preprocess(trim($D['varianta']));
            $variantyArray[] = $var;
        }
        $sluc = false;
        if(($pocetVariant > 1) && (count(array_unique($variantyArray)) < $pocetVariant) && $reduce){
            $sluc = true;
        }

        $pocet_vyznamu = count(get_vyznamy_count($hid, $to_pdf));
        $vicevyznamove = ($pocet_vyznamu > 1);
        $variantyArray = array();
        $template = "";
        foreach($varianty as $var_id){
            $cisloVarianty++;
            $D = get_db_values('varianty', array('varianta', 'neosemantismus', 'homonymie', 'komentar', 'komentar_za', 'prvni_reg_vyskyt', 'sortorder','komentar_tvarchar','komentar_tvarchar_slovesa', 'komentar_tvaru', 'f_varianta'), $var_id);
				$varPodhArray[$cisloVarianty] = $D['f_varianta'];
            //VARIANTA a jej vlastnosti (neologismus, homonymie)
            $close_tag = "";
            if($web)
            {
                if(check_link($hid) && !$master && !is_slave($hid)){
                    $varianty = get('varianty_hesla', $hid, array('sortorder'));
                    $hl_var_data = get_db_values('varianty', array('varianta', 'homonymie'), $varianty[0]);

                    $var = '<a id="hid-'.$hid.'" class="clickable" href="heslo/'.$hl_var_data['varianta'].'--'.$hl_var_data['homonymie'].'/'.$hid.'"><span class="clickable">'.fix_typography(text_html_preprocess(trim($D['varianta'])));
                    $close_tag = "</span></a>";

                } else{
                    $var = '<span id="hid-'.$hid.'">'.fix_typography(text_html_preprocess(trim($D['varianta'])));
                    $close_tag = "</span>";
                }
            }
            else
            {
                $var = fix_typography(text_html_preprocess(trim($D['varianta'])));
            }


            if(/*$master &&*/ !$to_pdf && $redakce){
                $slave_id = '';
                if(!$master) $slave_id = $hid;
                if(!$hidRel_id){
                    $DOMid = "varianta-$var_id--tvar";
                    handle_correction($hid, $DOMid, 'varianta-tvar', $var_id, $var, 'span', $slave_id);
                }
                else{
                    $DOMid = "nest-$hidRel_id";
                    handle_correction($hid, $DOMid, 'nest', $hidRel_id, $var, 'span', $slave_hid);
                }
            } /*else
        if(!$redakce){
          $var = "<a href='tisk_hesel_new.php?hid=$hid'>".$var."</a>";
        } */
            $is_neo = ($D['neosemantismus']=='1') ? true : false;
            $neo_sign = (($is_neo) ? "".NEO : "");
            $homonym = (trim($D['homonymie'])!="")? "&nbsp;".number_to_roman(text_html_preprocess($D['homonymie'])):"";
            if(!$to_pdf && !empty($homonym)){
                $DOMid = "varianta-$var_id--homonymie";
                handle_correction($hid, $DOMid, 'varianta-homonymie', $var_id, $homonym);
            }
            if($to_pdf && $D['f_varianta']==0){
                $var.="^^P".$cisloVarianty."^^";
            }
            $variantyArray[$cisloVarianty] = $var.$neo_sign.$homonym.$close_tag;
            $var_kom = text_html_preprocess(trim($D['komentar']));
            $komentareArray[$cisloVarianty][] = $var_kom;
            if(!empty($var_kom) && !$to_pdf){
                $DOMid = "varianta-$var_id--komentar";
                handle_correction($hid, $DOMid, 'varianta-komentar', $var_id, $var_kom);
            }

            $var_kom_za = text_html_preprocess(trim($D['komentar_za']));
            $komentareZaArray[$cisloVarianty][] = $var_kom_za;
            if(!empty($var_kom_za) && !$to_pdf){
                $DOMid = "varianta-$var_id--komentarza";
                handle_correction($hid, $DOMid, 'varianta-komentarza', $var_id, $var_kom_za);
            }


            //PRVNI REG. VYSKYT
            $prvni_reg_vyskyt = text_html_preprocess(trim($D['prvni_reg_vyskyt']));
            if($prvni_reg_vyskyt!=""){
                $DOMid = "varianta-$var_id--prvni_registr_vyskyt";
                if(!$to_pdf)
                    handle_correction($hid, $DOMid, 'varianta-prvni_registr_vyskyt', $var_id, $prvni_reg_vyskyt);
                else
                    $prvniRegVyskytArray[$cisloVarianty][] = $prvni_reg_vyskyt;
            }

            //KOMENTAR K TVAROSLOVNE CHARAKTERISTICE
            $komentar_tvarchar = text_html_preprocess(trim($D['komentar_tvarchar']));
            if($komentar_tvarchar!=""){
                $DOMid = "varianta-$var_id--komentar_tvarchar";
                if(!$to_pdf)
                    handle_correction($hid, $DOMid, 'varianta-komentar_tvarchar', $var_id, $komentar_tvarchar);
                else
                    $komentarTvarcharArray[$cisloVarianty][] = $komentar_tvarchar;
            }

            //KOMENTAR K TVAROSLOVNE CHARAKTERISTICE SLOVESA
            $komentar_tvarchar_slovesa = text_html_preprocess(trim($D['komentar_tvarchar_slovesa']));
            if($komentar_tvarchar_slovesa!=""){
                $DOMid = "varianta-$var_id--komentar_tvarchar_slovesa";
                if(!$to_pdf)
                    handle_correction($hid, $DOMid, 'varianta-komentar_tvarchar_slovesa', $var_id, $komentar_tvarchar_slovesa);
                else
                    $komentarTvarcharSlovesaArray[$cisloVarianty][] = $komentar_tvarchar_slovesa;
            }

            //komentar tvaru
            $komentar_tvaru = '';
            if(is_field_enabled($hid, 'varianta--komentar_tvaru')){
              $komentar_tvaru = trim($D['komentar_tvaru']);
              if(!empty($komentar_tvaru)){
                  $DOMid = "varianta-$var_id--komentar_tvaru";
                  $komentar_tvaru = handle_wysiwyg($komentar_tvaru);
                  if(!$to_pdf){
                      handle_correction($hid, $DOMid, 'varianta-komentar_tvaru', $var_id, $komentar_tvaru);
                  }else{
                      $komentarTvaruArray[$cisloVarianty][] = $komentar_tvaru;
                  }
              }
            }

            //SLOV_DRUHY
            $sl_Druhy = get('slovneDruhy_varianty', $var_id);
            $sl_druhy_str = $sl_Druhy_vyber = array();
            $slDruhyArray[$cisloVarianty][0] = '';
            //$slDruhyArray[$cisloVarianty] = array();
            foreach($sl_Druhy as $slDruh_id){
                $tmp = get_vybrane_hodnoty_ciselniku(SLOV_DRUHY, 'var', $slDruh_id);
                $sl_druhy_raw = $tmp;
                if($to_pdf){
                    $slDruhyArray[$cisloVarianty] = $slDruhyArray[$cisloVarianty] + $tmp;
                }
                $sl_druhy = text_html_preprocess(implode(", ", $sl_druhy_raw));
                $DOMid = "varianta-$var_id--slovnyDruh-$slDruh_id";
                if(!$to_pdf)
                    handle_correction($hid, $DOMid, 'varianta-slovnyDruh', $slDruh_id, $sl_druhy);
                if(!empty($sl_druhy_raw)){
                    $sl_druhy_kom = get_db_values('var_slov_druhy_vyber_rel', 'komentar', $slDruh_id);
                    if(!empty($sl_druhy_kom)){
                        $sl_druhy_kom = text_html_preprocess($sl_druhy_kom);
                        $DOMid = "varianta-$var_id--slovnyDruh-$slDruh_id--komentar";
                        if(!$to_pdf){
                            handle_correction($hid, $DOMid, 'varianta-slovny_druh-komentar', $slDruh_id, $sl_druhy_kom);
						}
						if(!empty($sl_druhy_kom)){
                        	$slDruhyArray[$cisloVarianty][0] = "<span class='sl_druhy_kom'>".$sl_druhy_kom."</span>";
						}
                    }
                    $sl_druhy_str[] = ((!empty($sl_druhy_kom))?"<span class='sl_druhy_kom'>$sl_druhy_kom</span>\r\n":"").$sl_druhy;
                }
            }
            //TVAROSLOVNE UDAJE
            $tvCh_arr = array();
            $field = '';
            $tvChs = get('tvarChary_varianty', $var_id, 'sortorder');
            foreach($tvChs as $tvCh_id){
                $tvCh_str = "";
                $field = "";
                $tmp = get_vybrane_hodnoty_ciselniku(TVAR_CHAR, 'var', $tvCh_id);
                $tvChs_vyber = $tmp;
                if(!empty($tvChs_vyber)){
                    $DOMid = "varianta-$var_id--tvarChar-$tvCh_id";
                    $tvCh_str = $field = text_html_preprocess(implode(", ", $tvChs_vyber));
                    if(!$to_pdf)
                        handle_correction($hid, $DOMid, 'varianta-tvarChar', $tvCh_id, $tvCh_str);
                    else
                        add_css_class($field, 'varianta-tvarChar', 'span');
                }
                $koncofky_ids = get('koncovky_tvarChar', $tvCh_id, 'sortorder');
                $koncofky = array();
                $cisloKoncovky = 0;
                foreach($koncofky_ids as $konc_id){
                    $cisloKoncovky++;
                    $konc = get_db_values('koncovky_tvar_char', 'koncovka', $konc_id);
                    $konc_kom = get_db_values('koncovky_tvar_char', 'komentar', $konc_id);
                    if(trim($konc)!=""){
                        $konc = text_html_preprocess($konc);
                        $DOMid = "varianta-$var_id--tvarChar-$tvCh_id--koncovka-$konc_id--tvar";
                        if(!$to_pdf)
                            handle_correction($hid, $DOMid, 'varianta-tvarChar-koncovka-tvar', $konc_id, $konc);
                        else
                            add_css_class($konc, 'varianta-tvarChar-koncovka-tvar', 'span');
                    }
                    if(!empty($konc_kom)){
                        $konc_kom = text_html_preprocess($konc_kom);
                        $DOMid = "varianta-$var_id--tvarChar-$tvCh_id--koncovka-$konc_id--komentar";
                        if(!$to_pdf){
                            handle_correction($hid, $DOMid, 'varianta-tvarChar-koncovka-komentar', $konc_id, $konc_kom);
                        }
                        else{
                            add_css_class($konc_kom, 'varianta-tvarChar-koncovka-komentar', 'span');
                            if($cisloKoncovky > 1)
                                $field = $field.", ".$konc_kom." ".$konc;
                            else
                                $field = $field." ".$konc_kom." ".$konc;
                            $field = trim($field);
                        }
                        if(!empty($konc))
                            $konc = "\r\n".$konc;
                    }
                    else{
                        //$field = "";
                        if(!empty($konc)){
                          if($cisloKoncovky > 1)
                              $field = $field.", ".$konc;
                          else
                              $field = $field." ".$konc;
                          $field = trim($field);
                        }
                    }
                    $empty_test = ((!empty($konc_kom))?"<span class='komentar'>$konc_kom</span>":"").$konc;
                    if(!empty($empty_test)){
                      $koncofky[] = $empty_test;
                    }

                }
				if(!empty($field)){
					$tvarCharArray[$cisloVarianty][] = $field;
				}
                /*if($koncofky_ids==null && !empty($field)){
            $tvarCharArray[$cisloVarianty][] = $field;
          }*/
                if(!empty($koncofky) && !empty($tvCh_str)) $tvCh_str.="&nbsp;";
                $tvCh_str.= implode(",&nbsp;", $koncofky);
                if(trim($tvCh_str)!="")
                    $tvCh_arr[] = $tvCh_str;
            }

            //TVAROSLOVNE UDAJE SLOVESA
            $tvChSl_arr = array();
            $field = '';
            $tvChSls = get('tvarCharySl_varianty', $var_id, 'sortorder');
            foreach($tvChSls as $tvChSl_id){
                $tvChSl_str = "";
                $tmp = get_vybrane_hodnoty_ciselniku(TVAR_CHAR_SL, 'var', $tvChSl_id);
                $tvChSls_vyber = $tmp;
                if(!empty($tvChSls_vyber)){
                    $DOMid = "varianta-$var_id--tvarCharSl-$tvChSl_id";
                    $tvChSl_str = $field = text_html_preprocess(implode(", ", $tvChSls_vyber));
                    if(!$to_pdf)
                        handle_correction($hid, $DOMid, 'varianta-tvarCharSl', $tvChSl_id, $tvChSl_str);
                    else
                        add_css_class($field, 'varianta-tvarCharSl', 'span');
                }
                $koncofky_ids = get('koncovky_tvarCharSl', $tvChSl_id, 'sortorder');
                $koncofky = array();
                $cisloKoncovky =  0;
                foreach($koncofky_ids as $konc_id){
                    $cisloKoncovky++;
                    $konc = get_db_values('koncovky_tvar_char_sl', 'koncovka', $konc_id);
                    $konc_kom = get_db_values('koncovky_tvar_char_sl', 'komentar', $konc_id);
                    if(trim($konc)!=""){
                        $konc = text_html_preprocess($konc);
                        $DOMid = "varianta-$var_id--tvarCharSl-$tvChSl_id--koncovka-$konc_id--tvar";
                        if(!$to_pdf)
                            handle_correction($hid, $DOMid, 'varianta-tvarCharSl-koncovka-tvar', $konc_id, $konc);
                        else
                            add_css_class($konc, 'varianta-tvarCharSl-koncovka-tvar', 'span');
                    }
                    if(!empty($konc_kom)){
                        $konc_kom = text_html_preprocess($konc_kom);
                        $DOMid = "varianta-$var_id--tvarCharSl-$tvChSl_id--koncovka-$konc_id--komentar";
                        if(!$to_pdf)
                            handle_correction($hid, $DOMid, 'varianta-tvarCharSl-koncovka-komentar', $konc_id, $konc_kom);
                        else{
                            add_css_class($konc_kom, 'varianta-tvarCharSl-koncovka-komentar', 'span');
                            if($cisloKoncovky > 1)
                                $field = $field.", ".$konc_kom." ".$konc;
                            else
                                $field = $field." ".$konc_kom." ".$konc;
                            $field = trim($field);
                        }
                    }  else{
                        //$field = "";
                        if(!empty($konc)){
                          if($cisloKoncovky > 1)
                              $field = $field.", ".$konc;
                          else
                              $field = $field." ".$konc;
                          $field = trim($field);
                      }
                    }
                    if(!empty($konc_kom) && !empty($konc))
                        $konc = "\r\n".$konc;
                    $empty_test = ((!empty($konc_kom))?"<span class='komentar'>$konc_kom</span>":"")."".$konc;
                    if(!empty($empty_test)){
                      $koncofky[] = $empty_test;
                    }
                }
                $tvarCharSlArray[$cisloVarianty][] = $field;
                if(!empty($koncofky) && !empty($tvChSl_str)) $tvChSl_str.="&nbsp;";
                $tvChSl_str.= implode(",&nbsp;", $koncofky);
                if(trim($tvChSl_str)!="")
                    $tvChSl_arr[] = $tvChSl_str;
            }

            //GRAM INFO
            $DOMid = "varianta-$var_id--gram_info";
            $gramInfo_cisVyber = get_vybrane_hodnoty_ciselniku(GRAM_INFO, 'var', $var_id);
            $gramInfo_cisVyber_str = text_html_preprocess(implode(", ", $gramInfo_cisVyber));
            if(!$to_pdf)
                handle_correction($hid, $DOMid, 'varianta-gram_info', $var_id, $gramInfo_cisVyber_str);
            else
                $gramInfoArray[$cisloVarianty] = $gramInfo_cisVyber;

            //PUVOD
            $DOMid = "varianta-$var_id--puvod";
            $puvod_cisVyber = get_vybrane_hodnoty_ciselniku(PUVOD, 'var', $var_id);
            $puvod_cisVyber_str = text_html_preprocess(implode(", ", $puvod_cisVyber));
            if(!$to_pdf)
                handle_correction($hid, $DOMid, 'varianta-puvod', $var_id, $puvod_cisVyber_str);
            else
                $puvodArray[$cisloVarianty] = $puvod_cisVyber;

            //OBOR UZITI
            $DOMid = "varianta-$var_id--obor_uziti";
            $oborUziti_cisVyber = get_vybrane_hodnoty_ciselniku(OBOR_UZITI, 'var', $var_id);
            $oborUziti_cisVyber_str = text_html_preprocess(implode(", ", $oborUziti_cisVyber));

            if(!$to_pdf)
                handle_correction($hid, $DOMid, 'varianta-obor_uziti', $var_id, $oborUziti_cisVyber_str);
            else
                $oborArray[$cisloVarianty] = $oborUziti_cisVyber;

            //STYLISTICKY KVAL.
            $DOMid = "varianta-$var_id--styl_kval";
            $stylKval_cisVyber = get_vybrane_hodnoty_ciselniku(STYL_KVAL, 'var', $var_id);
            $stylKval_cisVyber_str = text_html_preprocess(implode(", ", $stylKval_cisVyber));
            if($preview){
                $stylKval_cisVyber = str_replace("&#9651;", "<span style='font-size:17px;'>&#9651;</span>", $stylKval_cisVyber);
            }
            if(!$to_pdf)
                handle_correction($hid, $DOMid, 'varianta-styl_kval', $var_id, $stylKval_cisVyber_str);
            else
                $stylKvalArray[$cisloVarianty] = $stylKval_cisVyber;


            //TYP HESLA
            $typHesla_cisVyber_str = typ_hesla($hid, $var_id, $to_pdf);

            //TEMATICKE OKRUHY
            $DOMid = "varianta-$var_id--tematicke_okruhy";
            $tematickeOkruhy_cisVyber = get_vybrane_hodnoty_ciselniku(TEMATICKE_OKRUHY, 'var', $var_id);
            $tematickeOkruhy_cisVyber_str = text_html_preprocess(implode(", ", $tematickeOkruhy_cisVyber));
            if(!$to_pdf){
                if($tematickeOkruhy_cisVyber_str==""){
                    $tematickeOkruhy_cisVyber_str = "--neoborové--";
                }
                handle_correction($hid, $DOMid, 'varianta-tematicke_okruhy', $var_id, $tematickeOkruhy_cisVyber_str);
            }
            $tematickeOkruhyArray[$cisloVarianty] = $tematickeOkruhy_cisVyber_str;

            //VAZEBNOST
            $vazebnosti_var_ids = get('vazebnosti_varianty', $var_id);
            $vazebnosti_var_arr = array();
            foreach($vazebnosti_var_ids as $vaz_id){
                $vaz = text_html_preprocess(get_db_values('vazebnost_var', 'vazebnost', $vaz_id));
                $vaz = strip_tags($vaz);
                $vaz_kom = text_html_preprocess(get_db_values('vazebnost_var', 'komentar', $vaz_id));
                if(trim($vaz)!=""){
                    $DOMid = "varianta-$var_id--vazebnost-$vaz_id--tvar";
                    if(!$to_pdf)
                        handle_correction($hid, $DOMid, 'varianta-vazebnost-tvar', $vaz_id, $vaz);
                    if(!empty($vaz_kom)){
                        $DOMid = "varianta-$var_id--vazebnost-$vaz_id--komentar";
                        if(!$to_pdf)
                            handle_correction($hid, $DOMid, 'varianta-vazebnost-komentar', $vaz_id, $vaz_kom);
                    }
                    $s = ((!empty($vaz_kom))?"<span class='komentar'>$vaz_kom</span>\r\n":"").$vaz;
                    $vazebnostArray[$cisloVarianty][] = $s;
                    $vazebnosti_var_arr[] = $s;
                }
            }

            //VYSLOVNOST
            $vyslovnosti_ids = get('vyslovnosti_varianty', $var_id);
            $vyslovnosti_arr = array();
            foreach($vyslovnosti_ids as $vysl_id){
                $vysl = text_html_preprocess(get_db_values('vyslovnost_var', 'vyslovnost', $vysl_id));
                $vysl_kom = text_html_preprocess(get_db_values('vyslovnost_var', 'komentar', $vysl_id));
                if(trim($vysl)!=""){
                    $DOMid = "varianta-$var_id--vyslovnost-$vysl_id--tvar";
                    if(!$to_pdf)
                        handle_correction($hid, $DOMid, 'varianta-vyslovnost-tvar', $vysl_id, $vysl);

                    if(!empty($vysl_kom)){
                        $DOMid = "varianta-$var_id--vyslovnost-$vysl_id--komentar";
                        if(!$to_pdf)
                            handle_correction($hid, $DOMid, 'varianta-vyslovnost-komentar', $vysl_id, $vysl_kom);
                    }
                    $s = ((!empty($vysl_kom))?"<span class='komentar'>$vysl_kom</span>\r\n":"").$vysl;
                    $vyslovnostArray[$cisloVarianty][] = $s;
                    $vyslovnosti_arr[] = $s;

                }
            }

            //Zacatek tisku varianty
            /*$html.="
         <div class='variantaContainer'>\r\n<div class='margin'>\r\n
          <h3 style='float:left'>heslo (var.):&nbsp;".$var.$neo_sign.$homonym."&nbsp;</h3>\r\n"; */
            $header[$cisloVarianty] = '';
            if($master && !empty($typHesla_cisVyber)){
                if($cisloVarianty == 1){
                    $sign = print_sign($typHesla_cisVyber_str, $jednoslovne);
                    $header[$cisloVarianty].=$sign;
                }
            }

            /*if(($cisloVarianty > 1) && !empty($var_kom))
            $header[$cisloVarianty].="\r\n<span class='varianta-label'>".$var_kom."</span>\r\n";*/

            if($to_pdf){
                $header[$cisloVarianty].="^^komentar$cisloVarianty^^\r\n";
                //$header[$cisloVarianty].="^^varianta$cisloVarianty^^\r\n";
                $header[$cisloVarianty].="^^stylKvalPred$cisloVarianty^^\r\n";
            }


            $t = strip_tags($gramInfo_cisVyber_str);
            $gramInfoVarUsed = false;
            if(!$to_pdf && $D['f_varianta']==0 && ($t == "mn." || $t == "pomn." || $t=="zprav. mn.")){
                    $gramInfoVarUsed = true;
                    $header[$cisloVarianty] .= "\r\n<span class='gramInfoUpres'>".$gramInfo_cisVyber_str."</span>";
            }

            //if(($sluc && $cisloVarianty == 1) || (!$sluc) || (!$to_pdf)){

            if(/*($cisloVarianty == 1) &&*/ !empty($var_kom) && !$to_pdf)
                $header[$cisloVarianty].="\r\n<span class='varianta-label'>".$var_kom."</span>\r\n";

            if($to_pdf){
                $var = "^^varianta$cisloVarianty^^";
                $neo_sign = "";
                $homonym = "";
            }

            if($cisloVarianty == 1){
              $podhesli_vyznamu_cls = "souslovi$clsSuffix";
            }
            if($master)
            {
                $typHesla_stripped = strip_tags($typHesla_cisVyber_str);
                if($typHesla_stripped==$_TYP_HESLA[SOUSLOVI]){
                    if($heslar == HESLAR_HLAVNI){
                    $header[$cisloVarianty].="<span class='souslovi$clsSuffix'>&#9633;\r\n".$var.$neo_sign.$homonym."</span>";
                    } else{
                    $header[$cisloVarianty].="<span class='souslovi$clsSuffix'>".$var.$neo_sign.$homonym."</span>";
                    }
                }
                else if($typHesla_stripped==$_TYP_HESLA[FRAZEM]){
                    $header[$cisloVarianty].="<span class='frazem$clsSuffix'>\r\n".$var.$neo_sign.$homonym."</span>";
                    if($cisloVarianty == 1){
                      $podhesli_vyznamu_cls = "frazem$clsSuffix";
                    }
                }
                else if($typHesla_stripped==$_TYP_HESLA[VICESLOVNE]){
                    $header[$cisloVarianty].="<span class='viceslovne$clsSuffix'>&#9633;\r\n".$var.$neo_sign.$homonym."</span>";
                    if($cisloVarianty == 1){
                      $podhesli_vyznamu_cls = "viceslovne$clsSuffix";
                    }
                }
                else{
                    $header[$cisloVarianty].="<span class='heslo$clsSuffix'>".$var.$neo_sign.$homonym."</span>";
                    if($cisloVarianty == 1){
                      $podhesli_vyznamu_cls = "heslo$clsSuffix";
                    }
                }
            }
            else
            {
                $cls = 'odkaz';
                if($pdf_tmp)
                    $cls = 'nepodtrzeny_odkaz';
                $typHesla_stripped = strip_tags($typHesla_cisVyber_str);
                if($typHesla_stripped==$_TYP_HESLA[SOUSLOVI])
                    $header[$cisloVarianty].="<span class='souslovi$clsSuffix $cls'>".$var.$neo_sign.$homonym."</span>";
                else if($typHesla_stripped==$_TYP_HESLA[VICESLOVNE])
                    $header[$cisloVarianty].="<span class='viceslovne$clsSuffix $cls'>".$var.$neo_sign.$homonym."</span>";
                else if($typHesla_stripped==$_TYP_HESLA[FRAZEM])
                    $header[$cisloVarianty].="<span class='frazem$clsSuffix $cls'>".$var.$neo_sign.$homonym."</span>";
                else
                    $header[$cisloVarianty].="<span class='heslo$clsSuffix $cls'>".$var.$neo_sign.$homonym."</span>";
            }
            if(/*($cisloVarianty == 1) &&*/ !empty($var_kom_za))
                $header[$cisloVarianty].="\r\n<span class='varianta-label'>".$var_kom_za."</span>";

            //}
            if(!$to_pdf){
            	 $html.=$header[$cisloVarianty];
                //zpracovani podrazenych hesel
                if(!empty($subhids)){
                    $html.="\r\n<span id='toggle-$hid' class='small_plus' onclick='toggle_visibility(\"$hid\")'>&nbsp;&nbsp;&nbsp;&nbsp;</span><span id='subvarianty-$hid' class='hidden'>";
                    $poradi = 0;
                    foreach($subhids as $subhid){
                        $subvarianty = get('varianty_hesla', $subhid, array('sortorder'));
                        $poradi++;
                        foreach($subvarianty as $subvarianta){
                            $dbvals = get_db_values('varianty', array('id', 'varianta', 'komentar'), $subvarianta);
                            $subvar = text_html_preprocess(trim($dbvals['varianta']));
                            $subvar_id = $dbvals['id'];
                            //$DOMid = "subvarianta-$svar_id--tvar";
                            $DOMid = "varianta-$subvar_id--tvar";
                            handle_correction($subhid, $DOMid, 'varianta-tvar', $subvarianta, $subvar);
                            $subvar_kom = text_html_preprocess(trim($dbvals['komentar']));
                            if(!empty($subvar_kom)){
                                $DOMid = "subvarianta-$subvarianta--komentar";
                                handle_correction($subhid, $DOMid, 'varianta-komentar', $subvarianta, $subvar_kom);
                            }
                            if($poradi > 1)
                                $html.=",\r\n<span class='frazem '>$subvar</span>";
                            else
                                $html.="\r\n<span class='frazem '>$subvar</span>";
                            if(!empty($subvar_kom)){
                                $html.="\r\n<span class='varianta-label'>$subvar_kom</span>";
                            }
                        }
                    }
                    $html.="</span>";
                }

                //HTML vystup pro varianty - tisknou se vsechny informace,
                //bez redukce duplicit
                //-> !$to_pdf
                if(!empty($vyslovnosti_arr)){ //label výslovnost
                    $html.="\r\n<span class='vyslovnost'>[".implode(", ", $vyslovnosti_arr)."]</span>";
                }
                if($komentar_tvarchar!=""){ //label: komentar tvaroslovne charakteristiky
                    $html.="\r\n<span class='komentar_tvarchar'>".$komentar_tvarchar."</span>";
                }
                if($komentar_tvarchar_slovesa!=""){ //label: komentar tvaroslovne charakteristiky slovesa
                    $html.="\r\n<span class='komentar_tvarchar_slovesa'>".$komentar_tvarchar_slovesa."</span>";
                }
                if(!empty($tvCh_arr)){ //label: tvaroslovná charakteristika
                    $html.="\r\n<span class='normal_size'>(</span><span class='tvCh'>".implode(", ", $tvCh_arr)."</span><span class='normal_size'>)</span>";
                }
                if(!empty($tvChSl_arr)){ //label: tvaroslovná charakteristika slovesa
                    $html.="\r\n<span class='normal_size'>(</span><span class='tvCh'>".implode(", ", (array)$tvChSl_arr)."</span><span class='normal_size'>)</span>";
                }
                if(!empty($komentar_tvaru)){
                    $html.="\r\n<span class='komentar_tvaru'>$komentar_tvaru</span>";
                }
                if(!empty($sl_druhy_str)){ //label: slovní druh
                    $html.="\r\n<span class='sl_druh'>".implode(", ", $sl_druhy_str)."</span>";
                }
                if(!empty($gramInfo_cisVyber) && !$gramInfoVarUsed){ //label: upřesňující gram. info
                    $html.="\r\n<span class='gramInfoUpres'>".$gramInfo_cisVyber_str."</span>";
                }
                if(!empty($puvod_cisVyber)){ //label: původ
                    $html.="\r\n<span class='puvod'>&lt;".$puvod_cisVyber_str."&gt;</span>";
                }
                if(!empty($oborUziti_cisVyber)){ //label: obor/oblast užití
                    $html.="\r\n<span class='oborUziti'>".$oborUziti_cisVyber_str."</span>";
                }
                if(!empty($stylKval_cisVyber)){ //label: stylistický kvalifikátor
                    $html.="\r\n<span class='stylKval-label'>".$stylKval_cisVyber_str."</span>";
                }

                $vyznamy_novy_radek = false;
                if($jednoslovne && ($cisloVarianty == count($varianty)) && isset($vazebnostArray[$cisloVarianty]) && $vazebnostArray[$cisloVarianty]!==null){
                    if(!$vicevyznamove){
                      $html.="\r\n<br />";
                      $vyznamy_novy_radek = true;
                    }
                }

                if(!empty($vazebnosti_var_arr)){ //label: vazebnost
                    $html.="\r\n<span class='vazebnost'>(".implode(", ", $vazebnosti_var_arr).")</span>";
                }
                //tematicke okruhy v bile zone
                /*if(!empty($tematickeOkruhy_cisVyber)){ //label: tematické okruhy
                $html.="\r\n<span class='tematickeOkruhy'>".$tematickeOkruhy_cisVyber_str."</span> ";

            }*/
                if($prvni_reg_vyskyt!=""){ //label: první registr. výskyt
                    $html.="\r\n<span class='prvniRegVyskyt'>".$prvni_reg_vyskyt."</span>";
                }
            }


            //oddeleni jednotlivych variant carkou nebo n.
            if($pocetVariant > 1 && $pocetVariant > $cisloVarianty /*&& (!$sluc || !$to_pdf)*/)
                if(!$to_pdf){
                    if(strip_tags($typHesla_cisVyber_str)==$_TYP_HESLA[FRAZEM]){
                        $var_trimmed = trim(strip_tags($var));
                        if($var_trimmed[strlen($var_trimmed)-1]!='/')
                            $html.="<span class='frazem-oddelovac'> n. </span>";
                        else
                            $html.=" ";
                    }
                    else
                        $html.=", ";
                } else{
                    $separatorArray[$cisloVarianty] = '';

                    if(strip_tags($typHesla_cisVyber_str)==$_TYP_HESLA[FRAZEM]){
                        $var_trimmed = trim(strip_tags($var));
                        if($var_trimmed[strlen($var_trimmed)-1]!='/')
                            $separatorArray[$cisloVarianty]="<span class='frazem-oddelovac'> n. </span>";
                        else
                            $separatorArray[$cisloVarianty]=" ";
                    }
                    else
                        $separatorArray[$cisloVarianty]=", ";
                }
        } //foreach varianty


        if($master){
            if($pdf_tmp)
                $html.="\r\n<!-- varianty konec -->";
            else
                $html.="\r\n</span><!-- varianty konec -->";
        }

        //Odstraneni duplicit v PDF exportu
        if($to_pdf){
            $reduceVariants = true;
            $moveVariants = false;
            if($pocetVariant == 4){
                if(($variantyArray[1] == $variantyArray[3]) &&
                   ($variantyArray[2] == $variantyArray[4]) &&
                   ($variantyArray[1] != $variantyArray[2]))
                {
                    $moveVariants = true;
                } else if(($variantyArray[1] == $variantyArray[2]) &&
                   ($variantyArray[3] == $variantyArray[4]) &&
                   ($variantyArray[1] != $variantyArray[3]))
                {
                    $moveVariants = false;
                } else{
                    $reduceVariants = false;
                }

                $test_arr = array();
                if($reduceVariants){
                    for($i = 1; $i < 5; $i++){
                        $test_arr[$i] =
                                implode("", $komentareArray[$i])
                               .implode("", $komentareZaArray[$i])
                               .$komentarTvarcharArray[$i]
                               .$komentarTvarcharSlovesaArray[$i]
                               .$komentarTvaruArray[$i];
                        if(is_array($tvarCharArray[$i])){
                            $test_arr[$i] .= implode("", $tvarCharArray[$i]);
                        }
                        if(is_array($tvarCharSlArray[$i])){
                            $test_arr[$i] .= implode("", $tvarCharSlArray[$i]);
                        }
                        $test_arr[$i] .= implode("", $slDruhyArray[$i])
                               .implode("", $gramInfoArray[$i]);
                        if(is_array($vyslovnostArray[$i])){
                             $test_arr[$i] .= implode($vyslovnostArray[$i]);
                        }
                        $test_arr[$i] .= implode("", $puvodArray[$i])
                               .implode("", $oborArray[$i])
                               .implode("", $stylKvalArray[$i])
                               .implode("", $oborArray[$i])
                               .implode("", $stylKvalArray[$i])
                               .$vazebnostArray[$i]
                               .implode("", $prvniRegVyskytArray);

                    }

                    if($moveVariants && ($test_arr[1] != $test_arr[2] || ($test_arr[3] != $test_arr[4]))){
                        $reduceVariants = false;
                    }

                    if(!$moveVariants && ($test_arr[1] != $test_arr[3] || ($test_arr[2] != $test_arr[4]))){
                        $reduceVariants = false;
                    }
                }

                if($reduceVariants){
                    $pocetVariant = 2;
                    if($moveVariants){
                        $variantyArray[1] = $variantyArray[1]."<span class='oddelovac'>, </span>".$variantyArray[2];
                    } else{
                        $variantyArray[1] = $variantyArray[1]."<span class='oddelovac'>, </span>".$variantyArray[3];

                    }
                    $variantyArray[2] = $variantyArray[1];
                    unset($variantyArray[3]);
                    unset($variantyArray[4]);

                    reduceArray($komentareArray, $moveVariants);
                    reduceArray($komentareZaArray, $moveVariants);
                    reduceArray($komentarTvarcharArray, $moveVariants);
                    reduceArray($komentarTvarcharSlovesaArray, $moveVariants);
                    reduceArray($tvarCharArray, $moveVariants);
                    reduceArray($tvarCharSlArray, $moveVariants);
                    reduceArray($komentarTvaruArray, $moveVariants);
                    reduceArray($slDruhyArray, $moveVariants);
                    reduceArray($gramInfoArray, $moveVariants);
                    reduceArray($vyslovnostArray, $moveVariants);
                    reduceArray($puvodArray, $moveVariants);
                    reduceArray($oborArray, $moveVariants);
                    reduceArray($stylKvalArray, $moveVariants);
                    reduceArray($vazebnostArray, $moveVariants);
                    reduceArray($prvniRegVyskytArray, $moveVariants);

                    unset($separatorArray[2]);
                    unset($separatorArray[3]);
                }
            }


            $remove = true;
            if($reduce){
                redukuj_vyslovnost($variantyArray, $slDruhyArray, $tvarCharArray, $pocetVariant, $vyslovnostArray);
            }
            if($reduce){
                $stylKvalPostfix = priprav_stylKval($stylKvalArray, $pocetVariant);
            } else{
                $stylKvalPostfix = "";
            }
            //$template = '';
            for($cisloVarianty = 1; $cisloVarianty <= $pocetVariant; $cisloVarianty++){
                if($reduce){
                    $template.="%%Z$cisloVarianty"; //zacatek varianty
                }
                $template.="^^gramInfoUpresSpecial$cisloVarianty^^";
                $template.=$header[$cisloVarianty];
                $template.="^^vyslovnost$cisloVarianty^^";
                $template.="^^komentar_tvarchar$cisloVarianty^^
            ^^komentar_tvarchar_slovesa$cisloVarianty^^
            ^^tvCh$cisloVarianty^^
            ^^tvChSl$cisloVarianty^^
            ^^komentar_tvaru$cisloVarianty^^
            ^^sl_druh$cisloVarianty^^
            ^^gramInfoUpres$cisloVarianty^^
            ^^puvod$cisloVarianty^^
            ^^oborUziti$cisloVarianty^^
            ^^stylKval$cisloVarianty^^";
                if($cisloVarianty < $pocetVariant || ($vicevyznamove && $cisloVarianty == $pocetVariant)){
                    $template.="^^vazebnost$cisloVarianty^^";
                }
                if(isset($variantyArray[$cisloVarianty+1]) && $variantyArray[$cisloVarianty]==$variantyArray[$cisloVarianty+1] && $reduce){
                    $template.=" ";
                    $vyslovnostArray[$cisloVarianty+1] = null;
                } else{
                    if(isset($separatorArray[$cisloVarianty])){
                        $template.=$separatorArray[$cisloVarianty];
                    }
                }
                if($reduce){
                    $template.="%%K$cisloVarianty"; //konec varianty
                }
            }
            if(!empty($stylKvalPostfix)){
                $template = str_replace("^^stylKval$pocetVariant^^", $stylKvalPostfix, $template);
            }
            //ini_set('xdebug.var_display_max_data', 8192);
            print_duplicities($reduce, $variantyArray, "varianta", $template, "", "", true);
            print_duplicities($reduce, $komentareArray, "komentar", $template, "", "", true);
            print_duplicities($reduce, $komentareZaArray, "komentarZa", $template, "", "", true);
            print_duplicities($reduce, $komentarTvarcharSlovesaArray, "komentar_tvarchar_slovesa", $template);
            //print_duplicities($reduce, $tvarCharArray, "tvCh", $template, "(", ")");
            print_tvCh($reduce, $tvarCharArray, $template, $remove, $variantyArray, $slDruhyArray, $stylKvalArray, $komentarTvarcharArray);
            print_duplicities($reduce, $komentarTvarcharArray, "komentar_tvarchar", $template);
            print_duplicities($reduce, $tvarCharSlArray, "tvChSl", $template, "<span class='normal_size'>(</span>", "<span class='normal_size'>)</span>");
            print_duplicities($reduce, $komentarTvaruArray, "komentar_tvaru", $template, "", "");
            print_duplicities($reduce, $slDruhyArray, "sl_druh", $template);
            print_duplicities($reduce, $gramInfoArray, "gramInfoUpres", $template, "", "", false, $varPodhArray);
            print_duplicities($reduce, $vyslovnostArray, "vyslovnost", $template, "[", "]");
            print_duplicities($reduce, $puvodArray, "puvod", $template, "&lt;", "&gt;");
            print_duplicities($reduce, $oborArray, "oborUziti", $template);
            //stylisticky kvalifikator vyplneny pouze pro druhou variantu
            /*$stylKval = implode(array_filter($stylKvalArray[1]), ', ');
        if(($pocetVariant == 2) && (empty($stylKval) || is_null($stylKval))){
          $stylKval = implode(array_filter($stylKvalArray[2]), ', ');
          $stylKval = "<span class='stylKval'>$stylKval</span>";
          $template = str_replace("^^stylKval2^^",$stylKval,$template);
        }
        else*/{
                //remove_duplicities($stylKvalArray);
                print_duplicities($reduce, $stylKvalArray, "stylKval", $template);
            }

            print_duplicities($reduce, $vazebnostArray, "vazebnost", $template, "(", ")");
            //print_duplicities($reduce, $tematickeOkruhyArray, "tematickeOkruhy", $template, true);
            print_duplicities($reduce, $prvniRegVyskytArray, "prvniRegVyskyt", $template);
            //$template = trim(preg_replace('/\s*\{[^}]*\}/', '', $template));
            $template = trim(preg_replace('/\s*\^\^[^^]*\^\^/', '', $template));
            $template = fix_typography($template);
            if($reduce){
                $template = druhy_pruchod($variantyArray, $pocetVariant, $template, $web);
            }

            if(!empty($template)){
                $html.="\r\n".$template;
            }
            if($web){
                $html.="\r\n^^MV1-$hid^^";
            }

        }


        if(!empty(strip_tags($konec_zahlavi_cisVyber_str))){
            $html.="\r\n<span class='konec_zahlavi'>$konec_zahlavi_cisVyber_str</span>";
        }
        // Poznamky k heslu - posunuto nad poznamky k vyznamu

        $to_pdf = $pdf_tmp;

        // V Y Z N A M Y //
        $tematickeOkruhyVyzArray = array();
        $tematickeOkruhyPodhArray = array();
        $vyznamy = get('vyznamy_hesla', $hid, array('sortorder'));

        $vyznamy_tmp = vygeneruj_podvyznamy($hid, $vyznamy);

        $nezarazene_vyznamy = '';
        $extra_tab = '';
        if($web && !$master){
            if(!empty($hidRel_id) && is_numeric($hidRel_id)){
                $place = get_db_values_where("hesla_rel_places", "place", "hesla_rel_id", $hidRel_id);
                if($place === "exemplifikace"){
                    $extra_tab = "<span class='pripoj'></span>";
                }
            }
        }
        //if(!empty($vyznamy)){
        if($master && !$vyznamy_novy_radek && !$web && $typHesla_stripped!=$_TYP_HESLA[ODKAZOVE])
        {
            $newline = "<br />";
        }
        else
        {
            $newline = "";
        }
        if($to_pdf)
            $html.="$newline\r\n<!-- VYZNAMY -->";
        else
            $html.="$newline\r\n<!-- VYZNAMY -->\r\n<span class='vyznamy'>";

        $vyz_count=0;
        $vyz_linked = false;
        if(isset($exemplifikace_nez)) unset($exemplifikace_nez);
        $exemplifikace_nez = array();
        $vyznamy_count = count(get_vyznamy_count($hid, $to_pdf));
        $prazdna_exemplifikace = false;
        $prazdny_vyznam = false;
        ///
        /// Cyklus pres vsechny vyznamy
        ///
        foreach($vyznamy_tmp as $vyz_id_info){
            $vyz_id = $vyz_id_info['ID'];
            $Dvyz = get_db_values('vyznamy', array('podhesli', 'komentar', 'vystup',  'zacatek_predvykladu', 'konec_predvykladu', 'vyklad_vyznamu', 'metavyklad2', 'komentar_tvarchar', 'komentar_tvarchar_slovesa','typ_vystupu', 'vyklad_vyznamu_link', 'metavyklad1_link', 'metavyklad2_link', 'predvyklad_link'), $vyz_id);
            $vystup = $Dvyz['typ_vystupu'];
            $vyklad_vyznamu_link = $Dvyz['vyklad_vyznamu_link'];
            unset($Dvyz_linked);
            if(is_numeric($vyklad_vyznamu_link) && ($vyklad_vyznamu_link > 0)){
                //$Dvyz_linked = get_db_values('vyznamy', array('zacatek_predvykladu', 'konec_predvykladu', 'vyklad_vyznamu', 'metavyklad2'), $vyklad_vyznamu_link);
                $Dvyz_linked = get_db_values('vyznamy_master', array('zacatek_predvykladu', 'konec_predvykladu', 'vyklad_vyznamu', 'metavyklad2'), $vyklad_vyznamu_link);

            }
            $vyz_count_cls = 'vyz_count';
            $pad = '';
            if($web && !$master){
                $vyz_count_cls = 'vyz_count vyz_count2';
                $pad = "^^PAD^^";
            }
            if($vyz_id_info['MASTER']==0){
                if(!$to_pdf){
                    if($vystup!=NEZARAZENO)
                        $vyz_count++;
                } else{
                    if($vystup==TISTENY)
                        $vyz_count++;
                }

                $cislo_vyznamu="";
                //if(count($vyznamy) > 1){
                if($vyznamy_count > 1 && $vystup!=NEZARAZENO){
                    $cislo_vyznamu = "\r\n<span $pad class=\"".$vyz_count_cls."\">".$vyz_count.".</span>";
                    /*if($web){
                $cislo_vyznamu.="<span class='tab'></span>";
            }*/
                } else if($vyznamy_count == 1 && $web && $master){
                    $cislo_vyznamu.="\r\n<span $pad class=\"".$vyz_count_cls."\" style=\"visibility:hidden;\">1.</span>"; //<!--<span class='tab'></span>-->";
                }

            } else{
                if($web){
                    if($prazdna_exemplifikace){
                        $cislo_vyznamu = "\r\n&nbsp;<span $pad class=\"".$vyz_count_cls."\">&bull;&nbsp;</span>";
                    } else{
                        $cislo_vyznamu = "<span class='pripoj'>&nbsp;</span><span $pad class=\"".$vyz_count_cls."\">&bull;&nbsp;</span>";
                        if(!$master){
                            $cislo_vyznamu = "<hr class='vskipSmall' />".$cislo_vyznamu;
                        }

                    }

                } else{
                    $cislo_vyznamu = "\r\n<span class=\"".$vyz_count_cls."\">&bull;&nbsp;</span>";

                }
            }

            if($vyz_id_info['MASTER']!=0){
                $vystup = get_db_values('vyznamy', 'typ_vystupu', $vyz_id_info['MASTER']);
            }

            //odstraneni vyznamu, ktere nejsou tistene, z PDF exportu
            if($to_pdf){
                if($vystup!=TISTENY){
                    continue;
                }
            }

            //Nova podoba podhesli
            $podhesli_ids = get_podhesli_vyznamu($vyz_id);

            $podhesli_vyznamu_html = '';
            $podhesli_array = array();
            $cislo_podhesli = 0;
            foreach($podhesli_ids as $podhesli_id){
                $Dpodhesli = get_db_values('podhesli_vyznamu', array('komentar_pred', 'podhesli', 'komentar_za', 'komentar_tvarchar', 'komentar_tvarchar_slovesa'), $podhesli_id);
                $podhesli_array[$cislo_podhesli] = array_map('text_html_preprocess', $Dpodhesli);

                if(!empty($podhesli_array[$cislo_podhesli]['podhesli']) && !$to_pdf){
                    $DOMid = "podhesli-$podhesli_id--tvar_podhesli";
                    handle_correction($hid, $DOMid, 'podhesli-podhesli', $podhesli_id, $podhesli_array[$cislo_podhesli]['podhesli']);
                }

                if(!empty($podhesli_array[$cislo_podhesli]['komentar_pred']) && !$to_pdf){
                    $DOMid = "podhesli-$podhesli_id--komentar_podhesli";
                    handle_correction($hid, $DOMid, 'podhesli-komentar_podhesli', $podhesli_id, $podhesli_array[$cislo_podhesli]['komentar_pred']);
                }

                if(!empty($podhesli_array[$cislo_podhesli]['komentar_za']) && !$to_pdf){
                    $DOMid = "podhesli-$podhesli_id--komentar_podhesli_za";
                    handle_correction($hid, $DOMid, 'podhesli-komentar-za_podhesli', $podhesli_id, $podhesli_array[$cislo_podhesli]['komentar_za']);
                }


                //KOMENTAR TVAROSLOVNE CHARAKTERISTIKY
                if(!empty($podhesli_array[$cislo_podhesli]['komentar_tvarchar']) && !$to_pdf){
                    $DOMid = "podhesli-$podhesli_id--komentar_tvarchar";
                    handle_correction($hid, $DOMid, 'podhesli-komentar_tvarchar', $podhesli_id, $podhesli_array[$cislo_podhesli]['komentar_tvarchar']);
                }

                //KOMENTAR TVAROSLOVNE CHARAKTERISTIKY SLOVESA
                if(!empty($podhesli_array[$cislo_podhesli]['komentar_tvarchar_slovesa']) && !$to_pdf){
                    $DOMid = "podhesli-$podhesli_id--komentar_tvarchar_slovesa";
                    handle_correction($hid, $DOMid, 'podhesli-komentar_tvarchar_slovesa', $podhesli_id, $podhesli_array[$cislo_podhesli]['komentar_tvarchar_slovesa']);
                }

                $podhesli_array[$cislo_podhesli]['vyslovnost'] = vyslovnost_podhesli($hid, $podhesli_id, $to_pdf);
                $podhesli_array[$cislo_podhesli]['gramaticke_info'] = gramaticke_info_podhesli($hid, $podhesli_id, $to_pdf);
                $podhesli_array[$cislo_podhesli]['tvar_char'] = tvar_char_podhesli($hid, $podhesli_id, $to_pdf);
                $podhesli_array[$cislo_podhesli]['tvar_char_sl'] = tvar_char_sl_podhesli($hid, $podhesli_id, $to_pdf);
                $podhesli_array[$cislo_podhesli]['slovni_druhy'] = slovni_druh_podhesli($hid, $podhesli_id, $to_pdf);
                $podhesli_array[$cislo_podhesli]['vazebnosti'] = vazebnost_podhesli($hid, $podhesli_id, $to_pdf);
                $podhesli_array[$cislo_podhesli]['styl_kval'] = stylisticky_kvalifikator($hid, $podhesli_id, $to_pdf, "podh");
                $podhesli_array[$cislo_podhesli]['tematicke_okruhy'] = tematicke_okruhy($hid, $podhesli_id, $to_pdf, "podh");
                $podhesli_array[$cislo_podhesli]['obor_uziti'] = obor_uziti($hid, $podhesli_id, $to_pdf, "podh");
                $cislo_podhesli++;
            }

            //PODHESLI - stara podoba
            //2015-04-22 zakazano
            /*
        $podhesli_vyz = text_html_preprocess(trim($Dvyz['podhesli']));
        $podhesli_vyz_komentar = text_html_preprocess(trim($Dvyz['komentar']));
        if($podhesli_vyz!=""){
         $DOMid = "vyznam-$vyz_id--tvar_podhesli";
         if(!$to_pdf){
           handle_correction($hid, $DOMid, 'vyznam-podhesli', $vyz_id, $podhesli_vyz);
         }
         if($podhesli_vyz_komentar!=""){
           $DOMid = "vyznam-$vyz_id--komentar_podhesli";
           if(!$to_pdf){
            handle_correction($hid, $DOMid, 'vyznam-komentar_podhesli', $vyz_id, $podhesli_vyz_komentar);
           }
         }
        }
        */

            //GRAM INFO
            $gramInfo_cisVyber_str = gramaticke_info_vyznamu($hid, $vyz_id, $to_pdf);

            //OBOR UZITI
            $oborUziti_cisVyber_str = obor_uziti($hid, $vyz_id, $to_pdf, "vyz");

            //STYLISTICKY KVAL.
            $stylKval_cisVyber_str = stylisticky_kvalifikator($hid, $vyz_id, $to_pdf, "vyz");

            //TEMATICKE OKRUHY
            $tematickeOkruhy_cisVyber_str = tematicke_okruhy($hid, $vyz_id, $to_pdf, "vyz");


            //KOMENTAR TVAROSLOVNE CHARAKTERISTIKY
            $komentar_tvarchar_vyz = nl2br(text_html_preprocess(trim($Dvyz['komentar_tvarchar'])));
            if($komentar_tvarchar_vyz!=""){
                $DOMid = "vyznam-$vyz_id--komentar_tvarchar";
                if(!$to_pdf)
                    handle_correction($hid, $DOMid, 'vyznam-komentar_tvarchar', $vyz_id, $komentar_tvarchar_vyz);
            }

            //KOMENTAR TVAROSLOVNE CHARAKTERISTIKY SLOVESA
            $komentar_tvarchar_slovesa_vyz = nl2br(text_html_preprocess(trim($Dvyz['komentar_tvarchar_slovesa'])));
            if($komentar_tvarchar_slovesa_vyz!=""){
                $DOMid = "vyznam-$vyz_id--komentar_tvarchar_slovesa";
                if(!$to_pdf)
                    handle_correction($hid, $DOMid, 'vyznam-komentar_tvarchar_slovesa', $vyz_id, $komentar_tvarchar_slovesa_vyz);
            }

            //METAVYKLAD 1
            $tmp_id = $vyz_id;
            $redakce = true;
            if(isset($Dvyz_linked) && $Dvyz['metavyklad1_link'] == 1){
                $tmp_id = $vyklad_vyznamu_link;
                $redakce = false;
                $metavyklad1_cisVyber = get_vybrane_hodnoty_ciselniku(METAVYKLAD1_M, 'vyz', $tmp_id);
                $metavyklad1_cisVyber_str = text_html_preprocess(implode(", ", $metavyklad1_cisVyber));
                if(!$to_pdf){
                    $DOMid = "vyznam-$tmp_id--metavyklad1_master";
                    handle_correction($hid, $DOMid, "vyznam-metavyklad1_master", $tmp_id, $metavyklad1_cisVyber_str);
                }
            } else{
                $metavyklad1_cisVyber = get_vybrane_hodnoty_ciselniku(METAVYKLAD1, 'vyz', $tmp_id);
                $metavyklad1_cisVyber_str = text_html_preprocess(implode(", ", $metavyklad1_cisVyber));
                if(!$to_pdf && $redakce){
                    $DOMid = "vyznam-$vyz_id--metavyklad1";
                    handle_correction($hid, $DOMid, 'vyznam-metavyklad1', $tmp_id, $metavyklad1_cisVyber_str);
                }
            }

            //PREDVYKLAD - stara podoba
            /* 2015-05-06 zakazano
        $redakce = true;
        $predvyklad_vyz = "";

        if(isset($Dvyz_linked) && $Dvyz['predvyklad_link'] == 1){
          $predvyklad_vyz = nl2br(text_html_preprocess(trim($Dvyz_linked['predvyklad'])));
          $redakce = false;
          if(!$to_pdf && !empty($predvyklad_vyz)){
            $DOMid = "vyznam-$vyklad_vyznamu_link--predvyklad_master";
            handle_correction($hid, $DOMid, 'vyznam-predvyklad_master', $vyklad_vyznamu_link, $predvyklad_vyz);
          }
        } else{
          if(trim($Dvyz['predvyklad'])!=""){
            $predvyklad_vyz = nl2br(text_html_preprocess(trim($Dvyz['predvyklad'])));
            if(!$to_pdf && $redakce)
              $DOMid = "vyznam-$vyz_id--predvyklad";
              handle_correction($hid, $DOMid, 'vyznam-predvyklad', $vyz_id, $predvyklad_vyz);
          }
        } */

            //PREDVYKLAD - nova podoba
            //inicializace
            $zacatek_predvykladu = "";
            $predvyklad_vyrazy = "";
            $konec_predvykladu = "";

            $redakce = true;
            if(isset($Dvyz_linked) && $Dvyz['predvyklad_link'] == 1){
                $zacatek_predvykladu = nl2br(text_html_preprocess(trim($Dvyz_linked['zacatek_predvykladu'])));
                if(!$to_pdf && !empty($zacatek_predvykladu)){
                    $DOMid = "vyznam-$vyklad_vyznamu_link--zacatek_predvykladu_master";
                    handle_correction($hid, $DOMid, 'vyznam-zacatek_predvykladu_master', $vyklad_vyznamu_link, $zacatek_predvykladu);
                }
                $redakce = false;
            } else{
                $zacatek_predvykladu = nl2br(text_html_preprocess(trim($Dvyz['zacatek_predvykladu'])));
            }

            if($zacatek_predvykladu!="" && !$to_pdf && $redakce){
                $DOMid = "vyznam-$vyz_id--zacatek_predvykladu";
                handle_correction($hid, $DOMid, 'vyznam-zacatek_predvykladu', $vyz_id, $zacatek_predvykladu);
            }

            $vyrazy_ids = null;
            if(is_numeric($vyklad_vyznamu_link) && $vyklad_vyznamu_link > 0 && $Dvyz['predvyklad_link'] == 1){
                $vyrazy_ids = get('vyrazy_predvykladu_m', $vyklad_vyznamu_link, array('sortorder'));
            } else{
                $vyrazy_ids = get('vyrazy_predvykladu', $vyz_id, array('sortorder'));
            }
            foreach($vyrazy_ids as $vyraz_id){
                if(is_numeric($vyklad_vyznamu_link) && $vyklad_vyznamu_link > 0 && $Dvyz['predvyklad_link'] == 1){
                    $predvyklad_vyrazy_array = get_db_values('vyrazy_predvykladu_m', array('id', 'vyraz', 'komentar'), $vyraz_id);
                } else{
                    $predvyklad_vyrazy_array = get_db_values('vyrazy_predvykladu', array('id', 'vyraz', 'komentar'), $vyraz_id);
                }

                $predvyklad_vyraz = $predvyklad_komentar = "";
                $predvyklad_vyraz = nl2br(text_html_preprocess(trim($predvyklad_vyrazy_array['vyraz'])));
                $predvyklad_komentar = nl2br(text_html_preprocess(trim($predvyklad_vyrazy_array['komentar'])));
                if(!empty($predvyklad_vyraz)){
                    if(!$to_pdf){
                        if($redakce){
                            $DOMid = "vyznam-$vyz_id--vyraz_predvykladu-$predvyklad_vyrazy_array[id]";
                            handle_correction($hid, $DOMid, 'vyznam-vyraz_predvykladu', $predvyklad_vyrazy_array['id'], $predvyklad_vyraz);
                        } else{
                            $DOMid = "vyznam-$vyklad_vyznamu_link--vyraz_predvykladu_master-$predvyklad_vyrazy_array[id]";
                            handle_correction($hid, $DOMid, 'vyznam-vyraz_predvykladu_master', $predvyklad_vyrazy_array['id'], $predvyklad_vyraz);
                        }
                    }
                    $predvyklad_vyraz = "<span class='predvyklad_vyraz'>$predvyklad_vyraz</span>";
                }
                if(!empty($predvyklad_komentar)){
                    if(!$to_pdf){
                        if($redakce){
                            $DOMid = "vyznam-$vyz_id--komentar_predvykladu-$predvyklad_vyrazy_array[id]";
                            handle_correction($hid, $DOMid, 'vyznam-komentar_predvykladu', $predvyklad_vyrazy_array[id], $predvyklad_komentar);
                        } else{
                            $DOMid = "vyznam-$vyklad_vyznamu_link--komentar_predvykladu_master-$predvyklad_vyrazy_array[id]";
                            handle_correction($hid, $DOMid, 'vyznam-komentar_predvykladu_master', $predvyklad_vyrazy_array[id], $predvyklad_komentar);
                        }

                    }
                    $predvyklad_komentar = "<span class='predvyklad_komentar'>$predvyklad_komentar</span>";
                }
                if(!empty($predvyklad_vyrazy))
                    $predvyklad_vyrazy.="<span class='normalni'>,</span>\r\n";
                if(!empty($predvyklad_komentar)){
                    $predvyklad_vyrazy.="$predvyklad_vyraz\r\n$predvyklad_komentar";
                } else{
                    $predvyklad_vyrazy.=$predvyklad_vyraz;
                }
            }

            if(isset($Dvyz_linked) && $Dvyz['predvyklad_link'] == 1){
                $konec_predvykladu = nl2br(text_html_preprocess(trim($Dvyz_linked['konec_predvykladu'])));
                if(!$to_pdf && !empty($konec_predvykladu)){
                    $DOMid = "vyznam-$vyklad_vyznamu_link--konec_predvykladu_master";
                    handle_correction($hid, $DOMid, 'vyznam-konec_predvykladu_master', $vyklad_vyznamu_link, $konec_predvykladu);
                }
            }
            else{
                $konec_predvykladu = nl2br(text_html_preprocess(trim($Dvyz['konec_predvykladu'])));
            }
            if($konec_predvykladu!="" && !$to_pdf && $redakce){
                $DOMid = "vyznam-$vyz_id--konec_predvykladu";
                handle_correction($hid, $DOMid, 'vyznam-konec_predvykladu', $vyz_id, $konec_predvykladu);
            }
            $predvyklad_cls = "petit";
            if(!empty($predvyklad_vyrazy)){
                $predvyklad_cls = "normalni";
            }


            //VYKLAD VYZNAMU
            $redakce = true;
            if(is_numeric($vyklad_vyznamu_link) && $vyklad_vyznamu_link > 0){
                $vyklad_vyznamu = fix_typography($Dvyz_linked['vyklad_vyznamu']);
                /*$redakce = false;
          if(!$to_pdf){
              $DOMid = "vyznam_master-$vyklad_vyznamu_link--vyklad_vyznamu";
              handle_correction($hid, $DOMid, "vyznam-vyklad_vyznamu_master", $vyklad_vyznamu_link, $vyklad_vyznamu);
          } */
            } else{
                $vyklad_vyznamu = fix_typography($Dvyz['vyklad_vyznamu']);
            }
            if($vyklad_vyznamu!=""){
                $DOMid = "vyznam-$vyz_id--vyklad_vyznamu";
                $links = array();
                $DOMid = "";
                $group = false;
                $val_id = $vyz_id;
                if(is_numeric($vyklad_vyznamu_link) && $vyklad_vyznamu_link > 0){
                    $links = get_links($vyklad_vyznamu_link, true);
                    $DOMid = "vyznam_master-$vyklad_vyznamu_link--vyklad_vyznamu";
                    $val_id = $vyklad_vyznamu_link;
                    $group = true;
                } else {
                    $links = get_links($vyz_id);
                    $DOMid = "vyznam-$vyz_id--vyklad_vyznamu";
                }
                if(!$to_pdf && $redakce){
                    $vyklad_vyznamu = handle_correction_vyznamu($vyklad_vyznamu, $hid, $links, $group, $val_id, $DOMid);

                    /*if(!empty($links) && !Redakce::field_has_opened_correction($DOMid)){
                  $blokRedakciVyznamu = false;
                  foreach($links as $link){
                    $stringArr = split_vyznam($vyklad_vyznamu, $link);
                    if(Redakce::field_has_opened_correction("vyznam-link-$link")){
                        $blokRedakciVyznamu = true;
                    }
                    handle_correction($hid, "vyznam-link-$link", 'vyznam-link', $link, $stringArr[1]);
                    $vyklad_vyznamu = implode("", $stringArr);
                  }
                  if(!$blokRedakciVyznamu){
                    $vyklad_cpy = "";
                    $prefix = '';
                    $sufix = $vyklad_vyznamu;
                    for($i = 1; $i <= count($links); $i++){
                        $start = strpos($sufix, "<span id=");
                        $end = strpos($sufix, "</span>", $start);
                        $prefix = substr($sufix, 0, $start);
                        $link_txt = substr($sufix, $start, $end - $start + 7);
                        $sufix = substr($sufix, $end + 7);
                        handle_correction($hid, $DOMid, 'vyznam-vyklad_vyznamu', $vyz_id, $prefix);
                        $vyklad_cpy.=$prefix.$link_txt;
                    }
                    handle_correction($hid, $DOMid, 'vyznam-vyklad_vyznamu', $vyz_id, $sufix);
                    $vyklad_vyznamu = $vyklad_cpy.$sufix;
                  }


              } else{
                handle_correction($hid, $DOMid, 'vyznam-vyklad_vyznamu', $vyz_id, $vyklad_vyznamu);
              } */
                }
                if($web){
                    $vyklad_vyznamu = handle_wysiwyg($vyklad_vyznamu, false);
                    if(!empty($links)){
                        foreach($links as $link){
                            $stringArr = split_vyznam($vyklad_vyznamu, $link);
                            $vyz_to = get_db_values("propojeni_vyznamu", "vyz_to", $link);
                            if(!empty($vyz_to)){
                                $hid_to = get_db_values("vyznamy", "hid", $vyz_to);
                                if(!empty($hid_to)){
                                    if(check_link($hid_to)){
                                        $varianty = get('varianty_hesla', $hid_to, array('sortorder'));
                                        $hl_var_data = get_db_values('varianty', array('varianta', 'homonymie'), $varianty[0]);

                                        $stringArr[1] = '<a id="hid-'.$hid_to.'" class="clickable" href="heslo/'.$hl_var_data['varianta'].'--'.$hl_var_data['homonymie'].'/'.$hid_to.'">'.$stringArr[1].'</a>';
                                    }
                                }
                            }
                            $vyklad_vyznamu = implode("", $stringArr);
                        }
                    }

                } else{
                    $vyklad_vyznamu = handle_wysiwyg($vyklad_vyznamu, ($to_pdf && !$preview));
                }
                if($to_pdf){
                    $vyklad_vyznamu = fix_mpdf($vyklad_vyznamu);
                }
            }

            //METAVYKLAD 2
            $redakce = true;
            if(isset($Dvyz_linked) && $Dvyz['metavyklad2_link'] == 1){
                $metavyklad2 = nl2br(text_html_preprocess(trim($Dvyz_linked['metavyklad2'])));
                $redakce = false;
                if(!$to_pdf && !empty($metavyklad2)){
                    $DOMid = "vyznam-$vyklad_vyznamu_link--metavyklad2_master";
                    handle_correction($hid, $DOMid, 'vyznam-metavyklad2_master', $vyklad_vyznamu_link, $metavyklad2);
                }
            } else{
                $metavyklad2 = nl2br(text_html_preprocess(trim($Dvyz['metavyklad2'])));
                if($metavyklad2!=""){
                    if(!$to_pdf && $redakce){
                        $DOMid = "vyznam-$vyz_id--metavyklad2";
                        handle_correction($hid, $DOMid, 'vyznam-metavyklad2', $vyz_id, $metavyklad2);
                    }
                }
            }

            //VAZEBNOST
            $vazebnosti_vyz_ids = get('vazebnosti_vyznamu', $vyz_id);
            $vazebnosti_vyz_arr = array();
            foreach($vazebnosti_vyz_ids as $vaz_id){
                $vaz = text_html_preprocess(get_db_values('vazebnost_vyz', 'vazebnost', $vaz_id));
                $vaz = strip_tags($vaz);
                $vaz_kom = text_html_preprocess(get_db_values('vazebnost_vyz', 'komentar', $vaz_id));
                if(trim($vaz)!=""){
                    $DOMid = "vyznam-$vyz_id--vazebnost-$vaz_id--tvar";
                    $vaz = text_html_preprocess($vaz);
                    if(!$to_pdf)
                        handle_correction($hid, $DOMid, 'vyznam-vazebnost-tvar', $vaz_id, $vaz);
                    if(!empty($vaz_kom)){
                        $DOMid = "vyznam-$vyz_id--vazebnost-$vaz_id--komentar";
                        if(!$to_pdf)
                            handle_correction($hid, $DOMid, 'vyznam-vazebnost-komentar', $vaz_id, $vaz_kom);
                    }
                    $vazebnosti_vyz_arr[] = ((!empty($vaz_kom))?"<span class='komentar'>$vaz_kom</span>\r\n":"").$vaz;
                }
            }

            //SLOV_DRUHY
            $sl_Druhy = get('slovneDruhy_vyznamu', $vyz_id);
            $sl_druhy_str = $sl_Druhy_vyber = array();
            foreach($sl_Druhy as $slDruh_id){
                $DOMid = "vyznam-$vyz_id--slovnyDruh-$slDruh_id";
                $sl_druhy_raw = get_vybrane_hodnoty_ciselniku(SLOV_DRUHY, 'vyz', $slDruh_id);
                $sl_druhy = text_html_preprocess(implode(", ", $sl_druhy_raw));
                if(!$to_pdf)
                    handle_correction($hid, $DOMid, 'vyznam-slovnyDruh', $slDruh_id, $sl_druhy);
                $sl_druhy_kom = get_db_values('vyz_slov_druhy_vyber_rel', 'komentar', $slDruh_id);
                if(!empty($sl_druhy_raw)){
                    if(!empty($sl_druhy_kom)){
                        $DOMid = "vyznam-$vyz_id--slovnyDruh-$slDruh_id--komentar";
                        if(!$to_pdf)
                            handle_correction($hid, $DOMid, 'vyznam-slovnyDruh-komentar', $slDruh_id, $sl_druhy_kom);
                    }
                    $sl_druhy_str[] = ((!empty($sl_druhy_kom))?"<span class='komentar'>$sl_druhy_kom</span>\r\n":"").$sl_druhy;
                }
            }

            //TVAROSLOVNE UDAJE VYZNAMU
            $tvCh_vyznamu = "";
            $ok2open = false;
			$opened = false;
			$first = true;
            $tvCh_str = "";
            //$tvCh_arr = array();
            $tvChs = get('tvarChary_vyznamu', $vyz_id, 'sortorder');
            foreach($tvChs as $tvCh_id){
                $ok2open = true;
                $tvChs_vyber = get_vybrane_hodnoty_ciselniku(TVAR_CHAR, 'vyz', $tvCh_id);
                if(!empty($tvChs_vyber)){
                    $DOMid = "vyznam-$vyz_id--tvarChar-$tvCh_id";
                    $tvCh_str = implode(", ", $tvChs_vyber);
                    if(!$to_pdf){
                        handle_correction($hid, $DOMid, 'vyznam-tvarChar', $tvCh_id, $tvCh_str);
                    }
                  	if($to_pdf && !$opened && ($tvCh_str != "2. j." && $tvCh_str!="2. mn." && $tvCh_str!="neskl.")){
						$opened = true;
						$first = true;
						if(empty($tvCh_vyznamu)){
							$tvCh_vyznamu = "<span class='normal_size'>(</span>";
						} else{
							$tvCh_vyznamu .= " <span class='normal_size'>(</span>";
						}
					}
					if($to_pdf && ($tvCh_str == "2. j." || $tvCh_str == "2. mn.")){
						$tvCh_str = ""; //2. j. 2. mn se netiskne v PDF
					} else{
		            	$tvCh_str = "<span class='tvCh-typ'>$tvCh_str</span>";
					}
		        }

                $koncofky_ids = get('koncovky_tvarChar_vyz', $tvCh_id, 'sortorder');
                $koncofky = array();
                foreach($koncofky_ids as $konc_id){
                    $konc = get_db_values('koncovky_tvar_char_vyz', 'koncovka', $konc_id);
                    $konc_kom = get_db_values('koncovky_tvar_char_vyz', 'komentar', $konc_id);
                    if(trim($konc)!=""){
                        $DOMid = "vyznam-$vyz_id--tvarChar-$tvCh_id--koncovka-$konc_id--tvar";
                        $konc = text_html_preprocess($konc);
                        if(!$to_pdf){
                            handle_correction($hid, $DOMid, 'vyznam-tvarChar-koncovka-tvar', $konc_id, $konc);
                        }
                    }

                    if(!empty($konc_kom)){
                        $konc_kom = text_html_preprocess($konc_kom);
                        $DOMid = "vyznam-$vyz_id--tvarChar-$tvCh_id--koncovka-$konc_id--komentar";
                        if(!$to_pdf){
                            handle_correction($hid, $DOMid, 'vyznam-tvarChar-koncovka-komentar', $konc_id, $konc_kom);
                        }
                    }

                    //if(!empty($konc)) $konc = " ".$konc;
                    $koncofky[] = ((!empty($konc_kom))?"<span class='varianta-tvarChar-koncovka-komentar'>$konc_kom</span>\r\n":"").$konc;
                }
                if(!empty($koncofky) && !empty($tvCh_str)) $tvCh_str.="&nbsp;";
                $tvCh_str.= implode(",&nbsp;", $koncofky);
                if(trim($tvCh_str)!=""){
                    //$tvCh_arr[] = $tvCh_str;
                    if(!$first){
						$tvCh_vyznamu .= ", ".$tvCh_str;
					} else{
						$tvCh_vyznamu .= $tvCh_str;
					}
					$first = false;
				}
            }

			if($opened){
		 		$tvCh_vyznamu.="<span class='normal_size'>)</span>";
			}
			if(!$to_pdf && !empty($tvCh_vyznamu)){
				$tvCh_vyznamu = "<span class='normal_size'>(</span>$tvCh_vyznamu<span class='normal_size'>)</span>";
			}
            //TVAROSLOVNE UDAJE SLOVESA VYZNAMU
            $tvChSl_arr = array();
            $tvChSl_str = "";
            $tvChSls = get('tvarCharySl_vyznamu', $vyz_id, 'sortorder');
            foreach($tvChSls as $tvChSl_id){
                $tvChSls_vyber = get_vybrane_hodnoty_ciselniku(TVAR_CHAR_SL, 'vyz', $tvChSl_id);
                if(!empty($tvChSls_vyber)){
                    $DOMid = "vyznam-$vyz_id--tvarCharSl-$tvChSl_id";
                    $tvChSl_str = text_html_preprocess(implode(", ", $tvChSls_vyber));
                    if(!$to_pdf){
                        handle_correction($hid, $DOMid, 'vyznam-tvarCharSl', $tvChSl_id, $tvChSl_str);
                    }
                    $tvChSl_str = "<span class='tvCh-typ'>$tvChSl_str</span>";
                }
                $koncofky_ids = get('koncovky_tvarCharSl_vyz', $tvChSl_id, 'sortorder');
                $koncofky = array();
                foreach($koncofky_ids as $konc_id){
                    $konc = get_db_values('koncovky_tvar_char_sl_vyz', 'koncovka', $konc_id);
                    $konc_kom = get_db_values('koncovky_tvar_char_sl_vyz', 'komentar', $konc_id);
                    if(trim($konc)!=""){
                        $DOMid = "vyznam-$vyz_id--tvarCharSl-$tvChSl_id--koncovka-$konc_id--tvar";
                        $konc = text_html_preprocess($konc);
                        if(!$to_pdf){
                            handle_correction($hid, $DOMid, 'vyznam-tvarCharSl-koncovka-tvar', $konc_id, $konc);
                        }
                        if(!empty($konc_kom)){
                            $konc_kom = text_html_preprocess($konc_kom);
                            $DOMid = "vyznam-$vyz_id--tvarCharSl-$tvChSl_id--koncovka-$konc_id--komentar";
                            if(!$to_pdf){
                                handle_correction($hid, $DOMid, 'vyznam-tvarCharSl-koncovka-komentar', $konc_id, $konc_kom);
                            }
                        }
                        $koncofky[] = ((!empty($konc_kom))?"<span class='komentar'>$konc_kom</span>\r\n":"").$konc;
                    }
                }
                if(!empty($koncofky) && !empty($tvChSl_str)) $tvChSl_str.="&nbsp;";
                $tvChSl_str.= implode(",&nbsp;", $koncofky);
                if(trim($tvChSl_str)!=""){
                    $tvChSl_arr[] = $tvChSl_str;
                }
            }

            $syn_odkazy = vytvor_odkazy_k_ant_syn($hid, $vyz_id, 'synonymum', $to_pdf, $web);

            $ant_odkazy = vytvor_odkazy_k_ant_syn($hid, $vyz_id, 'antonymum', $to_pdf, $web);

            //EXEMPLIFIKACE
            $exempl_ids = get('exempl_vyznamu', $vyz_id, array('sortorder'));
            $exempl_elektro_vys = array();
            $exempl_tiskovy_vys = array();
            $exeplifikace = "";
            $exeplifikace_pripoj = "";

            if($vyz_id_info['MASTER']==0){
                $exemplifikace_nez[$vyz_id] = "";
            }
            foreach($exempl_ids as $exempl_id){
                $exempl_nezarazeno = "";
                $Dexempl = get_db_values('exemplifikace', array('exemplifikace', 'vystup'), $exempl_id);

                $exempl = $Dexempl['exemplifikace'];
                $exepl = " \r\n".fix_typography($exempl); //odstraneni prebytecnych mezer
                if($exempl!=""){
                    $DOMid = "vyznam-$vyz_id--exemplifikacia-$exempl_id";
                    if(!$to_pdf){
                        $tag='span';
                        if($Dexempl['vystup']==NEZARAZENO && $vystup!=NEZARAZENO){
                            $tag='div';
                        }
                        handle_correction($hid, $DOMid, 'vyznam-exemplifikacia-text', $exempl_id, $exempl, $tag);
                    }
                }


                if($to_pdf){
                    if($Dexempl['vystup']==TISTENY){
                        $exempl_tiskovy_vys[] = $exempl;
                    }
                }else{
                    if(($Dexempl['vystup']==ELEKTRONICKY) || ($Dexempl['vystup']==TISTENY) || $vystup==NEZARAZENO){
                        $exempl_elektro_vys[] = $exempl;
                    }
                    else if($Dexempl['vystup']==NEZARAZENO){
                        $exempl_nezarazeno = $exempl;
                    }
                }

                if($to_pdf){
                    if(!empty($exempl_tiskovy_vys)){
                        $exeplifikace .= " \r\n".implode("<p>&nbsp;</p>", $exempl_tiskovy_vys);
                        $exempl_tiskovy_vys = array();
                    }
                }else{
                    if(!empty($exempl_elektro_vys)){
                        $exeplifikace .= " \r\n".implode("<p>&nbsp;</p>", $exempl_elektro_vys);
                        $exempl_elektro_vys = array();
                    }
                    if(!empty($exempl_nezarazeno)){
                        $exemplifikace_nez[$vyz_id] .= "$exempl_nezarazeno";
                    }
                }

                $num = get_db_values("exemplifikace", "sortorder", $exempl_id);
                if($web){
                    $exeplifikace = handle_wysiwyg($exeplifikace, false);
                } else{
                    $exeplifikace = handle_wysiwyg($exeplifikace, ($to_pdf && !$preview));
                }

                if($to_pdf){
                    $exeplifikace = fix_mpdf($exeplifikace);
                }

                if($master){
                    $processed_rel_ids = array();
                }

                if($master){
                    $bilaZona = "";
                }
                $tmp = vytvor_pripojene("exemplifikace", $exempl_id, $num, $to_pdf, $bilaZona, $hid, $master, $master, $web);

                if(!empty($tmp)){
                    if($Dexempl['vystup']==NEZARAZENO){
                        if($vystup!=NEZARAZENO){
                            $exemplifikace_nez[$vyz_id] .= $tmp;
                        }
                    } else{
                        if(!($to_pdf && ($Dexempl['vystup']==ELEKTRONICKY))){
                            $exeplifikace_pripoj .= $tmp;
                        }
                    }
                    if($bilaZona)
                        $bileZony .= $bilaZona;
                }
            }


            //POZNAMKY
            $ext_pozn_vyz_ids = get('pozn_vyznamu', $vyz_id);
            $pozn_typy = get_hodnoty_ciselniku(TYP_EXT_POZN);

            if(!isset($ext_pozn_vyz_arr))
                $ext_pozn_vyz_arr = array();
            foreach($ext_pozn_vyz_ids as $pozn_id){
                $pozn = get_db_values('ext_poznamky_vyz', 'poznamka', $pozn_id);
                $typ = get_db_values('ext_poznamky_vyz', 'cis_id', $pozn_id);

                $t = utf8_trim($pozn);
                if($t!="" && $pozn!="&nbsp;"){
                    $DOMid = "vyznam-$vyz_id--extPozn-$pozn_id--text";
                    if(!$to_pdf){
                        handle_correction($hid, $DOMid, 'vyznam-extPozn-text', $pozn_id, $pozn, "span");
                    }
                    $ext_pozn_vyz_arr[$vyz_id]['text'] = $pozn;
                    $ext_pozn_vyz_arr[$vyz_id]['typ'][] = $pozn_typy[$typ];
                }
            }



            $html.="\r\n<!-- vyznam $vyz_count -->";

            //$html.=$newline;
            $vyznam_str = "";
            if($web){
                $break = true;
                $pad = '';
                if(!$master){
                    $rel_type = get_db_values("hesla_rel", "rel_type", $hidRel_id);
                    if($rel_type != HREL_TYPE_prihnizdovani)
                        $break = false;

                    //$vyznamy_count == pocet vyznamu
                    //$vyz_count == cislo vyznamu
                    $master_place = get_db_values_where("hesla_rel_places", "place", "hesla_rel_id", $hidRel_id);
                    if($vyznamy_count > 1 && $master_place == 'heslo'){
                        $pad = " style='padding:0;' ";
                        if($vyz_count == 1){
                            $break = true;
                        }
                    }
                    $hlVarianta = get_hlavni_varianta_hesla($hid);
                    $typHesla_cisVyber = get_vybrane_hodnoty_ciselniku(TYP_HESLA, 'var', $hlVarianta);

                    if((key($typHesla_cisVyber) === SOUSLOVI) || (key($typHesla_cisVyber) === FRAZEM)){
                        if($vyz_count > 1){
                            $break = true;
                        }
                    }


                    if($master_place=='exemplifikace'){
                        if($vyznamy_count == 1){
                            $break = false;
                            $extra_tab="";
                        } else{
                            $break = true;
                            $extra_tab="<span class='pripoj'></span>";

                        }
                    }

                }
                if($break || (!$master && !empty($extra_tab))){
                    $cls = "";
                    if(trim(strip_tags($cislo_vyznamu)) == '1.' || empty($vyklad_vyznamu) || !$master){
                        if($master){
                            $cls = "vskipSmall";
                        }
                        else {
                            $typ = get_db_values("hesla_rel", "rel_type", $hidRel_id);
                            if($typ == HREL_TYPE_prihnizdovani){
                                $cls = "vskipSmall";
                            } else{
                                $cls = "vskipExtraSmall";
                            }
                        }
                    }
                    else{
                        if(is_subvyznam($vyz_id)){
                            $cls = "vskipSmall";
                        } else{
                            $cls = "vskipMedium";
                        }
                    }
                    if(!$prazdna_exemplifikace || ($prazdna_exemplifikace && !is_subvyznam($vyz_id)))
                        if(!$prazdny_vyznam){
                            $vyznam_str .= "<hr class='$cls' />";
                        }
                }
            }

            if(($web && $master) || ($web && !$master && $pocet_vyznamu > 1)){
                $vyznam_str.="<span class='vyznam_wrapper'>";
            }

            $vyznam_str.=$extra_tab.$cislo_vyznamu;    //$cislo_vyznamu uz je naformatovane
            $vyznam_str = str_replace("^^PAD^^", $pad, $vyznam_str);


            if(($to_pdf || $web) && !$vicevyznamove && $reduce){
                if(!empty($vazebnosti_var_arr)){ //label: vazebnost
                    $vyznam_str.="\r\n<span class='vazebnost'>(".implode(", ",      $vazebnosti_var_arr).")</span>";
                }
            }

            $nove_podhesli = '';
            $gramInfoUsed = false;
            foreach($podhesli_array as $podhesli_info){
                if(!empty($nove_podhesli)){
                    $nove_podhesli .= ", ";
                }

                if(!empty($podhesli_info['gramaticke_info'])){ //label: upřesňující gram. info
                    $nove_podhesli.="\r\n<span class='gramInfo'>".$podhesli_info['gramaticke_info']."</span>";
                }
					 $t = strip_tags($gramInfo_cisVyber_str);
					 if(($t == "pomn." || $t == "mn." || $t == "zprav. mn.") && isset($podhesli_info['podhesli']) && !empty($podhesli_info['podhesli'])) {
					 	$gramInfoUsed = true;
					 	if(!empty($gramInfo_cisVyber_str)){ //label: upřesňující gram. info
                		$nove_podhesli.="\r\n<span class='gramInfo'>".$gramInfo_cisVyber_str."</span>";
            		}
					 }

                if(isset($podhesli_info['komentar_pred']) && !empty($podhesli_info['komentar_pred'])){
                    $nove_podhesli.="\r\n<span class='podhesli_komentar'>$podhesli_info[komentar_pred]</span>";
                }
                if(isset($podhesli_info['podhesli']) && !empty($podhesli_info['podhesli'])){
                    $nove_podhesli.="\r\n<span class='$podhesli_vyznamu_cls'>$podhesli_info[podhesli]</span>";
                }

                if(isset($podhesli_info['komentar_za']) && !empty($podhesli_info['komentar_za'])){
                    $nove_podhesli.="\r\n<span class='podhesli_komentar'>$podhesli_info[komentar_za]</span>";
                }

                if(!empty($podhesli_info['vyslovnost'])){ //label výslovnost
                    $nove_podhesli.="\r\n<span class='vyslovnost'>[".implode(", ", $podhesli_info['vyslovnost'])."]</span>";
                }


                if(isset($podhesli_info['komentar_tvarchar']) && !empty($podhesli_info['komentar_tvarchar'])){ //label: komentář tvaroslovné charakteristiky
                    $nove_podhesli.="\r\n<span class='komentar_tvarchar'>$podhesli_info[komentar_tvarchar]</span>";
                }

                if(!empty($podhesli_info['tvar_char'])){ //label: tvaroslovná charakteristika
                    $nove_podhesli.="\r\n<span class='tvCh'>".$podhesli_info[tvar_char]."</span>";
                }

                if(isset($podhesli_info['komentar_tvarchar_slovesa']) && !empty($podhesli_info['komentar_tvarchar_slovesa'])){ //label: komentář tvaroslovné charakteristiky
                    $nove_podhesli.="\r\n<span class='komentar_tvarchar_slovesa'>$podhesli_info[komentar_tvarchar_slovesa]</span>";
                }

                if(!empty($podhesli_info['tvar_char_sl'])){ //label: tvaroslovná charakteristika
                    $nove_podhesli.="\r\n<span class='normal_size'>(</span><span class='tvCh'>".implode(", ", (array)$podhesli_info[tvar_char_sl])."</span><span class='normal_size'>)</span>";
                }

                if(!empty($podhesli_info['slovni_druhy'])){ //label: slovní druh
                    $nove_podhesli.="\r\n<span class='sl_druh'>".implode(", ", $podhesli_info['slovni_druhy'])."</span>";
                }

                if(!empty($podhesli_info['obor_uziti'])){ //label: obor/oblast užití
                    $nove_podhesli.="\r\n<span class='oborUziti'>".$podhesli_info['obor_uziti']."</span>";
                }

                if(!empty($podhesli_info['tematicke_okruhy'])){ //label: tematické okruhy
                    $num = $vyz_count;
                    if(strpos($cislo_vyznamu, "&bull;")){
                        $num = $vyz_count."S";
                    }
                    if($vystup!=NEZARAZENO){
                        $tematickeOkruhyPodhArray[$num] .= $podhesli_info['tematicke_okruhy'];
                    }
                }

                if(!empty($podhesli_info['styl_kval'])){ //label: stylistický kvalifikátor
                    $nove_podhesli.="\r\n<span class='stylKval'>".$podhesli_info['styl_kval']."</span>";
                }

				if(!empty($podhesli_info['vazebnosti'])){ //label: vazebnost
                    $nove_podhesli.="\r\n<span class='vazebnost'>(".implode(", ", $podhesli_info['vazebnosti']).")</span>";
                }


            } //konec tisku podhesli vyznamu
            $vyznam_str.=$nove_podhesli;

            $test = trim(strip_tags($nove_podhesli));

            //stare podhesli zobraz, pouze pokud neni vyplneno nove
            //2015-04-22 zakazano
            /*if($podhesli_vyz!="" && empty($test)){ //label: podheslí
              $vyznam_str.=(($podhesli_vyz_komentar!="")?"\r\n<span class='podhesli_komentar'>".$podhesli_vyz_komentar."</span>" : "")."\r\n<span class='podhesli'>".$podhesli_vyz."</span>";
           } */

            if(!empty($gramInfo_cisVyber_str) && !$gramInfoUsed){ //label: upřesňující gram. info
                $vyznam_str.="\r\n<span class='gramInfo'>".$gramInfo_cisVyber_str."</span>";
            }//.": ".$Dvyz['koncovka_gram_info']."</p>";
            if(!empty($komentar_tvarchar_vyz)){ //label: komentář tvaroslovné charakteristiky
                $vyznam_str.="\r\n<span class='komentar_tvarchar'>$komentar_tvarchar_vyz</span>";
            }
            if(!empty($tvCh_vyznamu)){ //label: tvaroslovná charakteristika
         //       $vyznam_str.="\r\n<span class='normal_size'>(</span><span class='tvCh'>".implode(", ", (array)$tvCh_arr)."</span><span class='normal_size'>)</span>";
           		  $vyznam_str.="\r\n<span class='tvCh'>".$tvCh_vyznamu."</span>";

            }
            if(!empty($komentar_tvarchar_slovesa_vyz)){ //label: komentář tvaroslovné charakteristiky slovesa
                $vyznam_str.="\r\n<span class='komentar_tvarchar_slovesa'>$komentar_tvarchar_slovesa_vyz</span>";
            }
            if(!empty($tvChSl_arr)){ //label: tvaroslovná charakteristika slovesa
                $vyznam_str.="\r\n<span class='normal_size'>(</span><span class='tvChSl'>".implode(", ", (array)$tvChSl_arr)."</span><span class='normal_size'>)</span>";
            }
            if(!empty($sl_druhy_str)){ //label: slovní druh
                $vyznam_str.="\r\n<span class='sl_druh'>".implode(", ", $sl_druhy_str)."</span>";
            }
            if(!empty($oborUziti_cisVyber_str)){ //label: obor/oblast užití
                $vyznam_str.="\r\n<span class='oborUziti'>".$oborUziti_cisVyber_str."</span>";
            }
            if(!empty($tematickeOkruhy_cisVyber_str)){ //label: tematické okruhy
                //$html.="\r\n<span class='tematickeOkruhy'>".$tematickeOkruhy_cisVyber_str."</span>";

                $num = $vyz_count;
                if(strpos($cislo_vyznamu, "&bull;")){
                    $num = $vyz_count."S";
                }
                if($vystup!=NEZARAZENO){
                    $tematickeOkruhyVyzArray[$num] .= $tematickeOkruhy_cisVyber_str;
                }
            }
            if(!empty($stylKval_cisVyber_str)){ //label: stylistický kvalifikátor
                $vyznam_str.="\r\n<span class='stylKval'>".$stylKval_cisVyber_str."</span>";
            }
            if(!empty($vazebnosti_vyz_arr)){ //label: vazebnost
                $vyznam_str.="\r\n<span class='vazebnost'>(".implode(", ", $vazebnosti_vyz_arr).")</span>";
            }
            /*  2015-05-06 stara podoba predvykladu zakazana
           if($predvyklad_vyz!=""){ //label: předvýklad
              $vyznam_str.="\r\n<span class='predvyklad'>(".$predvyklad_vyz.")</span>";
           } */
            //novy predvyklad
            $novy_predvyklad = "";
            if($zacatek_predvykladu!=""){
                $novy_predvyklad.="<span class='predvyklad_zacatek'>".$zacatek_predvykladu."</span>";
            }
            if($predvyklad_vyrazy!=""){
                if(!empty($novy_predvyklad))
                    $novy_predvyklad.="\r\n";
                $novy_predvyklad.=$predvyklad_vyrazy;
            }
            if($konec_predvykladu!=""){
                if(!empty($novy_predvyklad))
                    $novy_predvyklad.="\r\n";
                $novy_predvyklad.="<span class='predvyklad_konec'>".$konec_predvykladu."</span>";
            }
            if($novy_predvyklad!=""){
                $vyznam_str.="\r\n<span class='$predvyklad_cls'>(</span>".$novy_predvyklad."<span class='$predvyklad_cls'>)</span>";
            }

            $skip_semicolon = false;
            if(!empty($metavyklad1_cisVyber)){ //label: metavýklad 1

                if($web && $vyznamy_count == 1 &&
                    (substr_count($metavyklad1_cisVyber_str, "přechýl.") > 0 ||
                     substr_count($metavyklad1_cisVyber_str, "opak.")    > 0   ||
                     substr_count($metavyklad1_cisVyber_str, "zdrob.")   > 0)){
                    $html = str_replace("^^MV1-$hid^^", "<span class='metavyklad'>".$metavyklad1_cisVyber_str."</span>", $html);
                    $skip_semicolon = true;
                } else{
                    $vyznam_str.="\r\n<span class='metavyklad'>".$metavyklad1_cisVyber_str."</span>";
                    //ticket 458: Pokud po metavykladu nasleduje synonymum/antonymum, musi mezi nimi byt strednik
                    if(strip_tags($vyklad_vyznamu)=="" && (!empty($syn_odkazy) || !empty($ant_odkazy))){
                        $vyznam_str.="<span class='komentar'>;</span> ";
                    }
                }
            }

            $html = str_replace("^^MV1-$hid^^", "", $html);

            //dvojtecka za metavykladem 1 (pouze pokud neni zadano syn./ant.)
            if((substr(strip_tags($metavyklad1_cisVyber_str), 0, 7) == "přechýl") && (empty($syn_odkazy) && empty($ant_odkazy))){
                if(!$skip_semicolon){
                    $vyznam_str.="<span class='normal_size'>:</span>";
                }
            }

            if(strip_tags($vyklad_vyznamu)!=""){ //label: výklad významu
              $delim = '';
              if(!empty($syn_vyz_arr) || !empty($syn_odkazy) ||
                 !empty($ant_vyz_arr) || !empty($ant_odkazy)){
                $delim = ";";
              }
              $vyklad_vyznamu = strip_block_tags($vyklad_vyznamu);
              if($web){
                $vyklad_vyznamu = lematizace($vyklad_vyznamu);
              }

            $vyklad_vyznamu = bulletizace($vyklad_vyznamu);


              /*
              $vyklad_vyznamu = str_replace(array("&nbsp;", "&hellip;", "&#8211;", ";'", ';"'), array("&nbsp", "&hellip", "&#8211", "[]'", '[]"'), $vyklad_vyznamu);
              $vyklad_vyznamu = preg_replace('/&(?:[a-z\d]+|#\d+|#x[a-f\d]+);/i', '$0|', $vyklad_vyznamu);
              $vyklad_vyznamu = str_replace(";", " &bull;", $vyklad_vyznamu);
              $vyklad_vyznamu = str_replace(array(" &bull;|", "&nbsp", "&hellip", "&#8211", "[]'", '[]"'), array(";", "&nbsp;", "&hellip;", "&#8211;", ";'", ';"'), $vyklad_vyznamu);
              */
              $vyznam_str.="\r\n<span class='vyznam'>".$vyklad_vyznamu.$delim."</span>";
           }

            /*if(!empty($syn_vyz_arr)){ //label: syn.
              $delim = '';
              if(!empty($ant_vyz_arr) && empty($syn_odkazy)) $delim = ',';
              $vyznam_str.="\r\n<span class='synonymum-label'>syn.</span>";
              $vyznam_str.="\r\n<span class='synonymum'>".implode(", ", $syn_vyz_arr).$delim."</span>";
              if(!empty($syn_odkazy))
                $vyznam_str.=", ";
            }*/
            if(!empty($syn_odkazy)){
                //if(empty($syn_vyz_arr))
                $vyznam_str.="\r\n<span class='synonymum-label'>syn.</span>";
                $vyznam_str.="\r\n$syn_odkazy";
                if(!empty($ant_odkazy))
                    $vyznam_str.="; ";
            }
            /*if(!empty($ant_vyz_arr)){ //label: ant.
             $vyznam_str.="\r\n<span class='antonymum-label'>op.</span>";
             $vyznam_str.="\r\n<span class='antonymum'>".implode(", ", $ant_vyz_arr)."</span>";
             if(!empty($ant_odkazy))
              $vyznam_str.=", ";
           }*/
            if(!empty($ant_odkazy)){
                //if(empty($ant_vyz_arr))
                $vyznam_str.="\r\n<span class='antonymum-label'>op.</span>";
                $vyznam_str.="\r\n$ant_odkazy";
            }


            if($metavyklad2!=""){ //label: metavýklad 2
                //$html.="<p><span class='label'>metavýklad 2:</span>&nbsp;".$metavyklad2."</p>";
                $vyznam_str.="\r\n<span class='metavyklad2'>".$metavyklad2."</span>";
            }


            if($web){
                $vyznam_str.="</span>"; //zarovnavani vyznamu
            }

            //label: exemplifikace k významu $vyz_count
            $exeplifikace = strip_block_tags($exeplifikace);
            $test = trim(strip_tags($exeplifikace));

            if($web && !$master && empty($test) && empty($vyklad_vyznamu)){
                $vyznam_str.="<span style='display:none'>.</span>";
            }
            if(!empty($test)){
                $vyznam_stripped = trim(strip_tags($vyznam_str));
                if($web)
                {
                    $exeplifikace = str_replace(array(";'", ';"', ";</span> ", "px;"), array("[]'", '[]"', ";</span>", "px[]"), $exeplifikace);  ;;
                    $exeplifikaceArr=explode(";",$exeplifikace);

                    $cls = '';
                    if(!$master){
                        $place = get_db_values_where("hesla_rel_places", array("place"), "hesla_rel_id", $hidRel_id);
                        if($place[0]=="exemplifikace"){
                            //$cls = "<span class='pripoj2'></span>";
                        }
                    }

                    //cislo vyznamu + tecka
                    $br = true;
                    if(strlen(trim(strip_tags($vyznam_str)))<3){
                        $br = false;
                    }


                    $prvni = true;
                    foreach($exeplifikaceArr as $exep)
                    {

                        if(empty($cls)){
                            $cls = "";//"<span class='pripoj'></span>";
                        }
                        $test = trim(strip_tags($vyznam_str));
                        $space = '';
                        if($vyz_count == 1 && $test=="1."){
                            if(!$master){
                                $space = "<span class=\"vyz_count\" style=\"visibility:hidden;\">1.</span><span class='tab'></span>";
                            }
                            $vyznam_str = "<hr class='vskipSmall' />";
                        }
                        $exe = fix_typography(str_replace(array("[]'", '[]"', 'px[]'), array(";'", ';"', 'px;'), $exep));
                        $prefix = '</span>';
                        $replacement = '';
                        if (substr($exe, 0, strlen($prefix)) == $prefix) {
                            $exe = substr($exe, strlen($prefix));
                            $replacement .=$prefix;
                        }
                        $exe = trim($exe);
                        $exe = trim($exe, "\xC2\xA0");
                        if(!empty($exe)){
                            $x = strip_tags($exe);
                            if(empty($x)){
                                $br = false;
                            }
                            $tag_open = '';
                            if($prvni){
                                if($br){
                                    $tag_open="<hr class='vskipSmall' /><span class='exeplifikace'>".$space;
                                } else{
                                    $tag_open="<span class='exeplifikace'>".$space;
                                }
                                $prvni = false;
                            }

                            if(!$br){
                                if($master){
                                    $cls = '';
                                }
                                $vyznam_str.=$tag_open.$replacement."$cls".$exe;

                                $br = true;
                            } else{
                                $vyznam_str.="\r\n<br />".$tag_open.$replacement.$cls.$exe;

                            }
                        }
                    }
                    if(!$prvni){
                        $vyznam_str.="\r\n</span>";
                    }
                }
                else
                {
                    $exeplifikace = "\r\n".fix_typography($exeplifikace);
                    if(!empty($vyznam_str) && ($vyznam_stripped[strlen($vyznam_stripped)-1])!=":")
                        $vyznam_str.="<span class='normal_size'>:</span><span class='exeplifikace'>".$exeplifikace."</span>";
                    else
                        $vyznam_str.="<span class='exeplifikace'>".$exeplifikace."</span>";
                }
            }

            $test = trim(strip_tags($exeplifikace_pripoj));
            if(!empty($test)){
                if($web)
                    $vyznam_str.="<br />".$exeplifikace_pripoj;
                else if(!empty($vyznam_str))
                    $vyznam_str.=" ".$exeplifikace_pripoj;
                else
                    $vyznam_str=$exeplifikace_pripoj;
            }
            //exemplifikace konec

            if($master){
                if(!empty($ext_pozn_vyz_arr[$vyz_id])){ //label: externí poznámky k významu
                    if($ext_pozn_vyz_arr[$vyz_id]['typ'][0]!=="v názvech"){
                        //podminka pro odstraneni prebytecne prazdne radky
                        if(empty($vyznam_str))
                            $vyznam_str="\r\n<span class='externiPoznamka'>".handle_wysiwyg(strip_block_tags($ext_pozn_vyz_arr[$vyz_id]['text']), ($to_pdf && !$preview))."</span>";
                        else
                            $vyznam_str.="\r\n<br /><span class='externiPoznamka'>".handle_wysiwyg(strip_block_tags($ext_pozn_vyz_arr[$vyz_id]['text']), ($to_pdf && !$preview))."</span>";

                    }
                }
            }
            //tisk pripojeni/prihnizdovani k vyznamu
            /*if($vyz_id_info['MASTER'])
              $place = "podvyznam";
            else
              $place = "vyznam"; */

            $place = "vyznam";

            if($master){
                $processed_rel_ids = array();
            }

            $prazdny_vyznam = false;
            if(empty($vyklad_vyznamu)){
                $prazdny_vyznam = true;
            }
            $tmp = vytvor_pripojene($place, $vyz_id, $vyz_count, $to_pdf, $bilaZona, $hid, $master, $master, $web, $prazdny_vyznam);
            if(!empty($tmp)){
                /*if($web && !$master && $prazdny_vyznam){
                    $vyznam_str.='<span class="vyz_count" style="visibility:hidden;">1.</span>';
                }*/
                //var_dump($pocet_vyznamu);
                if($web /*&& $master*/ && $prazdny_vyznam && $pocet_vyznamu == 1){
                    $vyznam_str = str_replace("<hr class='vskipSmall' />", "<hr class='vskipSmall' /><span class='pripoj_wrapper'>", $vyznam_str);
                    if(!$master){
                        $tmp = str_replace("wrapper", "", $tmp);
                        $tmp = "<span class='lexikalizovana_elipsa';'></span>".$tmp;
                    }
                    $vyznam_str = $vyznam_str.$tmp."</span>";
                } else {
                    $vyznam_str.=" ".$tmp;
                }
                if($bilaZona)
                    $bileZony .= $bilaZona;
            }

            $test = trim(strip_tags($exeplifikace));
            if(empty($test))
                $prazdna_exemplifikace = true;
            else
                $prazdna_exemplifikace = false;
            $test = trim(strip_tags($vyznam_str));
            if(empty($test) || $test == "1."){
                $prazdny_vyznam = true;
                if($web){
                    $vyznam_str = '';
                }
            } else{
                $prazdny_vyznam = false;
            }

            if($master){
                if(!$prazdny_vyznam){
                    if(!$web){
                        if(!$to_pdf || !$prazdna_exemplifikace){
                            $vyznam_str.="<br />";
                        }
                    }
                }
                if($vystup==TISTENY || $vystup==ELEKTRONICKY)
                    $html.=$vyznam_str."\r\n<!-- vyznam $vyz_count konec -->";
                else
                    $nezarazene_vyznamy.=$vyznam_str."\r\n<!-- vyznam $vyz_count konec -->";
            } else{
                if($vystup==TISTENY || $vystup==ELEKTRONICKY)
                    $html.=$vyznam_str."<!-- vyznam $vyz_count konec -->";
            }

        }

        if($master){
            if($to_pdf)
                $html.="\r\n<!-- vyznamy konec -->";
            else
                $html.="\r\n</span><!-- vyznamy konec -->";
        } else if(!$to_pdf){
            $html.="</span><!-- vyznamy konec -->";
        }


        //POZNAMKY
        $ext_pozn_hesla_ids = get('pozn_hesla', $hid);
        $ext_pozn_hesla_arr = array();

        foreach($ext_pozn_hesla_ids as $pozn_id){
            $hes_ext_pozn = handle_wysiwyg(strip_block_tags(get_db_values('ext_poznamky_hes', 'poznamka', $pozn_id)), ($to_pdf && !$preview));
            if($to_pdf){
                $hes_ext_pozn = fix_mpdf($hes_ext_pozn);
            }

            if($hes_ext_pozn == "&nbsp;" || empty(utf8_trim($hes_ext_pozn))){
                $hes_ext_pozn = "";
            }
            $typ = get_db_values('ext_poznamky_hes','cis_id',$pozn_id);
            $ext_pozn_hesla_typy[] = $typ;
            if(trim($hes_ext_pozn)!=""){
                $DOMid = "heslo-$hid--extPozn-$pozn_id--text";
                if(!$to_pdf)
                    handle_correction($hid, $DOMid, 'heslo-extPozn-text', $pozn_id, $hes_ext_pozn, 'span');
                $ext_pozn_hesla_arr['text'][] = $hes_ext_pozn;
                $ext_pozn_hesla_arr['typ'][]=$pozn_typy[$typ];
            }
        }

        if($master){
            //Prihnizdovani/pripojeni k heslu
            $processed_rel_ids = null;
            $processed_rel_ids = array();

            $tmp = vytvor_pripojene("heslo", $hid, 0, $to_pdf, $bilaZona, $hid, $master, $master, $web, $prazdny_vyznam);
            $processed_rel_ids = null;
            $processed_rel_ids = array();
            if(!empty($tmp)){
                //$pripoj = $tmp;
                if($bilaZona)
                    $bileZony .= $bilaZona;
                if($to_pdf && !$prazdny_vyznam && $prazdna_exemplifikace){
                    $html.="<br />";
                }
                $html.="$tmp<br />";
            }
            $odkazy_k_heslu = vytvor_odkazy($hid, $to_pdf, true, $web);
            $html .= $odkazy_k_heslu;
            if($preview && !empty($odkazy_k_heslu))
                $html.="<br />";
        }
        if(!empty($ext_pozn_hesla_arr)){
            //$html.="<p><span class='label'>externí poznámky k heslu:</span>&nbsp;".implode("", $ext_pozn_hesla_arr)."</p>";
            if(!$preview && !empty($odkazy_k_heslu)){
                $html.="<br />";
            }
            $nl = false;
            for($i = 0; $i < count($ext_pozn_hesla_arr['text']); $i++){
                if($ext_pozn_hesla_arr['typ'][$i]!=="v názvech"){

                    $pozn = $ext_pozn_hesla_arr['text'][$i];
                    if($web){
                        $pozn = handle_wysiwyg($pozn, false);
                    }
                    if(!$master){
                        $html.="<br />";
                    }
                    $html.="\r\n<span class='ext_pozn'>".$pozn."</span>";
                    $nl = true;
                }

                if($nl && $preview){
                    $html.="<br />";
                }
            }
        }
        if($master){
            if(!$to_pdf){
                //$html.="\r\n</div><p class='printPageSpacer'></p>";
                $html.="\r\n</div>";
                if($master)
                    $bilaZona = "\r\n<div class='html bilaZona'>";
            }
            else{
                if($preview){
                    //workaroud for ticket #450
                    $html.="<br />";
                }
                if(!$web){
                    $html.="\r\n<div class='pageSeparator'></div>";
                }
            }
        }
        if(!$master){
            $tmp = vytvor_pripojene("heslo", $hid, 0, $to_pdf, $bilaZona, $hid, $master, $master, $web, $prazdny_vyznam);

            if($master){
                $processed_rel_ids = null;
                $processed_rel_ids = array();
            }
            if(!empty($tmp)){
                //$pripoj = $tmp;
                if($bilaZona)
                    $bileZony .= $bilaZona;

                $html.="<br />$tmp";
            }
        }

        /*
    "Bila zona"
    Udaje, ktere nejdou do PDF
    - lexikograficka poznamka
    - externi poznamky
    - neprirazene exemplifikace
    */
        if(!$to_pdf){
            $semaforStr = "^^SEMAFOR$hid^^";

            if(is_role_uzivatel($role)){
                //KOREKTURY V HLAVICKE
                $DOMid = "heslo-$hid--do_vystupu";
                handle_correction($hid, $DOMid, 'heslo-do_vystupu', $hid, $do_vystupu);
                $DOMid = "heslo-$hid--stav";
                handle_correction($hid, $DOMid, 'heslo-stav', $hid, $stav);
                //$html.="<div id='#seznam_variant' class='floatLeft'>";
                $vr = 0;
                $ph = 0;
                foreach($varianty as $var_id){
                    //$html.="<div class='border varTeaser'>
                    $var_info = get_db_values('varianty', array('id', 'varianta', 'f_varianta'), $var_id);
                    $varianta =  text_html_preprocess($var_info['varianta']);
                    $fv = $var_info['f_varianta'];
                    $label = "";
                    if($fv == 1){
                        $vr++;
                        $label = "varianta $vr";
                    } else{
                        $ph++;
                        $label = "podheslí $ph";
                    }

                    if($vr + $ph == 1){
                        if(!$master){
                            $bilaZona.="\r\n<br /><h3>Informace k připojenému/přihnízdovanému heslu <em>$varianta</em></h3>";
                        } else{
                            $bilaZona.="\r\n<h3>Informace k heslu <em>$varianta</em></h3>";
                        }
                    }

                    $bilaZona .= "<p><span class='label'>Heslo ($label): </span><span>".$varianta."</span></p><br />";
                    $typHesla_cisVyber_str = typ_hesla($hid, $var_info['id'], $to_pdf);
                    $bilaZona .= "<p><span class='label'>Typ hesla ($label): </span>$typHesla_cisVyber_str</p><br/>";

                    // </div>";
                }
                //$html.="</div>"; //#seznam variant

                $bilaZona .= $semaforStr;
                $bilaZona.="
<p><span class='label'>Stav: </span>$stav</p><br />
<p><span class='label'>Vytvořeno: </span>".ftime($hinfo['cts'])."</p><br />
<p><span class='label'>Změněno: </span>".ftime($hinfo['uts'])."</p><br />
<p><span class='label'>Výstup: </span>$do_vystupu</p><br />
<p><span class='label'>Zpracovatelé: </span>$zpracovatele_str</p><br />";

                foreach($tematickeOkruhyArray as $i => $sd){
                    if($sd!=''){
                        $bilaZona .=  "\r\n<span class='label'>Tematické okruhy (varianta $i): </span><span class='tematickeOkruhy'>$sd</span><br />";
                    }
                }

                foreach($tematickeOkruhyVyzArray as $i => $sd){
                    if($sd!=''){
                        $bilaZona .=  "\r\n<span class='label'>Tematické okruhy (význam $i): </span><span class='tematickeOkruhy'>$sd</span><br />";
                    }
                }

                foreach($tematickeOkruhyPodhArray as $i => $sd){
                    if($sd!=''){
                        $bilaZona .=  "\r\n<span class='label'>Tematické okruhy (podheslí $i): </span><span class='tematickeOkruhy'>$sd</span><br />";
                    }
                }

                if(!empty($nezarazene_vyznamy)){
                    $bilaZona.="\r\n<p><span class='label'>Nezařazené významy: </span></p><br />";
                    $bilaZona.=$nezarazene_vyznamy;
                }

                foreach($exemplifikace_nez as $vn => $enz){
                    //for($i = 1; $i<=$vyz_count; $i++){
                    $i = vyznam_number($vn, false);
                    if(trim($enz)!=""){ //label: exemplifikace k významu $vyz_count
                        $bilaZona.="\r\n<p><span class='label'>Nezařazená exemplifikace k významu $i: </span></p>".$enz;
                    }
                }


                for($i = 1; $i <= $vyz_count; $i++){
                    if(!empty($ext_pozn_vyz_arr[$i])){ //label: externí poznámky k významu
                        if($ext_pozn_vyz_arr[$i]['typ'][0]==="v názvech"){
                            $bilaZona.="\r\n<span class='label'>Externí poznámka k významu $i:&nbsp;</span><br />";
                            $bilaZona.="\r\n<span class='externiPoznamka'>".handle_wysiwyg(strip_block_tags($ext_pozn_vyz_arr[$i][text]), ($to_pdf && !$preview))."</span><br />";
                        }
                    }
                }

                if(!empty($ext_pozn_hesla_arr)){
                    //$html.="<p><span class='label'>externí poznámky k heslu:</span>&nbsp;".implode("", $ext_pozn_hesla_arr)."</p>";
                    for($i = 0; $i < count($ext_pozn_hesla_arr['text']); $i++){
                        if($ext_pozn_hesla_arr['typ'][$i]==="v názvech"){
                            $bilaZona.="\r\n<p><span class='label'>Externí poznámka k heslu:&nbsp;</span>";
                            $bilaZona.="\r\n<span class='ext_pozn'>".$ext_pozn_hesla_arr['text'][$i]."</span>";
                            $bilaZona.="\r\n</p><br />";
                        }
                    }
                }
                $lexi_pozn = nl2br(text_html_preprocess($hinfo['lexgraf_pozn']));
                if(empty($lexi_pozn)){
                    $lexi_pozn = "-- poznámka není zadána --";
                }
                //if(!empty($lexi_pozn)){
                $DOMid = "heslo-$hid--lexikograficka_poznamka";
                handle_correction($hid, $DOMid, 'heslo-lexikograficka_poznamka', $hid, $lexi_pozn);
                $bilaZona.="\r\n<br /><p><span class='label'>Lexikografická poznámka: </span></p>";
                $bilaZona.="\r\n<div class='clear'>".$lexi_pozn."</div>\r\n";

                //}
            } //role UZIVATEL
            //if($role == ODBORNIK){
            $odbo_pozn = nl2br(text_html_preprocess($hinfo['pozn_odbornik']));
            if(!empty($odbo_pozn)){
                $DOMid = "heslo-$hid--poznamka_odbornik";
                handle_correction($hid, $DOMid, 'heslo-poznamka_odbornik', $hid, $odbo_pozn);
                $var_id = get_hlavni_varianta_hesla($hid);
                $var_info = get_db_values('varianty', array('id', 'varianta', 'f_varianta'), $var_id);
                $varianta =  text_html_preprocess($var_info['varianta']);

                $bilaZona.="\r\n<br /><p><span class='label'>Poznámka pro odborníka (heslo $varianta): </span></p>";
                $bilaZona.="\r\n<div class='clear'>".$odbo_pozn."</div>\r\n";
            }
            //} //role ODBORNIK

            //$html.="</div>";
            if($master){
                $html.=$bilaZona;
                $html.=$bileZony;
                $html.="\r\n</div><!-- bilaZona -->";
            }
        }


        //}//vyznamy empty test
        unset($ext_pozn_vyz_arr);
    }
    else
    {
        $typHesla_cisVyber_str = typ_hesla($hid, $vid, $to_pdf);
        $typHesla_stripped = strip_tags($typHesla_cisVyber_str);
        $next_hid=current($hesla);
        $next_vid=key($hesla);
        if(prev($hesla)==false )
        {
            end($hesla);
            $prev_hid=prev($hesla);
        }
        else
        {
            $prev_hid=prev($hesla);
        }
        next($hesla);
        next($hesla);
        if(($typHesla_stripped==$_TYP_HESLA[JEDNOSLOVNE] || $typHesla_stripped==$_TYP_HESLA[VICESLOZKOVE]) && ($prev_hid!=$hid ))
        {
            if($to_pdf)
                $html.="\r\n<!-- VARIANTY -->";
            else
                $html.="\r\n<div class='pdf'><!-- VARIANTY -->\r\n<span class='varianty'>";

            $cacheable = false;
            $html.="<span class='heslo$clsSuffix'>";

            $html.=$var_temp["varianta"];
            if(!empty($var_temp['homonymie'])){
                $html.="\r\n".number_to_roman($var_temp['homonymie']);
            }

            $counter=0;
            while($next_hid==$hid)
            {
                $html.= "</span><span class='oddelovac'>, </span><span class='heslo$clsSuffix'>".get_db_values('varianty',array('varianta'),$next_vid)["varianta"];
                $next_hid=next($hesla);
                $counter=$counter+1;
            }
            for($ii=0;$ii<$counter;$ii++)
            {
                prev($hesla);
            }
            $html.="</span>";
            $html.=" &rarr; ";

            $label = naformatuj_varianty($hid, $hid, false, "", true);
            $temp = explode(",", $label);
            $label = $temp[0];

            /*$varianty = get('varianty_hesla', $hid, array('sortorder'));
      $D = get_db_values('varianty', array('varianta'), $varianty[0]);
      $var = text_html_preprocess(trim($D['varianta'])); */
            $html.=$label;
            $html.="</span>";
            if(!$to_pdf){
                //$html.="\r\n</div><p class='printPageSpacer'></p>";
                $html.="\r\n</div>";
                if($master){
                    $bilaZona = "\r\n<div class='html bilaZona'>";
                }
            }
            else
            {
                if($preview)
                {
                    //workaroud for ticket #450
                    $html.="<br />&nbsp;";
                }
                if(!$web){
                    $html.="\r\n<div class='pageSeparator'></div>";
                }
            }
        }
    }
    if(!$cacheable){
        $html = "<!-- not cacheable -->".$html;
    }
    // $html='['.$html.']';
    if($web){
        $html = str_replace("^^MV1-$hid^^", "", $html);
    }
    return $html;
}

function get_hlavni_frazemy($hids){
    $res = array();
    $hids_bez_podr_frazemu = array();
    $pids = array();
    foreach($hids as $vid => $hid){
        $pid = get_db_values("heslo", "pid", $hid);
        if(!is_numeric($pid)){
            if(!in_array($hid, $pids)){
                $pids[] = $hid;
            }
        } else{
            if(!in_array($pid, $pids)){
                $pids[] = $pid;
            }
        }
        unset($pid);
    }
    $h = implode(", ", $pids);

//    $sql = "SELECT hid, var, vz, vid, so FROM (
//             SELECT v.varianta as var, v.varianty_bez_zavor as vz, v.homonymie as hom, v.sortorder as so, h.id as hid, h.pid as pid, v.id as vid
//             FROM heslo h
//              JOIN varianty v ON h.id=v.hid
//              LEFT JOIN typ_hesla_var_vyber th ON v.id=th.vid
//              LEFT JOIN hesla_rel hr ON h.id=hr.main_hid
//             WHERE h.id IN ($h)
//             ORDER BY v.varianta ASC, v.varianta COLLATE utf8_czech_w2 ASC, v.sortorder ASC
//             ) as tab
//            GROUP BY var,var COLLATE utf8_czech_w2,var COLLATE utf8_bin, hom COLLATE utf8_bin, hid";

    //ORDER na konec; prvni VAR z GROUP BY odstraneno (kvuli fatalni chybe Incorrect key file for table '/tmp/#sql12075_c6f2dd_7.MYI'; try to repair it); jeden JOIN zakomentovany, protze se jevi jako zbytecny
    $sql = "SELECT hid, var, vz, vid, so FROM (
              SELECT v.varianta as var, v.varianty_bez_zavor as vz, v.homonymie as hom, v.sortorder as so, h.id as hid, h.pid as pid, v.id as vid
              FROM heslo h
               JOIN varianty v ON h.id=v.hid
               LEFT JOIN typ_hesla_var_vyber th ON v.id=th.vid
               -- LEFT JOIN hesla_rel hr ON h.id=hr.main_hid
              WHERE h.id IN ($h)
              ) as tab
            GROUP BY var COLLATE utf8_czech_w2,var COLLATE utf8_bin,  hom COLLATE utf8_bin, hid
            ORDER BY var ASC, var COLLATE utf8_czech_w2 ASC, hom ASC, so ASC";

    $result = dbq($sql);
    while($rec = mysql_fetch_assoc($result)){
        $vid = $rec['vid'];//get_hlavni_varianta_hesla($rec['hid']);
        $children = get_db_values_where("heslo", "id", "pid", $rec['hid'], true);
        if(is_numeric($children) && $rec['so'] > 1){
            //var_dump($rec['hid'], $children, $rec['so']);
        } else{
            $hids_bez_podr_frazemu[$vid] = $rec['hid'];
        }
    }
    return $hids_bez_podr_frazemu;
}

function pridej_podrazene_frazemy($hids_bez_podr_frazemu){
    $res = array();
    $vids = array();

    foreach($hids_bez_podr_frazemu as $vid => $hid){

        //zarad do vysledku heslo bez frazemu
        $res[$vid] = $hid;
        //a za nej jeho pripadne podrizene frazemy
        $sql2 = "SELECT hid, vid FROM (SELECT v.varianta as var, v.homonymie as hom, h.id as hid, v.id as vid FROM heslo h JOIN varianty v ON h.id=v.hid LEFT JOIN typ_hesla_var_vyber th ON v.id=th.vid LEFT JOIN hesla_rel hr ON h.id=hr.main_hid WHERE h.pid = $hid ORDER BY v.varianta ASC, v.varianta COLLATE utf8_czech_w2 ASC, v.sortorder ASC) as tab GROUP BY var,var COLLATE utf8_czech_w2,var COLLATE utf8_bin, hom COLLATE utf8_bin, hid";

        $frazemy = db_get_val_arr($sql2,  array('vid'=>'hid'));
        foreach($frazemy as $vid => $fid){
            if(is_numeric($fid) && ($fid > 0)){
                if(!array_key_exists($vid, $vids)){
                    $res[$vid] = $fid;
                }
            }
        }
    }
    return $res;
}

function filter_varianty($hids)
{
    $last=count($hids);
    $now=count($hids)-1;
    $temp=$hids;
    $output = array();
    while($last>$now)
    {
        $last=$now;
        foreach($temp as $vid => $hid)
        {
            $var_sort = get_db_values('varianty',array('sortorder', 'f_varianta'),$vid);
            if($var_sort[1]!=0)
            {
                if($var_sort[0]==1)
                {
                    $output[$vid]=$hid;
                }
                else
                {
                    $vzdalenost=0;
                    $pred=false;
                    $za=false;
                    foreach($temp as $vid2 => $hid2)
                    {
                        if($vid2==$vid)
                        {
                            $za=true;
                            if($vzdalenost>5 && $pred==true)
                            {
                                $output[$vid]=$hid;
                                break;
                            }
                            $vzdalenost=0;
                        }
                        else if($hid==$hid2)
                        {
                            $var_sort = get_db_values('varianty',array('sortorder'),$vid2);
                            if($var_sort[0]==1)
                            {
                                $pred=true;
                                if($vzdalenost>5 && $za==true)
                                {
                                    $output[$vid]=$hid;
                                    break;
                                }
                                $vzdalenost=0;
                            }
                        }
                        else
                        {
                            $vzdalenost=$vzdalenost+1;
                        }
                    }
                }
            }
        }
        $now=count($output);
        $temp=$output;
    }
    return $output;
}

function get_hesla_varianty($hids)
{
    if(empty($hids))
    {
        return null;
    }
    else
    {
        $hids = implode($hids,",");
        $sql = "SELECT hid, vid FROM (SELECT v.varianty_bez_zavor as var, v.homonymie as hom, h.id as hid, v.id as vid FROM heslo h JOIN varianty v ON h.id=v.hid LEFT JOIN typ_hesla_var_vyber th ON v.id=th.vid LEFT JOIN hesla_rel hr ON h.id=hr.main_hid WHERE h.id in ($hids) OR (th.cis_id=8 AND slave_hid in ($hids)) ORDER BY v.varianta ASC, v.varianta COLLATE utf8_czech_w2 ASC, v.sortorder ASC) as tab GROUP BY var,var COLLATE utf8_czech_w2,var COLLATE utf8_bin,  hom COLLATE utf8_bin, hid";

        return db_get_val_arr($sql,  array('vid'=>'hid'));
    }
}

function viceslovne($hid, $vid){

}

function nacti_heslo($manager, $hid, $vid, $to_pdf, $aj_varianty, $vystup, $hesla){
    $res = '';
    $souvisle = null;
    if(isset($_GET['souvisl'])){
        $souvisle = $_GET['souvisl'];
    }
    if(is_null($souvisle) || empty($souvisle)) $souvisle = 0;
    if(($souvisle) && (count($hesla) > 1)){
        if(je_viceslovne($hid)){
            return;
        }
        if(is_slave($hid)){
          return;
        }
    }

    $hinfo = get_db_values('heslo',array('vystup'),$hid);
    if(!over_vystup($hesla, $souvisle, $to_pdf, $hinfo['vystup'])){
        return;
    }
    $status = $manager->entryValid($hid, $vystup, $vid, get_role());
    if($status == VALID || $status == OLDVERSION){
        $res = $manager->loadFromCache($hid, $vystup, $vid);
    } else{
        $res = tisk_hesla($aj_varianty, $hid, $vid, $to_pdf, true, $dummy, true, 0, 0, false, $hesla);
        if($res!=NULL)
        {
            if(substr($res, 0, strlen("<!-- not cacheable -->"))!="<!-- not cacheable -->"){
                $manager->saveToCache($hid, $vystup, $res, $vid);
            }
        }
    }
    //$res = tisk_hesla($aj_varianty, $hid, $vid, $to_pdf, true, $dummy);
    return $res;
}

function tisk_cast($hesla, $preview, $souvisle, $to_pdf, $aj_varianty){
    $html="";
    if(sizeof($hesla)>0) {
        $hesla = get_hesla_varianty($hesla);
        if (!$souvisle && !isset($_GET['hid'])) {
            $hesla = get_hlavni_frazemy($hesla);
        }

        $hesla = filter_varianty($hesla);
        if (!$souvisle && !isset($_GET['hid'])) {
            $hesla = pridej_podrazene_frazemy($hesla);
        }
        $dummy = "";
        if (!$to_pdf) {
            $html .= "\r\n<table class='seznam_hesel'>";
        }
        $cache = new CacheManager;
        reset($hesla);
        $uid = get_logged_user();
        $role = get_role();
        $l = strlen("^^SEMAFOR");
        foreach ($hesla as $vid => $hid) {
            if (!$to_pdf) {
                $elek = nacti_heslo($cache, $hid, $vid, false, $aj_varianty, ELEKTRONICKY, $hesla);
                //vytvoreni semaforu - potreba mimo cache
                while(($pos=strpos($elek, "^^SEMAFOR"))!==FALSE){
                    $pos+=$l;
                    $end_pos = strpos($elek, "^^", $pos);
                    $sem_id = substr($elek, $pos, $end_pos - $pos);
                    $cdo = new CDO(CDOin_EMPTY, $sem_id);
                    $_SESSION[SESS_TISK_CDO][$sem_id] = $cdo;
                    $semafor = $_SESSION[SESS_TISK_CDO][$sem_id]->getSemafor();
                    $semaforStr = $semafor->printForm();
                    $elek = str_replace("^^SEMAFOR$sem_id^^", $semaforStr, $elek);
                }
                $tist = nacti_heslo($cache, $hid, $vid, true, $aj_varianty, TISTENY, $hesla);

                if ($elek || $tist) {
                    if($role == ODBORNIK || $role == UZIVATEL || $role == HLAVNI_REDAKTOR){
                    $html .= "\r\n<tr><td>";
                    if(heslo_videno($hid, $uid)){

                        $html .= "<span class='videno' data-hid='$hid' data-videno=1 data-uid=$uid id='videno-$hid'><img src='css/images/videl_jsem_on.png' alt='Viděl/a jsem' /></span>";
                    } else{
                        $html .= "<span class='videno' data-hid='$hid' data-videno=0 data-uid=$uid id='videno-$hid'><img src='css/images/videl_jsem_off.png' alt='Neviděl/a jsem' /></span>";
                    }
                    $html.="\r\n</td><td></td></tr>";
                }
                    $html .= "\r\n<tr id='heslo$hid'>";
                    $html .= "\r\n\t<td class='elektronicky'>$elek</td>";
                    $html .= "\r\n\t<td class='tisteny'>$tist</td>";
                    $html .= "\r\n</tr>";
                }
            } else {
                if ($preview) {
                    $html .= nacti_heslo($cache, $hid, $vid, true, $aj_varianty, WORD, $hesla);
                } else {
                    $html .= nacti_heslo($cache, $hid, $vid, true, $aj_varianty, TISTENY, $hesla);
                }
            }
        } //for each heslo
        if (!$to_pdf) {
            $html .= "\r\n</table>";
        }
    }
    return $html;
}

function tisk_seznamu_hesel($aj_varianty=true, $hid=0, $to_pdf, $master = true, &$bilaZona, $redakce = true, $hidRel_id = 0, $slave_hid = 0){
    global $preview;
    $role = get_role();
    $souvisle = null;
    if(isset($_GET['souvisl'])){
        $souvisle = $_GET['souvisl'];
    }
    if(is_null($souvisle) || empty($souvisle)){
        $souvisle = 0;
    }
    if(is_null($_SESSION['aktivni_heslar']) || empty($_SESSION['aktivni_heslar']))
    {
        $_SESSION['aktivni_heslar']=["1"];
    }
    $heslare_data=dibi::fetchAll("SELECT id, name, label FROM heslare WHERE id IN (".implode(",",$_SESSION['aktivni_heslar']).") ORDER BY sortorder");
    global $heslar;
    $html = "";
    if ($hid > 0) {
        $heslar=HESLAR_HLAVNI;
        $hesla = array($hid);
        $html .=tisk_cast($hesla, $preview, $souvisle, $to_pdf, $aj_varianty);
    } else {
        foreach ($heslare_data as $id=>$jmeno_heslar) {
            $heslar = $jmeno_heslar['id'];
            $html .= "<h2>".((empty($jmeno_heslar['name']))?$jmeno_heslar['label']:$jmeno_heslar['name'])."</h2>";
            if (isset($_SESSION['data_filter']['_dataID']) && $_SESSION['data_filter']['_dataID'] == 'jine_in_hesla') {
                $hesla = get_hesla_by_jine();
                //$co_hledam = "<td>Císelník: <b>".$_CIS[$_SESSION['data_filter']['_filterValue']['cis']]."</b> Hodnota \"jiné\": <b>".text_html_preprocess($_SESSION['data_filter']['_filterValue']['jine_val'])."</b></td>";
                //$co_hledam.= "<td><a href='heslar.php?act=data_filter&filter=0' class='cancelSearch'></a></td>";
            } else {
                $hesla = get_hesla(False, $temp, $heslar);
            }
            $html .=tisk_cast($hesla, $preview, $souvisle, $to_pdf, $aj_varianty);
        }
    }

  //korektorsky popup jen jednou - spolecny pro vsechny heslare
  if ($master && !$to_pdf) {
            $html .= popup();
            $html .= upravy_ant_syn_redakce();
  }

  return $html;
}

?>
